<?php 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */



//Add missing definitions to avoid php warnings if we access them
function checkBoxDefinition(&$box, &$definition) {
	if (!is_array($definition)) {
		return;
	}
	if (!is_array($box)) {
		$box = array();
	}
	
	foreach ($definition as $tag => &$value) {
		if (is_array($value)) {
			if (!isset($box[$tag]) || !is_array($box[$tag])) {
				$box[$tag] = $value;
			} else {
				checkBoxDefinition($box[$tag], $value);
			}
		} else {
			if (!isset($box[$tag])) {
				$box[$tag] = $value;
			}
		}
	}
}



//Sets up tooltips on a page, and also sets up the admin floating box
function setupAdminTooltips($autoAddToolTipsToPage = false) {
	
	if ($autoAddToolTipsToPage) {
		echo '
	<script type="text/javascript">tribiq.tooltips();</script>';
	}
}

//Set up the floating box functionality
function setupAdminFloatingBoxes($showInfoBox) {
	echo '
	<form style="display: none;" target="tribiq_iframe" method="post" id="tribiq_iframe_form"></form>
	<iframe style="display: none;" src="" name="tribiq_iframe" id="tribiq_iframe"></iframe>
	<div id="tribiq_now_loading" class="tribiq_now" style="display: none;">
		<h1 style="text-align: center;">', getPhrase('Loading...'), '</h1>
	</div>
	<div id="tribiq_now_saving" class="tribiq_now" style="display: none;">
		<h1 style="text-align: center;">', getPhrase('Saving...'), '</h1>
	</div>
	<div id="tribiq_notification" class="tribiq_now" style="display: none;"></div>
	<div class="tribiq_fbAdmin">
		<div id="tribiq_fbAdminFloatingBox">
			<div class="tribiq_jqmBor"><div class="tribiq_jqmBor"><div class="tribiq_jqmBor"><div class="tribiq_jqmBor">
				<div class="tribiq_jqmHead"><div><div>
					<a class="tribiq_jqmClose" onclick="return tribiqAB.closeButton();" href="#">
						<div><p>', getPhrase('Close'), '</p></div>
					</a>
					<div class="tribiq_jqmTitle"><div><div id="tribiq_jqmTitle"></div></div></div>
				</div></div></div>
				<div class="tribiq_jqmMain"><div class="tribiq_jqmMainBor"><div class="tribiq_jqmMainBor">
					<div id="tribiq_jqmTabs"></div>
					<div id="tribiq_fbMain" class="tribiq_fbMain">
						<div class="tribiq_jqmWinBor"><div class="tribiq_jqmWinBor" id="tribiq_fbAdminInner"></div></div>
						<div class="tribiq_fbButtons" id="tribiq_fbButtons"></div>
					</div>
				</div></div></div>
				<div class="tribiq_jqmFoot"></div>
			</div></div></div></div>
		</div>
		<div id="tribiq_fbAdminMessage">
			<div class="tribiq_jqmBor"><div class="tribiq_jqmBor"><div class="tribiq_jqmBor"><div class="tribiq_jqmBor">
				<div class="tribiq_jqmHead"><div></div></div>
				<div class="tribiq_jqmMain"><div class="tribiq_jqmMainBor"><div class="tribiq_jqmMainBor">
					<div class="tribiq_fbMain">
						<div class="tribiq_jqmWinBor"><div class="tribiq_jqmWinBor">
							<div id="tribiq_fbWarning">
								<div id="tribiq_fbInner"></div>
							</div>
						</div></div>
						<div class="tribiq_fbButtons" id="tribiq_fbMessageButtons" onClick="tribiqA.closeFloatingBox();"></div>
					</div>
				</div></div></div>
				<div class="tribiq_jqmFoot"></div>
			</div></div></div></div>
		</div>';
	
	if ($showInfoBox) {
		echo '
		<div id="tribiq_fbAdminInfoBox">
			<div class="tribiq_infoBoxHead">
				<div onclick="tribiqA.closeInfoBox();"></div>
				<p>', getPhrase('About Tribiq CMS'), '</p>
			</div>
			<div class="tribiq_infoBox">
				<div class="tribiq_infoBoxName">
					', getPhrase('Logged in as [[name]]', array('name' => formatAdminName(getAdminDetails($_SESSION['admin_userid'], $_SESSION['admin_authtype'])))), '
				</div>
				<div>
					<span>', getPhrase('Software Information'), '</span>
					<div>
						<div>
							', cms_core::getEditionName(), '
						</div>
						', getPhrase('Edition:'), '
					</div>
					<div>
						<div>
							', cms_core::getLicenseName(), '
						</div>
						', getPhrase('License:'), '
					</div>
					<div>
						<div>
							', getTribiqCmsVersionNumber(), '
						</div>
						', getPhrase('Version:'), '
					</div>
					<div>
						<div>
							', htmlspecialchars(CSS_JS_VERSION), '
						</div>
						', getPhrase('SVN no:'), '
					</div>
				</div>
				<div>
					<span>', getPhrase('Installation Information'), '</span>
					<div>
						<div>
							', htmlspecialchars(CMS_ROOT), '
						</div>
						', getPhrase('Directory:'), '
					</div>';
			
			if (DBNAME_GLOBAL != DBNAME) {
				echo '
					<div>
						<div>
							', htmlspecialchars(DBNAME), '
						</div>
						', getPhrase('Local Database:'), '
					</div>
					<div>
						<div>
							', htmlspecialchars(DBNAME_GLOBAL), '
						</div>
						', getPhrase('Global Database:'), '
					</div>';
			} else {
				echo '
					<div>
						<div>
							', htmlspecialchars(DBNAME), '
						</div>
						', getPhrase('Database Name:'), '
					</div>';
			}
			
			if (DBHOST_GLOBAL != DBHOST) {
				echo '
					<div>
						<div>
							', htmlspecialchars(DBHOST), '
						</div>
						', getPhrase('Local DB Host:'), '
					</div>
					<div>
						<div>
							', htmlspecialchars(DBHOST_GLOBAL), '
						</div>
						', getPhrase('Global DB Host:'), '
					</div>';
			} else {
				echo '
					<div>
						<div>
							', htmlspecialchars(DBHOST), '
						</div>
						', getPhrase('Database Host:'), '
					</div>';
			}
			
			echo '
				</div>
			</div>
			<div class="tribiq_infoBoxFoot"></div>
		</div>';
	}
	
	echo'
	</div>
	<div class="floating_box" id="tribiq_afb_container">';
	
	global $slotContents, $siteConfig;
	if (checkPriv('_PRIV_MANAGE_PLUGIN_THEME') && isset($slotContents) && is_array($slotContents)) {
		echo '
			<div id="tribiq_fbAdminChangeThemeSample" style="display: none;">
				<div class="tribiq_themename">
					<label>', getPhrase('Theme:'), '</label> <span id="tribiq_theme_name_[[SLOT_NAME]]-[[NEST]]"></span><br/>
					<label>', getPhrase('CSS Selector:'), '</label> <span id="tribiq_theme_selector_[[SLOT_NAME]]-[[NEST]]"></span><br/>
					<label>', getPhrase('Path:'), '</label> <span id="tribiq_theme_path_[[SLOT_NAME]]-[[NEST]]"></span>
				</div>

				<a href="#" onclick="return tribiqA.cancelThemeChange(this, \'[[SLOT_NAME]]\', [[NEST]]);" class="tribiq_close_button"><span></span></a>

				<a href="#" onclick="return tribiqA.previousTheme(this, \'[[SLOT_NAME]]\', [[NEST]]);" class="tribiq_left_arrow"><span></span></a>
				<a href="#" onclick="return tribiqA.nextTheme(this, \'[[SLOT_NAME]]\', [[NEST]]);" class="tribiq_right_arrow"><span></span></a>
				
				<form><input type="hidden" id="tribiq_original_theme_[[SLOT_NAME]]-[[NEST]]"/>
				<input type="button" class="submit_selected" onclick="return tribiqA.saveThemeChange(this, \'[[SLOT_NAME]]\', [[NEST]]);" value="', getPhrase('Save'), '"/></form>
			</div>';
	}
	
	echo '
		<div id="tribiq_fbAdminViewModeOptions" style="display: none;"></div>
		<div id="tribiq_fbAdminMoreCollActions" style="display: none;"></div>
		<div id="tribiq_fbAdminMoreItemActions" style="display: none;"></div>
		<div id="tribiq_fbAdminTooltip" style="display: none;"></div>
		<div id="tribiq_fbAdminStorekeeper" style="display: none;"></div>
	</div>';

	echo '
		<script type="text/javascript" language="JavaScript">
			tribiqA.pageMode = ';
	
	if (session('page_preview_mode')) {
		echo "'preview';";
	} elseif (session('page_slot_mode')) {
		echo "'slot';";
	} else {
		echo "'edit';";
	}

	if (issetArrayKey($siteConfig, 'storekeeper_preload_select_mode')) {
		echo '
			$(document).ready(tribiqA.SKStartInit);';
	}
	
	echo '
		</script>';
}

//Write the JavaScript command needed to use the floating box above
function floatingBoxJS($message, $buttons = false, $showWarning = false, $addCancelButton = false) {
	
	if (!$buttons) {
		$buttons = '<input type="button" value="'. getPhrase('_OK'). '" />';
	}
	
	if ($addCancelButton) {
		$buttons .= '<input type="button" value="'. getPhrase('_CANCEL'). '" />';
	}
	
	return 'tribiqA.floatingBox(\''. jsOnClickEscape($message). '\', \''. jsOnClickEscape($buttons). '\', '. ($showWarning ===  2 || $showWarning === 'error'? '2' : ($showWarning? '1' : '0')). ');';
}


function getAdminStorekeeperPrefs() {
	$sql = "
		SELECT prefs
		FROM ". DB_NAME_PREFIX. "admin_storekeeper_prefs
		WHERE admin_id = ". (int) $_SESSION['admin_userid']. "
		  AND admin_type = '". mysql_real_escape_string($_SESSION['admin_authtype']). "'";
	
	$result = my_mysql_query($sql);
	if ($row = mysql_fetch_assoc($result)) {
		return $row['prefs'];
	} else {
		return '{}';
	}
}


function saveAdminStorekeeperPrefs($prefs) {
	$sql = "
		REPLACE INTO ". DB_NAME_PREFIX. "admin_storekeeper_prefs SET
			prefs = '". mysql_real_escape_string($prefs). "',
			admin_id = ". (int) $_SESSION['admin_userid']. ",
			admin_type = '". mysql_real_escape_string($_SESSION['admin_authtype']). "'";
	
	my_mysql_query($sql);
}



function adminLogout () {
	$sql = "DELETE FROM ".DB_NAME_PREFIX."admin_session
			WHERE phpsessid = '". mysql_real_escape_string($_COOKIE["PHPSESSID"]) ."'";
			
	$result = my_mysql_query ($sql);
	
	unset ($_SESSION["admin_userid"]);
	unset ($_SESSION["admin_username"]);
	unset ($_SESSION["admin_authtype"]);
	unset ($_SESSION["admin_lang"]);
	unset ($_SESSION["perm_manage"]);
	unset ($_SESSION["perm_publish"]);
	unset ($_SESSION["perm_author"]);
	unset ($_SESSION["perm_editmenu"]);
	unset ($_SESSION["perm_manageforum"]);
	unset ($_SESSION["perm_override_author_lock"]);
	unset ($_SESSION["perm_view_users"]);
	unset ($_SESSION["perm_edit_users"]);
	unset ($_SESSION["perm_view_groups"]);
	unset ($_SESSION["perm_edit_groups"]);
	unset ($_SESSION["perm_sysadmin"]);
	unset ($_SESSION["perm_translate"]);
	
	if (isset(	$_COOKIE[session_name()] ) ) {
    	setcookie( session_name(), "", time()-42000, "/" );
	}
	
	session_destroy();
}

function getActionAdministrator ($cID, $cType, $cVersion, $status) {
	switch ($status) {
		case "private_draft";
			$sql_frag1 = "last_author_id";
			$sql_frag2 = "last_author_authtype";
			break;
		case "published";
			$sql_frag1 = "publisher_id";
			$sql_frag2 = "publisher_authtype";
			break;
		case "archived";
			$sql_frag1 = "archiver_id";
			$sql_frag2 = "archiver_authtype";
			break;
		case "hidden";
			$sql_frag1 = "hider_id";
			$sql_frag2 = "hider_authtype";
			break;
		default:
		return false;
	}
	
	$sql = "SELECT " . $sql_frag1 . ",
				" . $sql_frag2 . "
			FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . "
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;
	
	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		
		$admin = getAdminDetails($row[$sql_frag1],$row[$sql_frag2],true,false);
		
		return $admin;
	} else {
		return false;
	}
}

function getActionTimestamp ($cID, $cType, $cVersion, $status) {
	switch ($status) {
		case "private_draft";
			$sql_frag1 = "created_datetime";
			break;
		case "published";
			$sql_frag1 = "published_datetime";
			break;
		case "archived";
			$sql_frag1 = "archived_datetime";
			break;
		case "hidden";
			$sql_frag1 = "hidden_datetime";
			break;
		default:
		return false;
	}
	
	$sql = "SELECT " . $sql_frag1 . "
			FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . "
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;
	
	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		
		return $row[0];
	} else {
		return false;
	}	
}

function wasActionPerfomedToday($cID, $cType, $cVersion, $status) {
	if ($actionDate = getActionTimestamp($cID, $cType, $cVersion, $status)) {
		return (mysql_num_rows(my_mysql_query("SELECT 1 
												FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . " 
												WHERE DATE(NOW())=DATE('" . mysql_real_escape_string($actionDate) . "') LIMIT 1" 
												))==1);
	} else {
		return false;
	}
}

function wasActionPerfomedYesterday($cID, $cType, $cVersion, $status) {
	if ($actionDate = getActionTimestamp($cID, $cType, $cVersion, $status)) {
		return (mysql_num_rows(my_mysql_query("SELECT 1 
												FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . " 
												WHERE DATE(NOW())=DATE_ADD(DATE('" . mysql_real_escape_string($actionDate) . "'),INTERVAL 1 DAY) LIMIT 1" 
												))==1);
	} else {
		return false;
	}
}


function publishContent($cID, $cType, $cVersion, $adminId = false, $adminType = false) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	
	if (!$adminId) {
		$adminId = $_SESSION['admin_userid'];
		$adminType = $_SESSION['admin_authtype'];
	}

	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . $cType . "
			SET status = 'published',
				draft_exists = 0,
				publisher_id = " . (int) $adminId . ",
				publisher_authtype = '" . mysql_real_escape_string($adminType) . "',
				published_datetime = NOW()
			WHERE status != 'published'
				AND id = " . (int) $cID . "
				AND version = " . (int) $cVersion;
	$result = my_mysql_query($sql);
	
	if (!mysql_affected_rows()) {
		return;
	}

	if ($cType=="html") {
		$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems
				SET html_content_alias = '" . mysql_real_escape_string(getContentAlias($cID,$cVersion)) . "',
				active = '1'
				WHERE content_id = " . (int) $cID . "
					AND content_type = 'html'";

		$result = my_mysql_query($sql);
	} else {
		$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems
				SET active = '1'
				WHERE content_id = " . (int) $cID . "
					AND content_type = '" . mysql_real_escape_string($cType) . "'";

		$result = my_mysql_query($sql);
	}

	if ($menuitem_array = getMenuItemFromContent($cID, $cType)) {
		$menuitem = $menuitem_array[0];

		setParentMenuItemsActive($menuitem);
	}

	$prev_version = $cVersion - 1;

	if ($prev_version>0) {
		if ($cType=="html") {
			if (getContentStatus($cID,"html",$prev_version)=="published") {
				
				if (includeContentType('html')) {
					$currentAlias = getAlias($cID,$prev_version);
					$newAlias = getAlias($cID,$cVersion);
				}
				
				if (checkModuleReadyAndInclude("microsites-cms.inc.php")) {
					$currentMicrositeId = getMicrositeIdFromContent($cID,$cType,$prev_version);
					$newMicrositeId = getMicrositeIdFromContent($cID,$cType,$cVersion);
					
					if ($currentMicrositeId==$newMicrositeId) {
						$microsite = getMicrosite($newMicrositeId);
						
						if ($microsite['home_alias']==$currentAlias) {
							setMicrositeHomepageAlias($currentMicrositeId,$newAlias);
						}
					}
				}
			}
		}
	}
	
	cms_core::publishContent($cID, $cType, $cVersion, $prev_version, $adminId, $adminType);

	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . "
			SET draft_exists = 0
			WHERE id = " . $cID;
			
	$result = my_mysql_query($sql);

	if (function_exists("getMenuStructureArray")) {
		$menu_array = getMenuStructureArray(0,0,"","");
		createMenuCache($menu_array);
	}

	if (function_exists("updateKeywordCache")) {
		$sql = "SELECT keywords
				FROM " . DB_NAME_PREFIX . "content_" . $cType . "
				WHERE id = " . (int) $cID . "
					AND status = 'published'";
		
		$result = my_mysql_query($sql);
		
		$row = mysql_fetch_array($result);
	
		updateKeywordCache($row['keywords'],$cID,$cType);
	}
	sendSignal("eventContentPublished",array("cID" => $cID,"cType" => $cType, "cVersion" => $cVersion));
}

function getAdmins($authtype, $status_array) {
	if ($authtype=="local") {
		$sql = "SELECT id,
					username,
					first_name,
					last_name,
					perm_manage,
					perm_publish,
					perm_author,
					perm_editmenu,
					perm_manageforum,
					perm_sysadmin,
					perm_translate,
					perm_override_author_lock,
					perm_view_users,
					perm_edit_users,
					perm_view_groups,
					perm_edit_groups
				FROM ".DB_NAME_PREFIX."admins
				WHERE status IN ";

		$sql_where = "(";

		foreach ($status_array as $status) {
			$sql_where .= "'" . mysql_real_escape_string($status) . "',";
		}

		$sql_where = substr($sql_where,0,strlen($sql_where)-1) . ")";

		$sql .= $sql_where;

		$result = my_mysql_query ($sql);

		if (mysql_num_rows($result)>0) {
			while ($row = mysql_fetch_array($result)) {
				$admins[] = $row;
			}
			return $admins;
		} else {
			return false;
		}
	} elseif ($authtype=="super") {
		connectGlobalDB();

		$sql = "SELECT id,
					username,
					first_name,
					last_name,
					perm_manage,
					perm_publish,
					perm_author,
					perm_editmenu,
					perm_manageforum,
					perm_sysadmin,
					perm_translate,
					perm_override_author_lock,
					perm_view_users,
					perm_edit_users,
					perm_view_groups,
					perm_edit_groups
				FROM ".DB_NAME_PREFIX_GLOBAL."superadmins
				WHERE status IN ";

		$sql_where = "(";

		foreach ($status_array as $status) {
			$sql_where .= "'" . mysql_real_escape_string($status) . "',";
		}

		$sql_where = substr($sql_where,0,strlen($sql_where)-1) . ")";

		$sql .= $sql_where;

		$result = my_mysql_query ($sql);

		connectLocalDB();

		if (mysql_num_rows($result)>0) {
			while ($row = mysql_fetch_array($result)) {
				$admins[] = $row;
			}
			return $admins;
		} else {
			return false;
		}
	}
}

function deleteContent($cID, $cType, $cVersion = false, $itemIsArchived = false) {
	return require 'cmsincludes/admin/deleteContent.fun.php';
}

function deleteArchive($cID, $cType, $cVersion) {
	for ($v = $cVersion; checkRowExists('content_'. mysql_real_escape_string($cType), array('id' => $cID, 'version' => $v)); --$v) {
		deleteContent($cID, $cType, $v, $itemIsArchived = true);
	}
}

function trashContent($cID, $cType) {

	$cID = (int) $cID;

	/* Update selected version to archived and put it in trash folder */

	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . "
			SET status = 'archived',
				archiver_id = " . $_SESSION['admin_userid'] . ",
				archiver_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
				archived_datetime = NOW()";
	
	if ($cType=="html") {
		$sql .= ",alias = ''";
	}
	
	$sql .= "	WHERE status IN ('published', 'hidden')
				  AND id = " . (int) $cID;

	$result = my_mysql_query($sql);
	
	removeItemFromMenu($cID, $cType);

	/* Update images to archived */

	$sql = "UPDATE " . DB_NAME_PREFIX . "images
			SET archived = 1
			WHERE content_item_id = " . (int) $cID . "
				AND content_item_type = '" . mysql_real_escape_string($cType) . "'";
	
	$result = my_mysql_query($sql);
	
	
	
	if (inc('tribiq_avls')) {
		tribiq_avls::removeEquivalence($cID, $cType);
	}
	
	sendSignal("eventContentTrashed",array("cID" => $cID,"cType" => $cType));
}

function removeItemFromMenu($cID, $cType) {
	/* Get the menuitem(s) for this content item if available */

	$sql = "SELECT id
			FROM " . DB_NAME_PREFIX . "menuitems
			WHERE content_id = " . (int) $cID . "
				AND content_type = '" . mysql_real_escape_string($cType) . "'";

	if ($result = my_mysql_query($sql)) {
		while ($row = mysql_fetch_assoc($result)) {

			if (getNumMenuChildren($row['id'])==0) {
				/* If this menuitem has no children delete it */
				$sql = "DELETE
						FROM " . DB_NAME_PREFIX . "menuitems
						WHERE id = " . (int) $row['id'] . "
						LIMIT 1";
			} else {
				/* Update the menuitem to point to nothing */
				$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems
						SET content_id = 0,
							content_type = '',
							html_content_alias = '',
							target_loc = 'none'
						WHERE id = " . (int) $row['id'];
			}
			
			my_mysql_query($sql);
		}
	}
}


function hideContent($cID, $cType) {
	$cID = (int) $cID;

	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . "
			SET status = 'hidden',
				hider_id = " . $_SESSION['admin_userid'] . ",
				hider_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
				hidden_datetime = NOW()
			WHERE status = 'published'
			  AND id = " . (int) $cID;

	$result = my_mysql_query($sql);
	
	$sql1 = "UPDATE " . DB_NAME_PREFIX . "menuitems
			SET active = '0'
			WHERE content_id = '" . mysql_real_escape_string($cID) . "'
				AND content_type = '" . mysql_real_escape_string($cType) . "'";
	$result = my_mysql_query($sql1);
	
	sendSignal("eventContentHidden",array("cID" => $cID,"cType" => $cType));
}

function addMediaToContentItemIfNeeded($type, $checksum, $dest_cID, $dest_cType, $dest_cVersion = false) {
	
	if (!$dest_cVersion) {
		$dest_cVersion = getLatestVersion($dest_cID, $dest_cType);
	}
	
	$sql = "
		SELECT
			id,
			content_item_id,
			content_item_type,
			content_item_version,
			mime_type,
			width, 
			height, 
			data, 
			size, 
			filename,
			checksum,
			checksum_inc_name,
			thumbnail_data,
			thumbnail_width,
			thumbnail_height,
			thumbnail_size";
	if ($type == 'image') {
		$sql .= ",
			storekeeper_width,
			storekeeper_height,
			storekeeper_data,
			storekeeper_size";
	}
	
	$sql .= "
		FROM " . DB_NAME_PREFIX . "". mysql_real_escape_string($type). "s
		WHERE checksum_inc_name = '". mysql_real_escape_string($checksum). "'
		ORDER BY content_item_id = " . (int) $dest_cID . "
			 AND content_item_type = '" . mysql_real_escape_string($dest_cType) . "'
			 AND content_item_version = " . (int) $dest_cVersion . " DESC
		LIMIT 1";
	
	$result = my_mysql_query($sql);
	$image = mysql_fetch_assoc($result);
	
	if (!$image['content_item_id']) {
		//Image/Movie is unassociated; associate it
		$sql = "
			UPDATE " . DB_NAME_PREFIX . "". mysql_real_escape_string($type). "s SET
				content_item_id = " . (int) $dest_cID . ",
				content_item_type = '" . mysql_real_escape_string($dest_cType) . "', 
				content_item_version = " . (int) $dest_cVersion . "
			WHERE id = ". (int) $image['id'];
		my_mysql_query($sql);
		return;
		
	} elseif ($image['content_item_id'] == $dest_cID && $image['content_item_type'] == $dest_cType && $image['content_item_version'] == $dest_cVersion) {
		//Image/Movie already associated with this content item, no need to do anything
		return;
	
	} else {
		//Image/Movie already associated with a different content item, make a copy and associate it with this item
		unset($image['id']);
		$image['content_item_id'] = $dest_cID;
		$image['content_item_type'] = $dest_cType;
		$image['content_item_version'] = $dest_cVersion;
		
		$unsets = array();
		foreach($image as $key => $value) {
			if (!$value) {
				$unsets[] = $key;
			}
		}
		foreach($unsets as $unset) {
			unset($image[$unset]);
		}
		
		setRow($type. "s", $image);
	}
}

function setPublic($cID,$cType,$cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;

	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "group_content_link
			WHERE content_id = " . (int) $cID . "
				AND content_type = '" . mysql_real_escape_string($cType) . "'
				AND content_version = " . (int) $cVersion;

	$result = my_mysql_query($sql);

	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . $cType . "
			SET private = 0
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;

	$result = my_mysql_query($sql);
}

function getPublic($cID,$cType,$cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;

	$sql = "SELECT private
			FROM " . DB_NAME_PREFIX . "content_" . $cType . "
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;

	$result = my_mysql_query($sql);
	$row = mysql_fetch_array($result);

	if ($row['private']==1) {
		return false;
	} else {
		return true;
	}
}

function setPrivate($cID,$cType,$cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;

	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "group_content_link
			WHERE content_id = " . (int) $cID . "
				AND content_type = '" . mysql_real_escape_string($cType) . "'
				AND content_version = " . (int) $cVersion;
	$result = my_mysql_query($sql);

	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . $cType . "
			SET private = 1
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;

	$result = my_mysql_query($sql);
}

function getPrivate($cID,$cType,$cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;

	$sql = "SELECT private
			FROM " . DB_NAME_PREFIX . "content_" . $cType . "
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;

	$result = my_mysql_query($sql);
	$row = mysql_fetch_array($result);

	if ($row['private']==1) {
		return true;
	} else {
		return false;
	}
}

function setPrivateByGroupAndUser ($cID,$cType,$cVersion,$groups=array(),$users=array()) {
	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . $cType . "
			SET private = 1
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;
	$result = my_mysql_query($sql);

	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "group_content_link
			WHERE content_id = " . (int) $cID . "
				AND content_type = '" . mysql_real_escape_string($cType) . "'
				AND content_version = " . (int) $cVersion;

	$result = my_mysql_query($sql);

	foreach ($groups as $group) {
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "group_content_link
				SET group_id = " . $group . ",
					content_id = " . (int) $cID . ",
					content_version = " . (int) $cVersion . ",
					content_type = '" . mysql_real_escape_string($cType) . "'";

		$result = my_mysql_query($sql);
	}

	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "user_content_link
			WHERE content_id = " . (int) $cID . "
				AND content_type = '" . mysql_real_escape_string($cType) . "'
				AND content_version = " . (int) $cVersion;

	$result = my_mysql_query($sql);

	foreach ($users as $user) {
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "user_content_link
				SET user_id = " . $group . ",
					content_id = " . (int) $cID . ",
					content_version = " . (int) $cVersion . ",
					content_type = '" . mysql_real_escape_string($cType) . "'";

		$result = my_mysql_query($sql);
	}
}

function getPrivateByGroupAndUser ($cID,$cType,$cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;

	$sql = "SELECT group_id
			FROM " . DB_NAME_PREFIX . "group_content_link
			WHERE content_id = " . (int) $cID . "
				AND content_type = '" . mysql_real_escape_string($cType) . "'
				AND content_version = " . (int) $cVersion;
	$result = my_mysql_query($sql);

	$groups = mysql_fetch_array($result);

	$sql = "SELECT user_id
			FROM " . DB_NAME_PREFIX . "user_content_link
			WHERE content_id = " . (int) $cID . "
				AND content_type = '" . mysql_real_escape_string($cType) . "'
				AND content_version = " . (int) $cVersion;
	$result = my_mysql_query($sql);

	$users = mysql_fetch_array($result);

	return array($groups,$users);

}



//Validation function for checking aliases
function validateAlias($alias, $cID = false, $errorIfNotExists = false) {
	
	$error = array();
	if ($alias!="") {
		if (preg_match('/\s/', $alias)) {
			$error[] = getPhrase("You must not have a space in your Alias.");
		}
		
		if (preg_match('/[A-Z]/', $alias)) {
			$error[] = getPhrase("An Alias cannot have Upper Case Characters.");
		}
		
		if (preg_match('/[^a-zA-Z 0-9_-]/', $alias)) {
			$error[] = getPhrase("An Alias can only contain the letters a-z, numbers, underscores or hyphens.");
		}
		
		if (is_numeric($alias)) {
			$error[] = getPhrase("You must enter a non-numeric Alias.");
		}
		
		$existingItem = aliasExists(tidyAlias($alias), $cID);
		if (!$errorIfNotExists && $existingItem) {
			
			$cVersion = getLatestVersion($existingItem['id'], 'html');
			$tag = getTag($existingItem['id'], 'html', $existingItem['version']);
			
			$error[] = getPhrase("_MSG_UNIQUE_ALIAS", array('alias' => $alias, 'tag' => $tag, 'version' => $existingItem['version'], 'status' => $existingItem['status']));
		
		} elseif ($errorIfNotExists && !$existingItem) {
			
			$error[] = getPhrase("The Alias &quot;[[alias]]&quot; does not exist!", array('alias' => $alias));
		}
	}
	
	if (empty($error)) {
		return false;
	} else {
		return $error;
	}
}

function tidyAlias ($alias) {
	
	$alias = strtolower($alias);
	$alias = str_replace(" ","-",$alias);
	$alias = preg_replace("/[^a-z0-9-_]/","",$alias);
	
	return $alias;
}

function aliasExists($alias, $cID = false) {
	
	$sql = "
		SELECT id, version, status
		FROM " . DB_NAME_PREFIX . "content_html 
		WHERE alias = '" . mysql_real_escape_string($alias) . "'";
	
	if ($cID) {
		$sql .= "
		  AND id <> ". (int) $cID;
	}

	$sql .= "
		ORDER BY id, version DESC";
	
	$result = my_mysql_query($sql);
	
	if ($row = mysql_fetch_assoc($result)) {
		return $row;
	} else {
		return false;
	}
}

//Check to see if a given alias is used as a system alias
function checkIfAliasIsSystemAlias($alias, $cType = 'html') {
	$error = array();
	
	//Allow the function to take a cID and cType as inputs, if the alias is unknown
	if (is_numeric($alias)) {
		$cID = $alias;
		
		//Is this a html-type item?
		if ($cType != 'html') {
			//Non-html type items do not have aliases, we can stop here
			return false;
		}
	} else {
		//No need to check empty/not set aliases
		if ($alias == '') {
			return false;
		}
		
		$cID = getIDfromAlias($alias);
	}
	
	//Check for the site default homepage
	if ($cID == getSiteConfig('default_homepage_id')) {
		return true;
	}
	
	//Check for the Homepage, Sitemap and Search Page for each language
	return checkRowExists('languages', array('homepage_id' => $cID))
		|| checkRowExists('languages', array('search_page_id' => $cID))
		|| checkRowExists('languages', array('extranet_login_page_id' => $cID))
		|| checkRowExists('languages', array('extranet_registration_page_id' => $cID))
		|| checkRowExists('languages', array('extranet_password_reminder_page_id' => $cID))
		|| checkRowExists('languages', array('extranet_change_password_page_id' => $cID))
		|| checkRowExists('languages', array('extranet_logout_page_id' => $cID));
}


//ADMINISTRATOR
function getAdminDetails($admin_id, $authtype, $renameAndFilterColumns = true, $onlyGetActiveAdmins = true) {
	$admin_id = (int) $admin_id;

	if ($authtype=="local") {
		$sql = "SELECT *
				FROM ".DB_NAME_PREFIX."admins
				WHERE id='".mysql_real_escape_string($admin_id)."'";
		
		if ($onlyGetActiveAdmins) {
			$sql .= "
				  AND status = 'active'";
		}
		
		$result = my_mysql_query ($sql);
	} else {
		connectGlobalDB();
			$sql = "SELECT *
					FROM ".DB_NAME_PREFIX_GLOBAL."superadmins
					WHERE id='".mysql_real_escape_string($admin_id)."'";
			
			if ($onlyGetActiveAdmins) {
				$sql .= "
					  AND status = 'active'";
			}
			
			$result = my_mysql_query ($sql);
		connectLocalDB();
	}

	if ($row = mysql_fetch_array($result)) {
		if ($renameAndFilterColumns) {
			if($row["perm_manage"]<>"1") {
				$disable='1';
			} else {
				$disable='0';
			}
			
			return array(
				'admin_id' => $row["id"],
				'admin_username' => $row["username"],
				'admin_type' => $authtype,
				'admin_status' => $row["status"],
				'admin_use_language_id' => $row["use_language_id"],
				'admin_first_name' => $row["first_name"],
				'admin_last_name' => $row["last_name"],
				'admin_email' => $row["email"],
				'admin_perm_manage' => $row["perm_manage"],
				'admin_perm_sysadmin' => $row["perm_sysadmin"],
				'admin_perm_publish' => $row["perm_publish"],
				'admin_perm_author' => $row["perm_author"],
				'admin_perm_editmenu' => $row["perm_editmenu"],
				'admin_perm_manageforum' => $row["perm_manageforum"],
				'admin_perm_override_author_lock' => $row["perm_override_author_lock"],
				'admin_perm_view_users' => $row["perm_view_users"],
				'admin_perm_edit_users' => $row["perm_edit_users"],
				'admin_perm_view_groups' => $row["perm_view_groups"],
				'admin_perm_edit_groups' => $row["perm_edit_groups"],
				'admin_perm_translate' => $row["perm_translate"],
				'admin_created_date' => $row["created_date"],
				'admin_modified_date' => $row["modified_date"],
				'admin_preferred_editor_id' => $row["preferred_editor_id"],
				'admin_note_email_min_priority' => $row["note_email_min_priority"],
				'disable' => $disable);
		} else {
			return $row;
		}
	} else {
		return false;
	}
}

//Takes a row from an admin table, and returns the admin's name in the standard format
function formatAdminName($adminDetails) {

	return $adminDetails['admin_username']. ' - '. $adminDetails['admin_first_name']. ' '. $adminDetails['admin_last_name']. (
		$adminDetails['admin_type'] == 'super'?
			' (superadmin)'
		:
			null
	);
}

//Takes a row from an admin table, and returns the admin's first and last names in the standard format
function formatAdminFullName($adminDetails) {

	return $adminDetails['admin_first_name']. ' '. $adminDetails['admin_last_name'];
}

function alreadyExistsAdmin($uname, $currentAdminId = false, $currentAdminType = '') {
	
	$sql = "SELECT username, status
			FROM ".DB_NAME_PREFIX."admins
			WHERE username='".mysql_real_escape_string($uname)."'";
	
	if ($currentAdminId && $currentAdminType == 'local') {
		$sql .= "
			  AND id != ". (int) $currentAdminId;
	}
	
	$result = my_mysql_query($sql);

	if(mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		return $row['status'];
	} else {
		/* Select the global database for phrases, but remember the Site DB */
		connectGlobalDB();

		$sql = "SELECT username, status
				FROM ".DB_NAME_PREFIX_GLOBAL."superadmins
				WHERE username='".mysql_real_escape_string($uname)."'";
		
		if ($currentAdminId && $currentAdminType == 'super') {
			$sql .= "
				  AND id != ". (int) $currentAdminId;
		}
		
		$result = my_mysql_query($sql);

		if(mysql_num_rows($result)>0) {
			$row = mysql_fetch_array($result);
			connectLocalDB();
			return $row['status'];
		} else {
			connectLocalDB();
			return false;
		}
	}
}

function validateAdmin($adminDetails, $adminId, $adminType) {
	
	$errArray = array();
	
	if(isset($adminDetails['username']) && !$adminDetails['username']) {
		$errArray[] = getPhrase('_MSG_USERNAME_ADMIN');
	}
	
	if (isset($adminDetails['username']) && alreadyExistsAdmin($adminDetails['username'], $adminId, $adminType) ) {
		$errArray[] = getPhrase('_MSG_OTHER_USERNAME_ADMIN');
	}
	
	if (isset($adminDetails['username']) && strpos($adminDetails['username'], ' ') !== false) {
		$errArray[] = getPhrase('_MSG_USERNAME_SPACES_ADMIN');
	}
	
	if (isset($adminDetails['password']) && $adminDetails['password'] === '') {
		$errArray[] = getPhrase('_MSG_NO_PASS');
	
	} elseif (isset($adminDetails['password']) && !checkPasswordStrength($adminDetails["password"])) {
		$errArray[] = getPhrase("_MSG_PASS_STRENGTH");
	}
	
	if (isset($adminDetails['password_reconfirm']) && $adminDetails['password_reconfirm'] === '') {
		$errArray[] = getPhrase('_MSG_PASS');
	
	} elseif (isset($adminDetails['password_reconfirm']) && isset($adminDetails['password']) && $adminDetails['password'] != $adminDetails['password_reconfirm']) {
		$errArray[] = getPhrase('_MSG_PASS_2');
	}
	
	if (isset($adminDetails['status']) && !$adminDetails['status']) {
		$errArray[] = getPhrase('_MSG_NO_STATUS');
	}
	
	if (isset($adminDetails['firstName']) && !$adminDetails['firstName']) {
		$errArray[] = getPhrase('_MSG_NAME_LASTN_ADMIN');
	}
	
	if (isset($adminDetails['lastName']) && !$adminDetails['lastName']) {
		$errArray[] = getPhrase('_MSG_NAME_LASTN_ADMIN');
	}
	
	if ($adminDetails['email'] && !validateEmailAddress($adminDetails['email'])) {
		$errArray[] = getPhrase('_MSG_VALID_EMAIL_ADMIN');
	}
	
	return array('valid' => !count($errArray), 'errArray' => $errArray);
}

function saveAdmin($newAdmin, &$admin_id, $authtype, $nonDestructive = false) {
	return require 'cmsincludes/admin/saveAdmin.fun.php';
}

//Add an administrator into a role
function setAdminRole($adminId, $adminType, $role, $add, $nonDestructive = false) {
	
	$actions = array();
	connectGlobalDB();
		
		$sql = "
			SELECT name
			FROM ". DB_NAME_PREFIX_GLOBAL. "actions
			WHERE role_name = '". mysql_real_escape_string($role). "'";
		$result = my_mysql_query($sql);
		
		while ($row = mysql_fetch_assoc($result)) {
			$actions[] = $row['name'];
		}
		
		if ($adminType != 'local') {
			foreach ($actions as $action) {
				if ($add) {
					$sql = "
						REPLACE INTO ". DB_NAME_PREFIX_GLOBAL. "action_superadmin_link SET
							action_name = '". mysql_real_escape_string($action). "',
							admin_id = ". (int) $adminId;
					my_mysql_query($sql);
				
				} elseif (!$nonDestructive) {
					$sql = "
						DELETE FROM ". DB_NAME_PREFIX_GLOBAL. "action_superadmin_link
						WHERE action_name = '". mysql_real_escape_string($action). "'
						  AND admin_id = ". (int) $adminId;
					my_mysql_query($sql);
				}
			}
		}
	
	connectLocalDB();
		
	if ($adminType == 'local') {
		foreach ($actions as $action) {
			if ($add) {
				$sql = "
					REPLACE INTO ". DB_NAME_PREFIX. "action_admin_link SET
						action_name = '". mysql_real_escape_string($action). "',
						admin_id = ". (int) $adminId;
				my_mysql_query($sql);
				
			} elseif (!$nonDestructive) {
				$sql = "
					DELETE FROM ". DB_NAME_PREFIX. "action_admin_link
					WHERE action_name = '". mysql_real_escape_string($action). "'
					  AND admin_id = ". (int) $adminId;
				my_mysql_query($sql);
			}
		}
	}
}

function deleteAdmin($admin_id, $authtype, $undo = false) {
	$admin_id = (int) $admin_id;

	//verify if user has not been deleted
	if ($authtype=="local") {
		$sql = "SELECT id
				FROM ".DB_NAME_PREFIX."admins
				WHERE id = '". mysql_real_escape_string($admin_id) ."'
					AND status ". ($undo? "!" : ""). "= 'deleted'";
		$result = my_mysql_query($sql);
		if($row = mysql_fetch_array($result)) {
			return false;
		}
		else {
			//verify if user doesn't exists
			$sql = "SELECT id
					FROM ".DB_NAME_PREFIX."admins
					WHERE id = '". mysql_real_escape_string($admin_id) ."'";
			$result = my_mysql_query($sql);
			if(!$row = mysql_fetch_array($result)) {
				return false;
			}
			else {
				//no errors, then delete
				$sql = "UPDATE ".DB_NAME_PREFIX."admins
						SET status = '". ($undo? "active" : "deleted"). "',
							modified_date = CURDATE(),
							password_salt = '',
							password_needs_changing = 1
						WHERE id = '". mysql_real_escape_string($admin_id) ."'";
				$result = my_mysql_query($sql);
				return true;
			}
		}
	} else {
		connectGlobalDB();
		$sql = "SELECT id
				FROM ".DB_NAME_PREFIX_GLOBAL."superadmins
				WHERE id = '". mysql_real_escape_string($admin_id) ."'
					AND status ". ($undo? "!" : ""). "= 'deleted'";
		$result = my_mysql_query($sql);
		if($row = mysql_fetch_array($result)) {
			connectLocalDB();
			return false;
		}
		else {
			//verify if user doesn't exists
			$sql = "SELECT id
					FROM ".DB_NAME_PREFIX_GLOBAL."superadmins
					WHERE id = '". mysql_real_escape_string($admin_id) ."'";
			$result = my_mysql_query($sql);
			if(!$row = mysql_fetch_array($result)) {
				connectLocalDB();
				return false;
			}
			else {
				//no errors, then delete
				$sql = "UPDATE ".DB_NAME_PREFIX_GLOBAL."superadmins
						SET status = '". ($undo? "active" : "deleted"). "',
							modified_date = CURDATE(),
							password_salt = '',
							password_needs_changing = 1
						WHERE id = ". $admin_id;
				$result = my_mysql_query($sql);
				connectLocalDB();
				return true;
			}
		}
		connectLocalDB();
	}
}

//Workaround function that checks to see if the password_salt and
//password_needs_changing columns exist.
function checkNewPasswordColumnsExist() {

	//Use whether the NEW_PASSWORD_COLUMNS_EXIST constant is defined to cache this
	if (!defined('NEW_PASSWORD_COLUMNS_EXIST')) {
	
		//Run a SQL statement, and use whether it fails or not to check if the columns exist
		define('NEW_PASSWORD_COLUMNS_EXIST',
			@mysql_query("
				SELECT password_salt, password_needs_changing
				FROM ". DB_NAME_PREFIX ."admins
				LIMIT 1"
			)?
					true
				:
					false
		);
	}

	return NEW_PASSWORD_COLUMNS_EXIST;
}

//Check to see if an admin exists and if the supplied password matches their password
// 0 means they didn't exist
// false means they exist but their password wasn't correct
// true means they exist and that password was right

//If the admin exists, then the details are returned even if the password was wrong.
//Also, if you're only after their details and not the password check, then you can
//set the password to false to avoid checking passwords.
function checkPasswordAdmin($adminUsernameOrEmail, &$details, $password = false, $checkViaEmail = false) {
	return require 'cmsincludes/admin/checkPasswordAdmin.fun.php';
}

//Shortcut to $checkViaEmail = true for the function above
function checkPasswordAdminByEmail($adminEmail, &$details, $password = false) {
	return checkPasswordAdmin($adminEmail, $details, $password, true);
}

//Sets an admin's password, overwriting the current value
//By default changing someone's password removes the password_needs_changing flag, but
//you can override this and set it instead by passing a value of 1 to $requireChange
function setPasswordAdmin( $adminId, $authType, $password, $requireChange = 0) {
	
	//Check which table name we need to update
	$sql = $authType == 'local'? DB_NAME_PREFIX. 'admins' : DB_NAME_PREFIX_GLOBAL. 'superadmins';
	
	//Generate a random salt for this password. If someone gets hold of the encrypted value of
	//the password in the database, having a salt on it helps to stop dictonary attacks.
	$salt = randomString(8);
	
	if (checkNewPasswordColumnsExist()) {
		$sql = "
			UPDATE ". $sql. " SET
				modified_date = CURDATE(),
				password_salt = '". $salt. "',
				password_needs_changing = ". (int) $requireChange. ",
				password = SHA('". mysql_real_escape_string($salt. $password). "')
			WHERE id = ". (int) $adminId;
	} else {
		$sql = "
			UPDATE ". $sql. " SET
				modified_date = CURDATE(),
				password = '". mysql_real_escape_string($password). "'
			WHERE id = ". (int) $adminId;
	}
	
	
	if ( $authType == 'local' ) {
		$result = my_mysql_query($sql);
	} else {
		connectGlobalDB();
		$result = my_mysql_query($sql);
		connectLocalDB();
	}
}

function cancelPasswordChange($adminId, $authType) {
	
	//Check which table name we need to update
	$sql = $authType == 'local'? DB_NAME_PREFIX. 'admins' : DB_NAME_PREFIX_GLOBAL. 'superadmins';
	
	if (checkNewPasswordColumnsExist()) {
		$sql = "
			UPDATE ". $sql. " SET
				password_needs_changing = 0
			WHERE id = ". (int) $adminId;
		
		if ( $authType == 'local' ) {
			$result = my_mysql_query($sql);
		} else {
			connectGlobalDB();
			$result = my_mysql_query($sql);
			connectLocalDB();
		}
	}
}

//Reset someone's password, returning the reset password
//A randomly generated string is used
function resetPasswordAdmin($adminId, $authType) {
	$newPassword = randomString();
	setPasswordAdmin($adminId, $authType, $newPassword, 1);
	return $newPassword;
}



function setProfileAdmin( $adminId, $authType,  $profile ) {
	$adminId = (int) $adminId;
	$sql = "
		use_language_id = '".mysql_real_escape_string( $profile['language_id'] )."',
		first_name = '".mysql_real_escape_string( $profile['first_name'] )."',
		last_name = '".mysql_real_escape_string( $profile['last_name'] )."',
		email = '".mysql_real_escape_string( $profile['email'] )."',
		preferred_editor_id = '".mysql_real_escape_string( $profile['preferred_editor_id'] ) . "'";
	if ( $authType == "local" ) {
		$sql = "
			UPDATE ".DB_NAME_PREFIX."admins 
			SET modified_date = CURDATE(), " . $sql . "
			WHERE id = ". $adminId;
		$result = my_mysql_query($sql);
	
	} else {
		connectGlobalDB();
		$sql = "
			UPDATE ".DB_NAME_PREFIX_GLOBAL."superadmins
			SET modified_date = CURDATE(), " . $sql . "
			WHERE id = ". $adminId;
		$result = my_mysql_query($sql);
		connectLocalDB();
	}
}

//Set an admin's session
function setAdminSession($admin_id, $auth_type) {
	$admin_id = (int) $admin_id;
	$allowedActions = array();
	
	//A while ago we added some new columns to the admin tables
	//However we require authentication before we allow database updates, so this function needs to work historically
	//Only include the new columns if they exist!
	$checkNewPasswordColumns = '';
	if (checkNewPasswordColumnsExist()) {
		$checkNewPasswordColumns = ',	password_needs_changing';
	}
	
	//Load information on the admin from the local database for normal admins, or from the
	//global database for super admins
	if ($auth_type=="local") {
		
		//Look up the id of each action that the admin is allowed to do from the links table
		// 	(For backwards compatability purposes this statement should not give an error message if it failes)
		$sql = "
			SELECT action_name
			FROM ". DB_NAME_PREFIX. "action_admin_link
			WHERE admin_id = ". (int) $admin_id;
		
		if ($result = @mysql_query($sql)) {
			while($row = mysql_fetch_assoc($result)) {
				$allowedActions[$row['action_name']] = true;
			}
		}
		
		//Check which actions are for superadmins. Disallow these for local users
		connectGlobalDB();
			
			$sql = "
				SELECT name
				FROM ". DB_NAME_PREFIX_GLOBAL. "actions
				WHERE role_name = '_ROLE_SUPERADMIN'";
			
			if ($result = @mysql_query($sql)) {
				while($row = mysql_fetch_assoc($result)) {
					$allowedActions[$row['name']] = false;
				}
			}
			
		connectLocalDB();
		
		
		//Look up the admin's name, and other details, from the admin table
		$sql = "SELECT id,
						username,
						last_login,
						first_name,
						last_name,
						use_language_id,
						preferred_editor_id,
						perm_sysadmin AS old_perm_sysadmin
						". $checkNewPasswordColumns. "
					FROM " . DB_NAME_PREFIX . "admins
					WHERE id = ". (int) $admin_id;
		$result = my_mysql_query($sql);
	
	
	} elseif ($auth_type=="super") {
		connectGlobalDB();
		
			//Look up the id of each action that the admin is allowed to do from the links table
			// 	(For backwards compatability purposes this statement should not give an error message if it failes)
			$sql = "
				SELECT action_name
				FROM ". DB_NAME_PREFIX_GLOBAL. "action_superadmin_link
				WHERE admin_id = ". (int) $admin_id;
			
			if ($result = @mysql_query($sql)) {
				while($row = mysql_fetch_assoc($result)) {
					$allowedActions[$row['action_name']] = true;
				}
			}
			
			//Look up the admin's name, and other details, from the admin table
			$sql = "SELECT id,
							username,
							last_login,
							first_name,
							last_name,
							use_language_id,
							preferred_editor_id,
						perm_sysadmin AS old_perm_sysadmin
							". $checkNewPasswordColumns. "
						FROM " . DB_NAME_PREFIX_GLOBAL . "superadmins
						WHERE id = " . $admin_id;
			$result = my_mysql_query($sql);
		
		connectLocalDB();
	}
	
	if (mysql_num_rows($result)>0) {
			$row = mysql_fetch_array($result);
			
			//Set the admin's details in their session
			$_SESSION["admin_userid"] = $row["id"];
			$_SESSION["admin_first_name"] = $row["first_name"];
			$_SESSION["admin_last_name"] = $row["last_name"];
			$_SESSION["admin_lang"] = $row["use_language_id"];
			$_SESSION["password_needs_changing"] = $row["password_needs_changing"];
			$_SESSION["admin_username"] = $row["username"];
			$_SESSION["admin_authtype"] = $auth_type;
			$_SESSION["admin_server_host"] = httpHost();
			
			$_SESSION['privs'] = $allowedActions;
			if ($row["old_perm_sysadmin"]) {
				$_SESSION["old_perm_sysadmin"] = true;
			}
			
			//Mark the site that they've logged into
			$_SESSION["admin_logged_into_site"] = SUBDIRECTORY. SITENAME;
			
			return true;
	} else {
		return false;
	}
}

//The reverse of the above...
function unsetAdminSession($destorySession = true) {
	
	$sql = "DELETE FROM ".DB_NAME_PREFIX."admin_session
			WHERE phpsessid = '". mysql_real_escape_string($_COOKIE["PHPSESSID"]) ."'";
	$result = my_mysql_query ($sql);
	
	
	unset($_SESSION["admin_authtype"]);
	unset($_SESSION["admin_first_name"]);
	unset($_SESSION["admin_last_name"]);
	unset($_SESSION["admin_lang"]);
	unset($_SESSION["admin_logged_in"]);
	unset($_SESSION["admin_logged_into_site"]);
	unset($_SESSION["admin_server_host"]);
	unset($_SESSION["admin_userid"]);
	unset($_SESSION["admin_username"]);
	unset($_SESSION["old_perm_sysadmin"]);
	unset($_SESSION["privs"]);

	
	if ($destorySession) {
		if ($_SESSION["admin_logged_into_site"] == SUBDIRECTORY. SITENAME) {
			if (isset(	$_COOKIE[session_name()] ) ) {
				setcookie( session_name(), "", time()-42000, "/" );
			}
		}
		
		session_destroy();
	}
}

function checkAdminHasDrafts ($adminId, $authType) {
	
	$sql = "
		SELECT content_type_id
		FROM ". DB_NAME_PREFIX. "contenttypes";
	$result = my_mysql_query($sql);
	
	while ($cType = mysql_fetch_assoc($result)) {
		$sql = "
			SELECT 1
			FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($cType['content_type_id']). "
			WHERE creating_author_id = " . (int) $adminId . "
			  AND creating_author_authtype = '" . mysql_real_escape_string($authType) . "'
			  AND status = 'private_draft'";
		
		$result2 = my_mysql_query($sql);
		if (mysql_fetch_row($result2)) {
			return true;
		}
	}
	
	return false;
}

function checkContentPrivate ($cID,$cType,$cVersion) {
	$sql = "SELECT private
			FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . "
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;
				
	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		
		return $row[0];
	} else {
		return false;
	}
}





// Content Types

function getContentTypeDetails($contentTypeId) {
	$sql = "
		SELECT *
		FROM ". DB_NAME_PREFIX. "contenttypes
		WHERE content_type_id = '". mysql_real_escape_string($contentTypeId). "'";
	
	$result = my_mysql_query($sql);
	return mysql_fetch_assoc($result);
}

function alreadyExistsContentType($contentTypeId, $curentContentTypeId) {
	$sql = "
		SELECT content_type_id
		FROM " . DB_NAME_PREFIX . "contenttypes
		WHERE content_type_id = '" . mysql_real_escape_string( $contentTypeId ) . "'";
	
	if ($curentContentTypeId) {
		$sql .= "
		  AND content_type_id != '" . mysql_real_escape_string( $curentContentTypeId ) . "'";
	
	}
}

function validateContentTypeDetails($details) {
	
	$errArray = array();
	
	if(isset($details['content_type_id']) && !$details['content_type_id']) {
		$errArray[] = getPhrase('_MSG_ENTER_ALL_FIELDS');
	}
	
	if(isset($details['content_type_name_en']) && !$details['content_type_name_en']) {
		$errArray[] = getPhrase('_MSG_ENTER_ALL_FIELDS');
	}
	
	if(isset($details['tag_prefix']) && !$details['tag_prefix']) {
		$errArray[] = getPhrase('_MSG_ENTER_ALL_FIELDS');
	}
	
	if (isset($details['username']) && alreadyExistsContentType($details['content_type_id'], $details['contentTypeId']) ) {
		$errArray[] = getPhrase('_MSG_CONTENT_TYPE_ID_ALREADY_EXISTS',  array('id' => $details['content_type_id']));
	}
	
	if(isset($details['default_template_id']) && !$details['default_template_id']) {
		$errArray[] = getPhrase('Please select a default Template');
	}
	
	return array('valid' => !count($errArray), 'errArray' => $errArray);
}

function saveContentTypeDetails($submission, $contentTypeId) {

	
	//Build up an insert/update statement using the values we have for the fields
	$sql = "";
	foreach(getFields(DB_NAME_PREFIX, 'contenttypes') as $field => $details) {
		if (isset($submission[$field])) {
			addFieldToSQL($sql, DB_NAME_PREFIX. 'contenttypes', $field, $submission, $contentTypeId, $details);
		}
	}

	if($contentTypeId) {
		$sql .= "
			WHERE content_type_id = '". mysql_real_escape_string($contentTypeId). "'";
	}
	
	$result = my_mysql_query($sql);
}



function saveContentTypeSettings($submission, $contentTypeId, $fields) {
	foreach($fields as $field => $details) {
		if (isset($submission[$field])) {
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "contenttype_settings SET
					`value` = '". mysql_real_escape_string($submission[$field]). "'
				WHERE content_type_id = '". mysql_real_escape_string($contentTypeId). "'
				  AND `name` = '". mysql_real_escape_string($field). "'";
			my_mysql_query($sql);
		}
	}
}



function getFolderOptions( $id ) { 
	$folders = getFoldersWithIdIndex();
	$options = array();
	foreach ( $folders as $folder ) {
		if ( empty( $folder['parent_name'] ) ) {
			$options[$folder['id']] = $folder['name'];
		} else { 
			$parentId = $folder['parent_id'];
			$name = $folder['name'];
			while ( array_key_exists( $parentId, $folders ) ) {
				$name = $folders[$parentId]['name'] . '/' . $name;
				$parentId = $folders[$parentId]['parent_id'];
			}
			$options[$folder['id']] = $name;
		}	
	}
	asort( $options );
	$folderOptions = '';
	foreach ( $options as $key=>$value ) {
		if ( $key == $id ) {
			$folderOptions .= '<option value="' . $key . '" selected>' . $value . '</option>';
		} else {
			$folderOptions .= '<option value="' . $key . '">' . $value . '</option>';
		}
	}
	return $folderOptions;
}







// Templates

function getTemplatesWithIdIndex($cType) {
	$sql = "
		SELECT template_id, 
			family_name,
			name,
			status,
			filename
		FROM " . DB_NAME_PREFIX . "templates";
	
	if ($cType) {
		$sql .= "
		WHERE content_type = '". mysql_real_escape_string($cType). "'";
	}
	
	$sql .= "
		ORDER BY family_name, filename, name";
	
	$result = my_mysql_query($sql);
	$templates = array();
	while ( $row = mysql_fetch_array($result)) {
		$templates[ $row['template_id'] ] = $row;
	}
	return $templates;
}

function getTemplateNameAndStatus($templateId) {
	
	if ($row = getTemplateDetails($templateId)) {
		return $row['family_name']. ' - '. $row['name'];
	} else {
		return false;
	}
}

function checkTemplateFirstForContentType( $templateId ) {
	$templateId = (int) $templateId;
	$sql = "
		SELECT content_type
		FROM " . DB_NAME_PREFIX . "templates as t
			JOIN " . DB_NAME_PREFIX . "contenttypes as ct ON t.content_type = ct.content_type_id
		WHERE t.template_id = " . (int) $templateId;
	$result = my_mysql_query($sql);
	if ($row = mysql_fetch_array($result)) {
		return false;
	} else {
		return true;
	}
}

function setContentTypeDefaultTemplateID ($cType, $templateId) {
	$templateId = (int) $templateId;

	$sql = "UPDATE " . DB_NAME_PREFIX . "contenttypes
			SET default_template_id = " . (int) $templateId . "
			WHERE content_type_id = '" . mysql_real_escape_string($cType) . "'";

	$result = my_mysql_query($sql);
}

function checkTemplateNameUnique ($template_family, $template_name, $templatePrimaryKey=0) {
	$sql = "SELECT 1
			FROM " . DB_NAME_PREFIX . "templates
			WHERE family_name = '" . mysql_real_escape_string($template_family) . "'
			AND name = '" . mysql_real_escape_string($template_name) . "'";

	if ($templatePrimaryKey){
		$sql .=" AND template_id<>" . (int) $templatePrimaryKey;
	}

	$result = my_mysql_query($sql);

	if (mysql_num_rows($result)>0) {
		return false;
	} else {
		return true;
	}
}

function getTemplateUsage ($templateId) {
	$templateId = (int) $templateId;

	$content_types = getAllContentTypes();
	$content_statuses = array("archived","published","private_draft", "reviewable_draft", "hidden");

	foreach ($content_types as $content_type) {
		foreach ($content_statuses as $content_status) {

			if (!$status_results[$content_status]) {
				$status_results[$content_status] = 0;
			}

			$sql = "SELECT count(*)
					FROM " . DB_NAME_PREFIX . "content_" . $content_type . "
					WHERE status = '" . mysql_real_escape_string($content_status) . "'
						AND template_id = " . $templateId;

			$result = my_mysql_query($sql);
			$row = mysql_fetch_array($result);

			$status_results[$content_status] += $row[0];
		}
	}

	return $status_results;
}

function checkTemplateLive ($templateId) {
	$template = getTemplateDetails($templateId);
	
	if ($template) {
		$sql = "SELECT id
				FROM " . DB_NAME_PREFIX . "content_" . $template['content_type'] . "
				WHERE template_id = " . (int) $templateId . "
					AND status IN ('private_draft','published','hidden')";
		$result = my_mysql_query($sql);
		
		if (mysql_num_rows($result)>0) {
			return true;
		} else {
			return false;
		}
	} else {
		return false;
	}
}

function checkTemplateUsed ($templateId) {
	$template = getTemplateDetails($templateId);
	
	if ($template) {
		$sql = "SELECT id
				FROM " . DB_NAME_PREFIX . "content_" . $template['content_type'] . "
				WHERE template_id = " . (int) $templateId;
				
		$result = my_mysql_query($sql);
		
		if (mysql_num_rows($result)>0) {
			return true;
		} else {
			return false;
		}
	} else {
		return false;
	}
}

function getLatestContentUsingTemplate ($templateId) {
	$template = getTemplateDetails($templateId);

	$sql = "SELECT c.id,
				c.version
			FROM " . DB_NAME_PREFIX . "content_" . $template['content_type'] . " AS c
			INNER JOIN (SELECT MAX(id) AS id
						FROM " . DB_NAME_PREFIX . "content_" . $template['content_type'] . "
						WHERE template_id = " . (int) $templateId . ") AS sub
			ON c.id = sub.id
			WHERE c.template_id = " . (int) $templateId;
			
	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		
		return array("cID" => $row['id'], "cType" => $template['content_type'], "cVersion" => getLatestVersion($row['id'], $template['content_type']));
	} else {
		return false;
	}
}

function getContentUsage () {

	$content_types = getAllContentTypes();
	$content_statuses = array("archived","published","private_draft", "reviewable_draft", "hidden");

	foreach ($content_types as $content_type) {
		foreach ($content_statuses as $content_status) {

			if (!$status_results[$content_status]) {
				$status_results[$content_status] = 0;
			}

			$sql = "SELECT count(*)
					FROM " . DB_NAME_PREFIX . "content_" . $content_type . "
					WHERE status = '" . mysql_real_escape_string($content_status) . "'
						";

			$result = my_mysql_query($sql);
			$row = mysql_fetch_array($result);

			$status_results[$content_status] += $row[0];
		}
	}

	return $status_results;
}
function getTemplateOptions($id, $cType = false, $hideNullOption = false) {
	$templates = getTemplatesWithIdIndex($cType);
	$tempTemplate = current( $templates );
	$family = $tempTemplate['family_name'];
	$templateOptions = '<optgroup label="' . $family . '">';
	foreach ( $templates as $key => $value ) {
		if ( $family <> $value['family_name'] ) {
			$family = $value['family_name'];
			$templateOptions .= '</optgroup><optgroup label="' . $family . '">';
		}
		if ( $value['status'] == 'suspended'  ) {
			if ( $key == $id ) {
				$inList = true;
				$templateOptions .= '<option value="' . $key . '" selected disabled>' . htmlspecialchars($value['name']) . '</option>';
			} else {
				$templateOptions .= '<option value="' . $key . '" disabled>' . htmlspecialchars($value['name']) . '</option>';
			}
		} else {
			if ( $key == $id ) {
				$inList = true;
				$templateOptions .= '<option value="' . $key . '" selected>' . htmlspecialchars($value['name']) . '</option>';
			} else {
				$templateOptions .= '<option value="' . $key . '">' . htmlspecialchars($value['name']) . '</option>';
			}
		}
	}
	$templateOptions .= '</optgroup>';
	
	if (!$inList && !$hideNullOption) {
		$templateOptions = '<optgroup label="' . getPhrase('Current value') . '"><option value="">'.  getPhrase('Not set'). '</option></optgroup>'. $templateOptions;
	}
	
	return $templateOptions;
}

function getAllNewTemplates ($templateFamily=false) {
	if (!$templateFamily) {
		$dir = CMS_ROOT . "templates/" . SITENAME . "/";
		$dh  = opendir($dir);
	
		while ($file = readdir($dh)) {
			clearstatcache;
			if (filetype($dir . $file)=="dir" && $file!="." && $file!=".."
				&& substr ($file, 0, 1)<>".") {
				$template_families[] = $file;
			}
		}
		if ( ! $template_families ) {
			return false;
		}
	} else {
		$template_families[] = $templateFamily;
	}
	
	foreach ( $template_families as $template_family ) {
		if ( $offset > 0 ) {
			$offset--;
			continue;
		}
		$dir = CMS_ROOT . "templates/" . SITENAME . "/" . $template_family . "/";
		$handler = opendir($dir);
		while ($file = readdir($handler)) {
			clearstatcache;
			if (filetype($dir . $file)!="dir" && strpos($file,".tpl.php")) {
				if (!checkTemplateInDB($template_family,$file)) {
					$newtemplates[$template_family][] = $file;
				}
			}
		}
		
		closedir($handler);
	}
	if (is_array($newtemplates)) {
		return $newtemplates;
	} else {
		return false;
	}
}

function importTemplateFamily ($templateFamily) {
	$dir = CMS_ROOT . "templates/" . SITENAME . "/" . $templateFamily . "/";
	$handler = opendir($dir);
	
	$sql = "SELECT family_name
			FROM " . DB_NAME_PREFIX . "template_family
			WHERE family_name = '" . $templateFamily . "'";
			
	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)==0) {
		$newTemplateFamily = true;
	}	
	
	while ($file = readdir($handler)) {
		clearstatcache;
		if (filetype($dir . $file)!="dir" && strpos($file,".tpl.php")) {
			if (!checkTemplateInDB($templateFamily,$file)) {
				$sql = "SELECT content_type_id
						FROM " . DB_NAME_PREFIX . "contenttypes
						WHERE tag_prefix = '" . mysql_real_escape_string(strtolower(substr($file,0,4))) . "'";
				
				$result = my_mysql_query($sql);
				
				if (mysql_num_rows($result)>0) {
					$row = mysql_fetch_array($result);
					
					$sql = "REPLACE INTO " . DB_NAME_PREFIX . "templates
							SET family_name = '" . $templateFamily . "',
								filename = '" . $file . "',
								name = '" . $file . "',
								content_type = '" . $row[0] . "'";
							
					$result = my_mysql_query($sql);
					
					$templatesAddCount++;
				}
			}
		}
	}
	
	if ($templatesAddCount && $newTemplateFamily) {
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "template_family
				SET family_name = '" . $templateFamily . "'";
		
		$result = my_mysql_query($sql);
	}
	
	closedir($handler);
}

function importTemplate ($templateFamily,$filename) {
	if (!checkTemplateInDB($templateFamily,$filename)) {
		$sql = "SELECT content_type_id
				FROM " . DB_NAME_PREFIX . "contenttypes
				WHERE tag_prefix = '" . mysql_real_escape_string(strtolower(substr($filename,0,4))) . "'";
		
		$result = my_mysql_query($sql);
		
		if (mysql_num_rows($result)>0) {
			$row = mysql_fetch_array($result);
		
			$sql = "SELECT family_name
					FROM " . DB_NAME_PREFIX . "template_family
					WHERE family_name = '" . $templateFamily . "'";
					
			$result = my_mysql_query($sql);
			
			if (mysql_num_rows($result)==0) {
				$newTemplateFamily = true;
			}
		
			$sql = "REPLACE INTO " . DB_NAME_PREFIX . "templates
					SET family_name = '" . $templateFamily . "',
						filename = '" . $filename . "',
						name = '" . $filename . "',
						content_type = '" . $row[0] . "'";
					
			$result = my_mysql_query($sql);
			
			$templatesAddCount++;
		}
	}
	
	if ($newTemplateFamily) {
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "template_family
				SET family_name = '" . $templateFamily . "'";
		
		$result = my_mysql_query($sql);
	}
}



function getTemplateFamilyDetails($familyName) {
	$sql = "
		SELECT
			family_name,
			skin_id
		FROM ". DB_NAME_PREFIX. "template_family
		WHERE family_name = '". mysql_real_escape_string($familyName). "'";
	$result = my_mysql_query($sql);
	return mysql_fetch_assoc($result);
}

function validateTemplate($details,$primaryKey,$tabName) {
	
	switch ($tabName) {
		case 'Details':
			$errArray = array();
			
			if(isset($details['name']) && !$details['name']) {
				$errArray[] = getPhrase('Please enter a name for the Template');
			}
			
			$details['id'] = $primaryKey;
			if (!checkTemplateNameUnique($details['templateFamily'],$details['name'],$details['id'])){
				$errArray[] = getPhrase('Name for the Template must be unique within a Template Family');
			}
			break;
		case 'Image':
			if (decodeItemIdForStorekeeper(issetArrayKey($_REQUEST,'image')) && 
				defined('DROPBOX_DIR') && defined('SITENAME') && !file_exists(DROPBOX_DIR . '/' . SITENAME . '/' .  decodeItemIdForStorekeeper(arrayKey($_REQUEST,'image')))){
 
				$errArray[] = getPhrase('Image "' . decodeItemIdForStorekeeper(arrayKey($_REQUEST,'image')) . '" no longer exist in the Dropbox. Please select a different image or click the "Remove selection" button.');
					
			}
			break;
	}
	
	
	return array('valid' => !count($errArray), 'errArray' => $errArray);
}

function saveTemplate($submission, &$templateId, $sourceTemplateId,$tabName) {
	switch ($tabName) {
		case 'Details':
			if (($templateId) && (!$sourceTemplateId)) {
				$sqlStart = "UPDATE ";
				$sqlEnd = " WHERE template_id = ". (int) $templateId;
			} else {
				$sqlStart = "INSERT INTO ";
				$sqlEnd = ", content_type = '" . $submission['content_type'] . "',
							filename = '" . $submission['fileName'] . "',
							family_name = '" . $submission['templateFamily'] . "'";
			}
			
			$sql = DB_NAME_PREFIX. "templates 
					SET skin_id = ". (int) $submission['skin_id']. ",
						name = '" . mysql_real_escape_string($submission['name']) . "'";
			
			my_mysql_query($sqlStart . $sql . $sqlEnd);

			$newlyCreatedTemplate = mysql_insert_id();

			if (($templateId) && ($sourceTemplateId) && ($newlyCreatedTemplate)) {
				$sql = "UPDATE 
							" . DB_NAME_PREFIX . "templates s,
							" . DB_NAME_PREFIX . "templates d
						SET 
							d.image_filename=s.image_filename,
							d.mime_type=s.mime_type,
							d.width=s.width,
							d.height=s.height,
							d.size=s.size,
							d.data=s.data,
							d.checksum=s.checksum,
							d.checksum_inc_name=s.checksum_inc_name,
							d.storekeeper_width=s.storekeeper_width,
							d.storekeeper_height=s.storekeeper_height,
							d.storekeeper_size=s.storekeeper_size,
							d.storekeeper_data=s.storekeeper_data
						WHERE 
								s.template_id = " . (int) $sourceTemplateId . "
							AND d.template_id = " . (int) $newlyCreatedTemplate;
				my_mysql_query($sql);
						
				$sql = " INSERT INTO " . DB_NAME_PREFIX . "plugin_inst_temp_link 
						(plugin_id,
						instance_id,
						family_name,
						template_id,
						slot_name
						)
						SELECT 
							plugin_id,
							instance_id,
							family_name,
							" . (int) $newlyCreatedTemplate .  ",
							slot_name
						FROM " 
							. DB_NAME_PREFIX . "plugin_inst_temp_link
						WHERE 
							template_id = " . (int) $sourceTemplateId;
				my_mysql_query($sql);	
			}
		
			if (!getTemplateFamilyDetails($submission['templateFamily'])) {
				$sql = "INSERT INTO " . DB_NAME_PREFIX . "template_family
					SET family_name = '" . $submission['templateFamily'] . "'";
				
				$result = my_mysql_query($sql);
			}
			$templateId= $newlyCreatedTemplate;

			break;
		case 'Image':
			if ($templateId && (!decodeItemIdForStorekeeper(arrayKey($_REQUEST,'image')))){
					$sql ="UPDATE "
								. DB_NAME_PREFIX . "templates 
							SET
								image_filename = NULL,
								mime_type = NULL,
								width = NULL,
								height = NULL,
								size = NULL,
								data = NULL,
								checksum = NULL,
								checksum_inc_name = NULL,
								storekeeper_width = NULL,
								storekeeper_height = NULL,
								storekeeper_size = NULL,
								storekeeper_data = NULL
							WHERE 
								template_id = " . (int) $templateId;
					my_mysql_query($sql);
			} elseif ($templateId && decodeItemIdForStorekeeper(issetArrayKey($_REQUEST,'image')) && defined('CMS_DROPBOX_DIR') && defined('SITENAME') ){
				$imageFileName = CMS_DROPBOX_DIR . '/' . SITENAME . '/' .  decodeItemIdForStorekeeper(arrayKey($_REQUEST,'image'));
				$image = getimagesize($imageFileName);
				$imageData = file_get_contents($imageFileName);

				$image['width'] = $image[0];
				$image['height'] = $image[1];
				$image['mime_type'] = $image['mime'];
				$arr = explode("/",$imageFileName);
				if (count($arr)>0){
					$image['filename'] = $arr[count($arr)-1];
				}
				$maxWidth = 800;
				$maxHeight = 600;


				$skImageData = file_get_contents($imageFileName);
				$image['sk_width'] = $image[0];
				$image['sk_height'] = $image[1];
				$image['sk_mime_type'] = $image['mime'];


				$skMaxImageWidth = 70;
				$skMaxImageHeight = 62;
				
				if (issetArrayKey($image,'mime_type') && issetArrayKey($image,'width') && issetArrayKey($image,'height') 
					&& issetArrayKey($image,'filename') && isset($maxWidth) && isset($maxHeight) && isset($imageData) )  {

					resizeImageString($imageData, $image['mime_type'], $image['width'], $image['height'], $maxWidth, $maxHeight);
					resizeImageString($skImageData, $image['sk_mime_type'], $image['sk_width'], $image['sk_height'], $skMaxImageWidth, $skMaxImageHeight);

					$sql ="UPDATE "
								. DB_NAME_PREFIX . "templates 
							SET
								image_filename = '" . mysql_real_escape_string(arrayKey($image,'filename')) . "' ,
								mime_type = '" . mysql_real_escape_string(arrayKey($image,'mime_type')) . "' ,
								width = " . (int) arrayKey($image,'width') . " ,
								height = " . (int) arrayKey($image,'height') . " ,
								size = " . (int) sizeof($imageData) . " ,
								data = '" . mysql_real_escape_string($imageData) . "' ,
								checksum = '" . md5($imageData) . "' ,
								checksum_inc_name = '" . md5($image['filename']. md5($imageData)) . "' ,
								storekeeper_width = " . (int) mysql_real_escape_string(arrayKey($image,'sk_width')) . " ,
								storekeeper_height = " . (int)  mysql_real_escape_string(arrayKey($image,'sk_height')) . " ,
								storekeeper_size = " . (int) sizeof($skImageData) . " ,
								storekeeper_data = '" . mysql_real_escape_string($skImageData) . "'
							WHERE 
								template_id = " . (int) $templateId;
					my_mysql_query($sql);
					unlink(CMS_DROPBOX_DIR . '/' . SITENAME . '/' .  decodeItemIdForStorekeeper(arrayKey($_REQUEST,'image')));
				}				
			}
			break;
		
	}
}

function saveTemplateFamily($submission, &$familyName) {
	$sql = "
		UPDATE ". DB_NAME_PREFIX. "template_family SET
			skin_id = ". (int) $submission['skin_id']. "
		WHERE family_name = '". mysql_real_escape_string($familyName). "'";
	my_mysql_query($sql);
}






//Get a list of all skins in the filesystem, but not in the database
function getAllNewSkins ($selectedTemplateFamily=false) {
	$templateFamilies = array();
	$templateFamiliesToNewSkins = array();
	
	//Look up all of the Template Families in the filesystem
	$dir = CMS_ROOT . "templates/" . SITENAME . "/";
	$dh  = opendir($dir);
	while ($file = readdir($dh)) {
		clearstatcache;
		if (filetype($dir . $file)=="dir" && $file!="." && $file!=".."
			&& substr ($file, 0, 1)<>".") {
			$templateFamilies[] = $file;
		}
	}
	
	//Make sure they are in alphabetical order
	asort($templateFamilies);
	
	//For each one, check if the skins directory exists, and if there are any skins inside
	foreach ( $templateFamilies as $templateFamily ) {
		if (!$selectedTemplateFamily || $templateFamily==$selectedTemplateFamily) {
			$newSkins = array();
			
			$dir = CMS_ROOT . "templates/" . SITENAME . "/" . $templateFamily . "/skins/";
			if ($handler = @opendir($dir)) {
				while ($file = readdir($handler)) {
					clearstatcache;
					if ($file != '.' && $file != '..' && $file != '.svn' && ((filetype($dir . $file)=="dir") || is_link($dir . $file))) {
						if (!checkSkinInDB($templateFamily, $file)) {
							$newSkins[] = $file;
						}
					}
				}
				closedir($handler);
			}
			
			asort($newSkins);
			$templateFamiliesToNewSkins[$templateFamily] = $newSkins;
		}
	}
	
	if ($templateFamiliesToNewSkins) {
		return $templateFamiliesToNewSkins;
	} else {
		return false;
	}
}

function getAllSkins ($templateFamily=false) {
	$existingSkins = getSkins($templateFamily);
	$newSkins = getAllNewSkins($templateFamily);
	
	if (is_array($existingSkins)) {
		foreach ($existingSkins as $existingSkin) {
			$skins[] = $existingSkin;
		}
	}

	if (is_array($newSkins)) {
		foreach ($newSkins as $newTemplateFamily => $newTemplateFamilySkins) {
			if (is_array($newTemplateFamilySkins)) {
				foreach ($newTemplateFamilySkins as $newTemplateFamilySkin) {
					$skins[] = array(
										"family_name" => $newTemplateFamily,
										"name" => $newTemplateFamilySkin
									);
				}
			}
		}
	}
	
	if ($skins) {
		return $skins;
	} else {
		return false;
	}
}

function getAllMissingTemplates( $offset = -1, $quantity = 0, $familyName = false ) {
	$sql = "SELECT t.template_id,
				t.family_name,
				t.filename,
				t.name,
				t.content_type,
				c.tag_prefix,
				t.status
			FROM " . DB_NAME_PREFIX . "templates as t
			LEFT JOIN " . DB_NAME_PREFIX . "contenttypes as c
				ON t.content_type = c.content_type_id
			WHERE c.content_type_id IS NOT NULL";
			
	if ($familyName) {
		$sql .= " AND t.family_name = '" . mysql_real_escape_string($familyName) . "'";
	}
	
	if ( $offset >= 0 ) {
		$sql .= "
			LIMIT " . $offset;
		if ( $quantity ) {
			$sql .= ', ' . $quantity;
		}
	}
	$result = my_mysql_query($sql);
	if (mysql_num_rows($result)==0) {
		return false;
	} else {
		$missingtemplates = array();
		while ( $row = mysql_fetch_array( $result ) ) {
			if (!checkTemplateInFS($row['family_name'], $row['filename']) && strpos($row['filename'],".tpl.php")) {
				$missingtemplates[] = $row;
			}
		}
		return $missingtemplates;
	}
}

function getAllExistingTemplates( $content_type = 0, $usage_flag = 0, $offset = -1, $quantity = 0, $orderByName = true, $familyName = false ) {
	$sql = "SELECT template_id,
				family_name,
				filename,
				name,
				content_type,
				tag_prefix,
				editor_width_bodymain,
				t.status,
				allow_rss,
				t.skin_id
			FROM " . DB_NAME_PREFIX . "templates AS t
			LEFT JOIN " . DB_NAME_PREFIX . "contenttypes as c
				ON t.content_type = c.content_type_id
			WHERE c.content_type_id IS NOT NULL";
	if ($content_type) {
		$sql .= " AND t.content_type = '" . mysql_real_escape_string($content_type) . "'";
	}
	if ($usage_flag) {
		$sql .= " AND usage_flag = '" . mysql_real_escape_string($usage_flag) . "'";
	}

	if ($familyName) {
		$sql .= " AND t.family_name = '" . mysql_real_escape_string($familyName) . "'";
	}
	
	if ($orderByName) {
		$sql .= " ORDER BY family_name, name";
	}
	
	if ( $offset >= 0 ) {
		$sql .= "
			LIMIT " . $offset;
		if ( $quantity ) {
			$sql .= ', ' . $quantity;
		}
	}
	$result = my_mysql_query($sql);
	if ( mysql_num_rows( $result ) == 0 ) {
		return false;
	} else {
		$existingtemplates = array();
		while ($row = mysql_fetch_array($result)) {
			if (checkTemplateInFS($row['family_name'],$row['filename']) && strpos($row['filename'],".tpl.php")) {
				$existingtemplates[] = $row;
			}
		}
		return $existingtemplates;
	}
}

function getAllTemplates( $content_type = 0, $usage_flag = 0, $offset = -1, $quantity = 0 ) {
	$sql = "SELECT template_id,
				family_name,
				filename,
				name,
				content_type,
				tag_prefix,
				editor_width_bodymain,
				t.status
			FROM " . DB_NAME_PREFIX . "templates AS t
			LEFT JOIN " . DB_NAME_PREFIX . "contenttypes as c
				ON t.content_type = c.content_type_id
			WHERE c.content_type_id IS NOT NULL";
	if ($content_type) {
		$sql .= " AND t.content_type = '" . mysql_real_escape_string($content_type) . "'";
	}
	if ($usage_flag) {
		$sql .= " AND usage_flag = '" . mysql_real_escape_string($usage_flag) . "'";
	}
	$sql .= " ORDER BY family_name, filename";
	if ( $offset >= 0 ) {
		$sql .= "
			LIMIT " . $offset;
		if ( $quantity ) {
			$sql .= ', ' . $quantity;
		}
	}
	$result = my_mysql_query($sql);
	if ( mysql_num_rows( $result ) == 0 ) {
		return false;
	} else {
		$templates = array();
		while ($row = mysql_fetch_array($result)) {
			$templates[] = $row;
		}
		return $templates;
	}
}

function checkTemplateFamilyInDB ($template_family) {
	$sql = "SELECT family_name
			FROM " . DB_NAME_PREFIX . "template_family
			WHERE family_name = '" . mysql_real_escape_string($template_family) . "'";

	$result = my_mysql_query($sql);

	if (mysql_num_rows($result)>0) {
		return true;
	} else {
		return false;
	}
}

function checkTemplateInDB ($template_family, $template_filename) {
	$sql = "SELECT template_id
			FROM " . DB_NAME_PREFIX . "templates
			WHERE family_name = '" . mysql_real_escape_string($template_family) . "'
				AND filename = '" . mysql_real_escape_string($template_filename) . "'";

	$result = my_mysql_query($sql);

	if (mysql_num_rows($result)>0) {
		return true;
	} else {
		return false;
	}
}

function checkSkinInDB ($template_family, $skin_name) {
	$sql = "SELECT id
			FROM " . DB_NAME_PREFIX . "skins
			WHERE family_name = '" . mysql_real_escape_string($template_family) . "'
				AND name = '" . mysql_real_escape_string($skin_name) . "'";

	$result = my_mysql_query($sql);

	if (mysql_num_rows($result)>0) {
		return true;
	} else {
		return false;
	}
}

function checkSkinInFS ($template_family, $skinName) {
	$path = CMS_ROOT . "templates/" . SITENAME . "/" . $template_family . "/skins/" . $skinName . "/stylesheet.css";
	return file_exists($path);
}

function checkTemplateInFS ($template_family, $template_filename) {
	$path = CMS_ROOT . "templates/" . SITENAME . "/" . $template_family . "/" . $template_filename;
	return file_exists($path);
}

function updateTemplateStatus( $templateId, $status ) {
	$templateId = (int) $templateId;
	$sql = "
		UPDATE " . DB_NAME_PREFIX . "templates
		SET status = '" . mysql_real_escape_string($status) . "'
		WHERE template_id = " . $templateId . "
		LIMIT 1";
	my_mysql_query($sql);
	return mysql_affected_rows();
}
function updateTemplate ($templateId, $template_name, $template_content_type, $template_head, $template_bodytop, $template_bodymain, $template_bodyfoot, $template_usage_type, $template_editor_width_bodymain, $template_editor_custom_bodytag, $allow_rss, $skin_id = null) {

	$templateId = (int) $templateId;
	$skin_id = $skin_id? (int) $skin_id : 'NULL';

	$sql = "UPDATE " . DB_NAME_PREFIX . "templates
			SET name = '" . mysql_real_escape_string($template_name) . "',
				content_type = '" . mysql_real_escape_string($template_content_type) . "',
				enable_content_head = '" . mysql_real_escape_string($template_head) . "',
				enable_content_bodytop = '" . mysql_real_escape_string($template_bodytop) . "',
				enable_content_bodymain = '" . mysql_real_escape_string($template_bodymain) . "',
				enable_content_bodyfoot = '" . mysql_real_escape_string($template_bodyfoot) . "',
				custom_bodytag = '" . mysql_real_escape_string($template_editor_custom_bodytag) ."',
				usage_flag = '" . mysql_real_escape_string($template_usage_type) . "',
				editor_width_bodymain = '" . mysql_real_escape_string($template_editor_width_bodymain) . "',
				allow_rss = '" . (int) $allow_rss . "',
				skin_id = ". $skin_id. "
			WHERE template_id = " . $templateId . "
			LIMIT 1";
	$result = my_mysql_query($sql);
}

function insertTemplate ($template_family, $template_filename, $template_name, $template_content_type, $template_head, $template_bodytop, $template_bodymain, $template_bodyfoot, $template_usage_type, $template_editor_width_bodymain, $template_editor_custom_bodytag, $allow_rss) {
	$sql = "REPLACE INTO " . DB_NAME_PREFIX . "templates
			SET family_name = '" . mysql_real_escape_string($template_family) . "',
				filename = '" . mysql_real_escape_string($template_filename) . "',
				name = '" . mysql_real_escape_string($template_name) . "',
				content_type = '" . mysql_real_escape_string($template_content_type) . "',
				enable_content_head = '" . (int) $template_head . "',
				enable_content_bodytop = '" . (int) $template_bodytop . "',
				enable_content_bodymain = '" . (int) $template_bodymain . "',
				enable_content_bodyfoot = '" . (int) $template_bodyfoot . "',
				custom_bodytag = '" . mysql_real_escape_string($template_editor_custom_bodytag) ."',
				usage_flag = '" . mysql_real_escape_string($template_usage_type) . "',
				editor_width_bodymain = '" . (int) $template_editor_width_bodymain . "',
				allow_rss = '" . (int) $allow_rss . "'";

	my_mysql_query($sql);

	$new_template_id = mysql_insert_id();

	//Check if there is an entry in the Template Family table
	$sql = "
		SELECT COUNT(*)
		FROM ". DB_NAME_PREFIX. "template_family
		WHERE family_name = '" . mysql_real_escape_string($template_family) . "'";
	$result = my_mysql_query($sql);
	list($count) = mysql_fetch_row($result);
	
	//If there isn't, create one
	if ($count == 0) {
		$sql = "
			INSERT INTO ". DB_NAME_PREFIX. "template_family
			SET family_name = '" . mysql_real_escape_string($template_family) . "'";
		my_mysql_query($sql);
	}
	

	if ($new_template_id) {
		if (checkTemplateFirstForContentType($new_template_id)) {
			setContentTypeDefaultTemplateID ($template_content_type, $new_template_id);
		}
	}

	return $new_template_id;
}

function insertSkin($template_family, $skin_name, &$desc) {
	//Ensure that the requested skin exists before trying to update or add it
	if (is_dir(CMS_ROOT. 'templates/'. SITENAME. '/'. $template_family. '/skins/'. $skin_name)) {
		
		if (!$desc) {
			validateSkinFromXMLDescriptionByName($template_family, $skin_name, $desc);
		}
		
		$relatedThemes = '';
		if ($desc->related_plugin_themes && $desc->related_plugin_themes->name) {
			foreach ($desc->related_plugin_themes->name as $theme){
				$relatedThemes .= ($relatedThemes? ',' : ''). (string) $theme;
			}
		}
		
		setRow('skins', array('active' => 1, 'related_plugin_themes' => $relatedThemes), array('family_name' => $template_family, 'name' => $skin_name));
	}
}

function deleteTemplate($templateId, $template_family = false) {
	$templateId = (int) $templateId;

	$sql = "SELECT family_name
			FROM ". DB_NAME_PREFIX . "templates
			WHERE template_id = " . (int) $templateId;
			
	$result = my_mysql_query($sql);
	
	if (mysql_num_rowS($result)>0) {
		$row = mysql_fetch_array($result);
		
		$template_family = $row[0];
	}

	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "templates
			WHERE template_id = " . (int) $templateId;

	$result = my_mysql_query($sql);
	$deletes = mysql_affected_rows();

	$sql = "DELETE 
				FROM " .  DB_NAME_PREFIX . "plugin_inst_temp_link
				WHERE template_id = " . (int) $templateId;

	$result = my_mysql_query($sql);
	
	if ($deletes) {

		sendSignal('eventTemplateDeleted',array('templateId'=>$templateId));
		
		//Check to see if there are now no more instances of that Template Family
		if ($template_family !== false) {
			$sql = "SELECT COUNT(*)
					FROM " . DB_NAME_PREFIX . "templates
					WHERE family_name = '". mysql_real_escape_string($template_family). "'";
		
			$result = my_mysql_query($sql);
			list($count) = mysql_fetch_row($result);
			
			//If not, then remove the template_family entry
			if ($count == 0) {
				deleteTemplateFamily($template_family);
			}
		}
	}
	
	return $deletes;	
}

function deleteSkin($template_family, $skin_name){
	$sql  = "DELETE FROM 
				" . DB_NAME_PREFIX . "skins
			WHERE 
					family_name = '" . mysql_real_escape_string($template_family) . "'
				AND	name = '" . mysql_real_escape_string($skin_name) . "'";

	my_mysql_query($sql);
			
}

function deleteTemplateFamily ($templateFamily) {
	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "template_family
			WHERE family_name = '" . mysql_real_escape_string($templateFamily) . "'";
			
	$result = my_mysql_query($sql);
	
	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "templates
			WHERE family_name = '" . mysql_real_escape_string($templateFamily) . "'";
			
	$result = my_mysql_query($sql);	

	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "plugin_inst_temp_fam_link
			WHERE family_name = '" . mysql_real_escape_string($templateFamily) . "'";
			
	$result = my_mysql_query($sql);	
	
	sendSignal('eventTemplateFamilyDeleted',array('templateFamily'=>$templateFamily));
}

function updateTemplateFamily($family_name, $skin_id) {

	$skin_id = $skin_id? (int) $skin_id : 'NULL';

	$sql = "UPDATE " . DB_NAME_PREFIX . "template_family
			SET skin_id = ". $skin_id. "
			WHERE family_name = '". mysql_real_escape_string($family_name). "'
			LIMIT 1";
	$result = my_mysql_query($sql);
}

function updateItemTemplate ($cID, $cType, $cVersion, $templateId, $skinId = false) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	$templateId = (int) $templateId;

	$sql = "
		UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . "
		SET template_id = " . (int) $templateId;
	
	if ($skinId !== false) {
		$sql .= ",
			skin_id = ". (int) $skinId;
	}
	
	$sql .= "
		WHERE id = " . (int) $cID . "
		  AND version = " . (int) $cVersion;

	$result = my_mysql_query($sql);
}


//Display the Skin Picker select list for a Template or Template Family.
//Optionally have the option to display it in read-only mode (i.e. only the name of the picked
//value is shown).
function getSkinOptions($templateFamilyName, $pickedSkin, $readOnly = false, $tableName = false) {
	
	if ($tableName == 'template_family') {
		$notSetPhrase = getPhrase('Always use Template-specific or Item-specific Skin (not recommended)');
	} elseif ($tableName == 'templates') {
		$notSetPhrase = getPhrase('Use the Default Skin for this Family');
	} else {
		$notSetPhrase = getPhrase('Use the Default Skin for this Template');
	}
	
	//If no skin is picked, and we're only displaying the value of the picked
	//skin, we can return "Not Set" straight away
	if ($readOnly && !$pickedSkin) {
		return $notSetPhrase;
	}
	
	//Otherwise, build up a SQL statement
	$sql = "
		SELECT name, id
		FROM ". DB_NAME_PREFIX. "skins
		WHERE family_name = '". mysql_real_escape_string($templateFamilyName). "'";
	
	//If we're only displaying the value, only look at the picked skin
	if ($readOnly) {
		$sql .= "
			AND id = ". (int) $pickedSkin;
	
	//Otherwise, show only active skins. But make sure we show the selected skin as well;
	//it would be impolite to wipe over the user's choice of skin without warning
	} elseif ($pickedSkin) {
		$sql .= "
		  AND (active = 1 OR id = ". (int) $pickedSkin. ")";
		  
	} else {
		$sql .= "
		  AND active = 1";
	}
		
	if (!$readOnly) {
		$sql .= "
			ORDER BY name";
	}
	
	$result = my_mysql_query($sql);
	
	//If we're just after the chosen value, return it without looping
	if ($readOnly) {
		$row = mysql_fetch_assoc($result);
		return $row['name'];
	}
	
	//Otherwise loop through the results, drawing the insides of a select list
	$output = '
		<option'. (!$pickedSkin? ' selected="selected"' :null). ' value="">'. $notSetPhrase. '</option>';
	
	while ($row = mysql_fetch_assoc($result)) {
		$output .= '
			<option'. ($row['id'] == $pickedSkin? ' selected="selected"' :null). ' value="'. $row['id']. '">
				'. htmlspecialchars($row['name']). '
			</option>';
	}
	
	return $output;
}




//Functions for languages



function validateAddLanguage($details, $tab) {
	$errors = array();

	if ($tab == 1) {
		//Check to see if this language has already been created
		if (checkRowExists('languages', array('id' => $details['lang']))) {
			
			//If it has, that's a pretty big error. Stop processing errors and display that error message
			$errors[] = getPhrase('_LANGUAGE_ALREADY_EXISTS');
			
		} else {
			if ($details['create_search_page'] && $details['home_page_alias']
			 && $details['home_page_alias'] == $details['search_page_alias']) {
				$errors[] = getPhrase('_ERROR_ALIASES_MUST_BE_UNIQUE', array('alias' => htmlspecialchars($details['home_page_alias'])));
			}
			
			if (!$details['home_page_alias']) {
				$errors[] = getPhrase('Please enter an Alias for the Home page');
			} elseif ($mistakesInAlias = validateAlias($details['home_page_alias'])) {
				$errors = array_merge($errors, $mistakesInAlias);
			}
			
			if ($details['create_search_page']) {
				if (!$details['search_page_alias']) {
					$errors[] = getPhrase('Please enter an Alias for the Search page');
				} elseif ($mistakesInAlias = validateAlias($details['search_page_alias'])) {
					$errors = array_merge($errors, $mistakesInAlias);
				}
			}
		}
	} elseif ($tab == 2) {
		
		$aliases = array('hp_alias');
		$dupedAliases = array();
		
		if ($details['sp_alias']) {
			$aliases[] = 'sp_alias';
		}
		
		foreach (array(
					'extranet_login_page',
					'extranet_registration_page',
					'extranet_password_reminder_page',
					'extranet_change_password_page',
					'extranet_logout_page'
		) as $field) {
			if ($details['create_'. $field]) {
				$aliases[] = $field. '_alias';
			}
		}
		
		foreach ($aliases as $i) {
			foreach ($aliases as $j) {
				if ($i != $j && $details[$i] && $details[$j] && $details[$i] == $details[$j] && !issetArrayKey($dupedAliases, $details[$i])) {
					$errors[] = getPhrase('_ERROR_ALIASES_MUST_BE_UNIQUE', array('alias' => htmlspecialchars($details[$i])));
					$dupedAliases[$details[$i]] = true;
				}
			}
		}
		
		if ($details['create_extranet_login_page']) {
			if (!$details['extranet_login_page_alias']) {
				$errors[] = getPhrase('Please enter an Alias for the Login page');
			} elseif ($mistakesInAlias = validateAlias($details['extranet_login_page_alias'])) {
				$errors = array_merge($errors, $mistakesInAlias);
			}
		}
		
		if ($details['create_extranet_registration_page']) {
			if (!$details['extranet_registration_page_alias']) {
				$errors[] = getPhrase('Please enter an Alias for the Registration page');
			} elseif ($mistakesInAlias = validateAlias($details['extranet_registration_page_alias'])) {
				$errors = array_merge($errors, $mistakesInAlias);
			}
		}
		
		if ($details['create_extranet_password_reminder_page']) {
			if (!$details['extranet_password_reminder_page_alias']) {
				$errors[] = getPhrase('Please enter an Alias for the Password Reminder page');
			} elseif ($mistakesInAlias = validateAlias($details['extranet_password_reminder_page_alias'])) {
				$errors = array_merge($errors, $mistakesInAlias);
			}
		}
		
		if ($details['create_extranet_change_password_page']) {
			if (!$details['extranet_change_password_page_alias']) {
				$errors[] = getPhrase('Please enter an Alias for the Change Password page');
			} elseif ($mistakesInAlias = validateAlias($details['extranet_change_password_page_alias'])) {
				$errors = array_merge($errors, $mistakesInAlias);
			}
		}
		
		if ($details['create_extranet_logout_page']) {
			if (!$details['extranet_logout_page_alias']) {
				$errors[] = getPhrase('Please enter an Alias for the Logout page');
			} elseif ($mistakesInAlias = validateAlias($details['extranet_logout_page_alias'])) {
				$errors = array_merge($errors, $mistakesInAlias);
			}
		}
	}

	return array('valid' => empty($errors), 'errArray' => $errors);

}

function saveAddLanguage($details, $tab) {
	return require 'cmsincludes/admin/saveAddLanguage.fun.php';
}


function validateLanguage($details) {
	
	$htmlError = false;
	$langError = false;
	$errArray = array();
	
	$fields = array('homepage_id', 'search_page_id', 'extranet_login_page_id', 'extranet_registration_page_id', 'extranet_password_reminder_page_id', 'extranet_change_password_page_id', 'extranet_logout_page_id', );
	
	
	if(!$details['homepage_id']) {
		$errArray[] = getPhrase('Please choose a Homepage for this Language.');
	}
	
	if(!$details['language_local_name']) {
		$errArray[] = getPhrase('_ERROR_LANGUAGE_LOCAL_NAME');
	}
	
	//Do some validation on aliases, that is needed for every mode
	foreach ($fields as $field) {
		if ($details[$field]) {
			if (getContentLang($details[$field], 'html') != $details['lang']) {
				$langError = true;
			}
		}
	}
	
	if ($langError) {
		$errArray[] = getPhrase('Please select only &quot;[[lang]]&quot; Content Items.', array('lang' => htmlspecialchars(getLanguageName($details['lang']))));
	}
	
			
	$dupedItems = array();
	foreach ($fields as $i) {
		foreach ($fields as $j) {
			if ($i != $j && $details[$i] && $details[$j] && $details[$i] == $details[$j] && !issetArrayKey($dupedItems, $details[$i])) {
				$errArray[] = getPhrase('Each page must be a different Content Item. You have selected &quot;[[citem]]&quot; more than once.',
									array('citem' => htmlspecialchars(getTag($details[$i], 'html'))));
				$dupedItems[$details[$i]] = true;
			}
		}
	}
	
	
	return array('valid' => empty($errArray), 'errArray' => $errArray);
}


function saveLanguage($submission, $lang) {
	
	if (($valid = validateLanguage($submission)) && ($valid['valid'])) {
		//Build up an insert/update statement using the values we have for the fields
		$sql = "";
		foreach(getFields(DB_NAME_PREFIX, 'languages') as $field => $details) {
			if (isset($submission[$field])) {
				addFieldToSQL($sql, DB_NAME_PREFIX. 'languages', $field, $submission, true, $details);
			}
		}
	
		$sql .= "
			WHERE id = '". mysql_real_escape_string($lang). "'";
		
		$result = my_mysql_query($sql);
	}
}



//Check a VLP to see if the three bare-minimum required phrases are there
//If they are, then the VLP can be added as a language
function checkIfLanguageCanBeAdded($languageId) {
	$sql = "
		SELECT COUNT(*)
		FROM ". DB_NAME_PREFIX. "visitor_phrases
		WHERE language_id = '". mysql_real_escape_string($languageId). "'
		  AND code IN ('__LANGUAGE_LOCAL_NAME__', '__LANGUAGE_FLAG_FILENAME__')
		  AND plugin_class = ''";

	$result = my_mysql_query($sql);
	list($count) = mysql_fetch_row($result);
	return $count == 2;
}

//check that the user isn't trying to delete one of the important phrases
function visitorPhraseShouldNotBeDeleted($phrase) {
	$importantPhrases = array('__LANGUAGE_LOCAL_NAME__' => 1, '__LANGUAGE_FLAG_FILENAME__' => 1);
	return (bool) $importantPhrases[$phrase];
}

function checkLanguageExists ($language_id) {
	$sql = "SELECT id
			FROM " . DB_NAME_PREFIX . "languages
			WHERE id = '" . mysql_real_escape_string($language_id) . "'";
	
	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)>0) {
		return true;
	} else {
		return false;
	}		
}

function getLanguageUsage ($languageID) {
	$content_types = getAllContentTypes();
	$content_statuses = array("archived","published","private_draft", "reviewable_draft", "hidden");
	foreach ($content_types as $content_type) {
		foreach ($content_statuses as $content_status) {
			if (!$status_results[$content_status]) {
				$status_results[$content_status] = 0;
			}
			$sql = "SELECT count(*)
					FROM " . DB_NAME_PREFIX . "content_" . $content_type . "
					WHERE status = '" . mysql_real_escape_string($content_status) . "'
						AND language_id = '" . mysql_real_escape_string($languageID) . "'";
			$result = my_mysql_query($sql);
			$row = mysql_fetch_array($result);
			$status_results[$content_status] += $row[0];
		}
	}
	return $status_results;
}

function hasDraftContent ($admin_id, $adminType = '') {
	$admin_id = (int) $admin_id;

	connectLocalDB ();

	$contenttypes = getAllContentTypes();

	$found_draft = false;

	foreach($contenttypes as $contenttype) {
		$sql = "SELECT id
				FROM " . DB_NAME_PREFIX . "content_" . $contenttype . "
				WHERE creating_author_id = " . $admin_id . "
				  AND creating_author_authtype = '". ($adminType == 'super'? 'super' : 'local'). "'
				  AND status = 'private_draft'";
		$result = my_mysql_query($sql);

		if (mysql_num_rows($result)>0) {
			$found_draft = true;
		}
	}

	return $found_draft;

}

function aliasURLIsValid($url) {
	return preg_match("/^[0-9A-Za-z\.\-]*\.[0-9A-Za-z\.\-\/]*$/",$url);
}

//Function gets a list of all drafts being worked upon by an author
//Returns both a text string in the for of <option>
//Pass it the value of the current administrator, and the ID of the page
//they're currently on, and then it will show this one "selected" in the pull-down

//As a new addition, this function will now get drafts for other all other admins, shown
//underneath the current admin's drafts
function getAllDrafts_Option($adminUserID, $cID, $cType, $adminAuthType) {
	
	
	$adminUserID = (int) $adminUserID;
	$cID = (int) $cID;
	
	if ($adminUserID > 0) {
	
		$sql = "";
		foreach(getAllContentTypes() as $type) {
			
			$sql .= ($sql == ""? "" : " UNION ") . "
					SELECT
						id,
						title,
						version,
						creating_author_id,
						creating_author_authtype,
						created_datetime,
						'". $type ."' AS `type`
					FROM ".DB_NAME_PREFIX."content_" . $type . "
					WHERE status IN ('private_draft','reviewable_draft')
				";
		}
		$sql .= "ORDER BY creating_author_id != " . (int) $adminUserID . ",
					creating_author_authtype != '" . mysql_real_escape_string($adminAuthType) . "',
					creating_author_id,
					`type`,
					title";

		$txt = '';
		$authorDetails = array('admin_id' => -1);
		

		$result = my_mysql_query ($sql);
		while ($row = mysql_fetch_array ($result)) {

			//Check if this auther is different from the last author
			if ($authorDetails['admin_id'] != $row['creating_author_id'] || $authorDetails['admin_type'] != $row['creating_author_authtype']) {
				
				if ($authorDetails = getAdminDetails($row['creating_author_id'], $row['creating_author_authtype'])) {
					$authorDetails['admin_display'] = htmlspecialchars(
						' -- '. $authorDetails['admin_username'].
						' ('. $authorDetails['admin_first_name'].
						' '. $authorDetails['admin_last_name'].
						'; '. $row['creating_author_authtype'].
						'): ');
				} else {
					$authorDetails = array();
					$authorDetails['admin_display'] =
						' -- ('. getPhrase('_ADMIN_NOT_FOUND'). 
						'; '. $row['creating_author_authtype'].
						'): ';
				}
				
				$authorDetails['admin_id'] = $row['creating_author_id'];
				$authorDetails['admin_type'] = $row['creating_author_authtype'];
				
				//Check if this is the current author
				if ($authorDetails['admin_id'] == $adminUserID && $authorDetails['admin_type'] == $adminAuthType) {
					$txt .= '<option value="" disabled="disabled"> -- ' . getPhrase('_MY_DRAFTS') . ': </option>' . "\n";
				} else {
					$txt .= '<option value="" disabled="disabled">'. $authorDetails['admin_display']. '</option>' . "\n";
				}
			}
			
			
			
			$txt .= '<option value="' . SUBDIRECTORY . indexDotPHP(). '?cID=' . $row['id'] . '&amp;cType=' . $row['type'] . '&amp;version=' . $row['version'] . '"';
			
			if (($row['id']==$cID) && ($thisType==$cType)) {
				$txt .= ' selected';
			}
			
			$txt .= '>' . getTag($row['id'], $row['type'], $row['version'], $siteConfig['content_tag_zerofill']) . "</option>\n";
		
		}
		
		return $txt;
	} else {
		return false;
	}
}


//Functions for Menus

function getMenuItemStorekeeperDeepLink($menuId) {
	$menuDetails = getMenuItemFromMenuID($menuId);
	
	//Build up a link to the current parent in Storekeeper
	$path = 'tribiq__menu/item//'. $menuDetails['language_id']. '//item//'. $menuDetails['section_id'];
	
	$ancestors = array($menuId);
	if ($ancestorId = $menuDetails['parent_id']) {
		do {
			$ancestors[] = $ancestorId;
		} while ($ancestorId = getMenuParent($ancestorId));
	}
	
	for ($i = count($ancestors) - 1; $i >= 0; --$i) {
		$path .= '//'. ($i? 'item//' : ''). $ancestors[$i];
	}
	
	return $path;
}

function saveMenuDetails($submission, &$menuId) {
	
	if (isset($submission['section_id'])) {
		if (!checkRowExists('menu_sections', array('section_name' => $submission['section_id']))) {
			echo 'The section "', $submission['section_id'], '" does not exist!';
			exit;
		}
	}
	
	//If we are linking to a content item, follow some special logic
	if (isset($submission['content_id'])) {
		if ($submission['target_loc'] == 'int' && $submission['content_id'] && $submission['content_type']) {
			//If we are saving the cID, make sure we get the correct alias to save as well
			$submission['html_content_alias'] = $submission['content_type'] == 'html'? getContentAlias($submission['content_id']) :null;
			//Mark the menu item active if the content item being linked to is published
			$submission['active'] = (bool) getPublishedVersion($submission['content_id'], $submission['content_type']);
		
		} else {
			//If we're not linking to content, make sure that the active flag is always set
			$submission['active'] = 1;
			$submission['hide_private_item'] = 0;
			$submission['content_id'] = 0;
			$submission['content_type'] = '';
			$submission['html_content_alias'] = '';
		}
	}
	
	//For new menu items, or menu items that are being moved, work out a new ordinal for them
	if(!$menuId || (isset($submission['parentMenuID']) && isset($submission['parent_id']) && $submission['parentMenuID'] != $submission['parent_id'])) {
		$sql = "
			SELECT max(ordinal)
			FROM ". DB_NAME_PREFIX. "menuitems 
			WHERE parent_id = ". (int) $submission['parent_id'];
			
		$result = my_mysql_query ($sql);
		list($ordinal) = mysql_fetch_row($result);
		
		$submission['ordinal'] = $ordinal? ++$ordinal : 1;
	}
	
	//Build up an insert/update statement using the values we have for the fields
	$sql = "";
	foreach(getFields(DB_NAME_PREFIX, 'menuitems') as $field => $details) {
		if (isset($submission[$field])) {
			addFieldToSQL($sql, DB_NAME_PREFIX. 'menuitems', $field, $submission, $menuId, $details);
		}
	}
	

	if($menuId) {
		$sql .= "
			WHERE id = '". mysql_real_escape_string($menuId). "'";	
	}
	
	
	$result = my_mysql_query($sql);
	
	//Get the new menu id for new menus
	if(!$menuId) {
		$menuId = mysql_insert_id();
	}
	
	//Allow the user to change the primary menu item for a content item
	if ($submission['primary']) {
		if ($submission['primary'] === 'this') {
			$submission['primary'] = $menuId;
		}
		
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "menuitems SET
				redundancy = 'secondary'
			WHERE content_id = ". (int) $submission['content_id']. "
			  AND content_type = '". mysql_real_escape_string($submission['content_type']). "'
			  AND id != ". (int) $submission['primary'];
		my_mysql_query($sql);
		
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "menuitems SET
				redundancy = 'primary'
			WHERE content_id = ". (int) $submission['content_id']. "
			  AND content_type = '". mysql_real_escape_string($submission['content_type']). "'
			  AND id = ". (int) $submission['primary'];
		my_mysql_query($sql);
	}
}

function validateMenuDetails($details, $menuId = false) {
	
	$errArray = array();
	
	if (isset($details['name']) && !$details['name']) {
		$errArray[] = getPhrase('_ERROR_MUST_ENTER_TITLE_FOR_MENU_ITEM');
	}
	
	if (issetArrayKey($details, 'mID')) {
		
		if (issetArrayKey($details, 'parent_id')) {
			$parentDetails = getMenuItemFromMenuID($details['parent_id']);
			
			if ($details['section_id'] != $parentDetails['section_id']) {
				$errArray[] = getPhrase('Please choose a Parent from the same Menu Section as the Menu Item you wish to move.');
			}
		}
		
		if ($details['mID'] == arrayKey($details, 'parent_id')) {
			$errArray[] = getPhrase('A Menu Item cannot be its own Parent. Please choose a different Menu Item to be the Parent.');
		} elseif (isMenuItemAncestor(arrayKey($details, 'parent_id'), $details['mID'])) {
			$errArray[] = getPhrase('A Menu Item cannot be both the Child and the Parent of another Menu Item. Please choose a different Menu Item to be the Parent.');
		}
	}
	
	if (isset($details['accesskey']) && $details['accesskey'] !== '') {
		
		$ord = ord($details['accesskey']);
		if ($ord < 48 || ($ord > 57 && $ord < 65) || $ord > 90) {
			$errArray[] = getPhrase('Access Keys may only be the capital letters A-Z, or the digits 0-9.');
		} else {
		
			$sql = "
				SELECT name
				FROM ". DB_NAME_PREFIX ."menuitems 
				WHERE accesskey = '" . mysql_real_escape_string($details['accesskey']) . "'";
			
			if ($menuId) {
				$sql .= "
				  AND id != ". (int) $menuId;
			}
			
			$result = my_mysql_query($sql);
			
			if ($row = mysql_fetch_assoc($result)) {
				$errArray[] = getPhrase('_WARN_ACCESSKEY_ALREADY_USED',
									array('accesskey' => strtoupper($_GET['accesskey']), 'menuitem' => $row['name']));
			}
		}
	}
	
	return array('valid' => !count($errArray), 'errArray' => $errArray);
}




function createMenuitem ($name, $language_id, $parent_id, $section_id="", $parent_microsite_id=0) {
	$parent_id = (int) $parent_id;
	
	if (file_exists(CMS_ROOT . "cmsincludes/modules/microsites-cms.inc.php")) {
		$microsites_enabled = true;
	}
	
	$sql = "SELECT max(ordinal)+0 AS maxid
			FROM " . DB_NAME_PREFIX . "menuitems 
			WHERE parent_id = " . $parent_id;
		
	$result = my_mysql_query ($sql);
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "menuitems
				SET name = '" . mysql_real_escape_string($name) . "',
					language_id = '" . mysql_real_escape_string($language_id) . "',";
		
		if ($section_id!="") {
			$sql .= "section_id = '" . mysql_real_escape_string($section_id) . "',";
		}

		if ($microsites_enabled && $parent_microsite_id) {
			$sql .= "parent_microsite_id = " . (int) $parent_microsite_id . ",";
		}
		
		$sql .= "	parent_id = " . $parent_id . ",
					ordinal = " . (int) $row['maxid'] . " + 2";
					
		if ($microsites_enabled && ($microsite_id_for_sql = getMicrositeIdFromMenuItem($parent_id ))) {
			$sql .= ",
					microsite_id = " . $microsite_id_for_sql;
		}
		
		$result = my_mysql_query($sql);
		
		$mID = mysql_insert_id();

		sendSignal("eventMenuItemCreated",array("mID" => $mID));
		
		return $mID;
	}
}

function updateMenuItemContentItem ($mID, $cID, $cType) {
	$mID = (int) $mID;
	$cID = (int) $cID;

	$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems
			SET content_id = " . (int) $cID . ",
				content_type = '" . mysql_real_escape_string($cType) . "'
			WHERE id = " . $mID;
	$result = my_mysql_query($sql);
}

function deleteMenuItem_recursive ($parent_id=0) {
	if ($parent_id!=0) {
		$parent_id = (int) $parent_id;
	}

	$sql = "SELECT id FROM " . DB_NAME_PREFIX . "menuitems WHERE parent_id = " . $parent_id;
	$result = my_mysql_query($sql);

	$newmenuitems_count = mysql_num_rows($result);

	while ($row = mysql_fetch_array($result)) {
		deleteMenuItem_recursive ($row['id']);
	}

	$sql = "DELETE FROM " . DB_NAME_PREFIX . "menuitems WHERE parent_id = " . $parent_id;
	$result = my_mysql_query($sql);
	$sql = "DELETE FROM " . DB_NAME_PREFIX . "menuitems WHERE id = " . $parent_id;
	$result = my_mysql_query($sql);
}

function setParentMenuItemsActive ($mID) {
	$mID = (int) $mID;

	$sql = "SELECT parent_id
			FROM " . DB_NAME_PREFIX . "menuitems
			WHERE id = " . $mID;

	$result = my_mysql_query($sql);

	$row = mysql_fetch_array($result);

	if ($row[0]!=0) {
		$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems
			SET active = '1'
			WHERE id = " . $row[0];

		$result = my_mysql_query($sql);

		setParentMenuItemsActive ($row[0]);
	}
}

function updateMenuOrder ($newOrder) {
	for ($i=0;$i<sizeof($newOrder);$i++) {
		$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems
				SET ordinal = " . ($i+1) . "
				WHERE id = " . $newOrder[$i];
					
		$result = my_mysql_query($sql);
	}
}

function tidyKeywords($keywords) {
	/* Strip white space around commas in keywords */

	$pattern = '/\s*,\s*/i';
	$replacement = ",";

	$output = preg_replace($pattern,$replacement,$keywords);

	$pattern = '/^,|,$/i';
	$replacement = "";

	$output = preg_replace($pattern,$replacement,$output);

	return $output;
}









function handleMediaUpload($filename, $maxSize, $type, $id, $movie = false, $cID = false, $cType = false, $cVersion = false) {
	return require 'cmsincludes/admin/handleMediaUpload.fun.php';
}





/*  Functions for Categories  */

function checkIfCategoryExists($categoryName, $catId = false, $parentCatId = false) {

	$sql = "SELECT name
			FROM " . DB_NAME_PREFIX . "categories
			WHERE name = '" . mysql_real_escape_string($categoryName) . "'";
	
	if ($catId) {
		$sql .= "
			  AND id != ". (int) $catId;
	}
	
	if ($parentCatId) {
		$sql .= " AND parent_id = " . (int) $parentCatId;
	}
	
	$result = my_mysql_query( $sql );
	return mysql_num_rows($result);
}




/* Plugins */

function getPluginIconURL($pluginName) {
	if (file_exists(CMS_ROOT . 'plugins/' . $pluginName . '/' . $pluginName . '.gif')) {
		return httpOrhttps(). httpHost() . SUBDIRECTORY . 'plugins/' . $pluginName . '/' . $pluginName . '.gif';
	} elseif (file_exists(CMS_ROOT . 'plugins/' . $pluginName . '/' . $pluginName . '.jpg')) {
		return httpOrhttps(). httpHost() . SUBDIRECTORY . 'plugins/' . $pluginName . '/' . $pluginName . '.jpg';
	} else {
		return httpOrhttps(). httpHost() . SUBDIRECTORY . 'cmsincludes/plugin_base_class/dummy_plugin.gif';
	}
}

function initialisePlugin($id) {
	$id = (int) $id;
	
	$plugin_name = getPluginName($id);
	
	getLatestRevisionNumber();
	require CMS_ROOT. 'plugins/'. $plugin_name. '/installation_check.php';

	if (checkIfDBUpdatesAreNeeded()) {
		$installation_status = array(getPhrase("Core databases need to be applied. Please log out and then log back in again before attempting to install any Plugins."));
	} else {
		$installation_status = checkInstallationCanProceed(TRIBIQ_CMS_NUMERIC_VERSION);
	}
	
	if (!is_array($installation_status) || !count($installation_status)) {
		if (runOrInitialisePlugin($id, '_ENUM_INITIALISED', $existingVersion)) {
			//Have a safety feature whereby if the installation fails, the Plugin will be immediately uninstalled
			//However this shouldn't be used for upgrading a Plugin to a different version
			if (!$existingVersion) {
				$uninstallPluginOnFail = $id;
			}
			checkIfDBUpdatesAreNeeded($andDoUpdates = true, $uninstallPluginOnFail);
		} else {
			$error_string = getPhrase('_ANOTHER_VERSION_OF_PLUGIN_IS_INSTALLED');
		}
		
	} else {
		foreach ($installation_status as $error) {
			$error_string .= $error . "<br />";
		}
	}
	
	if ($error_string) {
		return $error_string;
	} else {
		return "success";
	}	
}

function runPlugin($id) {
	$missingPlugin = false;
	if (includePluginAndDependencies($pluginName = getPluginName($id), $missingPlugin)) {
		runOrInitialisePlugin($id, '_ENUM_RUNNING', $existingVersion);
		//Add any content types this Plugin has
		setupPluginContentTypesFromXMLDescription('plugins/'. $pluginName. '/db_updates', 'description.xml');
	
	} elseif($missingPlugin) {
		echo getPhrase(
			'Cannot run the Plugin &quot;[[pluginName]]&quot; as its dependent &quot;[[dependencyName]]&quot; is not present or not running.',
			array('pluginName' => htmlspecialchars($pluginName), 'dependencyName' => htmlspecialchars($missingPlugin['plugin'])));
	
	} else {
		echo getPhrase(
			'Cannot run the Plugin &quot;[[pluginName]]&quot; as its plugin_code appears to be missing.',
			array('pluginName' => htmlspecialchars($pluginName)));
	}
}

function runOrInitialisePlugin($id, $newStatus, &$existingVersion) {
	
	//Get information on the current plugin
	$sql = "
		SELECT id, class_name
		FROM ". DB_NAME_PREFIX. "plugins
		WHERE id = ". (int) $id;
	$result = my_mysql_query($sql);
	$new = mysql_fetch_assoc($result);
	
	//Check to see if there are any other versions of the same plugin running, and
	//get their details
	$sql = "
		SELECT id, name, status
		FROM ". DB_NAME_PREFIX. "plugins
		WHERE class_name = '". mysql_real_escape_string($new['class_name']). "'
		  AND id != ". (int) $new['id'];
	$result = my_mysql_query($sql);	
	
	$current = false;
	while ($other = mysql_fetch_assoc($result)) {
		//If we find another version running, don't let this version be activated!
		if ($other['status'] == '_ENUM_RUNNING' || $other['status'] == '_ENUM_INITIALISED') {
			return false;
		}
	}
	
	//Mark this plugin as running
	$sql = "
		UPDATE ". DB_NAME_PREFIX. "plugins SET
			status = '". mysql_real_escape_string($newStatus). "'
		WHERE id = ". (int) $new['id'];
	$result = my_mysql_query($sql);
	
	return true;
}

function suspendPlugin($id) {
	suspendPluginCheckForDependencies(getPluginDetails($id));
	
	$sql = "UPDATE ". DB_NAME_PREFIX. "plugins
			SET status = '_ENUM_SUSPENDED'
			WHERE id = ". (int) $id;
			
	$result = my_mysql_query($sql);	
}

function succeedPlugin($id, $preview = false) {
	
	$instances = array();
	
	//Check to see if this Plugin is compatilible with any other Plugins
	$sql = "
		SELECT plugin_id
		FROM ". DB_NAME_PREFIX. "plugin_dependencies
		WHERE `type` = 'compatibility'
		  AND dependency_plugin_class_name = '". mysql_real_escape_string(getPluginClass($id)). "'
	  UNION
		SELECT p.id AS plugin_id
		FROM ". DB_NAME_PREFIX. "plugin_dependencies AS d
		INNER JOIN ". DB_NAME_PREFIX. "plugins AS p
		   ON d.dependency_plugin_class_name = p.class_name
		WHERE d.`type` = 'compatibility'
		  AND d.plugin_id = ". (int) $id;
	$result = my_mysql_query($sql);
	
	//Update all of those Plugin's instances to be instances for this Plugin
	while($row = mysql_fetch_assoc($result)) {
		if ($preview) {
			$sql = "
				SELECT name
				FROM ". DB_NAME_PREFIX. "plugin_instances
				WHERE plugin_id = ". (int) $row['plugin_id'];
			$result2 = my_mysql_query($sql);
			
			while($instance = mysql_fetch_assoc($result2)) {
				$instances[$instance['name']] = $instance['name'];
			}
		
		} else {
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "plugin_instances SET
					plugin_id = ". (int) $id. "
				WHERE plugin_id = ". (int) $row['plugin_id'];
			my_mysql_query($sql);
			
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "plugin_inst_item_link SET
					plugin_id = ". (int) $id. "
				WHERE plugin_id = ". (int) $row['plugin_id'];
			my_mysql_query($sql);
			
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "plugin_inst_temp_fam_link SET
					plugin_id = ". (int) $id. "
				WHERE plugin_id = ". (int) $row['plugin_id'];
			my_mysql_query($sql);
			
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "plugin_inst_temp_link SET
					plugin_id = ". (int) $id. "
				WHERE plugin_id = ". (int) $row['plugin_id'];
			my_mysql_query($sql);
		}
	}
	
	return $instances;
}

function addNewPlugins () {
	
	if (defined('ADD_NEW_PLUGINS_FUNCTION_RUN')) {
		return;
	}
	define('ADD_NEW_PLUGINS_FUNCTION_RUN', true);
	
	$dir = CMS_ROOT . "plugins/";
	$dh  = opendir($dir);

	while ($file = readdir($dh)) {
		clearstatcache;
		if (substr($file, 0, 1) != '.' && filetype($dir. $file) == 'dir') {
			
			$pluginStatus = getPluginStatusByName($file);
			
			if ($pluginStatus == '_ENUM_INSTALLED' || $pluginStatus === false) {
				
				if (is_file($path = CMS_ROOT . "plugins/" . $file . "/db_updates/description.xml")) {
					try {
						$xml = new SimpleXMLElement(file_get_contents($path));
						if (!(is_object($xml)) || !($xml->display_name) || !($xml->class_name)
						    || substr($file, 0, strlen($xml->class_name)) != $xml->class_name) {
							$xml = false;
						}
					} catch (Exception $e) {
						$xml = false;
					}
					
					if ($xml) {
						$sql = "
								version = '". mysql_real_escape_string($xml->version). "',
								class_name = '" . mysql_real_escape_string($xml->class_name) . "',
								display_name = '" . mysql_real_escape_string($xml->display_name) . "',
								company_name = '". mysql_real_escape_string($xml->company_name). "'";
						
						if ($pluginStatus === false) {
							$sql = "
								INSERT INTO " . DB_NAME_PREFIX . "plugins SET
									name = '" . mysql_real_escape_string($file) . "',".
									$sql;
						} else {
							$sql = "
								UPDATE " . DB_NAME_PREFIX . "plugins SET
									". $sql. "
								WHERE name = '" . mysql_real_escape_string($file) . "'";
						}
						
						$result = my_mysql_query($sql);
					}
				}
			}
		}
	}
}





function suspendPluginCheckForDependencies($plugin) {
	
	//Check that the core does not depend on the Plugin
	$sql = "
		SELECT 1
		FROM ". DB_NAME_PREFIX. "plugin_dependencies
		WHERE dependency_plugin_class_name = '". mysql_real_escape_string($plugin['class_name']). "'
		  AND plugin_id = 0";
	$result = my_mysql_query($sql);
	
	if (mysql_fetch_row($result)) {
		echo getPhrase(
			'Cannot Suspend the Plugin &quot;[[plugin]]&quot; as the Core CMS depends on it.',
			array('plugin' => htmlspecialchars($plugin['name'])));
		exit;
	}
	
	//Check that the Plugin has no other Plugins that are inheriting from this one
	$sql = "
		SELECT plugin_id, plugin_name
		FROM ". DB_NAME_PREFIX. "plugin_dependencies
		WHERE dependency_plugin_class_name = '". mysql_real_escape_string($plugin['class_name']). "'
		  AND `type` IN('dependency', 'inheritance')";
	$result = my_mysql_query($sql);
	
	while ($row = mysql_fetch_assoc($result)) {
		if (getPluginStatus($row['plugin_id']) == '_ENUM_RUNNING') {
			echo getPhrase(
				'Cannot Suspend the Plugin &quot;[[pluginName]]&quot; as the &quot;[[dependencyName]]&quot; Plugin depends on it.',
				array('pluginName' => htmlspecialchars($plugin['name']), 'dependencyName' => htmlspecialchars($row['plugin_name'])));
			exit;
		}
	}
}


function uninstallPluginCheckForDependencies($plugin) {
	//Check that the Plugin has no dependencies
	$sql = "
		SELECT plugin_name
		FROM ". DB_NAME_PREFIX. "plugin_dependencies
		WHERE dependency_plugin_class_name = '". mysql_real_escape_string($plugin['class_name']). "'
		  AND `type` IN ('dependency', 'inheritance')";
	$result = my_mysql_query($sql);
	
	if ($row = mysql_fetch_assoc($result)) {
		echo getPhrase(
			'Cannot Uninstall the Plugin &quot;[[pluginName]]&quot; as the &quot;[[dependencyName]]&quot; Plugin depends on it.',
			array('pluginName' => htmlspecialchars($plugin['name']), 'dependencyName' => htmlspecialchars($row['plugin_name']))
		);
		exit;
	}
}

//Completely removes all traces of a Plugin from a site.
function uninstallPlugin($pluginId) {
	
	$plugin = getPluginDetails($pluginId);
	
	if ($plugin['status'] == '_ENUM_RUNNING') {
		echo getPhrase('Running Plugins cannot be Uninstalled');
		exit;
	}
	
	uninstallPluginCheckForDependencies($plugin);
	
	
	//Remove all data about the Plugin
	$result = getRows('plugin_instances', 'id', array('plugin_id' => (int) $pluginId));
	while ($row = mysql_fetch_assoc($result)) {
		deletePluginInstance($row['id']);
	}

	foreach(array('job_logs') as $table) {
		$sql = "
			DELETE FROM ". DB_NAME_PREFIX. $table. "
			WHERE job_id IN (
				SELECT id
				FROM ". DB_NAME_PREFIX. "jobs
				WHERE job_id = ". (int) $pluginId. "
			)";
		my_mysql_query($sql);
	}

	foreach(array(
		'jobs', 'nested_plugins',
		'plugin_dependencies', 'signals',
		'plugin_inst_item_link', 'plugin_inst_temp_fam_link', 'plugin_inst_temp_link',
		'plugin_setting_defs', 'plugin_instances'
	) as $table) {
		$sql = "
			DELETE FROM ". DB_NAME_PREFIX. $table. "
			WHERE plugin_id = ". (int) $pluginId;
		my_mysql_query($sql);
	}
	
	//Attempt to delete any plugin tables or views
	$prefix = DB_NAME_PREFIX. "plg". (int) $pluginId. "_";
	$prefixLen = strlen($prefix);
	
	$sql = "
		SHOW TABLES LIKE '". $prefix. "%'";
	$result = my_mysql_query($sql);
	
	while($row = mysql_fetch_row($result)) {
		if (substr($row[0], 0, $prefixLen) == $prefix) {
			my_mysql_query("DROP TABLE IF EXISTS `". mysql_real_escape_string($row[0]). "`");
			@mysql_query("DROP VIEW IF EXISTS `". mysql_real_escape_string($row[0]). "`");
		}
	}
	
	//Delete any records of the Plugin having been installed
	$sql = "
		DELETE FROM ". DB_NAME_PREFIX. "local_revision_numbers
		WHERE path = 'plugins/". mysql_real_escape_string($plugin['name']). "/db_updates'";
	my_mysql_query($sql);
	
	//Finally, remove the Plugin from the Plugin table
	$sql = "
		DELETE FROM ". DB_NAME_PREFIX. "plugins
		WHERE id = ". (int) $pluginId;
	my_mysql_query($sql);
	
}


//Get a text desription of a site setting
function getSettingDesc($setting) {
	return getPhrase('_SETTINGS_DESC_'. strtoupper($setting));
}


/* Plugins, Slots and Instances */

//Get a description of everything needed for the Plugin Instance Settings Admin Floating Box
function getPluginSettingDesc($instanceId, &$instanceName, &$pluginName, &$pluginId, &$frameworks, &$tab_programs, &$sections, &$valuesInDB, $nest = 0, $editMode = false) {
	return require 'cmsincludes/admin/getPluginSettingDesc.fun.php';
}

//Add the standard Instance Name and Framework to a Section
function getPluginSettingDescAddFieldsToFirstSection(&$plugin, &$instance, $instanceId, &$frameworks, &$fields, &$valuesInDB, $nest, $allowCustomFramework) {
	
	//Even if there are no settings for this plugin, then we still want to have
	//one or two fixed fields at the start; e.g. the name of the instance as the very first field
	//Nested Plugins have a little more information
	if ($nest) {
		$fields['instance_name'] = array(
			'Label' => 'Nest:',
			'Type' => 'varchar(250)',
			'Null' => 'NO',
			'Read Only' => true);
	
		$fields['tab'] = array(
			'Label' => getPhrase('Tab #:'),
			'Read Only' => true);
		
		$fields['ord'] = array(
			'Label' => getPhrase('Plugin #:'),
			'Read Only' => true);
		
		$fields['plugin_display_name'] = array(
			'Label' => getPhrase('Plugin:'),
			'Read Only' => true);
		
		$valuesInDB['plugin_display_name'] = $plugin['display_name'];
	
	} else {
		$fields['instance_name'] = array(
			'Table' => 'plugin_instances',
			'Type' => 'varchar(250)',
			'Null' => 'NO',
			'Read Only' => (bool) $instanceId);
		
		$fields['keep_in_album'] = array(
			'Label' => 'In Album:',
			'Type' => 'tinyint(1)',
			'Note Below' => getPhrase('Keep Plugin Instances in the Album when you want to use them in several places. Instances in the Album are preserved when you &quot;Nest&quot; them.'));
		
		$valuesInDB['keep_in_album'] = $instance['keep_in_album'];
	}
	
	$valuesInDB['instance_name'] = $instance['instance_name'];
	
	
	//Does this Plugin have any frameworks..?
	if (count($frameworks)) {
		//If so, add a select list for frameworks
		$fields['framework'] = array(
			'Label' => 'Framework:',
			'Table' => 'plugin_instances',
			'Type' => 'select',
			'Null' => 'NO',
			'Options' => array());
		
		foreach($frameworks as $returnValue => $displayName) {
			$fields['framework']['Options'][$returnValue] = $displayName;
		}
	
		$valuesInDB['framework'] = $instance['framework'];
		
		
		if ($allowCustomFramework) {
			$fields['framework']['Post Field HTML'] = '
				<input class="submit" style="font-size: 70%; margin-left: 10px; padding: 1px;" type="button"
					onclick="tribiqTab.viewFrameworkSource();" value="'. getPhrase('View Framework Source'). '"/>';
			
			$fields['use_custom_framework'] = array(
				'Type' => 'tinyint',
				'Label' => getPhrase('Customise this Framework:'),
				'onclick' => "tribiqTab.customiseFrameworkOnclick(this, '".
					getPhrase("Are you sure you wish to stop using your custom Framework? You will lose any changes you have made to your Framework.").
				"', '".
					getPhrase("Stop and abandon changes").
				"', '".
					getPhrase("Cancel").
				"');");
			
			$valuesInDB['use_custom_framework'] = arrayKey($instance, 'use_custom_framework');
			
			
			$fields['custom_framework'] = array(
				'Type' => 'textarea',
				'Requires' => 'use_custom_framework',
				'Label' => getPhrase('Custom HTML Code:'),
				'Note Below' => getPhrase('Please note that these changes will not apply if you place this Plugin inside a Nest.'));
			
			$valuesInDB['custom_framework'] = arrayKey($valuesInDB, 'setting_%custom_framework%');
			
			if (!checkPriv('_PRIV_MANAGE_CUSTOM_FRAMEWORK')) {
				$fields['custom_framework']['Read Only'] = true;
				$fields['use_custom_framework']['Read Only'] = true;
			}
		}
	}
}


//List all of the themes in a Plugin
function listPluginThemes($pluginName, $pluginClassName, &$details, $lookFor, &$desc, &$skinDescFound, $recurseLimit = 9) {
	
	$exists = false;
	if (!$recurseLimit) {
		return;
	}
	
	$pluginName = preg_replace('/\W/', '', $pluginName);
	
	//Look through this Plugin's theme directories
	if (is_dir($path = CMS_ROOT. 'plugins/'. $pluginName. '/'. ($lookFor == 'frameworks'? 'frameworks' : 'themes'). '/')) {
		foreach(scandir($path) as $themeName) {
			if (substr($themeName, 0, 1) != '.') {
				
				if ($lookFor == 'frameworks') {
					//If we're looking for frameworks, only list the theme if a framework is present
					$exists = is_file($path. $themeName. '/framework.html');
				
				} elseif ($lookFor == 'styles') {
					//If we're looking for styles, only list the theme if a stylesheet is present
					$exists = is_file($path. $themeName. '/stylesheet.css');
				}
			}
			
			if ($exists) {
				$themeDisplayName = ucwords(str_replace('_', ' ', $themeName));
				
				$details[$themeDisplayName. '__'. $pluginClassName] = array(
					'dir' => $themeName,
					'name' => $themeDisplayName,
					'saveName' => $themeName,
					'pluginName' => $pluginName,
					'prefix' => $pluginClassName. '__'. $themeName);
			}
		}
	}
	
	//Add choices in for themes from the Skin
	if ($lookFor == 'styles'
	 && $desc
	 && $desc->plugin_themes
	 && $desc->plugin_themes->$pluginClassName) {
		foreach($desc->plugin_themes->$pluginClassName as $theme) {
			$skinDescFound = true;
			$details[(string) $theme->name. '__'. (int) $theme->ord] = array(
				'name' => (string) $theme->name,
				'saveName' => (int) $theme->ord,
				'prefix' => $pluginClassName. '__'. (int) $theme->ord);
		}
	}
	
	
	//Search this Plugin's inheritances for more themes
	$sql = "
		SELECT p.name, p.class_name
		FROM ". DB_NAME_PREFIX. "plugin_dependencies AS d
		INNER JOIN ". DB_NAME_PREFIX. "plugins AS p
		   ON p.class_name = d.dependency_plugin_class_name
		  AND p.status = '_ENUM_RUNNING'
		WHERE d.plugin_name = '". mysql_real_escape_string($pluginName). "'
		  AND d.`type` = 'inheritance'";
	
	$result = my_mysql_query($sql);
	if ($row = mysql_fetch_assoc($result)) {
		listPluginThemes($row['name'], $row['class_name'], $details, $lookFor, $desc, $skinDescFound, --$recurseLimit);
	}
}

//Get details on all of the themes available to a framework
function listPluginThemeCSS($pluginName, $pluginClassName, $framework, $frameworkPluginClassName, $skinId) {
	
	//Attempt to load this list from an xml file description to add choices in for themes from the Skin
	$skin = $desc = $skinDescFound = false;
	validateSkinFromXMLDescription($skinId, $skin, $desc);
	
	$details = array();
	if ($pluginName && $pluginClassName) {
		listPluginThemes($pluginName, $pluginClassName, $details, 'styles', $desc, $skinDescFound);
	}
	
	if (empty($details)) {
		$details[$skin['name']] = array(
			'name' => getPhrase('(No Themes have been defined for this Plugin)'),
			'saveName' => 1,
			'prefix' => $frameworkPluginClassName. '__1');
	}
	
	$output = array();
	$themeNames = array_keys($details);
	arsort($themeNames);
	foreach($themeNames as $key) {
		$output[$details[$key]['prefix']] = $details[$key];
		unset($details[$key]);
	}
	
	return $output;
}

//Get a list of each framework available to an instance
function listPluginThemeFrameworks($pluginName, $pluginClassName, $defaultTheme) {
	$desc = $skinDescFound = false;
	$details = array();
	listPluginThemes($pluginName, $pluginClassName, $details, 'frameworks', $desc, $skinDescFound);
	
	
	$output = array($defaultTheme => false);
	
	$themeNames = array_keys($details);
	arsort($themeNames);
	foreach($themeNames as $key) {
		$output[$details[$key]['dir']] = $details[$key]['name'];
		unset($details[$key]);
	}
	
	if ($output[$defaultTheme] === false) {
		unset($output[$defaultTheme]);
	}
	
	return $output;
}

//Save a Plugin Theme to the database
function setTheme($submission) {
	
	if (issetArrayKey($submission, 'theme')) {
		$sql = "
			REPLACE INTO ". DB_NAME_PREFIX. "plugin_slot_theme_link SET
				theme = '". mysql_real_escape_string($submission['theme']). "',
				skin_id = ". (int) $submission['skin_id']. ",
				slot_name = '". mysql_real_escape_string($submission['slot_name']). "',
				nest = ". (int) $submission['nest']. ",
				instance_id = ". (int) $submission['instance_id'];
	} else {
		$sql = "
			DELETE FROM ". DB_NAME_PREFIX. "plugin_slot_theme_link
			WHERE skin_id = ". (int) $submission['skin_id']. "
			  AND slot_name = '". mysql_real_escape_string($submission['slot_name']). "'
			  AND nest = ". (int) $submission['nest']. "
			  AND instance_id = ". (int) $submission['instance_id'];
	}
	
	my_mysql_query($sql);
}



function getInstanceName($instanceId) {
	$sql = "
		SELECT name
		FROM ". DB_NAME_PREFIX. "plugin_instances
		WHERE id = ". (int) $instanceId;
	
	$result = my_mysql_query($sql);
	$row = mysql_fetch_assoc($result);
	return $row['name'];
	
}

//Attempt to add a new instance
function createNewInstance($pluginId, $instanceName, &$instanceId, &$errors, $onlyValidate = false) {
	
	if (!$pluginId) {
		return false;
	}

	//Exit if called somewhere it shouldn't be
	if (!checkIfPluginUsesInstances($pluginId)) {
		exit;
	}
	
	if (!$instanceName) {
		$errors[] = getPhrase('_ERROR_INSTANCE_NAME');
		return false;
	}
	
	//Check to see if an instance of that name already exists
	$sql = "
		SELECT 1
		FROM ". DB_NAME_PREFIX. "plugin_instances
		WHERE name =  '". mysql_real_escape_string($instanceName). "'";
	
	$result = my_mysql_query($sql);
	if (mysql_num_rows($result)) {
		$errors[] = getPhrase('_ERROR_INSTANCE_NAME_EXISTS');
		return false;
	}
	
	if ($onlyValidate) {
		return true;
	}
	
	//Insert a new record into the instances table
	$sql = "
		INSERT INTO ". DB_NAME_PREFIX. "plugin_instances (plugin_id, name, keep_in_album)
		SELECT id, '". mysql_real_escape_string($instanceName). "', keep_in_album
		FROM ". DB_NAME_PREFIX. "plugins
		WHERE id = ". (int) $pluginId;
	
	$result = my_mysql_query($sql);
	$instanceId = mysql_insert_id();
	
	//Insert the default settings into the instances settings table
	$sql = "
		INSERT INTO ". DB_NAME_PREFIX. "plugin_settings
			(instance_id, name, value)
		SELECT
			". (int) $instanceId. ",
			name,
			default_value
		FROM ". DB_NAME_PREFIX. "plugin_setting_defs
		WHERE plugin_id = ". (int) $pluginId;
	
	$result = my_mysql_query($sql);
	
	return true;
}

function getInstanceParent($instanceId) {
	$sql = "
		SELECT parent_id
		FROM ". DB_NAME_PREFIX. "plugin_instances
		WHERE id =  ". (int) $instanceId;
	
	$result = my_mysql_query($sql);
	$row = mysql_fetch_assoc($result);
	
	return $row['parent_id']? getPluginInstanceDetails($row['parent_id']) : false;
}

//Rename an instance if possible
function renameInstance(&$instanceId, &$nest, $newName, &$error, $createNewInstance, $onlyValidate = false, $createParentLink = false) {
	
	$instance = getPluginInstanceDetails($instanceId);
	
	//Don't allow the rename to take place if the user has no permisions
	if (!checkPriv("_PRIV_MANAGE_PLUGIN_INSTANCE")) {
		$error = 'permissions error!';
		return false;
	}
	
	if (!$newName) {
		$error = getPhrase('Please enter a new name for your Instance.');
		return false;
	}
	
	//Check to see if an instance of that name already exists
	$sql = "
		SELECT 1
		FROM ". DB_NAME_PREFIX. "plugin_instances
		WHERE name =  '". mysql_real_escape_string($newName). "'";
	
	if (!$createNewInstance) {
		$sql .= "
		  AND id != ". (int) $instanceId;
	}
	
	$result = my_mysql_query($sql);
	if (mysql_num_rows($result)) {
		if ($createParentLink) {
			$error = getPhrase('You are already trying out this Instance on this page.');
		} else {
			$error = getPhrase('An Instance with the name &quot;[[name]]&quot; already exists. Please choose a different name.', array('name' => htmlspecialchars($newName)));
		}
		return false;
	}
	
	if ($onlyValidate) {
		return true;
	}
	
	if ($createNewInstance) {
		$sql = "
			INSERT INTO ". DB_NAME_PREFIX. "plugin_instances SET
				name = '". mysql_real_escape_string($newName). "',
				framework = '". mysql_real_escape_string($instance['framework']). "',
				use_custom_framework = ". (int) $instance['use_custom_framework']. ",
				plugin_id = ". (int) $instance['plugin_id'];
		
		if ($createParentLink) {
			$sql .= ",
				parent_id = ". (int) $instanceId;
		}
		
		my_mysql_query($sql);
		$oldInstanceId = $instanceId;
		$instanceId = mysql_insert_id();
		
		$sql = "
			INSERT INTO ". DB_NAME_PREFIX. "nested_plugins (
				instance_id,
				tab,
				ord,
				plugin_id,
				framework,
				is_tab,
				tab_title
			) SELECT
				". (int) $instanceId. " AS `instance_id`,
				tab,
				ord,
				plugin_id,
				framework,
				is_tab,
				tab_title
			FROM ". DB_NAME_PREFIX. "nested_plugins
			WHERE instance_id = ". (int) $oldInstanceId;
		my_mysql_query($sql);
		
		$sql = "
			INSERT INTO ". DB_NAME_PREFIX. "plugin_settings (
				instance_id,
				`name`,
				`value`,
				nest
			) SELECT
				". (int) $instanceId. " AS `instance_id`,
				ps.`name`,
				ps.`value`,
				IFNULL(np_new.id, 0)
			FROM ". DB_NAME_PREFIX. "plugin_settings AS ps
			LEFT JOIN ". DB_NAME_PREFIX. "nested_plugins AS np_old
			   ON np_old.instance_id = ". (int) $oldInstanceId. "
			  AND np_old.id = ps.nest
			LEFT JOIN ". DB_NAME_PREFIX. "nested_plugins AS np_new
			   ON np_new.instance_id = ". (int) $instanceId. "
			  AND np_old.tab = np_new.tab
			  AND np_old.ord = np_new.ord
			  AND np_old.plugin_id = np_new.plugin_id
			WHERE (ps.nest != 0 XOR np_new.id IS NULL)
			  AND ps.instance_id = ". (int) $oldInstanceId;
		my_mysql_query($sql);
		
		$sql = "
			INSERT INTO ". DB_NAME_PREFIX. "plugin_slot_theme_link (
				instance_id,
				skin_id,
				slot_name,
				theme,
				nest
			) SELECT
				". (int) $instanceId. " AS `instance_id`,
				pstl.skin_id,
				pstl.slot_name,
				pstl.theme,
				IFNULL(np_new.id, 0)
			FROM ". DB_NAME_PREFIX. "plugin_slot_theme_link AS pstl
			LEFT JOIN ". DB_NAME_PREFIX. "nested_plugins AS np_old
			   ON np_old.instance_id = ". (int) $oldInstanceId. "
			  AND np_old.id = pstl.nest
			LEFT JOIN ". DB_NAME_PREFIX. "nested_plugins AS np_new
			   ON np_new.instance_id = ". (int) $instanceId. "
			  AND np_old.tab = np_new.tab
			  AND np_old.ord = np_new.ord
			  AND np_old.plugin_id = np_new.plugin_id
			WHERE (pstl.nest != 0 XOR np_new.id IS NULL)
			  AND pstl.instance_id = ". (int) $oldInstanceId;
		my_mysql_query($sql);
		
		if ($nest) {
			$sql = "
				SELECT np_new.id AS nest
				FROM ". DB_NAME_PREFIX. "nested_plugins AS np_old
				INNER JOIN ". DB_NAME_PREFIX. "nested_plugins AS np_new
				   ON np_new.instance_id = ". (int) $instanceId. "
				  AND np_old.tab = np_new.tab
				  AND np_old.ord = np_new.ord
				  AND np_old.plugin_id = np_new.plugin_id
				WHERE np_old.instance_id = ". (int) $oldInstanceId. "
				  AND np_old.id = ". (int) $nest;
			
			$result = my_mysql_query($sql);
			$row = mysql_fetch_assoc($result);
			$nest = $row['nest'];
		}
		
		sendSignal('eventPluginInstanceDuplicated', array('oldInstanceId' => $oldInstanceId, 'newInstanceId' => $instanceId));
		
	} else {
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "plugin_instances
				SET name = '". mysql_real_escape_string($newName). "',
				parent_id = 0
			WHERE id = ". (int) $instanceId;
		my_mysql_query($sql);
	}
	
	return true;
}

function saveInstance($instanceId, $details, $nest) {
	if (!$nest) {
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "plugin_instances SET
				framework = '". mysql_real_escape_string($details['framework']). "',
				keep_in_album = ". (int) $details['keep_in_album']. "
			WHERE id = ". (int) $instanceId;
		my_mysql_query($sql);
	
	} else {
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "nested_plugins SET
				framework = '". mysql_real_escape_string($details['framework']). "'
			WHERE id = ". (int) $nest;
		my_mysql_query($sql);
	}
}

function setInstanceCustomFramework($instanceId, $details, $useCustomFramework, $customFramework) {
	$sql = "
		UPDATE ". DB_NAME_PREFIX. "plugin_instances SET
			framework = '". mysql_real_escape_string($details['framework']). "',
			keep_in_album = ". (int) $details['keep_in_album']. ",
			use_custom_framework = ". (int) $useCustomFramework. "
		WHERE id = ". (int) $instanceId;
	my_mysql_query($sql);
	
	if ($useCustomFramework) {
		$sql = "
			REPLACE INTO  ". DB_NAME_PREFIX. "plugin_settings SET
				name = '%custom_framework%',
				value = '". mysql_real_escape_string($customFramework). "',
				instance_id = ". (int) $instanceId;
	} else {
		$sql = "
			DELETE FROM  ". DB_NAME_PREFIX. "plugin_settings
			WHERE name = '%custom_framework%'
			  AND instance_id = ". (int) $instanceId;
	}
	my_mysql_query($sql);
}

//Check how many content items use an instance, and get one example
function checkInstancesUsage($instanceIds, $publishedOnly = false) {
	
	if (!$instanceIds) {
		return array('count' => 0);
	}
	
	
	$usage['count'] = 0;
	foreach (getContentTypes() as $contentType) {
		$sql = "
			SELECT COUNT(DISTINCT c.id)
			FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($contentType['content_type_id']). " AS c
			WHERE status ". ($publishedOnly? "= 'published'" : "IN ('published', 'private_draft')"). "
			  AND (
				template_id IN (
					SELECT template_id
					FROM ". DB_NAME_PREFIX. "plugin_inst_temp_link
					WHERE instance_id IN (". preg_replace('/[^\d,]/', '', $instanceIds). ")
				  UNION
					SELECT template_id
					FROM ". DB_NAME_PREFIX. "plugin_inst_temp_fam_link AS l
					INNER JOIN ". DB_NAME_PREFIX. "templates AS t
					   ON t.family_name = l.family_name
					WHERE instance_id IN (". preg_replace('/[^\d,]/', '', $instanceIds). ")
				) OR (id, version) IN (
					SELECT
						content_id,
						content_version
					FROM ". DB_NAME_PREFIX. "plugin_inst_item_link
					WHERE instance_id IN (". preg_replace('/[^\d,]/', '', $instanceIds). ")
					  AND content_type = '". mysql_real_escape_string($contentType['content_type_id']). "'
				)
			  )";
		
		$result = my_mysql_query($sql);
		$row = mysql_fetch_row($result);
		$usage['count'] += $row[0];
	}
	
	return $usage;
}

//Replace one instance with another
function replacePluginInstance($oldId, $newId, $cID = false, $cType = false, $cVersion = false, $slotName = false) {
	if ($instance = getPluginInstanceDetails($newId)) {
		//Replace the slot
		foreach (array('plugin_inst_item_link', 'plugin_inst_temp_fam_link', 'plugin_inst_temp_link') as $table) {
			$sql = "
				UPDATE ". DB_NAME_PREFIX. $table. " SET
					plugin_id = ". (int) $instance['plugin_id']. ",
					instance_id = ". (int) $newId. "
				WHERE instance_id = ". (int) $oldId;
			my_mysql_query($sql);
		}
		
		//Ensure the replacement isn't marked as a parent of the replacee
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "plugin_instances SET
				parent_id = 0
			WHERE id = ". (int) $newId;
		my_mysql_query($sql);
		
		//Remove the item level placement if needed
		if ($cID && $cType && $cVersion && $slotName) {
			list ($templateFamily, $dummy, $templateId) = getTemplateFamily($cID, $cType, $cVersion);
			$itemLevelId = getPluginInstanceInItemSlot($slotName, $cID, $cType, $cVersion);
			$templateLevelId = getPluginInstanceInTemplateSlot($slotName, $templateFamily, $templateId);
			$familyLevelId = getPluginInstanceInTemplateSlot($slotName, $templateFamily);
			
			if ($itemLevelId == $newId && ($templateLevelId == $newId || ($templateLevelId === false && $familyLevelId == $newId))) {
				updatePluginInstanceInItemSlot('', $slotName, $cID, $cType, $cVersion);
			}
		}
	}
}

function deletePluginInstance($instanceId) {
	deleteRow('plugin_instances', (int) $instanceId);
	
	foreach (array('nested_plugins', 'plugin_instance_cache', 'plugin_slot_theme_link', 'plugin_settings') as $table) {
		deleteRow($table, array('instance_id' => (int) $instanceId));
	}
	
	sendSignal('eventPluginInstanceDeleted', array('instanceId' => $instanceId));
}

//Check how many items use a Template or a Template Family
function checkTemplateUsage($templateId, $templateFamily = false, $publishedOnly = false) {
	
	$count = 0;
	$sql = "
		SELECT template_id, content_type
		FROM ". DB_NAME_PREFIX. "templates";
	
	if ($templateFamily) {
		$sql .= "
		WHERE family_name = '". mysql_real_escape_string($templateFamily). "'";
	} else {
		$sql .= "
		WHERE template_id = ". (int) $templateId;
	}
	
	$result = my_mysql_query($sql);
	while($template = mysql_fetch_assoc($result)) {
		$sql = "
			SELECT COUNT(*) FROM (
				SELECT DISTINCT id
				FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($template['content_type']). "
				WHERE status ". ($publishedOnly? "= 'published'" : "IN ('published', 'private_draft')"). "
				  AND template_id = ". (int) $template['template_id']. "
			) AS x";
		
		$result2 = my_mysql_query($sql);
		$row = mysql_fetch_row($result2);
		$count += $row[0];
	}
	
	return $count;
}

//Attempt to check if this plugin can work with instances
function checkIfPluginUsesInstances($pluginId) {
	$sql = "SELECT uses_instances
			FROM ". DB_NAME_PREFIX. "plugins
			WHERE id = ". (int) $pluginId;
	
	$result = my_mysql_query($sql);
	
	if ($row = mysql_fetch_assoc($result)) {
		return $row['uses_instances'];
	} else {
		return false;
	}
}



//Update or remove a plugins in slots
function updatePluginInstanceInItemSlot($instanceId, $slotName, $cID, $cType = 'html', $cVersion = false, $pluginId = false) {
	
	if (!$cVersion) {
		$cVersion = getLatestVersion($cID, $cType);
	}
	
	if ($instanceId !== '') {
		
		if ($pluginId === false) {
			$details = getPluginInstanceDetails($instanceId);
			$pluginId = $details['plugin_id'];
		}
		
		$sql = "
			REPLACE INTO ". DB_NAME_PREFIX. "plugin_inst_item_link SET
				plugin_id = ". (int) $pluginId. ",
				instance_id = ". (int) $instanceId. ",
				slot_name = '". mysql_real_escape_string($slotName). "',
				content_id = ". (int) $cID. ",
				content_type = '". mysql_real_escape_string($cType). "',
				content_version = ". (int) $cVersion;
	
	} else {
	
		$sql = "
			DELETE FROM ". DB_NAME_PREFIX. "plugin_inst_item_link
			WHERE slot_name = '". mysql_real_escape_string($slotName). "'
			  AND content_id = ". (int) $cID. "
			  AND content_type = '". mysql_real_escape_string($cType). "'
			  AND content_version = ". (int) $cVersion;
	}
	
	$result = my_mysql_query($sql);
}

function getNestDetails($nestedItemId, $instanceId = false) {

	$sql = "
		SELECT
			tab,
			ord,
			plugin_id,
			framework,
			is_tab,
			tab_title
		FROM ". DB_NAME_PREFIX. "nested_plugins
		WHERE id = ". (int) $nestedItemId;
	
	if ($instanceId !== false) {
		$sql .= "
		  AND instance_id = ". (int) $instanceId;
	}
	
	$result = my_mysql_query($sql);
	return mysql_fetch_assoc($result);
}

function updatePluginInstanceInTemplateSlot($instanceId, $slotName, $templateFamily, $templateId = false) {
	
	if ($templateId) {
		if ($instanceId !== '') {
			
			$details = getPluginInstanceDetails($instanceId);
	
			$sql = "
				REPLACE INTO ". DB_NAME_PREFIX. "plugin_inst_temp_link SET
					plugin_id = ". (int) $details['plugin_id']. ",
					instance_id = ". (int) $instanceId. ",
					slot_name = '". mysql_real_escape_string($slotName). "',
					family_name = '". mysql_real_escape_string($templateFamily). "',
					template_id = ". (int) $templateId;
			
		} else {
	
			$sql = "
				DELETE FROM ". DB_NAME_PREFIX. "plugin_inst_temp_link
				WHERE slot_name = '". mysql_real_escape_string($slotName). "'
				  AND family_name = '". mysql_real_escape_string($templateFamily). "'
				  AND template_id = ". (int) $templateId;
			
		}
	} else {
		if ($instanceId !== '' && $instanceId !== 0) {
			
			$details = getPluginInstanceDetails($instanceId);
	
			$sql = "
				REPLACE INTO ". DB_NAME_PREFIX. "plugin_inst_temp_fam_link SET
					plugin_id = ". (int) $details['plugin_id']. ",
					instance_id = ". (int) $instanceId. ",
					slot_name = '". mysql_real_escape_string($slotName). "',
					family_name = '". mysql_real_escape_string($templateFamily). "'";
			
		} else {
	
			$sql = "
				DELETE FROM ". DB_NAME_PREFIX. "plugin_inst_temp_fam_link
				WHERE slot_name = '". mysql_real_escape_string($slotName). "'
				  AND family_name = '". mysql_real_escape_string($templateFamily). "'";
		}
	}
	
	$result = my_mysql_query($sql);
}


function setPluginSetting($settingName, $settingValue, $instanceId, $nest = 0) {

	$sql = "
		REPLACE INTO ". DB_NAME_PREFIX. "plugin_settings SET
			instance_id = ". (int) $instanceId. ",
			`value` = '". mysql_real_escape_string($settingValue). "',
			`name` = '". mysql_real_escape_string($settingName). "',
			nest = ". (int) $nest;
	$result = my_mysql_query($sql);	
}

function getPluginSetting($settingName, $instanceId, $nest = 0) {

	$sql = "
		SELECT `value`
		FROM ". DB_NAME_PREFIX. "plugin_settings
		WHERE instance_id = ". (int) $instanceId. "
		  AND `name` = '". mysql_real_escape_string($settingName). "'
		  AND nest = ". (int) $nest;
	
	$result = my_mysql_query($sql);
	$row = mysql_fetch_assoc($result);
	return arrayKey($row, 'value');
}



//Plugin Admin Thickbox Tabs
function getPluginAdminFloatingBoxTabDetails($tabId) {
	
	require_once CMS_ROOT. 'cmsincludes/thickbox.inc.php';
	
	$array = explode('_', $tabId);
	
	if (count($array) != 2 || !($pluginId = (int) $array[0]) || !($tabOrdinal = (int) $array[1])) {
		return false;
	} else {
		lookForAdminFloatingBoxTabs($tabs, $pluginId, $tabId);
		return $tabs[$tabId];
	}
}





function checkAuth() {
	//This funciton is now no longer used
	return false;
}


/* Docstore functionality */

function initialiseDocStore () {
	$errors = array();
	
	//Check the docstore directory is correctly defined, exists, and has the correct permissions
	if (!defined('CMS_DOCSTORE_DIR')) {
		$errors[] = getPhrase('_NOT_DEFINED_DOCSTORE_DIR'). '<br />'. getPhrase('_FIX_DOCSTORE_DIR_TO_USE_DOCSTORE');
	
	} else {
		$docstorepath = CMS_DOCSTORE_DIR. '/'. SITENAME;
		
		if (!file_exists($docstorepath)) {
			$mrg = array('dirpath' => $docstorepath);
			$errors[] = getPhrase('_FIX_DOCSTORE_DIR_TO_USE_DOCSTORE'). '<br />'. getPhrase('_DIRECTORY_DOES_NOT_EXIST', $mrg);
		
		} elseif (!is_readable($docstorepath) || !is_writeable($docstorepath)) {
			$mrg = array('dirpath' => $docstorepath);
			$errors[] = getPhrase('_FIX_DOCSTORE_DIR_TO_USE_DOCSTORE'). '<br />'. getPhrase('_DIRECTORY_NOT_READ_AND_WRITEABLE', $mrg);
		}
	}
	
	return count($errors)? $errors : false;
}

/* Dropbox functionality */

function initialiseDropbox () {
	$errors = array();
	
	//Check the docstore directory is correctly defined, exists, and has the correct permissions
	if (!defined('CMS_DROPBOX_DIR')) {
		$errors[] = getPhrase('_NOT_DEFINED_DROPBOX_DIR'). '<br />'. getPhrase('_FIX_DROPBOX_DIR_TO_USE_DROPBOX');
	
	} else {
		$dropboxpath = CMS_DROPBOX_DIR. '/'. SITENAME;
		
		if (!file_exists($dropboxpath)) {
			$mrg = array('dirpath' => $dropboxpath);
			$errors[] = getPhrase('_FIX_DROPBOX_DIR_TO_USE_DROPBOX'). '<br />'. getPhrase('_DIRECTORY_DOES_NOT_EXIST', $mrg);
		
		} elseif (!is_readable($dropboxpath) || !is_writeable($dropboxpath)) {
			$mrg = array('dirpath' => $dropboxpath);
			$errors[] = getPhrase('_FIX_DROPBOX_DIR_TO_USE_DROPBOX'). '<br />'. getPhrase('_DIRECTORY_NOT_READ_AND_WRITEABLE', $mrg);
		}
	}
	
	return count($errors)? $errors : false;
}



//check if a Visitor Phrase is protected
function checkIfPhraseIsProtected($languageId, $pluginClass, $phraseCode, $adding) {

	$sql = "
		SELECT 1
		FROM " . DB_NAME_PREFIX . "visitor_phrases
		WHERE language_id = '". mysql_real_escape_string($languageId). "'
		  AND plugin_class = '". mysql_real_escape_string($pluginClass). "'
		  AND code = '". mysql_real_escape_string($phraseCode). "'";
	
	//Are we adding a new VLP, or updating an existing one?
	//If we are editing an existing one, do not overwrite a protected phrase
	//If we are adding a new VLP, don't allow anything that already exists to be overwritten
	if (!$adding) {
		$sql .= "
		  AND protect_flag = 1";
	}
	
	return (bool) mysql_num_rows(my_mysql_query($sql));
}

//Update a Visitor Phrase from the importer
function importVisitorPhrase($languageId, $pluginClass, $phraseCode, $localText, $adding, &$numberOf) {
	
	//Don't attempt to add empty phrases
	if (!$phraseCode || $localText === null || $localText === false || $localText === '') {
		return;
	}
	
	//Check if the phrase is protected
	if (checkIfPhraseIsProtected($languageId, $pluginClass, $phraseCode, $adding)) {
		++$numberOf['protected'];
		
	} else {
		//Update or insert the phrase
		$sql = "
			REPLACE INTO " . DB_NAME_PREFIX . "visitor_phrases SET
				language_id = '". mysql_real_escape_string($languageId). "',
				plugin_class = '". mysql_real_escape_string($pluginClass). "',
				code = '". mysql_real_escape_string($phraseCode). "',
				local_text = '". mysql_real_escape_string(trim($localText)). "'";
		
		my_mysql_query($sql);
		
		//Check mysql_affected_rows to see if we added or updated a phrase, and log it
		if (mysql_affected_rows() == 1) {
			++$numberOf['added'];
		} elseif (mysql_affected_rows() == 2) {
			++$numberOf['updated'];
		}
	}

}


//Given an uploaded XML file, pharse that file looking for visitor language phrases
function importVisitorLanguagePack($file, &$languageId, $adding, $scanning = false, $forceLanguageIdOverride = false) {
	return require 'cmsincludes/admin/importVisitorLanguagePack.fun.php';
}


function scanPluginPhraseDir($pluginName, $scanMode = true) {
	$importFiles = array();
	if (is_dir($path = CMS_ROOT. 'plugins/'. $pluginName. '/phrases/')) {
		foreach (scandir($path) as $file) {
			if (is_file($path. $file)) {
				$numberOf = importVisitorLanguagePack($path. $file, $languageId, $adding = true, $scanMode);
				if (!$numberOf['upload_error']) {
					if ($scanMode === 'full scan') {
						$importFiles[$languageId] = $numberOf['added'];
					} else {
						$importFiles[$languageId] = $file;
					}
				}
			}
		}
	}
	
	return $importFiles;
}














//Functions for the database updater
define('RUN_EVERY_UPDATE', 'RUN_EVERY_UPDATE');

//Get an array containing the patch levels of all installed modules.
function getAllCurrentRevisionNumbers() {

	$modulesToRevisionNumbers = array();
	
	foreach (array('global', 'local') as $localOrGlobal) {
		if ($localOrGlobal == 'global') {
			//Switch to the global database to check the global updates
			if (defined('DO_LOCAL_UPDATES_ONLY')) {
				continue;
			
			} else {
				connectGlobalDB();
				$prefix = DB_NAME_PREFIX_GLOBAL. 'global';
			}
		
		} else {
			//Then switch the database back to local when done
			if (!defined('DO_LOCAL_UPDATES_ONLY')) {
				connectLocalDB();
			}
			
			$prefix = DB_NAME_PREFIX. 'local';
		}
	
		//Attempt to get all of the rows from the revision numbers table
		$sql = "
			SELECT path, patchfile, revision_no
			FROM ". $prefix. "_revision_numbers";
		
		//If we fail, rather than exist with an error message and crash the entire admin section,
		//just return that there are no updates
		if (!($result = @mysql_query($sql))) {
			if (!defined('DO_LOCAL_UPDATES_ONLY')) {
				connectLocalDB();
			}
			
			return $modulesToRevisionNumbers;
		}
		
		//Put all of the revision numbers we found into an array, and return it
		while ($row = mysql_fetch_assoc($result)) {
			$modulesToRevisionNumbers[$row['path']. '/'. $row['patchfile']] = $row['revision_no'];
		}
	}
	
	return $modulesToRevisionNumbers;
}

//Given a path to a directory - which should have two subdirectories (local and global), each of which with 
//patch files inside - this function scans the local or global sub-directories, looking for patch files or folders
function scanDBUpdateDirectoryForPatches($path) {

	$files = array();
	
	//Check the directory actually exists. It's not invalid if not; there might be
	//no db_updates of this type
	if (is_dir(CMS_ROOT. $path)) {
		//Look for the contents of the file
		foreach (scandir(CMS_ROOT. $path) as $file) {
			
			//A file called general.inc.php should be processed first, if it exists
			if ($file == 'general.inc.php') {
				array_unshift($files, $file);
			
			//Ignore directory listings, svn folders, other hidden files and latest_revision_no.inc.php
			} elseif (substr($file, 0, 1) == '.' || $file == 'general.inc.php' || $file == 'latest_revision_no.inc.php') {
				continue;
			
			//Ignore global files in local-only mode
			} elseif ($file == 'global.inc.php' && defined('DO_LOCAL_UPDATES_ONLY')) {
				continue;
			
			} else {
				$files[] = $file;
			}
		}
	}

	return $files;
}


//Work out every directory that might have patches in them, and get the latest
//revision number for each patch
function lookForDirectoriesWithPatchesInThem() {
	
	//Add in some patch file paths which should always be there
	$directoriesAndTheirRevisionNumbers = array(
	
		//Add in updates for the database updater itself
		'admin/db_updates/updater'	=> getLatestRevisionNumber(),
		
		//Add in updates for the Core CMS
		'admin/db_updates/core'		=> getLatestRevisionNumber(),
		
		//Refresh the permissions tables
		//These should be run every update
		'admin/db_updates/run_every_update'	=> RUN_EVERY_UPDATE,
		
		//Major updates may need table data converted to the correct format
		'admin/db_updates/data_conversion'	=> getLatestRevisionNumber()
	);
	
	//Check for plugin updates. Check which plugins we have in the database
	if ($plugins = getPlugins($onlyGetRunningPlugins = false, $ignoreUninstalledPlugins = true, $dbUpdateSafemode = true)) {
		foreach ($plugins as $plugin) {
			$path = $plugin['path']. 'db_updates/';
			
			//Check if the updates directory is there, and that the latest revision number file is there
			if (is_dir($path) && is_file($path. 'latest_revision_no.inc.php')) {
			 	
			 	//Get the latest revision number
			 	require_once $path. 'latest_revision_no.inc.php';
				
				//Include this plugin's updates if the PLUGIN_NAME_LATEST_REVISION_NO has been defined in latest_revision_no.inc.php.
				if (defined(pluginName($path). '_LATEST_REVISION_NO')) {
					$directoriesAndTheirRevisionNumbers['plugins/'. $plugin['name']. '/db_updates'] = constant(pluginName($path). '_LATEST_REVISION_NO');
				}
			}
			
			//Check if the admin tabs updates directory is there, and include it if so
			if (is_dir($path. 'run_every_update')) {
				$directoriesAndTheirRevisionNumbers['plugins/'. $plugin['name']. '/db_updates/run_every_update'] = RUN_EVERY_UPDATE;
			}
		}
	}
	
	return $directoriesAndTheirRevisionNumbers;
}


//Check the current revisions as recorded in the revision_numbers tables
//to see if database updates are needed from the updates directory
function checkIfDBUpdatesAreNeeded($andDoUpdates = false, $uninstallPluginOnFail = false, $quickCheckForUpdates = true, $localUpdatesOnly = false) {
	
	if ($localUpdatesOnly) {
		define('DO_LOCAL_UPDATES_ONLY', true);
	}

	//As part of the migration process, Plugins can be enabled, or Plugins can be switched for other Plugins
	//There's an issue where if this happens, and the new Plugin(s) need their own database updates, they won't get them
	//So as a workaround, for database updates, we'll loop round the main body of this function twice
	for ($i = 0; $i < ($andDoUpdates? 2 : 1); ++$i) {
		$revisionsNeeded = false;
		$currentRevisionOut = false;
		$plugins = array();
		
		//Query the database, get all of the current revision numbers
		$currentRevisions = getAllCurrentRevisionNumbers();
		
		//Get a list of patch directories, and their associated revision numbers
		foreach (lookForDirectoriesWithPatchesInThem() as $path => $latestRevisionNumber) {
		
			//Query the updates directories, see what's in it
			foreach (scanDBUpdateDirectoryForPatches($path) as $update) {
				if (is_file(CMS_ROOT. $path. '/'. $update)) {
					
					//Does this update not track revision numbers?
					if ($latestRevisionNumber === RUN_EVERY_UPDATE) {
						//If not, ignore when checking versions, and always run when running
						//the exporter
						if ($andDoUpdates) {
							performDBUpdate($path, $update, $uninstallPluginOnFail);
						}
					
					} else {
			
						//Get the lastest revision number applied from that update file
						$currentRevision = $currentRevisions[$path. '/'. $update]?
												$currentRevisions[$path. '/'. $update]
											:
												//If it's not listed, then assume no updates have happened
												//and set it to 0
												0;
						
						//Check whether the revision is up to date.
						if ($currentRevision < $latestRevisionNumber) {
							
							//If we are doing the updates, run performDBUpdate().
							if ($andDoUpdates) {
								performDBUpdate($path, $update, $uninstallPluginOnFail, $currentRevision, $latestRevisionNumber);
							
							//If we are only reporting then note down any needed updates.
							} else {
								//If we only need to know yes or no, then we can stop after the first one
								if ($quickCheckForUpdates) {
									return true;
								}
								
								$revisionsNeeded = true;
								//If this is a core update, note down the revision number details
								if (substr($path, 0, 6) == 'admin/') {
									//Try to be vaugely smart about which number we choose if the core numbers are different;
									//for preference we should pick the smallest non-zero number
									if (!$currentRevisionOut || ($currentRevision && $currentRevision < $currentRevisionOut)) {
										$currentRevisionOut = $currentRevision;
									}
								
								//If this is a Plugin update, note down which Plugin this is
								} elseif (substr($path, 0, 8) == 'plugins/') {
									$plugins[substr($path, 8, -11)] = array($currentRevision, $latestRevisionNumber);
								}
							}
						}
					}
				}
			}
		}
	}
	
	if (!$revisionsNeeded) {
		return $andDoUpdates? true : false;
	} else {
		return array($currentRevisionOut, $plugins);
	}
}


//Update the revision number for a module
function setModuleRevisionNumber($revisionNumber, $path, $updateFile) {
	
	//Ignore updates in some cases
	if ($revisionNumber === RUN_EVERY_UPDATE) {
		return;
	}
	
	//Any patch file named "global.inc.php" will be run on the global database; hence
	//we should use DB_NAME_PREFIX_GLOBAL prefix. Otherwise use DB_NAME_PREFIX for local tables
	if ($updateFile == 'global.inc.php') {
		$prefix = DB_NAME_PREFIX_GLOBAL. 'global';
	} else {
		$prefix = DB_NAME_PREFIX. 'local';
	}

	$sql = "
		REPLACE INTO  ". $prefix. "_revision_numbers SET
		  path = '". mysql_real_escape_string($path). "',
		  patchfile = '". mysql_real_escape_string($updateFile). "',
		  revision_no = ". (int) $revisionNumber;
	
	my_mysql_query($sql);
}


//Run a patch file, making the revisions needed
//If $currentRevision and $latestRevisionNumber are set, it will use revision control for updates;
//i.e. updates that have already been applied can be skipped
function performDBUpdate($path, $updateFile, $uninstallPluginOnFail, $currentRevision = RUN_EVERY_UPDATE, $latestRevisionNumber = RUN_EVERY_UPDATE) {
	
	//The extension, to see if this is an xml description for a plugin
	if (substr($updateFile, -4) == '.xml') {
		//Attempt to apply the XML file
		if (!setupPluginFromXMLDescription($path, $updateFile)) {
			exit;
		}
		
		//If this is an installed Plugin, update any content types settings too
		if (!$uninstallPluginOnFail) {
			setupPluginContentTypesFromXMLDescription($path, $updateFile);
		}
	
	//Otherwise assume the file will be a php file with a series of revisions
	} else {
		//Set the inputs into global variables, so we can remember them for this revision
		//without needing to add extra parameters to every function (which would make the update files look messy!)
		global $_path;
		global $_updateFile;
		global $_currentRevision;
		global $_uninstallPluginOnFail;
		$_path = $path;
		$_updateFile = $updateFile;
		$_currentRevision = $currentRevision;
		$_uninstallPluginOnFail = $uninstallPluginOnFail;
		
		//Any patch file named "global.inc.php" should be run on the global database.
		//Connect to the global database if the patch file has this name
		if ($updateFile == 'global.inc.php') {
			if (defined('DO_LOCAL_UPDATES_ONLY')) {
				return;
			} else {
				connectGlobalDB();
			}
		}
		
		//Run the update file
		require_once CMS_ROOT. $path. '/'. $updateFile;
	}
	
	//Update the current revision in the database to the latest, so this will not be triggered again.
	setModuleRevisionNumber($latestRevisionNumber, $path, $updateFile);
	
	//Go back to the local database if needed
	if ($updateFile == 'global.inc.php') {
		connectLocalDB();
	}
}

function needRevision($revisionNumber) {

	global $_path;
	global $_updateFile;
	global $_currentRevision;
	global $_uninstallPluginOnFail;
	
	//Check the latest revision number, and if we have applied this revision yet
	//If we have already applied the revision, we can stop without processing it any further
	
	//Note that there is functionality to override this and always apply a revision!
	if ($_currentRevision !== RUN_EVERY_UPDATE
	 && $revisionNumber <= $_currentRevision) {
		return false;
	} else {
		return true;
	}
}

//This function is used for database revisions. It's called from the patch files.
//WARNING: It expects to already be connected to the correct database, and to have
//the $_path, $_updateFile and $_currentRevision global variables set
function revision($revisionNumber) {

	global $_path;
	global $_updateFile;
	global $_currentRevision;
	global $_uninstallPluginOnFail;
	
	//The first arguement to this function should be the revision number.
	//All remaining arguements will be the SQL statements for that revision.
	
	//Check the latest revision number, and if we have applied this revision yet
	//If we have already applied the revision, we can stop without processing it any further
	
	//Note that there is functionality to override this and always apply a revision!
	if (!needRevision($revisionNumber)) {
		return;
	}
	//If the above wasn't true, then we'll need to apply the update
	
	
	//Loop through all of the arguments given after the first
	$i = 1;
	$count = func_num_args();
	while ($i < $count && ($sql = func_get_arg($i++))) {
		
		//Run the SQL, using str_replace to subsitute in the values of DB_NAME_PREFIX or DB_NAME_PREFIX_GLOBAL
		//Any patch file named "global.inc.php" will be run on the global database; hence
		//we should use DB_NAME_PREFIX_GLOBAL prefix. Otherwise use DB_NAME_PREFIX for local tables
		if ($_updateFile == 'global.inc.php') {
			//Only use DB_NAME_PREFIX_GLOBAL for the global database
			$result = @mysql_query(str_replace('[[DB_NAME_PREFIX_GLOBAL]]', DB_NAME_PREFIX_GLOBAL, $sql));
		} else {
			$sql = addConstantsToString($sql, false);
			$result = @mysql_query($sql);
		}
		
		//Handle errors
		if ($result === false) {
			$errNo = mysql_errno();
			
			//Ignore "column already exists" errors
			if ($errNo == 1060) {
				continue;
			
			//Ignore "primary key already exists" errors
			} elseif ($errNo == 1068) {
				continue;
			
			//Ignore errors if we try to drop columns or unique keys that do not exist
			} elseif ($errNo == 1091) {
				continue;
			
			//Ignore "Table doesn't exist" and "Table already exists" error messages when renaming tables
			} elseif (($errNo == 1146 || $errNo == 1050) && preg_match('/\s*ALTER\s*TABLE\s*\S*\s*RENAME\s*TO\s*\S*\s*/i', $sql)) {
				continue;
			
			//Ignore "Table already created" error messages
			} elseif ($errNo == 1050 && preg_match('/\s*CREATE\s*TABLE\s*/i', $sql)) {
				continue;
			}
			
			
			//Otherwise we can't recover from this error
			
			//Report the error
			echo "Database query error: ".mysql_errno().", ".mysql_error().", $sql";
			
			//If this was the installation of a Plugin, then remove everything that the Plugin has installed
			if ($_uninstallPluginOnFail) {
				uninstallPlugin($_uninstallPluginOnFail);
			}
			
			//Stop
			exit;
		}
	}
	
	//Update the revision number for this module, or set it if it was not there.
	//I'm doing this with each revision, just in case we get an error in one
	//- the previous revisions won't be applied.
	if ($revisionNumber && $_currentRevision !== RUN_EVERY_UPDATE) {
		setModuleRevisionNumber($revisionNumber, $_path, $_updateFile);
	}
}



function validatePluginFromXMLDescription($path, $updateFile, &$pluginName, &$pluginId, &$desc, $suppressErrors = false) {
	
	//The path will be of the form 
	//	plugins/'. $plugin['name']. '/db_updates
	//Get the plugin's directory name from the path!
	$pluginName = substr($path, 8, -11);
	
	//Check if this plugin has been registered as installed in the database
	if (!$pluginId = getPluginId($pluginName)) {
		if (!$suppressErrors) {
			echo 'Error - plugin &quot;' . $pluginName . '&quot;not registered';
		}
		return false;
	}
	
	//Attempt to open and read the XML description
	try {
		if (!$desc = SimpleXML(CMS_ROOT. $path. '/'. $updateFile)) {
			if (!$suppressErrors) {
				echo $path. '/'. $updateFile. ' could not be loaded.';
			}
			return false;
		}
	} catch (Exception $e) {
		if (!$suppressErrors) {
			echo $path. '/'. $updateFile. ' appears to be in the wrong format or invalid: ',  $e->getMessage();
		}
		return false;
	}
	
	if (!$desc->display_name) {
		if (!$suppressErrors) {
			echo 'Missing display name from '. $path. '/'. $updateFile;
		}
		return false;
	}
	
	if (!$desc->class_name) {
		if (!$suppressErrors) {
			echo 'Missing class name from '. $path. '/'. $updateFile;
		}
		return false;
	}
	
	if (substr($pluginName, 0, strlen($desc->class_name)) != $desc->class_name) {
		if (!$suppressErrors) {
			echo 'The class name in '. $path. '/'. $updateFile. ' does not match the directory path';
		}
		return false;
	}
	
	return true;
}

//Get the XML description of a plugin, and apply it
function setupPluginFromXMLDescription($path, $updateFile) {
	return require 'cmsincludes/admin/setupPluginFromXMLDescription.fun.php';
}

//Repeated code from the function above
function setupPluginStorekeeperAction(&$sql, &$desc, &$action) {
	
	$sql .= ",
						action_type = '". mysql_real_escape_string(str_replace('floating_box', 'thickbox', (string) $action->type)). "',
						request = '". mysql_real_escape_string($action->request). "'";
	
	if ($action->type == 'ajax') {
		$sql .= ",
						confirm_button_msg = '". mysql_real_escape_string($action->confirm_button_msg). "',
						is_warning_msg = ". engToBoolean($action->is_warning_msg);
	
	} elseif ($action->type == 'ajax_with_confirmation') {
		$sql .= ",
						confirm_msg = '". mysql_real_escape_string($action->confirm_msg). "',
						confirm_button_msg = '". mysql_real_escape_string($action->confirm_button_msg). "',
						cancel_button_msg = '". mysql_real_escape_string($action->cancel_button_msg). "',
						is_warning_msg = ". engToBoolean($action->is_warning_msg);
	
	} elseif ($action->type == 'ajax_with_submit' || $action->type == 'ajax_with_form') {
		$sql .= ",
						confirm_button_msg = '". mysql_real_escape_string($action->confirm_button_msg). "',
						cancel_button_msg = '". mysql_real_escape_string($action->cancel_button_msg). "',
						is_warning_msg = ". engToBoolean($action->is_warning_msg);
		
	} elseif ($action->type == 'change_panel') {
		$sql .= ",
						view_mode = '". mysql_real_escape_string($action->view_mode). "',
						dest_class_name = '". mysql_real_escape_string(ifNull((string) $action->dest_class_name, $desc->class_name)). "',
						dest_panel_name = '". mysql_real_escape_string($action->dest_panel_name). "',
						dynamic_load = ". engToBoolean($action->dynamic_load);
		
	} elseif ($action->type == 'floating_box') {
		$sql .= ",
						dest_class_name = '". mysql_real_escape_string(ifNull((string) $action->dest_class_name, $desc->class_name)). "',
						dest_thickbox_name = '". mysql_real_escape_string($action->dest_floating_box_name). "'";
		
	}
}

//Set up the Content Types of a Plugin
function setupPluginContentTypesFromXMLDescription($path, $updateFile) {
	
	if (!validatePluginFromXMLDescription($path, $updateFile, $pluginName, $pluginId, $desc)) {
		return false;
	}
	
	//Add/update any content types
	if ($desc->content_types) {
		if ($desc->content_types->content_type) {
			foreach($desc->content_types->content_type as $type) {
				$sql = "
					INSERT INTO ". DB_NAME_PREFIX. "contenttypes SET
						content_type_id = '". mysql_real_escape_string($type->content_type_id). "',
						content_type_name_en = '". mysql_real_escape_string($type->content_type_name_en). "',
						tag_prefix = '". mysql_real_escape_string($type->tag_prefix). "',
						show_pub_date = ". engToBoolean($type->show_pub_date). ",
						plugin_id = ". (int) $pluginId. "
					ON DUPLICATE KEY UPDATE
						tag_prefix = '". mysql_real_escape_string($type->tag_prefix). "',
						show_pub_date = ". engToBoolean($type->show_pub_date). ",
						plugin_id = ". (int) $pluginId;
				my_mysql_query($sql);
				
				if ($type->settings) {
					if ($type->settings->setting) {
						foreach($type->settings->setting as $setting) {
							$sql = "
								INSERT INTO ". DB_NAME_PREFIX. "contenttype_settings SET
									content_type_id = '". mysql_real_escape_string($type->content_type_id). "',
									`name` = '". mysql_real_escape_string($setting->name). "',
									`value` = '". mysql_real_escape_string($setting->default_value). "',
									`type` = '". mysql_real_escape_string($setting->type). "',
									ordinal = ". (int) $setting->ordinal. "
								ON DUPLICATE KEY UPDATE
									`type` = '". mysql_real_escape_string($setting->type). "',
									ordinal = ". (int) $setting->ordinal;
							my_mysql_query($sql);
						}
					}
				}
			}
		}
	}
}

//Read the dependancies of a Plugin from an XML description
function getPluginSignalHandlersFromXMLDescription($path, $updateFile, &$signals) {
	
	$signals = array();

	
	if (!validatePluginFromXMLDescription($path, $updateFile, $pluginName, $pluginId, $desc)) {
		return false;
	}

	if ($desc->signals){
		if ($desc->signals->signal) {
			foreach($desc->signals->signal as $signal) {
				$signals[(string) $signal->name] = $signal->name;
			}
		}
	}
	
	return true;
}

//Read the dependancies of a Plugin from an XML description
function getPluginDependenciesFromXMLDescription($path, $updateFile, &$dependencies, &$compatibilities) {
	
	$dependencies = array();
	$compatibilities = array();
	
	if (!validatePluginFromXMLDescription($path, $updateFile, $pluginName, $pluginId, $desc)) {
		return false;
	}
	
	//Record any dependencies
	if ($desc->dependencies) {
		if ($desc->dependencies->plugin) {
			foreach($desc->dependencies->plugin as $dependency) {
				$dependencies[(string) $dependency] = $dependency;
			}
		}
	}
	
	if ($desc->inheritance) {
		if ($desc->inheritance->plugin) {
			foreach($desc->inheritance->plugin as $inheritance) {
				$dependencies[(string) $inheritance] = $inheritance;
			}
		}
	}
	
	if ($desc->compatibility) {
		if ($desc->compatibility->plugin) {
			foreach($desc->compatibility->plugin as $compatibility) {
				$compatibilities[(string) $compatibility] = $compatibility;
			}
		}
	}
	
	return true;
}

//Read the pagination-types of a Plugin from an XML description
function getPluginPaginationTypesFromXMLDescription($path, $updateFile, &$paginationTypes) {
	
	$paginationTypes = array();
	
	if (!validatePluginFromXMLDescription($path, $updateFile, $pluginName, $pluginId, $desc)) {
		return false;
	}
	
	$className = $desc->class_name;
	
	//Record any dependencies
	if ($desc->pagination_types) {
		if ($desc->pagination_types->pagination_type) {
			foreach($desc->pagination_types->pagination_type as $pagination_type) {
				if ($pagination_type->function_name && $pagination_type->label) {
					$paginationTypes[$className. '::'. (string) $pagination_type->function_name] = getPhrase($pagination_type->label);
				}
			}
		}
	}
	
	return true;
}

//Read the get-requests of a Plugin from an XML description
function getPluginMenuGetRequestsFromXMLDescription($path, $updateFile, &$menuGetRequests) {
	
	$menuGetRequests = array();
	
	if (!validatePluginFromXMLDescription($path, $updateFile, $pluginName, $pluginId, $desc)) {
		return false;
	}
	
	$className = $desc->class_name;
	
	//Record any dependencies
	if ($desc->menu_get_requests) {
		if ($desc->menu_get_requests->request) {
			foreach($desc->menu_get_requests->request as $request) {
				if ($request->string && $request->label) {
					$menuGetRequests[(string) $request->string] = getPhrase($request->label);
				}
			}
		}
	}
	
	return true;
}

//Load a license from tribiq.com
function getTribiqLicense($license) {
	$xml = $error = false;
	if (SimpleXMLCURL('http://tribiq.com/stores.xml', $xml, $error)) {
		if ($xml->licenses && $xml->licenses->url) {
			$url = (string) $xml->licenses->url;
			unset($xml);
			
			if (SimpleXMLCURL($url. rawurlencode($license), $xml, $error)) {
				if ($xml->items) {
					foreach ($xml->items->children() as $item) {
						if ($license == (string) $item->name) {
							return array('summary' => (string) $item->summary, 'text' => (string) $item->text);
						}
					}
				}
			}
		}
	}
	
	return false;
}


function getPluginInstanceUsageStorekeeperDeepLink($instanceId, $pluginId = false) {
	
	if (!$pluginId) {
		$instance = getPluginInstanceDetails($instanceId);
		$pluginId = $instance['plugin_id'];
	}
	
	return httpOrHttps(). httpHost(). SUBDIRECTORY. 'admin/storekeeper.php#'.
			'tribiq__plugins/view_instances//'. (int) $pluginId. '//view_content_items//'. (int) $instanceId. '//';
}


/* CMS feeds */

function getFeedDateTimestamp ($datetime) {
	$sql = "SELECT IF(
						DATEDIFF(NOW(),'" . $datetime . "')<1,
						IF (
							HOUR(TIMEDIFF(NOW(),'" . $datetime . "'))<1,
							IF (
								MINUTE(TIMEDIFF(NOW(),'" . $datetime . "'))<2,
								' <2 mins ago',
								CONCAT(MINUTE(TIMEDIFF(NOW(),'" . $datetime . "')),' mins ago')
							),
							IF (
								HOUR(TIMEDIFF(NOW(),'" . $datetime . "'))<2,
								' 1 hr ago',
								CONCAT(HOUR(TIMEDIFF(NOW(),'" . $datetime . "')),' hrs ago')
							)
						),
						IF (
							DATEDIFF(NOW(),'" . $datetime . "')<4,
							IF (
								DATEDIFF(NOW(),'" . $datetime . "')<2,
								' 1 day ago',
								CONCAT(DATEDIFF(NOW(),'" . $datetime . "'),' days ago')
							),
							DATE_FORMAT('" . $datetime . "','%D %b')
						)
				)";

	$result = my_mysql_query($sql);
	
	$row = mysql_fetch_array($result);

	return $row[0];
}


function getItemIconClass($cID, $cType, $cVersion = false, $status = false, $alias = false, $language = false, $homepage = -1) {
	
	if ($cVersion === false) {
		$cVersion = getLatestVersion($cID, $cType);
	}
	
	if ($status === false) {
		$status = getContentStatus($cID, $cType, $cVersion);
	}
	
	if ($homepage === -1) {
		$homepage = false;
		if ($cType == 'html') {
			if ($language === false) {
				$language = getContentLang($cID, $cType, $cVersion);
			}
			
			$homepage = $cID == getLanguageDefaultHomepage($language) || $cID == getSiteConfig('default_homepage_id');
		}
	}
	
	
	if ($status=='private_draft' && $cVersion==1) {
		if ($homepage) {
			return 'home_content_draft';
		} else {
			return 'content_draft';
		}
	} elseif ($status=='private_draft' && $cVersion>1) {
		$lastItemStatus = getContentStatus($cID, $cType, $cVersion-1);
		if ($lastItemStatus=='published' && $homepage) {
			return 'home_content_draft_published';
		} elseif ($lastItemStatus=='published') {
			return 'content_draft_published';
		} elseif ($lastItemStatus=='hidden') {
			return 'content_draft_hidden';
		} elseif ($lastItemStatus=='archived') {
			return 'content_draft_trashed';
		}
	} elseif ($status=='published' && $homepage) {
		return 'home_content_published';
	} elseif ($status=='published') {
		return 'content_published';
	} elseif ($status=='hidden') {
		return 'content_hidden';
	} elseif ($status=='archived') {
		return 'content_trashed';
	}
	
	return '';
}


function setContentItemStorekeeperDetails(&$contentItem, $contentType, $appendVersion = true) {
			
	if ($contentType=="html") {
		if (strlen($contentItem['alias'])>13) {
			$contentItem['short_alias'] = substr($contentItem['alias'],0,13) . "...";
			$contentItem['tooltip'] = $contentItem['alias'];
		} else {
			$contentItem['short_alias'] = $contentItem['alias'];
			$contentItem['tooltip'] = "";
		}
	} else {
		if (strlen($contentItem['title'])>13) {
			$contentItem['short_title'] = mb_substr($contentItem['title'],0,13,'UTF-8') . "...";
			$contentItem['tooltip'] = $contentItem['title'];
		} else {
			$contentItem['short_title'] = $contentItem['title'];
			$contentItem['tooltip'] = "";
		}			
	}
	
	$currentTitle = formatTag($contentItem['id'], $contentType, $contentItem['title'], $contentItem['alias'], getSiteConfig('content_tag_zerofill'), 45, false);
	$i = strpos( $currentTitle, ' ' );
	
	$contentItem['tag'] = $currentTitle;

	if ($contentType=="html") {
		$contentItem['displayTitle']  = mb_substr( $currentTitle, 0, $i,'UTF-8') . "<br />" . $contentItem['short_alias'];
	} else {
		$contentItem['displayTitle']  = mb_substr( $currentTitle, 0, $i,'UTF-8') . "<br />" . $contentItem['short_title'];
	}
	
	if ($appendVersion) {
		$contentItem['displayTitle'] .= "<br/>" . getPhrase( "_VERSION" ) . " " . $contentItem['version'];
	}

}








//Functions for site backups and restores


function initialiseBackupFunctions($includeWarnings = false) {
	
	$errors = array();
	$warnings = array();
	
	//Check the docstore directory is correctly defined, exists, and has the correct permissions
	if (!defined('CMS_DOCSTORE_DIR')) {
		$errors[] = getPhrase('_NOT_DEFINED_DOCSTORE_DIR'). '<br />'. getPhrase('_FIX_DOCSTORE_DIR_TO_BACKUP');
	
	} else {
		//$docpath = CMS_DOCSTORE_DIR. '/'. SITENAME;
		
		//if (!file_exists($docpath)) {
			//$mrg = array('dirpath' => $docpath);
			//$errors[] = getPhrase('_FIX_DOCSTORE_DIR_TO_BACKUP'). '<br />'. getPhrase('_DIRECTORY_DOES_NOT_EXIST', $mrg);
		
		//} elseif (!is_readable($docpath) || !is_writeable($docpath)) {
			//$mrg = array('dirpath' => $docpath);
			//$errors[] = getPhrase('_FIX_DOCSTORE_DIR_TO_BACKUP'). '<br />'. getPhrase('_DIRECTORY_NOT_READ_AND_WRITEABLE', $mrg);
		//}
	}
	
	//Check the backup directory is correctly defined, exists, and has the correct permissions
	if (!defined('CMS_BACKUP_DIR')) {
		$errors[] = getPhrase('_NOT_DEFINED_BACKUP_DIR');
	
	} else {
		$dirpath = CMS_BACKUP_DIR. '/'. SITENAME;
		
		if (!file_exists($dirpath)) {
			$mrg = array('dirpath' => $dirpath);
			$errors[] = getPhrase('_DIRECTORY_DOES_NOT_EXIST', $mrg);
		
		} elseif (!is_readable($dirpath) || !is_writeable($dirpath)) {
			$mrg = array('dirpath' => $dirpath);
			$errors[] = getPhrase('_DIRECTORY_NOT_READ_AND_WRITEABLE', $mrg);
		}
	}
	
	//Check if there are any admins with management rights in the database
	$sql = "
		SELECT 1
		FROM ". DB_NAME_PREFIX. "admins AS a
		INNER JOIN ". DB_NAME_PREFIX. "action_admin_link AS aal
		   ON aal.admin_id = a.id
		WHERE a.status = 'active'
		  AND aal.action_name = '_PRIV_EDIT_ADMIN'
		LIMIT 1";
	
	$result = my_mysql_query($sql);
	if (!mysql_fetch_row($result)) {
		$warnings[] = getPhrase('_NO_ADMINS_TO_BACKUP');
	}
	
	//Check if there are any admins with publisher/update database rights in the database
	$sql = "
		SELECT 1
		FROM ". DB_NAME_PREFIX. "admins AS a
		INNER JOIN ". DB_NAME_PREFIX. "action_admin_link AS aal
		   ON aal.admin_id = a.id
		WHERE a.status = 'active'
		  AND aal.action_name = '_PRIV_UPDATE_DATABASE'
		LIMIT 1";
	
	$result = my_mysql_query($sql);
	if (!mysql_fetch_row($result)) {
		$warnings[] = getPhrase('There are no Local Administrators for this site with Publisher rights. We recommend you create one before taking a backup.');
	}
	
	
	if ($includeWarnings) {
		$errors = array_merge($errors, $warnings);
	}
	
	return count($errors)? $errors : false;

}


function generateFilenameForBackups() {
	//Get the current date and time, and create a filename with that timestamp
	$sql = "SELECT DATE_FORMAT(NOW(), '%Y-%m-%d-%H.%i')";
	$result = my_mysql_query($sql);
	$row = mysql_fetch_row($result);
	return SITENAME ."-backup-". $row[0]. '-r'. getLatestRevisionNumber(). '.sql.gz';
}


//Look up the name of every table in the database which matches a certain pattern,
//and return them in an array.
//We're interested in returning tables with the patten:
	//PREFIX - i_m_p_ - table_name
function lookupImportedTables($refiner) {
	
	$refiner .= 'i_m_p_';
	
	$prefixLength = strlen($refiner);

	$importedTables = array();
	$sql = "SHOW TABLES";
	$result = my_mysql_query($sql);
	
	while($row = mysql_fetch_row($result)) {
		if ($refiner === false || substr($row[0], 0, $prefixLength) === $refiner) {
			$importedTables[] = $row[0];
		}
	}
	
	return $importedTables;
}

//Look up the name of every CMS table in the database, and return them in an array.
function lookupExistingCMSTables() {
	
	$prefixLength = strlen(DB_NAME_PREFIX);
	$globalPrefixLength = strlen(DB_NAME_PREFIX_GLOBAL);

	$existingTables = array();
	$sql = "SHOW TABLES";
	$result = my_mysql_query($sql);
	
	while($row = mysql_fetch_row($result)) {
		//Check whether this table matches the global or the local prefix
		$matchesLocal = substr($row[0], 0, $prefixLength) === DB_NAME_PREFIX;
		$matchesGlobal = substr($row[0], 0, $globalPrefixLength) === DB_NAME_PREFIX_GLOBAL;
		
		//If we get no matches, we're not interested
		if (!$matchesLocal && !$matchesGlobal) {
			continue;
		}
		
		//If we get both matches, try to sort out which is the real one by going
		//with the longer prefix match if possible
		if ($matchesLocal && $matchesGlobal) {
			if ($prefixLength < $globalPrefixLength) {
				$matchesLocal = false;
				
			} elseif ($prefixLength > $globalPrefixLength) {
				$matchesGlobal = false;
			}
		}
		
		//Strip the prefix off of the tablename
		if ($matchesLocal) {
			$tableName = substr($row[0], $prefixLength);
		} else {
			$tableName = substr($row[0], $globalPrefixLength);
		}
		
		//Are we still unsure if this is global or local? If so, best approach we can do
		//is just look at a hardcoded list.
		if ($matchesLocal && $matchesGlobal) {
			if ($tableName == 'action_superadmin_link'
			 || $tableName == 'actions'
			 || $tableName == 'admin_languages'
			 || $tableName == 'admin_phrases'
			 || $tableName == 'global_revision_numbers'
			 || $tableName == 'public_urls'
			 || $tableName == 'roles'
			 || $tableName == 'site_registry'
			 || $tableName == 'spare_urls'
			 || $tableName == 'superadmins'
			 || $tableName == 'url_alias_redirects'

			) {
				$matchesLocal = false;
				
			} else {
				$matchesGlobal = false;
			}
		}
		
		//Work out the correct prefix
			//DB_NAME_PREFIX - Tables in the local database
			//DB_NAME_PREFIX_GLOBAL - Single-site tables that would be in the global database in multisite
			//GLOBAL_NOT_NORMALLY_RESTORED - public_urls and site_registry tables
				//There would be no point in restoring the public_urls or site_registry tables; if they
				//weren't set up correctly then you wouldn't be able to get to this page and run the backup
				//in the first place, and if the restore broke them then you could break your site!
				//However I still want to put them in the backup, to help phpMyAdmin users
		if ($tableName == 'public_urls'
		 || $tableName == 'site_registry'
		) {
			$prefix = 'GLOBAL_NOT_NORMALLY_RESTORED';
		} elseif ($matchesGlobal) {
			$prefix = 'DB_NAME_PREFIX_GLOBAL';
		} else {
			$prefix = 'DB_NAME_PREFIX';
		}
		
		//Mark anything that begins with v_ as a view
		if (substr($tableName, 0, 2) == 'v_' || preg_match('/plg\d*_v_/', $tableName)) {
			$view = true;
		} else {
			$view = false;
		}
		
		//A few tables should be dropped by the "reset site" feature; mark these
		if ($view) {
			//Ignore views
			$reset = 'no';
		
		} else if (substr($tableName, 0, 3) == 'plg') {
			//Any plugin tables should be just dropped
			$reset = 'drop';
		
		} else {
			//Any other tables should be ignored
			$reset = 'no';
		}
		
		
		//Add the table to our list
		$existingTables[] = array(
			'name' => $tableName,
			'actual_name' => $row[0],
			'global' => $matchesGlobal,
			'prefix' => $prefix,
			'reset' => $reset,
			'view' => $view);
	}
	
	return $existingTables;
}

define('SITENAME_SUB_STRING', '.[[SITENAME]].');

function docstoreDirectoryPath($path) {
	return CMS_DOCSTORE_DIR. '/'. str_replace(SITENAME_SUB_STRING, SITENAME, $path);
}

//Scan and Write the Docstore Directory
function writeDocstoreDirectory(&$gzFile, $dir = SITENAME_SUB_STRING) {
	
	//Scan the current directory
	foreach (scandir(docstoreDirectoryPath($dir)) as $name) {
		$part = $dir. '/'. $name;
		
		if ($name != '.' && $name != '..') {
			//If we find a directory, write it down then scan it too.
			if (is_dir(docstoreDirectoryPath($part))) {
				gzwrite($gzFile, "DIR;\n". $part. ";\n");
				writeDocstoreDirectory($gzFile, $part);
			
			//If we find a file, write down it's name and path, then write down
			//its contents (in hexadecimal)
			} elseif (is_file(docstoreDirectoryPath($part))) {
				gzwrite($gzFile, "FILE;\n". $part. ";\n");
				
				$f = fopen(docstoreDirectoryPath($part), 'rb');
				while ($chunk = fread($f, 1000)) {
					gzwrite($gzFile, bin2hex($chunk));
				}
				fclose($f);
				
				gzwrite($gzFile, ";\n");
			}
		}
	}

}




//Start a new SQL statement if we see the statement that we are working on get longer than this:
define('MYSQL_CHUNK_SIZE', 3000);

//Create a backup of the database
function createDatabaseBackupScript(&$gzFile) {
	
	set_time_limit(60 * 10);

	//Loop through every table beginning with the DB_NAME_PREFIX
	foreach(lookupExistingCMSTables() as $table) {
		
		//If multisite then make sure we don't include any multisite tables!
		if (checkModuleReady('multisite.inc.php') && $table['global']) {
			continue;
		}
			
		//Remove the DB_NAME_PREFIX, and add [['DB_NAME_PREFIX']] in its place.
			//This pattern should never occur in a normal mysql statement, so it will be safe to
			//do a search and replace on this later!
		$importTable = "[['". $table['prefix']. "']]". $table['name'];
	
		
		//Attempt to get the create table script for the current table
		$sql = 'SHOW CREATE TABLE `'. $table['actual_name'] . '`';
		
		//This may fail if for some reason we don't have the correct permisions to look at a
		//create statement for the table/view.
		//(For example, this is a view and the current user has no rights to see views)
		//Ignore it if so!
		if (!($result = @mysql_query($sql))) {
			continue;
		}
		
		$createTable = mysql_fetch_assoc($result);
		
		//Check if this is a view and not a table - ignore it if so!
		if ($table['view'] || !$createTable['Create Table']) {
			continue;
		}
		
		$createTable = str_replace('`'. $table['actual_name']. '`', '`'. $importTable. '`', $createTable['Create Table']);
		
		//Get details on each column in the current table
		$sql = 'SHOW COLUMNS FROM `'. $table['actual_name']. '`';
		$result = my_mysql_query($sql);
		$columns = array();
		
		//Loop through each of them, getting their name and type
		while($column = mysql_fetch_assoc($result)) {
			$columns[$column['Field']] = $column;
		}
		
		//Generate a list of the columns
		$columnList = '';
		foreach($columns as $column => $details) {
			$columnList .= ($columnList? ', ' :null). '`'. $column. '`';
		}
		
		//Prepare the start of an insert statement for that table
		$insertInto = 'INSERT INTO `'. $importTable. '` ('. $columnList. ') VALUES';
	
		//Start generating the backup script for this table. Add a drop table if exists statement
		$inserts = 'DROP TABLE IF EXISTS `'. $importTable. '`;'.
			
			"\n\n".
			
			//Add the create table statement
			$createTable. ';'.
			
			"\n\n".
			
			//Disable indexs for faster inserting
			'ALTER TABLE `'. $importTable. '` DISABLE KEYS;'.
			
			"\n";
		
		gzwrite($gzFile, $inserts);
		
		//Run a SQL statement to get all of the information out of the table
		$sql = "
			SELECT ". $columnList. "
			FROM `". $table['actual_name']. "`
			ORDER BY 1";
		$result = my_mysql_query($sql);
		
		//Start building insert statements
		$inserts = '';
		//Loop through each row
		while($row = mysql_fetch_assoc($result)) {
			
			//Group the insert statement for this row together with the previous statements if possible.
			//Otherwise start a new insert statement
			if ($inserts == '') {
				$inserts = "\n". $insertInto. "\n(";
			} else {
				$inserts .= ",\n(";
			}
			
			//List the values for this row
			$comma = false;
			foreach($columns as $column => $details) {
				
				$value = $row[$column];
				$isBinary = strrpos($details['Type'], 'blob') !== false;
			
				$inserts .= $comma? ',' :null;
				
				//Attempt to fix some MySQL strict problems
				if (($value === NULL && $details['NULL'] == 'NO')
				 || ($value === '' && substr($details['Type'], 0, 4) == 'enum' && strpos($details['Type'], "''") === false)) {
					$value = $details['Default'];
				}
				
				//Write the value carfully.
				//If it is null, just write NULL
				if ($value === NULL) {
					$inserts .= 'NULL';
				
				//Otherwise if it is an empty string, write an empty string.
				} elseif ($value === '') {
					$inserts .= "''";
				
				//If the two if statements above didn't trigger, we know our value is not empty
				//If this is a binary column, convert it to hexadecimal to write it down
				//} elseif ($isBinary) {
					//$inserts .= '0x' . bin2hex($value);
				
				//If this is a number, we can write it as it is without quotes or escaping
				} elseif (is_numeric($value) && $value != '') {
					$inserts .= $value;
				
				//Otherwise, write the value quoted and escaped
				} else {
					$inserts .= "'". mysql_real_escape_string($value). "'";
				}
				
				$comma = true;
			}
			
			//If the length of the insert statement looks like it's getting even remotely close to  our maximum read size,
			//don't add any more and write the insert statement
			//Otherwise allow the next statement to be added onto this one
			if (strlen($inserts) < MYSQL_CHUNK_SIZE) {
				$inserts .= ')';
			} else {
				$inserts .= ');';
				gzwrite($gzFile, $inserts);
				$inserts = '';
			}
		}
		
		//After finishing with the tables, write any insert statements not yet written
		if ($inserts != '') {
			$inserts .= ';';
			gzwrite($gzFile, $inserts);
			$inserts = '';
		}
		
		
		$inserts = "\n\n".
			
			//Enable keys again
			'ALTER TABLE `'. $importTable. '` ENABLE KEYS;'.
			
			"\n\n\n";
		
		gzwrite($gzFile, $inserts);
	}
		
	$inserts = "\n\n\n\n\n;\nEND OF SQL;\n";
	
	gzwrite($gzFile, $inserts);
	
	//$docpath = CMS_DOCSTORE_DIR. '/'. SITENAME;
	//if (!is_readable($docpath) || !is_writeable($docpath)) {
		//$docpath = false;
	//}
		//writeDocstoreDirectory($gzFile);
	//}
	
}





//Reverse of the function bin2hex; converts hexadecimal back to binary
function hex2bin($hex) {
	return pack('H*', $hex);
}

//Define some constants to make the states clearer below
define ('NEXTPLEASE', 1);
define ('CREATEDIR', 2);
define ('FILENAME', 3);
define ('FILECONTENTS', 4);

define ('READ_BACKUP_CHUNK_SIZE', 10000);

//Given a backup, restore the database from it
function restoreDatabaseFromBackup($filename, $plainSql, $prefix, &$failures) {
	return require 'cmsincludes/admin/restoreDatabaseFromBackup.fun.php';
}


//Reset a site, putting all of its tables back to an innitial state
function resetSite(&$error) {
	
	//Delete all Plugin tables
	foreach (lookupExistingCMSTables() as $table) {
		if ($table['reset'] == 'drop') {
			$sql = "DROP TABLE `". $table['actual_name']. "`";
			my_mysql_query($sql);
		}
	}
	
	//look up the revision numbers of the admin tables from the local_revision_numbers table
	$sql = "
		SELECT `path`, revision_no
		FROM ". DB_NAME_PREFIX. "local_revision_numbers
		where patchfile = 'admin.inc.php'";
	$revisions = array();
	$result = my_mysql_query($sql);
	while ($row = mysql_fetch_assoc($result)) {
		$revisions[] = $row;
	}
	
	//Rerun some of the scripts from the installer to give us a blank site
	require_once CMS_ROOT. 'cmsincludes/welcome.inc.php';
	(runSQL(false, 'local-CREATE.sql', $error)) &&
	(runSQL(false, 'local-INSERT.sql', $error)) &&
	(runSQL(false, 'local-BUILD.sql', $error));
	
	//Add the admin-related revision numbers back in
	foreach ($revisions as &$revision) {
		$sql = "
			REPLACE INTO ". DB_NAME_PREFIX. "local_revision_numbers SET
				patchfile = 'admin.inc.php',
				`path` = '". mysql_real_escape_string($revision['path']). "',
				revision_no = ". (int) $revision['revision_no'];
		my_mysql_query($sql);
	}
	
	
	return !$error;	
}
















function deleteImage($id) {
	$sql = "DELETE 
			FROM " . DB_NAME_PREFIX . "images
			WHERE id = " . (int) $id;
			
	$result = my_mysql_query($sql);
}

function deleteImageByCheckSum($checksum, $cID = false, $cType = false, $cVersion = false) {
	$sql = "
		DELETE 
		FROM ". DB_NAME_PREFIX. "images
		WHERE checksum_inc_name = '". mysql_real_escape_string($checksum). "'";
	
	if ($cID) {
		if (!$cVersion) {
			$cVersion = getLatestVersion($cID, $cType);
		}
		
		$sql .= "
			AND content_item_id = ". (int) $cID. "
			AND content_item_type = '". mysql_real_escape_string($cType). "'
			AND content_item_version = ". (int) $cVersion;
	}
			
	$result = my_mysql_query($sql);
}

function deleteMovieByCheckSum($checksum, $cID = false, $cType = false, $cVersion = false) {
	$sql = "
		DELETE 
		FROM ". DB_NAME_PREFIX. "movies
		WHERE checksum_inc_name = '". mysql_real_escape_string($checksum). "'";
	
	if ($cID) {
		if (!$cVersion) {
			$cVersion = getLatestVersion($cID, $cType);
		}
		
		$sql .= "
			AND content_item_id = ". (int) $cID. "
			AND content_item_type = '". mysql_real_escape_string($cType). "'
			AND content_item_version = ". (int) $cVersion;
	}
			
	$result = my_mysql_query($sql);
}

function getDeleteMenuItemFloatingBox ($mID, $prefix = '') {
	$menuDetails = getMenuItemFromMenuID($mID);

	$deleteMenuWarningMessage = '<p>'. getPhrase("Are you sure that you wish to delete the menu item \"" . $menuDetails['name'] . "\"?<br /><br />No Content Items will be deleted."). '</p>';
	
	if ($menuDetails['children'] = getNumMenuChildren_recursive($mID)) {
		$deleteMenuWarningMessage .= '<p>'. getPhrase("There are " . $menuDetails['children'] . " child Menu Item(s). These, and any Menu Items below them, will be deleted."). '</p>';
	}
	
	$deleteMenuButton = '<input type="button" class="submit_selected" value="'. getPhrase("_DELETE"). '" onclick="'. $prefix. 'deleteMenuItemAction()" />';

	$floatingBox = htmlspecialchars_decode(floatingBoxJS($deleteMenuWarningMessage, $deleteMenuButton, $showWarning = true, $addCancelButton = true));

	return json_encode(array('open_floating_box' => true, 'floating_box_data' => $floatingBox));
}



function getDeleteContentFloatingBox ($cID,$cType,$cVersion, $prefix = '') {
	$contentTag = getTag($cID,$cType,$cVersion);

	$deleteContentWarningMessage = '<p>'. getPhrase("_DELETE_CONTENT_ITEM", array("tag" => $contentTag)). '</p>';
	
	$deleteContentButton = '<input type="button" class="submit_selected" value="'. getPhrase("_DELETE"). '" onclick="'. $prefix. 'deleteContentAction()" />';

	$floatingBox = htmlspecialchars_decode(floatingBoxJS($deleteContentWarningMessage, $deleteContentButton, $showWarning = true, $addCancelButton = true));

	return json_encode(array('open_floating_box' => true, 'floating_box_data' => $floatingBox));
}

function getTrashContentFloatingBox ($cID,$cType,$cVersion, $prefix = '') {
	$contentTag = getTag($cID,$cType,$cVersion);

	$trashContentWarningMessage = '<p>'. getPhrase("_TRASH_CONTENT_ITEM", array("tag" => $contentTag)). '</p>';
	
	$trashContentButton = '<input type="button" class="submit_selected" value="'. getPhrase("_TRASH"). '" onclick="'. $prefix. 'trashContentAction()" />';

	$floatingBox = htmlspecialchars_decode(floatingBoxJS($trashContentWarningMessage, $trashContentButton, $showWarning = true, $addCancelButton = true));

	return json_encode(array('open_floating_box' => true, 'floating_box_data' => $floatingBox));
}

function getHideContentFloatingBox ($cID,$cType,$cVersion, $prefix = '') {
	$contentTag = getTag($cID,$cType,$cVersion);

	$hideContentWarningMessage = '<p>This action will hide the Content Item &quot;' . $contentTag . '&quot;<br /><br />It will become invisible to visitors and any menu items linking to it will be deleted. You will be able to un-hide the Item again via Storekeeper.<br /><br />Are you sure you wish to proceed?</p>';
	
	$hideContentButton = '<input type="button" class="submit_selected" value="'. getPhrase("Hide"). '" onclick="'. $prefix. 'hideContentAction()" />';

	$floatingBox = htmlspecialchars_decode(floatingBoxJS($hideContentWarningMessage, $hideContentButton, $showWarning = true, $addCancelButton = true));

	return json_encode(array('open_floating_box' => true, 'floating_box_data' => $floatingBox));
}

function getUnhideContentFloatingBox ($cID,$cType,$cVersion) {
	$contentTag = getTag($cID,$cType,$cVersion);

	$unhideContentWarningMessage = '<p>'. getPhrase("_UNHIDE_CONTENT_ITEM", array("tag" => $contentTag)). '</p>';
	
	$unhideContentButton = '<input type="button" class="submit_selected" value="'. getPhrase("_UNHIDE"). '" onclick="unHideContentAction()" />';

	$floatingBox = htmlspecialchars_decode(floatingBoxJS($unhideContentWarningMessage, $unhideContentButton, $showWarning = true, $addCancelButton = true));

	return json_encode(array('open_floating_box' => true, 'floating_box_data' => $floatingBox));
}

function getCreateDraftFloatingBox() {
	$createDraftWarningMessage =
		'<p>'. getPhrase('Are you sure that you wish to create a draft version of this Content Item?'). '</p>';
	
	$createDraftButton = '<input type="button" class="submit_selected" value="'. getPhrase('Create'). '" onclick="tribiqAT.createDraftAction();" />';

	$floatingBox = htmlspecialchars_decode(floatingBoxJS($createDraftWarningMessage, $createDraftButton, $showWarning = true, $addCancelButton = true));

	return json_encode(array('open_floating_box' => true, 'floating_box_data' => $floatingBox));
}

function validatePublicURL($urlDetails) {
	
	$errArray = array();
	
	if (isset($urlDetails['public_url'])) {
		if (!$urlDetails['public_url']) {
			$errArray[] = getPhrase('Please enter a URL.');
		} elseif (!aliasURLIsValid($urlDetails['public_url'])) {
			$errArray[] = getPhrase("_MSG_ERR_SITE_REGISTRY_INVALID_PUBLIC_URL");		
		} elseif (!checkPublicURLunique($urlDetails['public_url'])) {
			$errArray[] = getPhrase("_MSG_ERR_SITE_REGISTRY_PUBLIC_URL_NOT_UNIQUE");
		}
	}
	
	return array('valid' => !count($errArray), 'errArray' => $errArray);
}

function savePublicURL($urlDetails, $url) {
	if ($urlDetails['public_url']) {
		connectGlobalDB();
		
		$sql = "INSERT INTO " . DB_NAME_PREFIX_GLOBAL . "public_urls
				SET public_url = '" . mysql_real_escape_string($urlDetails['public_url']) . "',
					sitename = '" . mysql_real_escape_string(SITENAME) . "'";
					
		$result = my_mysql_query($sql);
		
		connectLocalDB();
	}
	
	if ($urlDetails['admin_url']) {
		connectGlobalDB();
		
		$sql = "UPDATE " . DB_NAME_PREFIX_GLOBAL . "site_registry
				SET goto_admin_url = '" . mysql_real_escape_string(ifNull($urlDetails['url'], $urlDetails['public_url'])) . "'
				WHERE sitename = '" . mysql_real_escape_string(SITENAME) . "'";
				
		$result = my_mysql_query($sql);
		
		connectLocalDB();
	}
}



function getSiteRegistrySite ($sitename) {
	connectGlobalDB();

	$sql = "SELECT sitename,
				goto_admin_url,
				admin_use_ssl,
				force_public_url_refresh
			FROM " . DB_NAME_PREFIX_GLOBAL . "site_registry
			WHERE sitename = '" . mysql_real_escape_string($sitename) . "'";

	$result = my_mysql_query($sql);

	connectLocalDB();

	return mysql_fetch_assoc($result);
}

function deleteSiteRegistrySitePublicURL ($sitename, $public_url) {
	$site = getSiteRegistrySite(SITENAME);
	
	if ($public_url != $site['goto_admin_url']) {
		connectGlobalDB();
	
		$sql = "DELETE
				FROM " . DB_NAME_PREFIX_GLOBAL . "public_urls
				WHERE public_url = '" . mysql_real_escape_string($public_url) . "'
					AND	sitename = '" . mysql_real_escape_string($sitename) . "'";
	
		my_mysql_query($sql);
	
		connectLocalDB();
	}
}


function checkPublicURLunique($public_url) {
	connectGlobalDB();

	$sql = "SELECT public_url
			FROM " . DB_NAME_PREFIX_GLOBAL . "public_urls
			WHERE public_url = '" . mysql_real_escape_string($public_url) . "'";

	$result = my_mysql_query($sql);

	connectLocalDB();

	if (mysql_num_rows($result)>0) {
		return false;
	} else {
		return true;
	}
}








//Include extranet functionality

function getTotalUsers($searchterm='', $status='', $groupId) {
	$groupId = (int) $groupId;

	$sql = "SELECT COUNT(*) as nCount
			FROM ".DB_NAME_PREFIX."users";
	if($groupID!="") {
		$sql2 .= " JOIN ".DB_NAME_PREFIX."group_user_link ON ".DB_NAME_PREFIX."group_user_link.user_id = ".DB_NAME_PREFIX."users.id";
		}

	$sql2 .= " WHERE 1 ";

	if($groupID!="") {
		$sql2 .= "AND ".DB_NAME_PREFIX."group_user_link.$groupId = '".$groupId."'";
	}
	if($status!="") {

		$sql2 .= "AND status = '".$status."'";
	}
	if($searchterm!="") {

		$sql2 .= "AND (username LIKE '". $searchterm ."%'
		OR first_name LIKE '".$searchterm."%'
		OR last_name LIKE '". $searchterm."%'
		OR company_name LIKE '".$searchterm."%'
		OR email LIKE '".$searchterm."%')";
	}
	$sql .= $sql2;




	$result = my_mysql_query ($sql);
	if ($row = mysql_fetch_array($result)) {
		$nCount = $row["nCount"];
	}

	return $nCount;
}

function getSelectUsers($fieldName) {
	$sql = "describe ".DB_NAME_PREFIX."users";
	$result = my_mysql_query($sql);
	//then loop:
	while($row = mysql_fetch_array ($result)) {
		//# row is mysql type, in format "int(11) unsigned zerofill"
		//# or "enum('cheese','salmon')" etc.
		if($row['Field']==$fieldName) {
			preg_match('#^([^ (]+)(\((.+)\))?([ ](.+))?$#',$row['Type'],$fieldTypeSplit);
			//# split type up into array
			$fieldType = $fieldTypeSplit[1];// eg 'int' for integer.
			$fieldFlags = $fieldTypeSplit[5]; // eg 'binary' or 'unsigned zerofill'.
			$fieldLen = $fieldTypeSplit[3]; // eg 11, or 'cheese','salmon' for enum.

			if (($fieldType=='enum' || $fieldType=='set')) {
				$fieldOptions = split("','",substr($fieldLen,1,-1));
				return $fieldOptions;
			}
		}
	}

	//if the funciton makes it this far, then it either
	//did not find an enum/set field type, or it
	//failed to find the the fieldname, so exit FALSE!
	return FALSE;
}

function getTotalGroups($searchterm='') {
	$sql = "SELECT COUNT(*) as nCount
			FROM ".DB_NAME_PREFIX."groups WHERE 1";
	if($searchterm) $sql .= " AND name LIKE '%". $searchterm ."%'";
	$result = my_mysql_query ($sql);
	if ($row = mysql_fetch_array($result)) {
		$nCount = $row["nCount"];
	}

	return $nCount;
}

function getAllGroups() {
	$sql = "SELECT id,
				name
			FROM ". DB_NAME_PREFIX . "groups
			ORDER BY name ";
	$result= my_mysql_query($sql);

	while($row = mysql_fetch_array ($result)) {
		$grp[] = $row;
	}
	return $grp;
}

function getSelectGroups($groupId) {
	$groupId = (int) $groupId;

	$sql = "SELECT *
			FROM ". DB_NAME_PREFIX . "groups";
	$result = my_mysql_query($sql);
	$selectBox = "<select name=\"groups\">";
	$selectBox .= "<option>-- ". getPhrase("_ANY_GROUP") ." --</option>";
	while ($row = mysql_fetch_array ($result)) {
		if($row['id'] == $id) { $selectBox .= "<option value=\"". $row['id'] ."\" selected>". $row['name'] ."</option>"; }
		else { $selectBox .= "<option value=\"". $row['id'] ."\">". $row['name'] ."</option>"; }
	}
	$selectBox .= "</select>";
	return $selectBox;
}

function changeStatusEnMasse($action, $ids) {

		$i = 0;
		foreach($ids as $id) {
			if($i == 0) $ids_string = "'" . $id . "'";
			else $ids_string .= ",'" . $id . "'";
			$i++;
		}


		if($action == "active") {
			$sql = "SELECT email FROM ".DB_NAME_PREFIX."users
					WHERE status != '$action'
						AND id IN (" . $ids_string . ")";
			$result = my_mysql_query($sql);
			while($row = mysql_fetch_array($result)) {
				//mail($row["email"], "Extranet access granted", "You have been granted access to the Extranet.\n\nVisit the site at:\n" . SITE_ADDRESS . HOME_DIRECTORY, "From: " . $siteConfig['email_address_from']);
			}
		}
		$sql = "UPDATE ".DB_NAME_PREFIX."users
				SET status = '$action'
				WHERE id IN (" . $ids_string . ")";
		if ($result = mysql_query ($sql)) {
			return true;
		} else {
			return false;
		}
}

function changeGroupEnMasse($groupId, $user_ids) {
	$groupId = (int) $groupId;

	foreach ($user_ids as $user_id) {
		$sql = "REPLACE INTO " . DB_NAME_PREFIX . "group_user_link
				SET group_id = " . $groupId . ",
				user_id = " . $user_id;

		$result = my_mysql_query($sql);
	}
}

function removeGroupEnMasse($groupId, $user_ids) {
	$groupId = (int) $groupId;

	foreach ($user_ids as $user_id) {
		$sql = "DELETE
				FROM " . DB_NAME_PREFIX . "group_user_link
				WHERE group_id = " . $groupId . "
					AND user_id = " . $user_id;

		$result = my_mysql_query($sql);
	}
}


function getGroupDBDetails($groupId) {

	$sql = "
		SELECT id, name, public, allow_opt_in_opt_out, members_are_employees, active
		FROM ". DB_NAME_PREFIX. "groups
		WHERE id = ". (int) $groupId;
	
	$result = my_mysql_query($sql);
	return mysql_fetch_assoc($result);
}



//Validate the input to a form about user details
function validateGroup($groupDetails) {
	
	$errArray = array();
	
	if(isset($groupDetails['name']) && !$groupDetails['name']) {
		$errArray[] = getPhrase('_MSG_ENTER_NAME_GROUP');
	}
	
	if (isset($groupDetails['name']) && alreadyExistsGroupName($groupDetails['name'], $groupDetails['groupId'])) {
		$errArray[] = getPhrase('_MSG_NAME_GROUP_ALREADY_EXISTS');
	}
	
	return array('valid' => !count($errArray), 'errArray' => $errArray);
}



function saveGroup($groupDetails, &$groupId, $action = false) {
	
	if (!$action) {
		$action = $groupId? 'edit' : 'new';
	}
	
	//Build up an insert/update statement using the values we have for the fields
	$sql = "";
	foreach(getFields(DB_NAME_PREFIX, 'groups') as $field => $details) {
		if (isset($groupDetails[$field])) {
			addFieldToSQL($sql, DB_NAME_PREFIX. 'groups', $field, $groupDetails, $action == 'edit', $details);
		}
	}
	
	if ( $action == "edit") {
		$sql .= "
		WHERE id = ". (int) $groupId;
	}
	
	$result = my_mysql_query( $sql );
	
	if ($action == 'new') {
		$groupId = mysql_insert_id();
		
		if (post('duplicateId')) {
			$sql = "
				INSERT INTO ". DB_NAME_PREFIX. "group_user_link (
					group_id,
					user_id,
					joined_group_date,
					remove_date
				) SELECT
					". (int) $groupId. ",
					user_id,
					joined_group_date,
					remove_date
				FROM ". DB_NAME_PREFIX. "group_user_link
				WHERE group_id = ". (int) post('duplicateId');
			my_mysql_query($sql);
		}
	}
	
	if ($groupDetails['public']) {
		foreach (getLanguages() as $lang) {
			if (!checkRowExists('visitor_phrases', array('language_id' => $lang['id'], 'code' => '_GROUP_'. (int) $groupId, 'plugin_class' => ''))) {
						 setRow('visitor_phrases', array('language_id' => $lang['id'], 'code' => '_GROUP_'. (int) $groupId, 'plugin_class' => '',
								'local_text' => $groupDetails['name']));
			}
		}
	}

	return;
}


function alreadyExistsGroupName($name,  $groupId = false) {
	$groupId =  $groupId;
	$sql = "
		SELECT name
		FROM ".DB_NAME_PREFIX."groups
		WHERE name = '" . mysql_real_escape_string( $name ) . "'";
	if ($groupId) {
		$sql .= "
			AND id <> " . (int) $groupId;
	}
	$result = my_mysql_query( $sql );
	if ( $row = mysql_fetch_array( $result ) ) {
		return true;
	} else {
		return false;
	}
}

function deleteGroup($groupId, $transferID="") {
	$groupId = (int) $groupId;

	##What happens with Private content items for a group?

	$sql = "DELETE
			FROM ". DB_NAME_PREFIX . "group_content_link
			WHERE group_id = '".$groupId."'";
	$result = my_mysql_query($sql);

	$sql = "DELETE
			FROM ". DB_NAME_PREFIX . "group_user_link
			WHERE group_id = '".$groupId."'";
	$result = my_mysql_query($sql);

	# finally once all the links have been sorted out, the actual group is deleted from the system
	# ensures that if any of the above fails, the group is not removed
	$sql = "DELETE
			FROM ". DB_NAME_PREFIX . "groups
			WHERE id = '".$groupId."'";
	$result = my_mysql_query($sql);

	$sql = "DELETE
			FROM ". DB_NAME_PREFIX . "group_images
			WHERE group_id = " . $groupId;
	$result = my_mysql_query($sql);
	
	
}







//Admin AJAX functions


//This function reads a single xml files, and merges it into the information that we've already read
function tribiqAJAXParseXML(&$tags, &$xml, $type, $pluginClassName = false, $requestedPath = false, $path = '', $goodURLs = array(), $level = 0) {
	
	//Get the tag's name. Build up a "path" of tag names that we've taken to get to this point
	$tag = preg_replace('/[^\w-]/', '', $xml->getName());
	
	//Strip underscores from the begining of tag names
	if (substr($tag, 0, 1) == '_') {
		$tag = substr($tag, 1);
	}
	
	$path .= $tag. '/';
	
	//Note that I'm stripping the "storekeeper/" from the start of the URL, and the final "/" from the end
	$url = substr($path, strlen($type. '/'), -1);
	
	//Check to see if we should include this tag and its children
	$goFurther = true;
	if ($type == 'storekeeper') {
		//If this tag has a panel, then it's valid to link to this tag
		if ($xml->panel) {
			array_unshift($goodURLs, tribiqAJAXShortenPath($url, $type));
			//Note that I'm stripping the "storekeeper/" from the start of the URL, and the final "/" from the end
		}
		
		//Have the option to only return a specific path
		if ($key == 'panel' && $requestedPath && issetArrayKey($goodURLs, 0) && (strlen($requestedPath) < ($sl = strlen($goodURLs[0])) || substr($requestedPath, 0, $sl) != $goodURLs[0])) {
			$goFurther = false;
		}
	
	} elseif ($type == 'admin_boxes') {
		if ($level == 1 && $url != $requestedPath) {
			$goFurther = false;
		} else {
			//Check attributes for keys and values.
			foreach ($xml->attributes() as $key => $child) {
				//The key/value must be in the get requests to include this tag
				if (request($key) != $child) {
					$goFurther = false;
				}
			}
		}
	}
	
	//Add an entry for this tag in the sk array, if it doesn't already have one
	if (!is_array($tags[$tag]) && $pluginClassName) {
		//Note down which Plugin owns this tag
		$tags[$tag] = array('class_name' => $pluginClassName);
	}
	
	//Recursively scan each child-tag 
	$children = false;
	foreach ($xml->children() as $key => $child) {
		$children = true;
		
		if ($goFurther) {
			tribiqAJAXParseXML($tags[$tag], $child, $type, $pluginClassName, $requestedPath, $path, $goodURLs, $level + 1);
		}
	}
	
	
	if ($type == 'storekeeper') {
		//If this tag has a panel, note down the link to this panel, and also the link to the panel above
		if ($xml->panel) {
			$tags[$tag]['link'] = array('path' => $goodURLs[0]);
			$tags[$tag]['panel']['back_link'] = $goodURLs[1];
		}
	}
	
	//If this tag had no children, then note down its value
	if (!$children) {
		$tags[$tag]['_VALUE'] = trim((string) $xml);
	}
}

//This function runs some tidy-ups from the first function
function tribiqAJAXParseXML2(&$tags) {
	$count = 0;
	if (is_array($tags)) {
		foreach ($tags as $key => &$value) {
			++$count;
			tribiqAJAXParseXML2($value);
		}
		
		//Simplify the output a little; if the only children of a tag are our standard tracking attributes then these can be 
		//ommitted and the tag can be turned into a string
		if (($count == 1 && isset($tags['_VALUE']))
		 || ($count == 2 && isset($tags['_VALUE']) && isset($tags['class_name']))) {
			$tags = $tags['_VALUE'];
		}
	}
}




//Old, removed modules - need moving into Plugins at some point!
//checkModuleReadyAndInclude('microsites-admin.inc.php');
//checkModuleReadyAndInclude('extranet-admin.inc.php');
//checkModuleReadyAndInclude('extranet-newsletters.inc.php');
?>