


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]action_superadmin_link`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]action_superadmin_link` (
  `action_name` varchar(50) NOT NULL,
  `admin_id` int(10) unsigned NOT NULL,
  UNIQUE KEY `action_name` (`action_name`,`admin_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]actions`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]actions` (
  `name` varchar(50) NOT NULL,
  `role_name` varchar(50) NOT NULL,
  UNIQUE KEY `name` (`name`,`role_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]admin_languages`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]admin_languages` (
  `language_id` varchar(5) NOT NULL default '',
  `local_name` varchar(255) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]admin_phrases`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]admin_phrases` (
  `code` varchar(100) NOT NULL default '',
  `comment` text NOT NULL,
  `en-GB` text NOT NULL,
  `en-US` text NOT NULL,
  `ar` text NOT NULL,
  `be` text NOT NULL,
  `da` text NOT NULL,
  `de` text NOT NULL,
  `es` text NOT NULL,
  `fr` text NOT NULL,
  `gu` text NOT NULL,
  `he` text NOT NULL,
  `hi` text NOT NULL,
  `ja` text NOT NULL,
  `no` text NOT NULL,
  `nl` text NOT NULL,
  `it` text NOT NULL,
  `pt-BR` text NOT NULL,
  `pt-EU` text NOT NULL,
  `ru` text NOT NULL,
  `se` text NOT NULL,
  `th` text NOT NULL,
  `tr` text NOT NULL,
  `uk` text NOT NULL,
  `ur` text NOT NULL,
  `vi` text NOT NULL,
  `zh` text NOT NULL,
  PRIMARY KEY  (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]global_revision_numbers`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]global_revision_numbers` (
  `path` varchar(255) NOT NULL,
  `patchfile` varchar(64) NOT NULL,
  `revision_no` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`path`,`patchfile`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]public_urls`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]public_urls` (
  `public_url` varchar(255) NOT NULL default '',
  `sitename` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`public_url`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]roles`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]roles` (
  `name` varchar(50) NOT NULL,
  `ordinal` int(10) NOT NULL default '0',
  UNIQUE KEY `name` (`name`),
  KEY `ordinal` (`ordinal`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]site_registry`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]site_registry` (
  `sitename` varchar(50) NOT NULL default '',
  `goto_admin_url` varchar(255) NOT NULL default '',
  `admin_use_ssl` enum('allow','force') NOT NULL default 'allow',
  `force_public_url_refresh` varchar(255) default NULL,
  PRIMARY KEY  (`sitename`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]superadmins`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]superadmins` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `username` varchar(50) NOT NULL default '',
  `password` varchar(50) NOT NULL default '',
  `password_salt` varchar(8) default NULL,
  `password_needs_changing` tinyint(1) NOT NULL default '0',
  `status` enum('pending','active','suspended','deleted') NOT NULL default 'pending',
  `last_login` datetime default NULL,
  `use_language_id` varchar(5) NOT NULL default 'en-GB',
  `first_name` varchar(100) NOT NULL default '',
  `last_name` varchar(100) NOT NULL default '',
  `email` varchar(200) NOT NULL default '',
  `perm_manage` tinyint(1) NOT NULL default '0',
  `perm_sysadmin` tinyint(1) NOT NULL default '0',
  `perm_publish` tinyint(1) NOT NULL default '0',
  `perm_author` tinyint(1) NOT NULL default '0',
  `perm_editmenu` tinyint(1) NOT NULL default '0',
  `perm_manageforum` tinyint(1) NOT NULL default '0',
  `perm_override_author_lock` tinyint(1) NOT NULL default '0',
  `perm_view_users` tinyint(1) NOT NULL default '0',
  `perm_edit_users` tinyint(1) NOT NULL default '0',
  `perm_view_groups` tinyint(1) NOT NULL default '0',
  `perm_edit_groups` tinyint(1) NOT NULL default '0',
  `perm_translate` tinyint(1) NOT NULL default '0',
  `created_date` datetime default NULL,
  `modified_date` datetime default NULL,
  `preferred_editor_id` varchar(20) NOT NULL default 'fckeditor',
  `note_email_min_priority` enum('','High','Normal','Low') NOT NULL default 'Normal',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=28 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]url_alias_redirects`;
CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]url_alias_redirects` (
  `sitename` varchar(50) NOT NULL default '',
  `requested_url` varchar(255) NOT NULL default '',
  `goto_alias` varchar(255) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8;




INSERT INTO `[[DB_NAME_PREFIX_GLOBAL]]global_revision_numbers` (`path`, `patchfile`, `revision_no`) VALUES
('admin/db_updates/core',				'global.inc.php',	[[INSTALLER_REVISION_NO]]),
('admin/db_updates/updater',			'global.inc.php',	[[INSTALLER_REVISION_NO]]),
('admin/db_updates/data_conversion',	'global.inc.php',	[[INSTALLER_REVISION_NO]]);
