


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_toolbar_button`;
CREATE TABLE `[[DB_NAME_PREFIX]]admin_toolbar_button` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `admin_toolbar_section_id` int(10) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `display_class` varchar(255) NOT NULL,
  `action_name` varchar(255) NOT NULL,
  `ordinal` int(10) unsigned NOT NULL,
  `show_next_separator` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `admin_toolbar_section_id` (`admin_toolbar_section_id`,`name`)
) ENGINE=MyISAM AUTO_INCREMENT=24 DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_toolbar_section`;
CREATE TABLE `[[DB_NAME_PREFIX]]admin_toolbar_section` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `admin_toolbar_tab_id` int(10) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `ordinal` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `admin_toolbar_tab_id` (`admin_toolbar_tab_id`,`name`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_toolbar_tab`;
CREATE TABLE `[[DB_NAME_PREFIX]]admin_toolbar_tab` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `ordinal` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]categories`;
CREATE TABLE `[[DB_NAME_PREFIX]]categories` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `parent_id` int(10) unsigned NOT NULL default '0',
  `name` varchar(50) NOT NULL,
  `restrict_content_type` varchar(20) NOT NULL default '',
  `language_id` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`,`parent_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]category_item_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]category_item_link` (
  `category_id` int(10) unsigned NOT NULL default '0',
  `item_id` int(10) unsigned NOT NULL default '0',
  `content_type` char(20) NOT NULL default '',
  `version` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`category_id`,`item_id`,`content_type`,`version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]characteristic_user_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]characteristic_user_link` (
  `id` int(10) NOT NULL auto_increment,
  `user_id` int(10) NOT NULL,
  `characteristic_id` int(10) NOT NULL,
  `characteristic_value_id` int(10) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `user_id_2` (`user_id`,`characteristic_id`),
  UNIQUE KEY `user_id` (`user_id`,`characteristic_value_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_audio`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_audio` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `filename` varchar(100) default NULL,
  `mime_type` varchar(50) default NULL,
  `size` int(10) unsigned default NULL,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `publication_date` (`publication_date`),
  KEY `version` (`version`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_audio_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_audio_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `filename` varchar(100) default NULL,
  `mime_type` varchar(50) default NULL,
  `size` int(10) unsigned default NULL,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_blog`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_blog` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `date_value` (`publication_date`),
  KEY `version` (`version`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  KEY `language_id_2` (`language_id`),
  KEY `status_2` (`status`),
  KEY `template_id_2` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_blog_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_blog_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` enum('0','1') NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_document`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_document` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `document_text` text,
  `filename` varchar(100) default NULL,
  `size` varchar(20) default NULL,
  `type` varchar(10) default 'unknown',
  `mime_type` varchar(50) default NULL,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `publication_date` (`publication_date`),
  KEY `version` (`version`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `document_text` (`document_text`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_document_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_document_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `document_text` text,
  `filename` varchar(100) default NULL,
  `size` varchar(20) default NULL,
  `type` varchar(10) default 'unknown',
  `mime_type` varchar(50) default NULL,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_event`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_event` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` mediumtext,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `private_view_event` tinyint(1) NOT NULL default '0',
  `private_view_guests` enum('public','extranet','guests','owner') NOT NULL default 'owner',
  `allow_join_event` enum('open','request_invitation','private') NOT NULL default 'private',
  `joining_fee` tinyint(1) NOT NULL default '0',
  `allow_max_guests` int(10) unsigned default NULL,
  `confirmation_status` enum('tentative','confirmed','cancelled') default NULL,
  `declare_full` tinyint(1) NOT NULL default '0',
  `allow_friends` tinyint(1) default '0',
  `event_type1` int(10) unsigned NOT NULL default '0',
  `event_type2` int(10) unsigned NOT NULL default '0',
  `location_name` varchar(255) NOT NULL default '',
  `location_address1` varchar(255) NOT NULL default '',
  `location_address2` varchar(255) NOT NULL default '',
  `location_city` varchar(255) NOT NULL default '',
  `location_state` varchar(255) NOT NULL default '',
  `location_postcode` varchar(20) NOT NULL default '',
  `location_country_id` char(3) NOT NULL default '',
  `phone` varchar(20) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `website` varchar(255) NOT NULL default '',
  `start_date` date default NULL,
  `start_time` time default NULL,
  `end_date` date default NULL,
  `end_time` time default NULL,
  `specify_time` tinyint(1) NOT NULL default '0',
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `version` (`version`),
  KEY `start_date` (`start_date`),
  KEY `start_time` (`start_time`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_event_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_event_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` mediumtext,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `private_view_event` tinyint(1) NOT NULL default '0',
  `private_view_guests` enum('public','extranet','guests','owner') NOT NULL default 'owner',
  `allow_join_event` enum('open','request_invitation','private') NOT NULL default 'private',
  `joining_fee` tinyint(1) NOT NULL default '0',
  `allow_max_guests` int(10) unsigned default NULL,
  `confirmation_status` enum('tentative','confirmed','cancelled') default NULL,
  `declare_full` tinyint(1) NOT NULL default '0',
  `allow_friends` tinyint(1) default '0',
  `event_type1` int(10) unsigned NOT NULL default '0',
  `event_type2` int(10) unsigned NOT NULL default '0',
  `location_name` varchar(255) NOT NULL default '',
  `location_address1` varchar(255) NOT NULL default '',
  `location_address2` varchar(255) NOT NULL default '',
  `location_city` varchar(255) NOT NULL default '',
  `location_state` varchar(255) NOT NULL default '',
  `location_postcode` varchar(20) NOT NULL default '',
  `location_country_id` char(3) NOT NULL default '',
  `phone` varchar(20) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `website` varchar(255) NOT NULL default '',
  `start_date` date default NULL,
  `start_time` time default NULL,
  `end_date` date default NULL,
  `end_time` time default NULL,
  `specify_time` tinyint(1) NOT NULL default '0',
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_html`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_html` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `alias` varchar(50) NOT NULL default '',
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `date_value` (`publication_date`),
  KEY `version` (`version`),
  KEY `alias` (`alias`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_html_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_html_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `alias` varchar(50) NOT NULL default '',
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_news`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_news` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `date_value` (`publication_date`),
  KEY `version` (`version`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_news_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_news_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_picture`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_picture` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `filename` varchar(100) NOT NULL default '',
  `mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg') NOT NULL default 'image/jpeg',
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `size` int(10) unsigned default NULL,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `date_value` (`publication_date`),
  KEY `version` (`version`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_picture_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_picture_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `filename` varchar(100) NOT NULL default '',
  `mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg') NOT NULL default 'image/jpeg',
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `size` int(10) unsigned default NULL,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_recurring_event`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_recurring_event` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` mediumtext,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `private_view_recurring_event` tinyint(1) NOT NULL default '0',
  `private_view_guests` enum('public','extranet','guests','owner') NOT NULL default 'owner',
  `allow_join_recurring_event` enum('open','request_invitation','private') NOT NULL default 'private',
  `joining_fee` tinyint(1) NOT NULL default '0',
  `allow_max_guests` int(10) unsigned default NULL,
  `confirmation_status` enum('tentative','confirmed','cancelled') default NULL,
  `declare_full` tinyint(1) NOT NULL default '0',
  `allow_friends` tinyint(1) default '0',
  `recurring_event_type1` int(10) unsigned NOT NULL default '0',
  `recurring_event_type2` int(10) unsigned NOT NULL default '0',
  `start_date` date default NULL,
  `start_time` time default NULL,
  `end_date` date default NULL,
  `end_time` time default NULL,
  `specify_time` tinyint(1) NOT NULL default '0',
  `day_sun_on` tinyint(1) NOT NULL default '0',
  `day_sun_start_time` time default NULL,
  `day_sun_end_time` time default NULL,
  `day_mon_on` tinyint(1) NOT NULL default '0',
  `day_mon_start_time` time default NULL,
  `day_mon_end_time` time default NULL,
  `day_tue_on` tinyint(1) NOT NULL default '0',
  `day_tue_start_time` time default NULL,
  `day_tue_end_time` time default NULL,
  `day_wed_on` tinyint(1) NOT NULL default '0',
  `day_wed_start_time` time default NULL,
  `day_wed_end_time` time default NULL,
  `day_thu_on` tinyint(1) NOT NULL default '0',
  `day_thu_start_time` time default NULL,
  `day_thu_end_time` time default NULL,
  `day_fri_on` tinyint(1) NOT NULL default '0',
  `day_fri_start_time` time default NULL,
  `day_fri_end_time` time default NULL,
  `day_sat_on` tinyint(1) NOT NULL default '0',
  `day_sat_start_time` time default NULL,
  `day_sat_end_time` time default NULL,
  `location_id` int(10) unsigned default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `version` (`version`),
  KEY `start_date` (`start_date`),
  KEY `start_time` (`start_time`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_recurring_event_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_recurring_event_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` mediumtext,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `private_view_recurring_event` tinyint(1) NOT NULL default '0',
  `private_view_guests` enum('public','extranet','guests','owner') NOT NULL default 'owner',
  `allow_join_recurring_event` enum('open','request_invitation','private') NOT NULL default 'private',
  `joining_fee` tinyint(1) NOT NULL default '0',
  `allow_max_guests` int(10) unsigned default NULL,
  `confirmation_status` enum('tentative','confirmed','cancelled') default NULL,
  `declare_full` tinyint(1) NOT NULL default '0',
  `allow_friends` tinyint(1) default '0',
  `recurring_event_type1` int(10) unsigned NOT NULL default '0',
  `recurring_event_type2` int(10) unsigned NOT NULL default '0',
  `start_date` date default NULL,
  `start_time` time default NULL,
  `end_date` date default NULL,
  `end_time` time default NULL,
  `specify_time` tinyint(1) NOT NULL default '0',
  `day_sun_on` tinyint(1) NOT NULL default '0',
  `day_sun_start_time` time default NULL,
  `day_sun_end_time` time default NULL,
  `day_mon_on` tinyint(1) NOT NULL default '0',
  `day_mon_start_time` time default NULL,
  `day_mon_end_time` time default NULL,
  `day_tue_on` tinyint(1) NOT NULL default '0',
  `day_tue_start_time` time default NULL,
  `day_tue_end_time` time default NULL,
  `day_wed_on` tinyint(1) NOT NULL default '0',
  `day_wed_start_time` time default NULL,
  `day_wed_end_time` time default NULL,
  `day_thu_on` tinyint(1) NOT NULL default '0',
  `day_thu_start_time` time default NULL,
  `day_thu_end_time` time default NULL,
  `day_fri_on` tinyint(1) NOT NULL default '0',
  `day_fri_start_time` time default NULL,
  `day_fri_end_time` time default NULL,
  `day_sat_on` tinyint(1) NOT NULL default '0',
  `day_sat_start_time` time default NULL,
  `day_sat_end_time` time default NULL,
  `location_id` int(10) unsigned default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_recurringevent`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_recurringevent` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` mediumtext,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `private_view_recurring_event` tinyint(1) NOT NULL default '0',
  `private_view_guests` enum('public','extranet','guests','owner') NOT NULL default 'owner',
  `allow_join_recurring_event` enum('open','request_invitation','private') NOT NULL default 'private',
  `joining_fee` tinyint(1) NOT NULL default '0',
  `allow_max_guests` int(10) unsigned default NULL,
  `confirmation_status` enum('tentative','confirmed','cancelled') default NULL,
  `declare_full` tinyint(1) NOT NULL default '0',
  `allow_friends` tinyint(1) default '0',
  `recurring_event_type1` int(10) unsigned NOT NULL default '0',
  `recurring_event_type2` int(10) unsigned NOT NULL default '0',
  `start_date` date default NULL,
  `start_time` time default NULL,
  `end_date` date default NULL,
  `end_time` time default NULL,
  `specify_time` tinyint(1) NOT NULL default '0',
  `next_day_finish` tinyint(1) NOT NULL default '0',
  `day_sun_on` tinyint(1) NOT NULL default '0',
  `day_sun_start_time` time default NULL,
  `day_sun_end_time` time default NULL,
  `day_mon_on` tinyint(1) NOT NULL default '0',
  `day_mon_start_time` time default NULL,
  `day_mon_end_time` time default NULL,
  `day_tue_on` tinyint(1) NOT NULL default '0',
  `day_tue_start_time` time default NULL,
  `day_tue_end_time` time default NULL,
  `day_wed_on` tinyint(1) NOT NULL default '0',
  `day_wed_start_time` time default NULL,
  `day_wed_end_time` time default NULL,
  `day_thu_on` tinyint(1) NOT NULL default '0',
  `day_thu_start_time` time default NULL,
  `day_thu_end_time` time default NULL,
  `day_fri_on` tinyint(1) NOT NULL default '0',
  `day_fri_start_time` time default NULL,
  `day_fri_end_time` time default NULL,
  `day_sat_on` tinyint(1) NOT NULL default '0',
  `day_sat_start_time` time default NULL,
  `day_sat_end_time` time default NULL,
  `location_id` int(10) unsigned default NULL,
  `stop_dates` text,
  `url` varchar(250) default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `version` (`version`),
  KEY `start_date` (`start_date`),
  KEY `start_time` (`start_time`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_recurringevent_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_recurringevent_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` mediumtext,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` datetime default NULL,
  `private_view_recurring_event` tinyint(1) NOT NULL default '0',
  `private_view_guests` enum('public','extranet','guests','owner') NOT NULL default 'owner',
  `allow_join_recurring_event` enum('open','request_invitation','private') NOT NULL default 'private',
  `joining_fee` tinyint(1) NOT NULL default '0',
  `allow_max_guests` int(10) unsigned default NULL,
  `confirmation_status` enum('tentative','confirmed','cancelled') default NULL,
  `declare_full` tinyint(1) NOT NULL default '0',
  `allow_friends` tinyint(1) default '0',
  `recurring_event_type1` int(10) unsigned NOT NULL default '0',
  `recurring_event_type2` int(10) unsigned NOT NULL default '0',
  `start_date` date default NULL,
  `start_time` time default NULL,
  `end_date` date default NULL,
  `end_time` time default NULL,
  `specify_time` tinyint(1) NOT NULL default '0',
  `next_day_finish` tinyint(1) NOT NULL default '0',
  `day_sun_on` tinyint(1) NOT NULL default '0',
  `day_sun_start_time` time default NULL,
  `day_sun_end_time` time default NULL,
  `day_mon_on` tinyint(1) NOT NULL default '0',
  `day_mon_start_time` time default NULL,
  `day_mon_end_time` time default NULL,
  `day_tue_on` tinyint(1) NOT NULL default '0',
  `day_tue_start_time` time default NULL,
  `day_tue_end_time` time default NULL,
  `day_wed_on` tinyint(1) NOT NULL default '0',
  `day_wed_start_time` time default NULL,
  `day_wed_end_time` time default NULL,
  `day_thu_on` tinyint(1) NOT NULL default '0',
  `day_thu_start_time` time default NULL,
  `day_thu_end_time` time default NULL,
  `day_fri_on` tinyint(1) NOT NULL default '0',
  `day_fri_start_time` time default NULL,
  `day_fri_end_time` time default NULL,
  `day_sat_on` tinyint(1) NOT NULL default '0',
  `day_sat_start_time` time default NULL,
  `day_sat_end_time` time default NULL,
  `location_id` int(10) unsigned default NULL,
  `url` varchar(250) default NULL,
  `stop_dates` text,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_video`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_video` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `filename` varchar(100) default NULL,
  `mime_type` varchar(50) default NULL,
  `size` int(10) unsigned default NULL,
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`,`version`),
  KEY `folder_id` (`folder_id`),
  KEY `publication_date` (`publication_date`),
  KEY `version` (`version`),
  KEY `language_id` (`language_id`),
  KEY `status` (`status`),
  KEY `template_id` (`template_id`),
  FULLTEXT KEY `title` (`title`),
  FULLTEXT KEY `keywords` (`keywords`),
  FULLTEXT KEY `description` (`description`),
  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`),
  FULLTEXT KEY `content_summary` (`content_summary`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_video_tmp`;
CREATE TABLE `[[DB_NAME_PREFIX]]content_video_tmp` (
  `id` int(10) unsigned NOT NULL default '0',
  `version` int(10) unsigned NOT NULL default '1',
  `title` varchar(250) NOT NULL default '',
  `private` tinyint(1) NOT NULL default '0',
  `log_user_access` tinyint(1) NOT NULL default '0',
  `language_id` varchar(5) NOT NULL default 'en',
  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
  `draft_exists` tinyint(1) NOT NULL default '0',
  `created_datetime` datetime default NULL,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `owner_authtype` enum('local','super') default NULL,
  `creating_author_id` int(10) unsigned NOT NULL default '0',
  `creating_author_authtype` enum('local','super') default NULL,
  `allow_local_coauthor_id` int(10) unsigned NOT NULL default '0',
  `last_author_id` int(10) unsigned NOT NULL default '0',
  `last_author_authtype` enum('local','super') default NULL,
  `publisher_id` int(10) unsigned NOT NULL default '0',
  `publisher_authtype` enum('local','super') default NULL,
  `published_datetime` datetime default NULL,
  `hider_id` int(10) unsigned NOT NULL default '0',
  `hider_authtype` enum('local','super') default NULL,
  `hidden_datetime` datetime default NULL,
  `archiver_id` int(10) unsigned NOT NULL default '0',
  `archiver_authtype` enum('local','super') default NULL,
  `archived_datetime` datetime default NULL,
  `expiry_datetime` datetime default NULL,
  `expiry_action` enum('delete','hide','alert') default NULL,
  `folder_id` int(10) unsigned NOT NULL default '0',
  `description` text,
  `keywords` text,
  `template_id` int(10) unsigned NOT NULL default '0',
  `skin_id` int(10) unsigned default NULL,
  `content_head` text,
  `content_bodytop` mediumtext,
  `content_bodymain` mediumtext,
  `content_bodyfoot` mediumtext,
  `content_summary` mediumtext,
  `filename` varchar(100) default NULL,
  `mime_type` varchar(50) default NULL,
  `size` int(10) unsigned default NULL,
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `spare_varchar1` varchar(250) NOT NULL default '',
  `spare_varchar2` varchar(250) NOT NULL default '',
  `new_menu_text` varchar(250) NOT NULL default '',
  `publication_date` date default NULL,
  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
  `seo_sitemap_priority` float(3,1) default NULL,
  `diagnostic_page` tinyint(1) NOT NULL default '0',
  `diagnostic_last_status` tinyint(1) default NULL,
  `diagnostic_last_run` datetime default NULL,
  `enable_rss` tinyint(1) default '0',
  `microsite_id` int(10) unsigned default NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]contenttype_settings`;
CREATE TABLE `[[DB_NAME_PREFIX]]contenttype_settings` (
  `content_type_id` varchar(20) NOT NULL default '',
  `name` varchar(50) NOT NULL default '',
  `ordinal` int(10) unsigned default NULL,
  `type` blob,
  `value` blob,
  PRIMARY KEY  (`content_type_id`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]contenttypes`;
CREATE TABLE `[[DB_NAME_PREFIX]]contenttypes` (
  `content_type_id` varchar(20) NOT NULL default '',
  `content_type_name_en` varchar(255) NOT NULL default '',
  `tag_prefix` varchar(4) NOT NULL default '',
  `show_pub_date` tinyint(1) NOT NULL default '0',
  `default_folder_id` int(10) unsigned NOT NULL default '0',
  `default_template_id` int(10) unsigned NOT NULL default '0',
  `enable_print` tinyint(1) NOT NULL default '1',
  `enable_emailfriend` tinyint(1) NOT NULL default '1',
  `enable_categories` tinyint(1) NOT NULL default '0',
  `special_flag` int(1) NOT NULL default '0',
  `disallow_normal_creation` tinyint(1) NOT NULL default '0',
  `bulk_upload` tinyint(1) NOT NULL default '0',
  `plugin_id` int(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`content_type_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]countries`;
CREATE TABLE `[[DB_NAME_PREFIX]]countries` (
  `iso2` varchar(2) NOT NULL default '',
  `iso3` varchar(3) NOT NULL default '',
  `name_en` varchar(50) default NULL,
  `name_fr` varchar(50) default NULL,
  `name_de` varchar(50) default NULL,
  `name_pt` varchar(50) default NULL,
  `name_es` varchar(50) default NULL,
  `default_language` varchar(2) default 'en',
  `worldzone_en` varchar(50) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`iso2`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]document_types`;
CREATE TABLE `[[DB_NAME_PREFIX]]document_types` (
  `type` varchar(10) NOT NULL default '',
  `enable_extract` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]email_templates`;
CREATE TABLE `[[DB_NAME_PREFIX]]email_templates` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `template_name` varchar(255) NOT NULL default '',
  `subject` tinytext NOT NULL,
  `email_address_from` varchar(100) NOT NULL default '',
  `email_name_from` varchar(255) NOT NULL default '',
  `body` text,
  `date_created` datetime NOT NULL,
  `created_by_id` int(10) unsigned NOT NULL,
  `created_by_authtype` enum('local','super') NOT NULL,
  `date_modified` datetime default NULL,
  `modified_by_id` int(10) unsigned default NULL,
  `modified_by_authtype` enum('local','super') default NULL,
  `allow_attachments` tinyint(1) default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `template_name` (`template_name`),
  KEY `date_modified` (`date_modified`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]favicons`;
CREATE TABLE `[[DB_NAME_PREFIX]]favicons` (
  `usage` enum('favicon','mobile') NOT NULL,
  `filename` varchar(50) NOT NULL default '',
  `mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg','image/vnd.microsoft.icon') NOT NULL,
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `size` int(10) unsigned default NULL,
  `data` mediumblob,
  `checksum` varchar(32) default NULL,
  PRIMARY KEY  (`usage`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]group_content_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]group_content_link` (
  `group_id` int(10) unsigned NOT NULL default '0',
  `content_id` int(10) unsigned NOT NULL default '0',
  `content_type` char(20) NOT NULL default '',
  `content_version` int(10) unsigned NOT NULL default '0',
  `allow_create_msg` tinyint(1) unsigned NOT NULL default '0',
  `allow_reply_msg` tinyint(1) unsigned NOT NULL default '0',
  `extranet_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`group_id`,`content_id`,`content_type`,`content_version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]group_images`;
CREATE TABLE `[[DB_NAME_PREFIX]]group_images` (
  `group_id` int(10) unsigned NOT NULL default '0',
  `filename` varchar(50) NOT NULL default '',
  `mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg') NOT NULL default 'image/jpeg',
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `size` int(10) unsigned default NULL,
  `data` mediumblob,
  `checksum` varchar(32) NOT NULL default '',
  `usage` enum('thumbnail','medium','fullsize') default NULL,
  `sticky_flag` tinyint(1) NOT NULL default '0',
  `storekeeper_width` smallint(5) unsigned default NULL,
  `storekeeper_height` smallint(5) unsigned default NULL,
  `storekeeper_data` mediumblob,
  `storekeeper_size` int(10) unsigned default NULL,
  PRIMARY KEY  (`group_id`,`checksum`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]group_user_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]group_user_link` (
  `group_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  `joined_group_date` datetime default NULL,
  `remove_date` datetime default NULL,
  PRIMARY KEY  (`group_id`,`user_id`),
  KEY `user_id` (`user_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]groups`;
CREATE TABLE `[[DB_NAME_PREFIX]]groups` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `public_name` varchar(255) NOT NULL default '',
  `description` text,
  `members_are_employees` tinyint(1) NOT NULL default '0',
  `active` int(1) NOT NULL default '1',
  `spare_varchar1` varchar(255) NOT NULL default '',
  `spare_varchar2` varchar(255) NOT NULL default '',
  `spare_varchar3` varchar(255) NOT NULL default '',
  `spare_varchar4` varchar(255) NOT NULL default '',
  `spare_varchar5` varchar(255) NOT NULL default '',
  `spare_text1` longtext,
  `spare_blob1` longblob,
  `spare_date1` date default NULL,
  `spare_date2` date default NULL,
  `spare_datetime1` datetime default NULL,
  `spare_datetime2` datetime default NULL,
  `spare_time1` time default NULL,
  `spare_time2` time default NULL,
  `spare_enum1` enum('A','B','C','D','E') default NULL,
  `spare_enum2` enum('A','B','C','D','E') default NULL,
  `spare_int1` int(20) default NULL,
  `spare_int2` int(20) default NULL,
  `spare_float1` float(10,2) default NULL,
  `spare_float2` float(10,2) default NULL,
  `consent1` enum('Yes','No') default NULL,
  `consent2` enum('Yes','No') default NULL,
  `consent3` enum('Yes','No') default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]images`;
CREATE TABLE `[[DB_NAME_PREFIX]]images` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `content_item_id` int(10) unsigned NOT NULL default '0',
  `content_item_version` int(10) unsigned NOT NULL default '0',
  `content_item_type` varchar(20) NOT NULL default '',
  `created_datetime` datetime default NULL,
  `filename` varchar(50) NOT NULL default '',
  `mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg') NOT NULL default 'image/jpeg',
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `size` int(10) unsigned default NULL,
  `data` mediumblob,
  `checksum` varchar(32) default NULL,
  `thumbnail_width` smallint(5) unsigned default NULL,
  `thumbnail_height` smallint(5) unsigned default NULL,
  `thumbnail_data` mediumblob,
  `thumbnail_size` int(10) unsigned default NULL,
  `sticky_flag` tinyint(1) NOT NULL default '0',
  `storekeeper_width` smallint(5) unsigned default NULL,
  `storekeeper_height` smallint(5) unsigned default NULL,
  `storekeeper_data` mediumblob,
  `storekeeper_size` int(10) unsigned default NULL,
  `archived` tinyint(1) NOT NULL default '0',
  `checksum_inc_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`content_item_id`,`content_item_version`,`checksum_inc_name`,`content_item_type`),
  UNIQUE KEY `id` (`id`),
  KEY `checksum` (`checksum`),
  KEY `checksum_inc_name` (`checksum_inc_name`),
  KEY `content_item_id` (`content_item_id`,`content_item_version`,`filename`,`content_item_type`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]lang_equiv_content`;
CREATE TABLE `[[DB_NAME_PREFIX]]lang_equiv_content` (
  `id` int(10) unsigned NOT NULL default '0',
  `language_id` varchar(10) NOT NULL default '',
  `content_id` int(10) unsigned NOT NULL default '0',
  `content_type` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`content_type`,`content_id`),
  KEY `id` (`id`),
  KEY `language_id` (`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]languages`;
CREATE TABLE `[[DB_NAME_PREFIX]]languages` (
  `id` varchar(5) NOT NULL default '',
  `language_local_name` varchar(100) NOT NULL default '',
  `detect` tinyint(1) NOT NULL default '0',
  `homepage_id` int(10) unsigned NOT NULL default '0',
  `search_page_id` int(10) unsigned NOT NULL default '0',
  `extranet_login_page_id` int(10) unsigned NOT NULL default '0',
  `extranet_registration_page_id` int(10) unsigned NOT NULL default '0',
  `extranet_password_reminder_page_id` int(10) unsigned NOT NULL default '0',
  `extranet_change_password_page_id` int(10) unsigned NOT NULL default '0',
  `extranet_logout_page_id` int(10) unsigned NOT NULL default '0',
  `flag_file_name` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]local_revision_numbers`;
CREATE TABLE `[[DB_NAME_PREFIX]]local_revision_numbers` (
  `path` varchar(255) NOT NULL,
  `patchfile` varchar(64) NOT NULL,
  `revision_no` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`path`,`patchfile`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]menu_sections`;
CREATE TABLE `[[DB_NAME_PREFIX]]menu_sections` (
  `section_name` varchar(20) NOT NULL,
  PRIMARY KEY  (`section_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]menuitems`;
CREATE TABLE `[[DB_NAME_PREFIX]]menuitems` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `section_id` varchar(20) NOT NULL default 'Main',
  `name` varchar(255) NOT NULL default '',
  `redundancy` enum('primary','secondary') NOT NULL default 'primary',
  `accesskey` char(1) NOT NULL default '',
  `target_loc` enum('int','ext','none') NOT NULL default 'none',
  `open_in_new_window` tinyint(1) NOT NULL default '0',
  `content_id` int(10) unsigned NOT NULL default '0',
  `html_content_alias` varchar(50) NOT NULL default '',
  `content_type` varchar(20) NOT NULL default '',
  `plugin_request` varchar(32) NOT NULL default '',
  `mode` varchar(20) NOT NULL default '',
  `parent_id` int(10) unsigned NOT NULL default '0',
  `ext_url` varchar(255) NOT NULL default '',
  `ordinal` int(10) unsigned NOT NULL default '0',
  `language_id` varchar(10) NOT NULL default 'en',
  `active` tinyint(1) NOT NULL default '0',
  `invisible` tinyint(1) NOT NULL default '0',
  `hide_private_item` tinyint(1) NOT NULL default '0',
  `rel_tag` varchar(100) default NULL,
  `microsite_id` int(10) unsigned default NULL,
  `parent_microsite_id` int(10) unsigned default NULL,
  `microsite_gateway` tinyint(1) default NULL,
  PRIMARY KEY  (`id`),
  KEY `ordinal` (`ordinal`),
  KEY `content_type` (`content_type`),
  KEY `parent_id` (`parent_id`),
  KEY `content_id` (`content_id`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]mime_types`;
CREATE TABLE `[[DB_NAME_PREFIX]]mime_types` (
  `raw_type` varchar(40) NOT NULL default '',
  `extension` varchar(10) NOT NULL default '',
  `type_display` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`raw_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]movies`;
CREATE TABLE `[[DB_NAME_PREFIX]]movies` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `content_item_id` int(10) unsigned NOT NULL default '0',
  `content_item_version` int(10) unsigned NOT NULL default '0',
  `content_item_type` varchar(20) NOT NULL default '',
  `created_datetime` datetime default NULL,
  `filename` varchar(50) NOT NULL default '',
  `mime_type` enum('application/x-shockwave-flash','video/quicktime','audio/x-ms-wmv') NOT NULL default 'application/x-shockwave-flash',
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `size` int(10) unsigned default NULL,
  `data` mediumblob,
  `checksum` varchar(32) default NULL,
  `thumbnail_width` smallint(5) unsigned default NULL,
  `thumbnail_height` smallint(5) unsigned default NULL,
  `thumbnail_data` mediumblob,
  `thumbnail_size` int(10) unsigned default NULL,
  `sticky_flag` tinyint(1) NOT NULL default '0',
  `archived` tinyint(1) NOT NULL default '0',
  `checksum_inc_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`content_item_id`,`content_item_version`,`checksum_inc_name`,`content_item_type`),
  UNIQUE KEY `id` (`id`),
  KEY `checksum` (`checksum`),
  KEY `checksum_inc_name` (`checksum_inc_name`),
  KEY `content_item_id` (`content_item_id`,`content_item_version`,`filename`,`content_item_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]nested_plugins`;
CREATE TABLE `[[DB_NAME_PREFIX]]nested_plugins` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `instance_id` int(10) unsigned NOT NULL,
  `tab` smallint(4) unsigned NOT NULL default '1',
  `ord` smallint(4) unsigned NOT NULL default '1',
  `plugin_id` int(10) unsigned NOT NULL,
  `framework` varchar(50) NOT NULL default '',
  `is_tab` tinyint(1) NOT NULL default '0',
  `tab_title` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `instance_id` (`instance_id`,`is_tab`,`tab`,`ord`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_dependencies`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_dependencies` (
  `plugin_id` int(10) unsigned NOT NULL,
  `plugin_name` varchar(255) NOT NULL,
  `plugin_class_name` varchar(255) NOT NULL,
  `dependency_plugin_class_name` varchar(255) NOT NULL,
  `type` enum('dependency','inheritance','compatibility') NOT NULL,
  UNIQUE KEY `plugin_id` (`plugin_id`,`type`,`dependency_plugin_class_name`),
  KEY `plugin_name` (`plugin_name`,`type`),
  KEY `plugin_class_name` (`plugin_class_name`,`type`),
  KEY `dependency_plugin_class_name` (`dependency_plugin_class_name`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_inst_item_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_item_link` (
  `plugin_id` int(10) unsigned NOT NULL default '0',
  `instance_id` int(10) unsigned NOT NULL,
  `content_id` int(10) unsigned NOT NULL,
  `content_type` varchar(20) NOT NULL,
  `content_version` int(10) unsigned NOT NULL,
  `slot_name` varchar(100) NOT NULL,
  PRIMARY KEY  (`content_id`,`content_type`,`content_version`,`slot_name`),
  KEY `instance_id` (`instance_id`,`content_type`),
  KEY `slot_name` (`instance_id`,`slot_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link` (
  `plugin_id` int(10) unsigned NOT NULL default '0',
  `instance_id` int(10) unsigned NOT NULL,
  `family_name` varchar(50) NOT NULL,
  `slot_name` varchar(100) NOT NULL,
  PRIMARY KEY  (`family_name`,`slot_name`),
  KEY `slot_name` (`instance_id`,`slot_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_inst_temp_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_link` (
  `plugin_id` int(10) unsigned NOT NULL default '0',
  `instance_id` int(10) unsigned NOT NULL,
  `family_name` varchar(50) NOT NULL,
  `template_id` int(10) unsigned NOT NULL,
  `slot_name` varchar(100) NOT NULL,
  PRIMARY KEY  (`family_name`,`template_id`,`slot_name`),
  KEY `slot_name` (`instance_id`,`slot_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_instance_cache`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_instance_cache` (
  `instance_id` int(10) unsigned NOT NULL,
  `method_name` varchar(64) NOT NULL,
  `request` varchar(255) NOT NULL default '',
  `last_updated` datetime NOT NULL,
  `cache` text NOT NULL,
  PRIMARY KEY  (`instance_id`,`method_name`,`request`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_instances`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_instances` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(250) NOT NULL,
  `plugin_id` int(10) unsigned NOT NULL,
  `parent_id` int(10) unsigned NOT NULL default '0',
  `framework` varchar(50) NOT NULL default '',
  `keep_in_album` tinyint(1) NOT NULL default '0',
  `use_custom_framework` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`,`parent_id`),
  KEY `keep_in_album` (`keep_in_album`)
) ENGINE=MyISAM AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_setting_defs`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs` (
  `plugin_id` int(10) unsigned NOT NULL,
  `name` varchar(50) NOT NULL,
  `type` varchar(50) NOT NULL default '',
  `default_value` blob,
  PRIMARY KEY  (`plugin_id`,`name`),
  KEY `type` (`type`,`plugin_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_settings` (
  `instance_id` int(10) unsigned NOT NULL,
  `name` varchar(50) NOT NULL,
  `nest` int(10) unsigned NOT NULL default '0',
  `value` blob,
  PRIMARY KEY  (`instance_id`,`name`,`nest`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_slot_theme_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugin_slot_theme_link` (
  `skin_id` int(10) unsigned NOT NULL,
  `slot_name` varchar(100) NOT NULL,
  `nest` int(10) unsigned NOT NULL default '0',
  `instance_id` int(10) unsigned NOT NULL,
  `theme` varchar(50) NOT NULL,
  PRIMARY KEY  (`skin_id`,`slot_name`,`nest`,`instance_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugins`;
CREATE TABLE `[[DB_NAME_PREFIX]]plugins` (
  `id` int(20) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `class_name` varchar(200) NOT NULL,
  `vlp_class` varchar(200) NOT NULL default '',
  `display_name` varchar(255) NOT NULL,
  `version` varchar(32) default NULL,
  `company_name` varchar(255) NOT NULL default '',
  `default_framework` varchar(50) NOT NULL default '',
  `default_theme` varchar(50) NOT NULL default '',
  `uses_instances` tinyint(1) NOT NULL default '0',
  `keep_in_album` tinyint(1) NOT NULL default '0',
  `feature_plugin` tinyint(1) NOT NULL default '0',
  `nestable` tinyint(1) NOT NULL default '0',
  `status` enum('_ENUM_INSTALLED','_ENUM_INITIALISED','_ENUM_RUNNING','_ENUM_SUSPENDED') NOT NULL default '_ENUM_INSTALLED',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `class_name` (`class_name`,`version`)
) ENGINE=MyISAM AUTO_INCREMENT=234 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]raw_audio_store`;
CREATE TABLE `[[DB_NAME_PREFIX]]raw_audio_store` (
  `content_id` int(10) unsigned default NULL,
  `content_version` int(10) unsigned NOT NULL,
  `data` longblob,
  UNIQUE KEY `content_id` (`content_id`,`content_version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]raw_picture_store`;
CREATE TABLE `[[DB_NAME_PREFIX]]raw_picture_store` (
  `content_id` int(10) unsigned default NULL,
  `content_version` int(10) unsigned NOT NULL,
  `data` longblob,
  UNIQUE KEY `content_id` (`content_id`,`content_version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]raw_video_store`;
CREATE TABLE `[[DB_NAME_PREFIX]]raw_video_store` (
  `content_id` int(10) unsigned default NULL,
  `content_version` int(10) unsigned NOT NULL,
  `data` longblob,
  UNIQUE KEY `content_id` (`content_id`,`content_version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]signals`;
CREATE TABLE `[[DB_NAME_PREFIX]]signals` (
  `signal_name` varchar(127) NOT NULL,
  `plugin_id` int(10) unsigned NOT NULL,
  `plugin_name` varchar(255) NOT NULL,
  `plugin_class` varchar(200) NOT NULL,
  `suppresses_plugin_class` varchar(200) NOT NULL default '',
  UNIQUE KEY `event_name` (`signal_name`,`plugin_class`),
  KEY `suppresses_plugin_class` (`suppresses_plugin_class`),
  KEY `plugin_id` (`plugin_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]site_settings`;
CREATE TABLE `[[DB_NAME_PREFIX]]site_settings` (
  `name` varchar(50) NOT NULL default '',
  `type` blob,
  `suppress_if_other_setting_false` varchar(50) default NULL,
  `value` blob,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]skins`;
CREATE TABLE `[[DB_NAME_PREFIX]]skins` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `family_name` varchar(50) NOT NULL,
  `name` varchar(255) NOT NULL,
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `family_name` (`family_name`,`name`),
  UNIQUE KEY `family_name_2` (`family_name`,`name`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]template_family`;
CREATE TABLE `[[DB_NAME_PREFIX]]template_family` (
  `family_name` varchar(50) NOT NULL,
  `skin_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`family_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]template_slot_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]template_slot_link` (
  `template_family_name` varchar(50) NOT NULL,
  `template_filename` varchar(50) NOT NULL,
  `slot_name` varchar(100) NOT NULL,
  PRIMARY KEY  (`template_family_name`,`template_filename`,`slot_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]templates`;
CREATE TABLE `[[DB_NAME_PREFIX]]templates` (
  `template_id` int(10) unsigned NOT NULL auto_increment,
  `family_name` varchar(50) NOT NULL default '',
  `filename` varchar(50) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `usage_flag` enum('simple','advanced') NOT NULL default 'simple',
  `content_type` varchar(20) NOT NULL default '',
  `editor_width_bodymain` int(4) unsigned NOT NULL default '0',
  `custom_bodytag` text,
  `enable_content_head` tinyint(1) NOT NULL default '0',
  `enable_content_bodytop` tinyint(1) NOT NULL default '0',
  `enable_content_bodymain` tinyint(1) NOT NULL default '0',
  `enable_content_bodyfoot` tinyint(1) NOT NULL default '0',
  `status` enum('active','suspended') NOT NULL default 'active',
  `allow_rss` tinyint(1) default '0',
  `skin_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`template_id`),
  KEY `family_name` (`family_name`)
) ENGINE=MyISAM AUTO_INCREMENT=44 DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_characteristic_values`;
CREATE TABLE `[[DB_NAME_PREFIX]]user_characteristic_values` (
  `id` int(10) NOT NULL auto_increment,
  `characteristic_id` int(10) NOT NULL,
  `ordinal` int(10) NOT NULL,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `characteristic_id` (`characteristic_id`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_characteristics`;
CREATE TABLE `[[DB_NAME_PREFIX]]user_characteristics` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `ordinal` int(10) NOT NULL,
  `boolean_values` tinyint(1) default NULL,
  `protected` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_content_accesslog`;
CREATE TABLE `[[DB_NAME_PREFIX]]user_content_accesslog` (
  `hit_datetime` datetime default NULL,
  `user_id` int(10) unsigned NOT NULL default '0',
  `content_id` int(10) unsigned NOT NULL default '0',
  `content_type` varchar(20) NOT NULL default '',
  `content_version` int(10) unsigned NOT NULL default '0',
  `ip` int(10) NOT NULL default '0',
  KEY `user_id` (`user_id`),
  KEY `content_type` (`content_type`),
  KEY `content_id` (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_content_link`;
CREATE TABLE `[[DB_NAME_PREFIX]]user_content_link` (
  `user_id` int(10) unsigned NOT NULL default '0',
  `content_id` int(10) unsigned NOT NULL default '0',
  `content_type` char(20) NOT NULL default '',
  `content_version` int(10) unsigned NOT NULL default '0',
  `extranet_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`user_id`,`content_id`,`content_type`,`content_version`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_images`;
CREATE TABLE `[[DB_NAME_PREFIX]]user_images` (
  `user_id` int(10) unsigned NOT NULL default '0',
  `filename` varchar(50) NOT NULL default '',
  `mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg') NOT NULL default 'image/jpeg',
  `width` smallint(5) unsigned default NULL,
  `height` smallint(5) unsigned default NULL,
  `size` int(10) unsigned default NULL,
  `data` mediumblob,
  `checksum` varchar(32) NOT NULL default '',
  `usage` enum('thumbnail','fullsize') default NULL,
  `sticky_flag` tinyint(1) NOT NULL default '0',
  `storekeeper_width` smallint(5) unsigned default NULL,
  `storekeeper_height` smallint(5) unsigned default NULL,
  `storekeeper_data` mediumblob,
  `storekeeper_size` int(10) unsigned default NULL,
  PRIMARY KEY  (`user_id`,`checksum`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]users`;
CREATE TABLE `[[DB_NAME_PREFIX]]users` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `parent_id` int(10) unsigned default '0',
  `ip` varchar(20) NOT NULL default '',
  `session_id` varchar(100) NOT NULL default '',
  `username` varchar(50) NOT NULL default '',
  `screen_name` varchar(50) default '',
  `password` varchar(50) NOT NULL default '',
  `status` enum('pending','active','suspended') NOT NULL default 'pending',
  `last_login` datetime default NULL,
  `title` varchar(25) default '',
  `first_name` varchar(100) NOT NULL default '',
  `middle_name` varchar(100) NOT NULL default '',
  `last_name` varchar(100) NOT NULL default '',
  `maiden_name` varchar(100) NOT NULL default '',
  `birth_date` date default NULL,
  `email` varchar(100) NOT NULL default '',
  `email_verified` tinyint(1) NOT NULL default '0',
  `alt_email` varchar(100) NOT NULL default '',
  `website` varchar(250) NOT NULL default '',
  `job_title` varchar(250) NOT NULL default '',
  `company_name` varchar(250) NOT NULL default '',
  `bus_address1` varchar(250) NOT NULL default '',
  `bus_address2` varchar(250) NOT NULL default '',
  `bus_town` varchar(250) NOT NULL default '',
  `bus_state` varchar(250) NOT NULL default '',
  `bus_postcode` varchar(20) NOT NULL default '',
  `bus_country_id` varchar(3) NOT NULL default '',
  `res_address1` varchar(250) NOT NULL default '',
  `res_address2` varchar(250) NOT NULL default '',
  `res_town` varchar(250) NOT NULL default '',
  `res_state` varchar(250) NOT NULL default '',
  `res_postcode` varchar(20) NOT NULL default '',
  `res_country_id` varchar(3) NOT NULL default '',
  `address_pref` enum('residential','business','no_pref') NOT NULL default 'no_pref',
  `mobile` varchar(20) default '',
  `bus_phone` varchar(20) NOT NULL default '',
  `res_phone` varchar(20) NOT NULL default '',
  `fax` varchar(20) NOT NULL default '',
  `created_date` datetime default NULL,
  `modified_date` datetime default NULL,
  `suspended_date` datetime default NULL,
  `first_subscrip_id` int(10) unsigned NOT NULL default '0',
  `first_subscrip_start` datetime default NULL,
  `first_subscrip_end` datetime default NULL,
  `notes` text,
  `spare_varchar1` varchar(255) default '',
  `spare_varchar2` varchar(255) default '',
  `spare_varchar3` varchar(255) default '',
  `spare_varchar4` varchar(255) default '',
  `spare_varchar5` varchar(255) default '',
  `spare_text1` longtext,
  `spare_blob1` longblob,
  `spare_date1` date default NULL,
  `spare_date2` date default NULL,
  `spare_datetime1` datetime default NULL,
  `spare_datetime2` datetime default NULL,
  `spare_time1` time default NULL,
  `spare_time2` time default NULL,
  `spare_enum1` enum('A','B','C','D','E') default NULL,
  `spare_enum2` enum('A','B','C','D','E') default NULL,
  `spare_int1` int(11) default NULL,
  `spare_int2` int(11) default NULL,
  `spare_float1` float(8,2) default NULL,
  `spare_float2` float(8,2) default NULL,
  `consent1` enum('Yes','No') default NULL,
  `consent2` enum('Yes','No') default NULL,
  `consent3` enum('Yes','No') default NULL,
  `hash` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `username` (`username`),
  KEY `email` (`email`),
  KEY `parent_id` (`parent_id`),
  KEY `screen_name` (`screen_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]visitor_phrases`;
CREATE TABLE `[[DB_NAME_PREFIX]]visitor_phrases` (
  `id` int(1) NOT NULL auto_increment,
  `code` varchar(100) NOT NULL default '',
  `language_id` varchar(5) NOT NULL default '',
  `plugin_class` varchar(200) NOT NULL default '',
  `local_text` text NOT NULL,
  `protect_flag` tinyint(1) NOT NULL default '0',
  `review_flag` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `plugin_class` (`plugin_class`,`language_id`,`code`),
  KEY `language_id` (`language_id`)
) ENGINE=MyISAM AUTO_INCREMENT=112 DEFAULT CHARSET=utf8;




REPLACE INTO `[[DB_NAME_PREFIX]]local_revision_numbers` VALUES
 ('admin/db_updates/core','local.inc.php',[[INSTALLER_REVISION_NO]]),
 ('admin/db_updates/data_conversion','local.inc.php',[[INSTALLER_REVISION_NO]]),
 ('admin/db_updates/updater','local.inc.php',[[INSTALLER_REVISION_NO]]);
