<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

//This file works like local.inc.php, but should contain any updates for local admin tables
//(i.e. updates that won't be re-run after a site-reset)





//The username column need not be unique in the superadmins table
//Also drop the unused restrict_by_menuitem column and fix the default use_language_id 
	revision( 2505,
<<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]admins DROP COLUMN `restrict_by_menuitem`
_sql

);	revision( 2512,
<<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]admins MODIFY COLUMN `use_language_id` varchar(5) NOT NULL DEFAULT 'en-GB'
_sql

);	revision( 2513
, <<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]admins DROP KEY `username`
_sql


//Add new password columns to the admin table
	//password_salt - used to store a salt for the password, if it is encrypted.
	//password_needs_changing - set if the user should change their password
);	revision( 2521
, <<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]admins
	ADD `password_needs_changing` tinyint(1) NOT NULL DEFAULT 0
	AFTER `password`
_sql

, <<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]admins
	ADD `password_salt` varchar(8) NULL DEFAULT NULL
	AFTER `password`
_sql


//Originally int was mistakenly used instead of tinyint above; fix that on any databases
//that made the original change
);	revision( 2525
, <<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]admins
	MODIFY `password_needs_changing` tinyint(1) NOT NULL DEFAULT 0
_sql


//Add junior menu editor permission
);	revision( 2806
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]admins` 
	ADD COLUMN `perm_editmenu_jnr` tinyint(1) NOT NULL DEFAULT 0
_sql


//Create new permissions tables
);	revision( 4830
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]action_admin_link`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]action_admin_link` (
		`action_name` varchar(50) NOT NULL,
		`admin_id` int(10) unsigned NOT NULL,
		UNIQUE KEY (`action_name`, `admin_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Fix any bad data that is not valid for MySQL strict mode
);	revision( 7050
, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]admins SET
		status = 'pending'
	WHERE status NOT IN ('pending','active','suspended','deleted')
_sql

, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]admins SET
		note_email_min_priority = 'Normal'
	WHERE note_email_min_priority NOT IN ('','High','Normal','Low')
_sql


//Create new table for storing admin storekeeper settings
);	revision( 8430
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_storekeeper_prefs`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]admin_storekeeper_prefs` (
		`admin_id` int(10) unsigned NOT NULL,
		`admin_type` enum('local','super') NOT NULL,
		`prefs` mediumtext,
		PRIMARY KEY (`admin_id`, `admin_type`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Drop the now unused overview tables
);	revision( 9310
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_overview_feeds`
_sql


);
