<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */






//General Patch File for the Global Database

//Any updates for the global database that are not associated with a module
//	(i.e. updates that should apply to every version of the CMS)
//should be placed in here.
//Although I wouldn't expect many module updates for the global database,
//the functionality is there if needed...

//Updates are applied using the revision function, which takes inputs in the following format:
	//The first input is the revision number
		//Revision numbers are used by the program as a way of tracking whether the revision
		//has already been applied.
		//For example, if the database has recorded in it that it's current revision number
		//for admin/db_updates/core/global.inc.php is revision #2390, then only revisions
		//numbered 2391 or higher will be run.
		//The following rules apply for picking revision numbers
			//Revision numbers need to appear in order
			//When adding a new revision number, it should be greater than the current revision number
				//stored in the admin/db_updates/latest_revision_no.inc.php file
			//After adding a new revision number, the number stored in the
				//admin/db_updates/latest_revision_no.inc.php file should be updated to reflect this
		//If you use the SVN version number of your latest SVN commit as the revision number all this will
		//work itself out.
	//Inputs after the first input should be SQL statements to run as part of that revision.
		//They will be run as is, however the subsitution string [[DB_NAME_PREFIX_GLOBAL]] will be replaced by
		//the correct table name prefix.




//The username column need not be unique in the superadmins table
//Also drop the unused perm_design column
	revision( 2505
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]superadmins` DROP KEY `username`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]superadmins` DROP COLUMN `perm_design`
_sql


//Add new password columns to the admin table
	//password_salt - used to store a salt for the password, if it is encrypted.
	//password_needs_changing - set if the user should change their password
);	revision( 2521
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]superadmins`
	ADD `password_needs_changing` tinyint(1) NOT NULL DEFAULT 0
	AFTER `password`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]superadmins`
	ADD `password_salt` varchar(8) NULL DEFAULT NULL
	AFTER `password`
_sql


//Originally int was mistakenly used instead of tinyint above; fix that on any databases
//that made the original change
);	revision( 2525
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]superadmins`
	MODIFY `password_needs_changing` tinyint(1) NOT NULL DEFAULT 0
_sql


//Create new permissions tables
);	revision( 4845
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]roles`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]actions`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]action_superadmin_link`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]roles` (
		`name` varchar(50) NOT NULL,
		UNIQUE KEY `name` (`name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]actions` (
		`name` varchar(50) NOT NULL,
		`role_name` varchar(50) NOT NULL,
		UNIQUE KEY `name` (`name`, `role_name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]action_superadmin_link` (
		`action_name` varchar(50) NOT NULL,
		`admin_id` int(10) unsigned NOT NULL,
		UNIQUE KEY (`action_name`, `admin_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Add keys to the site_registry table
);	revision( 7039
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]site_registry`
	ADD PRIMARY KEY (`sitename`)
_sql


//Add keys to the public_urls table
);	revision( 7040
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]public_urls`
	ADD PRIMARY KEY (`public_url`)
_sql


//Fix any bad data that is not valid for MySQL strict mode
);	revision( 7050
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX_GLOBAL]]site_registry` SET
		admin_use_ssl = 'allow'
	WHERE admin_use_ssl NOT IN ('allow','force')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX_GLOBAL]]superadmins` SET
		status = 'pending'
	WHERE status NOT IN ('pending','active','suspended','deleted')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX_GLOBAL]]superadmins` SET
		note_email_min_priority = 'Normal'
	WHERE note_email_min_priority NOT IN ('','High','Normal','Low')
_sql


//Add an ordinal column to the roles table
);	revision( 7130
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]roles`
	ADD COLUMN `ordinal` int(10) NOT NULL default 0
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]roles`
	ADD INDEX (`ordinal`)
_sql


//Ensure that the default editor for admins is fckeditor
);	revision( 7351
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]superadmins`
	MODIFY COLUMN `preferred_editor_id` varchar(20) NOT NULL default 'fckeditor'
_sql

/*
//Remove the admin phrases table from the global database
);	revision( 9900
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]admin_phrases`
_sql*/


//Create a new table to replace url_alias_redirects table to use cID and cType
);	revision( 11722
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]spare_urls`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]spare_urls` (
		`sitename` varchar(50) NOT NULL,
		`requested_url` varchar(255) NOT NULL,
		`content_id` int(10) unsigned NOT NULL,
		`content_type` varchar(20) NOT NULL,
		KEY (`sitename`),
		KEY (`requested_url`),
		KEY `content_type` (`content_type`,`content_id`)
	)
_sql


//Create a global settings table
);	revision( 12150
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX_GLOBAL]]global_settings`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX_GLOBAL]]global_settings` (
		`name` varchar(50) NOT NULL,
		`value` blob,
		PRIMARY KEY  (`name`)
	)
_sql


//Add a "jobs enabled" column to the site_registry table
);	revision( 13525
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX_GLOBAL]]site_registry`
	ADD `jobs_enabled` tinyint(1) NOT NULL DEFAULT 0
	AFTER `force_public_url_refresh`
_sql

);


?>