<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */







//General Patch File

//Any updates that are not associated with a module
//	(i.e. updates that should apply to every version of the CMS)
//should be placed in here.

//Updates are applied using the revision function, which takes inputs in the following format:
	//The first input is the revision number
		//Revision numbers are used by the program as a way of tracking whether the revision
		//has already been applied.
		//For example, if the database has recorded in it that it's current revision number
		//for admin/db_updates/local/general.inc.php is revision #2390, then only revisions
		//numbered 2391 or higher will be run.
		//The following rules apply for picking revision numbers
			//Revision numbers need to appear in order
			//When adding a new revision number, it should be greater than the current revision number
				//stored in the admin/db_updates/latest_revision_no.inc.php file
			//After adding a new revision number, the number stored in the
				//admin/db_updates/latest_revision_no.inc.php file should be updated to reflect this
		//If you use the SVN version number of your latest SVN commit as the revision number all this will
		//work itself out.
	//Inputs after the first input should be SQL statements to run as part of that revision.
		//They will be run as is, however the subsitution string [[DB_NAME_PREFIX]] will be replaced by
		//the correct table name prefix.
		//For the first few SQL statements I have added below, I've gone out of my way to ensure
		//that they will not break if run twice. The reason for this is that they have already appeared
		//in the database change log, and I don't want to harm any database with the change log already applied.
		//From now on we won't have to worry about that, however.




//Add the `[[DB_NAME_PREFIX]]equiv_link` table if it does not exist
	revision( 2380
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]equiv_link`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]equiv_link` (
		`id` int(20) NOT NULL default 0,
		`shortcut_id` int(20) NOT NULL default 0
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Add table `[[DB_NAME_PREFIX]]skins`
);	revision( 2385
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]skins`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]skins`(
		id int(10) unsigned PRIMARY KEY AUTO_INCREMENT NOT NULL,
		family_name varchar(50) NOT NULL,
		name varchar(255) NOT NULL,
		active tinyint(1) DEFAULT 0 NOT NULL
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Add Birth Date column to users
);	revision( 2387
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD `birth_date` DATE NULL DEFAULT NULL
	AFTER `last_name`
_sql


//Add update_password_along_with_other_details option
);	revision( 2388
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]enet_user_val`
	ADD `update_password_along_with_other_details` ENUM( 'Yes', 'No' ) NOT NULL DEFAULT 'No'
	AFTER `auto_create_password`
_sql


//Added support for uploading jpegs
);	revision( 2403
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` SET type = 'jpg'
_sql

, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` SET type = 'jpeg'
_sql


//Added support for uploading EPS and Illustrator files
);	revision( 2422
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` SET type = 'ai'
_sql

, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` SET type = 'eps'
_sql


//Added support for some more document type
);	revision( 2465,
<<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` (`type`)
	VALUES ('png'), ('tif'), ('mp4'), ('mpeg')
_sql


//Add new columns to each of the content tables, to store whether each content item
//should log each access
);	revision( 2526
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_extranet`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_forum`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_nlar`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql


//Also add these columns to the temp tables
);	revision( 2533
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_extranet_tmp`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_forum_tmp`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_nlar_tmp`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
	ADD `log_user_access` tinyint(1) NOT NULL DEFAULT 0
	AFTER `private`
_sql


//Replace min_admin_password_length config setting with min_admin_password_strength
);	revision( 2556
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET
		name = 'min_admin_password_strength',
		value_format = "RADIO('_WEAK','_MEDIUM','_STRONG','_VERY_STRONG')",
		value = IF(value < 6, '_WEAK',
				IF(value < 9, '_MEDIUM',
				IF(value < 12, '_STRONG',
					'_VERY_STRONG')))
	WHERE name = 'min_admin_password_strength'
_sql


//Create accesslog table for user access logging
);	revision( 2564
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_content_accesslog`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]user_content_accesslog` (
		`user_id` int(10) unsigned NOT NULL default 0,
		`hit_datetime` datetime default NULL,
		`ip` VARCHAR(40) default NULL,
		`content_id` int(10) unsigned NOT NULL default 0,
		`content_type` varchar(20) NOT NULL default '',
		`content_version` int(10) unsigned NOT NULL default 0,
		KEY user_id (user_id),
		KEY `content_type` (`content_type`),
		KEY `content_id` (`content_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Alter the admin_menu_items table to work off of names rather than numbers
//I'm adding a parent_name column, and putting a unique key on name and parent_name.
//Unique keys must be under 1000 bytes in size; this restriction forces me to reduce the
//size of the name column a little.
);	revision( 2589
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_menuitems`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]admin_menuitems` (
	  `id` int(20) unsigned NOT NULL auto_increment,
	  `parent_name` varchar(127) NOT NULL default '',
	  `name` varchar(127) NOT NULL default '',
	  `url` text NOT NULL,
	  `ordinal` int(20) unsigned NOT NULL default 0,
	  PRIMARY KEY  (`id`),
	  UNIQUE KEY `name` (`name`,`parent_name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Added two new values for siteConfig 
);	revision( 2598
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET ordinal = ordinal + 2 WHERE section = 'General' AND ordinal > 6
_sql

, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]site_settings` SET name = 'company', section = 'General', ordinal = 7, value_format = 'TEXT'
_sql

, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]site_settings` SET name = 'url', section = 'General', ordinal = 8, value_format = 'TEXT'
_sql


//Add `[[DB_NAME_PREFIX]]template_family`
);	revision( 2623
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]template_family`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]template_family`(
		family_name varchar(50) NOT NULL,
		skin_id int(10) unsigned NULL DEFAULT NULL
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]templates` ADD COLUMN skin_id int(10) unsigned NULL
_sql


//The template_family table should have a row for each Template Family.
//Generate a list of Template Families that is is missing from the
//Templates table and populate it.
);	revision( 2625
, <<<_sql
	INSERT INTO `[[DB_NAME_PREFIX]]template_family`(family_name)
	SELECT DISTINCT family_name
	FROM `[[DB_NAME_PREFIX]]templates`
	WHERE family_name NOT IN (
		SELECT family_name
		FROM `[[DB_NAME_PREFIX]]template_family`
	)

_sql


//Add new columns to each of the content tables, to store whether each content item
//should log each access
);	revision( 2662
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_extranet`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_forum`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_nlar`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_extranet_tmp`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_forum_tmp`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_nlar_tmp`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
	ADD skin_id int(10) unsigned NULL DEFAULT NULL
	AFTER `template_id`
_sql


//Adding the group_images table incase anyone missed it from the 5.0.9 patch log
);	revision( 2668
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]group_images`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]group_images`(
		`group_id` int(10) unsigned NOT NULL default 0,
		`filename` varchar(50) NOT NULL default '',
		`mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg') NOT NULL default 'image/jpeg',
		`width` smallint(5) unsigned default NULL,
		`height` smallint(5) unsigned default NULL,
		`size` int(10) unsigned default NULL,
		`data` mediumblob,
		`checksum` varchar(32) NOT NULL default '',
		`usage` enum('thumbnail','medium','fullsize') default NULL,
		`sticky_flag` tinyint(1) NOT NULL default 0,
		PRIMARY KEY (`group_id`,`checksum`),
		KEY `group_id` (`group_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Added support logging of Diagnostic results
);	revision( 2712
, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_nlar`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_nlar`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_extranet`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_extranet`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_forum`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_forum`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql


//Added support logging of Diagnostic results
);	revision( 2716

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_nlar_tmp`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_nlar_tmp`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_extranet_tmp`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_extranet_tmp`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_forum_tmp`
ADD COLUMN `diagnostic_last_run` datetime NULL AFTER `diagnostic_page`;
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]content_forum_tmp`
ADD COLUMN `diagnostic_last_status` tinyint(1) NULL AFTER `diagnostic_page`;
_sql


//Move the IP column to the end of the user_content_accesslog table,
//and the user_id to just after the time
);	revision( 2763
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_content_accesslog`
	MODIFY `ip` varchar(40) DEFAULT NULL AFTER `content_version`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_content_accesslog`
	MODIFY `user_id` int(10) unsigned NOT NULL default 0 AFTER `hit_datetime`
_sql


//Add a unique key to skins to stop accidental duplicate inserts
);	revision( 2770
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]skins`
	ADD UNIQUE KEY (family_name, name)
_sql


//Move the IP column to the end of the user_content_accesslog table,
//and convert it from being a varchar to being an int
//Also move the user_id to just after the time
);	revision( 2800
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_content_accesslog`
	CHANGE `ip` `ip_temp` varchar(40) DEFAULT NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_content_accesslog`
	ADD `ip` int(10) unsigned NOT NULL default 0
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]user_content_accesslog` SET
	`ip` = INET_ATON(`ip_temp`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_content_accesslog`
	DROP COLUMN `ip_temp`
_sql


//Remove an old table that was there for testing.
);	revision( 2814
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]flagged_items`
_sql


//Ensure that the Template Family table is populated.
//There should be a Template Family entry for each Template Family being used in
//the Templates table
);	revision( 3024
, <<<_sql
	INSERT INTO `[[DB_NAME_PREFIX]]template_family`
		(family_name, skin_id)
	SELECT DISTINCT
		family_name, NULL
	FROM `[[DB_NAME_PREFIX]]templates`
	WHERE family_name NOT IN (
		SELECT DISTINCT family_name
		FROM `[[DB_NAME_PREFIX]]template_family`)
_sql


//Add parent_id into the categories table
);	revision( 3035
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	ADD `parent_id` int(10) unsigned NULL default NULL
_sql


//Add parent_id into the users table
);	revision( 3036
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD `parent_id` int(10) unsigned NULL default NULL
_sql


//Move parent_id columns up next to the ids
);	revision( 3069
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	MODIFY `parent_id` int(10) unsigned NULL default NULL AFTER `id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY `parent_id` int(10) unsigned NULL default NULL AFTER `id`
_sql


//Changed setting names
);	revision( 3106
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET name = 'document_description_weighting' WHERE name = 'document_desc_weighting'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET name = 'document_keywords_weighting' WHERE name = 'document_keyword_weighting'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET name = 'html_description_weighting' WHERE name = 'html_desc_weighting'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET name = 'html_keywords_weighting' WHERE name = 'html_keyword_weighting'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET name = 'news_description_weighting' WHERE name = 'news_desc_weighting'
_sql

, <<<_sql
UPDATE `[[DB_NAME_PREFIX]]site_settings` SET name = 'news_keywords_weighting' WHERE name = 'news_keyword_weighting'
_sql


//Add avi into the allowed document types
);	revision( 3668
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` (`type`)
	VALUES ('avi');
_sql


//Create tables for plugins, instances and slots
);	revision( 3787
//Remove old development versions of the table, for anyone with a dev version of Tribiq or version 5.0.12b
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_setting_defs`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_global`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_by_plugin`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_by_slot`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_by_item`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_for_slot`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_for_item`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_for_slot_item`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_for_site`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_slot_link`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_instances`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_inst_temp_link`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_inst_item_link`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs` (
		`plugin_id` int(10) unsigned NOT NULL,
		`setting_for` ENUM('slot', 'site') NOT NULL,
		`section` varchar(50) NOT NULL,
		`ordinal` int(10) unsigned NOT NULL default 0,
		`name` varchar(50) NOT NULL,
		`type` blob NOT NULL,
		`default_value` blob,
		`require` enum('OR','AND') NOT NULL default 'AND',
		`authtype` enum('both','local','super') NOT NULL default 'both',
		`satisfy_permissions` set(
			'perm_manage','perm_sysadmin','perm_publish','perm_author','perm_editmenu',
			'perm_manageforum','perm_override_author_lock','perm_view_users','perm_edit_users',
			'perm_view_groups','perm_edit_groups','perm_translate'
		) NOT NULL default '',
		PRIMARY KEY  (`plugin_id`, `name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_instances` (
		`id` int(10) unsigned NOT NULL auto_increment,
		`name` varchar(250) NOT NULL,
		`plugin_id` int(10) unsigned NOT NULL,
		UNIQUE  KEY (`name`),
		PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_settings` (
		`plugin_id` int(10) unsigned NOT NULL,
		`instance_id` int(10) unsigned NOT NULL,
		`setting_for` ENUM('slot', 'site') NOT NULL,
		`published` tinyint(1) NOT NULL default 0,
		`name` varchar(50) NOT NULL,
		`value` blob,
		PRIMARY KEY  (`plugin_id`, `instance_id`, `published`, `name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link` (
		`instance_id` int(10) unsigned NOT NULL,
		`family_name` varchar(50) NOT NULL,
		`slot_name` varchar(100) NOT NULL,
		PRIMARY KEY (`family_name`, `slot_name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_link` (
		`instance_id` int(10) unsigned NOT NULL,
		`family_name` varchar(50) NOT NULL,
		`template_id` int(10) unsigned NOT NULL,
		`slot_name` varchar(100) NOT NULL,
		PRIMARY KEY (`family_name`, `template_id`, `slot_name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_item_link` (
		`instance_id` int(10) unsigned NOT NULL,
		`content_id` int(10) unsigned NOT NULL,
		`content_type` varchar(20) NOT NULL,
		`content_version` int(10) unsigned NOT NULL,
		`slot_name` varchar(100) NOT NULL,
		PRIMARY KEY (`content_id`, `content_type`, `content_version`, `slot_name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Alter images table for storekeeper
);	revision( 3801
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD COLUMN `storekeeper_width` smallint(5) unsigned default NULL
	AFTER `sticky_flag`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD COLUMN `storekeeper_height` smallint(5) unsigned default NULL
	AFTER `storekeeper_width`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD COLUMN `storekeeper_data` mediumblob
	AFTER `storekeeper_height`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD COLUMN `storekeeper_size` int(10) unsigned default NULL
	AFTER `storekeeper_data`
_sql


//Make sure that the name column in the plugin table is unique
);	revision( 3910
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD UNIQUE (`name`)
_sql


//Make sure that the menu plugin is running be default
);	revision( 3915
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'menu',
		`status` = '_ENUM_RUNNING'
_sql


//Add an "important" column to the plugin instances table
);	revision( 3918
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	ADD COLUMN `important` tinyint(1) default 0 NOT NULL
_sql


//Make sure that the content plugin is running be default
);	revision( 3948
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'content',
		`status` = '_ENUM_RUNNING'
_sql


//Add archived column to images table
);	revision( 3961
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images` 
	ADD COLUMN `archived` tinyint(1) NOT NULL DEFAULT 0
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` 
	INNER JOIN `[[DB_NAME_PREFIX]]content_document` AS c 
	ON content_item_id = c.id 
		AND content_item_version = c.version 
	SET archived = 1 
	WHERE status = 'archived' 
		AND content_item_type = 'document';
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` 
	INNER JOIN `[[DB_NAME_PREFIX]]content_event` AS c 
	ON content_item_id = c.id 
		AND content_item_version = c.version 
	SET archived = 1 
	WHERE status = 'archived' 
		AND content_item_type = 'event';
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` 
	INNER JOIN `[[DB_NAME_PREFIX]]content_extranet` AS c 
	ON content_item_id = c.id 
		AND content_item_version = c.version 
	SET archived = 1 
	WHERE status = 'archived' 
		AND content_item_type = 'extranet';
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` 
	INNER JOIN `[[DB_NAME_PREFIX]]content_forum` AS c 
	ON content_item_id = c.id 
		AND content_item_version = c.version 
	SET archived = 1 
	WHERE status = 'archived' 
		AND content_item_type = 'forum';
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` 
	INNER JOIN `[[DB_NAME_PREFIX]]content_html` AS c 
	ON content_item_id = c.id 
		AND content_item_version = c.version 
	SET archived = 1 
	WHERE status = 'archived' 
		AND content_item_type = 'html';
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` 
	INNER JOIN `[[DB_NAME_PREFIX]]content_news` AS c 
	ON content_item_id = c.id 
		AND content_item_version = c.version 
	SET archived = 1 
	WHERE status = 'archived' 
		AND content_item_type = 'news';
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` 
	INNER JOIN `[[DB_NAME_PREFIX]]content_nlar` AS c 
	ON content_item_id = c.id 
		AND content_item_version = c.version 
	SET archived = 1 
	WHERE status = 'archived' 
		AND content_item_type = 'nlar';
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` 
	INNER JOIN `[[DB_NAME_PREFIX]]content_picture` AS c 
	ON content_item_id = c.id 
		AND content_item_version = c.version 
	SET archived = 1 
	WHERE status = 'archived' 
		AND content_item_type = 'picture';
_sql


//Drop table plugin_slot_item_link if it has been created
//(It's another dev table that we forgot to trim in revision #3787)
);	revision( 3970
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_slot_item_link`
_sql


//Make sure that the breadcrumbs plugin is running be default
);	revision( 3979
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'breadcrumbs',
		`status` = '_ENUM_RUNNING'
_sql


//Add a categories column to the plugins table
);	revision( 4000
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `category` varchar(32) default '_MISC' NOT NULL
	AFTER `name`
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		`category` = '_CORE'
	WHERE `name` IN ('menu', 'breadcrumbs', 'content')
_sql


//Remove the "important" column in the plugin_instances table...
);	revision( 4001
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	DROP COLUMN `important`
_sql


//...and add "backwards_compatibility_use"
);	revision( 4002
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	ADD COLUMN `backwards_compatibility_use`
		ENUM(
			'none',
			'content_bodytop',
			'content_bodymain',
			'content_bodyfoot',
			'breadcrumbs'
		) default 'none' NOT NULL
_sql


//Add a column to the plugins table to determine which plugins use instances
);	revision( 4011
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `uses_instances` tinyint(1) default 0 NOT NULL
	AFTER `category`
_sql


//Remove permissions columns from plugin setting definitions
);	revision( 4020
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP COLUMN `require`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP COLUMN `authtype`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP COLUMN `satisfy_permissions`
_sql


//Remove the category column
);	revision( 4030
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	DROP COLUMN `category`
_sql


//Alter the links table, expanding the size of the "block" column to
//match the size of the plugin slotname column
);	revision( 4100
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	MODIFY COLUMN `block` varchar(100) NOT NULL default ''
_sql


//Added new storekeeper columns to links table
);  revision( 4222
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	ADD COLUMN `storekeeper_width` smallint(5) unsigned AFTER `img_checksum`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	ADD COLUMN `storekeeper_height` smallint(5) unsigned AFTER `storekeeper_width`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	ADD COLUMN `storekeeper_data` mediumblob AFTER `storekeeper_height`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	ADD COLUMN `storekeeper_data` int(10) unsigned unsigned AFTER `storekeeper_data`
_sql

); revision( 4231
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	ADD COLUMN `img_filename` varchar(5) NOT NULL AFTER `count_outgoing`
_sql


//Add display name column to the plugins table, defaulting it to the filename
//Also add version column
); revision( 4240
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `display_name` varchar(255) NULL AFTER `name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `version` varchar(32) NULL AFTER `display_name`
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		display_name = name,
		version = '0.1'
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	MODIFY COLUMN `display_name` varchar(255) NOT NULL
_sql


//Also add company_name columns column
); revision( 4241
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `company_name` varchar(255) NOT NULL DEFAULT '' AFTER `version`
_sql


//Convert the plugin names to the new format
); revision( 4242
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins`
	SET `name` = CONCAT('tribiq_', `name`, '_v1')
	WHERE `name` != 'api'
	  AND `name` NOT IN ('howarewe_outlets', 'howarewe_questionnaires')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins`
	SET `name` = CONCAT(`name`, '_v1')
	WHERE `name` IN ('howarewe_outlets', 'howarewe_questionnaires')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]local_revision_numbers`
	SET `path` = CONCAT('plugins/tribiq_', SUBSTR(`path`, 9, INSTR(`path`, '/db_updates')-9), '_v1/db_updates')
	WHERE SUBSTR(`path`, 1, 8) = 'plugins/'
	  AND SUBSTR(`path`, -11) = '/db_updates'
	  AND `path` NOT IN ('plugins/howarewe_outlets/db_updates', 'plugins/howarewe_questionnaires/db_updates')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]local_revision_numbers`
	SET `path` = CONCAT('plugins/', SUBSTR(`path`, 9, INSTR(`path`, '/db_updates')-9), '_v1/db_updates')
	WHERE `path` IN ('plugins/howarewe_outlets/db_updates', 'plugins/howarewe_questionnaires/db_updates')
_sql


//Add auto increment id to image table
); revision( 4265
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD COLUMN `id` int(10) unsigned auto_increment NOT NULL UNIQUE FIRST
_sql

//Added new storekeeper columns to links table
);  revision( 4271
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	ADD COLUMN `storekeeper_size` int(10) unsigned AFTER `storekeeper_data`
_sql


//Added storekeeper thumbnail image fields to user and group image tables
);  revision( 4472
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_images` 
	ADD COLUMN `storekeeper_width` smallint(5) unsigned NULL AFTER sticky_flag;
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_images` 
	ADD COLUMN `storekeeper_height` smallint(5) unsigned NULL AFTER storekeeper_width;
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_images` 
	ADD COLUMN `storekeeper_data` mediumblob NULL AFTER storekeeper_height;
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_images` 
	ADD COLUMN `storekeeper_size` int(10) unsigned NULL AFTER storekeeper_data;
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]group_images` 
	ADD COLUMN `storekeeper_width` smallint(5) unsigned NULL AFTER sticky_flag;
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]group_images` 
	ADD COLUMN `storekeeper_height` smallint(5) unsigned NULL AFTER storekeeper_width;
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]group_images` 
	ADD COLUMN `storekeeper_data` mediumblob NULL AFTER storekeeper_height;
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]group_images` 
	ADD COLUMN `storekeeper_size` int(10) unsigned NULL AFTER storekeeper_data;
_sql


//Add a cache killer function to shortcut images
);  revision( 4500
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	ADD COLUMN `img_version` int(10) unsigned NOT NULL default 1 AFTER `img_checksum`
_sql


//Remove all set plugins, due to a bug fix and another name change as they will no longer be reachable anyway
);	revision( 4515
, <<<_sql
	TRUNCATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_item_link`
_sql

, <<<_sql
	TRUNCATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_link`
_sql

, <<<_sql
	TRUNCATE TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link`
_sql


//Add a "target type" column to the menu items table
);	revision( 4560
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]menuitems`
	ADD COLUMN `target_loc` enum('int','ext','none') NOT NULL default 'int' AFTER `accesskey`
_sql


//Rename the language_picker_lite plugin to language_picker, unless the language_picker already exists
);	revision( 4580
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		name = 'tribiq_language_picker_v1'
	WHERE name IN ('tribiq_language_picker_v1', 'tribiq_language_picker_lite_v1')
	ORDER BY name DESC
	LIMIT 1
_sql


);	revision( 4607
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]movies` ADD COLUMN `id` int(10) unsigned NOT NULL AUTO_INCREMENT UNIQUE FIRST
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]movies` ADD COLUMN `archived` tinyint(1) NOT NULL DEFAULT 0
_sql


//Add plugin theme columns into the database
);	revision( 4646
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances` ADD COLUMN `theme` varchar(50) NOT NULL default '' AFTER `plugin_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins` ADD COLUMN `default_theme` varchar(50) NOT NULL default '' AFTER `company_name`
_sql


//Add a "first section" column into the plugins table
);	revision( 4660
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins` ADD COLUMN `first_section` varchar(50) NOT NULL default '' AFTER `default_theme`
_sql


//Changing the format of the site_settings to the MySQL format used by the dynamic thickbox function
);	revision( 4750
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET
		value_format = 'tinyint(1)',
		`value` = REPLACE(REPLACE(`value`, 'true', 1), 'false', '')
	WHERE value_format = "RADIO('true','false')"
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]site_settings` SET
		value_format = REPLACE(REPLACE(value_format, 'TEXT', 'varchar(255)'), 'RADIO', 'enum')
_sql

//Added Primary Key to template_family
);	revision( 4822
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]template_family`
	ADD PRIMARY KEY (family_name)
_sql


//Re-ordered columns in the languages table
);	revision( 4929
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	MODIFY COLUMN `language_local_name` varchar(100) NOT NULL default '' AFTER `id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	MODIFY COLUMN `default_search_page_alias` varchar(50) NOT NULL default '' AFTER `default_homepage_alias`
_sql

//Added admin toolbar tables
);	revision( 4988
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_toolbar_tab`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]admin_toolbar_tab`
	(
	`id` int(10) unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`name` varchar(255) NOT NULL UNIQUE
	)
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_toolbar_section`
_sql

, <<<_sql
CREATE TABLE `[[DB_NAME_PREFIX]]admin_toolbar_section`
	(
	`id` int(10) unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`admin_toolbar_tab_id` int(10) unsigned NOT NULL,
	`name` varchar(255) NOT NULL,
	UNIQUE (`admin_toolbar_tab_id`,`name`)
	)
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_toolbar_button`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]admin_toolbar_button`
	(
	`id` int(10) unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`admin_toolbar_section_id` int(10) unsigned NOT NULL,
	`name` varchar(255) NOT NULL UNIQUE,
	`onclick_function` varchar(255) NOT NULL,
	`display_class` varchar(255) NOT NULL,
	`action_name` varchar(255) NOT NULL,
	UNIQUE (`admin_toolbar_section_id`,`name`)
	)
_sql

//Added ordinal fields to admin toolbar tables, dropped onclick_function field, truncated data and repopulated
);	revision( 5004
, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]admin_toolbar_tab` 
ADD COLUMN `ordinal` int(10) unsigned NOT NULL
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]admin_toolbar_section` 
ADD COLUMN `ordinal` int(10) unsigned NOT NULL
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]admin_toolbar_button` 
ADD COLUMN `ordinal` int(10) unsigned NOT NULL
_sql

, <<<_sql
ALTER TABLE `[[DB_NAME_PREFIX]]admin_toolbar_button` 
DROP COLUMN `onclick_function`
_sql


//Try to eliminate any duplicates from the raw_picture_store table
);	revision( 5100
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]temp_5105`
_sql

);	revision( 5101
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]raw_picture_store`
	RENAME TO `[[DB_NAME_PREFIX]]temp_5105`
_sql

);	revision( 5102
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]raw_picture_store`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]raw_picture_store` (
	  `content_id` int(10) unsigned default NULL,
	  `content_version` int(10) unsigned NOT NULL,
	  `data` longblob,
	  UNIQUE KEY (`content_id`,`content_version`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

);	revision( 5103
, <<<_sql
	INSERT INTO `[[DB_NAME_PREFIX]]raw_picture_store`
		(content_id, content_version, `data`)
	SELECT
		content_id, content_version, `data`
	FROM `[[DB_NAME_PREFIX]]temp_5105`
	GROUP BY content_id, content_version
_sql

);	revision( 5104
, <<<_sql
	DROP TABLE `[[DB_NAME_PREFIX]]temp_5105`
_sql


//Update the menu items table, changing the default target-type to "none" to fix
//a bug with newly created menu items where the admin does not set the destination
);	revision( 5104
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]menuitems`
	MODIFY COLUMN `target_loc` enum('int','ext','none') NOT NULL default 'none'
_sql


//Drop the backwards_compatibility_use column
);	revision( 5145
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	DROP COLUMN `backwards_compatibility_use`
_sql


//Add a class name column to a plugin
);	revision( 5165
//Add the new column
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `class_name` varchar(255) NULL AFTER `name`
_sql

//For developers with test versions, clear out any plugins in that look like junk
, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]plugins`
	WHERE `name` NOT LIKE '%_v1'
_sql

//For developers with test versions, populate the class_name column from the name column
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		`class_name` = REPLACE(`name`, '_v1', '')
_sql

//Now it has been populated, make the column NOT NULL
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	MODIFY COLUMN `class_name` varchar(255) NOT NULL
_sql


//Add a unique key for class name
);	revision( 5170
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD UNIQUE (`class_name`, `version`)
_sql


//Add a column for tracking which version of a plugin is currently running and has data
);	revision( 5175
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `has_data` tinyint(1) NOT NULL DEFAULT 0 AFTER `status`
_sql


//Remove all uninitialised plugins, as due to a change they will need to be re-inserted into the
//database to pick up their proper names
);	revision( 5170
, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]plugins`
	WHERE `status` = '_ENUM_INSTALLED'
_sql


//Change around the columns on the plugin_settings and plugin_setting_defs tables
);	revision( 5190

//Remove the primary keys, as the columns we are dropping are inside the keys
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	DROP PRIMARY KEY
_sql

//Remove a primary key, as the columns we are dropping are inside it
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP PRIMARY KEY
_sql

//Remove the "setting_for" column, and remove the plugin_id column from the plugin settings table
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	DROP COLUMN `plugin_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	DROP COLUMN `setting_for`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP COLUMN `setting_for`
_sql

//Add a new version of the primary key back
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	ADD PRIMARY KEY (`instance_id`,`published`,`name`)
_sql


//Add the public name and members_are_employees columns to the groups table
);	revision( 5200
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]groups`
	ADD COLUMN `public_name` varchar(255) NOT NULL default ''
	AFTER `name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]groups`
	ADD COLUMN `members_are_employees` tinyint(1) NOT NULL default 0
	AFTER `description`
_sql


//Add the public name and members_are_employees columns to the groups table
);	revision( 5201
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_instance_cache`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_instance_cache` (
		`instance_id` int(10) unsigned NOT NULL,
		`method_name` varchar(255) NOT NULL,
		`last_updated` datetime NOT NULL,
		`cache` text NOT NULL,
		PRIMARY KEY (`instance_id`, `method_name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Add a "type" column to the content type settings table
);	revision( 5220
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttype_settings`
	ADD COLUMN `type` blob
	AFTER `ordinal`
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]contenttype_settings` SET
		`type` = 'int'
	WHERE `name` IN ('standard_width', 'standard_height')
_sql

//While I'm at it, rename the "value_format" column in the site_settings table to be
//in line with the plugin setting defs and the content types table
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]site_settings`
	CHANGE COLUMN `value_format` `type` blob
_sql


//Update admin toolbar buttons
);	revision ( 5299
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]admin_toolbar_button`
	ADD COLUMN show_next_separator tinyint(1) default 1 NOT NULL
_sql


//Change around the columns on the plugin_settings and plugin_setting_defs tables
);	revision( 5600
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD COLUMN `allow_newsletters` tinyint(1) NOT NULL default 1
	AFTER `email_verified`
_sql


//Add a "label" column to the Plugin Settings definition table
);	revision( 5680
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	ADD COLUMN `label` varchar(255) NOT NULL default ''
	AFTER `name`
_sql


//Removed the first_section column from the Plugins table as it is no longer needed
);	revision( 5685
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	DROP COLUMN `first_section`
_sql


//Remove the "install error" column from the Plugins table, for any developers that had it
);	revision( 5690
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	DROP COLUMN `install_error`
_sql


//Add a Plugin Id column into the primary key of the visitor phrases table
);	revision( 5692
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	ADD COLUMN `plugin_id` int(20) unsigned NOT NULL default 0
	AFTER `language_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	ADD PRIMARY KEY (`code`, `language_id`, `plugin_id`)
_sql


//Add an "invisible" column to the menu items table
);	revision( 5828
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]menuitems`
	ADD COLUMN `invisible` tinyint(1) NOT NULL default 0
	AFTER `active`
_sql


//Update admin toolbar buttons
);	revision ( 5878
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]site_settings` 
	DROP COLUMN `section`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]site_settings` 
	DROP COLUMN `ordinal`
_sql


//Forcebly insert the Community Features Plugin into the list of running Plugins
);	revision( 5941
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'tribiq_cms_core_v1',
		`class_name` = 'tribiq_cms_core',
		`status` = '_ENUM_RUNNING'
_sql


//Add a Plugin id column to the content-types table
);	revision( 5960
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	ADD COLUMN `plugin_id` int(20) unsigned NOT NULL default 0
_sql


//Clear the content types tables.
//(A revision in the data_conversion script will add them back from the Community Plugin)
);	revision( 5970
, <<<_sql
	TRUNCATE TABLE `[[DB_NAME_PREFIX]]contenttypes`
_sql

, <<<_sql
	TRUNCATE TABLE `[[DB_NAME_PREFIX]]contenttype_settings`
_sql


//Create content tables for the new content types in Pro Business
);	revision( 5985
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_audio`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]content_audio` (
	  `id` int(10) unsigned NOT NULL default 0,
	  `version` int(10) unsigned NOT NULL default '1',
	  `title` varchar(250) NOT NULL default '',
	  `private` tinyint(1) NOT NULL default 0,
	  `log_user_access` tinyint(1) NOT NULL default 0,
	  `language_id` varchar(5) NOT NULL default 'en',
	  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
	  `draft_exists` tinyint(1) NOT NULL default 0,
	  `created_datetime` datetime default NULL,
	  `owner_id` int(10) unsigned NOT NULL default 0,
	  `owner_authtype` enum('local','super') default NULL,
	  `creating_author_id` int(10) unsigned NOT NULL default 0,
	  `creating_author_authtype` enum('local','super') default NULL,
	  `allow_local_coauthor_id` int(10) unsigned NOT NULL default 0,
	  `last_author_id` int(10) unsigned NOT NULL default 0,
	  `last_author_authtype` enum('local','super') default NULL,
	  `publisher_id` int(10) unsigned NOT NULL default 0,
	  `publisher_authtype` enum('local','super') default NULL,
	  `published_datetime` datetime default NULL,
	  `hider_id` int(10) unsigned NOT NULL default 0,
	  `hider_authtype` enum('local','super') default NULL,
	  `hidden_datetime` datetime default NULL,
	  `archiver_id` int(10) unsigned NOT NULL default 0,
	  `archiver_authtype` enum('local','super') default NULL,
	  `archived_datetime` datetime default NULL,
	  `expiry_datetime` datetime default NULL,
	  `expiry_action` enum('delete','hide','alert') default NULL,
	  `folder_id` int(10) unsigned NOT NULL default 0,
	  `description` text,
	  `keywords` text,
	  `template_id` int(10) unsigned NOT NULL default 0,
	  `skin_id` int(10) unsigned default NULL,
	  `content_head` text,
	  `content_bodytop` mediumtext,
	  `content_bodymain` mediumtext,
	  `content_bodyfoot` mediumtext,
	  `filename` varchar(100) default NULL,
	  `mime_type` varchar(50) default NULL,
	  `size` int(10) unsigned default NULL,
	  `spare_varchar1` varchar(250) NOT NULL default '',
	  `spare_varchar2` varchar(250) NOT NULL default '',
	  `new_menu_text` varchar(250) NOT NULL default '',
	  `publication_date` date default NULL,
	  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
	  `seo_sitemap_priority` float(3,1) default NULL,
	  `diagnostic_page` tinyint(1) NOT NULL default 0,
	  `diagnostic_last_status` tinyint(1) default NULL,
	  `diagnostic_last_run` datetime default NULL,
	  `enable_rss` tinyint(1) default '0',
	  `microsite_id` int(10) unsigned default NULL,
	  PRIMARY KEY  (`id`,`version`),
	  KEY `folder_id` (`folder_id`),
	  KEY `publication_date` (`publication_date`),
	  KEY `version` (`version`),
	  FULLTEXT KEY `title` (`title`),
	  FULLTEXT KEY `keywords` (`keywords`),
	  FULLTEXT KEY `description` (`description`),
	  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
	  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
	  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_video`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]content_video` (
	  `id` int(10) unsigned NOT NULL default 0,
	  `version` int(10) unsigned NOT NULL default '1',
	  `title` varchar(250) NOT NULL default '',
	  `private` tinyint(1) NOT NULL default 0,
	  `log_user_access` tinyint(1) NOT NULL default 0,
	  `language_id` varchar(5) NOT NULL default 'en',
	  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
	  `draft_exists` tinyint(1) NOT NULL default 0,
	  `created_datetime` datetime default NULL,
	  `owner_id` int(10) unsigned NOT NULL default 0,
	  `owner_authtype` enum('local','super') default NULL,
	  `creating_author_id` int(10) unsigned NOT NULL default 0,
	  `creating_author_authtype` enum('local','super') default NULL,
	  `allow_local_coauthor_id` int(10) unsigned NOT NULL default 0,
	  `last_author_id` int(10) unsigned NOT NULL default 0,
	  `last_author_authtype` enum('local','super') default NULL,
	  `publisher_id` int(10) unsigned NOT NULL default 0,
	  `publisher_authtype` enum('local','super') default NULL,
	  `published_datetime` datetime default NULL,
	  `hider_id` int(10) unsigned NOT NULL default 0,
	  `hider_authtype` enum('local','super') default NULL,
	  `hidden_datetime` datetime default NULL,
	  `archiver_id` int(10) unsigned NOT NULL default 0,
	  `archiver_authtype` enum('local','super') default NULL,
	  `archived_datetime` datetime default NULL,
	  `expiry_datetime` datetime default NULL,
	  `expiry_action` enum('delete','hide','alert') default NULL,
	  `folder_id` int(10) unsigned NOT NULL default 0,
	  `description` text,
	  `keywords` text,
	  `template_id` int(10) unsigned NOT NULL default 0,
	  `skin_id` int(10) unsigned default NULL,
	  `content_head` text,
	  `content_bodytop` mediumtext,
	  `content_bodymain` mediumtext,
	  `content_bodyfoot` mediumtext,
	  `filename` varchar(100) default NULL,
	  `mime_type` varchar(50) default NULL,
	  `size` int(10) unsigned default NULL,
	  `width` smallint(5) unsigned default NULL,
	  `height` smallint(5) unsigned default NULL,
	  `spare_varchar1` varchar(250) NOT NULL default '',
	  `spare_varchar2` varchar(250) NOT NULL default '',
	  `new_menu_text` varchar(250) NOT NULL default '',
	  `publication_date` date default NULL,
	  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
	  `seo_sitemap_priority` float(3,1) default NULL,
	  `diagnostic_page` tinyint(1) NOT NULL default 0,
	  `diagnostic_last_status` tinyint(1) default NULL,
	  `diagnostic_last_run` datetime default NULL,
	  `enable_rss` tinyint(1) default '0',
	  `microsite_id` int(10) unsigned default NULL,
	  PRIMARY KEY  (`id`,`version`),
	  KEY `folder_id` (`folder_id`),
	  KEY `publication_date` (`publication_date`),
	  KEY `version` (`version`),
	  FULLTEXT KEY `title` (`title`),
	  FULLTEXT KEY `keywords` (`keywords`),
	  FULLTEXT KEY `description` (`description`),
	  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
	  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
	  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_audio_tmp`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]content_audio_tmp` (
	  `id` int(10) unsigned NOT NULL default 0,
	  `version` int(10) unsigned NOT NULL default '1',
	  `title` varchar(250) NOT NULL default '',
	  `private` tinyint(1) NOT NULL default 0,
	  `log_user_access` tinyint(1) NOT NULL default 0,
	  `language_id` varchar(5) NOT NULL default 'en',
	  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
	  `draft_exists` tinyint(1) NOT NULL default 0,
	  `created_datetime` datetime default NULL,
	  `owner_id` int(10) unsigned NOT NULL default 0,
	  `owner_authtype` enum('local','super') default NULL,
	  `creating_author_id` int(10) unsigned NOT NULL default 0,
	  `creating_author_authtype` enum('local','super') default NULL,
	  `allow_local_coauthor_id` int(10) unsigned NOT NULL default 0,
	  `last_author_id` int(10) unsigned NOT NULL default 0,
	  `last_author_authtype` enum('local','super') default NULL,
	  `publisher_id` int(10) unsigned NOT NULL default 0,
	  `publisher_authtype` enum('local','super') default NULL,
	  `published_datetime` datetime default NULL,
	  `hider_id` int(10) unsigned NOT NULL default 0,
	  `hider_authtype` enum('local','super') default NULL,
	  `hidden_datetime` datetime default NULL,
	  `archiver_id` int(10) unsigned NOT NULL default 0,
	  `archiver_authtype` enum('local','super') default NULL,
	  `archived_datetime` datetime default NULL,
	  `expiry_datetime` datetime default NULL,
	  `expiry_action` enum('delete','hide','alert') default NULL,
	  `folder_id` int(10) unsigned NOT NULL default 0,
	  `description` text,
	  `keywords` text,
	  `template_id` int(10) unsigned NOT NULL default 0,
	  `skin_id` int(10) unsigned default NULL,
	  `content_head` text,
	  `content_bodytop` mediumtext,
	  `content_bodymain` mediumtext,
	  `content_bodyfoot` mediumtext,
	  `filename` varchar(100) default NULL,
	  `mime_type` varchar(50) default NULL,
	  `size` int(10) unsigned default NULL,
	  `spare_varchar1` varchar(250) NOT NULL default '',
	  `spare_varchar2` varchar(250) NOT NULL default '',
	  `new_menu_text` varchar(250) NOT NULL default '',
	  `publication_date` date default NULL,
	  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
	  `seo_sitemap_priority` float(3,1) default NULL,
	  `diagnostic_page` tinyint(1) NOT NULL default 0,
	  `diagnostic_last_status` tinyint(1) default NULL,
	  `diagnostic_last_run` datetime default NULL,
	  `enable_rss` tinyint(1) default '0',
	  `microsite_id` int(10) unsigned default NULL
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Add a "none" option to shortcuts
);	revision( 6000
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	MODIFY COLUMN `target_loc`
	enum('int', 'ext', 'none') NOT NULL default 'none'
_sql


//Fix for categories table parent_id field
);	revision( 6038
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	MODIFY COLUMN `parent_id` int(10) unsigned NOT NULL default 0
_sql

//Increase name field length
);	revision( 6051
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	MODIFY COLUMN `name` varchar(50) NOT NULL
_sql


//Add a key to the email column of the users table
);	revision( 6077
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD KEY (`email`)
_sql


//Remove the "has data" column (functionality is now being handled by the compatibility option in the plugin_dependencies table
);	revision( 6100
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	DROP COLUMN `has_data`
_sql


//Add a new key to visitor phrases table, for checking if a Plugin has any phrases
);	revision( 6110
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	ADD KEY (`plugin_id`,`language_id`)
_sql


//Rename the Plugin "tribiq_cms_core_community_v1" to "tribiq_cms_core_v1"
//and "tribiq_extranet_lite_v1" to "tribiq_extranet_v1"
);	revision( 6122
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'tribiq_cms_core_v1',
		class_name = 'tribiq_cms_core'
	WHERE `name` = 'tribiq_cms_core_community_v1'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'tribiq_extranet_v1',
		class_name = 'tribiq_extranet'
	WHERE `name` = 'tribiq_extranet_lite_v1'
_sql

); revision( 6168
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]raw_video_store`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]raw_video_store` 
	(   
		`content_id` int(10) unsigned default NULL,   
		`content_version` int(10) unsigned NOT NULL,   
		`data` longblob,   
		UNIQUE KEY `content_id` (`content_id`,`content_version`) 
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Fixed a bug where the ip address column in the user_content_accesslog table was not correctly signed!
);	revision( 6229
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_content_accesslog`
	MODIFY `ip` int(10) signed NOT NULL default 0
_sql


//Remove the placeholder for the Presentation content type
);	revision( 6240
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_presentation`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_presentation_tmp`
_sql

, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]contenttypes`
	WHERE content_type_id = 'presentation'
_sql

); revision( 6268
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]raw_audio_store`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]raw_audio_store` 
	(   
		`content_id` int(10) unsigned default NULL,   
		`content_version` int(10) unsigned NOT NULL,   
		`data` longblob,   
		UNIQUE KEY `content_id` (`content_id`,`content_version`) 
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Drop some 5.0 tables that we no longer need 
);	revision( 6360
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_menuitems`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_menuitem_perms`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_notes`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]admin_page_perms`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]ancil_forum_badwords`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_eventtype1`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_eventtype2`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_extranet_tmp`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_forum_tmp`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_nlar_tmp`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]enet_steps`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]enet_user_field_labels`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]enet_user_val`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]folders`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]param_keys`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]param_values`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]template_params`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_for_site`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_for_slot`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_settings_for_slot_item`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_slot_link`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_slot_item_link`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]storekeeper_top_level_items`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_enet_step_link`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_forumthread_link`
_sql


//Drop some more 5.0 tables that we no longer need 
);	revision( 6370
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_stats_public`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]contentitem_price`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]creditcards`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]currencies`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]invoices`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]keyword_cache`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]known_referrers`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]newsletter_recip`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]newsletter_recip_log`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]newsletter_templates`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]order_items`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]orders`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]searched_keywords`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]transactions`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_content_event_attendees`
_sql


//Another 5.0 table
);	revision( 6390
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]template_link_blocks`
_sql


//Add a "detect" option to the languages table
);	revision( 6500
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	ADD COLUMN `detect` tinyint(1) NOT NULL default 0
	AFTER `language_local_name`;
_sql


//Add a plugin_dependancies table
); revision( 6505
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_dependancies`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_dependencies`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_dependencies` (
		`plugin_id` int(10) unsigned NOT NULL,
		`plugin_name` varchar(255) NOT NULL,
		`plugin_class_name` varchar(255) NOT NULL,
		`dependency_plugin_class_name` varchar(255) NOT NULL,
		`type` enum('dependency', 'inheritance', 'compatibility') NOT NULL,
		UNIQUE KEY (`plugin_id`, `type`, `dependency_plugin_class_name`),
		KEY (`plugin_name`, `type`),
		KEY (`plugin_class_name`, `type`),
		KEY (`dependency_plugin_class_name`, `type`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

//Add a dependency for the CMS on the Community Features
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]plugin_dependencies` SET
		plugin_id = 0,
		plugin_name = '',
		plugin_class_name = '',
		dependency_plugin_class_name = 'tribiq_cms_core',
		`type` = 'dependency'
_sql


//Add a key to the checksum column of the images and movies table
);	revision( 6520
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD KEY (`checksum`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]movies`
	ADD KEY (`checksum`)
_sql


//Remove the skin_slot_link table, as this test dev feature is being removed
);	revision( 6525
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]skin_slot_link`
_sql


//Drop the allowed size of the plugin class names down from 250 to 200
);	revision( 6540
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	MODIFY COLUMN `class_name` varchar(200) NOT NULL
_sql


//Add a "use VLPs from class" column to the Plugins table...
);	revision( 6550
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `vlp_class` varchar(200) NOT NULL default ''
	AFTER `class_name`
_sql


//...and change the plugin_id on the visitor_phrases table to a plugin_class
);	revision( 6560
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	ADD COLUMN `plugin_class` varchar(200) NOT NULL default ''
	AFTER `language_id`
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]visitor_phrases` AS v SET
		v.plugin_class = (
			SELECT p.class_name
			FROM `[[DB_NAME_PREFIX]]plugins` AS p
			WHERE p.id = v.plugin_id
		)
	WHERE v.plugin_id != 0
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	DROP INDEX `plugin_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	DROP COLUMN `plugin_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	ADD PRIMARY KEY (`plugin_class`, `language_id`, `code`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	ADD INDEX (`language_id`)
_sql


//Add an index on ordinal for shortcuts
);	revision( 6700
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	ADD INDEX (`ordinal`)
_sql


//Fix a bug where a lot of shortcut ordinals were set to zero
);	revision( 6710
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]links` SET
		`ordinal` = `id`
	WHERE `ordinal` = 0
_sql


//Add a request column to the plugin_instance_cache table
);	revision( 6900

, <<<_sql
	TRUNCATE TABLE `[[DB_NAME_PREFIX]]plugin_instance_cache`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instance_cache`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instance_cache`
	MODIFY COLUMN `method_name` varchar(64) NOT NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instance_cache`
	ADD COLUMN `request` varchar(255) NOT NULL default '' AFTER method_name
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instance_cache`
	ADD PRIMARY KEY (`instance_id`,`method_name`,`request`)
_sql

); revision( 6969
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	MODIFY COLUMN `img_filename` varchar(50) NOT NULL
_sql


//Fix any bad data that is not valid for MySQL strict mode
);	revision( 7050
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]links` SET
		target_loc = 'none'
	WHERE target_loc NOT IN ('int','ext','none')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]menuitems` SET
		redundancy = 'primary'
	WHERE redundancy NOT IN ('primary','secondary')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]menuitems` SET
		target_loc = 'none'
	WHERE target_loc NOT IN ('int','ext','none')
_sql


//Convert the draft_exists column of the content_event table from an enum to a tinyint
);	revision( 7051
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	MODIFY COLUMN `draft_exists` tinyint(1) NOT NULL default 0
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]content_event` SET
		draft_exists = draft_exists - 1
_sql


//Convert the hide_private_items column of the links table from an enum to a tinyint
);	revision( 7052
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	MODIFY COLUMN `hide_private_items` tinyint(1) NOT NULL default 0
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]links` SET
		hide_private_items = hide_private_items - 1
_sql


//Convert the hide_private_items column of the content_news_tmp and content_event_tmp tables from an enum to a tinyint
);	revision( 7053
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
	MODIFY COLUMN `draft_exists` tinyint(1) NOT NULL default 0
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]content_news_tmp` SET
		draft_exists = draft_exists - 1
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	MODIFY COLUMN `draft_exists` tinyint(1) NOT NULL default 0
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]content_event_tmp` SET
		draft_exists = draft_exists - 1
_sql


//Fix problems with the Users table and strict mode
);	revision( 7054
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		status = 'pending'
	WHERE status NOT IN ('pending','active','suspended')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		address_pref = 'no_pref'
	WHERE address_pref NOT IN ('residential','business','no_pref')
	   OR address_pref IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `address_pref` enum('residential','business','no_pref') NOT NULL default 'no_pref'
_sql


//Fix problems with the target_window column on the links table and strict mode
);	revision( 7055
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	MODIFY COLUMN `target_window` enum('blank','popup','same') NULL default NULL
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]links` SET
		target_window = 'same'
	WHERE target_window NOT IN ('blank','popup')
	   OR target_window IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	MODIFY COLUMN `target_window` enum('blank','popup','same') NOT NULL default 'same'
_sql


//Add Plugin Id columns to the slot/instance link tables for an efficiency tweak
);	revision( 7068
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link`
	ADD COLUMN `plugin_id` int(10) unsigned NOT NULL default 0 FIRST
_sql


);	revision( 7069
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_link`
	ADD COLUMN `plugin_id` int(10) unsigned NOT NULL default 0 FIRST
_sql


);	revision( 7070
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_item_link`
	ADD COLUMN `plugin_id` int(10) unsigned NOT NULL default 0 FIRST
_sql


//Automatically convert the saved data for pagination extensions to the new format
); revision( 7097
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'tribiq_cms_core::pagSelectList'
	WHERE name IN ('pagination_style', 'year_selector_style')
	  AND value = 'select_list'
_sql


, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'tribiq_cms_core::pagSimpleNumbers'
	WHERE name IN ('pagination_style', 'year_selector_style')
	  AND value = 'simple_list_of_numbers'
_sql


, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'tribiq_cms_core::pagSimpleNumbersWithMatches'
	WHERE name IN ('pagination_style', 'year_selector_style')
	  AND value = 'simple_list_of_numbers_with_matches'
_sql


//Create the content_video_tmp table if it has not been already
);	revision( 7120
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_video_tmp`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]content_video_tmp` (
	  `id` int(10) unsigned NOT NULL default 0,
	  `version` int(10) unsigned NOT NULL default '1',
	  `title` varchar(250) NOT NULL default '',
	  `private` tinyint(1) NOT NULL default 0,
	  `log_user_access` tinyint(1) NOT NULL default 0,
	  `language_id` varchar(5) NOT NULL default 'en',
	  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
	  `draft_exists` tinyint(1) NOT NULL default 0,
	  `created_datetime` datetime default NULL,
	  `owner_id` int(10) unsigned NOT NULL default 0,
	  `owner_authtype` enum('local','super') default NULL,
	  `creating_author_id` int(10) unsigned NOT NULL default 0,
	  `creating_author_authtype` enum('local','super') default NULL,
	  `allow_local_coauthor_id` int(10) unsigned NOT NULL default 0,
	  `last_author_id` int(10) unsigned NOT NULL default 0,
	  `last_author_authtype` enum('local','super') default NULL,
	  `publisher_id` int(10) unsigned NOT NULL default 0,
	  `publisher_authtype` enum('local','super') default NULL,
	  `published_datetime` datetime default NULL,
	  `hider_id` int(10) unsigned NOT NULL default 0,
	  `hider_authtype` enum('local','super') default NULL,
	  `hidden_datetime` datetime default NULL,
	  `archiver_id` int(10) unsigned NOT NULL default 0,
	  `archiver_authtype` enum('local','super') default NULL,
	  `archived_datetime` datetime default NULL,
	  `expiry_datetime` datetime default NULL,
	  `expiry_action` enum('delete','hide','alert') default NULL,
	  `folder_id` int(10) unsigned NOT NULL default 0,
	  `description` text,
	  `keywords` text,
	  `template_id` int(10) unsigned NOT NULL default 0,
	  `skin_id` int(10) unsigned default NULL,
	  `content_head` text,
	  `content_bodytop` mediumtext,
	  `content_bodymain` mediumtext,
	  `content_bodyfoot` mediumtext,
	  `filename` varchar(100) default NULL,
	  `mime_type` varchar(50) default NULL,
	  `size` int(10) unsigned default NULL,
	  `width` smallint(5) unsigned default NULL,
	  `height` smallint(5) unsigned default NULL,
	  `spare_varchar1` varchar(250) NOT NULL default '',
	  `spare_varchar2` varchar(250) NOT NULL default '',
	  `new_menu_text` varchar(250) NOT NULL default '',
	  `publication_date` date default NULL,
	  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
	  `seo_sitemap_priority` float(3,1) default NULL,
	  `diagnostic_page` tinyint(1) NOT NULL default 0,
	  `diagnostic_last_status` tinyint(1) default NULL,
	  `diagnostic_last_run` datetime default NULL,
	  `enable_rss` tinyint(1) default '0',
	  `microsite_id` int(10) unsigned default NULL,
	  PRIMARY KEY  (`id`,`version`),
	  KEY `folder_id` (`folder_id`),
	  KEY `publication_date` (`publication_date`),
	  KEY `version` (`version`),
	  FULLTEXT KEY `title` (`title`),
	  FULLTEXT KEY `keywords` (`keywords`),
	  FULLTEXT KEY `description` (`description`),
	  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
	  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
	  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//More fixes for strict mode
);	revision( 7122
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio_tmp`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio_tmp`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio_tmp`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio_tmp`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	MODIFY COLUMN `alias` varchar(50) NOT NULL default ''
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
	MODIFY COLUMN `alias` varchar(50) NOT NULL default ''
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	MODIFY COLUMN `filename` varchar(100) NOT NULL default ''
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
	MODIFY COLUMN `filename` varchar(100) NOT NULL default ''
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video_tmp`
	MODIFY COLUMN `content_head` text NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video_tmp`
	MODIFY COLUMN `content_bodytop` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video_tmp`
	MODIFY COLUMN `content_bodymain` mediumtext NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video_tmp`
	MODIFY COLUMN `content_bodyfoot` mediumtext NULL
_sql


//Fix a problem where the keys were not correctly defined for the lang_equiv_content table
);	revision( 7161

//Remove any invalid entries/bad data
, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]lang_equiv_content`
	WHERE (content_id, content_type) IN (
		SELECT content_id, content_type
		FROM (
			SELECT content_id, content_type, count(*) AS c
			FROM `[[DB_NAME_PREFIX]]lang_equiv_content`
			GROUP BY content_id, content_type
		) AS x
		WHERE c > 1
	)
_sql

//Change the keys
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]lang_equiv_content`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]lang_equiv_content`
	ADD PRIMARY KEY (`content_type`,`content_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]lang_equiv_content`
	ADD INDEX (`language_id`)
_sql


//Remove most of the columns from the plugin_setting_defs table, as now only the default value should be stored
//Also add a primary key (which was missing!)
);	revision( 7275

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP COLUMN `section`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP COLUMN `ordinal`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP COLUMN `label`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	DROP COLUMN `type`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	ADD PRIMARY KEY (`plugin_id`,`name`)
_sql


//Added ALTER TABLE to prevent strict problem with sticky flag
);	revision( 7286

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	MODIFY COLUMN `sticky_flag` tinyint(1) NOT NULL DEFAULT 0
_sql


//Update the format of the menu Plugin settings
);	revision( 7300

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = '_MENU_LEVEL_1'
	WHERE name = 'menu_start_from'
	  AND value = 'Menu Level 1'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = '_MENU_LEVEL_2'
	WHERE name = 'menu_start_from'
	  AND value = 'Menu Level 2'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = '_MENU_LEVEL_3'
	WHERE name = 'menu_start_from'
	  AND value = 'Menu Level 3'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = '_MENU_LEVEL_ABOVE'
	WHERE name = 'menu_start_from'
	  AND value = 'Menu Level Above'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = '_MENU_CURRENT_LEVEL'
	WHERE name = 'menu_start_from'
	  AND value = 'Current Menu Level'
_sql


//Ensure that the default editor for admins is fckeditor
);	revision( 7351
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]admins`
	MODIFY COLUMN `preferred_editor_id` varchar(20) NOT NULL default 'fckeditor'
_sql

//Drop and recreate unique key for categories
);	revision( 7383
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	DROP KEY `name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	ADD KEY `name` (`name`,`parent_id`,`language_id`)
_sql


//Remove the plugin_admin_thickbox_tabs table if it exists,
//as we're reading directly from the XML files for this now and don't need a table to store the info in
); revision( 7490
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_admin_thickbox_tabs`
_sql


//Added ALTER TABLE to prevent strict problem with shortcuts
);	revision( 7525
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]links`
	MODIFY COLUMN `img_filename` varchar(50) NOT NULL default ''
_sql


//Fix bad data in the instance link tables caused by a bug
);	revision( 7550
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link` AS l,
		   `[[DB_NAME_PREFIX]]plugin_instances` AS i SET
		l.plugin_id = i.plugin_id
	WHERE l.instance_id = i.id
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_inst_temp_link` AS l,
		   `[[DB_NAME_PREFIX]]plugin_instances` AS i SET
		l.plugin_id = i.plugin_id
	WHERE l.instance_id = i.id
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_inst_item_link` AS l,
		   `[[DB_NAME_PREFIX]]plugin_instances` AS i SET
		l.plugin_id = i.plugin_id
	WHERE l.instance_id = i.id
_sql


//Add table `[[DB_NAME_PREFIX]]menu_sections`
);	revision( 7600
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]menu_sections`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]menu_sections` (
		`section_name` varchar(20) PRIMARY KEY NOT NULL
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	INSERT INTO `[[DB_NAME_PREFIX]]menu_sections`(`section_name`)
	SELECT DISTINCT `section_id`
	FROM `[[DB_NAME_PREFIX]]menuitems`
	WHERE `section_id` != ''
	ORDER BY `section_id`
_sql

, <<<_sql
	INSERT IGNORE INTO `[[DB_NAME_PREFIX]]menu_sections`(`section_name`)
	VALUES ('Footer'), ('Main')
_sql


//Add some indices to the plugin links tables
);	revision( 7610
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_item_link`
	ADD INDEX (`instance_id`, `content_type`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_link`
	ADD INDEX (`instance_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link`
	ADD INDEX (`instance_id`)
_sql


//Added a missing publication_date column to the events table
);	revision( 7620
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	ADD COLUMN `publication_date` date default NULL
	AFTER `new_menu_text`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	ADD COLUMN `publication_date` date default NULL
	AFTER `new_menu_text`
_sql


//Add a plugin_events table
); revision( 7631
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_events`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_events`(
		`event_name` varchar(127) NOT NULL,
		`plugin_id` int(10) unsigned NOT NULL,
		`plugin_name` varchar(255) NOT NULL,
		`plugin_class` varchar(200) NOT NULL,
		`suppresses_plugin_class` varchar(200) NOT NULL default '',
		UNIQUE KEY (`event_name`, `plugin_class`),
		KEY (`suppresses_plugin_class`),
		KEY (`plugin_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Convert the values of the pagination settings to the new function names
);	revision( 7650
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'tribiq_cms_core::pagCloseWithNPIfNeeded'
	WHERE value IN ('tribiq_cms_core::pagSimpleNumbers', 'tribiq_cms_core::pagSimpleNumbersWithMatches')
	  AND name IN ('pagination_style', 'year_selector_style')
_sql


//Added a column onto the content types table to record which column that type uses for ordering by date
);	revision( 7725
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	ADD COLUMN `show_pub_date` tinyint(1) NOT NULL default 0
	AFTER `tag_prefix`
_sql


//Convert the name of the framework for the side-menus
);  revision( 8100
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_instances` SET
		theme = 'neutral_side_menu'
	WHERE theme = 'side_menu_without_css'
_sql


//Rename the tribiq_publication_date vlp class to tribiq_content
);  revision( 8101
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]visitor_phrases` SET
		plugin_class = 'tribiq_publication_date'
	WHERE plugin_class = 'tribiq_content'
_sql


//Change the instance_id index on the slot contents table
);  revision( 8102
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link`
	DROP INDEX `instance_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_link`
	DROP INDEX `instance_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_fam_link`
	ADD INDEX `slot_name` (`instance_id`,`slot_name`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_temp_link`
	ADD INDEX `slot_name` (`instance_id`,`slot_name`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_inst_item_link`
	ADD INDEX `slot_name` (`instance_id`,`slot_name`)
_sql


//Create a new table for storing theme choices
);  revision( 8103
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]plugin_slot_theme_link`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]plugin_slot_theme_link` (
		`skin_id` int(10) unsigned NOT NULL,
		`slot_name` varchar(100) NOT NULL,
		`instance_id` int(10) unsigned NOT NULL,
		`theme` varchar(50) NOT NULL,
		PRIMARY KEY (`skin_id`, `slot_name`, `instance_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Rename "theme" column to "framework" in the plugin_instances table
);  revision( 8104
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	CHANGE COLUMN `theme` `framework` varchar(50) NOT NULL default ''
_sql


//Convert the name of the framework for the side-menus
);  revision( 8130
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_instances` SET
		framework = 'menu_with_title'
	WHERE framework IN ('neutral_side_menu', 'side_menu_without_css')
_sql


//Add an index on user_id to the group_user_link table
);	revision( 8585
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]group_user_link`
	ADD INDEX (`user_id`, `group_id`)
_sql


//Add a default_framework column into the Plugins table
);	revision( 8640
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins` ADD COLUMN `default_framework` varchar(50) NOT NULL default '' AFTER `company_name`
_sql


//Add open_in_new_window column
);	revision( 8650
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]menuitems`
	ADD COLUMN `open_in_new_window` tinyint(1) NOT NULL default 0
	AFTER `target_loc`
_sql


//Add a use_custom_framework to the plugin_instances table
);	revision( 8696
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	ADD COLUMN `use_custom_framework` tinyint(1) NOT NULL default 0
	AFTER `framework`
_sql


//Added blog content type
);	revision( 8731
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_blog`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]content_blog` (
	  `id` int(10) unsigned NOT NULL default 0,
	  `version` int(10) unsigned NOT NULL default '1',
	  `title` varchar(250) NOT NULL default '',
	  `private` tinyint(1) NOT NULL default 0,
	  `log_user_access` tinyint(1) NOT NULL default 0,
	  `language_id` varchar(5) NOT NULL default 'en',
	  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
	  `draft_exists` tinyint(1) NOT NULL default 0,
	  `created_datetime` datetime default NULL,
	  `owner_id` int(10) unsigned NOT NULL default 0,
	  `owner_authtype` enum('local','super') default NULL,
	  `creating_author_id` int(10) unsigned NOT NULL default 0,
	  `creating_author_authtype` enum('local','super') default NULL,
	  `allow_local_coauthor_id` int(10) unsigned NOT NULL default 0,
	  `last_author_id` int(10) unsigned NOT NULL default 0,
	  `last_author_authtype` enum('local','super') default NULL,
	  `publisher_id` int(10) unsigned NOT NULL default 0,
	  `publisher_authtype` enum('local','super') default NULL,
	  `published_datetime` datetime default NULL,
	  `hider_id` int(10) unsigned NOT NULL default 0,
	  `hider_authtype` enum('local','super') default NULL,
	  `hidden_datetime` datetime default NULL,
	  `archiver_id` int(10) unsigned NOT NULL default 0,
	  `archiver_authtype` enum('local','super') default NULL,
	  `archived_datetime` datetime default NULL,
	  `expiry_datetime` datetime default NULL,
	  `expiry_action` enum('delete','hide','alert') default NULL,
	  `folder_id` int(10) unsigned NOT NULL default 0,
	  `description` text,
	  `keywords` text,
	  `template_id` int(10) unsigned NOT NULL default 0,
	  `skin_id` int(10) unsigned default NULL,
	  `content_head` text,
	  `content_bodytop` mediumtext,
	  `content_bodymain` mediumtext,
	  `content_bodyfoot` mediumtext,
	  `spare_varchar1` varchar(250) NOT NULL default '',
	  `spare_varchar2` varchar(250) NOT NULL default '',
	  `new_menu_text` varchar(250) NOT NULL default '',
	  `publication_date` datetime default NULL,
	  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
	  `seo_sitemap_priority` float(3,1) default NULL,
	  `diagnostic_page` tinyint(1) NOT NULL default 0,
	  `diagnostic_last_status` tinyint(1) default NULL,
	  `diagnostic_last_run` datetime default NULL,
	  `enable_rss` tinyint(1) default '0',
	  `microsite_id` int(10) unsigned default NULL,
	  PRIMARY KEY  (`id`,`version`),
	  KEY `folder_id` (`folder_id`),
	  KEY `date_value` (`publication_date`),
	  KEY `version` (`version`),
	  FULLTEXT KEY `title` (`title`),
	  FULLTEXT KEY `keywords` (`keywords`),
	  FULLTEXT KEY `description` (`description`),
	  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
	  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
	  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_blog_tmp`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]content_blog_tmp` (
	  `id` int(10) unsigned NOT NULL default 0,
	  `version` int(10) unsigned NOT NULL default '1',
	  `title` varchar(250) NOT NULL default '',
	  `private` tinyint(1) NOT NULL default 0,
	  `log_user_access` tinyint(1) NOT NULL default 0,
	  `language_id` varchar(5) NOT NULL default 'en',
	  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
	  `draft_exists` enum('0','1') NOT NULL default 0,
	  `created_datetime` datetime default NULL,
	  `owner_id` int(10) unsigned NOT NULL default 0,
	  `owner_authtype` enum('local','super') default NULL,
	  `creating_author_id` int(10) unsigned NOT NULL default 0,
	  `creating_author_authtype` enum('local','super') default NULL,
	  `allow_local_coauthor_id` int(10) unsigned NOT NULL default 0,
	  `last_author_id` int(10) unsigned NOT NULL default 0,
	  `last_author_authtype` enum('local','super') default NULL,
	  `publisher_id` int(10) unsigned NOT NULL default 0,
	  `publisher_authtype` enum('local','super') default NULL,
	  `published_datetime` datetime default NULL,
	  `hider_id` int(10) unsigned NOT NULL default 0,
	  `hider_authtype` enum('local','super') default NULL,
	  `hidden_datetime` datetime default NULL,
	  `archiver_id` int(10) unsigned NOT NULL default 0,
	  `archiver_authtype` enum('local','super') default NULL,
	  `archived_datetime` datetime default NULL,
	  `expiry_datetime` datetime default NULL,
	  `expiry_action` enum('delete','hide','alert') default NULL,
	  `folder_id` int(10) unsigned NOT NULL default 0,
	  `description` text,
	  `keywords` text,
	  `template_id` int(10) unsigned NOT NULL default 0,
	  `skin_id` int(10) unsigned default NULL,
	  `content_head` text,
	  `content_bodytop` mediumtext,
	  `content_bodymain` mediumtext,
	  `content_bodyfoot` mediumtext,
	  `spare_varchar1` varchar(250) NOT NULL default '',
	  `spare_varchar2` varchar(250) NOT NULL default '',
	  `new_menu_text` varchar(250) NOT NULL default '',
	  `publication_date` datetime default NULL,
	  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
	  `seo_sitemap_priority` float(3,1) default NULL,
	  `diagnostic_page` tinyint(1) NOT NULL default 0,
	  `diagnostic_last_status` tinyint(1) default NULL,
	  `diagnostic_last_run` datetime default NULL,
	  `enable_rss` tinyint(1) default '0',
	  `microsite_id` int(10) unsigned default NULL
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;
_sql


//Added user notes field
);	revision( 8732

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD COLUMN `notes` text NULL
	AFTER `first_subscrip_end`
_sql


//Add a new table to store which Plugins are on which Template
);	revision( 8787

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]visitor_phrases_new`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]template_slot_link`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]template_slot_link` (
		`template_id` int(10) unsigned NOT NULL,
		`slot_name` varchar(100) NOT NULL,
		PRIMARY KEY (`template_id`, `slot_name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Add a primary key to the visitor phrases table
);	revision( 8888

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]visitor_phrases_new` (
		`id` int(1) NOT NULL auto_increment,
		`code` varchar(100) NOT NULL default '',
		`language_id` varchar(5) NOT NULL default '',
		`plugin_class` varchar(200) NOT NULL default '',
		`local_text` text NOT NULL,
		`protect_flag` tinyint(1) NOT NULL default 0,
		`review_flag` tinyint(1) NOT NULL default 0,
		PRIMARY KEY  (`id`),
		UNIQUE KEY  (`plugin_class`,`language_id`,`code`),
		KEY `language_id` (`language_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	INSERT INTO `[[DB_NAME_PREFIX]]visitor_phrases_new`
		(`code`, `language_id`, `plugin_class`, `local_text`, `protect_flag`, `review_flag`)
	SELECT `code`, `language_id`, `plugin_class`, `local_text`, `protect_flag`, `review_flag`
	FROM `[[DB_NAME_PREFIX]]visitor_phrases`
	ORDER BY `plugin_class`,`language_id`,`code`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]visitor_phrases`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases_new`
	RENAME TO `[[DB_NAME_PREFIX]]visitor_phrases`
_sql


//Add a new table to store which Plugins are on which Template
);	revision(8975
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]email_templates`
_sql

, <<<_sql
CREATE TABLE `[[DB_NAME_PREFIX]]email_templates`(
		`id` int(10) unsigned NOT NULL auto_increment,
		`template_name` varchar(255) NOT NULL default '',
		`subject` tinytext NOT NULL,
		`email_address_from` varchar(100) NOT NULL default '',
		`email_name_from` varchar(255) NOT NULL default '',
		`body` text,
		`date_created` datetime NOT NULL,
		`created_by_id` int(10) unsigned NOT NULL,
		`created_by_authtype` enum('local','super') NOT NULL,
		`date_modified` datetime NULL,
		`modified_by_id` int(10) unsigned NULL,
		`modified_by_authtype` enum('local','super') NULL,
		`allow_attachments` TINYINT(1) DEFAULT 0, 
		PRIMARY KEY  (`id`),
		UNIQUE INDEX (`template_name`),
		INDEX (`date_modified`)
	) ENGINE=MyISAM AUTO_INCREMENT=100 DEFAULT CHARSET=utf8
_sql

//Change publication date to datetime field
);	revision( 9013
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	MODIFY COLUMN `publication_date` datetime default NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	MODIFY COLUMN `publication_date` datetime default NULL
_sql


//Add some missing keys to the content tables
);	revision( 9060
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	ADD KEY (`language_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	ADD KEY (`status`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_blog`
	ADD KEY (`language_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_blog`
	ADD KEY (`status`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	ADD KEY (`language_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	ADD KEY (`status`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	ADD KEY (`language_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	ADD KEY (`status`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	ADD KEY (`language_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	ADD KEY (`status`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	ADD KEY (`language_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	ADD KEY (`status`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	ADD KEY (`language_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	ADD KEY (`status`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	ADD KEY (`language_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	ADD KEY (`status`)
_sql


//Add another key to the content tables to try and speed up getting Plugin Instance Status
);	revision( 9130
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	ADD KEY (`template_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_blog`
	ADD KEY (`template_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	ADD KEY (`template_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	ADD KEY (`template_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	ADD KEY (`template_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	ADD KEY (`template_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	ADD KEY (`template_id`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	ADD KEY (`template_id`)
_sql

// Added screen name
);	revision( 9137
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD COLUMN `screen_name` varchar(50) NULL AFTER `username`
_sql


//Rename the Plugin "tribiq_temporary_memberships" to "tribiq_temporary_memberships_v1"
);	revision( 9150
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'tribiq_temporary_memberships_v1'
	WHERE `class_name` = 'tribiq_temporary_memberships'
_sql


//Drop any table to do with Storekeeper from 5.1
);	revision( 9180
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]storekeeper_plugin_items`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]storekeeper_plugin_toolbar_buttons`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]storekeeper_plugin_objects`
_sql


//Added hash user
);	revision( 9211
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD COLUMN `hash` varchar(255) NULL default NULL
_sql


//Remove the __CHOOSE_A_LANGUAGE__ phrase, which isn't used anymore
);	revision( 9230
, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]visitor_phrases`
	WHERE `code` = '__CHOOSE_A_LANGUAGE__'
_sql


//Change the data-structure used for previewing Plugin Instances
);	revision( 9270
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	DROP COLUMN `published`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	DROP KEY `name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	ADD COLUMN `parent_id` int(10) unsigned NOT NULL default 0
	AFTER `plugin_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	ADD UNIQUE KEY (`name`, `parent_id`)
_sql


//Rename the masthead Plugins
);	revision( 9272
, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]plugins`
	WHERE `class_name` IN ('tribiq_animation', 'tribiq_banner')
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'tribiq_animation_v1',
		`class_name` = 'tribiq_animation',
		`vlp_class` = 'tribiq_animation'
	WHERE `class_name` IN ('tribiq_masthead_pro', 'tribiq_movie')
	ORDER BY `class_name` = 'tribiq_masthead_pro' DESC
	LIMIT 1
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'tribiq_banner_v1',
		`class_name` = 'tribiq_banner',
		`vlp_class` = 'tribiq_banner'
	WHERE `class_name` IN ('tribiq_masthead', 'tribiq_image')
	ORDER BY `class_name` = 'tribiq_masthead' DESC
	LIMIT 1
_sql

, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]plugins`
	WHERE `class_name` IN ('tribiq_image', 'tribiq_movie', 'tribiq_masthead', 'tribiq_masthead_pro')
_sql


//Rename the Links Plugin to the Summary Links Plugin
);	revision( 9282
, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]plugins`
	WHERE `class_name` = 'tribiq_summary_link'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'tribiq_summary_link_v1',
		`class_name` = 'tribiq_summary_link',
		`vlp_class` = 'tribiq_content_list'
	WHERE `class_name` = 'tribiq_link'
_sql


//Drop the now unused overview tables
);	revision( 9310
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]overview_feeds`
_sql


//Drop the now unused menu_cache and site_diagnostics tables
);	revision( 9311
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]menu_cache`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]site_diagnostics`
_sql


//Drop the now unused advert tables
);	revision( 9312
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]adverts`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]advert_counter`
_sql


//Drop the now unused favourites and flags tables
);	revision( 9313
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]favourite_items`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]flagged_content_items`
_sql


//Drop the now unused statistics tables
);	revision( 9314
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]stats_daily`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]stats_extrefers`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]stats_intrefers`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]stats_hourly`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]stats_raw`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]stats_user_login_hist`
_sql


//Drop the now unused subscription_plans, user_subscriptions and tasks tables
);	revision( 9315
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]subscription_plans`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_subscriptions`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]tasks`
_sql


//Set "Wide" Content Instances to have wide editors
);	revision( 9425
, <<<_sql
	INSERT INTO `[[DB_NAME_PREFIX]]plugin_settings`
	SELECT id, 'editor_size', '_WIDE'
	FROM `[[DB_NAME_PREFIX]]plugin_instances`
	WHERE `name` LIKE '% Wide%'
	  AND plugin_id = (
	  	SELECT id
		FROM `[[DB_NAME_PREFIX]]plugins`
		WHERE `name` = 'tribiq_content_v1'
	  )
_sql


);	revision(9495
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_characteristics`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]user_characteristics`(
		`id` int(10) AUTO_INCREMENT,
		`name` varchar(255) NOT NULL,
		`ordinal` int(10) NOT NULL,
		`boolean_values` tinyint(1),
		UNIQUE(`name`),
		PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_characteristic_values`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]user_characteristic_values`(
		`id` int(10) AUTO_INCREMENT,
		`characteristic_id` int(10) NOT NULL,	
		`ordinal` int(10) NOT NULL,
		`name` varchar(255) NOT NULL,
		UNIQUE(`characteristic_id`,`name`),
		PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]characteristic_user_link`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]characteristic_user_link`(
		`id` int(10) AUTO_INCREMENT,
		`user_id` int(10) NOT NULL,
		`characteristic_id` int(10) NOT NULL,
		`characteristic_value_id` int(10) NOT NULL,
		UNIQUE(`user_id`,`characteristic_value_id`),
		PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;
_sql


);	revision( 9532
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]characteristic_user_link`
	CHANGE COLUMN `characteristic_value_id` `characteristic_value_id` int(10)
_sql


);	revision( 9533
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]characteristic_user_link`
	ADD CONSTRAINT UNIQUE(`user_id`,`characteristic_id`)
_sql


//Add a second checksum for images and movies
);	revision( 9588
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD COLUMN `checksum_inc_name` varchar(32) NULL default NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]movies`
	ADD COLUMN `checksum_inc_name` varchar(32) NULL default NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD KEY (`checksum_inc_name`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]movies`
	ADD KEY (`checksum_inc_name`)
_sql


//Add the type column back into the plugin_setting_defs table
);	revision( 9590
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	ADD COLUMN `type` varchar(50) NOT NULL default ''
	AFTER `name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_setting_defs`
	ADD KEY (`type`, `plugin_id`)
_sql

//Reset all of the plugin revision numbers for xml files to populate the column
, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]local_revision_numbers`
	WHERE patchfile LIKE '%.xml'
_sql


//Add Maiden Name column to users
);	revision( 9621
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD `maiden_name` varchar(100) NOT NULL default ''
	AFTER `last_name`
_sql


//Add the nest column to the Plugin Settings table
);	revision( 9696
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	ADD COLUMN `nest` smallint(4) unsigned NOT NULL default 0
	AFTER `name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	ADD PRIMARY KEY (`instance_id`, `name`, `nest`)
_sql


//Change the column definition above
);	revision( 9707
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_settings`
	MODIFY `nest` int(10) unsigned NOT NULL default 0
_sql


//Add the nest column to the plugin_slot_theme_link table
);	revision( 9708
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_slot_theme_link`
	ADD COLUMN `nest` int(10) unsigned NOT NULL default 0
	AFTER `slot_name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_slot_theme_link`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_slot_theme_link`
	ADD PRIMARY KEY (`skin_id`, `slot_name`, `nest`, `instance_id`)
_sql


//Create a new table for managing nested Plugins
);	revision( 9709
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]nested_plugins`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]nested_plugins` (
		`id` int(10) unsigned NOT NULL auto_increment,
		`instance_id` int(10) unsigned NOT NULL,
		`tab` smallint(4) unsigned NOT NULL default 1,
		`ord` smallint(4) unsigned NOT NULL default 1,
		`plugin_id` int(10) unsigned NOT NULL,
		`framework` varchar(50) NOT NULL default '',
		PRIMARY KEY  (`id`),
		KEY `name` (`instance_id`, `tab`, `ord`)
	)
_sql


//Add support for tabs to nested Plugins
);	revision( 9754
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]nested_plugins`
	DROP KEY `name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]nested_plugins`
	DROP KEY `instance_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]nested_plugins`
	DROP COLUMN `is_tab`
_sql


//Add support for tabs to nested Plugins
);	revision( 9755
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]nested_plugins`
	ADD COLUMN `is_tab` tinyint(1) NOT NULL DEFAULT 0
	AFTER `framework`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]nested_plugins`
	ADD COLUMN `tab_title` varchar(100) NOT NULL default ''
	AFTER `is_tab`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]nested_plugins`
	ADD KEY (`instance_id`, `is_tab`, `tab`, `ord`)
_sql


//Adding key to parent_id on users table
);	revision( 9817
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD KEY (`parent_id`)
_sql


//Add support for tabs to nested Plugins
);	revision( 9825
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `nestable` tinyint(1) NOT NULL DEFAULT 0
	AFTER `uses_instances`
_sql


//Demoted the primary key on the images table to just a key, and add a new primary key that uses checksum not filename
);	revision( 9837
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` SET
		checksum = MD5(data)
	WHERE checksum = ''
	   OR checksum IS NULL
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]images` SET
		checksum_inc_name = MD5(CONCAT(filename, checksum))
	WHERE checksum_inc_name = ''
	   OR checksum_inc_name IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD KEY (`content_item_id`,`content_item_version`,`filename`,`content_item_type`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]images`
	ADD PRIMARY KEY (`content_item_id`,`content_item_version`,`checksum_inc_name`,`content_item_type`)
_sql


//Add a "plugin_request" column to the menu items table
);	revision( 9888
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]menuitems`
	ADD COLUMN `plugin_request` varchar(32) NOT NULL default ''
	AFTER `content_type`
_sql


//Rename events to signals
);	revision( 9889
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]signals`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_events`
	RENAME TO `[[DB_NAME_PREFIX]]signals`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]signals`
	CHANGE COLUMN `event_name` `signal_name` varchar(127) NOT NULL
_sql


//Remove content type specific Template Files
);	revision( 9898
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]templates` SET
		filename = substr(filename, 6)
	WHERE family_name = 'tribiq-GPL-504'
_sql


//Update how the template_slot_link stores data to reflect the fact that template_id now points to an instance id; not a unique filename
);	revision( 9899
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]template_slot_link_cpy`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]template_slot_link`
	RENAME TO `[[DB_NAME_PREFIX]]template_slot_link_cpy`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]template_slot_link` (
		`template_family_name` varchar(50) NOT NULL,
		`template_filename` varchar(50) NOT NULL,
		`slot_name` varchar(100) NOT NULL,
		PRIMARY KEY  (`template_family_name`,`template_filename`,`slot_name`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 
_sql

, <<<_sql
	INSERT INTO `[[DB_NAME_PREFIX]]template_slot_link`
		(template_family_name, template_filename, slot_name)
	SELECT DISTINCT
		t.family_name, t.filename, tslc.slot_name
	FROM `[[DB_NAME_PREFIX]]template_slot_link_cpy` AS tslc
	INNER JOIN `[[DB_NAME_PREFIX]]templates` AS t
	   ON t.template_id = tslc.template_id
_sql

, <<<_sql
	DROP TABLE `[[DB_NAME_PREFIX]]template_slot_link_cpy`
_sql


//Demoted the primary key on the movies table to just a key, and add a new primary key that uses checksum not filename
);	revision( 9930
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]movies` SET
		checksum = MD5(data)
	WHERE checksum = ''
	   OR checksum IS NULL
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]movies` SET
		checksum_inc_name = MD5(CONCAT(filename, checksum))
	WHERE checksum_inc_name = ''
	   OR checksum_inc_name IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]movies`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]movies`
	ADD KEY (`content_item_id`,`content_item_version`,`filename`,`content_item_type`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]movies`
	ADD PRIMARY KEY (`content_item_id`,`content_item_version`,`checksum_inc_name`,`content_item_type`)
_sql


); revision( 10081
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_recurring_event`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]content_recurring_event` (
	  `id` int(10) unsigned NOT NULL default 0,
	  `version` int(10) unsigned NOT NULL default '1',
	  `title` varchar(250) NOT NULL default '',
	  `private` tinyint(1) NOT NULL default 0,
	  `log_user_access` tinyint(1) NOT NULL default 0,
	  `language_id` varchar(5) NOT NULL default 'en',
	  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
	  `draft_exists` tinyint(1) NOT NULL default 0,
	  `created_datetime` datetime default NULL,
	  `owner_id` int(10) unsigned NOT NULL default 0,
	  `owner_authtype` enum('local','super') default NULL,
	  `creating_author_id` int(10) unsigned NOT NULL default 0,
	  `creating_author_authtype` enum('local','super') default NULL,
	  `allow_local_coauthor_id` int(10) unsigned NOT NULL default 0,
	  `last_author_id` int(10) unsigned NOT NULL default 0,
	  `last_author_authtype` enum('local','super') default NULL,
	  `publisher_id` int(10) unsigned NOT NULL default 0,
	  `publisher_authtype` enum('local','super') default NULL,
	  `published_datetime` datetime default NULL,
	  `hider_id` int(10) unsigned NOT NULL default 0,
	  `hider_authtype` enum('local','super') default NULL,
	  `hidden_datetime` datetime default NULL,
	  `archiver_id` int(10) unsigned NOT NULL default 0,
	  `archiver_authtype` enum('local','super') default NULL,
	  `archived_datetime` datetime default NULL,
	  `expiry_datetime` datetime default NULL,
	  `expiry_action` enum('delete','hide','alert') default NULL,
	  `folder_id` int(10) unsigned NOT NULL default 0,
	  `description` mediumtext,
	  `keywords` text,
	  `template_id` int(10) unsigned NOT NULL default 0,
	  `skin_id` int(10) unsigned default NULL,
	  `content_head` text,
	  `content_bodytop` mediumtext,
	  `content_bodymain` mediumtext,
	  `content_bodyfoot` mediumtext,
	  `spare_varchar1` varchar(250) NOT NULL default '',
	  `spare_varchar2` varchar(250) NOT NULL default '',
	  `new_menu_text` varchar(250) NOT NULL default '',
	  `publication_date` datetime default NULL,
	  `private_view_recurring_event` tinyint(1) NOT NULL default 0,
	  `private_view_guests` enum('public','extranet','guests','owner') NOT NULL default 'owner',
	  `allow_join_recurring_event` enum('open','request_invitation','private') NOT NULL default 'private',
	  `joining_fee` tinyint(1) NOT NULL default 0,
	  `allow_max_guests` int(10) unsigned default NULL,
	  `confirmation_status` enum('tentative','confirmed','cancelled') default NULL,
	  `declare_full` tinyint(1) NOT NULL default 0,
	  `allow_friends` tinyint(1) default '0',
	  `recurring_event_type1` int(10) unsigned NOT NULL default 0,
	  `recurring_event_type2` int(10) unsigned NOT NULL default 0,
	  `start_date` date default NULL,
	  `start_time` time default NULL,
	  `end_date` date default NULL,
	  `end_time` time default NULL,
	  `specify_time` tinyint(1) NOT NULL default 0,
	  `day_sun_on` tinyint(1) NOT NULL default 0,
	  `day_sun_start_time` time NULL,
	  `day_sun_end_time` time NULL,
	  `day_mon_on` tinyint(1) NOT NULL default 0,
	  `day_mon_start_time` time NULL,
	  `day_mon_end_time` time NULL,
	  `day_tue_on` tinyint(1) NOT NULL default 0,
	  `day_tue_start_time` time NULL,
	  `day_tue_end_time` time NULL,
	  `day_wed_on` tinyint(1) NOT NULL default 0,
	  `day_wed_start_time` time NULL,
	  `day_wed_end_time` time NULL,
	  `day_thu_on` tinyint(1) NOT NULL default 0,
	  `day_thu_start_time` time NULL,
	  `day_thu_end_time` time NULL,
	  `day_fri_on` tinyint(1) NOT NULL default 0,
	  `day_fri_start_time` time NULL,
	  `day_fri_end_time` time NULL,
	  `day_sat_on` tinyint(1) NOT NULL default 0,
	  `day_sat_start_time` time NULL,
	  `day_sat_end_time` time NULL,
	  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
	  `seo_sitemap_priority` float(3,1) default NULL,
	  `diagnostic_page` tinyint(1) NOT NULL default 0,
	  `diagnostic_last_status` tinyint(1) default NULL,
	  `diagnostic_last_run` datetime default NULL,
	  `enable_rss` tinyint(1) default '0',
	  `microsite_id` int(10) unsigned default NULL,
	  PRIMARY KEY  (`id`,`version`),
	  KEY `folder_id` (`folder_id`),
	  KEY `version` (`version`),
	  KEY `start_date` (`start_date`),
	  KEY `start_time` (`start_time`),
	  KEY `language_id` (`language_id`),
	  KEY `status` (`status`),
	  KEY `template_id` (`template_id`),
	  FULLTEXT KEY `title` (`title`),
	  FULLTEXT KEY `keywords` (`keywords`),
	  FULLTEXT KEY `description` (`description`),
	  FULLTEXT KEY `content_bodytop` (`content_bodytop`),
	  FULLTEXT KEY `content_bodymain` (`content_bodymain`),
	  FULLTEXT KEY `content_bodyfoot` (`content_bodyfoot`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]content_recurring_event_tmp`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]content_recurring_event_tmp` (
	  `id` int(10) unsigned NOT NULL default 0,
	  `version` int(10) unsigned NOT NULL default '1',
	  `title` varchar(250) NOT NULL default '',
	  `private` tinyint(1) NOT NULL default 0,
	  `log_user_access` tinyint(1) NOT NULL default 0,
	  `language_id` varchar(5) NOT NULL default 'en',
	  `status` enum('private_draft','reviewable_draft','published','hidden','archived') default 'private_draft',
	  `draft_exists` tinyint(1) NOT NULL default 0,
	  `created_datetime` datetime default NULL,
	  `owner_id` int(10) unsigned NOT NULL default 0,
	  `owner_authtype` enum('local','super') default NULL,
	  `creating_author_id` int(10) unsigned NOT NULL default 0,
	  `creating_author_authtype` enum('local','super') default NULL,
	  `allow_local_coauthor_id` int(10) unsigned NOT NULL default 0,
	  `last_author_id` int(10) unsigned NOT NULL default 0,
	  `last_author_authtype` enum('local','super') default NULL,
	  `publisher_id` int(10) unsigned NOT NULL default 0,
	  `publisher_authtype` enum('local','super') default NULL,
	  `published_datetime` datetime default NULL,
	  `hider_id` int(10) unsigned NOT NULL default 0,
	  `hider_authtype` enum('local','super') default NULL,
	  `hidden_datetime` datetime default NULL,
	  `archiver_id` int(10) unsigned NOT NULL default 0,
	  `archiver_authtype` enum('local','super') default NULL,
	  `archived_datetime` datetime default NULL,
	  `expiry_datetime` datetime default NULL,
	  `expiry_action` enum('delete','hide','alert') default NULL,
	  `folder_id` int(10) unsigned NOT NULL default 0,
	  `description` mediumtext,
	  `keywords` text,
	  `template_id` int(10) unsigned NOT NULL default 0,
	  `skin_id` int(10) unsigned default NULL,
	  `content_head` text,
	  `content_bodytop` mediumtext,
	  `content_bodymain` mediumtext,
	  `content_bodyfoot` mediumtext,
	  `spare_varchar1` varchar(250) NOT NULL default '',
	  `spare_varchar2` varchar(250) NOT NULL default '',
	  `new_menu_text` varchar(250) NOT NULL default '',
	  `publication_date` datetime default NULL,
	  `private_view_recurring_event` tinyint(1) NOT NULL default 0,
	  `private_view_guests` enum('public','extranet','guests','owner') NOT NULL default 'owner',
	  `allow_join_recurring_event` enum('open','request_invitation','private') NOT NULL default 'private',
	  `joining_fee` tinyint(1) NOT NULL default 0,
	  `allow_max_guests` int(10) unsigned default NULL,
	  `confirmation_status` enum('tentative','confirmed','cancelled') default NULL,
	  `declare_full` tinyint(1) NOT NULL default 0,
	  `allow_friends` tinyint(1) default '0',
	  `recurring_event_type1` int(10) unsigned NOT NULL default 0,
	  `recurring_event_type2` int(10) unsigned NOT NULL default 0,
	  `start_date` date default NULL,
	  `start_time` time default NULL,
	  `end_date` date default NULL,
	  `end_time` time default NULL,
	  `specify_time` tinyint(1) NOT NULL default 0,
	  `day_sun_on` tinyint(1) NOT NULL default 0,
	  `day_sun_start_time` time NULL,
	  `day_sun_end_time` time NULL,
	  `day_mon_on` tinyint(1) NOT NULL default 0,
	  `day_mon_start_time` time NULL,
	  `day_mon_end_time` time NULL,
	  `day_tue_on` tinyint(1) NOT NULL default 0,
	  `day_tue_start_time` time NULL,
	  `day_tue_end_time` time NULL,
	  `day_wed_on` tinyint(1) NOT NULL default 0,
	  `day_wed_start_time` time NULL,
	  `day_wed_end_time` time NULL,
	  `day_thu_on` tinyint(1) NOT NULL default 0,
	  `day_thu_start_time` time NULL,
	  `day_thu_end_time` time NULL,
	  `day_fri_on` tinyint(1) NOT NULL default 0,
	  `day_fri_start_time` time NULL,
	  `day_fri_end_time` time NULL,
	  `day_sat_on` tinyint(1) NOT NULL default 0,
	  `day_sat_start_time` time NULL,
	  `day_sat_end_time` time NULL,
	  `seo_sitemap_changefreq` enum('always','hourly','daily','weekly','monthly','yearly','never') default NULL,
	  `seo_sitemap_priority` float(3,1) default NULL,
	  `diagnostic_page` tinyint(1) NOT NULL default 0,
	  `diagnostic_last_status` tinyint(1) default NULL,
	  `diagnostic_last_run` datetime default NULL,
	  `enable_rss` tinyint(1) default '0',
	  `microsite_id` int(10) unsigned default NULL,
	  PRIMARY KEY  (`id`,`version`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;
_sql


);	revision( 10082
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurring_event`
	ADD COLUMN `location_id` int(10) unsigned
	AFTER `day_sat_end_time`
_sql


//Add a key on screenname
);	revision( 10100
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD KEY (`screen_name`)
_sql


//Add a summary field to the content tables
);	revision( 10101
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_audio`
	ADD FULLTEXT KEY (`content_summary`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_blog_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_blog`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_blog`
	ADD FULLTEXT KEY (`content_summary`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	ADD FULLTEXT KEY (`content_summary`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_event`
	ADD FULLTEXT KEY (`content_summary`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_html`
	ADD FULLTEXT KEY (`content_summary`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_news`
	ADD FULLTEXT KEY (`content_summary`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_picture`
	ADD FULLTEXT KEY (`content_summary`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurring_event_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurring_event`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurring_event`
	ADD FULLTEXT KEY (`content_summary`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video_tmp`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	ADD COLUMN `content_summary` mediumtext
	AFTER `content_bodyfoot`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_video`
	ADD FULLTEXT KEY (`content_summary`)
_sql


//Convert "data_field" settings
);	revision( 10102
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'none'
	WHERE name = 'data_field'
	  AND value = 'None'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'description'
	WHERE name = 'data_field'
	  AND value = 'Description'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'content_bodytop'
	WHERE name = 'data_field'
	  AND value = 'Content Top'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'content_bodymain'
	WHERE name = 'data_field'
	  AND value = 'Content Main'
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_settings` SET
		value = 'content_bodyfoot'
	WHERE name = 'data_field'
	  AND value = 'Content Foot'
_sql


);	revision( 10204
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurring_event_tmp`
	ADD COLUMN `location_id` int(10) unsigned
	AFTER `day_sat_end_time`
_sql


);	revision( 10228

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurring_event`
	RENAME TO `[[DB_NAME_PREFIX]]content_recurringevent`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurring_event_tmp`
	RENAME TO `[[DB_NAME_PREFIX]]content_recurringevent_tmp`
_sql


);	revision( 10230
, <<<_sql
	DELETE FROM `[[DB_NAME_PREFIX]]contenttypes`
	WHERE content_type_id = 'recurring_event'
_sql


//Change lanuage default pages from working off aliases to working off id
//and add language default registration/forgot password/change password/logout pages,
);	revision( 10231
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	ADD COLUMN `homepage_id` int(10) unsigned NOT NULL default 0
	AFTER `detect`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	ADD COLUMN `search_page_id` int(10) unsigned NOT NULL default 0
	AFTER `homepage_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	ADD COLUMN `extranet_login_page_id` int(10) unsigned NOT NULL default 0
	AFTER `search_page_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	ADD COLUMN `extranet_registration_page_id` int(10) unsigned NOT NULL default 0
	AFTER `extranet_login_page_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	ADD COLUMN `extranet_password_reminder_page_id` int(10) unsigned NOT NULL default 0
	AFTER `extranet_registration_page_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	ADD COLUMN `extranet_change_password_page_id` int(10) unsigned NOT NULL default 0
	AFTER `extranet_password_reminder_page_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	ADD COLUMN `extranet_logout_page_id` int(10) unsigned NOT NULL default 0
	AFTER `extranet_change_password_page_id`
_sql


);	revision( 10232
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]languages` AS l SET
		homepage_id = IFNULL((
			SELECT c.id
			FROM `[[DB_NAME_PREFIX]]content_html` AS c
			WHERE c.language_id = l.id
			  AND alias = l.default_homepage_alias
			ORDER BY version DESC
			LIMIT 1
		), 0)
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]languages` AS l SET
		search_page_id = IFNULL((
			SELECT c.id
			FROM `[[DB_NAME_PREFIX]]content_html` AS c
			WHERE c.language_id = l.id
			  AND alias = l.default_search_page_alias
			ORDER BY version DESC
			LIMIT 1
		), 0)
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]languages` AS l SET
		extranet_login_page_id = IFNULL((
			SELECT c.id
			FROM `[[DB_NAME_PREFIX]]content_html` AS c
			WHERE c.language_id = l.id
			  AND alias = l.default_extranet_page_alias
			ORDER BY version DESC
			LIMIT 1
		), 0)
_sql


);	revision( 10233
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	DROP COLUMN `default_homepage_alias`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	DROP COLUMN `default_search_page_alias`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	DROP COLUMN `default_extranet_page_alias`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]languages`
	DROP COLUMN `default_sitemap_alias`
_sql


);	revision( 10395,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurringevent`
	ADD COLUMN `stop_dates` TEXT
_sql


);	revision( 10396,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurringevent`
	DROP COLUMN `stop_dates` 
_sql

,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurringevent`
	ADD COLUMN `stop_dates` TEXT
	AFTER `location_id`
_sql


);	revision( 10587,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurringevent_tmp`
	ADD COLUMN `stop_dates` TEXT
	AFTER `location_id`
_sql


);	revision( 10600,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurringevent_tmp`
	ADD COLUMN `url` varchar(250)
	AFTER `location_id`
_sql


);	revision( 10601,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurringevent`
	ADD COLUMN `url` varchar(250)
	AFTER `location_id`
_sql


//Add support for Feature Plugins
);	revision( 10660
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `feature_plugin` tinyint(1) NOT NULL DEFAULT 0
	AFTER `uses_instances`
_sql


//Forcebly run the Email Template Manager Plugin, as a few Plugins have developed dependencies
//for this Plugin and will be unstable without it
);	revision( 10725
, <<<_sql
	INSERT INTO `[[DB_NAME_PREFIX]]plugins` SET
		`name` = 'tribiq_email_template_manager_v1',
		`class_name` = 'tribiq_email_template_manager',
		`display_name` = 'Email Template Manager',
		`status` = '_ENUM_RUNNING'
	ON DUPLICATE KEY UPDATE
		`status` = '_ENUM_RUNNING'
_sql


//Create a new table for favicons
);	revision( 10780
, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]favicons` (
		`usage` enum('favicon','mobile') NOT NULL,
		`filename` varchar(50) NOT NULL default '',
		`mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg','image/vnd.microsoft.icon') NOT NULL,
		`width` smallint(5) unsigned default NULL,
		`height` smallint(5) unsigned default NULL,
		`size` int(10) unsigned default NULL,
		`data` mediumblob,
		`checksum` varchar(32) default NULL,
		PRIMARY KEY  (`usage`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

//Added next day finish field
);	revision( 10781
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurringevent`
	ADD COLUMN `next_day_finish` tinyint(1) NOT NULL DEFAULT 0 AFTER `specify_time`
_sql

);	revision( 10803
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_recurringevent_tmp`
	ADD COLUMN `next_day_finish` tinyint(1) NOT NULL DEFAULT 0 AFTER `specify_time`
_sql


//Add support for Plugin Album
);	revision( 10899
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugins`
	ADD COLUMN `keep_in_album` tinyint(1) NOT NULL DEFAULT 0
	AFTER `uses_instances`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	ADD COLUMN `keep_in_album` tinyint(1) NOT NULL DEFAULT 0
	AFTER `framework`
_sql


//Update some the Plugin Instances for some Plugins to be in the Album by default
);	revision( 10900
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]plugin_instances` SET
		`keep_in_album` = 1
	WHERE plugin_id IN (
		SELECT id
		FROM `[[DB_NAME_PREFIX]]plugins`
		WHERE `name` IN (
			'tribiq_menu_v1',
			'tribiq_search_entry_box_predictive_probusiness_v1',
			'tribiq_content_v1',
			'tribiq_language_picker_v1',
			'tribiq_menu_pro_v1',
			'tribiq_comments_v1',
			'tribiq_google_analytics_tracker',
			'tribiq_google_ad_slot',
			'tribiq_social_bookmarking_v1',
			'tribiq_footer_v1',
			'tribiq_language_picker_avls_v1',
			'tribiq_footer_pro_v1',
			'tribiq_search_entry_box_v1',
			'tribiq_menu_forward_back_navigator_v1',
			'tribiq_bookmark_email_print_v1',
			'tribiq_breadcrumbs_v1',
			'tribiq_extranet_v1'
		)
	)
_sql


//Add an index for the keep_in_album column
);	revision( 10901
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]plugin_instances`
	ADD INDEX (`keep_in_album`)
_sql


);	revision( 10978
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_characteristics`
	ADD COLUMN `protected` tinyint(1) NOT NULL DEFAULT 0
_sql


//Add a missing index to the Templates table
);	revision( 11100
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]templates`
	ADD INDEX (`family_name`)
_sql


//Remove the allow_newsletters column from the users table
);	revision( 11200
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	DROP COLUMN `allow_newsletters`
_sql


//Remove NULLs as default values from some columns in the users table
);	revision( 11250
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `parent_id` int(10) unsigned default 0
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`parent_id` = 0
	WHERE `parent_id` IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `screen_name` varchar(50) default ''
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`screen_name` = ''
	WHERE `screen_name` IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `title` varchar(25) default ''
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`title` = ''
	WHERE `title` IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `mobile` varchar(20) default ''
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`mobile` = ''
	WHERE `mobile` IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `spare_varchar1` varchar(255) default ''
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`spare_varchar1` = ''
	WHERE `spare_varchar1` IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `spare_varchar2` varchar(255) default ''
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`spare_varchar2` = ''
	WHERE `spare_varchar2` IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `spare_varchar3` varchar(255) default ''
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`spare_varchar3` = ''
	WHERE `spare_varchar3` IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `spare_varchar4` varchar(255) default ''
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`spare_varchar4` = ''
	WHERE `spare_varchar4` IS NULL
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	MODIFY COLUMN `spare_varchar5` varchar(255) default ''
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]users` SET
		`spare_varchar5` = ''
	WHERE `spare_varchar5` IS NULL
_sql


//Reorder the primary key and add a missing index on the category link table
);	revision( 11300
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]category_item_link`
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]category_item_link`
	ADD PRIMARY KEY (`category_id`,`content_type`,`item_id`,`version`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]category_item_link`
	ADD INDEX (`item_id`,`content_type`,`version`)
_sql


//Add a missing index on the groups table
);	revision( 11330
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]groups`
	ADD INDEX (`name`)
_sql


//Added a "public" flag to the categories table
//Also remove two unused columns
);	revision( 11400
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	ADD `public` tinyint(1) NOT NULL default 0
	AFTER `name`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	ADD `landing_page_content_id` tinyint(1) NOT NULL default 0
	AFTER `public`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	ADD `landing_page_content_type` varchar(20) NOT NULL default ''
	AFTER `landing_page_content_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	DROP COLUMN `restrict_content_type`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	DROP COLUMN `language_id`
_sql


//Remove the no-longer used a "plugin_request" column from the menu items table
);	revision( 11425
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]menuitems`
	DROP COLUMN `plugin_request`
_sql


//Added a "public" flag to the groups table
//Also remove the "public_name" column which wasn't multilingual
);	revision( 11430
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]groups`
	ADD `public` tinyint(1) NOT NULL default 0
	AFTER `name`
_sql

, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]groups` SET
		`public` = 1
	WHERE `public_name` != ''
_sql

, <<<_sql
	INSERT IGNORE INTO `[[DB_NAME_PREFIX]]visitor_phrases` (
		code,
		language_id,
		plugin_class,
		local_text)
	SELECT
		CONCAT('_GROUP_', g.id),
		l.id,
		'',
		g.public_name
	FROM `[[DB_NAME_PREFIX]]groups` AS g, `[[DB_NAME_PREFIX]]languages` AS l
	WHERE `public_name` != ''
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]groups`
	DROP COLUMN `public_name`
_sql

//Add indecies
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]groups`
	ADD INDEX (`public`)
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	ADD INDEX (`public`)
_sql


//Added an "allow_opt_in_opt_out" flag to the groups table
);	revision( 11440
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]groups`
	ADD `allow_opt_in_opt_out` tinyint(1) NOT NULL default 0
	AFTER `public`
_sql


//Added an "allow_opt_in_opt_out" flag to the groups table
);	revision( 11450
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]visitor_phrases`
	ADD INDEX (`code`,`plugin_class`,`language_id`)
_sql


//Added support for uploading 7zip files
);	revision( 11550
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` SET type = '7z'
_sql


//Add Address line 3 to the users table
);	revision( 11650
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD `bus_address3` varchar(250) NOT NULL default ''
	AFTER `bus_address2`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]users`
	ADD `res_address3` varchar(250) NOT NULL default ''
	AFTER `res_address2`
_sql


//Create a new table for spare aliases
);	revision( 11660
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]spare_aliases`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]spare_aliases` (
		`alias` varchar(50) NOT NULL,
		`content_id` int(10) unsigned NOT NULL,
		`content_type` varchar(20) NOT NULL,
		PRIMARY KEY (`alias`),
		KEY (`content_type`, `content_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Add a 'static method' option for signals
);	revision( 11771
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]signals`
	ADD `static_method` tinyint(1) unsigned NOT NULL default 0
	AFTER `plugin_class`
_sql


//Change size of document text field
);	revision( 11805
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]content_document`
	MODIFY COLUMN `document_text` LONGTEXT NULL
_sql


//Create new tables for jobs
);	revision( 11950
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]jobs`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]jobs` (
		`id` int(10) unsigned NOT NULL auto_increment,
		`job_name` varchar(127) NOT NULL,
		`plugin_id` int(10) unsigned NOT NULL,
		`plugin_name` varchar(255) NOT NULL,
		`plugin_class` varchar(200) NOT NULL,
		`static_method` tinyint(1) unsigned NOT NULL default 0,
		`months` set('jan','feb','mar','apr','may','jun','jul','aug','sep','oct','nov','dec') NOT NULL default 'jan,feb,mar,apr,may,jun,jul,aug,sep,oct,nov,dec',
		`days` set('mon','tue','wed','thr','fri','sat','sun') NOT NULL default 'mon,tue,wed,thr,fri,sat,sun',
		`hours` set('0h','1h','2h','3h','4h','5h','6h','7h','8h','9h','10h','11h','12h','13h','14h','15h','16h','17h','18h','19h','20h','21h','22h','23h') NOT NULL default '0h',
		`minutes` set('0m','5m','10m','15m','20m','25m','30m','35m','40m','45m','50m','55m','59m') NOT NULL default '0m',
		`first_n_days_of_month` tinyint(1) NOT NULL default 0,
		`log_on_action` tinyint(1) unsigned NOT NULL default '1',
		`log_on_no_action` tinyint(1) unsigned NOT NULL default 0,
		`email_on_action` tinyint(1) unsigned NOT NULL default 0,
		`email_on_no_action` tinyint(1) unsigned NOT NULL default 0,
		`last_run_started` datetime default NULL,
		`last_run_finished` datetime default NULL,
		`status` enum('never_run','rerun_scheduled','in_progress','action_taken','no_action_taken','error') NOT NULL default 'never_run',
		`last_successful_run` datetime default NULL,
		`last_action` datetime default NULL,
		PRIMARY KEY  (`id`),
		UNIQUE KEY `job_name` (`job_name`,`plugin_class`),
		KEY `plugin_id` (`plugin_id`),
		KEY `first_n_days_of_month` (`first_n_days_of_month`)
	) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]job_logs`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]job_logs` (
		`id` int(10) unsigned NOT NULL auto_increment,
		`job_id` int(10) unsigned NOT NULL,
		`status` enum('action_taken','no_action_taken','error') NOT NULL,
		`started` datetime default NULL,
		`finished` datetime default NULL,
		`note` text,
		PRIMARY KEY  (`id`),
		KEY `job_id` (`job_id`),
		KEY `status` (`status`),
		KEY `started` (`started`),
		KEY `finished` (`finished`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Create new tables for jobs
);	revision( 11960
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]jobs`
	ADD `email_address_on_action` varchar(200) NOT NULL default ''
	AFTER `email_on_no_action`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]jobs`
	ADD `email_address_on_no_action` varchar(200) NOT NULL default ''
	AFTER `email_address_on_action`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]jobs`
	ADD `email_address_on_error` varchar(200) NOT NULL default ''
	AFTER `email_address_on_no_action`
_sql

);	revision( 11980

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]email_templates`
	ADD `attachment_body` text
	AFTER `body`
_sql

);	revision( 11984

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]email_templates`
	ADD `enable_attachment_body` tinyint(1) default 0 NOT NULL
	AFTER `attachment_body`
_sql


//Add keys to the user_content_accesslog table
	//Update: rewrote this so it won't cause a database error if there are duplicate rows.
);	revision( 12251
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]user_content_accesslog_new`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]]user_content_accesslog_new` (
		`hit_datetime` datetime NOT NULL default '0000-00-00 00:00:00',
		`user_id` int(10) unsigned NOT NULL default 0,
		`content_id` int(10) unsigned NOT NULL default 0,
		`content_type` varchar(20) NOT NULL default '',
		`content_version` int(10) unsigned NOT NULL default 0,
		`ip` int(10) NOT NULL default 0,
		PRIMARY KEY  (`hit_datetime`,`user_id`,`content_id`,`content_type`),
		KEY `user_id` (`user_id`),
		KEY `content_type` (`content_type`),
		KEY `content_id` (`content_id`),
		KEY `user_id_2` (`user_id`),
		KEY `content_id_2` (`content_id`),
		KEY `content_type_2` (`content_type`),
		KEY `ip` (`ip`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

, <<<_sql
	INSERT IGNORE INTO `[[DB_NAME_PREFIX]]user_content_accesslog_new`
	SELECT * FROM `[[DB_NAME_PREFIX]]user_content_accesslog`
_sql

, <<<_sql
	DROP TABLE `[[DB_NAME_PREFIX]]user_content_accesslog`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_content_accesslog_new`
	RENAME TO `[[DB_NAME_PREFIX]]user_content_accesslog`
_sql


//Fix a bad column definition
);	revision( 12295
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]categories`
	MODIFY `landing_page_content_id` int(10) unsigned NOT NULL default 0
	AFTER `public`
_sql


);	revision(12619,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_characteristics`
	ADD COLUMN `type` enum('list','boolean','text') AFTER `boolean_values`
_sql
,
<<<_sql
	UPDATE `[[DB_NAME_PREFIX]]user_characteristics`
	SET `type`=IF(boolean_values=1,'boolean','list')
_sql
,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_characteristics`
	MODIFY `type` enum('list','boolean','text') NOT NULL
_sql


//Added support for docx
);	revision( 12650,
<<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` (`type`)
	VALUES ('docx'), ('xlsx')
_sql


);	revision(12657,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_characteristics`
	DROP COLUMN `boolean_values`
_sql


//Added a new index to the menuitems table
);	revision( 13260
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]menuitems`
	ADD INDEX (`target_loc`)
_sql


); 	revision( 13319
, <<<_sql
	UPDATE `[[DB_NAME_PREFIX]]content_event`
	SET location_country_id = UCASE(location_country_id);
_sql


//Added a job enabled flag
);	revision( 13525
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]jobs`
	ADD `enabled` tinyint(1) NOT NULL DEFAULT 0
	AFTER `static_method`
_sql


);	revision( 13595
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_characteristic_values`
	DROP INDEX `characteristic_id`
_sql


);	revision( 13596
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]user_characteristic_values`
	CHANGE COLUMN `name` `name` TEXT  NOT NULL
_sql


//Remove some unused tables/columns
);	revision( 13620
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]document_types`
	DROP COLUMN `enable_extract`
_sql

, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]]mime_types`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	DROP COLUMN `default_folder_id`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	DROP COLUMN `enable_print`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	DROP COLUMN `enable_emailfriend`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	DROP COLUMN `enable_categories`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	DROP COLUMN `special_flag`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	DROP COLUMN `disallow_normal_creation`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]contenttypes`
	DROP COLUMN `bulk_upload`
_sql


); revision( 13653,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]templates`
	ADD COLUMN `image_filename` varchar(50) NOT NULL default '',
	ADD COLUMN `mime_type` enum('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg') NOT NULL default 'image/jpeg',
	ADD COLUMN `width` smallint(5) unsigned default NULL,
	ADD COLUMN `height` smallint(5) unsigned default NULL,
	ADD COLUMN `size` int(10) unsigned default NULL,
	ADD COLUMN `data` mediumblob,
	ADD COLUMN `checksum` varchar(32) NOT NULL default '',
	ADD COLUMN `storekeeper_width` smallint(5) unsigned default NULL,
	ADD COLUMN `storekeeper_height` smallint(5) unsigned default NULL,
	ADD COLUMN `storekeeper_data` mediumblob,
	ADD COLUMN `storekeeper_size` int(10) unsigned default NULL
_sql


);	revision( 13654,
<<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]templates`
	ADD COLUMN `checksum_inc_name` varchar(32) NOT NULL default ''
_sql


//Added support for uploading jpegs
);	revision( 13675
, <<<_sql
	REPLACE INTO `[[DB_NAME_PREFIX]]document_types` SET type = 'flv'
_sql


//Drop now unused columns from the site settings table
);	revision( 13760
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]site_settings`
	DROP COLUMN `type`
_sql

, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]]site_settings`
	DROP COLUMN `suppress_if_other_setting_false`
_sql
);
?>