<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */



//Code for converting table data, after the more drastic database structure changes

//We cleared the content types table in revision 5970 of the core updates.
//Force the Core Plugin to reload it's Plugin description to add the basic content types back
if (needRevision(5970)) {
	
	setupPluginContentTypesFromXMLDescription('plugins/tribiq_cms_core_v1/db_updates', 'description.xml');
	
	revision(5970);
}


//Attempt to drop all of the views that we used to use in versions before 5.1.2
//I'm doing this in PHP, just in case there are permissions errors
if (needRevision(7630)) {
	
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_admin_reg_template_list`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_audio`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_document`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_event`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_extranet`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_forum`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_html`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_news`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_nlar`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_picture`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report_video`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_diagnostics_report`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_audio`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_document`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_event`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_extranet`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_forum`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_html`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_news`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_nlar`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_picture`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history_video`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_history`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_skins`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_template_content_document_status`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_template_content_event_status`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_template_content_extranet_status`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_template_content_forum_status`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_template_content_html_status`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_template_content_news_status`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_template_content_nlar_status`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_template_content_picture_status`");
	@mysql_query("DROP VIEW IF EXISTS `". DB_NAME_PREFIX. "v_vlp_status`");

	
	revision(7630);
}


//Adding a second checksum to images/movies, which includes the filename
if (needRevision(9925)) {
	foreach (array('images' => 'image_', 'movies' => 'movie_') as $table => $prefix) {
		$sql = "
			SELECT id, filename, checksum
			FROM ". DB_NAME_PREFIX. $table;
		$result = my_mysql_query($sql);
		
		while($row = mysql_fetch_assoc($result)) {
			$sql = "
				UPDATE ". DB_NAME_PREFIX. $table. " SET
					checksum_inc_name = '". ($checksum = md5($row['filename']. $row['checksum'])). "'
				WHERE id = ". (int) $row['id'];
			my_mysql_query($sql);
			
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "plugin_settings SET
					value = '". mysql_real_escape_string($prefix. $checksum). "'
				WHERE value = '". mysql_real_escape_string($prefix. $row['checksum']). "'";
			my_mysql_query($sql);
		}
	}
	
	revision(9925);
}


//Copy the data from the old url_alias_redirects table to the new spare_urls table.
//(Global table are being updated, but this script is in the local file because we need to access the content_html table)
if (needRevision(11722)) {
	connectGlobalDB();
		if ($result = getRows(
						'url_alias_redirects',
						array('requested_url', 'goto_alias'),
						array('sitename' => SITENAME),
						array(), false,
						DB_NAME_PREFIX_GLOBAL)
		) {
			while ($spareURL = mysql_fetch_assoc($result)) {
				connectLocalDB();
					if (!($cID = getRow('content_html', 'id', array('alias' => $spareURL['goto_alias'], 'status' => 'private_draft')))
					 && !($cID = getRow('content_html', 'id', array('alias' => $spareURL['goto_alias'], 'status' => 'published')))) {
						connectGlobalDB();
						continue;
					}
				connectGlobalDB();
				setRow('spare_urls',
					array('sitename' => SITENAME, 'requested_url' => $spareURL['requested_url'], 'content_id' => $cID, 'content_type' => 'html'),
					array(), DB_NAME_PREFIX_GLOBAL);
			}
		}
	connectLocalDB();
	
	revision(11722);
}

?>