<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */



//Code for handling renaming Plugin directories
function handlePluginDirectoryRename($oldName, $newName) {
	addNewPlugins();
	if (($oldId = getPluginId($oldName)) && ($newId = getPluginId($newName))) {
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "plugin_instances SET
				plugin_id = ". (int) $newId. "
			WHERE plugin_id = ". (int) $oldId;
		my_mysql_query($sql);
		
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "plugin_inst_item_link SET
				plugin_id = ". (int) $newId. "
			WHERE plugin_id = ". (int) $oldId;
		my_mysql_query($sql);
		
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "plugin_inst_temp_fam_link SET
				plugin_id = ". (int) $newId. "
			WHERE plugin_id = ". (int) $oldId;
		my_mysql_query($sql);
		
		$sql = "
			UPDATE ". DB_NAME_PREFIX. "plugin_inst_temp_link SET
				plugin_id = ". (int) $newId. "
			WHERE plugin_id = ". (int) $oldId;
		my_mysql_query($sql);
	}
}

if (needRevision(8432)) {
	
	handlePluginDirectoryRename('tribiq_contact_form_flexible_pro_v1', 'tribiq_flexible_form_v1');
	
	revision(8432);
}


if (needRevision(8466)) {
	
	handlePluginDirectoryRename('tribiq_show_static_content_v1', 'tribiq_html_snippet_v1');
	
	revision(8466);
}

//Fix a bug where a setting name was renamed
revision( 8467
, <<<_sql
	UPDATE IGNORE `[[DB_NAME_PREFIX]]plugin_settings` SET
		name = 'display_this_html'
	WHERE name = 'static_content'
_sql
);


if (needRevision(10724)) {
	
	handlePluginDirectoryRename('tribiq_content_list_pro_v1', 'tribiq_content_list_v1');
	
	revision(10724);
}


if (needRevision(10725)) {
	
	handlePluginDirectoryRename('tribiq_extranet_pro_v1', 'tribiq_extranet_v1');
	
	revision(10725);
}


if (needRevision(10726)) {
	
	handlePluginDirectoryRename('tribiq_extranet_probusiness_v1', 'tribiq_extranet_v1');
	
	revision(10726);
}


if (needRevision(10727)) {
	
	handlePluginDirectoryRename('tribiq_contact_form_pro_v1', 'tribiq_contact_form_v1');
	
	revision(10727);
}


if (needRevision(10728)) {
	
	handlePluginDirectoryRename('tribiq_publication_date_v1', 'tribiq_meta_data_v1');
	
	revision(10728);
}


//Try to in screen names for anyone with an empty screen-name
if (needRevision(10729)) {
	@mysql_query("
		UPDATE `". DB_NAME_PREFIX. "users` SET
			screen_name = CONCAT(first_name, ' ', last_name)
		WHERE (screen_name = '' OR screen_name IS NULL)
	");
	
	@mysql_query("
		UPDATE `". DB_NAME_PREFIX. "users` SET
			screen_name = SUBSTR(email, 1, INSTR(email, '@')-1)
		WHERE (screen_name = '' OR screen_name IS NULL)
		  AND INSTR(email, '@')
	");
	
	revision(10729);
}


if (needRevision(11540)) {
	
	handlePluginDirectoryRename('tribiq_language_picker_avls_v1', 'tribiq_language_picker_v1');
	
	revision(11540);
}


if (needRevision(13430)) {
	
	handlePluginDirectoryRename('my_full_moon_calculator_v1', 'my_hello_world_two_v1');
	
	revision(13430);
}


?>