<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */






//This update refreshes the admin permissions tables with each update, so we
//are always sure of what is in those two tables

//Warning:
	//This update will always be run with each update; no matter what the version numbers are!



//Empty whatever is in the admin_page_perms table
 revision( null
, <<<_sql
	TRUNCATE TABLE [[DB_NAME_PREFIX_GLOBAL]]roles
_sql

, <<<_sql
	TRUNCATE TABLE [[DB_NAME_PREFIX_GLOBAL]]actions
_sql
 );


/*
	//Not doing this right now, but possibly should:
		//Reinsert all the permission to access the database update page. This should be kept on its own.
		//(If someone makes a typo when adding a page permission below, they will need to be able to get
		// to the update page in order to fix it - hence this insert is rather important!)
*/


//Reinsert the roles
 revision( null
, <<<_sql
	INSERT INTO [[DB_NAME_PREFIX_GLOBAL]]roles
		(`name`, `ordinal`)
	VALUES
		('_ROLE_SUPERADMIN', 1),
		('_ROLE_MANAGER', 2),
		('_ROLE_SYSADMIN', 3),
		('_ROLE_PUBLISHER', 4),
		('_ROLE_AUTHOR', 5),
		('_ROLE_MENU_EDITOR', 6),
		('_ROLE_EXTRANET_GROUP_MANAGER', 7),
		('_ROLE_EXTRANET_USER_MANAGER', 8)
_sql
 );

//Reinsert the actions
 revision( null
, <<<_sql
	INSERT INTO [[DB_NAME_PREFIX_GLOBAL]]actions
		(`role_name`, `name`)
	VALUES
		('_ROLE_AUTHOR', '_PRIV_ADD_IMAGE_TO_ITEM'),
		('_ROLE_AUTHOR', '_PRIV_ADD_MOVIE_TO_ITEM'),
		('_ROLE_AUTHOR', '_PRIV_ADD_NEW_IMAGE'),
		('_ROLE_AUTHOR', '_PRIV_ADD_NEW_MOVIE'),
		('_ROLE_AUTHOR', '_PRIV_ADD_NEW_SHORTCUT_IMAGE'),
		('_ROLE_AUTHOR', '_PRIV_ADD_NEW_SHORTCUT_MOVIE'),
		('_ROLE_AUTHOR', '_PRIV_CREATE_FIRST_DRAFT'),
		('_ROLE_AUTHOR', '_PRIV_CREATE_REVISION_DRAFT'),
		('_ROLE_AUTHOR', '_PRIV_DELETE_DRAFT'),
		('_ROLE_AUTHOR', '_PRIV_DELETE_FROM_DROPBOX'),
		('_ROLE_AUTHOR', '_PRIV_DELETE_IMAGE'),
		('_ROLE_AUTHOR', '_PRIV_DELETE_MOVIE'),
		('_ROLE_AUTHOR', '_PRIV_DUPLICATE_ITEM'),
		('_ROLE_AUTHOR', '_PRIV_EDIT_DRAFT'),
		('_ROLE_AUTHOR', '_PRIV_EDIT_ITEM_CATEGORIES'),
		('_ROLE_AUTHOR', '_PRIV_EDIT_ITEM_META_DATA'),
		('_ROLE_AUTHOR', '_PRIV_EDIT_ITEM_PERMISSIONS'),
		('_ROLE_AUTHOR', '_PRIV_EDIT_ITEM_SETTINGS'),
		('_ROLE_AUTHOR', '_PRIV_EDIT_ITEM_TEMPLATE'),
		('_ROLE_AUTHOR', '_PRIV_EDIT_NEWSLETTER'),
		('_ROLE_AUTHOR', '_PRIV_EDIT_SHORTCUT'),
		('_ROLE_AUTHOR', '_PRIV_EXPORT_ITEM'),
		('_ROLE_AUTHOR', '_PRIV_IMPORT_ITEM'),
		('_ROLE_AUTHOR', '_PRIV_ROLLBACK_ITEM'),
		('_ROLE_AUTHOR', '_PRIV_UNHIDE_CONTENT'),
		('_ROLE_AUTHOR', '_PRIV_UPLOAD_ITEM_FILE'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_ITEM_CATEGORIES'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_ITEM_HISTORY'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_ITEM_META_DATA'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_ITEM_PERMISSIONS'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_ITEM_SETTINGS'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_ITEM_TEMPLATE'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_LANGUAGE_CONFIG'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_PREVIOUS_ITEM_VERSION'),
		('_ROLE_AUTHOR', '_PRIV_VIEW_NEXT_ITEM_VERSION'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_CHANGE_USER_PASSWORD'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_CHANGE_USER_STATUS'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_CREATE_USER'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_DELETE_USER'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_EDIT_CHILD_USERS'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_EDIT_USER'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_IMPERSONATE_USER'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_MANAGE_GROUP_MEMBERSHIP'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_MODERATE_USER_COMMENTS'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_SET_CHARACTERISTIC_ON_USER'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_VIEW_USER_CHARACTERISTIC'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_CREATE_CHARACTERISTIC'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_EDIT_CHARACTERISTIC'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_DELETE_CHARACTERISTIC'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_VIEW_CHILD_USERS'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_VIEW_ITEM_ACCESS_LOG'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_VIEW_NEWSLETTER_ACCESS_LOG'),
		('_ROLE_EXTRANET_USER_MANAGER', '_PRIV_VIEW_USER'),
		('_ROLE_EXTRANET_GROUP_MANAGER', '_PRIV_CREATE_GROUP'),
		('_ROLE_EXTRANET_GROUP_MANAGER', '_PRIV_DELETE_GROUP'),
		('_ROLE_EXTRANET_GROUP_MANAGER', '_PRIV_VIEW_GROUP'),
		('_ROLE_EXTRANET_GROUP_MANAGER', '_PRIV_EDIT_GROUP'),
		('_ROLE_MANAGER', '_PRIV_CHANGE_ADMIN_PASSWORD'),
		('_ROLE_MANAGER', '_PRIV_CREATE_ADMIN'),
		('_ROLE_MANAGER', '_PRIV_DOWNLOAD_ADMIN_PHRASES'),
		('_ROLE_MANAGER', '_PRIV_EDIT_ADMIN'),
		('_ROLE_MANAGER', '_PRIV_VIEW_ADMIN'),
		('_ROLE_MANAGER', '_PRIV_DELETE_ADMIN'),
		('_ROLE_MENU_EDITOR', '_PRIV_ADD_MENU_ITEM'),
		('_ROLE_MENU_EDITOR', '_PRIV_ADD_MENU_SECTION'),
		('_ROLE_MENU_EDITOR', '_PRIV_ADD_TOP_LEVEL_MENU_ITEM'),
		('_ROLE_MENU_EDITOR', '_PRIV_DELETE_MENU_ITEM'),
		('_ROLE_MENU_EDITOR', '_PRIV_DELETE_MENU_SECTION'),
		('_ROLE_MENU_EDITOR', '_PRIV_DELETE_TOP_LEVEL_MENU_ITEM'),
		('_ROLE_MENU_EDITOR', '_PRIV_EDIT_MENU_ITEM'),
		('_ROLE_MENU_EDITOR', '_PRIV_EDIT_TOP_LEVEL_MENU_ITEM'),
		('_ROLE_MENU_EDITOR', '_PRIV_SHUFFLE_MENU_ITEM'),
		('_ROLE_MENU_EDITOR', '_PRIV_VIEW_MENU_ITEM'),
		('_ROLE_PUBLISHER', '_PRIV_ADD_CATEGORY'),
		('_ROLE_PUBLISHER', '_PRIV_BACKUP_SITE'),
		('_ROLE_PUBLISHER', '_PRIV_CATEGORY_SETTINGS'),
		('_ROLE_PUBLISHER', '_PRIV_DELETE_CATEGORY'),
		('_ROLE_PUBLISHER', '_PRIV_DELETE_VLP'),
		('_ROLE_PUBLISHER', '_PRIV_EDIT_EMAIL_TEMPLATE'),
		('_ROLE_PUBLISHER', '_PRIV_EDIT_TEMPLATE'),
		('_ROLE_PUBLISHER', '_PRIV_EDIT_VLP'),
		('_ROLE_PUBLISHER', '_PRIV_ENABLE_VLP'),
		('_ROLE_PUBLISHER', '_PRIV_EXPORT_VLP'),
		('_ROLE_PUBLISHER', '_PRIV_IMPORT_VLP'),
		('_ROLE_PUBLISHER', '_PRIV_HIDE_CONTENT'),
		('_ROLE_PUBLISHER', '_PRIV_MANAGE_ITEM_SLOT'),
		('_ROLE_PUBLISHER', '_PRIV_MANAGE_NESTED_PLUGIN'),
		('_ROLE_PUBLISHER', '_PRIV_MANAGE_NESTED_PLUGIN_THEME'),
		('_ROLE_PUBLISHER', '_PRIV_MANAGE_PLUGIN_INSTANCE'),
		('_ROLE_PUBLISHER', '_PRIV_MANAGE_PLUGIN_NEST'),
		('_ROLE_PUBLISHER', '_PRIV_MANAGE_PLUGIN_THEME'),
		('_ROLE_PUBLISHER', '_PRIV_MANAGE_SPARE_ALIAS'),
		('_ROLE_PUBLISHER', '_PRIV_MANAGE_TEMPLATE_SLOT'),
		('_ROLE_PUBLISHER', '_PRIV_PUBLISH_ITEM'),
		('_ROLE_PUBLISHER', '_PRIV_REORDER_PLUGIN_NEST'),
		('_ROLE_PUBLISHER', '_PRIV_RUN_PLUGIN'),
		('_ROLE_PUBLISHER', '_PRIV_SEND_NEWSLETTER'),
		('_ROLE_PUBLISHER', '_PRIV_SET_ITEM_STICKY_IMAGE'),
		('_ROLE_PUBLISHER', '_PRIV_SUSPEND_PLUGIN'),
		('_ROLE_PUBLISHER', '_PRIV_TRASH_CONTENT'),
		('_ROLE_PUBLISHER', '_PRIV_UPDATE_DATABASE'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_NESTED_PLUGIN'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_PLUGIN'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_PLUGIN_INSTANCE'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_SCHEDULED_TASK'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_SITE_SETTING'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_SKIN'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_SLOT'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_TEMPLATE'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_TEMPLATE_FAMILY'),
		('_ROLE_PUBLISHER', '_PRIV_VIEW_VLP'),
		('_ROLE_SUPERADMIN', '_PRIV_EDIT_MULTISITE'),
		('_ROLE_SUPERADMIN', '_PRIV_VIEW_MULTISITE'),
		('_ROLE_SYSADMIN', '_PRIV_ADD_SKIN'),
		('_ROLE_SYSADMIN', '_PRIV_ADD_URL'),
		('_ROLE_SYSADMIN', '_PRIV_DELETE_URL'),
		('_ROLE_SYSADMIN', '_PRIV_EDIT_LANGUAGE_CONFIG'),
		('_ROLE_SYSADMIN', '_PRIV_EDIT_SITE_SETTING'),
		('_ROLE_SYSADMIN', '_PRIV_EDIT_CONTENT_TYPE'),
		('_ROLE_SYSADMIN', '_PRIV_EDIT_TEMPLATE_FAMILY'),
		('_ROLE_SYSADMIN', '_PRIV_EDIT_PROTECTED_USER_CHARACTERISTIC'),
		('_ROLE_SYSADMIN', '_PRIV_IMPORT_TEMPLATE_FAMILY'),
		('_ROLE_SYSADMIN', '_PRIV_INITIALISE_PLUGIN'),
		('_ROLE_SYSADMIN', '_PRIV_MANAGE_CUSTOM_FRAMEWORK'),
		('_ROLE_SYSADMIN', '_PRIV_MANAGE_SCHEDULED_TASK'),
		('_ROLE_SYSADMIN', '_PRIV_MANAGE_SPARE_DOMAIN_NAME'),
		('_ROLE_SYSADMIN', '_PRIV_RESTORE_SITE'),
		('_ROLE_SYSADMIN', '_PRIV_RESET_SITE'),
		('_ROLE_SYSADMIN', '_PRIV_RUN_PLUGIN_FIRST_TIME'),
		('_ROLE_SYSADMIN', '_PRIV_SET_EMAIL_ROUTING'),
		('_ROLE_SYSADMIN', '_PRIV_UNINSTALL_PLUGIN'),
		('_ROLE_SYSADMIN', '_PRIV_URL_SETTINGS')
_sql
 );


?>