<?php
	require '../adminheader.inc.php';
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>

<?php
	echo '
		<title>Storekeeper for ', htmlspecialchars(getGlobalURL()), '</title>';
	
	if (!checkPriv()) {
		echo '
			</head>
			<body>
				<script type="text/javascript">
					var hash = encodeURIComponent(("" + document.location.hash).replace("#", ""));
					document.location.href = "welcome.php?sk=" + (hash? hash : "tribiq__content");
				</script>
				<p><a href="welcome.php">', getPhrase('Please log in'), '</a></p>
			</body>
			</html>';
		exit;
	}
	
	
	echo '
		<link rel="stylesheet" type="text/css" href="../libraries/mit/uploadify/uploadify.css" media="screen" />
		<link rel="stylesheet" type="text/css" href="../cmsstyles/admin_storekeeper.min.css?v=', urlencode(CSS_JS_VERSION), '" media="screen" />';
	
	$pluginList = '';
	$plugins = getRunningPlugins();
	CMSWritePageHead('../', $plugins);
	CMSWritePageFoot('../');
	
	//Include the checksum of any xml files in Plugin storekeeper directories
	foreach ($plugins as &$plugin) {
		if (is_dir($dir = CMS_ROOT. 'plugins/'. $plugin['name']. '/storekeeper/')) {
			foreach (scandir($dir) as $file) {
				if (substr($file, 0, 1) != '.' && substr($file, -4) == '.xml') {
					$pluginList .= $plugin['name']. '/'. $file. '/'. sha1_file($dir. $file);
				}
			}
		}
	}
	
	//Get a list of language names for use in the formatting options
	$langs = array();
	$sql = "
		SELECT language_id, local_text
		FROM ". DB_NAME_PREFIX. "visitor_phrases
		WHERE code = '__LANGUAGE_LOCAL_NAME__'";
	$result = my_mysql_query($sql);
	while ($lang = mysql_fetch_assoc($result)) {
		$langs[$lang['language_id']] = $lang['local_text'];
	}
	
	//Get a list of Plugin names for use in the formatting options
	$pluginNames = array();
	foreach (getPlugins() as $plugin) {
		$pluginNames[$plugin['id']] = $pluginNames[$plugin['name']] = $pluginNames[$plugin['class_name']] = $plugin['display_name'];
	}
	
	echo '
		<script type="text/javascript" src="../cmsjs/admin_storekeeper.min.js?v=', urlencode(CSS_JS_VERSION), '"></script>
		<script type="text/javascript" src="../libraries/mit/swfobject/swfobject.js"></script>
		<script type="text/javascript" src="../libraries/mit/uploadify/jquery.uploadify.v2.1.4.min.js"></script>
<script type="text/javascript">
tribiqSK.languageNames = ', json_encode($langs), ';
tribiqSK.pluginList = "', sha1($pluginList), '";
tribiqSK.pluginNames = ', json_encode($pluginNames), ';

	try {
		tribiqSK.prefs = JSON.parse("', addslashes(json_encode(json_decode(getAdminStorekeeperPrefs()))), '");
	} catch (e) {
		alert("prefs fail");
		tribiqSK.prefs = {};
	}

tribiqSK.selectMode = ', issetArrayKey($_GET, 'selectMode')? 'true' : 'false', ';
tribiqSK.sessionId = "', addslashes(session_id()), '";
tribiqSK.sessionKey = "', addslashes(issetArrayKey($_SESSION, 'session_key')? $_SESSION['session_key'] : $_SESSION['session_key'] = randomString(32)), '";
</script>';

foreach ($plugins as $plugin) {
	if (file_exists($plugin['path']. 'adminstyles/storekeeper.css')) {
		echo "\n", '<link rel="stylesheet" type="text/css" href="../plugins/', $plugin['name'], '/adminstyles/storekeeper.css?v=', urlencode(CSS_JS_VERSION), '" media="screen" />';
	}
	if (file_exists($plugin['path']. 'js/storekeeper.js')) {
		echo "\n", '<script type="text/javascript" src="../plugins/', $plugin['name'], '/js/storekeeper.js?v=', urlencode(CSS_JS_VERSION), '"></script>';
	}
}


if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6') !== false) {
	echo '
		<style type="text/css">
			html {
				overflow: hidden;
			}
		</style>';
}
?>


</head>


<?php
CMSWritePageBody();
setupFloatingBoxes($showInfoBox = true);
setupAdminTooltips();
?>

<div id="fileQueue" style="display: none; position: absolute; top: 171px; z-index: 99;"></div>

<div class="wrapOuter">
	<div style="background-image: url('../<?php echo cms_core::getSKBannerPath(); ?>');">
		<div class="info_box" onclick="tribiqA.infoBox();"></div>
		<div id="search" style="visibility: hidden;">
			<form id="searchForm" onsubmit="return false;">
				<img src="images/store_keeper/search_box_left_end.png"
				/><input type="text" id="search_term" onclick="tribiqSK.searchOnClick(this);" onkeyup="tribiqSK.searchOnKeyUp(this);" onchange="tribiqSK.searchOnChange(this);" value=""
				/><img src="images/store_keeper/search_box_right_end.png" />
			</form>
		</div>
		<?php if (issetArrayKey($_GET, 'selectMode')) { ?>
			<div class="close_button">
				<a href="#" onclick="return tribiqSK.closeSelectMode();"></a>
			</div>
		<?php } else {
			if (checkAdminHasDrafts($_SESSION['admin_userid'],$_SESSION['admin_authtype'])) {
				$logoutMsg = getPhrase("You have unfinished Drafts of content items. Are you sure you want to log out? Click OK to logout but leave Drafts online, or Cancel to go back and work on them.");
			} else {
				$logoutMsg = getPhrase("Are you sure you want to logout?");
			}
			
			echo '
				<div class="logout_button">
					<a onclick="', floatingBoxJS($logoutMsg, '<input type="button" class="submit_selected" value="'. getPhrase('OK'). '" onclick="document.location.href = \'welcome.php?task=logout\';"/>', true, true), ' return false;" href="#" title="', getPhrase('Logout'), '"></a>
				</div>';
		} ?>
	</div>
</div>

<div id="container">
	<div id="header">
		<div class="headerPanel">
			<div id="preloader_circle"><span id="preloader_message"><?php echo getPhrase('Loading...'); ?></span> &nbsp;<img src="images/store_keeper/loader_dots.gif" /></div>
			<div class="toolbar" id="collectionToolbar" style="visibility: hidden;">
				<div id="collectionToolbarLeftEnd"></div>
				<div id="collectionToolbarTitle"><?php echo getPhrase('Actions'); ?></div>
				<div id="collectionToolbarTitleEnd"></div>
				<span id="collectionToolbarButtons"></span>
				<div id="collectionToolbarRightEnd"></div>
			</div>
			<div class="toolbar" id="itemToolbar" style="visibility: hidden;">
				<div id="itemToolbarLeftEnd"></div>
				<div id="itemToolbarTitle"></div>
				<div id="itemToolbarTitleEnd"></div>
				<span id="itemToolbarButtons"></span>
				<div id="itemToolbarRightEnd"></div>
			</div>
		</div>
		<div class="headerPanel">
			<div class="viewMode toolbar secondToolbar">
				<div id="refreshRightColumn" onclick="tribiqSK.refresh();"><a title="<?php echo getPhrase('Refresh View'); ?>"></a></div>
				<div id="listViewOptionsDropdown" onclick="tribiqSK.showViewOptions(event);"><a title="<?php echo getPhrase('Click to personalize this Panel'); ?>"></a></div>
			</div>
			
			<div class="viewMode toolbar firstToolbar">
				<span id="viewModeSelected">
					<div id="list_view"><a onclick="return tribiqSK.changeView('list');" title="<?php echo getPhrase('List View'); ?>"></a></div>
					<div id="summary_view"><a onclick="return tribiqSK.changeView('summary');" title="<?php echo getPhrase('Summary View'); ?>"></a></div>
					<div id="grid_view"><a onclick="return tribiqSK.changeView('grid');" title="<?php echo getPhrase('Grid View'); ?>"></a></div>
				</span>
			</div>
			
			<div id="backButton" onclick="tribiqSK.back();" style="visibility: hidden;">
				<div id="backButtonIcon"></div>
				<div class="backButtonText">
					<?php echo getPhrase('Back to '); ?><span id="backButtonText"></span>
				</div>
			</div>
		</div>
	</div>
	
	
	
	<div id="storekeeperOuter">
		<div class="findOuterWrap" style="">
			<div id="leftColumnOuter"><div id="leftColumn"></div></div>
			<div id="rightColumn">
				<div id="storeHeaderGraphic" style="display: none;"></div>
				<div id="rightColumnTitle">
					<div id="panelTitle"></div>
				</div>
				<div id="rightColumnContent" onclick="tribiqSK.itemBGClick();" ondblclick="tribiqSK.itemBGDoubleClick();"></div>
			</div>
			<form style="float: right;" id="bottomRightForm">
				<input type="button" id="choose_button" class="submit_disabled" onclick="tribiqSK.choose();" style="display: none;"/>
				<span id="trash_button" style="display: none;"><a onclick="tribiqSK.viewTrash();" title="<?php echo getPhrase('View Trash'); ?>"></a></span>
			</form>
			<div id="itemCountWrap" style="visibility: hidden;">
				<span id="pageStart"></span> - <span id="pageStop"></span>
				<?php echo getPhrase('of'); ?>
				<span id="itemCount"></span>
				<img id="pagePrevOff" src="images/store_keeper/pagination_btn_left_off.gif"/>
				<img id="pagePrev" src="images/store_keeper/pagination_btn_left_on.gif" onclick="tribiqSK.prevPage();"/>
				<span id="pages"></span>
				<img id="pageNextOff" src="images/store_keeper/pagination_btn_right_off.gif"/>
				<img id="pageNext" src="images/store_keeper/pagination_btn_right_on.gif" onclick="tribiqSK.nextPage();"/>
			</div>
		</div>
	</div>
</div>

<div class="wrapInner"></div>

<script type="text/javascript">
	if (tribiq.browserIsIE()) {
		get('storekeeperOuter').onselectstart =
			function() {
				return false;
			}
	}
</script>
</body>
</html>
