<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

if (!isset($_SESSION)) {
	session_start();
}

require_once 'visitorheader.inc.php';
require_once CMS_ROOT. 'cmsincludes/admin.inc.php';


//Check if the admin is currently logged in
if (!checkPriv()) {
	//If not, try to handle the problem
	//Attempt to check where this funciton is being called from
	$location = debug_backtrace();
	$location = array_reverse(explode('/', $location[0]['file']));
	
	//If this is an AJAX file, or an admin box, simply exit as there is no recovery we can really do
	if (arrayKey($location, 0) == 'admintoolbar_button_handler.php' || arrayKey($location, 0) == 'ajax' || arrayKey($location, 1) == 'ajax' || arrayKey($location, 1) == 'tb') {
		echo '<!--Logged_Out-->', getPhrase('You have been logged out.');
		exit;
	
	//Also don't do the redirect for index.php or storekeeper.php
	} elseif (arrayKey($location, 0) != indexDotPHP() && arrayKey($location, 0) != 'index.php' && arrayKey($location, 0) != 'storekeeper.php') {
		//Otherwise attempt to redirect the user to the login screen
		header('location: '. httpOrHttps(). $_SERVER["HTTP_HOST"]. SUBDIRECTORY. 'admin/welcome.php?desturl='. urlencode($_SERVER['REQUEST_URI']));
		exit;
	}
}

?>