<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || arrayKey($_SESSION, 'admin_logged_into_site') != SUBDIRECTORY. SITENAME) exit;

$public_checked = ' checked="checked"';			

if ($formInputs['submit']) {
	if ($formInputs['perm_type']=="public" || !$formInputs['perm_type']) {
		$public_checked = ' checked="checked"';			
	} else {
		$public_checked = "";
	}	
	
	if ($formInputs['perm_type']=="all_extranet") {
		$private_checked = ' checked="checked"';			
	} else {
		$private_checked = "";
	}
	
	if ($formInputs['perm_type']=="selected_groups") {
		$selected_groups_checked = ' checked="checked"';			
	} else {
		$selected_groups_checked = "";
	}
	
	$logUserAccess = $formInputs['log_user_access'];
	
} elseif ($formInputs['cID']) {
	if (getPublic($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion'])) {
		$public_checked = ' checked="checked"';
	} else {
		$public_checked = "";
	}

	if (getPrivate($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion'])) {
		$private_checked = ' checked="checked"';
	} else {
		$private_checked = "";
	}

	list($groups,$users) = getPrivateByGroupAndUser($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);

	if (is_array($groups)) {
		$selected_groups_checked = ' checked="checked"';
		$private_checked = "";
		$public_checked = "";
	} else {
		$selected_groups_checked = "";
	}
	
	if (inc('tribiq_cms_core_probusiness')) {
		$logUserAccess = tribiq_cms_core_probusiness::doesContentItemLogUserAccess($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);
	}
}


if ($editMode) {
	$formhtml = '
				<form name="setpermissions" id="setpermissions" method="post" action="?width='. $formInputs['width'] . '&height=' . $formInputs['height'] . '&KeepThis=true&TB_iframe=true&modal=true" class="thickbox" onsubmit="formHandler();return false;">
					<input type="hidden" id="formMode" name="formMode" value="edit" />
					<input type="hidden" id="cType" name="cType" value="' . $formInputs['cType'] . '" />';
					
	$formhtml .=	'
					<table class="thickbox_table" align="center" border="0">				
						<tr>
							<td colspan="4">'. getPhrase('_EDIT_PERMS_FOR_CONTENT_ITEM'). '</td>
						</tr>
						<tr id="errorDisplayRow" style="display:none;">
							<td class="thickbox_table" colspan="3"><div id="errorDisplay" style="display:none;">' . $errordisplay . '</div></td>
						</tr>
						<tr>
							<td colspan="3">
								<input type="radio" name="perm_type" id="perm_type1" onChange="if (this.checked && get(\'log_user_access\')) get(\'log_user_access\').disabled = true;"
									value="public"' . $public_checked . ' /><label for="perm_type1"> ' . getPhrase('_PUBLICLY_VISIBLE') . '</label>
							</td>
						</tr>
						<tr>
							<td colspan="3">
								<input type="radio" name="perm_type" id="perm_type2" onChange="if (this.checked && get(\'log_user_access\')) get(\'log_user_access\').disabled = false;"
									value="all_extranet"' . $private_checked . ' /><label for="perm_type2"> ' . getPhrase('Private: can be viewed by All Extranet Users') . '</label>
							</td>							
						</tr>
						<tr>
							<td colspan="3">
								<input type="radio" name="perm_type" id="perm_type3" onChange="if (this.checked && get(\'log_user_access\')) get(\'log_user_access\').disabled = false;"
									value="selected_groups"' . $selected_groups_checked . ' /><label for="perm_type3"> ' . getPhrase('Private: can be viewed by members of selected Groups:') . '</label>
							</td>							
						</tr>
						<tr>
							<td>
								<div>' . getPhrase('_ALL_GROUPS') . '</div>
								<select name="all_items" id="all_items" multiple="multiple" size="10" style="width: 300px;" onClick="tribiqTab.checkSelected_GroupsRadio()">';
	
	$sql = "SELECT id,
				name
			FROM " . DB_NAME_PREFIX . "groups";
	
	if ($formInputs['selected_items']) {
		$sql .= " WHERE id NOT IN (" . mysql_real_escape_string($formInputs['selected_items']) . ")";
	} elseif ($formInputs['cID'] && !isset($formInputs['selected_items'])) {
		$sql .= "	LEFT JOIN (SELECT * FROM " . DB_NAME_PREFIX . "group_content_link WHERE content_id = " . $formInputs['cID'] . " AND content_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "' AND content_version = " . $formInputs['cVersion'] . ") AS groupcontent ON " . DB_NAME_PREFIX . "groups.id = groupcontent.group_id 
			WHERE groupcontent.group_id IS NULL";
	}
	
	$sql .= " ORDER BY name ASC";
				
	$result = my_mysql_query($sql);
	
	while ($row = mysql_fetch_array($result)) {
		$formhtml .= '<option value="'. $row['id']. '">'. $row['name']. '</option>
';						
	}	
	
	$formhtml .= '							
								</select>
							</td>
							<td>
								<input type="button" name="right" value="&gt;&gt;" onClick="tribiqAFB.moveOptions(\'all_items\', \'selected_items\'); get(\'perm_type3\').checked=true;" \><br />
								<input type="button" name="left" value="&lt;&lt;" onClick="tribiqAFB.moveOptions(\'selected_items\', \'all_items\');" \>
							</td>
							<td>
								<div>' . getPhrase('_SELECTED_GROUPS') . '</div>
								<select name="selected_items" id="selected_items" multiple="multiple" size="10" style="width: 300px;" onClick="tribiqTab.checkSelected_GroupsRadio();">';
								
	if (isset($formInputs['selected_items'])) {
		$newArray = explode(',',$formInputs['selected_items']);
		
		foreach ($newArray as $item) {
			if (!empty($item)) {
				$groupDetails = getGroupDetails($item);
				$formhtml .= '
									<option value="' . $item . '">' . $groupDetails['name'] . '</option>';
			}
		}
	} elseif ($formInputs['cID']) {
		$sql = "SELECT id,
					name
				FROM " . DB_NAME_PREFIX . "groups
					JOIN " . DB_NAME_PREFIX . "group_content_link ON " . DB_NAME_PREFIX . "groups.id = " . DB_NAME_PREFIX . "group_content_link.group_id
				WHERE content_id = " . $formInputs['cID'] . " 
					AND content_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "' 
					AND content_version = " . $formInputs['cVersion'] . "
				ORDER BY name ASC";
					
		$result = my_mysql_query($sql);
		
		while ($row = mysql_fetch_array($result)) {
			$formhtml .= '
									<option value="' . $row['id'] . '">' . $row['name'] . '</option>';
		}
	}
	
	$formhtml .= '							
								</select>';
								
	if (function_exists('displayExtraPermissionsOptions')) {
		$formhtml .= displayExtraPermissionsOptions($formInputs);
	}
	
	$formhtml .= '
							</td>
						</tr>
					</table>
					<table>';
					
} else {
	$formhtml = '
				<form name="setpermissions" action="?width='. $formInputs['width'] . '&height=' . $formInputs['height'] . '&KeepThis=true&TB_iframe=true&modal=true" id="editmetadata" method="post" class="thickbox" onsubmit="formHandler(this);return false;">
					<input type="hidden" id="formMode" name="formMode" value="view" />
					<table class="thickbox_table" id="content_form" border="0">';

	$permissions = getContentPermissions ($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);
	$permissions_string = getContentPermissionsString($permissions['private'],$permissions['groups'],$permissions['users']);

				
	$formhtml .= '				
						<tr>
							<td colspan="2">'. getPhrase('_EDIT_PERMS_FOR_CONTENT_ITEM'). '</td>
						</tr>
						
						<tr>
							<td class="title" >' . getPhrase('_VISIBLE_TO:') . '</td>
							<td >' . htmlspecialchars($permissions_string) . '</td>
						</tr>';
}


if (inc('tribiq_cms_core_probusiness')) {
	$formhtml .= tribiq_cms_core_probusiness::showLogUserAccessCheckbox($formInputs['formMode'] == 'edit', $logUserAccess, $public_checked);
}


if ($editMode && $showEditButton) {
	$formhtml .= '
						<tr>
							<td>&nbsp;</td>
							<td class="left">
								<input type="submit" id="submit" class="submit" value="' . getPhrase('_CANCEL') . '" onclick="cancelEdit();" />
							</td>
						</tr>';
						
} elseif ($showEditButton && (($formInputs['cVersion']==getLatestVersion($formInputs['cID'],$formInputs['cType'])) || getLatestVersionStatus($formInputs['cID'],$formInputs['cType'])!="private_draft")) {
	$formhtml .= '
						<tr>
							<td>&nbsp;</td>
							<td class="left">
								<input type="submit" id="submit" name="submit" class="submit" value="' . getPhrase('_EDIT') . '" />
							</td>
						</tr>';
}

	
$formhtml .= '		</table>
				</form>';	
			
return array($formhtml,$msg,$type_msg);
?>