<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || arrayKey($_SESSION, 'admin_logged_into_site') != SUBDIRECTORY. SITENAME) exit;

if ($formInputs['cType']) {
	$contentType = getContentTypes($formInputs['cType']);
	$template_id = $contentType[0]['default_template_id'];
}

if ($formInputs['cID']) {
	$itemTemplate = getItemTemplate($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);
	$template_id = $itemTemplate['template_id'];
}

if ($formInputs['template_id']) {
	$template_id = $formInputs['template_id'];
}

if ($formInputs['formMode']=='edit' || !$formInputs['cID']) {
	$formhtml = '
		<form name="settemplate" id="settemplate" action="?width='. $formInputs['width'] . '&height=' . $formInputs['height'] . '&KeepThis=true&TB_iframe=true&modal=true" id="setmetadata" method="post" class="thickbox" onsubmit="formHandler();return false;">
			<input type="hidden" id="formMode" name="formMode" value="edit" />
			<input type="hidden" id="cType" name="cType" value="' . $formInputs['cType'] . '" />';
	
	$formhtml .= '
			<input type="hidden" id="initial_template_id" value="' . $template_id . '" />
			
		<table class="thickbox_table" id="content_form" border="0">
			<tr id="errorDisplayRow" style="display:none;">
				<td colspan="2"><div id="errorDisplay" style="display:none;">' . $errordisplay . '</div></td>
			</tr>
			<tr>
				<td colspan="2">Use this screen to edit the Template for this Content Item.</td>
			</tr>
			<tr>
				<td class="title" ><label for="title">' . getPhrase('Template Family and Template:') . '</label></td>
				<td>';
	
	if ($templates = getAllExistingTemplates($GLOBALS['cType'])) {
		foreach ($templates as $template) {
			if ($template['status']=="active") {
				if ($template_id==$template['template_id']) {
					$checked = ' checked="checked"';
				} else {
					$checked = '';
				}
				
				$onclick = ' onclick="tribiqTab.startSkinsRequest(\'' . $formInputs['cID'] . '\',\'' . addslashes($formInputs['cType']) . '\',\'' . $formInputs['cVersion'] . '\',\'' . $template['template_id'] . '\')"';
	
				if (!$template_family || $template['family_name']!=$template_family) {
					$template_family = $template['family_name'];
					$formhtml .= '
						<p><b>' . $template_family . '</b></p>'; 
				}
			
				$formhtml .= '
					<input type="radio" name="template_id" id="template_id" value="' . $template['template_id'] . '"' . $checked . $onclick . ' />' . $template['filename'] . ' (' . $template['name'] . ')<br />';
			}
		}
	} else {
		$formhtml .= getPhrase('_NO_TEMPLATES');
	}
							
	$formhtml .= '
				</td>
			</tr>
			
			<tr><td id="skin_list" colspan="2"></td></tr>';
	
	if ($showEditButton) {
		$formhtml .= '
			<tr>
				<td>&nbsp;</td>
				<td class="left">
					<input type="submit" id="submit" class="submit" value="' . getPhrase('_CANCEL') . '" onclick="cancelEdit();" />
				</td>
			</tr>';
	}
	
	$formhtml .= '
			<tr>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
			</tr>
		</table>
	</form>';
} else {
	$formhtml = '<form name="settemplate" action="?width='. $formInputs['width'] . '&height=' . $formInputs['height'] . '&KeepThis=true&TB_iframe=true&modal=true" id="editmetadata" method="post" class="thickbox" onsubmit="formHandler(this);return false;">
					<input type="hidden" id="formMode" name="formMode" value="view" />
					<table class="thickbox_table" id="content_form" border="0">';

	$template = getItemTemplate($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);

	if ($defaultSkinName = checkForActiveTemplateSkin($template['template_id'])) {
		$defaultSkinMessage = getPhrase("_DEFAULT_SKIN:",array("skinName" => $defaultSkinName . " (" . getPhrase("_SKIN_SET_AT_TEMPLATE_LEVEL") . ")"));
	} elseif ($defaultSkinName = checkForActiveTemplateFamilySkin($template['template_id'])) {
		$defaultSkinMessage = getPhrase("_DEFAULT_SKIN:",array("skinName" => $defaultSkinName . " (" . getPhrase("_SKIN_SET_AT_TEMPLATE_FAMILY_LEVEL") . ")"));
	} else {
		$defaultSkinMessage = getPhrase("_DEFAULT_SKIN:",array("skinName" => getPhrase("_NOT_SET")));
	}

	$formhtml .= '				
						<tr>
							<td colspan="2">Use this screen to edit the Template for this Content Item.</td>
						</tr>
						
						<tr>
							<td class="title" >' . getPhrase('Template Family and Template:') . '</td>
							<td >
								' . $template['family_name'] . '
								<br/>
								' . $template['filename'] . ' (' . $template['name'] . ')</td>
						</tr>
						<tr>
							<td class="title" >' . getPhrase('_SKIN:') . '</td>
							<td >'. (
								($skinName = checkForActiveContentItemSkin($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']))?
									$skinName
								:
									$defaultSkinMessage
							). '</td>
						</tr>';
	
	if ($showEditButton && (($formInputs['cVersion']==getLatestVersion($formInputs['cID'],$formInputs['cType'])) || getLatestVersionStatus($formInputs['cID'],$formInputs['cType'])!="private_draft")) {
		$formhtml .= '
						<tr>
							<td>&nbsp;</td>
							<td class="left">
								<input type="submit" id="submit" name="submit" class="submit" value="' . getPhrase('_EDIT') . '" />
							</td>
						</tr>';
	}
	
	$formhtml .= '
					</table>
				</form>';	
}

return array($formhtml,$msg,$type_msg);
?>