<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || arrayKey($_SESSION, 'admin_logged_into_site') != SUBDIRECTORY. SITENAME) exit;

$tab_programs = array();
$sections = array();
$valuesInDB = array();


if ($pluginId && $instanceId) {
	$plugin = getPluginDetails($pluginId);
	$instance = getPluginInstanceDetails($instanceId);
} elseif ($pluginId) {
	$plugin = getPluginDetails($pluginId);
	$instance = array('framework' => $plugin['default_framework'], 'keep_in_album' => $plugin['keep_in_album']);
} else {
	$plugin = $instance = getPluginInstanceDetails($instanceId);
	$pluginId = $instance['plugin_id'];
}


if ($nest) {
	$sql = "
		SELECT tab, ord, framework
		FROM ". DB_NAME_PREFIX. "nested_plugins
		WHERE id = ". (int) $nest;
	
	$result = my_mysql_query($sql);
	$row = mysql_fetch_assoc($result);
	$valuesInDB['ord'] = arrayKey($row, 'ord');
	$valuesInDB['tab'] = arrayKey($row, 'tab');
	$instance['framework'] = arrayKey($row, 'framework');
}


$pluginName = $plugin['plugin_name'];

//Load the XML description for this plugin
if (!validatePluginFromXMLDescription('plugins/'. $pluginName. '/db_updates', 'description.xml', $pluginName, $pluginId, $desc)) {
	echo ' plugins/'. $pluginName. '/db_updates/description.xml not found or invalid!';
	exit;
}


//Get the instance's name, or try to come up with a default value if this is a new instance
$instanceName = $instance['instance_name'] = ifNull(arrayKey($instance, 'instance_name'), (string) $desc->default_instance_name, (string) $desc->display_name);

//If this is a new instance, try and ensure that the name we are suggesting is unique
if (!$instanceId) {
		$sql = "
			SELECT COUNT(*)
			FROM  ". DB_NAME_PREFIX. "plugin_instances
			WHERE name LIKE '". mysql_real_escape_string($instanceName). "%'";
		$result = my_mysql_query($sql);
		$row = mysql_fetch_row($result);
		if ($row[0]) {
			$instanceName .= ' ('. ($row[0] + 1). ')';
			$instance['instance_name'] = $instanceName;
		}
}


//Look for frameworks
$frameworks = listPluginThemeFrameworks($pluginName, $plugin['class_name'], $plugin['default_framework']);


if ($instanceId) {
	//Load the values from the database
	$sql = "
		SELECT
			CONCAT('setting_', name) AS field, 
			`value`
		FROM ". DB_NAME_PREFIX. "plugin_settings
		WHERE instance_id = ". (int) $instanceId. "
		  AND nest = ". (int) $nest;
	$result = my_mysql_query($sql);
	
	while($row = mysql_fetch_assoc($result)) {
		$valuesInDB[$row['field']] = $row['value'];
	}
}


//Create the first tab, and add the instance name/framework in
$sections[$i=1] = array();

$tab_programs['plugin_settings_tab_1'] = array();
$tab_programs['plugin_settings_tab_1']['tab_label'] = getPhrase('Framework');

getPluginSettingDescAddFieldsToFirstSection($plugin, $instance, $instanceId, $frameworks, $sections[1], $valuesInDB, $nest, !$nest);


//Loop through sections and then the settings in each section, noting them down
if ($desc->slot_settings->section) {
	foreach ($desc->slot_settings->section as $section) {
		if ($section->setting) {
			
			//Insist that a name be set
			if (!($sectionName = (string) SimpleXMLAttribute($section, 'name'))) {
				continue;
			}
			
			$fields = array();
			
			foreach($section->setting as $setting) {
				
				//Insist that a type be set
				if (!$type = $setting->type) {
					continue;
				}
				
				$options = array();
				$field = 'setting_'. $setting->name;
				
				//Rather than have plugin developers type the whole enum string,
				//they can use <possible_value> tags to set possible values
				if (strtolower($type) == 'enum' || strtolower($type) == 'select') {
					if ($setting->possible_values && $setting->possible_values->value) {
						foreach($setting->possible_values->value as $possible_value) {
							if ($possible_value->name) {
								$options[(string) $possible_value->name] = ifNull((string) $possible_value->label, (string) $possible_value->name);
							} else {
								$options[(string) $possible_value] = (string) $possible_value;
							}
						}
					
					} else if ($setting->static_method && inc((string) $setting->static_method->source_plugin)) {
						$options = call_user_func_array(array((string) $setting->static_method->source_plugin, (string) $setting->static_method->source_method), array());
					}
				}
				
				if ($requires = (string) $setting->requires) {
					$requires = 'setting_'. $requires;
				}
				
				//Add information about this field
				$fields[$field] = array(
					'Table' => 'plugin_settings',
					'Setting Name' => (string) $setting->name,
					'Label' => ifNull((string) $setting->label, (string) $setting->name),
					'Type' => $type,
					'Null' => 'NO',
					
					'Requires' => $requires,
					'Requires Value' => $setting->requires_value,
					'Options' => $options,
					
					'Nothing Selected Phrase' => (string) $setting->nothing_selected_phrase,
					'Select Phrase' => (string) $setting->select_phrase,
					'Path' => (string) $setting->path,
					'Target Path' => (string) $setting->target_path,
					'Min Path' => (string) $setting->min_path,
					'Max Path' => (string) $setting->max_path,
					'Disallow Identical Min Path' => engToBoolean($setting->disallow_identical_min_path),
					
					'Pre Field HTML' => (string) $setting->pre_field_html,
					'Post Field HTML' => (string) $setting->post_field_html,
					'Note Below' => (string) $setting->note_below);
				
				if (!isset($valuesInDB[$field])) {
					$valuesInDB[$field] = (string) $setting->default_value;
				}
			}
			
			$sections[++$i] = $fields;
			$tab_programs['plugin_settings_tab_'. $i] = array();
			$tab_programs['plugin_settings_tab_'. $i]['tab_label'] = getPhrase($sectionName);
			
			if ($section->max_height) {
				$tab_programs['plugin_settings_tab_1']['max_height'] = (string) $section->max_height;
			}
			
			//Currently there's a nine tab limit
			if ($i == 9) {
				break;
			}
		}
	}
}

return false;
?>