<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

if (!validatePluginFromXMLDescription($path, $updateFile, $pluginName, $pluginId, $desc)) {
	return false;
}


//Update the plugins table with the details
$sql = "
	UPDATE ". DB_NAME_PREFIX. "plugins SET
		name = '". mysql_real_escape_string($pluginName). "',
		class_name = '". mysql_real_escape_string($desc->class_name). "',
		vlp_class = '". mysql_real_escape_string($desc->vlp_class_name). "',
		display_name = '". mysql_real_escape_string($desc->display_name). "',
		version = '". mysql_real_escape_string($desc->version). "',
		company_name = '". mysql_real_escape_string(ifNull((string) $desc->author_name, (string) $desc->company_name)). "',
		default_framework = '". mysql_real_escape_string($desc->default_framework). "',
		default_theme = '". mysql_real_escape_string($desc->default_theme). "',
		uses_instances = ". engToBoolean($desc->uses_instances). ",
		keep_in_album = ". engToBoolean($desc->keep_in_album). ",
		feature_plugin = ". engToBoolean($desc->feature_plugin). ",
		nestable = ". engToBoolean($desc->nestable). "
	WHERE id = '". (int) $pluginId. "'";
my_mysql_query($sql);

//Remove any existing settings
$sql = "
	DELETE FROM ". DB_NAME_PREFIX. "plugin_setting_defs
	WHERE plugin_id = '". (int) $pluginId. "'";
my_mysql_query($sql);

//Loop through every section for slot plugin settings
if ($desc->slot_settings->section) {
	foreach($desc->slot_settings->section as $section) {
		//insist that a section name be set
		if (!$sectionName = SimpleXMLAttribute($section, 'name')) {
			continue;
		}
		
		//Loop through each setting
		foreach($section->setting as $setting) {
			//Insist that a name and type be set
			if ((!$setting->name) || (!$type = $setting->type)) {
				continue;
			}
			
			//Insert the setting definition
			$sql = "
				INSERT INTO ". DB_NAME_PREFIX. "plugin_setting_defs SET
					plugin_id = '". (int) $pluginId. "',
					`name` = '". mysql_real_escape_string($setting->name). "',
					`type` = '". mysql_real_escape_string($setting->type). "',
					default_value = '". mysql_real_escape_string($setting->default_value). "'";
			my_mysql_query($sql);
		}	
	}
}


//Remove any existing dependencies
$sql = "
	DELETE FROM ". DB_NAME_PREFIX. "plugin_dependencies
	WHERE plugin_id = '". (int) $pluginId. "'";
my_mysql_query($sql);

//Record any dependencies
if ($desc->dependencies) {
	if ($desc->dependencies->plugin) {
		foreach($desc->dependencies->plugin as $dependency) {
			if (((string) $dependency) != $pluginName) {
				$sql = "
					INSERT INTO ". DB_NAME_PREFIX. "plugin_dependencies SET
						plugin_id = '". (int) $pluginId. "',
						plugin_name = '". mysql_real_escape_string($pluginName). "',
						plugin_class_name = '". mysql_real_escape_string($desc->class_name). "',
						dependency_plugin_class_name = '". mysql_real_escape_string($dependency). "',
						`type` = 'dependency'";
				my_mysql_query($sql);
			}
		}
	}
}

if ($desc->inheritance) {
	if ($desc->inheritance->plugin) {
		foreach($desc->inheritance->plugin as $inheritance) {
			if (((string) $dependency) != $pluginName) {
				$sql = "
					INSERT INTO ". DB_NAME_PREFIX. "plugin_dependencies SET
						plugin_id = '". (int) $pluginId. "',
						plugin_name = '". mysql_real_escape_string($pluginName). "',
						plugin_class_name = '". mysql_real_escape_string($desc->class_name). "',
						dependency_plugin_class_name = '". mysql_real_escape_string($inheritance). "',
						`type` = 'inheritance'";
				my_mysql_query($sql);
			}
		}
	}
}

if ($desc->compatibility) {
	if ($desc->compatibility->plugin) {
		foreach($desc->compatibility->plugin as $compatibility) {
			if (((string) $dependency) != $pluginName) {
				$sql = "
					INSERT INTO ". DB_NAME_PREFIX. "plugin_dependencies SET
						plugin_id = '". (int) $pluginId. "',
						plugin_name = '". mysql_real_escape_string($pluginName). "',
						plugin_class_name = '". mysql_real_escape_string($desc->class_name). "',
						dependency_plugin_class_name = '". mysql_real_escape_string($compatibility). "',
						`type` = 'compatibility'";
				my_mysql_query($sql);
			}
		}
	}
}


//Remove any existing signals
$sql = "
	DELETE FROM ". DB_NAME_PREFIX. "signals
	WHERE plugin_id = '". (int) $pluginId. "'";
my_mysql_query($sql);

//Record any signals listened for
if ($desc->signals) {
	if ($desc->signals->signal) {
		foreach($desc->signals->signal as $signal) {
			$sql = "
				INSERT INTO ". DB_NAME_PREFIX. "signals SET
					signal_name = '". mysql_real_escape_string($signal->name). "',
					plugin_id = '". (int) $pluginId. "',
					plugin_name = '". mysql_real_escape_string($pluginName). "',
					plugin_class = '". mysql_real_escape_string($desc->class_name). "',
					static_method = ". engToBoolean($signal->static). ",
					suppresses_plugin_class = '". mysql_real_escape_string($signal->suppresses_plugin_class). "'";
			my_mysql_query($sql);
		}
	}
}


//Record any jobs the Plugin has
$jobs = '';
if ($desc->jobs) {
	if ($desc->jobs->job) {
		foreach($desc->jobs->job as $job) {
			$jobs .= ($jobs? ',' : ''). "'". mysql_real_escape_string($job->name). "'";
			$sql = "
				INSERT IGNORE INTO ". DB_NAME_PREFIX. "jobs SET
					job_name = '". mysql_real_escape_string($job->name). "',
					plugin_id = '". (int) $pluginId. "',
					plugin_name = '". mysql_real_escape_string($pluginName). "',
					plugin_class = '". mysql_real_escape_string($desc->class_name). "',
					static_method = ". engToBoolean($job->static). ",
					months = '". mysql_real_escape_string(trim($job->months)). "',
					days = '". mysql_real_escape_string(trim($job->days)). "',
					hours = '". mysql_real_escape_string(trim($job->hours)). "',
					minutes = '". mysql_real_escape_string(trim($job->minutes)). "',
					first_n_days_of_month = ". (int) $job->first_n_days_of_month. ",
					log_on_action = ". engToBoolean($job->log_on_action). ",
					log_on_no_action = ". engToBoolean($job->log_on_no_action). ",
					email_on_action = ". engToBoolean($job->email_on_action). ",
					email_on_no_action = ". engToBoolean($job->email_on_no_action). ",
					email_address_on_action = '". mysql_real_escape_string(EMAIL_ADDRESS_GLOBAL_SUPPORT). "',
					email_address_on_no_action = '". mysql_real_escape_string(EMAIL_ADDRESS_GLOBAL_SUPPORT). "',
					email_address_on_error = '". mysql_real_escape_string(EMAIL_ADDRESS_GLOBAL_SUPPORT). "'";
			my_mysql_query($sql);
		}
	}
}

//Remove any unused jobs
$innerSql = "
	FROM ". DB_NAME_PREFIX. "jobs
	WHERE plugin_id = ". (int) $pluginId;

if ($jobs) {
	$innerSql .= "
	  AND job_name NOT IN (". $jobs. ")";
}

$sql = "
	DELETE FROM ". DB_NAME_PREFIX. "job_logs
	WHERE job_id IN (
		SELECT id
		". $innerSql. "
	)";

my_mysql_query($sql);

$sql = "
	DELETE ". $innerSql;

my_mysql_query($sql);



//Check if any new Visitor Phrases are in use for this Plugin, and install any new ones that have been added if so
//(For updating Plugins only, not installing)
if (is_dir($path = CMS_ROOT. 'plugins/'. $pluginName. '/phrases/')) {
	$sql = "
		SELECT DISTINCT language_id
		FROM ". DB_NAME_PREFIX. "visitor_phrases
		WHERE plugin_class = '". mysql_real_escape_string($desc->class_name). "'";
	
	$installedLanguages = array();
	$result = my_mysql_query($sql);
	while($row = mysql_fetch_assoc($result)) {
		$installedLanguages[] = $row['language_id'];
	}
	
	if (!empty($installedLanguages)) {
		$importFiles = scanPluginPhraseDir($pluginName);
		
		//For every language in the site, try to find a matching csv file
		foreach ($installedLanguages as $installedLang) {
			$bestMatch = false;
			foreach ($importFiles as $languageId => $file) {
				if ($languageId == $installedLang) {
					//If a language on the site matches a language availible to the Plugin, import that
					$bestMatch = $file;
					break;
				
				} elseif (substr($languageId, 0, 2) == substr($installedLang, 0, 2)) {
					//Otherwise if there is a close match, use that
					$bestMatch = $file;
				}
			}
			
			if ($bestMatch) {
				importVisitorLanguagePack($path. $bestMatch, $installedLang, $adding = true, $scanning = false, $forceLanguageIdOverride = true);
			}
		}
	}
}


return true;
?>