<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

$errArray = array();

if (isset($userDetails['username'])) {
	if (!$userDetails['username']) {
		$errArray[] = getPhrase('Please ensure you enter a Username for the User.');
	} else {
		//Allow valid email addresses as well has valid screen names
		if (!validateEmailAddress($userDetails['username']) && !validateScreenName($userDetails['username'])) {
			$errArray[] = getPhrase('The Username should be either a valid Screen Name or a valid email address. Please choose a username that is either a valid email addres, or contains only word-characters.');
		
		} elseif (checkIfUsernameIsTakenById($userDetails['username'], $userDetails['userId']) ) {
			$errArray[] = getPhrase('_MSG_OTHER_USERNAME_USER');
		}
	}
}

if (isset($userDetails['screen_name'])) {
	if (!$userDetails['screen_name']) {
		$errArray[] = getPhrase('Please ensure you enter a Screen Name for the User.');
	} else {
		if (!validateScreenName($userDetails['screen_name'])) {
			$errArray[] = getPhrase('The Screen Name contains special characters. Please choose a screen name that contains only word-characters.');
		
		} elseif (checkIfScreenNameIsTakenById($userDetails['screen_name'], $userDetails['userId']) ) {
			$errArray[] = getPhrase('This Screen Name already exists. Please choose a different screen name.');
		}
	}
}

if ($userDetails['email']) {
	if (!validateEmailAddress($userDetails['email'])) {
		$errArray[] = getPhrase('_MSG_VALID_EMAIL_ADMIN');
	} else {
		$sql = "
			SELECT 1
			FROM ". DB_NAME_PREFIX. "users
			WHERE `email` = '". mysql_real_escape_string($userDetails['email']). "'
			  AND id != ". (int) $userDetails['userId'];
		
		$result = my_mysql_query($sql);
		if (mysql_fetch_row($result)) {
			$errArray[] = getPhrase('This Email Address is already taken by another user.');
		}
	}
}

if ($userDetails['alt_email'] && !validateEmailAddress($userDetails['alt_email'])) {
	$errArray[] = getPhrase('_MSG_VALID_EMAIL_ADMIN');
}

if ($userDetails['send_user_email_notification'] && $userDetails['status'] != 'active') {
	$errArray[] = getPhrase('_NO_CHANGES_TO_NOTIFY');

} elseif ($userDetails['send_user_email_notification'] && !getEmailTemplate('ENET Access Granted')) {
	$errArray[] = getPhrase('_ERROR_EMAIL_TEMPLATE_MISSING', array('template' => 'ENET Access Granted'));
}


if (isset($userDetails['password']) && $userDetails['password'] === '') {
	$errArray[] = getPhrase('_MSG_NO_PASS');

} elseif (isset($userDetails['password']) && strlen($userDetails['password']) < getSiteConfig('min_user_password_length')) {
	$mrg = array ( 'min_pass_length' => getSiteConfig('min_user_password_length'));
	$errArray[] = getPhrase('_MIN_PASSWORD_LENGTH', $mrg);
}

if (isset($userDetails['password_reconfirm']) && $userDetails['password_reconfirm'] === '') {
	$errArray[] = getPhrase('_MSG_PASS');

} elseif (isset($userDetails['password_reconfirm']) && isset($userDetails['password']) && $userDetails['password'] != $userDetails['password_reconfirm']) {
	$errArray[] = getPhrase('_MSG_PASS_2');
}


if (isset($userDetails['status']) && !$userDetails['status']) {
	$errArray[] = getPhrase('_MSG_NO_STATUS');
}

return array('valid' => empty($errArray), 'errArray' => $errArray);
?>