<?php

/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

mb_internal_encoding('UTF-8');
error_reporting(E_ALL ^ E_NOTICE);

if (!defined('NOT_ACCESSED_DIRECTLY')) {
	//Define a constant to mark than any further include files have been legitamately included
	define('NOT_ACCESSED_DIRECTLY', true);
	define('THIS_FILE_IS_BEING_DIRECTLY_ACCESSED', false);
}


//Attempt to set the working directory to the CMS Root, if it is not already
$isFilelimit = 4;
while (!is_file('visitorheader.inc.php')) {
	if (!--$isFilelimit) {
		echo 'Incorrect working directory set.';
		exit;
	} else {
		chdir('../');
	}
}
unset($isFilelimit);


if (!function_exists('windowsServer')) {
	function windowsServer() {
		return (stristr($php_uname = php_uname('s'), 'win')) && $php_uname != 'Darwin';
	}
}

require_once 'admin/db_updates/latest_revision_no.inc.php';


//Attempt to use caching for a page, to avoid sending something a client already has cached
function useCache($ETag = false, $maxAge = false) {
	
	//Set a time-out of about a month
	if ($maxAge === false) {
		$maxAge = 60*60*24*28;
	}
	header('Cache-Control: maxage='. $maxAge);
	header('Expires: '. gmdate('D, d M Y H:i:s', time() + $maxAge). ' GMT');
	
	//Set an ETag to identify this library
	if ($ETag) {
		header('ETag: "'. $ETag. '"');
		
		if (isset($_SERVER['HTTP_IF_NONE_MATCH']) && trim($_SERVER['HTTP_IF_NONE_MATCH']) == $ETag) {
			header('HTTP/1.1 304 Not Modified');
			exit;
		}
	}
}

//Attempt to use gzip compression to send a page
//Note that if you use this, you can then no longer use ob_start()!
function useGZIP($useGZIP = true) {
	//Note: IE 6 frequently crashes if we try to use compression
	if ($useGZIP && strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6') === false) {
		ob_start("ob_gzhandler");
	}
}