<?php

/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
require '../adminheader.inc.php';

$plugin = false;
if (issetArrayKey($_REQUEST, 'instanceId')) {
	$plugin = getPluginInstanceDetails($_REQUEST['instanceId']);

} elseif (issetArrayKey($_REQUEST, 'pluginId')) {
	$plugin = getPluginDetails($_REQUEST['pluginId']);
	$plugin['framework'] = $plugin['default_framework'];
}

if (!$plugin) {
	echo 'Plugin not found!';
	exit;
}

if (issetArrayKey($_REQUEST, 'framework')) {
	$framework = preg_replace('/[^\w-]/', '', $_REQUEST['framework']);
} else {
	$framework = $plugin['framework'];
}

$recurseLimit = 9;
while (!file_exists($path = CMS_ROOT. $visiblePath = 'plugins/'. $plugin['plugin_name']. '/frameworks/'. $framework. '/framework.html')) {
	
	if (!--$recurseLimit || !($inheritance = getPluginInheritance($plugin['class_name']))) {
		echo 'Framework not found!';
		exit;
	} else {
		$plugin = getPluginDetails($inheritance, 'class');
	}
}


if (issetArrayKey($_REQUEST, 'fetch')) {
	echo file_get_contents($path);
	exit;
}


?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title><?php echo htmlspecialchars($visiblePath); ?></title>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<script type="text/javascript" src="../libraries/mit/jquery/jquery-1.4.3.min.js"></script>
<script type="text/javascript" src="../libraries/mit/jquery/jquery.chili.min.js"></script>
<script type="text/javascript" src="../libraries/mit/jquery/jquery.chili.recipes.html.min.js"></script>
<script type="text/javascript" src="../libraries/mit/jquery/jquery.chili.recipes.tribiq.min.js"></script>
</head>
<body>

<pre><code class="chili-lang-html">
<?php
echo htmlspecialchars(file_get_contents($path));
?>
</code></pre>
</body>
</html>
