<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

function getMaxValue ($data) {
	foreach ($data as $point) {
		if ($point > $maxvalue) {
			$maxvalue = $point;
		}
	}
	return $maxvalue;
}

function displayBarchart ($chartWidth, $chartHeight,$bars) {
	$biggestBar = getMaxValue($bars);
	$output .= "<div class=\"barchart_outer\">\n";
	$output .= "	<table class=\"barchart\" style=\"width: " . $chartWidth . "px;height: " . $chartHeight . "px;\">\n";
	$output .= "		<tr>\n";
	$output .= "			<td colspan=\"" . count($bars) . "\">Max Hits this month: " . $biggestBar . "</td>\n";
	$output .= "		</tr>\n";
	$output .= "		<tr style=\"height: " . $chartHeight * 0.9 . "px;\">\n";
	foreach ($bars as $bar) {
		$output .= "			<td style=\"vertical-align: bottom;width: " . $chartWidth/count($bars) . "px\"><div class=\"bar\" style=\"height: " . (($bar/$biggestBar) * $chartHeight * 0.9) . "px;width: 100%;background-color: blue;\" title=\"value: " . $bar . "\">&nbsp;</div></td>\n";
	}
	$output .= "		</tr>\n";
	$output .= "		<tr style=\"height: " . $chartHeight * 0.1 . "px;\">\n";
	foreach (array_keys($bars) as $bar_key) {
		$output .= "			<td><div class=\"bar_legend\">" . $bar_key . "</div></td>\n";
	}
	$output .= "		</tr>\n";
	$output .= "	</table>\n";
	$output .= "</div>\n";
	return $output;
}

function getMonthlyHits ($month, $year) {
	$month = (int) $month;
	$year = (int) $year;
	
	$sql = "SELECT DAYOFMONTH(LAST_DAY('" . $year . "-" . $month . "-01'))";

	$result = my_mysql_query($sql);

	$row = mysql_fetch_array($result);

	$lastdayofmonth = $row[0];

	for ($i=1;$i<=$lastdayofmonth;$i++) {

		$sql = "SELECT DAYOFMONTH(hit_date) AS hit_day,
					SUM(hit_count) AS total_hits
				FROM " . DB_NAME_PREFIX . "stats_daily
				WHERE YEAR(hit_date) = '" . $year . "'
					AND MONTH(hit_date) = '" . $month . "'
					AND DAYOFMONTH(hit_date) = " . $i . "
				GROUP BY hit_day";

		$result = my_mysql_query($sql);

		if (mysql_num_rows($result)>0) {
			$row = mysql_fetch_array($result);

			$monthly_data[$i] = $row[1];
		} else {
			$monthly_data[$i] = 0;
		}
	}

	return $monthly_data;

}


function getYearlyHits ($year) {
	$year = (int) $year;

		$sql = "SELECT DATE_FORMAT(hit_date, \"%c\") AS hit_month,
					SUM(hit_count) AS total_hits
				FROM " . DB_NAME_PREFIX . "stats_daily
				WHERE YEAR(hit_date) = '" . $year . "'
					GROUP BY hit_month ORDER BY month(hit_date) ASC";

	$result = my_mysql_query($sql);

	if (mysql_num_rows($result)>0) {


	while ($row = mysql_fetch_array($result)) {
		$dataset[] = $row;
	}

	for ($i=1; $i<=12; $i++) {
		$have_data = false;

		foreach ($dataset as $data) {
			if ($i==$data[0]) {
				$yearstats[$i] = $data[1];
				$have_data = true;
			}
		}

		if (!$have_data) {
			$yearstats[$i] = 0;
		}
	}
	return $yearstats;
	} else {
	return false;
	}

}






function getMonthYearList () {
	$sql = "SELECT CONCAT(YEAR(hit_date),'-',DATE_FORMAT(hit_date,\"%m\")) AS monthyear
			FROM " . DB_NAME_PREFIX . "stats_daily
			GROUP BY monthyear
			ORDER BY monthyear DESC";

	$result = my_mysql_query($sql);

	if (mysql_num_rows($result)>0) {
		while ($row = mysql_fetch_array($result)) {
			$monthyearlist[] = $row[0];
		}

		return $monthyearlist;
	} else {
		return false;
	}
}

function getYearList () {
	$sql = "SELECT YEAR(hit_date) AS year
			FROM " . DB_NAME_PREFIX . "stats_daily
			GROUP BY year
			ORDER BY year DESC";

	$result = my_mysql_query($sql);

	if (mysql_num_rows($result)>0) {
		while ($row = mysql_fetch_array($result)) {
			$yearlist[] = $row[0];
		}

		return $yearlist;
	} else {
		return false;
	}
}

function getTopItemsPerMonth($month,$year,$num_items) {
		$month = (int) $month;
		$year = (int) $year;

		GLOBAL $siteConfig;

		$sql = "(SELECT UCASE(content_type) AS content_type,content_id,IF(LENGTH(title)>20,CONCAT(SUBSTR(title,1,25),'...'),title) AS item_name,
					SUM(hit_count) AS total_hits
				FROM " . DB_NAME_PREFIX . "stats_daily AS stats
				JOIN " . DB_NAME_PREFIX . "content_html AS html
					ON stats.content_id = html.id
						AND stats.content_version = html.version
				WHERE YEAR(hit_date) = '" . $year . "'
					AND MONTH(hit_date) = '" . $month . "'
					AND content_type = 'html'
				GROUP BY item_name)
				UNION (SELECT UCASE(content_type) AS content_type,content_id,IF(LENGTH(title)>20,CONCAT(SUBSTR(title,1,25),'...'),title) AS item_name,
					SUM(hit_count) AS total_hits
				FROM " . DB_NAME_PREFIX . "stats_daily AS stats
				JOIN " . DB_NAME_PREFIX . "content_document AS document
					ON stats.content_id = document.id
						AND stats.content_version = document.version
				WHERE YEAR(hit_date) = '" . $year . "'
					AND MONTH(hit_date) = '" . $month . "'
					AND content_type = 'document'
				GROUP BY item_name)
				UNION (SELECT UCASE(content_type) AS content_type,content_id,IF(LENGTH(title)>20,CONCAT(SUBSTR(title,1,25),'...'),title) AS item_name,
					SUM(hit_count) AS total_hits
				FROM " . DB_NAME_PREFIX . "stats_daily AS stats
				JOIN " . DB_NAME_PREFIX . "content_forum AS forum
					ON stats.content_id = forum.id
						AND stats.content_version = forum.version
				WHERE YEAR(hit_date) = '" . $year . "'
					AND MONTH(hit_date) = '" . $month . "'
					AND content_type = 'forum'
				GROUP BY item_name)
				ORDER BY total_hits DESC
				LIMIT " . $num_items;

		$result = my_mysql_query($sql);

		if (mysql_num_rows($result)>0) {
			while ($row = mysql_fetch_array($result)) {
				$topitemspermonth[substr($row['content_type'],0,4).str_pad($row['content_id'], $siteConfig['content_tag_zerofill'], "0", STR_PAD_LEFT)."\n".$row['item_name']] = $row['total_hits'];
			}

			return $topitemspermonth;

		} else {
			return false;
		}
}

function getLastRawStat() {

		$sql =  "SELECT MAX(hit_date) FROM " . DB_NAME_PREFIX . "stats_raw";

		$result = my_mysql_query($sql);

		if (mysql_num_rows($result)>0) {
			$row = mysql_fetch_array($result);
			$hitdate = $row[0];
			return $hitdate;
		} else {
			return false;
	}

}

function getLastDailyStat() {

		$sql =  "SELECT MAX(hit_date) FROM " . DB_NAME_PREFIX . "stats_daily";

		$result = my_mysql_query($sql);

		if (mysql_num_rows($result)>0) {
			$row = mysql_fetch_array($result);
			$hitdate = $row[0];
			return $hitdate;
		} else {
			return false;
	}

}

?>