<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

if (!$siteConfig && !$welcome) {
	$siteConfig = loadSiteConfig();
}

$gzf = issetArrayKey($siteConfig, 'compress_web_pages')? '?gz=1' : '?gz=0';
$gz = issetArrayKey($siteConfig, 'compress_web_pages')? '&amp;gz=1' : '&amp;gz=0';


//Add JS needed for the CMS
echo '
<script type="text/javascript" src="', $prefix, 'libraries/mit/jquery/jquery-1.4.3.min.js"></script>
<script type="text/javascript" src="', $prefix, 'libraries/mit/jquery/jquery-ui-1.8.6.', $welcome || checkPriv()? 'admin' : 'visitor', '.min.js"></script>
<script type="text/javascript" src="', $prefix, 'cmsjs/inc.js.php?v=', urlencode(CSS_JS_VERSION), $gz, '"></script>';
	
//Add JS needed for the CMS in Admin mode
if ($welcome || checkPriv()) {
	echo '
<script type="text/javascript" src="', $prefix, 'cmsjs/inc-admin.js.php?v=', urlencode(CSS_JS_VERSION), $gz, '"></script>';
}


//Write the URLBasePath, and other related JavaScript variables, to the page
echo '
<script type="text/javascript">
	var URLBasePath = "', addslashes(httpOrhttps(). $_SERVER["HTTP_HOST"] . SUBDIRECTORY), '";
	tribiq.languageId = "', addslashes($_SESSION["user_lang"]), '";
	tribiq.dpf = "', addslashes(arrayKey($siteConfig, 'vis_date_format_datepicker')), '";
	tribiq.indexDotPHP = "'. addslashes(indexDotPHP()). '";';
	
//Add location information about a content item if it is available
global $cID, $cType, $cVersion, $menuitem;
if ($cID) {
	echo '
	tribiq.cID = ', (int) $cID, ';';
}
if ($cType) {
	echo '
	tribiq.cType = "', addslashes(str_replace(array("\n", "\r"), '', $cType)), '";';
}
if ($cVersion) {
	echo '
	tribiq.cVersion = ', (int) $cVersion, ';';
}
if ($menuitem) {
	echo '
	tribiq.mID = ', (int) $menuitem, ';';
}
if (issetArrayKey($siteConfig, 'mod_rewrite_enabled')) {
	echo '
	tribiq.suffix = "', urlencode(arrayKey($siteConfig, 'mod_rewrite_suffix')), '";';
}

if ($welcome || checkPriv()) {
	echo '
	tribiqA.siteSettings = ', json_encode($siteConfig), ';';
}
	
if (defined('SKIN_PATH')) {
	global $skin;
	echo "\n	tribiq.skinId = ", (int) $skin['id'], ";";
	
	if (checkPriv()) {
		echo "\n	tribiq.SKIN_PATH = '", addslashes(htmlspecialchars(SKIN_PATH)), "';";
	}
}

echo '
	tribiq.useGZ = ', (int) issetArrayKey($siteConfig, 'compress_web_pages'), ';
</script>';


//Add JS needed for Plugins
if (!$welcome && cms_core::$pluginJS) {
	if (checkPriv()) {
		cms_core::$pluginJS .= '&amp;admin=1';
	}
	
	echo '
<script type="text/javascript" src="', $prefix, 'cmsjs/plugin.js.php?v=', urlencode(CSS_JS_VERSION), '&amp;ids=', cms_core::$pluginJS, $gz, '"></script>';
}

//Are there Plugins on this page..?
if (is_array($slotContents) && count($slotContents)) {
	echo '
<script type="text/javascript">';
	//Add encapculated objects for slots
	$i = 0;
	echo '
	tribiq.slot([';
	foreach ($slotContents as $slotName => &$instance) {
		if (checkPriv() || issetArrayKey($instance, 'class')) {
			echo
				$i++? ',' : '',
				'["',
					preg_replace('/[^\w-]/', '', $slotName), '",',
					(int) arrayKey($instance, 'instance_id'), ',',
					(int) arrayKey($instance, 'plugin_id');
			
			if (issetArrayKey($instance, 'class') && $instance['class']->cmsPluginApiLinkGetTabId()) {
				echo ',', (int) $instance['class']->cmsPluginApiLinkGetTabId();
			}
			
			echo ']';
		}
	}
	echo ']);',
	
	cms_core::$pluginPossibleThemes, '
</script>';

	//Include the JS for any plugin instances on the page, if they have any
	$JavaScriptOnPage = array();
	foreach($slotContents as &$instance) {
		if (issetArrayKey($instance, 'class')) {
			//Check if a framework has been set
			if ($instance['framework']) {
				//Check if this framework has any specific JavaScript, and include it if so
				//Note that there's no nice wrapping/caching support for this, as I intend it to be very rare that a framework needs specific JavaScript support
				$path = $instance['class']->cmsPluginApiLinkGetFrameworkDir(). 'javascript.js';
				
				if (!issetArrayKey($JavaScriptOnPage, $path)) {
					if (file_exists(CMS_ROOT. $path)) {
						echo "\n", '<script type="text/javascript" src="'. $prefix. $path. '"></script>';
					}
				}
			}
			
			$instance['class']->addRequestedScripts();
		}
	}
}

?>