<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

$this->setInstanceVariables($locationAndInstanceDetails, $nest, $tab, $errorMessage);

//Set up Themes, etc. for front-end Plugins
if ($this->instanceId) {
	//Get the current language
	$this->languageId = getContentLang($this->cID, $this->cType, $this->cVersion);
	
	//Find any inheritances this Plugin uses
	$this->cmsPluginApiLinkFindInheritances($this->pluginClassName);
	
	//Check that the chosen framework exists
	//Attempt to fall back to the default theme if it does not
	if ($this->framework || $this->defaultFramework) {
		if (!$this->framework || !($this->frameworkPath = $this->cmsPluginApiLinkFindPath($this->frameworkPluginName, $this->frameworkPluginClassName, 'frameworks/'. $this->framework, 'framework.html'))) {
			if ($this->defaultFramework && $this->framework != $this->defaultFramework) {
				$this->framework = $this->defaultFramework;
				if (!$this->frameworkPath = $this->cmsPluginApiLinkFindPath($this->frameworkPluginName, $this->frameworkPluginClassName, 'frameworks/'. $this->framework, 'framework.html')) {
					$this->framework = false;
				}
			} else {
				$this->framework = false;
			}
		}
	}
	
	//Check if a Theme from a Skin is being used. These will have a numeric name
	if ($this->themeStyle && is_numeric($this->themeStyle)) {
		$this->themePluginName = false;
		$this->themePluginClassName = $this->frameworkPluginClassName;
	
	//Otherwise use a Theme from the Plugins directory.
	//Check that the chosen theme style exists
	} elseif (!$this->themeStyle || !($this->themePath = $this->cmsPluginApiLinkFindPath($this->themePluginName, $this->themePluginClassName, 'themes/'. $this->themeStyle, 'stylesheet.css'))) {
		
		//Attempt to fall back to the default named Theme mentioned in the Skin, if it exists for this Plugin
		global $skin;
		if (issetArrayKey($skin, 'related_plugin_themes')) {
			foreach (explode(',', $skin['related_plugin_themes']) as $skinRelatedTheme) {
				if (issetArrayKey($skin, 'related_plugin_themes')
				 && $this->themeStyle != $skinRelatedTheme
				 && ($this->themePath = $this->cmsPluginApiLinkFindPath($this->themePluginName, $this->themePluginClassName, 'themes/'. $skinRelatedTheme, 'stylesheet.css'))) {
					$this->themeStyle = $skinRelatedTheme;
					break;
				}
			}
		}
		
		//Attempt to fall back to the default Theme mentioned in the Plugin, if it exists
		if (!$this->themeStyle) {
			if ($this->defaultTheme
			   && $this->themeStyle != $this->defaultTheme
			   && ($this->themePath = $this->cmsPluginApiLinkFindPath($this->themePluginName, $this->themePluginClassName, 'themes/'. $this->defaultTheme, 'stylesheet.css'))) {
				$this->themeStyle = $this->defaultTheme;
			
			//Fall back to using the first numbered Theme from the Skin (hopefully this exists!)
			} else {
				$this->themeStyle = 1;
				$this->themePluginName = false;
				$this->themePluginClassName = $this->frameworkPluginClassName;
			}
		}
		
		//Update any changes made in the $slotContents global array
		global $slotContents;
		$slotNameNestId = $this->slotName. ($this->eggId? '-'. $this->eggId : '');
		if (issetArrayKey($slotContents, $slotNameNestId)) {
			$slotContents[$slotNameNestId]['theme'] = $this->themeStyle;
		}
	}
	
	
	//Look up this plugin's settings, starting with the default values
	$this->cmsPluginApiLinkSettings = array();
	$sql = "
		SELECT `name`, default_value
		FROM ". DB_NAME_PREFIX. "plugin_setting_defs
		WHERE plugin_id = ". (int) $this->pluginId;
	$result = my_mysql_query($sql);
	
	while($row = mysql_fetch_assoc($result)) {
		$this->cmsPluginApiLinkSettings[$row['name']] = $row['default_value'];
	}
	
	//Now look up the settings that have been set, and overwrite the defaults
	$sql = "
		SELECT `name`, `value`
		FROM ". DB_NAME_PREFIX. "plugin_settings
		WHERE instance_id = ". (int) $this->instanceId. "
		  AND nest = ". (int) $nest;
	$result = my_mysql_query($sql);
	
	while($row = mysql_fetch_assoc($result)) {
		$this->cmsPluginApiLinkSettings[$row['name']] = $row['value'];
	}
}

return false;
?>