<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

global $errMsg, $cID;

if ($errMsg == "noSuchContentType") {
	echo '
			<h1>', getVLPPhrase('_CMS_ERROR_ITEM_NOT_FOUND_TITLE'), '</h1>
			<p>', getVLPPhrase('_CMS_ERROR_CONTENT_TYPE_NOT_FOUND'), '</p>';

} elseif ($errMsg == "noSuchContentID" || $errMsg == "noSuchContentVersion") {
	/* Item not found */
	if (ifNull($_REQUEST['cID'], $_REQUEST['id'], $cID)) {
		$mrg = array('cID' => htmlspecialchars(ifNull($_REQUEST['cID'], $_REQUEST['id'], $cID)));
		echo '
		<h1>', getVLPPhrase('_CMS_ERROR_ITEM_NOT_FOUND_TITLE'), '</h1>', '
		<p>', getVLPPhrase('_CMS_ERROR_ITEM_NOT_FOUND', $mrg), '</p>';

	} else {
		$mrg = array('admin_login_link' => 'admin/storekeeper.php');
		echo '
		<h1>', getVLPPhrase('_CMS_ERROR_ITEM_NOT_FOUND_TITLE'), '</h1>', '
		<p>', getPhrase("No Item ID or Alias was passed in the URL, and the site's Default Homepage Alias or ID are not set or invalid."), '</p>
		<p>', getPhrase('If you are an Administrator, please log in to your <a href="[[admin_login_link]]">Administration Area</a> with the correct authorization to set up your site.', $mrg), '</p>';
	}
} elseif ($errMsg == "dbConnectionError") {
	echo "<h1>Database Error</h1><p>Sorry, a database connection error occurred.</p>";
} elseif ($errMsg == "dbQueryError") {
	echo "<h1>Database Error</h1><p>Sorry, a database query error occurred.</p><p>$sql</p>";

} elseif ($errMsg == "dumbMenuID") {
	echo "<h1>". getPhrase("_UNLINKED_MENU_ITEM") ."</h1>
	<p class=\"text_red\">". getPhrase("_UNLINKED_NOT_EXIST") ."</p>
	<p>". getPhrase("_UNLINKED_NOT_EXIST1") ."</p>
	<p>". getPhrase("_UNLINKED_NOT_EXIST2") ."</p>";

} elseif ($errMsg == "notLoggedIn") {
	$mrg = array('admin_login_link' => 'admin/storekeeper.php');
	echo '
	<p>', getPhrase('No Login Page has been set for this Language.'), '</p>
	<p>', getPhrase('If you are an Administrator, please log in to your <a href="[[admin_login_link]]">Administration Area</a> with the correct authorization to set up your site.', $mrg), '</p>';

} elseif ($errMsg == "noPermission") {
	echo '
	<h1>', getVLPPhrase('_AUTH_PERMISSION_DENIED_TITLE'), '</h1>
	<p>', getVLPPhrase('_AUTH_PERMISSION_DENIED'), '</p>';

} elseif ($errMsg == "noTemplateExists") {
	global $use_template_family, $use_template_filename;
	
	if (!$use_template_family || !$use_template_filename) {
		echo '
		<h2>', getPhrase('_MSG_NO_TEMPLATE_SELECTED'), '</h2>';
	} else {
		echo '
		<h2>', getPhrase('NO_SUCH_TEMPLATE_EXISTS:'), '</h2>
		<p><pre>'. CMS_ROOT. 'templates/'. SITENAME. '/'. $use_template_family. '/'. $use_template_filename. '</pre></p>';
	}
}

return false;
?>