<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

// Returns the version of this content item which should normally be returned
/* $cType cannot contain spaces, so let's just make sure it's tidy */
$cType = str_replace(" ", "", $cType);
$cID = (int) $cID;
$requestVersion = (int) $requestVersion;
$extranetUserID = (int) $extranetUserID;
$dontShowVersion = (bool) $dontShowVersion;

if ($cID==0 || $cType=="") {
	return false;
} else {
	if (!checkPriv()) {
		// We are in visitor mode, show only a published version
		$sql = "SELECT version, private
				FROM ".DB_NAME_PREFIX."content_". mysql_real_escape_string($cType). "
				WHERE id = ". (int) $cID. "
					AND status = 'published'";
		$result = my_mysql_query ($sql);
		if ($row = mysql_fetch_array ($result)) {
			if (!$row['private']) {
				// Item is published and non-private, so return the published version number
				if ($dontShowVersion) return true;
				else return $row['version'];
			} else {
				// Published Item exists in this version but is private; check permissions
				if (!$extranetUserID) {
					// Deny it; user is not logged in as a valid extranet user
					if ($return_permissions_error) {
						return "notLoggedIn";
					} else {
						return false;
					}
				} else {
					$privateVersion = $row['version'];

					// First check if content is in user_content_link and set flag

					$sql = "SELECT content_version
							FROM ".DB_NAME_PREFIX."user_content_link
							WHERE content_id = " . (int) $cID . "
								AND content_type = '" . mysql_real_escape_string($cType) . "'
								AND content_version = " . (int) $privateVersion;

					$result = my_mysql_query($sql);

					if (mysql_num_rows($result)>0) {
						$content_user_link = true;
					}

					// Second check if content is in user_group_link and set flag

					$sql = "SELECT content_version
							FROM ".DB_NAME_PREFIX."group_content_link
							WHERE content_id = " . (int) $cID . "
								AND content_type = '" . mysql_real_escape_string($cType) . "'
								AND content_version = " . (int) $privateVersion;

					$result = my_mysql_query($sql);

					if (mysql_num_rows($result)>0) {
						$content_group_link = true;
					}

					/*

					if content not in either table then it is available to
					all extranet users so return version

					*/

					if (!$content_user_link && !$content_group_link) {
						if ($dontShowVersion) return true;
						else return $row['version'];
					}

					/* Check user content link */

					if ($content_user_link) {
						$sql = "SELECT content_version
								FROM ".DB_NAME_PREFIX."user_content_link
								WHERE user_id = ". (int) $extranetUserID. "
									AND content_id = ". (int) $cID. "
									AND content_type = '". mysql_real_escape_string($cType). "'
									AND content_version = ". (int) $privateVersion;
						$result = my_mysql_query ($sql);
						if ($row2 = mysql_fetch_array ($result)) {
							if ($dontShowVersion) {
								return true;
							} else {
								return $row2['content_version'];
							}
						}
					}

					/* Check group content link */

					if ($content_group_link) {
						$sql = "SELECT gcl.content_version
								FROM ".DB_NAME_PREFIX."group_content_link AS gcl
									INNER JOIN ".DB_NAME_PREFIX."group_user_link AS gul USING (group_id)
								WHERE gul.user_id = ". (int) $extranetUserID. "
									AND content_id = ". (int) $cID. "
									AND content_type = '". mysql_real_escape_string($cType). "'
									AND content_version = ". (int) $privateVersion;
						$result = my_mysql_query ($sql);
						if ($row3 = mysql_fetch_array ($result)) {
							if ($dontShowVersion) {
								return true;
							} else {
								return $row3['content_version'];
							}
						}
					}

					/* If we reach this far then user does not have rights to content */
					if ($return_permissions_error) {
						return "no_permission";
					} else {
						return false;
					}
				}
			}
		} else {
			return false;
		}
	} else {
		// We are in admin preview mode, so show the latest draft unless other version specified
		if (!$requestVersion) {
			// If version not specifed in the URL, return the latest possible
			$sql = "SELECT max(version) AS v
					FROM ".DB_NAME_PREFIX."content_". mysql_real_escape_string($cType). "
					WHERE id = ". (int) $cID;
			$result = my_mysql_query ($sql);
			if ($row = mysql_fetch_array ($result)) {
				return $row['v'];
			} else {
				return false;
			}
		} else {
			// Version number was specified in the URL; but first check to see if it exists
			$sql = "SELECT version
					FROM ".DB_NAME_PREFIX."content_". mysql_real_escape_string($cType). "
					WHERE id = ". (int) $cID. "
						AND version = ". (int) $requestVersion;
			$result = my_mysql_query ($sql);
			if ($row = mysql_fetch_array ($result)) {
				return $row['version'];
			} else {
				return false;
			}
		}
	}
}

return false;
?>