<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

$slots = array();
$slotContents = array();
$plugins = getRunningPlugins();

//Look for every plugin instance on the current page, prioritising item level
//over Template level, and Template level over Template Family level.
$sql = "
	SELECT pi.slot_name, pi.plugin_id, pi.instance_id, pi.level, st.theme
	FROM (
		SELECT slot_name, plugin_id, instance_id, 3 AS level
		FROM ". DB_NAME_PREFIX. "plugin_inst_temp_fam_link
		WHERE family_name = '". mysql_real_escape_string($familyName). "'
	  UNION
		SELECT slot_name, plugin_id, instance_id, 2 AS level
		FROM ". DB_NAME_PREFIX. "plugin_inst_temp_link
		WHERE family_name = '". mysql_real_escape_string($familyName). "'
		  AND template_id = ". (int) $templateId;

if ($cID) {
	$sql .= "
	  UNION
		SELECT slot_name, plugin_id, instance_id, 1 AS level
		FROM ". DB_NAME_PREFIX. "plugin_inst_item_link
		WHERE content_id = ". (int) $cID. "
		  AND content_type = '". mysql_real_escape_string($cType). "'
		  AND content_version = ". (int) $cVersion;
}

$sql .= "
	) AS pi
	INNER JOIN ". DB_NAME_PREFIX. "template_slot_link AS tsl
	   ON tsl.template_family_name = '". mysql_real_escape_string($familyName). "'
	  AND tsl.template_filename = '". mysql_real_escape_string($templateName). "'
	  AND tsl.slot_name = pi.slot_name
	LEFT JOIN ". DB_NAME_PREFIX. "plugin_slot_theme_link AS st
	   ON st.skin_id = ". (int) $skinId. "
	  AND st.slot_name = pi.slot_name
	  AND st.nest = 0
	  AND st.instance_id = pi.instance_id
	ORDER BY";

if ($specificInstanceId) {
	$sql .= "
		pi.instance_id = ". (int) $specificInstanceId. " DESC,";
}

if ($specificSlotName) {
	$sql .= "
		pi.slot_name = '". mysql_real_escape_string($specificSlotName). "' DESC,";
}

$sql .= "
		pi.level DESC";

if ($specificInstanceId || $specificSlotName) {
	$sql .= "
		LIMIT 1";
}


$result = my_mysql_query($sql);
while($row = mysql_fetch_assoc($result)) {
	//The "show nothing" option is a special case; let it through without an "is running" check
	if ($row['instance_id'] == 0) {
		$slotContents[$row['slot_name']] = array('instance_id' => 0);
		$slots[$row['slot_name']] = true;
	
	//Otherwise, if the instance is running, allow it to be added to the page
	} elseif ($plugins[$row['plugin_id']]) {
		$slotContents[$row['slot_name']] = $plugins[$row['plugin_id']];
		$slotContents[$row['slot_name']]['theme'] = $row['theme'];
		$slotContents[$row['slot_name']]['level'] = $row['level'];
		$slotContents[$row['slot_name']]['instance_id'] = $row['instance_id'];
		$slots[$row['slot_name']] = true;
	}
}


//Attempt to initialise each plugin on the page
foreach ($slots as $slot => $dummy) {
	//Attempt to check to see if it is in the filesystem, then include it in the list of running instances
	if ($slotContents[$slot]['plugin_name'] && $slotContents[$slot]['instance_id']) {
		if (includePluginAndDependencies($slotContents[$slot]['plugin_name'], $missingPlugin)
		 && method_exists($slotContents[$slot]['class_name'], 'showSlot')) {
			
			//Fetch the name of the instance, and the name of the theme being used
			$sql = "
				SELECT name, framework, use_custom_framework
				FROM ". DB_NAME_PREFIX. "plugin_instances
				WHERE id = ". (int) $slotContents[$slot]['instance_id'];
			$result = my_mysql_query($sql);
			if ($row = mysql_fetch_assoc($result)) {
				//If we found a plugin to display, activate it and set it up
				$slotContents[$slot]['instance_name'] = $row['name'];
				$slotContents[$slot]['framework'] = ifNull($row['framework'], $slotContents[$slot]['default_framework']);
				$slotContents[$slot]['theme'] = $slotContents[$slot]['theme'];
				$slotContents[$slot]['use_custom_framework'] = $row['use_custom_framework'];
				
				setInstance($slotContents[$slot], $cID, $cType, $cVersion, $skinId, $slot, $checkForErrorPages = true);
				
				if (!$ajaxReload && $slotContents[$slot]['class'] && ($location = $slotContents[$slot]['class']->checkHeaderRedirectLocation())) {
					header("Location: ". $location);
					exit;
				}
				
			} else {
				$details = getPluginDetails($slotContents[$slot]['plugin_id']);
				$slotContents[$slot]['class'] = false;
				$slotContents[$slot]['error'] = getPhrase('[Selected Instance not found for the Plugin &quot;[[plugin]]&quot;]', array('plugin' => htmlspecialchars($details['display_name'])));
			}
		} else {
			$details = getPluginDetails($slotContents[$slot]['plugin_id']);
			$slotContents[$slot]['class'] = false;
			$slotContents[$slot]['error'] = getPhrase('[Selected Plugin &quot;[[plugin]]&quot; not found, not running, or has missing dependencies]', array('plugin' => htmlspecialchars($details['display_name'])));
		}
	} else {
		$slotContents[$slot]['class'] = false;
		$slotContents[$slot]['error'] = getPhrase('[Slot set to <em>Show Nothing</em>]');
	}
}

return false;
?>