/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

//Create an encapsulated object for the admin functions
window.tribiqA = function() {};

//Create an encapsulated object for any functions that the admin floating box tabs wish to create
window.tribiqTab = function() {};


tribiqA.storekeeperInitTime = 5000;




//Code to add the "tribiq_slotParent" class to the elements just above slots
tribiqA.slotParentMouseOver = function(event) {
	if (tribiqA.slotControlHide) {
		clearTimeout(tribiqA.slotControlHide);
	}
	
	$('.tribiq_slotParent').removeClass('tribiq_slotParent');
	
	if (event) {
		$(this).parent().addClass('tribiq_slotParent');
	}
}

tribiqA.slotParentMouseOut = function(a) {
	if (tribiqA.slotControlHide) {
		clearTimeout(tribiqA.slotControlHide);
	}
	
	tribiqA.slotControlHide = tribiq.setTimeout('tribiqA.slotParentMouseOver()', tribiqA.slotControlHoverInterval);
}

tribiqA.setSlotParents = function() {
	$('.tribiq_slotAdminControlBox').parent().children().mouseenter(tribiqA.slotParentMouseOver);
	$('.tribiq_slotAdminControlBox').parent().children().mouseleave(tribiqA.slotParentMouseOut);
}

tribiqA.slotControlHide = false;
tribiqA.slotControlHoverInterval = 1500;
$(document).ready(tribiqA.setSlotParents);



//Functions for managing plugin slots
tribiqA.pickNewPluginSlotName = false;
tribiqA.pickNewPlugin = function(el, slotName) {
	el.blur();
	
	//Check if this is a regular empty slot
	if ($('#plgslt_' + slotName + ' .tribiq_empty_slot_message').size()) {
		//Allow the quick-add functionality if so
		tribiqA.pickNewPluginSlotName = slotName;
		tribiqA.SK('tribiqA', 'addNewPlugin', false, 'tribiq__plugins/slotable_only////', 'tribiq__plugins/instances', 'tribiq__plugins', 'tribiq__plugins/instances', true);
	} else {
		//Otherwise show the slot Admin Box
		tribiqA.managePluginSlot(el, slotName);
	}
	
	return false;
}

tribiqA.addNewPlugin = function(path, key, row) {
	var addPluginInstance = key.id;
	var slotName = tribiqA.pickNewPluginSlotName;
	tribiq.pluginClassAJAX('tribiq_cms_core', {addPluginInstance: addPluginInstance, slotName: slotName, cID: tribiq.cID, cType: tribiq.cType, cVersion: tribiq.cVersion}, true);
	tribiq.refreshPluginSlot(slotName, addPluginInstance);
}



//Show the thickbox for managing the contents of a slot
tribiqA.managePluginSlot = function(el, slotName) {
	el.blur();
	
	if (!get('tribiq_theme_name_' + slotName + '__0')) {
		tribiqAFB.open('core', 'slot', {cID: tribiq.cID, cType: tribiq.cType, slotName: slotName});
	}
	
	return false;
}

//Show the thickbox for editing the instance in the slot, if there is one
tribiqA.pluginSlotEditSettings = function(el, slotName) {

	el.blur();
	var instanceId = tribiq.slots[slotName].instanceId;
	
	if (!get('tribiq_theme_name_' + slotName + '__0') && instanceId) {
		tribiqAFB.open('core', 'plugin_settings', {cID: tribiq.cID, cType: tribiq.cType, slotName: slotName, instanceId: instanceId});
	}
	
	return false;
}

//Cancel trying out Plugin Settings in a Slot
tribiqA.pluginSlotRollback = function(el, slotName) {

	el.blur();
	var instanceId = tribiq.slots[slotName].instanceId;
	
	var requests = {cID: tribiq.cID, cType: tribiq.cType, slotName: slotName, instanceId: instanceId, rollback: true};
	var box = tribiq.pluginClassAJAX('tribiq_cms_core', requests, false, true);
	
	tribiqA.floatingBox(box.html, box.buttonsHTML, box.warning);
	
	return false;
}

tribiqA.doRollback = function(slotName) {

	var instanceId = tribiq.slots[slotName].instanceId;
	
	var requests = {cID: tribiq.cID, cType: tribiq.cType, cVersion: tribiq.cVersion, slotName: slotName, instanceId: instanceId, rollback: true};
	var results = tribiq.pluginClassAJAX('tribiq_cms_core', requests, true, true);
	
	tribiq.refreshPluginSlot(slotName, results.instanceId);
}

//Roll out Plugin Settings to all other slots
tribiqA.pluginSlotRollout = function(el, slotName) {

	el.blur();
	var instanceId = tribiq.slots[slotName].instanceId;
	
	if (instanceId) {
		tribiqAFB.open('core', 'plugin_rollout', {cID: tribiq.cID, cType: tribiq.cType, cVersion: tribiq.cVersion, slotName: slotName, instanceId: instanceId});
	}
	
	return false;
}


/*  Plugin Phrases  */

//Open a Storekeeper window, deep-linking to the phrases for this Plugin
tribiqA.pluginPhrases = function(el, slotName) {
	
	el.blur();
	var className, pluginId;
	
	if (className = tribiq.slots[slotName].pluginClassNameForPhrases) {
		tribiqA.showPhrasesByClassName(className);
	}
	
	return false;
}

tribiqA.showPhrasesByClassName = function(className) {
	var pluginId;
	
	if (pluginId = tribiq.pluginClassAJAX('tribiq_cms_core', {getPluginIdFromClassName: className}, false, false)) {
		window.open(URLBasePath + 'admin/storekeeper.php#tribiq__plugins/phrases//' + pluginId + '//item//' + tribiq.languageId + '//');
	}
	
	return false;
}


/*  Changing Themes  */

//Show a floating box for managing the theme in a slot
tribiqA.pluginSlotChangeTheme = function(el, e, slotName, nest) {
	
	el.blur();
	
	var instanceId = tribiq.slots[slotName].instanceId;
	if (nest === undefined) {
		nest = 0;
	}
	
	if (!get('tribiq_theme_name_' + slotName + '__0') && instanceId) {
		
		//Check if the box is already open, and don't open it again if so
		if (!get('tribiq_theme_name_' + slotName + '__0')) {
			
			//Create the div element for this slot if it doesn't already exist
			if (!get('tribiq_fbAdminChangeTheme-' + slotName + '-' + nest)) {
				var themeChanger = document.createElement('div');
				themeChanger.setAttribute('id', 'tribiq_fbAdminChangeTheme-' + slotName + '-' + nest);
				themeChanger.setAttribute('onclick', 'tribiqA.raiseThemeChanger(this);');
				get('tribiq_afb_container').appendChild(themeChanger);
			}
			
			//Show the tail at the top center of the mouse if possible
			var left = -250;
			var top = -226;
			var width = 359;
			tribiqA.openBox(
				get('tribiq_fbAdminChangeThemeSample').innerHTML.replace(/\[\[SLOT_NAME\]\]/g, slotName).replace(/\[\[NEST\]\]/g, nest),
				'tribiq_fbAdminChangeTheme', 'AdminChangeTheme-' + slotName + '-' + nest, e, width, left, top, false, 0);
			
			var originalTheme = tribiqA.getCurrentTheme(slotName, nest);
			
			tribiqA.setThemeName(slotName, nest, originalTheme);
			
			get('tribiq_original_theme_' + slotName + '-' + nest).value = originalTheme;
		}
		
		tribiqA.raiseThemeChanger(get('tribiq_fbAdminChangeTheme-' + slotName + '-' + nest));
	}
	
	return false;
}

//Raise one theme change above the others
tribiqA.raiseThemeChanger = function(el) {
	
	if (tribiqA.risenThemeChanger) {
		get(tribiqA.risenThemeChanger).style.zIndex = 30000;
	}
	
	el.style.zIndex = 30020;
	
	tribiqA.risenThemeChanger = el.id;
}

//Get the current theme prefix for a slot
tribiqA.getCurrentTheme = function(slotName, nest) {
	if (nest) {
		return get('plgslt_' + slotName + '-' + nest).className.substr(12);
	} else {
		return get('plgslt_' + slotName).className.substr(12);
	}
}

tribiqA.setTheme = function(slotName, nest, themePrefix) {
	
	var containerName = slotName;
	if (nest) {
		containerName += '-' + nest;
	}
	
	if (!tribiqA.slotPossibleThemes[containerName] || !tribiqA.slotPossibleThemes[containerName][themePrefix]) {
		return false;
	}
	
	var themeName = tribiqA.slotPossibleThemes[containerName][themePrefix].name;
	var themeDirName = tribiqA.slotPossibleThemes[containerName][themePrefix].dir;
	var themePluginName = tribiqA.slotPossibleThemes[containerName][themePrefix].pluginName;
	
	if (themeDirName) {
		tribiq.addPluginStyleSheet(themePluginName, themeDirName);
	}
	
	get('plgslt_' + containerName).className = 'tribiq_slot ' + themePrefix;
	if (get('tribiq_theme_name_' + slotName + '-' + nest)) {
		tribiqA.setThemeName(slotName, nest, themePrefix)
	}
	
	return false;
}

tribiqA.setThemeName = function(slotName, nest, themePrefix) {
	
	var containerName = slotName;
	if (nest) {
		containerName += '-' + nest;
	}
	
	if (!tribiqA.slotPossibleThemes[containerName] || !tribiqA.slotPossibleThemes[containerName][themePrefix]) {
		return;
	}
	
	var themeName = tribiqA.slotPossibleThemes[containerName][themePrefix].name;
	var themeDirName = tribiqA.slotPossibleThemes[containerName][themePrefix].dir;
	var themePluginName = tribiqA.slotPossibleThemes[containerName][themePrefix].pluginName;
	
	get('tribiq_theme_name_' + slotName + '-' + nest).innerHTML = htmlspecialchars(themeName);
	get('tribiq_theme_selector_' + slotName + '-' + nest).innerHTML = htmlspecialchars(themePrefix);
	
	if (themePluginName) {
		get('tribiq_theme_path_' + slotName + '-' + nest).innerHTML = htmlspecialchars('plugins/' + themePluginName + '/themes/' + themeDirName + '/stylesheet.css');
	} else {
		get('tribiq_theme_path_' + slotName + '-' + nest).innerHTML = htmlspecialchars(tribiq.SKIN_PATH);
	}
}

//Preview the next theme from the themes array (coding carefully so that the end of the array loops back to the beginning)
tribiqA.nextTheme = function(el, slotName, nest) {
	el.blur();
	
	var containerName = slotName;
	if (nest) {
		containerName += '-' + nest;
	}
	
	var first = false;
	var next = false;
	var current = tribiqA.getCurrentTheme(slotName, nest);
	
	for (t in tribiqA.slotPossibleThemes[containerName]) {
		
		if (!first) {
			first = t;
		}
		
		if (next) {
			return tribiqA.setTheme(slotName, nest, t);
		} else if (t == current) {
			next = true;
		}
	}
	
	return tribiqA.setTheme(slotName, nest, first);
}

//Preview the next previous theme from the themes array (coding carefully so that the start of the array loops back to the end)
tribiqA.previousTheme = function(el, slotName, nest) {
	el.blur();
	
	var containerName = slotName;
	if (nest) {
		containerName += '-' + nest;
	}
	
	var prev = false;
	var current = tribiqA.getCurrentTheme(slotName, nest);
	
	for (t in tribiqA.slotPossibleThemes[containerName]) {
		
		if (t == current && prev) {
			return tribiqA.setTheme(slotName, nest, prev);
		}
		
		prev = t;
	}
	
	return tribiqA.setTheme(slotName, nest, prev);
}

//Close an open theme selector box
tribiqA.closeThemes = function(el, slotName, nest) {
	el.blur();
	tribiqA.closeBox('AdminChangeTheme-' + slotName + '-' + nest);
	return false;
}

//Revert any changes and close a theme selector box
tribiqA.cancelThemeChange = function(el, slotName, nest) {
	tribiqA.setTheme(slotName, nest, get('tribiq_original_theme_' + slotName + '-' + nest).value);
	return tribiqA.closeThemes(el, slotName, nest);
}

//Save changes and close a theme selector box
tribiqA.saveThemeChange = function(el, slotName, nest) {
	el.blur();
	
	instanceId = tribiq.slots[slotName].instanceId;
	
	var containerName = slotName;
	if (nest) {
		containerName += '-' + nest;
	}
	
	var themePrefix = tribiqA.getCurrentTheme(slotName, nest);
	var themeSaveName = tribiqA.slotPossibleThemes[containerName][themePrefix].saveName;
	
	tribiq.nonAsyncAJAX(
		URLBasePath + 'plugins.php'
			+ '?__method_call__=saveTheme'
			+ '&slot_name=' + encodeURIComponent(slotName)
			+ '&nest=' + nest
			+ '&skin_id=' + tribiq.skinId
			+ '&instance_id=' + instanceId
			+ '&theme=' + encodeURIComponent(themeSaveName),
		true);
	
	return tribiqA.closeThemes(el, slotName, nest);
}


/*  Reloading Slots  */

tribiqA.slotPossibleThemes = new Object();

//Callback function for refreshPluginSlot()
tribiqA.replacePluginSlot = function(slotName, instanceId, tabId, contents, info, scriptsToRunBefore) {
	
	var pluginId = false;
	var parentId = false;
	var beingEdited = false;
	var canBeEdited = false;
	var shownInVisitorMode = true;
	
	//Look through the info at the top of the AJAX return
	if (info) {
		for (i in info) {
			var details = info[i].split('--');
			
			//Watch out for the "In Edit Mode" tag from plugins in their edit modes
			if (details[0] == 'IN_EDIT_MODE') {
				beingEdited = true;
			
			//Watch out for the "Can Be Edited" tag from plugins
			} else if (details[0] == 'CAN_BE_EDITED') {
				canBeEdited = true;
			
			//Watch out for the Plugin id
			} else if (details[0] == 'PLUGIN_ID') {
				pluginId = 1*details[1];
			
			//Watch out for the instance's parent id
			} else if (details[0] == 'PARENT_ID') {
				parentId = 1*details[1];
			
			//Watch out for the "Shown in Visitor Mode" tag
			} else if (details[0] == 'NOT_SHOWN_IN_VISITOR_MODE') {
				shownInVisitorMode = false;
			
			//Watch out for plugins requesting custom CSS Themes to be added
			} else if (details[0] == 'THEME_CSS') {
				
				//Change the Class name of the slot
				get('plgslt_' + slotName).className = 'tribiq_slot ' + tribiq.uneschyp(details[1])
				
				//Add a stylesheet, if one exists
				if (details[4]) {
					tribiq.addPluginStyleSheet(tribiq.uneschyp(details[2]), tribiq.uneschyp(details[3]));
				}
				
				//Add any JavaScript for the framework
				if (details[7]) {
					tribiq.addPluginJavaScript(tribiq.uneschyp(details[5]), 'javascript.js', 'frameworks/' + tribiq.uneschyp(details[6]));
				}
				
				//Note down a list of themes available for this Framework
				if (details[8]) {
					tribiqA.slotPossibleThemes[slotName] = eval('(' + details[8] + ')');
				} else {
					tribiqA.slotPossibleThemes[slotName] = new Array();
				}
			
			//Add a JavaScript namespace for a Plugin if one is not already present
			//Also watch out for plugins requesting JavaScript files to be added
			} else if (details[0] == 'NAMESPACE') {
				if (pluginId && !window[tribiq.uneschyp(details[1])]) {
					tribiq.addPluginJavaScript('..', 'plugin.js.php?admin=1&ids=' + pluginId, 'cmsjs');
				}
			
			//Change the tooltips for the slot control buttons
			} else if (details[0] == 'INSTANCE_SETTINGS_TEXT') {
				if (get('plgslt_' + slotName + '-edit')) {
					get('plgslt_' + slotName + '-edit').alt = tribiq.uneschyp(details[1]);
					get('plgslt_' + slotName + '-edit').title = tribiq.uneschyp(details[1]);
					tribiq.tooltips('#plgslt_' + slotName + '-edit');
				}
			
			} else if (details[0] == 'INSTANCE_IN_SLOT_TEXT') {
				if (get('plgslt_' + slotName + '-contents')) {
					get('plgslt_' + slotName + '-contents').alt = tribiq.uneschyp(details[1]);
					get('plgslt_' + slotName + '-contents').title = tribiq.uneschyp(details[1]);
					tribiq.tooltips('#plgslt_' + slotName + '-contents');
				}
			}
		}
	}
	
	if (!pluginId) {
		instanceId = 0;
	}
	
	//Set the current instance id
	tribiq.slot([[slotName, instanceId, pluginId, tabId]]);
	
	//Set the CSS classes of the buttons, depending on whether there is a plugin inside or not
	if(get('plgslt_' + slotName + '-add_contents'))
		get('plgslt_' + slotName + '-add_contents').className =
			instanceId?
				'tribiq_slotAddContentsFull' : 'tribiq_slotAddContentsEmpty';
	
	if(get('plgslt_' + slotName + '-edit'))
		get('plgslt_' + slotName + '-edit').className =
			instanceId?
				'tribiq_editSettingsFull' : 'tribiq_editSettingsEmpty';
	
	if(get('plgslt_' + slotName + '-theme'))
		get('plgslt_' + slotName + '-theme').className =
			instanceId?
				'tribiq_changeThemeFull' : 'tribiq_changeThemeEmpty';
	
	if(get('plgslt_' + slotName + '-phrases'))
		get('plgslt_' + slotName + '-phrases').className =
			instanceId && tribiq.plugins[pluginId].pluginClassNameForPhrases?
				'tribiq_phrasesFull' : 'tribiq_phrasesEmpty';
	
	if(get('plgslt_' + slotName + '-contents'))
		get('plgslt_' + slotName + '-contents').className =
			instanceId && !parentId?
				'tribiq_slotContentsFull' : 'tribiq_slotContentsEmpty';
	
	if(get('plgslt_' + slotName + '-rollout'))
		get('plgslt_' + slotName + '-rollout').className =
			instanceId && parentId?
				'tribiq_rolloutFull' : 'tribiq_rolloutEmpty';
	
	if(get('plgslt_' + slotName + '-rollback'))
		get('plgslt_' + slotName + '-rollback').className =
			instanceId && parentId?
				'tribiq_rollbackFull' : 'tribiq_rollbackEmpty';
	
	//Set the CSS class around the slot contents
	tribiqA.markSlotAsBeingEdited(slotName, instanceId, beingEdited, canBeEdited, shownInVisitorMode);
	
	for (script in scriptsToRunBefore) {
		if (tribiq.slots[slotName]) {
			tribiq.callScript(tribiq.slots[slotName].pluginClassName, scriptsToRunBefore[script]);
		}
	}
	
	//Refresh the slot's innerHTML
	get('plgslt_' + slotName).innerHTML = contents;
	
	
	//Set tooltips for the area, if we are using tooltips
	tribiq.tooltips('#plgslt_' + slotName + ' a');
	tribiq.tooltips('#plgslt_' + slotName + ' img');
	tribiq.tooltips('#plgslt_' + slotName + ' input');
}


tribiq.checkSlotsBeingEdited = function() {
	if (tribiq.slots) {
		for (slotName in tribiq.slots) {
			if (tribiq.slots[slotName].beingEdited) {
				return true;
			}
		}
	}
	
	return false
}

tribiqA.markSlotAsBeingEdited = function(slotName, filled, beingEdited, canBeEdited, shownInVisitorMode) {
	//Set the CSS class for the slot
	//Empty slots need to be semi-transparent, filled slots need to have a dotted line
	//around them, and slots being edited need a solid line around them
	get('plgslt_' + slotName + '-wrap').className =
		filled?
			'tribiq_slotWithContents' +
			(beingEdited?
				' tribiq_slotWithContentsBeingEdited'
			 :
				(canBeEdited?
					' tribiq_slotWithContentsCanBeEdited' : ''
				)
			) + (
				shownInVisitorMode? '' : ' tribiq_slotNotShownInVisitorMode'
		) :
			'tribiq_slotWithNoContents';
	
	//Remember that this slot is being edited
	tribiq.slots[slotName].beingEdited = beingEdited;
	
	//If any slots are being edited, set a warning message for if an admin tries to leave the page 
	window.onbeforeunload = tribiqA.onbeforeunload;
}

tribiqA.onbeforeunload = function() {
	//If any Admin Boxes are open, and look like they might have been changed, set a warning message for if an admin tries to leave the page 
	if ((tribiq.oldAFBOpen && tribiqAFB.inEditMode && tribiqAFB.changed)
	 || (tribiq.newABOpen && tribiqAB.editModeOnBox() && (tribiqAB.changed || tribiqAB.callFunctionOnEditors('isDirty')))) {
		return tribiqA.phrase.leaveAdminBoxWarning;
	
	//Set a warning if any slots are being edited
	} else if (tribiq.checkSlotsBeingEdited()) {
		return tribiqA.phrase.leavePageWarning;
	
	} else {
		return undefined;
	}
}



//Pop up messages/boxes



tribiqA.openBox = function(html, className, n, e, width, left, top, disablePageBelow, overlayOpacity, overlayColor, padding, maxHeight) {
	
	if (!n) {
		n = 1;
	}
	
	if (disablePageBelow === undefined) {
		disablePageBelow = false;
	}
	
	if (overlayColor === undefined) {
		overlayColor = 'black';
	}
	
	if (overlayOpacity === undefined) {
		overlayOpacity = 50;
	}
	
	if (className === undefined) {
		className = '';
	}
	
	
	get('tribiq_fb' + n).className = className;
	
	tribiqA.adjustBox(n, e, width, left, top, html, padding, maxHeight);
	
	
	$('#tribiq_fb' + n).jqm({overlay: overlayOpacity, overlayClass: 'floatingBoxOverlay_' + overlayColor});
	$('#tribiq_fb' + n).jqmShow();
	
	if (disablePageBelow) {
		$('div.floatingBoxOverlay_' + overlayColor).unbind();
	}
	
	//Really odd workaround for a really odd CSS glitch in IE6
	if (tribiq.browserIsIE6()) {
		$('body').addClass('ie6workaround');
	}
}

tribiqA.adjustBox = function(n, e, width, left, top, html, padding, maxHeight) {
	
	if (!n) {
		n = 1;
	}
	
	if (!width) {
		width = 500;
	}
	
	if (top === undefined) {
		top = 15;
	}
	
	if (left === undefined) {
		left = 50;
	}
	
	if (padding === undefined) {
		padding = 15;
	}
	
	if (maxHeight === undefined) {
		maxHeight = 50;
	}
	
	
	get('tribiq_fb' + n).style.width = width + 'px';
	
	//Position the floating box
	//If e is provided, then position it relative to the mouse. Otherwise position it relative to the screen.
	if (e) {
		var y = tribiq.getMouseY(e) + top;
		
		//Check the box is not off the screen, and move it back if so
		var minY = 1 + tribiq.scrollTop();
		if (y < minY) {
			y = minY;
		} else {
			var maxY = $(window).height() - maxHeight - padding + tribiq.scrollTop();
			if (y > maxY) {
				y = maxY - maxHeight;
			}
		}
		
		get('tribiq_fb' + n).style.bottom = null;
		get('tribiq_fb' + n).style.top = y + 'px';
		get('tribiq_fb' + n).style.position = 'absolute';
	
	} else {
		if (top < 1) {
			top = 0;
		} else if (top > 100) {
			top = 100;
		}
		
		if (tribiq.browserIsIE6()) {
			get('tribiq_fb' + n).style.position = 'absolute';
			
			var className = get('tribiq_fb' + n).className;
			className = className.replace(/tribiq_fbIE6Hack\d+/, '');
			className += ' tribiq_fbIE6Hack' + (top < 4? top : 5 * Math.round(top / 5));
			
			get('tribiq_fb' + n).className = className;
			
		} else {
			get('tribiq_fb' + n).style.position = 'fixed';
			
			if (top <= 50) {
				get('tribiq_fb' + n).style.bottom = null;
				get('tribiq_fb' + n).style.top = top + '%';
			} else {
				get('tribiq_fb' + n).style.top = null;
				get('tribiq_fb' + n).style.bottom = (100 - top) + '%';
			}
		}
	}
	
	if (e) {
		var x = tribiq.getMouseX(e) + left;
		
		//Check the box is not off the screen, and move it back if so
		var minX = 1 + tribiq.scrollLeft();
		if (x < minX) {
			x = minX;
		} else {
			var maxX = $(window).width() - width - padding + tribiq.scrollLeft();
			if (x > maxX) {
				x = maxX;
			}
		}
		
		get('tribiq_fb' + n).style.right = null;
		get('tribiq_fb' + n).style.marginRight = 0;
		get('tribiq_fb' + n).style.marginLeft = 0;
		get('tribiq_fb' + n).style.left = x + 'px';
	} else {
		if (left < 1) {
			left = 0;
		} else if (left > 100) {
			left = 100;
		}
		
		if (left <= 50) {
			get('tribiq_fb' + n).style.right = null;
			get('tribiq_fb' + n).style.marginRight = 0;
			get('tribiq_fb' + n).style.left = left + '%';
			get('tribiq_fb' + n).style.marginLeft = '-' + Math.round(width * left / 100) + 'px';
		} else {
			get('tribiq_fb' + n).style.left = null;
			get('tribiq_fb' + n).style.marginLeft = 0;
			get('tribiq_fb' + n).style.right = (100 - left) + '%';
			get('tribiq_fb' + n).style.marginRight = '-' + Math.round(width * (100 - left) / 100) + 'px';
		}
	}
	
	if (html !== false && html !== undefined) {
		get('tribiq_fb' + n).innerHTML = html;
	}
}

tribiqA.closeBox = function(n, keepHTML) {
	if (!n) {
		n = 1;
	}
	
	if (get('tribiq_fb' + n).style.display != 'none') {
		if (!keepHTML) {
			get('tribiq_fb' + n).innerHTML = '';
		}
		$('#tribiq_fb' + n).jqmHide();
	}
	
	return false;
}















tribiqA.infoBox = function() {
	$('#tribiq_fbAdminInfoBox').jqm();
	$('#tribiq_fbAdminInfoBox').jqmShow();
	tribiq.addJQueryElements('#tribiq_fbAdminInfoBox ');
}

tribiqA.closeInfoBox = function(stopBoxClosingTwice) {
	if (get('tribiq_fbAdminInfoBox').style.display == 'block') {
		$('#tribiq_fbAdminInfoBox').jqmHide();
	}
}

tribiqA.showMessage = function(message, messageType) {
	var modal = false;
	message = '' + message;
	
	if (messageType === undefined) {
		messageType = 'error';
	}
	
	if (!message) {
		message = tribiqA.phrase.timedOut;
	}
	
	if		  (message.substr(0, 24) == '<!--Message_Type:None-->') {
		message = message.substr(24);
		messageType = false;
	} else if (message.substr(0, 25) == '<!--Message_Type:Error-->') {
		message = message.substr(25);
		messageType = 'error';
	} else if (message.substr(0, 27) == '<!--Message_Type:Success-->') {
		message = message.substr(27);
		messageType = 'success';
	} else if (message.substr(0, 27) == '<!--Message_Type:Warning-->') {
		message = message.substr(27);
		messageType = 'warning';
	} else if (message.substr(0, 28) == '<!--Message_Type:Question-->') {
		message = message.substr(28);
		messageType = 'question';
	
	//Undocumented trick to refresh the Storekeeper!
	} else if (message.substr(0, 25) == '<!--Reload_Storekeeper-->' && typeof tribiqSK != 'undefined') {
		tribiqSK.reload();
		return false;
	}
	
	//Undocumented trick to set some custom buttons!
	var buttonHTML = true;
	if (message.substr(0, 16) == '<!--Button_HTML:' && (buttonHTMLEnd = message.indexOf('-->')) != -1) {
		buttonHTML = message.substr(16, buttonHTMLEnd -16);
		message = message.substr(buttonHTMLEnd + 3);
	
	} else if (message.substr(0, 17) == '<!--Logged_Out-->') {
		if (typeof tribiqSK != 'undefined') {
			buttonHTML =
				'<input type="button" value="' + tribiqA.phrase.logIn + '" class="submit_selected" onclick="tribiqSK.reload(undefined, true);">' +
				'<input type="button" class="submit" value="' + tribiqA.phrase.cancel + '" onclick="tribiq.goToURL(URLBasePath);"/>';
		} else {
			buttonHTML = 
				'<input type="button" value="' + tribiqA.phrase.logIn + '" class="submit_selected"' +
				' onclick="tribiq.goToURL(tribiq.linkToItem(tribiq.cID, tribiq.cType, \'\', true));">' +
				'<input type="button" class="submit" value="' + tribiqA.phrase.cancel + '" onclick="tribiq.goToURL(tribiq.linkToItem(tribiq.cID, tribiq.cType));"/>';
		}
		message = message.substr(17);
		modal = true;
	}
	
	tribiqA.floatingBox(message, buttonHTML, messageType, modal);
	return true;
}

tribiqA.floatingBox = function(html, buttonsHTML, warning, modal) {
	get('tribiq_fbInner').innerHTML = html;
	
	if (buttonsHTML === true) {
		get('tribiq_fbMessageButtons').innerHTML = '<input type="button" class="submit" value="' + tribiqA.phrase.OK + '"/>';
	} else {
		get('tribiq_fbMessageButtons').innerHTML = buttonsHTML;
	}
	
	if (modal === undefined) {
		modal = false;
	}
	
	if (warning == 'success' || warning == 4) {
		get('tribiq_fbWarning').className = 'tribiq_fbSuccess';
	} else if (warning == 'question' || warning == 3) {
		get('tribiq_fbWarning').className = 'tribiq_fbQuestion';
	} else if (warning == 'error' || warning == 2) {
		get('tribiq_fbWarning').className = 'tribiq_fbError';
	} else if (warning && warning != 'none') {
		get('tribiq_fbWarning').className = 'tribiq_fbWarning';
	} else {
		get('tribiq_fbWarning').className = '';
	}
	
	$('#tribiq_fbAdminMessage').jqm({modal: modal});
	$('#tribiq_fbAdminMessage').jqmShow();
	tribiq.addJQueryElements('#tribiq_fbAdminMessage ');
}

tribiqA.currentlyClosingFloatingBox = false;
tribiqA.closeFloatingBox = function(stopBoxClosingTwice) {
	if (tribiqA.currentlyClosingFloatingBox) {
		tribiqA.currentlyClosingFloatingBox = false;
	} else {
		if (get('tribiq_fbAdminMessage').style.display == 'block') {
			get('tribiq_fbInner').innerHTML = '';
			$('#tribiq_fbAdminMessage').jqmHide();
			
			if (stopBoxClosingTwice) {
				tribiqA.currentlyClosingFloatingBox = true;
			}
		}
	}
}


tribiqA.notification = function(title) {
	
	get('tribiq_notification').style.display = '';
	get('tribiq_notification').style.top = tribiq.scrollTop() + 'px';
	get('tribiq_notification').innerHTML = '<div><h1>' + htmlspecialchars(title) + '</h1></div>';
	
	$('#tribiq_notification div').clearQueue();
	$('#tribiq_notification div').show('drop', {direction: 'up', queue: true}, 500);
	$('#tribiq_notification div').delay(2500);
	$('#tribiq_notification div').hide('drop', {direction: 'up', queue: true}, 500, function() {
		get('tribiq_notification').style.display = 'none';
	});
}



/*  Admin Tooltips  */
/*
tribiqA.tooltipStatus = 'closed';
tribiqA.tooltipOpacity = 0;
tribiqA.tooltipMaxOpacity = 10;
tribiqA.tooltipOpacityMultiplier = 0.1;
tribiqA.tooltipTimerInterval = 15;

//When the user hovers their mouse over an item with a tooltip, open the tooltips and display it
tribiqA.mouseOverTooltip = false;
tribiqA.openTooltip = function(el, e) {
	
	//If we've not already done so, attempt to work out what the tooltip for this item should be
	var tip = el.getAttribute('tooltip');
	
	if (tip == 'x' || !tip) {
		return;
	}
	
	//Show the tooltip at the bottom right of the mouse if possible
	var left = 20;
	var top = 20;
	var width = 300;
	tribiqA.mouseOverTooltip = true;
	
	if (tribiqA.tooltipStatus == 'closed') {
		tribiqA.openBox(tip, '', 'AdminTooltip', e, width, left, top, false, 0);
	} else {
		tribiqA.adjustBox('AdminTooltip', e, width, left, top, tip);
	}
	
	tribiqA.tooltipStatus = 'opening';
	tribiqA.adjustTooltip();
}

//Set a time out to keep checking on the tooltip
tribiqA.adjustingTooltip = false;
tribiqA.adjustTooltip = function() {
	if (tribiqA.adjustingTooltip) {
		clearTimeout(tribiqA.adjustingTooltip);
	}
	
	if (get('tribiq_fbAdminTooltip')) {
		if (tribiqA.tooltipStatus == 'opening') {
			if (tribiqA.tooltipOpacity >= tribiqA.tooltipMaxOpacity) {
				tribiqA.tooltipStatus = 'open';
			} else {
				tribiq.opacity(get('tribiq_fbAdminTooltip'), tribiqA.tooltipOpacityMultiplier * tribiqA.tooltipOpacity++);
			}
			
		} else if (tribiqA.tooltipStatus == 'closing') {
			if (tribiqA.tooltipOpacity <= 0) {
				tribiqA.closeBox('AdminTooltip');
				tribiqA.tooltipStatus = 'closed';
			} else {
				tribiq.opacity(get('tribiq_fbAdminTooltip'), tribiqA.tooltipOpacityMultiplier * tribiqA.tooltipOpacity--);
			}
			
		}
		
	}
	
	if (tribiqA.tooltipStatus == 'opening' || tribiqA.tooltipStatus == 'closing') {
		tribiqA.adjustingTooltip = tribiq.setTimeout('tribiqA.adjustTooltip()', tribiqA.tooltipTimerInterval);
	}
}

tribiqA.closeTooltip = function() {
	if (tribiqA.mouseOverTooltip) {
		tribiqA.mouseOverTooltip = false;
	} else if (tribiqA.tooltipStatus == 'open') {
		tribiqA.tooltipStatus = 'closing';
		tribiqA.adjustTooltip();
	}
}

tribiqA.snapCloseTooltip = function() {
	if (tribiqA.tooltipStatus != 'closed') {
		tribiqA.tooltipStatus = 'closing';
		tribiqA.tooltipOpacity = 1;
		tribiqA.adjustTooltip();
	}
}

//Try to close the tooltip every time the user moves their mouse over the page
$(document).mousemove(function(e) {
	tribiqA.closeTooltip();
});

tribiq.tooltips = function(target) {
	
	$(target).each(function(i, el) {
		
		//Ignore lightbox links, or anything with a rel set
		if (el.rel) {
			el.setAttribute('tooltip', 'x');
			return;
		}
		
		//Convert an old wz_tooltip-style tooltip to jQuery
		var mouseover = '' + el.onmouseover;
		if (mouseover && mouseover.indexOf('this.T_TITLE') != -1) {
			var bodyText = unescape(el.onmouseover());
			var title = el.T_TITLE;
			el.onmouseover = null;
			tip = '<h3>' + title + '</h3><p>' + bodyText + '</p>';
		
		//Otherwise Extract a tooltip from the alt or title
		} else if (el.title) {
			tip = el.title;
		
		} else if (el.alt) {
			tip = el.alt;
		
		//If there was nothing to use as a tip, mark the tip as empty
		} else {
			el.setAttribute('tooltip', 'x');
			return;
		}
		
		//Convert the old jQuery tooltips to the new format
		var pos = tip.indexOf('|');
		if (pos != -1) {
			tip = '<h3>' + tip.substr(0, pos) + '</h3><p>' + tip.substr(pos+1) + '</p>';
		}
		
		el.setAttribute('tooltip', tip);
		el.setAttribute('title', '');
	});
	
	$(target).mousemove(function(e) {
		tribiqA.openTooltip(this, e);
	});
}

*/




//Add jQuery elements automatically by class name
tribiqA.addJQueryElements = function(path) {
	
	var onchange_callback = undefined;
	
	if (tribiq.oldAFBOpen) {
		onchange_callback = function(inst) {
			tribiqAFB.changed = true;
		}
	}
	
	//Add TinyMCE editors to the page
	$(path + 'textarea.tinymce').tinymce({
		script_url: URLBasePath + 'libraries/lgpl/tinymce/tiny_mce.js',

		theme: "advanced",
		skin: "o2k7",
		skin_variant: "silver",

		plugins: "pagebreak,style,layer,table,advhr,advimage,emotions,inlinepopups,insertdatetime,media,searchreplace" +
					",contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,advlist",

		inline_styles: false,
		convert_urls: false,
		relative_urls: true,
		document_base_url: URLBasePath,
		
		theme_advanced_buttons1: "fullscreen,code,cleanup,|,pasteword,|,undo,redo,|,charmap,|,hr,|,search,replace",
		theme_advanced_buttons2: "visualaid,tablecontrols,|,sub,sup,|,numlist,bullist,|,outdent,indent,blockquote",
		theme_advanced_buttons3: "styleselect,formatselect,fontsizeselect,|,bold,italic,underline,strikethrough,|,removeformat,|,justifyleft,justifycenter,justifyright,justifyfull",
		
		theme_advanced_toolbar_location: "top",
		theme_advanced_toolbar_align: "left",
		theme_advanced_statusbar_location: "bottom",
		theme_advanced_resizing: true,
		
		onchange_callback: onchange_callback
	});
	
	$(path + 'textarea.tinymce_readonly').tinymce({
		script_url: URLBasePath + 'libraries/lgpl/tinymce/tiny_mce.js',

		theme: "advanced",
		skin: "o2k7",
		skin_variant: "silver",
		convert_urls: false,
		readonly: true,
		
		inline_styles: false,
		theme_advanced_toolbar_location: "top",
		theme_advanced_toolbar_align: "left",
		theme_advanced_statusbar_location: "bottom",
		theme_advanced_resizing: true,
		
		//Attempt to fix a bug where links are clickable
		oninit: function() {
			var links;
			if (get('body_ifr')
			 && get('body_ifr').contentWindow
			 && get('body_ifr').contentWindow.document
			 && (links = get('body_ifr').contentWindow.document.getElementsByTagName('a'))) {
				for (var i in links) {
					links[i].target = '_blank';
				}
			}
		}
	});
	
	$(path + 'textarea.tinymce_with_images').tinymce({
		script_url: URLBasePath + 'libraries/lgpl/tinymce/tiny_mce.js',

		theme: "advanced",
		skin: "o2k7",
		skin_variant: "silver",

		plugins: "pagebreak,style,layer,table,advhr,advimage,emotions,inlinepopups,insertdatetime,media,searchreplace" +
					",contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,advlist",

		inline_styles: false,
		relative_urls: false,
		convert_urls: false,
		
		theme_advanced_buttons1: "fullscreen,code,cleanup,|,pasteword,|,link,unlink,anchor,|,image,|,charmap,|,hr,|,undo,redo,|,search,replace",
		theme_advanced_buttons2: "visualaid,tablecontrols,|,sub,sup,|,numlist,bullist,|,outdent,indent,blockquote",
		theme_advanced_buttons3: "styleselect,formatselect,fontsizeselect,|,bold,italic,underline,strikethrough,|,removeformat,|,justifyleft,justifycenter,justifyright,justifyfull",
		
		theme_advanced_toolbar_location: "top",
		theme_advanced_toolbar_align: "left",
		theme_advanced_statusbar_location: "bottom",
		theme_advanced_resizing: true,
		
		file_browser_callback: "tribiqAFB.SK",
		onchange_callback: onchange_callback
	});
	
	//Look for fields that IDs from Storekeeper, and look up what the names should be
	$(path + '.look_value_from_sk').each(function(i, el) {
		//Requires three fields with ids in the format: "id", "name_for_id" and "target_path_for_id" to work.
		if (el.id && el.id.substr(0, 9) == 'name_for_') {
			var id = el.id.substr(9);
			var pathEl, valueEl, panel;
			if ((valueEl = get(id)) && (pathEl = get('target_path_for_' + id))) {
				if (valueEl.value && valueEl.value != 0) {
					if (panel = tribiqA.getSKItem(pathEl.value, valueEl.value)) {
						var labelTag = ifNull(panel.label_tag, 'name');
						if (panel.items && panel.items[valueEl.value] && panel.items[valueEl.value][labelTag]) {
							if (el.type && el.type == 'text') {
								el.value = panel.items[valueEl.value][labelTag];
							} else {
								el.innerHTML = htmlspecialchars(panel.items[valueEl.value][labelTag]);
							}
						}
					}
				}
			}
		}
	});
}


tribiqA.formatFilesizeNicely = function(size, precision) {
	
	//Return 0 without formating if the size is 0.
	if (size <= 0) {
		return '0';
	}
	
	//Define labels to use
	var labels = ['_BYTES', '_KBYTES', '_MBYTES', '_GBYTES', '_TBYTES'];
	
	//Work out which of the labels to use, based on how many powers of 1024 go into the size, and
	//how many labels we have
	var order = Math.min(4, 
					Math.floor(
						Math.log(size) / Math.log(1024)
					));
	
	precision = Math.pow(10, precision);
	
	return (Math.round(precision * size / Math.pow(1024, order)) / precision) + tribiqA.phrase[labels[order]];

}



tribiqA.makeTimeFromParts = function(hours,minutes,seconds) {
	var outputTime;
	
	if (seconds == undefined) {
		seconds = "00";
	}
	
	outputTime = hours + ":" + minutes + ":" + seconds;
	
	return outputTime;
}



/* Storekeeper launch functions */

//Get information on a single item from Storekeeper 
tribiqA.getSKItem = function(path, id) {
	return tribiq.nonAsyncAJAX(
		URLBasePath +
			'admin/ajax.php?_json=1&_limit=1&_start=0&_getting_item_name=1&path=' + encodeURIComponent(path) + '&_item=' + encodeURIComponent(id),
		false, true);
}

//Open the storekeeper in select mode
tribiqA.SK = function(callbackObject, callbackFunction, enableMultipleSelect, path, targetPath, minPath, maxPath, disallowIdenticalMinPath, chooseButtonActiveClass, choosePhrase, chooseMultiplePhrase, tinyMCE, labelColumn) {
	
	//Initialise it if it's not been preloaded yet
	tribiqA.SKInit();

	var overlayOpacity;
	if (tinyMCE) {
		overlayOpacity = 10;
	} else if (typeof tribiqSK == 'undefined' || tribiqSK.selectMode === false) {
		overlayOpacity = 75;
	} else {
		overlayOpacity = 35;
	}

	get('tribiq_sk_iframe').contentWindow.tribiqSKQueue = [{path: path, branch: -1, selectedItems: {}}];
	
	if (maxPath !== undefined && !engToBoolean(maxPath)) {
		maxPath = false;
	}
	if (targetPath !== undefined && !engToBoolean(targetPath)) {
		targetPath = false;
	}
	
	get('tribiq_sk_iframe').contentWindow.tribiqSKTargetPath = targetPath === false? false : ifNull(targetPath, path);
	get('tribiq_sk_iframe').contentWindow.tribiqSKMinPath = ifNull(minPath, path);
	get('tribiq_sk_iframe').contentWindow.tribiqSKMaxPath = maxPath === false? false : ifNull(maxPath, get('tribiq_sk_iframe').contentWindow.tribiqSKTargetPath);
	get('tribiq_sk_iframe').contentWindow.tribiqSKDisallowIdenticalMinPath = engToBoolean(disallowIdenticalMinPath);
	
	get('tribiq_sk_iframe').contentWindow.tribiqSKCallbackObject = callbackObject;
	get('tribiq_sk_iframe').contentWindow.tribiqSKCallbackFunction = callbackFunction;
	get('tribiq_sk_iframe').contentWindow.tribiqSKChoosePhrase = choosePhrase;
	get('tribiq_sk_iframe').contentWindow.tribiqSKChooseButtonActiveClass = chooseButtonActiveClass;
	get('tribiq_sk_iframe').contentWindow.tribiqSKChooseMultiplePhrase = chooseMultiplePhrase;
	get('tribiq_sk_iframe').contentWindow.tribiqSKMultipleSelect = engToBoolean(enableMultipleSelect);
	get('tribiq_sk_iframe').contentWindow.tribiqSKLabelColumn = labelColumn;
	
	//If Storekeeper has been already pre-loaded, we can use the navigation functions to go to the correct path
	if (get('tribiq_sk_iframe').contentWindow.tribiqSK) {
		get('tribiq_sk_iframe').contentWindow.tribiqSK.go(path, -1);
	}
	//Otherwise store the requested path in tribiqSKGoToPathWhenLoaded and wait for the it to catch up
	
	//Close the tooltip if it is open
	tribiq.closeTooltip();
	
	//Show the storekeeper window
	tribiqA.openBox(false, '', 'AdminStorekeeper', false, 980, 50, 2, true, overlayOpacity, 'white');
}

tribiqA.SKInitted = false;
tribiqA.SKInit = function() {
	if (tribiqA.SKInitted) {
		return;
	}
	
	//if (typeof tribiqSK == 'undefined' || tribiqSK.selectMode === false) {
		get('tribiq_fbAdminStorekeeper').innerHTML =
			'<iframe id="tribiq_sk_iframe" src="' + URLBasePath + 'admin/storekeeper.php?selectMode=1&amp;rand=' + (new Date).getTime() + '"' +
				' width="' + (tribiq.browserIsIE6()? '984' : '100%') + '" height="96%"></iframe>';
	//}
	
	tribiqA.SKInitted = true;
}

//Attempt to preload the Storekeeper ten seconds after the current page has finished loading
tribiqA.SKStartInit = function() {
	if (!window.tribiq_inIframe && (typeof tribiqSK == 'undefined' || tribiqSK.selectMode === false)) {
		tribiq.setTimeout('tribiqA.SKInit()', tribiqA.storekeeperInitTime);
	}
}


tribiqA.getCustomFromSK = function(field, path, targetPath, minPath, maxPath, disallowIdenticalMinPath) {
	tribiqA.SKTarget = field;
	tribiqA.SK('tribiqA', 'setCustom', false, path, targetPath, minPath, maxPath, disallowIdenticalMinPath);
}

tribiqA.getFromSK = function(field, type, cType, language, forceCType, forceLanguage, HTMLIdOnly) {
	tribiqA.SKTarget = field;
	
	if (type == 'user_group') {
		tribiqA.SK('tribiqA', 'setGroupNameAndId', false, 'tribiq__users/groups');
	
	} else if (type == 'user') {
		tribiqA.SK('tribiqA', 'setUserNameAndId', false, 'tribiq__users');
	
	} else if (type == 'image') {
		tribiqA.SK('tribiqA', 'setMediaNameAndId', false, 'tribiq__content/media/images');
	
	} else if (type == 'movie') {
		tribiqA.SK('tribiqA', 'setMediaNameAndId', false, 'tribiq__content/media/movies');
	
	} else if (type == 'content') {
		var path = minPath = 'tribiq__content';
		if (cType) {
			path += '/item//' + cType + '//';
			if (language) {
				path += 'item//' + language  + '//';
			}
		}
		
		if (forceLanguage && language) {
			minPath = 'tribiq__content/content';
		} else if (forceCType && cType) {
			minPath = 'tribiq__content/languages';
		}
		
		if (field === false) {
			//Special case for menu destination tab
			tribiqA.SK('tribiqTab', 'setMenuDestination', false, path, 'tribiq__content/content', minPath, 'tribiq__content/content');
		} else if (HTMLIdOnly) {
			tribiqA.SK('tribiqA', 'setContentId', false, path, 'tribiq__content/content', minPath, 'tribiq__content/content');
		} else {
			tribiqA.SK('tribiqA', 'setContentIdAndCType', false, path, 'tribiq__content/content', minPath, 'tribiq__content/content');
		}
	}	
}

//Handle callback for custom things
tribiqA.setCustom = function(path, key, row) {
	get(tribiqA.SKTarget).value = key.id;
	get('name_for_' + tribiqA.SKTarget).value = row[row.__label_tag__];
}

//Handle callback for a Group
tribiqA.setGroupNameAndId = function(path, key, row) {
	get(tribiqA.SKTarget).value = key.id;
	get('name_for_' + tribiqA.SKTarget).value = row.name;
}

//Handle callback for a user
tribiqA.setUserNameAndId = function(path, key, row) {
	get(tribiqA.SKTarget).value = key.id;
	get('name_for_' + tribiqA.SKTarget).value = row.username;
}

//Handle callback for a media file
tribiqA.setMediaNameAndId = function(path, key, row) {

	get('name_for_' + tribiqA.SKTarget).value = row.filename;
	
	if (path == 'tribiq__content/media/images') {
		get(tribiqA.SKTarget).value = 'image_' + key.id;
	} else if (path == 'tribiq__content/media/movies') {
		get(tribiqA.SKTarget).value = 'movie_' + key.id;
	}
}

//Handle callback for a content item
tribiqA.setContentId = function(path, key, row) {
	get(tribiqA.SKTarget).value = key.id;
	get('name_for_' + tribiqA.SKTarget).value = row.tag;
}

tribiqA.setContentIdAndCType = function(path, key, row) {
	get(tribiqA.SKTarget).value = key.id + '_' + key.refiner__content_type;
	get('name_for_' + tribiqA.SKTarget).value = row.tag;
}

tribiqA.removeNameAndId = function(field) {
	get(field).value = '';
	get('name_for_' + field).value = get('nothing_selected_phrase_for_' + field).value;
}




















//Code for highlighting slots

/*

var previousZIndex;
var previousPosition;
var mouseEnterCounter = 0;

$(document).ready(function () {
	var overlay = $("<div id='modal-overlay'></div>");

	
	$("#admin_toolbar").css("position","relative");
	$("#admin_toolbar").css("z-index",500);
	
	overlay.css("opacity", 0.6);
	
	$("body").append(overlay);

	$(".tribiq_slotWithContents").mouseenter(function () {
								mouseEnterCounter++;
								
								if (mouseEnterCounter==1) {
									previousPosition = $(this).css("position");
									$(this).css("position","relative");
									previousZIndex = $(this).css("z-index");
									$(this).css("z-index",500);
									$("#modal-overlay").show();
								} else {
									mouseEnterCounter--;
								}
							});
							
	$(".tribiq_slotWithContents").mouseleave(function () {
								mouseEnterCounter--;
								$(this).css("position",previousPosition);
								$(this).css("z-index",previousZIndex);
								//alert($(this).attr("id") + ": " + $(this).css("z-index"));
								$("#modal-overlay").hide();
							});
	});
*/