/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


//Create an encapsulated object for the Admin Floating Box functions
window.tribiqAB = function() {};

tribiqAB.welcome = false;

tribiqAB.onKeyUpNum = 0;
tribiqAB.sizing = false;
tribiqAB.documentScrollTop = false;
tribiqAB.cachedAJAXSnippets = {};


//Open an admin floating box
tribiqAB.open = function(path, key, tab) {
	
	var overlayColor, overlayOpacity;
	if (typeof tribiqSK == 'undefined' || tribiqSK.selectMode === false) {
		overlayColor = 'black';
		overlayOpacity = 50;
	} else {
		overlayColor = 'white';
		overlayOpacity = 35;
	}
	
	//Record the current scroll location of the page behind the box
	if (tribiqAB.documentScrollTop === false) {
		tribiqAB.documentScrollTop = $(tribiq.browserIsSafari()? 'body' : 'html').scrollTop();
	}
	
	//Open the box...
	tribiq.AFBOpen = true;
	tribiq.newABOpen = true;
	tribiqAB.changed = false;
	tribiqAB.SKColPicker = false;
	tribiqA.openBox(false, '', 'AdminFloatingBox', false, 944, 50, 2, true, overlayOpacity, overlayColor);
	
	//...but hide the box itself, so only the overlay shows
	get('tribiq_fbAdminInner').innerHTML = '<div id="tribiq_abtab" style="display: none; width: 844px;"></div>';
	get('tribiq_fbAdminFloatingBox').style.display = 'none';
	
	//If any Admin Boxes are open, set a warning message for if an admin tries to leave the page 
	window.onbeforeunload = tribiqA.onbeforeunload;
	
	
	tribiqAB.start(path, key, tab);
}


tribiqAB.start = function(path, key, tab) {
	tribiqAB.tabHidden = true;
	tribiqAB.differentTab = false;
	
	tribiqAB.path = ifNull(path, '');
	
	tribiqAB.focus = {};
	tribiqAB.key = ifNull(key, {});
	tribiqAB.tab = tab;
	tribiqAB.shownTab = false;
	
	$.get(tribiqAB.getURL(),
		function(data) {
			if (tribiqAB.load(data)) {
				if (tribiqAB.tab) {
					tribiqAB.focus.tab = tribiqAB.tab;
				}
				
				delete tribiqAB.key;
				delete tribiqAB.tab;
				
				tribiqAB.sortTabs();
				tribiqAB.draw();
			} else {
				tribiqAB.close(true);
			}
		},
	'text');
}

tribiqAB.load = function(data) {
	tribiqAB.loaded = true;
	
	try {
		data = JSON.parse(data);
	} catch (e) {
		tribiqA.showMessage(data, 'error');
		return false;
	}
	
	if (tribiqAB.callFunctionOnEditors('isDirty')) {
		tribiqAB.changed = true;
	}
	
	tribiqAB.callFunctionOnEditors('remove');
	tribiqAB.focus = data;
	
	if (!tribiqAB.focus || (!tribiqAB.focus.tabs && tribiqAB.focus._location === undefined)) {
		tribiqA.showMessage(tribiqA.phrase.couldNotOpenBox, 'error');
		return false;
	}
	
	return true;
}

tribiqAB.changeMode = function() {
	if (tribiqAB.editModeEnabled()) {
		tribiqAB.differentTab = false;
		tribiqAB.loaded = false;
		tribiqAB.hideTab();
		tribiqAB.clearTab();
		tribiqAB.focus.tabs[tribiqAB.focus.tab].edit_mode.on = !tribiqAB.editModeOn();
		tribiqAB.clearTab();
		tribiqAB.loaded = true;
		
		tribiqAB.draw();
	}
}

tribiqAB.clickTab = function(tab) {
	if (tribiqAB.loaded) {
		tribiqAB.validate(tab != tribiqAB.focus.tab, tab);
	}
}

tribiqAB.clickButton = function(el, id) {
	if (tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].type == 'submit') {
		tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].pressed = true;
		tribiqAB.validate(true);
	} else if (tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].type == 'toggle') {
		tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].pressed = !engToBoolean(tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].pressed);
		tribiqAB.format();
	}
}

tribiqAB.format = function() {
	if (tribiqAB.SKColPicker) {
		return;
	}
	
	tribiqAB.loaded = false;
	tribiqAB.hideTab();
	
	tribiqAB.readTab();
	tribiqAB.stripAllErrors();
	
	$.post(tribiqAB.getURL(),
		{_format: true, _box: JSON.stringify(tribiqAB.focus)},
		function(data) {
			tribiqAB.load(data);
			tribiqAB.sortTabs();
			tribiqAB.draw();
		},
	'text');
	
	tribiqAB.nowDoingSomething('loading');
}

tribiqAB.validate = function(differentTab, tab) {
	if (tribiqAB.SKColPicker) {
		return;
	}
	
	tribiqAB.differentTab = differentTab;
	tribiqAB.loaded = false;
	tribiqAB.hideTab(differentTab);
	
	tribiqAB.readTab();
	tribiqAB.stripAllErrors();
	
	$.post(tribiqAB.getURL(),
		{_validate: true, _box: JSON.stringify(tribiqAB.focus)},
		function(data) {
			if (tribiqAB.load(data)) {
				
				if (!tribiqAB.errorOnTab(tribiqAB.focus.tab) && tab !== undefined) {
					tribiqAB.focus.tab = tab;
				}
			}
			
			tribiqAB.sortTabs();
			tribiqAB.draw();
		},
	'text');
	
	tribiqAB.nowDoingSomething('loading');
}

tribiqAB.save = function(confirm) {
	if (tribiqAB.SKColPicker) {
		return;
	}
	
	tribiqAB.differentTab = true;
	tribiqAB.loaded = false;
	tribiqAB.hideTab(true);
	
	tribiqAB.readTab();
	tribiqAB.stripAllErrors();
	
	var post = {
		_save: true,
		_confirm: confirm? 1 : '',
		_box: JSON.stringify(tribiqAB.focus)};
	
	if (tribiqAB.focus.confirm && engToBoolean(tribiqAB.focus.confirm.download)) {
		tribiqAB.save2(tribiq.nonAsyncAJAX(tribiqAB.getURL(), tribiq.urlRequest(post)));
	} else {
		$.post(tribiqAB.getURL(), post, tribiqAB.save2, 'text');
		tribiqAB.nowDoingSomething('saving');
	}
}

tribiqAB.save2 = function(data) {
	if (('' + data).substr(0, 12) == '<!--Valid-->') {
		data = data.substr(12);
		
		if (('' + data).substr(0, 14) == '<!--Confirm-->') {
			data = data.substr(14);
			tribiqAB.load(data);
			tribiqAB.sortTabs();
			tribiqAB.draw();
			tribiqAB.showConfirm();
		
		} else if (('' + data).substr(0, 15) == '<!--Download-->') {
			get('tribiq_iframe_form').action = tribiqAB.getURL();
			get('tribiq_iframe_form').innerHTML =
				'<input type="hidden" name="_download" value="1"/>' +
				'<input type="hidden" name="_box" value="' + htmlspecialchars(JSON.stringify(tribiqAB.focus)) + '"/>';
			get('tribiq_iframe_form').submit();
			
			tribiqAB.refreshParentAndClose(true);
		
		} else if (('' + data).substr(0, 12) == '<!--Saved-->') {
			data = data.substr(12);
			tribiqAB.load(data);
			tribiqAB.refreshParentAndClose();
		
		} else {
			tribiqAB.close();
			tribiqA.showMessage(data, 'error');
			tribiqAB.refreshParentAndClose();
		}
	} else {
		tribiqAB.load(data);
		tribiqAB.sortTabs();
		tribiqAB.draw();
	}
}


tribiqAB.showConfirm = function() {
	if (tribiqAB.focus && tribiqAB.focus.confirm && engToBoolean(tribiqAB.focus.confirm.show)) {
		
		var message = tribiqAB.focus.confirm.message;
		
		if (!engToBoolean(tribiqAB.focus.confirm.html)) {
			message = $.trim(htmlspecialchars(message)).replace(/\n/g, '<br/>');
		}
		
		var buttons =
			'<input type="button" class="submit_selected" value="' + tribiqAB.focus.confirm.button_message + '" onClick="tribiqAB.save(true);"/>' +
			'<input type="button" class="submit" value="' + tribiqAB.focus.confirm.cancel_button_message + '" onClick="tribiqA.closeFloatingBox();"/>';
		
		tribiqA.floatingBox(message, buttons, ifNull(tribiqAB.focus.confirm.message_type, 'none'));
	}
}


tribiqAB.hideTab = function(differentTab) {
	if (differentTab) {
		$('#tribiq_abtab input').add('#tribiq_abtab select').add('#tribiq_abtab textarea').attr('disabled', 'disabled');
		$('#tribiq_abtab').animate({opacity: .5}, 200, function() {
			tribiqAB.tabHidden = true;
			tribiqAB.draw();
		});
	} else {
		$('#tribiq_abtab input').add('#tribiq_abtab select').add('#tribiq_abtab textarea').attr('disabled', 'disabled').animate({opacity: .5}, 100);
		tribiqAB.tabHidden = true;
		tribiqAB.draw();
	}
}

tribiqAB.draw = function() {
	if (tribiqAB.welcome && tribiqAB.focus) {
		if (tribiqAB.focus._location !== undefined) {
			document.location.href = tribiq.addBasePath(tribiqAB.focus._location);
			return;
		} else if (tribiqAB.focus._task !== undefined) {
			tribiqAB.task = tribiqAB.focus._task;
			delete tribiqAB.focus._task;
		}
	}
	
	if ((tribiq.newABOpen || tribiqAB.SKColPicker || tribiqAB.welcome) && tribiqAB.loaded && tribiqAB.tabHidden) {
		tribiqAB.draw2();
	}
}

tribiqAB.draw2 = function(SKColPicker) {
	tribiqAB.SKColPicker = SKColPicker;
	
	if (!tribiqAB.SKColPicker && !tribiqAB.welcome) {
		
		//Don't show the requested tab if it has been hidden
		if (tribiqAB.focus.tab && (!tribiqAB.focus.tabs[tribiqAB.focus.tab] || engToBoolean(tribiqAB.focus.tabs[tribiqAB.focus.tab].hidden))) {
			tribiqAB.focus.tab = false;
		}
		
		//Generate the HTML for the tabs
		var html = '';
		for (var i in tribiqAB.sortedTabs) {
			var tab = tribiqAB.sortedTabs[i];
			if (tribiqAB.focus.tabs[tab] && !engToBoolean(tribiqAB.focus.tabs[tab].hidden)) {
				//Show the first tab we find, if a tab has not yet been set
				if (!tribiqAB.focus.tab) {
					tribiqAB.focus.tab = tab;
				}
				
				//Generate the HTML for the tab
				html +=
					  '<div id="afb_tab_' + tab + '" class="' + (tribiqAB.focus.tab == tab? 'current' : '') + '"><div>'
						+ '<a href="#" onclick="tribiqAB.clickTab(\'' + tab + '\'); return false;">'
							+ htmlspecialchars(tribiqAB.focus.tabs[tab].label)
						+ '</a>'
					+ '</div></div>';
			}
		}
		
		//Set the HTML for the floating boxes tabs and title
		get('tribiq_jqmTabs').innerHTML = html;
		tribiqAB.setTitle(tribiqAB.focus.title, true);
		
		//Set the HTML for the checkbox next to the save button, if there is one
		html = '';
		if (tribiqAB.focus.checkbox) {
			html +=
				'<label for="tribiq_admin_box_checkbox">' + htmlspecialchars(tribiqAB.focus.checkbox.label) + ' </label>' +
				'<input id="tribiq_admin_box_checkbox" type="checkbox" style="margin-right:10px;"' +
				' onclick="tribiqAB.focus.checkbox.checked = this.checked;"' +
					(tribiqAB.editModeOnBox()? '' : ' disabled="disabled"') + 
					(engToBoolean(tribiqAB.focus.checkbox.checked)? ' checked="checked"' : '') + 
				'/> ';
		}

		//Set the html for the save button
		html += tribiqAB.getSaveButtonHTML(ifNull(htmlspecialchars(tribiqAB.focus.save_button_message), tribiqA.phrase.save));
		get('tribiq_fbButtons').innerHTML = html;
		
		//Set the floating box to the max height for the user's screen
		tribiqAB.size();
		
		//Show the box
		get('tribiq_fbAdminFloatingBox').style.display = 'block';
	}
	
	tribiqAB.nowDoingSomething(false);
	if (tribiqAB.welcome) {
		$('#tribiq_abtab input').add('#tribiq_abtab select').add('#tribiq_abtab textarea').clearQueue();
	}
	
	
	html = '<form class="thickbox" onsubmit="return false;"><table class="thickbox_table">';
	
	tribiqAB.closeRow = tribiqAB.lastFieldId = false;
	for (var f in tribiqAB.sortedFields[tribiqAB.focus.tab]) {
		var fieldId = tribiqAB.sortedFields[tribiqAB.focus.tab][f];
		html += tribiqAB.drawField(tribiqAB.focus.tab, fieldId);
	}
	html += tribiqAB.drawFieldEnd();
	
	if (tribiqAB.editModeEnabled()) {
		html +=
			'<tr><td>&nbsp;</td><td class="left">' +
				'<input class="submit" type="button" onclick="tribiqAB.changeMode(); return false;" value="' +
					(tribiqAB.editModeOn()? tribiqA.phrase.cancel : tribiqA.phrase.edit) +
				'">' + 
			'</td>';
	}
	
	html += '</table></form>';
	
	
	//Special logic if we're generating the column picker
	if (tribiqAB.SKColPicker) {
		return html;
	
	//Drop in the tab if this is the first time we're showing the box
	} else if (tribiqAB.shownTab === false) {
		tribiqAB.insertHTML(html);
		
		if (tribiqAB.welcome) {
			$('#welcome').show('drop', {direction: 'up'}, 300, tribiqAB.focusFirstField);
			tribiq.addJQueryElements('#tribiq_abtab ');	
		} else {
			$('#tribiq_abtab').show('drop', {direction: 'up'}, 300, tribiqAB.focusFirstField);
		}
		
	
	} else if (tribiqAB.shownTab == tribiqAB.focus.tab) {
	
		if (tribiqAB.differentTab && tribiqAB.errorOnTab(tribiqAB.focus.tab)) {
			//Shake the tab if there are errors
			$('#tribiq_abtab').effect('bounce', {direction: 'right', times: 2, distance: 5, mode: 'effect'}, 125, function() {
				tribiqAB.insertHTML(html);
				$('#tribiq_abtab').animate({opacity: 1}, 75, tribiqAB.focusFirstField);
				tribiqAB.hideShowFields();
			});
			
		} else {
			//Otherwise fade in a tab if it was hidden
			//(It's probably not hidden but just in case)
			tribiqAB.insertHTML(html);
			$('#tribiq_abtab').animate({opacity: 1}, 150, tribiqAB.focusFirstField);
			tribiqAB.hideShowFields();
		}
	
	//A new/different tab - fade it in
	} else {
		tribiqAB.insertHTML(html);
		$('#tribiq_abtab').animate({opacity: 1}, 150, tribiqAB.focusFirstField);
	
	//Left and right sliding logic (removed)
	//} else if (tribiqAB.sortedTabOrders[tribiqAB.shownTab] < tribiqAB.sortedTabOrders[tribiqAB.focus.tab]) {
		//tribiqAB.insertHTML(html);
		//tribiq.opacity(get('tribiq_abtab'), 1);
		//$('#tribiq_abtab').show('slide', {direction: 'right', distance: 50}, 150, tribiqAB.focusFirstField);
	
	//} else {
		//tribiqAB.insertHTML(html);
		//tribiq.opacity(get('tribiq_abtab'), 1);
		//$('#tribiq_abtab').show('slide', {direction: 'left', distance: 50}, 150, tribiqAB.focusFirstField);
	}

	tribiqAB.shownTab = tribiqAB.focus.tab;
}

tribiqAB.insertHTML = function(html) {
	get('tribiq_abtab').innerHTML = html;
	tribiqAB.tabHidden = false;
}

tribiqAB.hideShowFields = function(onShowFunction) {
	//Open/close newly hidden sections with a blind animation
	$('div.tribiq_hide_on_open').hide('blind', {queue: true}, 500, function() {
		$('tr.tribiq_hide_on_open').each(function(i, e) {e.style.display = 'none'});
	});
	$('div.tribiq_show_on_open').show('blind', {queue: true}, 500, onShowFunction);
}

tribiqAB.nowDoingSomething = function(something) {
	
	$('#tribiq_now_loading').clearQueue();
	get('tribiq_now_loading').style.display = 'none';
	$('#tribiq_now_saving').clearQueue();
	get('tribiq_now_saving').style.display = 'none';
	if (tribiqAB.welcome) {
		$('#tribiq_now_installing').clearQueue();
		get('tribiq_now_installing').style.display = 'none';
	}
	
	if (something) {
		tribiq.opacity(get('tribiq_now_' + something), 0);
		get('tribiq_now_' + something).style.display = '';
		$('#tribiq_now_' + something).animate({opacity: 0.01}, 850);
		$('#tribiq_now_' + something).show('puff', {queue: true}, 1000);
		$('#tribiq_now_' + something).effect('pulsate', {queue: true, times: 100}, 1000);
	}
}

tribiqAB.focusFirstField = function() {
	//Add any special jQuery objects to the page
	tribiq.addJQueryElements('#tribiq_abtab ');
	
	//Loop through the text-fields on a tab, looking for the first incomplete field
	var nextBest = false;
	for (var f in tribiqAB.sortedFields[tribiqAB.focus.tab]) {
		var fieldId = tribiqAB.sortedFields[tribiqAB.focus.tab][f];
		if (get(fieldId)
		 && (get(fieldId).type == 'text' || get(fieldId).type == 'password')
		 && !engToBoolean(get(fieldId).disabled)
		 && !engToBoolean(get(fieldId).readonly)
		 && (typeof get(fieldId).focus == 'function' || typeof get(fieldId).focus == 'object')) {
			if (get(fieldId).value == '') {
				tribiqAB.fieldToFocus = fieldId;
				tribiq.setTimeout(tribiqAB.focusField, 50);
				return;
			} else {
				nextBest = fieldId;
			}
		}
	}
	
	//If they're all complete, focus the last one that we found
	if (nextBest) {
		tribiqAB.fieldToFocus = nextBest;
		tribiq.setTimeout(tribiqAB.focusField, 50);
	}
}

tribiqAB.focusField = function() {
	if (tribiqAB.fieldToFocus && get(tribiqAB.fieldToFocus) && $(get(tribiqAB.fieldToFocus)).is(':visible')) {
		get(tribiqAB.fieldToFocus).focus();
	}
	delete tribiqAB.fieldToFocus;
}

tribiqAB.setTitle = function(title, htmlEscape) {
	
	if (!title) {
		title = '';
	}
	
	if (htmlEscape) {
		get('tribiq_jqmTitle').innerHTML = htmlspecialchars(title);
		title = title.replace(/&quot;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&amp;/g, '&');
	} else {
		get('tribiq_jqmTitle').innerHTML = title;
	}
	
	get('tribiq_jqmTitle').style.fontSize = Math.min(12, Math.round(1300 / ('' + title).length)) + 'px';
}


tribiqAB.drawErrors = function(tab) {
	var html = '';
	if (tribiqAB.editModeOn() && tribiqAB.focus.tabs[tab].errors) {
		for (var e in tribiqAB.focus.tabs[tab].errors) {
			if (!tribiqAB.isInfoTag(e)) {
				if (!html) {
					html += '<tr id="errorDisplayRow"><td colspan="2"><div id="errorDisplay"><div id="errorDisplay_inner">';
				} else {
					html += '<br/>';
				}
				html += htmlspecialchars(tribiqAB.focus.tabs[tab].errors[e]).replace(/\n/g, '<br/>');
			}
		}
		if (html) {
			html += '</div></div></td></tr>';
		}
	}
	return html
}

tribiqAB.errorOnTab = function(tab) {
	if (tribiqAB.focus.tabs[tab] && tribiqAB.editModeOn(tab) && tribiqAB.focus.tabs[tab].errors) {
		for (var e in tribiqAB.focus.tabs[tab].errors) {
			if (!tribiqAB.isInfoTag(e)) {
				return true;
			}
		}
	}
}

tribiqAB.stripAllErrors = function() {
	for (var tab in tribiqAB.focus.tabs) {
		tribiqAB.stripErrors(tab);
	}
}

tribiqAB.stripErrors = function(tab) {
	delete tribiqAB.focus.tabs[tab].errors;
	tribiqAB.focus.tabs[tab].errors = {};
	
	if (tribiqAB.editModeAlwaysOn(tab)) {
		tribiqAB.focus.tabs[tab].edit_mode.on = true;
	}
}

			
//Most attributes that are part of the HTML spec we'll pass on directly
tribiqAB.allowedAtt = {
	'id': true,
	'name': true, //radio groups only
	'size': true,
	'maxlength': true,
	'accesskey': true,
	'class': true,
	'cols': true,
	'dir': true,
	'readonly': true,
	'rows': true,
	'style': true,
	'tabindex': true,
	'title': true,
	'disabled': true,
	'onblur': true,
	'onchange': true,
	'onclick': true,
	'ondblclick': true,
	'onfocus': true,
	'onmousedown': true,
	'onmousemove': true,
	'onmouseout': true,
	'onmouseover': true,
	'onmouseup': true,
	'onkeydown': true,
	'onkeypress': true,
	'onkeyup': true,
	'onselect': true};

tribiqAB.drawField = function(tab, id) {
	var html = '';
	var extraAtt = {};
	extraAtt['class'] = '';
	var field = tribiqAB.focus.tabs[tab].fields[id];
	
	//Close the last row if it was left open, unless this field should be on the same line
	if (!engToBoolean(field.same_row)) {
		html += tribiqAB.drawFieldEnd();
	}
	
	var rowExtraClass = '';
	tribiqAB.cellPre = '';
	tribiqAB.cellPost = '';
	//Include an animation to show newly unhidden fields
	if (tribiqAB.shownTab !== false && tribiqAB.shownTab == tribiqAB.focus.tab && tribiqAB.focus.tabs[tab].fields[id]._h && !engToBoolean(field.hidden)) {
		tribiqAB.cellPre = '<div class="tribiq_show_on_open">';
		tribiqAB.cellPost = '</div>';
		delete tribiqAB.focus.tabs[tab].fields[id]._h;	
	
	//Include an animation to hide newly hidden fields
	} else if (tribiqAB.shownTab !== false && tribiqAB.shownTab == tribiqAB.focus.tab && !tribiqAB.focus.tabs[tab].fields[id]._h && engToBoolean(field.hidden)) {
		rowExtraClass += ' tribiq_hide_on_open';
		tribiqAB.cellPre = '<div class="tribiq_hide_on_open">';
		tribiqAB.cellPost = '</div>';
		tribiqAB.focus.tabs[tab].fields[id]._h = true;
	
	//Don't show hidden fields
	} else if (engToBoolean(field.hidden)) {
		tribiqAB.focus.tabs[tab].fields[id]._h = true;
		
		tribiqAB.lastFieldId = id;
		return html;
	}
	
	var value;
	if (!field.snippet) {
		value = tribiqAB.editModeOn() && field._value !== undefined? field._value : field.value;
	}
	
	if (value === undefined) {
		value = '';
	}
	
	//Start a new row, unless the previous row was already open
	if (!engToBoolean(field.same_row) || !tribiqAB.closeRow) {
		
		//Draw the errors above this field if that's the correct position for them
		if ((tribiqAB.lastFieldId === false && !tribiqAB.focus.tabs[tab].show_errors_after_field)
		 || tribiqAB.lastFieldId == tribiqAB.focus.tabs[tab].show_errors_after_field) {
			html += tribiqAB.drawErrors(tribiqAB.focus.tab);
		}
		
		
		html += '<tr id="row__' + htmlspecialchars(id) + '" class="' + htmlspecialchars(field.row_class) + rowExtraClass + '">';
		
		if (engToBoolean(field.full_width)) {
			html += '<td colspan="2">' + tribiqAB.cellPre;
		
		} else {
			html += '<td class="title">' + tribiqAB.cellPre;
			
			if (tribiqAB.editModeOn() && field.multiple_edit) {
				html += '<input type="checkbox" id="multiple_edit__' + id + '" onchange="tribiqAB.meChange(this, \'' + id + '\');"' +
							(engToBoolean(field.multiple_edit.changed)? ' checked="checked"' : '') + '/> ';
			}
			
			html +=
					'<label for="' + htmlspecialchars(id) + '">' + ifNull(field.label, '', '') + '</label>' +
				tribiqAB.cellPost + '</td><td>' + tribiqAB.cellPre;
		}
		tribiqAB.closeRow = true;
	}
	
	
	var readOnly = !tribiqAB.editModeOn() || engToBoolean(field.read_only);
	
	if (field.pre_field_html !== undefined) {
		html += field.pre_field_html;
	}
	
	if (field.snippet) {
		if (field.snippet.html) {
			html += '<span id="snippet__' + htmlspecialchars(id) + '">' + field.snippet.html + '</span>';
		} else if (field.snippet.url) {
			if (!engToBoolean(field.snippet.cache)) {
				html += tribiq.nonAsyncAJAX(tribiq.addBasePath(field.snippet.url));
			
			} else if (!tribiqAB.cachedAJAXSnippets[field.snippet.url]) {
				html += (tribiqAB.cachedAJAXSnippets[field.snippet.url] = tribiq.nonAsyncAJAX(tribiq.addBasePath(field.snippet.url)));
			
			} else {
				html += tribiqAB.cachedAJAXSnippets[field.snippet.url];
			}
		}
	
	} else if (readOnly && field.type != 'editor') {
		if (field.pick_items) {
			html += tribiqAB.drawPickItems(tab, id, true);
		
		} else if (field.type == 'select' && field.values && field.values[value]) {
			html += htmlspecialchars(field.values[value]);
		
		} else if (field.type == 'checkbox' || field.type == 'radio') {
			html += engToBoolean(value)? tribiqA.phrase.yes : tribiqA.phrase.no;
		
		} else if (field.type == 'date') {
			html += htmlspecialchars(tribiq.formatDate(value));
		
		} else if (field.type == 'textarea') {
			html += htmlspecialchars(value).replace(/\n/g, '<br/>');
		
		} else if (value === '' || value === false || value === null || value === undefined) {
			html += '&nbsp;';
		
		} else {
			html += htmlspecialchars(value);
		}
	
	} else if (field.pick_items) {
		html += tribiqAB.drawPickItems(tab, id, false);
	
	} else if (field.type) {
		extraAtt.onchange = "tribiqAB.fieldChange(this, '" + htmlspecialchars(id) + "');";
		
		if (field.disabled) {
			extraAtt['class'] += 'disabled ';
		}
		
		if (field.quick_validate_onkeyup) {
			extraAtt.onfocus =
				"$(this).data('_tribiq_current_value', $(this).val());";
			extraAtt.onkeyup =
				"if ($(this).data('_tribiq_current_value') != $(this).val()) {" +
					"setTimeout(" +
						"'" +
							"if ($(get(\\'" + htmlspecialchars(id) + "\\')).data(\\'_tribiq_current_value\\') != $(get(\\'" + htmlspecialchars(id) + "\\')).val()) {" +
								"if (tribiqAB.quickValidate(' + ++tribiqAB.onKeyUpNum + ', \\'" + htmlspecialchars(field.class_name) + "\\')) {" +
									"$(get(\\'" + htmlspecialchars(id) + "\\')).data(\\'_tribiq_current_value\\',    $(get(\\'" + htmlspecialchars(id) + "\\')).val()); " +
								"}" +
							"}" +
						"', " +
							(1 * field.quick_validate_onkeyup) +
					");" +
				"}";
			extraAtt.onblur =
				"if ($(this).data('_tribiq_current_value') != $(this).val()) {" +
					"tribiqAB.quickValidate(++tribiqAB.onKeyUpNum, '" + htmlspecialchars(field.class_name) + "');" +
				"}" +
				"$(this).data('_tribiq_current_value', $(this).val());";
		}
		
		if (field.return_key_presses_button) {
			extraAtt.onkeyup =
				ifNull(extraAtt.onkeyup, '', '') +
				"if (event.keyCode == 13) {" +
					"$('#" + htmlspecialchars(field.return_key_presses_button) + "').click();" +
				"}";
		}
		
		//Open the field's tag
		if (field.type == 'select') {
			html += '<select';
		
		} else if (field.type == 'textarea') {
			html += '<textarea';
		
		} else if (field.type == 'editor') {
			html += '<textarea';
			
			extraAtt.style = 'visibility: hidden;';
			
			if (readOnly) {
				extraAtt['class'] += 'tinymce_readonly';
			} else if (engToBoolean(field.show_image_and_link_controls)) {
				extraAtt['class'] += 'tinymce_with_images';
			} else {
				extraAtt['class'] += 'tinymce';
			}
		
		} else if (field.type == 'submit' || field.type == 'toggle') {
			html += '<input';
			extraAtt.type = 'button';
			extraAtt['class'] += 'input_' + field.type;
			extraAtt.onclick = 'tribiqAB.clickButton(this, \'' + id + '\');';
			
			if (field.type == 'submit') {
				tribiqAB.focus.tabs[tab].fields[id].pressed = false;
			}
		
		} else if (field.type == 'date') {
			html += '<input';
			extraAtt.type = 'text';
			extraAtt['class'] += 'jquery_datepicker input_' + field.type;
			extraAtt.readonly = 'readonly';
			extraAtt.onkeyup = "tribiq.dateFieldKeyUp(this, event, '" + htmlspecialchars(id) + "');";
		
		} else {
			html += '<input';
			extraAtt.type = field.type;
			extraAtt['class'] += 'input_' + field.type;
		}
		
		//Checkboxes/Radiogroups only: If the form has already been submitted, overwrite the "checked" attribute depending on whether the checkbox/radiogroup was chosen
		if (field.type == 'checkbox' || field.type == 'radio') {
			if (engToBoolean(value)) {
				extraAtt.checked = 'checked';
			}
			value = undefined;
		}
		
		field.id = id;
		if (field.type != 'radio' || !field.name) {
			field.name = id;
		}
		for (var att in field) {
			if (tribiqAB.allowedAtt[att]) {
				html += ' ' + att + '="';
				
				if (extraAtt[att]) {
					html += extraAtt[att] + ' ';
					delete extraAtt[att];
				}
				
				html += htmlspecialchars(field[att]) + '"';
			}
		}
		for (var att in extraAtt) {
			html += ' ' + att + '="' + htmlspecialchars(extraAtt[att]) + '"';
		}
		
		//Add the value (which happens slightly differently for textareas)
		if (field.type == 'select') {
			html += '>';
		
		} else if (field.type == 'textarea' || field.type == 'editor') {
			html += '>' + htmlspecialchars(value) + '</textarea>';
		
		} else if (field.type == 'date') {
			html += ' value="' + htmlspecialchars(tribiq.formatDate(value)) + '"/>';
			html += '<input type="hidden" id="_value_for__' + htmlspecialchars(id) + '" value="' + htmlspecialchars(value) + '"/>';
		
		} else if (value !== undefined) {
			html += ' value="' + htmlspecialchars(value) + '"/>';
		
		} else {
			html += '/>';
		}
		
		if (field.type == 'select' && field.values) {
			for (var v in field.values) {
				html +=
					'<option value="' + htmlspecialchars(v) + '"' + (v == value? ' selected="selected"' : '') + '>' +
						htmlspecialchars(field.values[v]) +
					'</option>';
			}
			html += '</select>';
		}
	}
	
	if (field.post_field_html !== undefined) {
		html += field.post_field_html;
	}
	
	if (field.note_below !== undefined) {
		html += '<div class="tribiq_note_below">' + field.note_below + '</div>'
	}
	
	tribiqAB.lastFieldId = id;
	return html;
}

tribiqAB.drawFieldEnd = function() {
	var html = '';
	
	if (tribiqAB.closeRow) {
		html += tribiqAB.cellPost + '</td></tr>';
	}
	tribiqAB.closeRow = false;
	
	return html;
}

tribiqAB.drawPickItems = function(tab, id, readOnly) {
	
	var field = tribiqAB.focus.tabs[tab].fields[id],
		html = '';
	
	if (!field.pick_items || !field.pick_items.path || !field.pick_items.min_path || !field.pick_items.target_path) {
		return html;
	}
	
	if (readOnly) {
		html += tribiqAB.drawPickedItems(id, true);
	} else {
		html +=
			'<span id="name_for_' + id + '">' + tribiqAB.drawPickedItems(id) + '</span>';
		
		if (!engToBoolean(field.pick_items.hide_select_button)) {
			html +=
				'<br/>' +
				'<input type="button" class="launch_keeper"' +
				' value="' + ifNull(field.pick_items.select_phrase, tribiqA.phrase.select) + '"' +
				' onClick="tribiqAB.pickItems(\'' + htmlspecialchars(id) + '\');" />';
		}
	}
	
	return html;
}

tribiqAB.drawPickedItems = function(id, readOnly) {
	
	var field = tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id],
		itemSelected = false,
		panel,
		picked_items;
	
	//Use picked_items if in read-only mode, or _picked_items for editing
	if (readOnly) {
		picked_items = 'picked_items';
	} else {
		picked_items = '_picked_items';
		
		if (!field._picked_items) {
			tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id]._picked_items = $.extend(true, {}, field.picked_items);
		}
	}
	
	//Check if any items have been selected
	if (field[picked_items]) {
		for (var item in field[picked_items]) {
			if (item && item != 0) {
				if (field[picked_items][item] == '' || field[picked_items][item] === true) {
					field[picked_items][item] = item;
					
					//If an id was set, but no label, attempt to look up the label from Storekeeper
					if (panel = tribiqA.getSKItem(field.pick_items.target_path, item)) {
						var labelTag = ifNull(field.pick_items.label_column, panel.label_tag, 'name');
						if (panel.items && panel.items[item] && panel.items[item][labelTag]) {
							tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id][picked_items][item] = panel.items[item][labelTag];
						}
					}
				}
				itemSelected = true;
			} else {
				delete tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id][picked_items][item];
			}
		}
	}
	if (!itemSelected) {
		tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id][picked_items] = {};
	}
	
	//Sort any picked items by label
	tribiqAB.sortPickedItems(id, picked_items);
	
	var field = tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id],
		html = '';
	
	
	if (!itemSelected) {
		html += ifNull(field.pick_items.nothing_selected_phrase, tribiqA.phrase.nothing_selected);
		html += '<br/>';
	} else {
		for (var i in tribiqAB.sortedPickedItems[id]) {
			var item = tribiqAB.sortedPickedItems[id][i][0],
				label = tribiqAB.sortedPickedItems[id][i][1];
			
			if (readOnly) {
				html += htmlspecialchars(label);
			} else {
				html += '<input type="text" value="' + htmlspecialchars(label) + '" readonly="readonly" class="form_field"/>';
				
				if (i && !engToBoolean(field.pick_items.hide_remove_button)) {
					html += ' <input type="button" value="' + tribiqA.phrase.remove + '" class="launch_keeper"' +
							  ' onClick="tribiqAB.removePickedItem(\'' + htmlspecialchars(id) + '\', \'' + htmlspecialchars(item) + '\');"/>';
				}
				
			}
			html += '<br/>';
		}
	}
	
	return html;
}

tribiqAB.pickItems = function(id) {
	if (!tribiqAB.focus.tabs[tribiqAB.focus.tab] || !tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id]) {
		return false;
	}
	
	var field = tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id];
	
	if (!field.pick_items || !field.pick_items.path || !field.pick_items.min_path || !field.pick_items.target_path) {
		return false;
	}
	
	tribiqAB.SKTarget = id;
	tribiqA.SK('tribiqAB', 'setPickedItems', field.pick_items.multiple_select,
				field.pick_items.path, field.pick_items.target_path, field.pick_items.min_path, field.pick_items.max_path,
				field.pick_items.disallow_identical_min_path, undefined,
				field.pick_items.one_to_one_choose_phrase, field.pick_items.one_to_many_choose_phrase,
				undefined, field.pick_items.label_column);
}

tribiqAB.setPickedItems = function(path, key, row) {
	tribiqAB.changed = true;
	
	var id = tribiqAB.SKTarget,
		tab = tribiqAB.focus.tab,
		field = tribiqAB.focus.tabs[tab].fields[id];
	
	if (!engToBoolean(field.pick_items.multiple_select) || !tribiqAB.focus.tabs[tab].fields[id]._picked_items) {
		tribiqAB.focus.tabs[tab].fields[id]._picked_items = {};
	}
	
	for (var item in key._items) {
		tribiqAB.focus.tabs[tab].fields[id]._picked_items[decodeItemIdForStorekeeper(item)] = key._items[item]
		if (!engToBoolean(field.pick_items.multiple_select)) {
			break;
		}
	}
	
	get('name_for_' + id).innerHTML = tribiqAB.drawPickedItems(id);
}

tribiqAB.removePickedItem = function(id, item) {
	delete tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id]._picked_items[item];
	get('name_for_' + id).innerHTML = tribiqAB.drawPickedItems(id);
	
}

tribiqAB.fieldChange = function(el, id) {
	tribiqAB.changed = true;
	
	if (engToBoolean(tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].multiple_edit)) {
		tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].multiple_edit.changed = true;
		get('multiple_edit__' + id).checked = true;
	}
	
	if (engToBoolean(tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].format_onchange)) {
		tribiqAB.format();
	}
	
	if (tribiqAB.SKColPicker && tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id]._change_filter_on_change) {
		tribiqSK.changeFilters();
	}
}

tribiqAB.meChange = function(el, id) {
	if (el.checked) {
		tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].multiple_edit.changed = true;
	} else {
		tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].multiple_edit.changed = false;
		$(get(id)).val(ifNull(tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id].value, '', ''));
	}
}


tribiqAB.readField = function(f) {
	var value = undefined;
	var tab = tribiqAB.focus.tab;
	var field = tribiqAB.focus.tabs[tab].fields[f];
	
	//Non-field types
	if (!field || field.hidden || field.snippet || field.type == 'submit' || field.type == 'toggle') {
		return undefined;
	}
	
	var readOnly = !tribiqAB.editModeOn() || engToBoolean(field.read_only);
	
	//Fields with seperate values to display values
	if (get('_value_for__' + f)) {
		tribiqAB.focus.tabs[tab].fields[f]._value = value = get('_value_for__' + f).value;
	
	//Storekeeper select fields
	} else if (field.pick_items) {
		value = false;
		var picked_items = readOnly? 'picked_items' : '_picked_items',
			first = true;
		
		for (var i in field[picked_items]) {
			if (first) {
				first = false;
				value = i;
			} else {
				value += ',' + i;
			}
		}
		
		if (!readOnly) {
			tribiqAB.focus.tabs[tab].fields[f]._value = value;
		} else {
			delete tribiqAB.focus.tabs[tab].fields[f]._picked_items;
		}
	
	//Editors
	} else if (field.type == 'editor') {
		var content;
		
		if (typeof tinyMCE != 'undefined') {
			if (tinyMCE.get(f)) {
				content = tinyMCE.get(f).getContent();
			}
		}
		
		if (content !== undefined && content !== false) {
			value = tribiqAB.focus.tabs[tab].fields[f]._value = content;
		} else if (tribiqAB.focus.tabs[tab].fields[f]._value !== undefined) {
			value = tribiqAB.focus.tabs[tab].fields[f]._value;
		} else {
			value = tribiqAB.focus.tabs[tab].fields[f].value;
		}
	
	//Normal fields
	} else {
		if (!readOnly && get(f)) {
			if (field.type == 'checkbox' || field.type == 'radio') {
				tribiqAB.focus.tabs[tab].fields[f]._value = value = get(f).checked? true : false;
			} else {
				tribiqAB.focus.tabs[tab].fields[f]._value = value = $(get(f)).val();
			}
		
		} else {
			delete tribiqAB.focus.tabs[tab].fields[f]._value;
			value = field.value;
			if (field.multiple_edit) {
				tribiqAB.focus.tabs[tab].fields[f].multiple_edit.changed = false;
			}
		}
	}
	
	return value;
}

tribiqAB.blankField = function(f) {
	var tab = tribiqAB.focus.tab;
	
	if (get(f)) {
		$(get(f)).val('');
	}
	
	if (get('_value_for__' + f)) {
		get('_value_for__' + f).value = '';
	}
	
	tribiqAB.focus.tabs[tab].fields[f]._value = '';
}



tribiqAB.readTab = function() {
	var tab = tribiqAB.focus.tab;
	var value, values = {};
	for (var f in tribiqAB.focus.tabs[tab].fields) {
		if (!tribiqAB.isInfoTag(f)) {
			if ((value = tribiqAB.readField(f)) !== undefined) {
				values[f] = value;
			}
		}
	}
	
	return values;
}

tribiqAB.clearTab = function() {
	if (!tribiqAB.editModeOn()) {
		tribiqAB.readTab();
		tribiqAB.stripErrors(tribiqAB.focus.tab);
	}
}






//Automatically set the box to the correct height for the users screen, or the maximum height requested, whichever is smaller
tribiqAB.size = function() {
	if (tribiqAB.sizing) {
		clearTimeout(tribiqAB.sizing);
	}
	
	if (get('tribiq_fbMain')) {
		if (tribiqAB.focus && engToBoolean(tribiqAB.focus.hide_tab_bar)) {
			get('tribiq_fbMain').style.top = '0px';
			get('tribiq_fbButtons').style.paddingBottom = '7px';
			get('tribiq_jqmTabs').style.display = 'none';
		} else {
			get('tribiq_fbMain').style.top = '24px';
			get('tribiq_fbButtons').style.paddingBottom = '31px';
			get('tribiq_jqmTabs').style.display = tribiq.browserIsIE()? '' : 'inherit';
		}
	}
	
	if (get('tribiq_fbAdminInner')) {
		var height = Math.floor($(window).height() * 0.96 - (tribiq.browserIsIE()? 210 : tribiq.browserIsSafari()? 202 : 205));
		
		if (tribiqAB.focus.max_height && height > tribiqAB.focus.max_height) {
			height = tribiqAB.focus.max_height;
		}
		
		if (tribiqAB.focus && engToBoolean(tribiqAB.focus.hide_tab_bar)) {
			height = 1*height + 24;
		}
		
		if ((height = 1*height) > 0) {
			get('tribiq_fbAdminInner').style.height = height + 'px';
		}
	}
	
	//Keep the page below at the top of the page, to prevent a bug with TinyMCE
	if (tribiq.AFBOpen && tribiqAB.documentScrollTop !== false) {
		$(tribiq.browserIsSafari()? 'body' : 'html').scrollTop(0);
	}
	
	tribiqAB.sizing = tribiq.setTimeout(tribiqAB.size, 250);
}



//Get a URL needed for an AJAX request
tribiqAB.getURL = function() {
	//Outdate any validation attempts
	++tribiqAB.onKeyUpNum;
	
	if (tribiqAB.welcome) {
		return URLBasePath + 'admin/welcome_ajax.php' +
										'?_json=1&_ab=1' +
										'&task=' + encodeURIComponent(tribiqAB.task) +
										'&get=' + encodeURIComponent(JSON.stringify(tribiqAB.getRequest)) +
										tribiq.urlRequest(ifNull(tribiqAB.key, tribiqAB.focus.key));
	} else {
		return URLBasePath + 'admin/ajax.php' +
										'?_json=1&_ab=1' +
										'&path=' + encodeURIComponent(tribiqAB.path) +
										tribiq.urlRequest(ifNull(tribiqAB.key, tribiqAB.focus.key));
	}
}


tribiqAB.quickValidate = function(onKeyUpNum, pluginClassName) {
	
	if (onKeyUpNum !== tribiqAB.onKeyUpNum) {
		return false;
	}
	
	if (tribiqAB.SKColPicker) {
		tribiqSK.changeFilters();
		return true;
	}
	
	var rowClasses = {};
	
	for (var field in tribiqAB.focus.tabs[tribiqAB.focus.tab].fields) {
		if (!tribiqAB.isInfoTag(field)) {
			rowClasses[field] = ifNull(tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[field].row_class, '', '');
		}
	}

	
	var url;
	if (tribiqAB.welcome) {
		url = URLBasePath + 'admin/welcome_ajax.php?quickValidate=1';
	} else {
		url = URLBasePath + 'plugins.php?__pluginClassName__=' + pluginClassName + '&method_call=quickValidateAdminBox';
	}
	
	
	$.post(url,
		{
			tab: tribiqAB.focus.tab,
			path: tribiqAB.welcome? '' : tribiqAB.path,
			values: JSON.stringify(tribiqAB.readTab()),
			row_classes: JSON.stringify(rowClasses)
		},
		function(data) {
			try {
				data = JSON.parse(data);
			} catch (e) {
				tribiqA.showMessage(data, 'error');
				return false;
			}
			
			if (data && data.row_classes) {
				for (var field in data.row_classes) {
					if (tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[field] && get('row__' + field)) {
						tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[field].row_class = data.row_classes[field];
						get('row__' + field).className = data.row_classes[field];
					}
				}
			}
			
			if (data && data.snippets) {
				for (var field in data.snippets) {
					if (tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[field]
					 && tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[field].snippet
					 && tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[field].snippet.html && get('snippet__' + field)) {
						tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[field].snippet.html = data.snippets[field];
						get('snippet__' + field).innerHTML = data.snippets[field];
					}
				}
			}
		},
	'text');
	
	return true;
}


//Some shortcuts
tribiqAB.editModeEnabled = function(tab) {
	if (!tab) {
		tab = tribiqAB.focus.tab;
	}
	return tribiqAB.focus.tabs[tab].edit_mode && !tribiqAB.editModeAlwaysOn();
}

tribiqAB.editModeOn = function(tab) {
	
	if (!tribiqAB.focus || !tribiqAB.focus.tabs) {
		return false;
	}
	
	if (!tab) {
		tab = tribiqAB.focus.tab;
	}
	return tribiqAB.focus.tabs[tab].edit_mode && (tribiqAB.editModeAlwaysOn(tab) || engToBoolean(tribiqAB.focus.tabs[tab].edit_mode.on));
}

tribiqAB.editModeAlwaysOn = function(tab) {
	if (!tab) {
		tab = tribiqAB.focus.tab;
	}
	return tribiqAB.focus.tabs[tab].edit_mode && engToBoolean(tribiqAB.focus.tabs[tab].edit_mode.always_on);
}

tribiqAB.editModeOnBox = function() {
	if (tribiqAB.focus && tribiqAB.focus.tabs && tribiqAB.sortedTabs) {
		for (var i in tribiqAB.sortedTabs) {
			var tab = tribiqAB.sortedTabs[i];
			
			if (tribiqAB.editModeOn(tab)) {
				return true;
			}
		}
	}
	
	return false;
}



//  Sorting Functions  //

//refine tags added by the CMS for location/tracking purposes
tribiqAB.isInfoTag = function(i) {
	return i == 'class_name'
		|| i == 'count'
		|| i == 'ord';
}

tribiqAB.sortTabs = function() {
	//Build an array to sort, containing:
		//0: The item's actual index
		//1: The value to sort by
	tribiqAB.sortedTabs = [];
	if (tribiqAB.focus.tabs) {
		for (var i in tribiqAB.focus.tabs) {
			if (!tribiqAB.isInfoTag(i) && tribiqAB.focus.tabs[i]) {
				tribiqAB.sortedTabs.push([i, tribiqAB.focus.tabs[i].ord]);
			}
		}
	}
	
	//Sort this array
	tribiqAB.sortedTabs.sort(tribiqAB.sortArray);
	
	//Remove fields that were just there to help sort
	tribiqAB.sortedFields = {};
	tribiqAB.sortedTabOrders = {};
	tribiqAB.sortedPickedItems = {};
	for (var i in tribiqAB.sortedTabs) {
		var tab = tribiqAB.sortedTabs[i] = tribiqAB.sortedTabs[i][0];
		tribiqAB.sortFields(tab);
		tribiqAB.sortedTabOrders[tab] = i;
	}
}

tribiqAB.sortFields = function(tab) {
	//Build an array to sort, containing:
		//0: The item's actual index
		//1: The value to sort by
	tribiqAB.sortedFields[tab] = [];
	if (tribiqAB.focus.tabs[tab].fields) {
		for (var i in tribiqAB.focus.tabs[tab].fields) {
			if (!tribiqAB.isInfoTag(i) && tribiqAB.focus.tabs[tab].fields[i]) {
				tribiqAB.sortedFields[tab].push([i, tribiqAB.focus.tabs[tab].fields[i].ord]);
			}
		}
	}
	
	//Sort this array
	tribiqAB.sortedFields[tab].sort(tribiqAB.sortArray);
	
	//Remove fields that were just there to help sort
	for (var i in tribiqAB.sortedFields[tab]) {
		tribiqAB.sortedFields[tab][i] = tribiqAB.sortedFields[tab][i][0];
	}
}

//Given two elements from the above function, say which order they should be in
tribiqAB.sortArray = function(a, b) {
	if (a[1] === b[1]) {
		return 0;
	} else {
		return a[1] < b[1]? -1 : 1;
	}
}

//Sort any picked items by label
tribiqAB.sortPickedItems = function(id, picked_items) {
	//Build an array to sort, containing:
		//0: The item's actual index
		//1: The value to sort by
	tribiqAB.sortedPickedItems[id] = [];
	for (var i in tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id][picked_items]) {
		tribiqAB.sortedPickedItems[id].push([i, tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[id][picked_items][i]]);
	}
	
	//Sort this array
	tribiqAB.sortedPickedItems[id].sort(tribiqAB.iSortArray);
}

//Given two elements from the above function, say which order they should be in
tribiqAB.iSortArray = function(a, b) {
	if (a[1] === b[1]) {
		return 0;
	} else {
		return a[1].toUpperCase() < b[1].toUpperCase()? -1 : 1;
	}
}





/*	Saving/Closing  */


//Need to convert this one
tribiqAB.getSaveButtonHTML = function(saveButtonText) {
	
	if (tribiqAB.editModeOnBox()) {
		return '<input id="tribiqAFB_save" class="submit" type="button" value="' + saveButtonText + '" onclick="tribiqAB.save();"/>';
	} else {
		return '<input id="tribiqAFB_save" class="submit_disabled" type="button" value="' + saveButtonText + '"/>';
	}
}


tribiqAB.refreshParentAndClose = function(disallowNavigation) {
	tribiqAB.nowDoingSomething(false);
	tribiq.newABOpen = false;
	
	//Attempt to work out what to do next.
	if ((typeof tribiqSK != 'undefined')) {
		//Reload the storekeeper if this window is a storekeeper window (new storekeeper)
		var id = false;
		
		if (tribiqAB.focus.key.id !== undefined) {
			id = tribiqAB.focus.key.id;
		} else {
			for (var i in tribiqAB.focus.key) {
				id = tribiqAB.focus.key[i];
				break;
			}
		}
		
		tribiqSK.refreshToShowItem(id);
		tribiqAB.close();
		return;
		
	} else if (tribiqAB.focus.key.slotName != undefined) {
		//Refresh the slot if this was one of the slot settings thickboxes
		tribiq.refreshPluginSlot(tribiqAB.focus.key.slotName, 1*tribiqAB.focus.key.instanceId, tribiqAB.createGetRequestFromPrimaryKeyForSlotReload());
	
	} else if (disallowNavigation) {
		//Don't allow any of the actions below, as they involve navigation
	
	//Otherwise build up a URL from the primary key, if it looks valid
	} else if (tribiqAB.focus.key.mID) {
		//Going to a menu id
		tribiq.goToURL(URLBasePath + tribiq.indexDotPHP + '?mID=' + tribiqAB.focus.key.mID);
	} else if (tribiqAB.focus.key.cID) {
		//Go to a specific content item
		tribiq.goToURL(tribiq.linkToItem(tribiqAB.focus.key.cID, tribiqAB.focus.key.cType));
	}
	
	tribiqAB.close();
}


tribiqAB.close = function(keepMessageWindowOpen) {
	//Close TinyMCE if it is open
	tribiqAB.callFunctionOnEditors('remove');
	tribiqAB.nowDoingSomething(false);
	
	if (tribiqAB.sizing) {
		clearTimeout(tribiqAB.sizing);
	}
	if (tribiqAFB.sizing) {
		clearTimeout(tribiqAFB.sizing);
	}
	
	if (tribiq.AFBOpen) {
		if (!keepMessageWindowOpen) {
			tribiqA.closeFloatingBox();
		}
		
		$('#tribiq_fbAdminFloatingBox').jqmHide();
	}
	if (get('tribiq_fbAdminFloatingBox').style.display == 'block') {
		get('tribiq_fbAdminFloatingBox').style.display = 'none';
	}
	get('tribiq_fbAdminInner').innerHTML = '';
	tribiq.newABOpen = false;
	tribiq.AFBOpen = false;
	
	//Really odd workaround for a really odd CSS glitch in IE6
	if (tribiq.browserIsIE6()) {
		$('body').addClass('ie6workaround');
	}
	
	//Return the page to it's original scroll position, before the box was opened
	if (tribiqAB.documentScrollTop !== false) {
		$(tribiq.browserIsSafari()? 'body' : 'html').scrollTop(tribiqAB.documentScrollTop);
		tribiqAB.documentScrollTop = false;
	}
	
	return false;
}

tribiqAB.closeButton = function() {
	//Check if there is an editor open
	var message = tribiqA.onbeforeunload();
	//If there was, give the Admin a chance to stop leaving the page
	if (message === undefined || confirm(message)) {
		if (tribiq.newABOpen) {
			tribiqAB.close();
		} else if (tribiq.oldAFBOpen) {
			tribiqAFB.close();
		}
	}
	
	return false;
}

tribiqAB.callFunctionOnEditors = function(action) {
	if (tribiqAB.focus && tribiqAB.focus.tab && tribiqAB.focus.tabs[tribiqAB.focus.tab] && tribiqAB.focus.tabs[tribiqAB.focus.tab].fields && typeof tinyMCE != 'undefined') {
		for (f in tribiqAB.focus.tabs[tribiqAB.focus.tab].fields) {
			var field = tribiqAB.focus.tabs[tribiqAB.focus.tab].fields[f];
			
			if (field.type == 'editor') {
				if (tinyMCE.get(f)) {
					if (action == 'remove') {
						tinyMCE.get(f).remove();
					
					} else if (action == 'isDirty') {
						if (tinyMCE.get(f).isDirty()) {
							return true;
						}
					}
				}
			}
		}
	}
	
	return false;
}