<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

header('Content-Type: text/css; charset=UTF-8');

require '../cmsincludes/cache.inc.php';

//Set up an ETag with each of the plugin names and themes in it
$ETag = 'tribiq-theme-'. CSS_JS_VERSION. '-';

//Get a list of plugin names and  ids from the url
$themes = array();
foreach(explode(',', $_GET['t']) as $i => $thing) {
	$thing = preg_replace('/[^\w-]/', '', $thing);
	
	//They'll be in the format: plugin_name,theme,plugin_name,theme...
	//Convert this to an array of paths
	if ($i%2) {
		$theme = $thing;
		$themes[] = 'plugins/'. $pluginName. '/themes/'. $theme. '/';
	} else {
		$pluginName = $thing;
	}
	
	//Add the combinaiton of plugin names/themes to the ETag
	$ETag .= '-'. $thing;
}


//Cache this combination of Themes
useCache($ETag);
useGZIP($_GET['gz']);


$files = array('stylesheet.css');
//Include a list of fixes for IE
if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false) {
	$files[] = 'style_ie.css';
	if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 9') !== false) {
		$files[] = 'style_ie9.css';
	} elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 8') !== false) {
		$files[] = 'style_ie8.css';
	} elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 7') !== false) {
		$files[] = 'style_ie7.css';
	} elseif (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6') !== false) {
		$files[] = 'style_ie6.css';
	}
}


//Loop through each path
foreach ($themes as $path) {
	//Loop through each possible file
	foreach ($files as $file) {
		//Check if there's a stylesheet there
		if (is_file($filePath = $path. $file)) {
			//Include the contents of the file, being careful to correct for the fact that the relative path for images will be wrong
			echo preg_replace('/url\(([\'\"]?)([^:]+?)\)/i', 'url($1../'. $path. '$2)', file_get_contents($filePath));
			echo "\n/**/\n";
		}
	}
}