<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

/**
 * This section lists methods that Plugin Developers override to alter how a plugin loads or is displayed.
 */

class plugin_placeholder_methods extends plugin_initialization_functions {


 /**
  * Plugin Developers can call addToPageHead() to write HTML to a page's HEAD tag.
  * The addToPageHead() method called run by the CMS whilst displaying a page's HEAD tag.
  * 
  * Plugin Developers should not use addToPageHead for CSS.
  * A Theme's CSS file will be included automatically by the CMS.
  * 
  * Any file in the plugin's directory called js/plugin.js, will be included automatically by the CMS.
  * If you do use addToPageHead() to add JavaScript then you will need to force a page reload for Admins...
  * 
  * The CMS calls the addToPageHead() function; Plugin Developers need not call it themselves.
  */
	public function addToPageHead() {
		
		//...your PHP code...//
	}


 /**
  * When displaying an error page, the CMS called a Plugin's allowPluginToBeShownOnErrorPage() method
  * to check whether the Plugin should be initialized and displayed
  * 
  * The default behaviour is that it should not be shown, however Plugin Developers may overwrite this Placeholder
  * method to change the default behaviour.
  */
	public function allowPluginToBeShownOnErrorPage() {
		return false;
	}

	
 /**
  * The CMS and the various Plugin API functions handle reloading Plugins via AJAX.
  * 
  * However should a Plugin Developer wish to have more control and use AJAX in a specific way, then
  * the AJAXAnchor() or the AJAXJS() methods can be used to direct visitors to the handleAJAX() method.
  * 
  * The CMS calls the handleAJAX() function; Plugin Developers need not call it themselves.
  */
	public function handleAJAX() {
		
		//...your PHP code...//
	}

	
 /**
  * The init() method allows Plugin Developers to check and/or initialise any variables they will need
  * before the plugin is displayed.
  * 
  * If a Plugin processes any submissions via the $getVariables or the $postVariables, any
  * code to handle the submission should be included in the init() method rather than the showSlot method.
  * 
  * Plugin Developers should note that the init() function is run before the CMS displays any output to
  * the screen, and as such, should not display any output itself!
  * 
  * The CMS calls the init() function; Plugin Developers need not call it themselves.
  * 
  * In visitor mode, the return value is used by the CMS to decide whether the plugin should be displayed.
  * If the init() method returns false, the plugin slot will not be displayed for visitors.
  * Note that the plugin will always display in admin mode, regardless of whether the init() method
  * returns true or false.
  */
	public function init() {
		
		//...your PHP code...//
		
		return true;
	}

	
 /**
  * The showFile() method displays the plugin on its own, outside of the page.
  * It acts very similar to the showSlot() method.
  * 
  * If Plugin Developers should use the showFileLink() methods to direct visitors to this method.
  * 
  * The CMS calls the showFile() function; Plugin Developers need not call it themselves.
  */
	public function showFile() {
		
		//...your PHP code...//
	}

	
 /**
  * The showIframe() method displays the plugin on its own, outside of the page.
  * It is intended to be used for displaying the Plugin in an iframe. It acts very similar to the showSlot() method.
  * 
  * If Plugin Developers should use the showIframeLink() methods to direct visitors to this method.
  * 
  * The CMS calls the showIframe() function; Plugin Developers need not call it themselves.
  */
	public function showIframe() {
		
		//...your PHP code...//
	}

	
 /**
  * The showImage() method displays the plugin on its own, outside of the page.
  * It acts very similar to the showSlot() method.
  * 
  * If Plugin Developers should use the showImageLink() methods to direct visitors to this method.
  * 
  * The CMS calls the showImage() function; Plugin Developers need not call it themselves.
  */
	public function showImage() {
		
		//...your PHP code...//
	}

	
 /**
  * The showRSS() method displays the plugin on its own, outside of the page.
  * It acts very similar to the showSlot() method.
  * 
  * For example, the News Feed Plugin has an RSS feed, which would need to be called without calling
  * the page itself.
  * 
  * If Plugin Developers should use the showRSSLink() methods to direct visitors to this method.
  * 
  * The CMS calls the showRSS() function; Plugin Developers need not call it themselves.
  */
	public function showRSS() {
		
		//...your PHP code...//
	}

	
 /**
  * The showSlot() method displays the plugin on the page.
  * 
  * For example, for simple Plugins, Plugin Developers can use echo statements to display the plugin.
  * However, it is highly recommended that Plugin Developers use the Theme system to display things rather
  * than hardcode HTML into their PHP code.
  * 
  * The CMS calls the showSlot() function; Plugin Developers need not call it themselves.
  */
	public function showSlot() {
		
		//...your PHP code...//
	}

	
 /**
  * The showFloatingBox() method displays the plugin on its own, outside of the page.
  * It acts very similar to the showSlot() method.
  * 
  * If Plugin Developers should use the showFloatingBoxLink() methods to direct visitors to this method.
  * 
  * The CMS calls the showFloatingBox() function; Plugin Developers need not call it themselves.
  */
	public function showFloatingBox() {
		
		//...your PHP code...//
	}
	
}
?>