<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

//Get the requested file from the URL
$path = $_GET['p']. '.'. preg_replace('/\W/', '', $_GET['e']);

//Exit if the request was not valid
if (strpos($path, '..') !== false || !is_file($path)) {
	header("HTTP/1.0 404 Not Found");
	exit;
}

require 'cmsincludes/cache.inc.php';
$ETag = 'tribiq-lose_image--'. $_SERVER["HTTP_HOST"]. '--'. $path;
useCache($ETag);
useGZIP();

//This is written for images, but use it to cover loose .js, .css and .ico files too
switch ($_GET['e']) {
	case 'css':
	case 'CSS':
		$mimeType = 'text/css';
		break;

	case 'ico':
	case 'ICO':
		$mimeType = 'image/vnd.microsoft.icon';
		break;

	case 'js':
	case 'JS':
		$mimeType = 'text/javascript';
		break;
	
	default:
		$details = getimagesize($path);
		$mimeType = $details['mime'];
}

header('Content-Type: '. $mimeType);
readfile($path);