<?php 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

session_start();

global $cms_timings;

function displayCMSTimings () {
	global $cms_timings;
	$start_time = $prev_time = false;
	
	echo '<table width="45%"><th>Name</th><th>Timestamp</th><th>Split</th></tr>';
	foreach ($cms_timings as $cms_timing) {
		if ($start_time === false) {
			$start_time = $cms_timing['time'];
			echo "<tr><td>" . $cms_timing['name'] . "</td><td>" . ($cms_timing['time']-$start_time) . "</td><td>0</td></tr>";
		} else {
			echo "<tr><td>" . $cms_timing['name'] . "</td><td>" . ($cms_timing['time']-$start_time) . "</td><td>" . ($cms_timing['time']-$prev_time) . "</td></tr>";
		}
		$prev_time = $cms_timing['time'];
	}
	echo '</table>';
}

function addCMSTiming ($name) {
	global $cms_timings;
	
	list($usec, $sec) = explode(" ", microtime());
	$time = ((float)$usec + (float)$sec);	
	
	$cms_timings[] = array('name' => $name, 'time' => $time);
}

/* Note the time so we can measure the execution time of this script */
addCMSTiming("START"); 
// here need to test whether config file empty. If so put link to installer. If not, site is set up so show pages as normal.
$testGlobalFilesize = @filesize("siteconfigs/global.php");
if (!$testGlobalFilesize || $testGlobalFilesize < 20) {
  ?>
	<html>
	  <head>
		<title>Welcome to Tribiq CMS</title>
	  </head>
	  <body>
		<script type="text/javascript">
		<!--
			document.location.href = 'admin/welcome.php';
		-->
		</script>
		<h1>Welcome to Tribiq CMS</h1>
		<p>A new Tribiq-powered website is coming soon at this location.</p>
		<p style="font-size: 70%">If you own this site and wish to continue with the installation please enable JavaScript to continue.</p>
	  </body>
	</html>
  <?php
} else {
	
	if (isset($_SESSION['admin_logged_in']) && $_SESSION['admin_logged_in']) {
		require 'adminheader.inc.php';
	} else {
		require 'visitorheader.inc.php';
	}
	
	addCMSTiming("Connecting to DB and loading Config");
	
	if (arrayKey($_GET, 'mode') == 'diagmap' && arrayKey($_GET, 'diagcode') == DIAGNOSTIC_CODE) {
		if (function_exists(getDiagnosticsSitemap)) {
			$diagnostic_sitemap = getDiagnosticsSitemap();
			echo $diagnostic_sitemap;
			exit;
		}
	}

	if (($menuitem = arrayKey($_GET, 'mID')) && !($content_array = getContentFromMenu($menuitem))) {
		$menuitem = getMenuParent($menuitem);
		$content_array = getContentFromMenu($menuitem);
	}
	
	if ($menuitem && !$content_array) {
		// Special mode:
		// Call by menu ID (mID) but normally only in Admin mode
		// You come here if a menu ID is passed and it really can't be resolved to a content item
		$errMsg = "dumbMenuID";
		useGZIP($siteConfig['compress_web_pages']);
				
		include ("templatewrap/fixedpagehead.php");
		include ("templatewrap/fixedpagebodystart.php");
		include (CMS_ROOT."templates/".SITENAME."/".$use_template_family."/error.php");
		include ("templatewrap/templatefoot.php");
		exit;
	} elseif ($menuitem) {
		$cID = $content_array[0];
		$cType = $content_array[1];
	} else {
		// If no particular page ID passed, 
		// find the default homepage by either pseudonym (e.g. 'home') or id (e.g. '1')
		$cType = false;
		if (issetArrayKey($_GET, 'cID')) {
			$cID = $_GET["cID"];
		} elseif (issetArrayKey($_GET, 'id')) {
			$cID = $_GET["id"];
		} elseif (issetArrayKey($_POST, 'cID')) {
			$cID = $_POST['cID'];
		} elseif (issetArrayKey($_POST, 'id')) {
			$cID = $_POST['id'];
		} else {
			$cID = cms_core::directUserToHomepage($siteConfig);
		}
		
		if (issetArrayKey($_GET, 'cVersion')) {		
			$cVersion = $_GET['cVersion'];
		} elseif (issetArrayKey($_POST, 'cVersion')) {
			$cVersion = $_POST['cVersion'];
		} else {
			$cVersion = false;
		}
		
		if (!$cType) {
			if (issetArrayKey($_GET, 'cType')) {		
				$cType = $_GET['cType'];
			} elseif (issetArrayKey($_POST, 'cType')) {
				$cType = $_POST['cType'];
			} else {
				$cType = "html";
			}
		}		
		
		if (!is_numeric($cID)) {
			includeContentType('html');
			$menuitem_array = getMenuItemFromContent(getIDfromAlias($cID), $cType);
			$menuitem = $menuitem_array[0];
		} else {
			$menuitem_array = getMenuItemFromContent($cID, $cType);
			$menuitem = $menuitem_array[0];		
		}
	}
	// Second check that content of this type exists (if specified)
	if (!$cType) $cType = "html";
	
	if (includeContentType($cType)) {
		addCMSTiming("Checking Content Type Exists");
		
		$contentTypeSettings = loadContentTypeSettings($cType);
	
		addCMSTiming("Loading Content Type Settings");
		
		// Now $cType contains a verified name for the content type
		// Now see if we can log in an admin (not mandatory yet)
		if (checkPriv()) {
			include_once("cmsincludes/admin.inc.php");
			include_once("cmsincludes/actionhandler.inc.php");
			addCMSTiming("Including admin.inc.php");
		}
		
		if ($checkItemExists = checkItemExists($cID, $cType)) {
			$cID = $checkItemExists;
			// $cID may have been converted from an alias
			// From now on, $cID is numeric, not the textual alias which it might have been
			
			addCMSTiming("Checking content item exists");

			//Work out which language this page is in
			
			$cLanguage = getContentLang($cID, $cType, $cVersion);


			// Find out which version we should be displaying
			$cVersion = getShowableVersion($cID, $cType, $cVersion, arrayKey($_SESSION, 'admin_username'), arrayKey($_SESSION, 'extranetUserID'),false,false,true);

			if (checkPriv()) {
				setAdminSession($_SESSION["admin_userid"],$_SESSION["admin_authtype"]);
			}
			
			addCMSTiming("Getting Showable Version");

			if (checkPriv()) {
				$status = getContentStatus($cID, $cType, $cVersion);
				$action_admin = getActionAdministrator($cID, $cType, $cVersion, $status);
				$action_timestamp = getActionTimestamp($cID, $cType, $cVersion, $status);
				$admin_username = $action_admin['admin_username'];
				if ($action_admin['admin_status']=='deleted'){
					if ($action_admin['admin_type']=='super'){
						$admin_username.= ' (Super, trashed administrator)';
					} else {
						$admin_username.= ' (trashed administrator)';
					}
				} else {
					if ($action_admin['admin_type']=='super'){
						$admin_username.= ' (Super)';
					} 
				}
				$mrg = array(
								"status" => $status,
								"username" =>$admin_username,
								"date" => formatDateNicely($action_timestamp,$siteConfig['vis_date_format_med']),
								"time"=>formatTimeNicely($action_timestamp,$siteConfig['vis_time_format'],$cLanguage) );
								
				if (wasActionPerfomedYesterday($cID, $cType, $cVersion, $status)) {
					$adminBarMsg = getPhrase("_MSG_CONTENT_ACTION_ADMIN_YESTERDAY",$mrg);
				} elseif (wasActionPerfomedToday($cID, $cType, $cVersion, $status)) {
					$adminBarMsg = getPhrase("_MSG_CONTENT_ACTION_ADMIN_TODAY",$mrg);
				} else {
					$adminBarMsg = getPhrase("_MSG_CONTENT_ACTION_ADMIN",$mrg);
				}
				addCMSTiming("Display Admin Message"); 
			}

			if (is_numeric($cVersion)) {
			
				sendSignal("eventPageAccessed",array("cID" => $cID,"cType" => $cType, "cVersion" => $cVersion));
				
				addCMSTiming("Get Item Meta"); 
				$item_meta = getItemMeta($cID, $cVersion);
				$_SESSION["user_lang"] = $language = $cLanguage;
				
				// Whatever happens, get the Template Family to use for this one
				list ($use_template_family, $use_template_filename, $use_template_id, $custom_bodytag) = getTemplateFamily ($cID, $cType, $cVersion);
				$use_template_filename = ensureTemplateExists($use_template_id, $use_template_family, $siteConfig, $cType);
				
				//Check for skins, and set the skin and template paths
				$skin = getSkin($cID, $cType, $cVersion, $use_template_id, true);
				
				define('TEMPLATE_PATH', SITENAME. '/'. $use_template_family);
				define('SKIN_PATH', 'templates/'. TEMPLATE_PATH. '/skins/'. $skin['name']. '/');
				define('SKIN_PATH_URL', 'templates/'. TEMPLATE_PATH. '/skins/'. rawurlencode($skin['name']). '/');

				
				//Check for plugins on the page
				getSlotContents($slotContents, $cID, $cType, $cVersion, $use_template_id, $use_template_filename, $use_template_family, $skin['id']);
				

				//if ($_GET['mode']=="diagpage") {
					//ob_start();
				//} else {
					useGZIP($siteConfig['compress_web_pages']);
				//}
						
						include ("templatewrap/templatehead.php");
						addCMSTiming("Include Template Head"); 
						include ("templatewrap/templatebodystart.php");
						addCMSTiming("Include Template Body Start"); 
						
						
						include (CMS_ROOT."templates/".SITENAME."/$use_template_family/$use_template_filename");
						addCMSTiming("Include Template Body"); 
						
						checkSlotsWereUsed($cID, $cType, $cVersion, $use_template_filename, $use_template_family);
						include ("templatewrap/templatefoot.php");
						addCMSTiming("Include Template Foot"); 
						
						//If the user is logged in, and the user_access_logging module is there, call
						//logUserAccess to check if we need to log this pageview.
						if (issetArrayKey($_SESSION, 'extranetUserID')	&& inc('tribiq_cms_core_probusiness')) {
							tribiq_cms_core_probusiness::logUserAccess($_SESSION['extranetUserID'], $cID, $cType, $cVersion);
						}
				
				//We've finishing displaying the page, run some checks as we finish up
				//if ($_GET['mode']=="diagpage" && $_GET['diagcode']==DIAGNOSTIC_CODE) {
					//ob_end_clean();
					//echo "[[OK]]";
					//logDiagnosticCheck($_GET['cID'],$_GET['cType'],getPublishedVersion($_GET['cID'],$_GET['cType']),1);
					//exit;
				//}
				
				//displayCMSTimings();
				
				exit;
			} elseif ($cVersion=="no_permission") {
				// Error, this version may not be accessed
				$errMsg = "noPermission";
				header("HTTP/1.0 401 Authentication Required");
				useGZIP($siteConfig['compress_web_pages']);
				
				include ("templatewrap/fixedpagehead.php");
				include ("templatewrap/fixedpagebodystart.php");
				include (CMS_ROOT."templates/".SITENAME."/".$use_template_family."/error.php");
				include ("templatewrap/templatefoot.php");
				exit;				
			} elseif ($cVersion=="notLoggedIn") {
				//This content item needs the user to be logged in to be accessed
				
				//Check if a login page has been defined that we can take the user to
				if (($loginCID = getLanguageDefaultExtranetPage($cLanguage)) && ($loginCID != $cID || $cType != 'html')) {
					//If so, redirect the user to the login page
					$_SESSION['destCID'] = $cID;
					$_SESSION['destCType'] = $cType;
					$_SESSION['destTitle'] = getItemTitle($cID, $cType);
					$_SESSION['destURL'] = $_SERVER['REQUEST_URI'];
					header("location: ". linkToItem($loginCID));
					exit;
				}

				// Error, this version may not be accessed
				$errMsg = "notLoggedIn";
				useGZIP($siteConfig['compress_web_pages']);
				
				include ("templatewrap/fixedpagehead.php");
				include ("templatewrap/fixedpagebodystart.php");
				include (CMS_ROOT."templates/".SITENAME."/".$use_template_family."/error.php");
				include ("templatewrap/templatefoot.php");
				exit;	
			} else {
				showStartSitePageIfNeeded($cID, $cType, $siteConfig);
				
				// Error, this version exist
				$errMsg = "noSuchContentVersion";
				header("HTTP/1.0 404 Not Found");
				useGZIP($siteConfig['compress_web_pages']);
				
				include ("templatewrap/fixedpagehead.php");
				include ("templatewrap/fixedpagebodystart.php");
				include (CMS_ROOT."templates/".SITENAME."/".$use_template_family."/error.php");
				include ("templatewrap/templatefoot.php");
				exit;
			}
		} else {
			showStartSitePageIfNeeded($cID, $cType, $siteConfig);
			
			// Error, this particular item does not exist
			$errMsg = "noSuchContentID";
			header("HTTP/1.0 404 Not Found");
			useGZIP($siteConfig['compress_web_pages']);
			
			include ("templatewrap/fixedpagehead.php");
			include ("templatewrap/fixedpagebodystart.php");
			if (!$use_template_family || 
				!file_exists (CMS_ROOT."templates/".SITENAME."/".$use_template_family."/error.php")) {
				echo 
					'<p>', getPhrase("Unable to display error message: $errMsg.<p>Please check that the following default error page exists:"), '</p>',
					'<p><pre>', CMS_ROOT, 'templates/', SITENAME, '/',$use_template_family, '/error.php</pre></p>',
					'<p><a href="admin/storekeeper.php">', getPhrase("Go to Storekeeper administration area"), '</a></p>';
				
			} else {
				include (CMS_ROOT."templates/".SITENAME."/".$use_template_family."/error.php");
			}
			include ("templatewrap/templatefoot.php");
			exit;
		}
	} else {
		// Error, this content type does not exist
		unset($cType);
		unset($_GET['cType']);
		
		$errMsg = "noSuchContentType";
		header("HTTP/1.0 404 Not Found");
		useGZIP($siteConfig['compress_web_pages']);
		
		include ("templatewrap/fixedpagehead.php");
		include ("templatewrap/fixedpagebodystart.php");
		include (CMS_ROOT."templates/".SITENAME."/$use_template_family/error.php");
		include ("templatewrap/templatefoot.php");
		exit;
	}
}
?>
