/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

/**
 * A replacement for the Preview/Save Plugins that come with TinyMCE
 * Allows TinyMCE to save to TribiqCMS
 * Requires Tribiq CMS to be running, and a content editor to be on the page
 */

(function() {
	tinymce.create('tinymce.plugins.TribiqSave', {
		init: function(ed, url) {
			
			var t = this;
			t.editor = ed;

			ed.addCommand('mceTribiqSave', t._tribiq_save, t);
			ed.addCommand('mceTribiqSaveAndContinue', t._tribiq_save_and_continue, t);
			ed.addCommand('mceTribiqCancel', t._tribiq_cancel, t);

			ed.addButton('save_and_close', {title: 'tribiq_save.save_desc', cmd: 'mceTribiqSave'});
			ed.addButton('save', {title: 'tribiq_save.save_and_continue_desc', cmd: 'mceTribiqSaveAndContinue'});
			ed.addButton('cancel', {title: 'tribiq_save.cancel_desc', cmd: 'mceTribiqCancel'});

			ed.addShortcut('ctrl+s', ed.getLang('save.save_and_continue_desc'), 'mceSave');
		},

		getInfo: function() {
			return {
				longname: 'TribiqSave',
				author: 'Tribiq',
				authorurl: 'http://tribiq.com',
				infourl: 'http://tribiq.com',
				version: '5.2.0'
			};
		},

		_tribiq_save: function() {
			tribiq_content.saveViaAJAX(get(this.editor.editorId), true);
		},

		_tribiq_save_and_continue: function() {
			tribiq_content.saveViaAJAX(get(this.editor.editorId));
		},

		_tribiq_cancel: function() {
			tribiq_content.close(get(this.editor.editorId));
		}
	});

	tinymce.PluginManager.add('tribiq_save', tinymce.plugins.TribiqSave);
})();