<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit; 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */




// This plugin helps visitors to bookmark pages


class tribiq_bookmark_email_print extends plugin_base_class {

		var $content;
		var $displaySections;
		var $mergeFields;
		var $missingFieldsErrors;
		var $incorrectEmailFormatErrors;
        var $errors;
		

	function init() {
		if ($this->request('floatingBoxMode')=='1'){
			$this->showInFloatingBox(); 
		}
		
		return true;
	}

	function checkVar($varName,$varLabel,$len){
		if ($this->post($varName)){
			if (strlen($this->post($varName)) > $len){
                $errStr = $this->phrase('_FIELD_LENGTH_EXCEEDED',array('field_name'=>htmlspecialchars($varLabel))) . '<br/>';
                $this->mergeFields[$varName]='';
            }
		}else {
            $errStr = $this->phrase('_FIELD_MISSING',array('field_name'=>htmlspecialchars($varLabel))) . '<br/>';
		}
        if ($errStr){
            $this->errors.=$errStr;
            return false; 
        }
        else return true;
    }
	
	function checkEmailVar ($varName,$varLabel,$len){
		if ($this->checkVar($varName,$varLabel,$len))
            if (!validateEmailAddress($this->post($varName))){
            	$errStr = $this->phrase('_INVALID_EMAIL_ADDRESS',array('field_name'=>htmlspecialchars($varLabel))) . '<br/>';
            }
	    if ($errStr){
            $this->errors.=$errStr;
            return false; 
        }
        else return true;}
	


	function showSlot() {
						
		if ($this->request('floatingBoxMode')){
			$this->displaySections['Email_friend_popup_header']=true;
	
			$this->mergeFields['email']=$this->post('email');
			$this->mergeFields['name']=$this->post('name');
			$this->mergeFields['msg']=$this->post('msg');
			$this->mergeFields['email_from']=$this->post('email_from');
			
			$this->checkEmailVar('email',$this->phrase('_EMAIL_ADDRESS'),100);
			$this->checkEmailVar('email_from',$this->phrase('_EMAIL_FROM'),100);
			$this->checkVar('msg',$this->phrase('_MESSAGE'),1000);
			$this->checkVar('name',$this->phrase('_SENDER_NAME'),100);
			
			if ((!$this->errors) && ($this->inc('tribiq_email_template_manager')) && $this->setting('email_template') ) {
				$mergeFields = array('Sender_name'=>$this->post('name'), 
									'Your_email'=>$this->post('email'),
									'Sender_message'=>$this->post('msg'),
									'Link_to_page'=>$this->linkToItem($this->cID,$this->cType,true),
									'Page_title'=>getItemTitle($this->cID,$this->cType),
									'Page_description'=>getItemDescription($this->cID,$this->cType,$this->cVersion));
																		
				if (tribiq_email_template_manager::sendEmailsUsingTemplate($this->post('email'),$this->setting('email_template'),$mergeFields,array())){
					$this->displaySections['Email_friend_popup_msg_sent']=true;
				} else {
					$this->displaySections['Email_friend_sending_error']=true;
				}
			}else{
				if ($this->post('Go')){
					$this->mergeFields['Error_message']=$this->errors;
					$this->displaySections['Input_error_section']=true;
					}
					
				$this->displaySections['Email_friend_popup_form_elements']=true;	
				$this->mergeFields['Open_form']=$this->openForm(). $this->remember('floatingBoxMode');
				}
			$this->framework('Email_friend_popup_window',$this->mergeFields,$this->displaySections);
		} else {
			$this->mergeFields = array();
			
			$this->mergeFields['Bookmark_page_script'] = 
				"if (window.tribiq) tribiq_bookmark_email_print.add('".
					// url to be bookmarked	
					htmlspecialchars(addslashes($this->linkToItem($this->cID, $this->cType, true))).
				"', '".
					// title of the bookmark
					htmlspecialchars(addslashes(getItemTitle($this->cID, $this->cType, $this->cVersion))).
				"'); return false;";
	
			$this->mergeFields['Print_page_script'] = "if (window.tribiq) tribiq_bookmark_email_print.print(); return false;"; 
			$this->mergeFields['email_friend_onclick_attr_plus_script_plus_href'] = $this->refreshPluginSlotAnchor('floatingBoxMode=1');
		
			
			if ($this->setting('print_page_section')) {
				$allowedChildSections['Print_page_section']=true;
			}
			
			if ($this->setting('bookmark_section') && strpos($_SERVER['HTTP_USER_AGENT'], 'WebKit') === false) {
				$allowedChildSections['Bookmark_page_section'] = true;
			}
			
			if ($this->setting('email_friend_section')
			 && $this->setting('email_template')
			 && $this->inc('tribiq_email_template_manager')
			 && tribiq_email_template_manager::getTemplateById($this->setting('email_template'))) {
				$allowedChildSections['Email_friend_section'] = true;
			}
			
			
			$this->framework( 'Outer', $this->mergeFields, $allowedChildSections );
		}
	} 
}
?>