<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

class tribiq_breadcrumbs extends tribiq_menu {
	
	function allowPluginToBeShownOnErrorPage() {
		return false;
	}
	
	function init() {
		$this->sectionId				= $this->setting('menu_section');
		$this->startFrom				= '_MENU_LEVEL_1';
		$this->numLevels				= 999;
		$this->maxLevel1MenuItems		= 999;
		$this->language					= false;
		$this->showAdminAddMenuItem		= false;
		$this->onlyFollowOnLinks		= true;
		$this->onlyIncludeOnLinks		= true;
		$this->showInvisibleMenuItems	= true;
		
		//Get the menu item for this content item
		$this->currentMenuId = getSectionMenuItemFromContent($this->cID, $this->cType, $this->sectionId);
		
		return (bool) $this->currentMenuId || !$this->setting('hide_if_not_in_tree');
	}
	
	function showSlot() {
		if ((bool) $this->currentMenuId || !$this->setting('hide_if_not_in_tree')) {
			tribiq_menu::showSlot();
		}
	}
	
	
	//Recursive function to draw menu items from the database
	function drawMenu(&$menuArray, $recurseCount = 0, $headerObjects = array(), $subSections = array()) {
		
		if ($recurseCount == 0) {
			$home = $this->getHomepage($_SESSION['user_lang']);
			$home['url'] = htmlspecialchars($this->linkToItem(ifNull($home['alias'], $home['id'])));
			$home['active'] = true;
			
			if ($home['url'] != $menuArray[0]['url'] && $home['name'] && $home['name'] != $menuArray[0]['name']) {
				$home['children'] = $menuArray;
				$menuArrayHome = array($home);
				tribiq_menu::drawMenu($menuArrayHome, $recurseCount);
				return;
			}
		}
		
		tribiq_menu::drawMenu($menuArray, $recurseCount);
	}
}


?>
