<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if ($phase == 3) {
	$numberOf = array('added' => 0, 'updated' => 0, 'protected' => 0);
}

if (!SimpleXMLCURL('http://tribiq.com/stores.xml', $xml, $error)) {
	$panel['no_items_message'] = $error;

} else {
	if ($xml->languages) {
		$panel['items'] = array();
		
		foreach ($xml->languages->children() as $item) {
			if ($phase == 1) {
				$panel['items'][$item->getName()] = array('name' => (string) $item->name, 'image' => (string) $item->image);
			} else {
				if ($item->getName() == $refinerId) {
					if (!SimpleXMLCURL($item->url, $xml2, $error)) {
						$panel['no_items_message'] = $error;
					
					} else {
						if ($xml2->items) {
							$panel['title'] = ifNull((string) $xml2->title, (string) $item->name);
							$panel['banner'] = ifNull((string) $xml2->banner, (string) $item->banner);
							
							foreach ($xml2->items->children() as $item2) {
								if ($phase == 2) {
									$panel['items'][$item2->getName()] = array('name' => $item2->language_local_name. ' ('. $item2->name. ')', 'image' => (string) $item2->image);
								
								} elseif ($phase == 3) {
									if ($item2->getName() == $id) {
										if (SimpleXMLCURL($item2->url, $xml3, $error)) {
											if ($xml3->items) {
												foreach ($xml3->items->children() as $item3) {
													importVisitorPhrase($id, '', $item3->code, $item3->local_text, true, $numberOf);
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
}

if ($phase == 3) {
	$this->languageImportResults($numberOf, $error, true);
}

return false;
?>