<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

//Get details on the current content item
$sql = "
	SELECT title, language_id, ". ($cType == 'html'? "alias" : "'' AS alias"). "
	FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($cType). "
	WHERE id = ". (int) $cID. "
	  AND version = ". (int) $cVersion;

$result = my_mysql_query($sql);
list($currentTitle, $currentLang, $currentAlias) = mysql_fetch_row($result);


//Get details on the current menu item, if there is one
if (!($currentMenu = getMenuItemFromContent($cID, $cType))) {
	$currentMenu = array();
}

//Load a list of languages
$languages = array();
foreach(getLanguages() as $language) {
	$languages[$language['id']] = array('local_name' => $language['language_local_name'], 'flag' => $language['flag']);

	//Get a list of languages in which we will be able to copy the menu item
	//To know where to put it, we'll need to look at the parent menu item, then 
	//try to find the equivalent parent item in the foreign language.
	$languages[$language['id']]['menu_parent'] = 
		
		//Only let people copy the menu item if they have the right permissions
		checkPriv('_PRIV_ADD_MENU_ITEM')? (
			
			//Firstly, check if there is a menu item at all!
			isset($currentMenu['parent_id'])? (
			
				//Next, check if this is the current language - we already know the parent id if so!
				$language['id'] == $currentLang?
					$currentMenu['parent_id']
				: (
				
					//Check if this is a top level menu item: a trivial case; we can just make the new menu item the top level
					$currentMenu['parent_id'] == 0?
						0
					: (
						
						//Otherwise, we'll require AVLS in order to try and get an equivalent
						inc('tribiq_avls')?
							tribiq_avls::menuEquivalence($currentMenu['parent_id'], $language['id'])
						:
						
						//Othewise give in ='(
							false
					)
				)
			) : false
		) : false;
}

return $languages;
?>