<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

switch ($path) {
	case 'tribiq_categories':
		$box['key']['content_type'] = get('refiner__content_type');
		
		if (!checkContentTypeExists($box['key']['content_type'])) {
			exit;
		}
		
		$itemsSelected = 0;
		$box['tabs']['categories']['fields']['some']['hidden'] = true;
		foreach (explode(',', $box['key']['id']) as $i => $id) {
			if ($i == 0) {
				$box['key']['id'] = '';
			}
			
			if ((int) $id) {
				++$itemsSelected;
				$box['key']['id'] .= ($box['key']['id']? ',' : ''). (int) $id;
			}
		
		}
		
		$sql = "
			SELECT category_id, COUNT(*) AS cnt
			FROM ". DB_NAME_PREFIX. "category_item_link
			INNER JOIN ". DB_NAME_PREFIX. "categories
			   ON id = category_id
			WHERE content_type = '". mysql_real_escape_string($box['key']['content_type']). "'
			  AND (item_id, version) IN (
				SELECT id, MAX(version)
				FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($box['key']['content_type']). "
				WHERE id IN (". $box['key']['id']. ")
				GROUP BY id
			)
			GROUP BY category_id";
		
		$result = my_mysql_query($sql);
		
		$box['tabs']['categories']['fields']['all']['picked_items'] = array();
		$box['tabs']['categories']['fields']['some']['picked_items'] = array();
		while ($row = mysql_fetch_assoc($result)) {
			if ($row['cnt'] == $itemsSelected) {
				$box['tabs']['categories']['fields']['all']['picked_items'][$row['category_id']] = true;
			} else {
				$box['tabs']['categories']['fields']['some']['picked_items'][$row['category_id']] = true;
				$box['tabs']['categories']['fields']['some']['hidden'] = false;
			}
		}
		
		if ($itemsSelected == 1) {
			$box['title'] = getPhrase('Adding/Removing the Content Item "[[tag]]" to/from Categories', array('tag' => getTag($box['key']['id'], $box['key']['content_type'])));
			$box['tabs']['categories']['fields']['all']['label'] = getPhrase('Categories:');
		} else {
			$box['title'] = getPhrase('Adding/Removing [[num]] Content Items to/from Categories', array('num' => $itemsSelected));
		}
		
		break;
	
	
	case 'tribiq_site_settings':
		if (is_array($box['tabs'])) {
			foreach ($box['tabs'] as &$tab) {
				if (is_array($tab['fields'])) {
					foreach ($tab['fields'] as $setting => &$field) {
						if ($setting != 'description') {
							$field['value'] = setting($setting);
							
							if ($setting == 'default_homepage_id') {
								$field['picked_items'] = array($field['value'] => getTag($field['value'], 'html'));
							
							} elseif ($setting == 'default_template_family') {
								$field['picked_items'] = array($field['value'] => $field['value']);
							}
						}
					}
				}
			}
		}
		
		break;
}

?>