<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

switch ($path) {
	case 'tribiq_categories':
		if (!checkContentTypeExists($box['key']['content_type'])) {
			exit;
		}
		
		foreach (explode(',', $box['key']['id']) as $i => $id) {
			if ($i == 0) {
				$box['key']['id'] = '';
			}
			
			if ((int) $id) {
				$box['key']['id'] .= ($box['key']['id']? ',' : ''). (int) $id;
			}
		
		}
		
		
		$deletes = '';
		foreach ($box['tabs']['categories']['fields']['some']['picked_items'] as $id => $name) {
			if (!isset($box['tabs']['categories']['fields']['all']['_picked_items'][$id])
			 && !isset($box['tabs']['categories']['fields']['some']['_picked_items'][$id])) {
				$deletes .= ($deletes? ',' : ''). (int) $id;
			}
		}
		
		foreach ($box['tabs']['categories']['fields']['all']['picked_items'] as $id => $name) {
			if (!isset($box['tabs']['categories']['fields']['all']['_picked_items'][$id])) {
				$deletes .= ($deletes? ',' : ''). (int) $id;
			}
		}
		
		$adds = '';
		foreach ($box['tabs']['categories']['fields']['all']['_picked_items'] as $id => $name) {
			$adds .= ($adds? ',' : ''). (int) $id;
		}
		
		
		if ($deletes) {
			$sql = "
				DELETE FROM ". DB_NAME_PREFIX. "category_item_link
				WHERE content_type = '". mysql_real_escape_string($box['key']['content_type']). "'
				  AND category_id IN (". $deletes. ")
				  AND (item_id, version) IN (
					SELECT id, MAX(version)
					FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($box['key']['content_type']). "
					WHERE id IN (". $box['key']['id']. ")
					GROUP BY id
				)";
			
			my_mysql_query($sql);
		}
		
		if ($adds) {
			$sql = "
				INSERT IGNORE INTO ". DB_NAME_PREFIX. "category_item_link (category_id, item_id, content_type, version)
				SELECT cat.id, c.id, '". mysql_real_escape_string($box['key']['content_type']). "', MAX(c.version)
				FROM ". DB_NAME_PREFIX. "categories AS cat, 
					 ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($box['key']['content_type']). " AS c
				WHERE cat.id IN (". $adds. ")
				  AND c.id IN (". $box['key']['id']. ")
				GROUP BY c.id, cat.id";
			
			my_mysql_query($sql);
		}

		
		break;
	
	
	case 'tribiq_site_settings':
		
		if (!checkPriv('_PRIV_EDIT_SITE_SETTING')) {
			exit;
		}
		
		if (is_array($box['tabs'])) {
			foreach ($box['tabs'] as &$tab) {
				if (engToBooleanArray($tab, 'edit_mode', 'on')) {
					if (is_array($tab['fields'])) {
						foreach ($tab['fields'] as $setting => &$field) {
							if ($setting != 'description') {
								setRow('site_settings', array('value' => $field['_value']), array('name' => $setting));
							}
						}
					}
				}
			}
		}
		
		break;
}

?>