<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if (checkPriv('_PRIV_EDIT_ADMIN') && ($primaryKey['adminType'] == 'local' || $_SESSION["admin_authtype"] == 'super')) {
} else {
	if ($editMode) {
		exit;
	}
	$showEditButton = false;
}
	
$details = array();
if ($primaryKey['adminId']) {
	$details = getAdminDetails($primaryKey['adminId'], $primaryKey['adminType'], false, false);
}

$fields = array();

if ($primaryKey['adminType'] == $_SESSION['admin_authtype'] && $primaryKey['adminId'] == $_SESSION['admin_userid']) {
	$fields['perm_manage_read_only'] = array(
			'Type' => 'tinyint(1)',
			'Read Only' => true,
			'Label' => getPhrase('Management Permissions:'));
	$details['perm_manage_read_only'] = $details['perm_manage'];

} else {
	$fields['perm_manage'] = array(
			'Type' => 'tinyint(1)',
			'Label' => getPhrase('Management Permissions:'));
}

$fields['perm_sysadmin'] = array(
		'Type' => 'tinyint(1)',
		'Label' => getPhrase('Sysadmin Permissions:'));
$fields['perm_publish'] = array(
		'Type' => 'tinyint(1)',
		'Label' => getPhrase('Publisher Permissions:'));
$fields['perm_override_author_lock'] = array(
		'Type' => 'tinyint(1)',
		'Label' => getPhrase('Author Permissions:'));
$fields['perm_editmenu'] = array(
		'Type' => 'tinyint(1)',
		'Label' => getPhrase('Menu Management Permissions:'));
$fields['perm_edit_users'] = array(
		'Type' => 'tinyint(1)',
		'Label' => getPhrase('Can Edit Extranet Users:'));
$fields['perm_edit_groups'] = array(
		'Type' => 'tinyint(1)',
		'Label' => getPhrase('Can Edit Extranet Groups:'));
	
$requiredFields = array();
			
echo dynamicThickboxFormInner($editMode, $fields, $requiredFields, $this->postVariables, $details);

return false;
?>