<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

$cID = (int) $primaryKey['sourceCID'];
$cType = $primaryKey['cType'];
$cVersion = $primaryKey['sourceVersion'];


cms_core::duplicateContentLoadDetails($cID, $cType, $cVersion, $currentTitle, $currentLang, $currentAlias, $currentMenu, $languages);


//Check if the $title is set; if not set it to the content's title
if (isset($this->postVariables['title']) && $this->postVariables['title'] != '') {
	$title = $this->post('title');
} else {
	$title = $currentTitle. getPhrase('_(COPY)');
}

//Check if the $menuTitle is set; if not set it to the content's menu title
if (isset($this->postVariables['menu_title']) && $this->postVariables['menu_title'] != '') {
	$menuTitle = $this->postVariables['menu_title'];
} elseif ($currentMenu['name']) {
	$menuTitle = $currentMenu['name']. getPhrase('_(COPY)');
} else {
	$menuTitle = '';
}

$menu = $this->post('menu');

//Check if the $language is set; if not set it to the content's language
if (isset($this->postVariables['language']) && $languages[$this->postVariables['language']]) {
	$lang = $this->postVariables['language'];
} else {
	$lang = $currentLang;
}

//Check if the alias is set; if not set it to the content's language
if (isset($this->postVariables['alias'])) {
	$alias = $this->postVariables['alias'];
} else {
	$alias = getContentAlias($cID, $cVersion, $cType);
}

		
echo '
	<tr><td class="title">
		<label>', getPhrase('Original Item\'s Title:'), '</label>
	</td><td nowrap>
		<img src="'. httpOrhttps(). $_SERVER["HTTP_HOST"] . SUBDIRECTORY. 'admin/images/flags/'. $languages[$currentLang]['flag']. '.gif" width="16" height="11" 
			alt="'. $languages[$currentLang]['flag']. '" title="'. $languages[$currentLang]['flag']. '">
		<a target="_blank" href="'. httpOrhttps(). $_SERVER["HTTP_HOST"] . SUBDIRECTORY. indexDotPHP(). '?cID='. $cID. '&cType'. $cType .'&cVersion='. $cVersion. '">
			'. getTag($cID, $cType, $cVersion). '
		</a>
	</td></tr>
	<tr><td class="title">
		<label>', getPhrase('Original Version/Status:'), '</label>
	</td><td nowrap>
		<div style="float: left;">'. $cVersion. ' &nbsp; </div>
		<div style="float: left;">'. getContentStatusIcon($cID, $cType, $cVersion). '</div>
	</td></tr>
	<tr><td class="title">
		<label for="title">', getPhrase('New Item\'s Title:'), '</label>
	</td><td class="', $currentTitle? 'mandatory_correct' : 'mandatory', '">
		<input type="hidden" id="current_title" value="', htmlspecialchars($currentTitle), '" />
		<input class="form_field" type="text" id="title" name="title" value="', htmlspecialchars($title), '" />
		<div class="icon_field"/>
	</td></tr>';
	
if ($cType == 'html') {
	echo '
	<tr><td class="title">
		<label for="alias">', getPhrase('New Item\'s Alias:'), '</label>
	</td><td>
		<input class="form_field" type="text" maxlength="50" id="alias" name="alias" value="', htmlspecialchars($alias), '" />
	</td></tr>';	
}

echo '
	<tr><td class="title">
		<label for="curr_language">', getPhrase('New Item\'s Language:'), '</label>
	</td><td>
		<input type="hidden" id="language" value="', htmlspecialchars($currentLang), '" />
		<select class="form_field" id="curr_language" name="language" onChange="langChange(); tribiqAFB.radioChange(this, true);">';
		
			foreach($languages as $langId => $languageDetails) {
				echo '
				<option style="background: left no-repeat url(../admin/images/flags/', $languageDetails['flag'], ');
								padding-left: 20px; color:', $langId == $currentLang? '#000000' : '#505050', ';"
				  value="', htmlspecialchars($langId), '" ', $lang == $langId? 'selected="selected"' :null, '>',
					htmlspecialchars($languageDetails['local_name']), ' (', htmlspecialchars($langId), ')',
				'</option>';
			}
		
echo '
		</select>
	</td></tr>';

if (inc('tribiq_avls')) {
	$details = array('create_equivalence' => 1);
	
	$fields = array(
		'create_equivalence' => array(
			'Type' => 'tinyint(1)',
			'Requires' => 'language',
			'Requires Value' => '',
			'Label' => getPhrase('Create an Equivalence:')),
		);
	
	$i = 0;
	foreach($languages as $langId => $languageDetails) {
		if ($langId != $currentLang) {
			$fields['create_equivalence']['Requires Value'] .= ($i++? ',' : ''). $langId;
		}
	}
		
	$requiredFields = array();
				
	echo dynamicThickboxFormInner($editMode, $fields, $requiredFields, $this->postVariables, $details);
}

echo '
	<tr><td class="title">
		<label>', getPhrase('_COPY_MENU_ITEM?'), '</label>
	</td><td>
		<input type="radio" id="menu_yes" name="menu" value="1" ', $menu? 'checked="checked"' :null, ' onChange="checkIfWeCanCopyMenus();" />
		<label for="menu_yes">Yes</label>
		&nbsp;
		<input type="radio" id="menu_no" name="menu" value="0" ', $menu? null: 'checked="checked"', ' onChange="checkIfWeCanCopyMenus();" />
		<label for="menu_no">No</label>
	</td></tr>
	<tr><td class="title">
		<label for="title">', getPhrase('_NEW_MENU_TITLE:'), '</label>
	</td><td>
		<input class="form_field" type="text" id="menu_title" name="menu_title" value="', htmlspecialchars($menuTitle), '" />
		
		<input type="hidden" id="copy_phrase" value="', getPhrase('_(COPY)'), '" />
		<input type="hidden" id="known_parent_ids" value="';

foreach($languages as $languageDetails) {
	echo $languageDetails['menu_parent'] === false? '' : '1', ',';
}

echo '" />
	</td></tr>';	

return false;
?>