<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if (!checkPriv('_PRIV_ENABLE_VLP')) {
	exit;
}

$errors = array();
if (!$_POST['lang_id']) {
	$errors[] = getPhrase('Please enter a Language Code.');

} elseif ($_POST['lang_id'] != preg_replace('/[^\w_-]/', '', $_POST['lang_id'])) {
	$errors[] = getPhrase('The Language Code can only contain letters, numbers, underscores or hyphens.');

} elseif (checkIfLanguageCanBeAdded($_POST['lang_id'])) {
	$errors[] = getPhrase('The Language Code [[id]] already exists', array('id' => htmlspecialchars($_POST['lang_id'])));
}

if (!$_POST['__LANGUAGE_LOCAL_NAME__']) {
	$errors[] = getPhrase('Please enter Local Name.');
}
if (!$_POST['__LANGUAGE_FLAG_FILENAME__']) {
	$errors[] = getPhrase('Please select a flag.');
}

echo json_encode(array('valid' => empty($errors), 'errArray' => $errors));

return false;
?>