<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if (!checkPriv('_PRIV_MANAGE_SPARE_DOMAIN_NAME')) {
	exit;
}

$errors = array();

if (!$primaryKey['url']) {
	if (!$_POST['requested_url']) {
		$errors[] = getPhrase('Please enter a URL.');
	
	} elseif (!aliasURLIsValid($_POST['requested_url'])) {
		$errors[] = getPhrase('Please enter a valid URL.');
	
	} else {
		connectGlobalDB();
			if (checkRowExists('spare_urls', array('sitename' => SITENAME, 'requested_url' => $_POST['requested_url']), DB_NAME_PREFIX_GLOBAL)) {
				$errors[] = getPhrase('The URL &quot;[[url]]&quot; already exists in the system.', array('url' => htmlspecialchars($_POST['requested_url'])));
			}
			if (issetArrayKey($_POST, 'add_www')
			 && checkRowExists('spare_urls', array('sitename' => SITENAME, 'requested_url' => 'www.'. $_POST['requested_url']), DB_NAME_PREFIX_GLOBAL)) {
				$errors[] = getPhrase('The URL &quot;[[url]]&quot; already exists in the system.', array('url' => htmlspecialchars('www.'. $_POST['requested_url'])));
			}
		connectLocalDB();
	}
}

if (!post('content')) {
	$errors[] = getPhrase('Please select a Content Item.');
}

echo json_encode(array('valid' => empty($errors), 'errArray' => $errors));

return false;
?>