<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

/* Define the content type variable for this include */

global $cType;
$cType = "document";





function getExtract ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	if (($cID > 0) && ($cVersion > 0)) {
		$sql = "
			SELECT document_text
			FROM ".DB_NAME_PREFIX."content_" . mysql_real_escape_string($GLOBALS['cType']) . "
			WHERE id=" . $cID . "
				AND version = " . (int) $cVersion;
		$result = my_mysql_query ($sql);
		if ($row = mysql_fetch_array ($result)) {
			return $row["document_text"];
		} else {
			return "<img src=\"contenttypes/images/awaiting_content.gif\" border=\"0\">";
		}
	} else { 
		return false;
	}
}

function getItemMeta ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	if (($cID > 0) && ($cVersion > 0)) {
		$sql = "
			SELECT title,
				language_id,
				".DB_NAME_PREFIX."content_" . mysql_real_escape_string($GLOBALS['cType']) . ".status,
				description,
				keywords,
				family_name,
				".DB_NAME_PREFIX."templates.filename,
				".DB_NAME_PREFIX."content_" . mysql_real_escape_string($GLOBALS['cType']) . ".template_id
			FROM ".DB_NAME_PREFIX."content_" . mysql_real_escape_string($GLOBALS['cType']) . "
			LEFT JOIN " . DB_NAME_PREFIX . "templates
				ON ".DB_NAME_PREFIX."content_" . mysql_real_escape_string($GLOBALS['cType']) . ".template_id = " . DB_NAME_PREFIX . "templates.template_id
			WHERE id = '" . mysql_real_escape_string($cID) . "'
				AND version = " . (int) $cVersion;
		$result = my_mysql_query ($sql);
		if ($row = mysql_fetch_array ($result)) {
			return $row;
		} else {
			return false;
		}
	} else {
		return false;
	}
}

function getDocument ($cID, $cVersion) {
	
	$sql = "
		SELECT
			type,
			title,
			description,
			publication_date,
			document_text,
			size
		FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . "
		WHERE id = " . (int) $cID . "
			AND version = " . (int) $cVersion;
	$result = my_mysql_query($sql);
	if ($row = mysql_fetch_assoc($result)) {
		return $row;
	} else {
		return false;
	}
}

# creates a random directory of $length length for the document to be stored in
# adds a htaccess file into this directory, so only the current user's IP address can view the downloaded file

function getItemFilename ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	$sql = "SELECT filename
			FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . "
			WHERE id = " . $cID . "
			AND version = " . (int) $cVersion;
	$result = my_mysql_query($sql);
	if ($row = mysql_fetch_row($result)) {
		return $row[0];
	} else {
		return false;
	}
}	



function buildDownload($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	cleanDownloads();
	# folder creation
	# pass a string length and the document path to the function which creates a randomly generated folder name
	$randomDir = createRandomDir( '15', "tmp_downloads" );
	$filename = getItemFilename( $cID, $cVersion ) ;
	$originalPath = CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $cID . "/" . $cVersion . "/" . $filename;
	if (file_exists($originalPath)) {
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
  			copy( $originalPath, "tmp_downloads/" . $randomDir . "/". $filename );
		} else {
   			symlink( $originalPath, "tmp_downloads/" . $randomDir . "/". $filename );
		}
		# link creation
		$link = "tmp_downloads/" . $randomDir . "/" . $filename;
		return $link;
	} else {
		return false;
	}
}


function copyDocumentFile ($original_cID, $original_cVersion, $new_cID, $new_cVersion) {
	$original_cID = (int) $original_cID;
	$original_cVersion = (int) $original_cVersion;
	$new_cID = (int) $new_cID;
	$new_cVersion = (int) $new_cVersion;
	
	if (!file_exists(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $new_cID)) {
		if (!@mkdir(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $new_cID)) {
			echo "Could not create directory '" . CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $new_cID . "'";
			exit;
		}
	}

	if (!file_exists(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $new_cID . "/" . $new_cVersion)) {
		if (!@mkdir(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $new_cID . "/" . $new_cVersion)) {
			echo "Could not create directory '" . CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $new_cID . "/" . $new_cVersion . "'";
			exit;			
		}
	}
	
	$filename = getItemFilename($original_cID,$original_cVersion);
	
	$source_filename = CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $original_cID . "/" . $original_cVersion . "/" . $filename;
	$destination_filename = CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $new_cID . "/" . $new_cVersion . "/" . $filename;
	
	if (!@copy($source_filename,$destination_filename)) {
		echo "Copy Failed. Could not copy " . $source_filename . " to " . $destination_filename . ".";
		exit;
	}
}

function deleteRawVersion ($cID, $cVersion,$deleteDirectories=false) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	$filename = getItemFilename($cID, $cVersion);	
	@unlink(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $cID . "/" . $cVersion . "/" . $filename);
	if ($deleteDirectories) {
		@rmdir(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $cID . "/" . $cVersion);
		if (getLatestVersion($cID,$GLOBALS['cType'])==1 && getLatestVersionStatus($cID,$GLOBALS['cType'])=="private_draft") {
			@rmdir(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $cID);		
		}
	}
}
function clearDocumentExtract( $cID, $cVersion ) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	$sql = "
		UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . "
		SET document_text = ''
		WHERE id = " . (int) $cID. "
			AND version = " . (int) $cVersion;
	my_mysql_query($sql);
	return true;
}
function updateExtract( $cID, $cVersion, $mimeType, $file ) {
	$extract = '';
	$fileEscaped = str_replace( array( '(', ')' ), array( '\(', '\)' ), $file );
	if ( 'text/plain' == $mimeType ) {
		if ( ! $extract = @file_get_contents( $file ) ) {
			$returnValue = 'file_get_contents failed';
		}
	} elseif ( 'application/msword' == $mimeType ) { 
		if (inc("tribiq_word_extractor")) {
			$extract = tribiq_word_extractor::performExtraction($file);
		}
	} elseif ( 'application/pdf'  == $mimeType ) { 
		if (inc("tribiq_pdf_extractor")) {
			$extract = tribiq_pdf_extractor::performExtraction($file);
		}
	} else {
		return true;
	}
	
	if ( empty( $extract ) ) {
		$sql = "
			UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . "
			SET document_text = ''
			WHERE id = " . (int) $cID. "
				AND version = " . (int) $cVersion;
		$result = my_mysql_query($sql);
		return false;
	} else {
		$sql = "
			UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . "
			SET document_text = '" . mysql_real_escape_string( trim( $extract ) ) . "'
			WHERE id = " . (int) $cID. "
				AND version = " . (int) $cVersion;
		$result = my_mysql_query($sql);
		return true;
	}
}
function reloadDocumentExtract( $cID, $cVersion ) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	// get filename and mime-type
	$sql = "
		SELECT filename, mime_type
		FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . "
		WHERE id = " . (int) $cID. "
			AND version = " . (int) $cVersion;
	$result = my_mysql_query($sql);
	if ( list( $file, $mimeType ) = mysql_fetch_row( $result ) ) {
		$file = CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $cID . "/" . $cVersion . "/" . basename( $file );
		updateExtract(  $cID, $cVersion,  $mimeType, $file );	
	}
	return true;
}

function updateDocumentFile( $cID, $cVersion, $filename ) {
	global $siteConfig;
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;	

	$contentTypeSettings = loadContentTypeSettings($GLOBALS['cType']);

	if ($filename) {
		if (is_uploaded_file($filename['tmp_name'])) {
			if ($filename['size']>$contentTypeSettings['max_filesize']) {
				$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
			}

			$fileExtension = preg_replace("#^.+\\.([^.]+)$#", "\\1", $filename['name']);
			if (!documentTypeIsAllowed($fileExtension)) {
				$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_INVALID_TYPE' );
			}

		} else {
			switch ($filename['error']) {
				case 1:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
					break;
				case 2:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
					break;
				case 3:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_PARTIAL_UPLOAD', array( 'size' => $contentTypeSettings['max_filesize'] ) );
					break;
				default:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_EMPTY', array( 'size' => $contentTypeSettings['max_filesize'] ) );
			}
		}
	} else {
		$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_EMPTY', array( 'size' => $contentTypeSettings['max_filesize'] ) );
	}
	if (!$error) {
		$latestVersion = getLatestVersion($cID, $GLOBALS['cType']);
		if (getLatestVersionStatus($cID,$GLOBALS['cType'])!="private_draft") {
			$cVersion = createPrivateDraft( $cID, $cVersion, $latestVersion );
		}
		
		$baseFilename = urlencode( basename( $filename['name'] ) );
		$uploadDestination = CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $cID . "/" . $cVersion . "/" . $baseFilename;
		deleteRawVersion($cID,$cVersion);
		$mimeType = $filename['type'];
		
/*
-- Code hack!
Error: PDF files show as MIME type text/html instead of application/pdf
The problem is a corruption of the mimeTypes.rdf file on Firefox home directory.
If you remove it and restart firefox, a new file is created and then the PDF is handled correctly.
*/
		if ( 'text/html' == $mimeType && $fileExtension == 'pdf' ) {
			$mimeType = 'application/pdf';
		}
			
		$sql = "
			UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . " 
			SET filename = '" . mysql_real_escape_string( $baseFilename ) . "',
				size = '" . mysql_real_escape_string($filename['size']) . "',
				type = '" . mysql_real_escape_string($fileExtension) . "',
				mime_type = '" . mysql_real_escape_string($mimeType) . "'
			WHERE id = " . $cID . "
				AND version = " . (int) $cVersion;
		$result = my_mysql_query($sql);
		move_uploaded_file( $filename['tmp_name'], $uploadDestination);
		if ( ! chmod( $uploadDestination, 0755 ) ) {
			echo "CHMOD has failed";
			exit;
		}
		updateExtract(  $cID, $cVersion, $mimeType, $uploadDestination );	
		return true;
	} else {
		return $error;
	}
}

function importContent ($formInputs) {
	$cID = (int) $formInputs['cID'];
	$cVersion = (int) $formInputs['cVersion'];	
	$latestVersion = getLatestVersion($cID, $GLOBALS['cType']);
	
	if ($formInputs['current_file']!="undefined") {
		if (!file_exists(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $formInputs['cID'])) {
			if (!mkdir(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $formInputs['cID'])) {
				echo "Could not create directory '" . CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $formInputs['cID'] . "'";
				exit;
			}
		}
	
		if (!file_exists(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $formInputs['cID'] . "/" . $formInputs['cVersion'])) {
			if (!mkdir(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $formInputs['cID'] . "/" . $formInputs['cVersion'])) {
				echo "Could not create directory '" . CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $formInputs['cID'] . "/" . $formInputs['cVersion'] . "'";
				exit;			
			}
		}
		
		$tidiedFilename = tidyFilename($formInputs['current_file']);
		
		$path = CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $cID . "/" . $cVersion . "/";
		$uploadDestination = $path . $tidiedFilename;
		
		//empty the directory
		foreach(scandir($path) as $existingFile) {
			if (is_file($path. $existingFile)) {
				@unlink($path. $existingFile);
			}
		}
		
		rename(CMS_DROPBOX_DIR . "/" . SITENAME . "/" . $formInputs['current_file'], $uploadDestination);
		
		/*
		
		if ( ! chmod( $uploadDestination, 0755 ) ) {
			echo "CHMOD has failed";
			exit;
		}
		
		*/
		
		$fileExt = substr($tidiedFilename,strrpos($tidiedFilename,".")+1);
		
		if (function_exists(finfo_open)) {
			$finfo = finfo_open(FILEINFO_MIME);
			$mimeType = finfo_file($finfo, $tidiedFilename);
		} else {
			if ($formInputs['cType']=="picture") {
				$mimeType = "image/" . $fileExt;
			} elseif ($formInputs['cType']=="document") {
				if ($fileExt=="pdf") {
					$mimeType = "application/" . $fileExt;
				} elseif ($fileExt=="doc") {
					$mimeType = "application/msword";
				} elseif ($fileExt=="txt") {
					$mimeType = "text/plain";
				}
			}
		}
		
		$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . " 
				SET filename = '" . mysql_real_escape_string( $tidiedFilename ) . "',
					size = '" . mysql_real_escape_string(filesize($uploadDestination)) . "',
					type = '" . mysql_real_escape_string($fileExt) . "',
					mime_type = '" . mysql_real_escape_string($mimeType) . "'
				WHERE id = " . $cID . "
					AND version = " . (int) $cVersion;
		
		$result = my_mysql_query($sql);
		
		updateExtract($cID,$cVersion,$mimeType,$uploadDestination);
	}
}

function validateDropbox ($data) {
	if (!$data['selected_file']) {
		$error[] = getPhrase("Please select a file.");
	}
	
	if ($error) {
		return Array("valid" => false,"errArray" => $error);
	} else {
		return Array("valid" => true,"errArray" => "");
	}
}

function createNewContent( $menuId, $pageTitle, $languageId, $description, $filename, $private=false, $caller="" ) {
	global $siteConfig;

	$contentTypeSettings = loadContentTypeSettings($GLOBALS['cType']);

	if ($filename) {
		if (is_uploaded_file($filename['tmp_name'])) {
			if ($filename['size']>$contentTypeSettings['max_filesize']) {
				$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
			}
			
			$fileExtension = preg_replace("#^.+\\.([^.]+)$#", "\\1", $filename['name']);
			if (!documentTypeIsAllowed($fileExtension)) {
				$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_INVALID_TYPE' );
			}
			
		} else {
			switch ($filename['error']) {
				case 1:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
					break;
				case 2:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
					break;
				case 3:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_PARTIAL_UPLOAD', array( 'size' => $contentTypeSettings['max_filesize'] ) );
					break;
				default:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_EMPTY', array( 'size' => $contentTypeSettings['max_filesize'] ) );
			}
		}
	}
	if (!$pageTitle||$pageTitle=="") {
		$error['page_title'] = getPhrase("_MSG_NO_TITLE_OR_FILENAME");
	}
	if (!$error) {
		if ($private) {
			$private = 1;
		} else {
			$private = 0;
		}
		if ($caller=="" && $parent_mID = getMenuParent($menuId)) {
			$sql = "
				SELECT template_id 
				FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . "
				WHERE id = " . $parent_mID;
			$result = my_mysql_query($sql);
			if (mysql_num_rows($result)>0) {			
				$row = mysql_fetch_array($result);
				$templateId = $row['template_id'];
			} else {
				$sql = "
					SELECT default_template_id
					FROM " . DB_NAME_PREFIX . "contenttypes
					WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";				
				$result = my_mysql_query($sql);
				$row = mysql_fetch_array($result);
				$templateId = $row['default_template_id'];				
			}
		} else {
			$sql = "SELECT default_template_id
					FROM " . DB_NAME_PREFIX . "contenttypes
					WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
			
			$result = my_mysql_query($sql);
			
			$row = mysql_fetch_array($result);
			
			$templateId = $row['default_template_id'];				
		}
		
		$sql = "SELECT MAX(id)+1 AS NewID 
				FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']);
		
		$result = my_mysql_query($sql);
		

		$row = mysql_fetch_array($result);
		
		if ($row[0]!="") {
			$newid = $row[0];
		} else {
			$newid = 1;			
		}
		
		$cVersion = 1;
		
		if (!file_exists(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $newid)) {
			if (!mkdir(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $newid)) {
				echo "Could not create directory '" . CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $newid . "'";
				exit;
			}
		}

		if (!file_exists(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $newid . "/" . $cVersion)) {
			if (!mkdir(CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $newid . "/" . $cVersion)) {
				echo "Could not create directory '" . CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $newid . "/" . $cVersion . "'";
				exit;			
			}
		}
		$mimeType = $filename['type'];
		$baseFilename = str_replace( " ", "_", basename( $filename['name'] ) );
		
		$uploadDestination = CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . $newid . "/" . $cVersion . "/" . stripslashes( $baseFilename );

		$sql = "REPLACE INTO " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . " 
				SET id = " . $newid . ",
					title = '" . mysql_real_escape_string($pageTitle) . "',
					owner_id = " . $_SESSION["admin_userid"] . ",
					owner_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					creating_author_id = " . $_SESSION["admin_userid"] . ",
					creating_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					created_datetime = NOW(),
					last_author_id = " . $_SESSION["admin_userid"] . ",
					last_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					description = '" . mysql_real_escape_string($description) . "',
					private = " . $private . ",
					template_id = " . $templateId . ",
					language_id = '" . mysql_real_escape_string($languageId) . "',
					filename = '" . mysql_real_escape_string($baseFilename) . "',
					size = '" . mysql_real_escape_string($filename['size']) . "',
					type = '" . mysql_real_escape_string($fileExtension) . "',
					mime_type = '" . mysql_real_escape_string($mimeType) . "'";
		
		$result = my_mysql_query($sql);
		
		move_uploaded_file($filename['tmp_name'], $uploadDestination);
		
		if (!chmod($uploadDestination,0755)) {
			echo "CHMOD has failed";
			exit;
		}
		if ( 'text/plain' == $mimeType 
			|| 'application/msword' == $mimeType 
			|| 'application/pdf'  == $mimeType ) { 
			updateExtract(  $newid, $cVersion, $mimeType, $uploadDestination );	
		}
		if ($caller=="") {
			$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems 
					SET content_id = " . $newid . ", 
						content_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "'
					WHERE id = " . $menuId;
			
			$result = my_mysql_query($sql);
		}
		
		return true;
	
	} else {
		return $error;
	}
}




?>