<?php 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */  

/* Define the content type variable for this include */

global $cType;
$cType = "event";


 


function getItemMeta ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	
	if (($cID > 0) && ($cVersion > 0)) {
		$sql = "SELECT title,
					language_id,
					".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".status,
					description,
					keywords,
					family_name,
					filename,
					".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".template_id
				FROM ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . "
				LEFT JOIN " . DB_NAME_PREFIX . "templates
					ON ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".template_id = " . DB_NAME_PREFIX . "templates.template_id
				WHERE id = '" . mysql_real_escape_string($cID) . "'
					AND version = " . $cVersion;
		$result = my_mysql_query ($sql);
		if ($row = mysql_fetch_array ($result)) {
			return $row;
		} else {
			return false;
		}
	} else {
		return false;
	}
}



function getEvent ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	$sql = "SELECT id,
				version,
				title,
				private,
				language_id,
				status,
				draft_exists,
				created_datetime,
				owner_id,
				owner_authtype,
				creating_author_id,
				creating_author_authtype,
				allow_local_coauthor_id,
				last_author_id,
				last_author_authtype,
				publisher_id,
				publisher_authtype,
				published_datetime,
				hider_id,
				hider_authtype,
				hidden_datetime,
				archiver_id,
				archiver_authtype,
				archived_datetime,
				expiry_datetime,
				expiry_action,
				description,
				keywords,
				template_id,
				content_head,
				content_bodytop,
				content_bodymain,
				content_bodyfoot,
				spare_varchar1,
				spare_varchar2,
				new_menu_text,
				private_view_event,
				private_view_guests,
				allow_join_event,
				joining_fee,
				allow_max_guests,
				confirmation_status,
				declare_full,
				allow_friends,
				event_type1,
				event_type2,
				location_name,
				location_address1,
				location_address2,
				location_city,
				location_state,
				location_postcode,
				location_country_id,
				phone,
				email,
				website,
				start_date,
				start_time,
				end_date,
				end_time,
				specify_time,
				seo_sitemap_changefreq,
				seo_sitemap_priority,
				diagnostic_page
			FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
			WHERE id = " . $cID . "
				AND version = " . $cVersion;
				
	$result = my_mysql_query($sql);
	
	if ($row = mysql_fetch_array($result)) {
		return $row;
	} else {
		return false;
	}
}

function createNewContent($menuid,$page_title, $template_id,$language_id,$sampletext=false,$publication_date,$private=false,$caller="") {
	$menuid = (int) $menuid;
	$template_id = (int) $template_id;
	
	if (!$page_title||$page_title=="") {
		$error['page_title'] = getPhrase("_MSG_NO_TITLE");
	}
	
	// Do Date Format checks if it exists
	if ($publication_date) {

		// _MSG_DATE_FORMAT
		if (preg_match("/\d{4}-\d{2}-\d{2}/",$publication_date)) {

			$digit_array_check = explode("-",$publication_date);

			$date_year_error = false;
			$date_month_error = false;
			$date_day_error = false;
			$date_error_string = "";

			// Digit check
			$digit_year = (int)$digit_array_check[0];
			$digit_month = (int)$digit_array_check[1];
			$digit_day = (int)$digit_array_check[2];				

			// Date 0000-00-00 should be a null entry in db
			if ((!$digit_year) && (!$digit_month) && (!$digit_day)) {
				$publication_date = ""; 
			} else {

				if (!$digit_year) $date_year_error = true;
				if (($digit_month < 1) || ($digit_month > 12)) $date_month_error = true;
				if (($digit_day < 1) || ($digit_day > 31)) $date_day_error = true;	

				// If no errors in date then, Format for SQL insert
				if ((!$date_year_error) && (!$date_month_error) && (!$date_day_error))
					$publication_date = "'".$digit_array_check[0]."-".$digit_array_check[1]."-".$digit_array_check[2]."'";
				else {
					if ($date_year_error) $date_error_string .= getPhrase("_MSG_DATE_YEAR")."<br/>";
					if ($date_month_error) $date_error_string .= getPhrase("_MSG_DATE_MONTH")."<br/>";
					if ($date_day_error) $date_error_string .= getPhrase("_MSG_DATE_DAY")."<br/>";
					$error['publication_date'] = getPhrase("_MSG_DATE_FORMAT")."<br/>".$date_error_string;
				}
			}

		} else $error['publication_date'] = getPhrase("_MSG_DATE_FORMAT");
	} 

	 //$publication_date = checkDateFormat($publication_date,"publication_date");

	if (strlen($publication_date) <= 0) $publication_date="null";

	if (!$error) {

		if ($sampletext) {
			$content_bodymain = "<h1>Sample Text</h1>\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Curabitur eros augue, suscipit et, tempus nec, consequat sed, erat. Proin est. Proin dapibus. In facilisis sagittis libero. Vivamus nec enim. Cras magna. Donec eu eros. Vestibulum purus dui, viverra nec, sagittis at, laoreet at, augue. Integer mi ante, dictum id, posuere ac, malesuada non, nisi. Sed pulvinar elementum nisi. Nullam lacus erat, cursus sed, rutrum sit amet, interdum vel, quam.</p>";
		}
		
		if ($private) {
			$private = 1;
		} else {
			$private = 0;
		}
		
		if ($caller=="" && $parent_mID = getMenuParent($menuid)) {
			$content_array = getContentFromMenu($parent_mID);
			
			$cID = $content_array['content_id'];
			
			$sql = "SELECT template_id 
					FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . " 
					WHERE id = '" . mysql_real_escape_string($cID) . "'";
			$result = my_mysql_query($sql);
			
			if (mysql_num_rows($result)>0) {			
				$row = mysql_fetch_array($result);
				
				if (!$template_id) {
					$template_id = $row['template_id'];
				}
			} else {
				$sql = "SELECT default_template_id
						FROM " . DB_NAME_PREFIX . "contenttypes
						WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
				
				$result = my_mysql_query($sql);
				
				$row = mysql_fetch_array($result);
				
				if (!$template_id) {
					$template_id = $row['default_template_id'];
				}
			}
		} else {
			$sql = "SELECT default_template_id
					FROM " . DB_NAME_PREFIX . "contenttypes
					WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
			
			$result = my_mysql_query($sql);
			
			$row = mysql_fetch_array($result);
			
			if (!$template_id) {
				$template_id = $row['default_template_id'];
			}
		}
		
		$sql = "SELECT MAX(id)+1 AS NewID 
				FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'];
		
		$result = my_mysql_query($sql);
		

		$row = mysql_fetch_array($result);
		
		if ($row[0]!="") {
			$newid = $row[0];
		} else {
			$newid = 1;			
		}
		
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
					SET id = " . $newid . ",
					title = '" . mysql_real_escape_string($page_title) . "',
					owner_id = " . $_SESSION["admin_userid"] . ",
					owner_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					creating_author_id = " . $_SESSION["admin_userid"] . ",
					creating_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					created_datetime = NOW(),
					last_author_id = " . $_SESSION["admin_userid"] . ",
					last_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					content_head = '" . mysql_real_escape_string($content_head) . "',
					content_bodytop = '" . mysql_real_escape_string($content_bodytop) . "',
					content_bodymain = '" . mysql_real_escape_string($content_bodymain) . "',
					content_bodyfoot = '" . mysql_real_escape_string($content_bodyfoot) . "',
					language_id = '" . mysql_real_escape_string($language_id) . "',
					private = '" . mysql_real_escape_string($private) . "',
					template_id = " . $template_id;
		
		$result = my_mysql_query($sql);
		
		if ($caller=="" AND $menuid<>"") {
			$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems 
						SET content_id = " . $newid . ", 
						content_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "' , 
						language_id = '" . mysql_real_escape_string($language_id) . "'
						WHERE id = " . $menuid;
			
			$result = my_mysql_query($sql);
		}
		
		return true;
	
	} else {
		return $error;
	}
}




function displaySetSettingsForm($formInputs, $showEditButton) {
	
	
	if ($formInputs['cID']) {
		$event = getEvent($formInputs['cID'],$formInputs['cVersion']);
	}
	
	if ($formInputs['submit']) {
		$event = $formInputs;
	}

	if ($event['specify_time']) {
		$specify_time_checked = " checked=\"checked\"";
	} else {
		$specify_time_checked = "";
	}



	if ($formInputs['start_date_mysql']){
		$mysqlStartDate = $formInputs['start_date_mysql'];
	} else {
		$mysqlStartDate = $event['start_date'];
	}

	if ($formInputs['start_date']){
		$startDate = $formInputs['start_date'];
	} else {
		if ($d = strtotime($event['start_date'])){
			$startDate = date('d/m/Y',$d);
		} else {
			$endDate = "";
		}
	}



	if ($formInputs['formMode']=="edit" || !$formInputs['cID']) {

		$formhtml = "
		<form name=\"setsettings\" action=\"?width=". $formInputs['width'] . "&height=" . $formInputs['height'] . "&KeepThis=true&TB_iframe=true&modal=true\" id=\"setsettings\" method=\"post\" class=\"thickbox\" onsubmit=\"formHandler();return false;\">
						<input type=\"hidden\" id=\"formMode\" name=\"formMode\" value=\"edit\" />
						<input type=\"hidden\" id=\"cType\" name=\"cType\" value=\"" . $formInputs['cType'] . "\" />\n";
		
		$formhtml .= "<input type=\"hidden\" id=\"start_time\" value=\"" . $event['start_time'] . "\" />
						<input type=\"hidden\" id=\"end_time\" value=\"" . $event['end_time'] . "\" />
						<table id=\"content_form\" border=\"0\">
							<tr id=\"errorDisplayRow\" style=\"display:none;\">
								<td colspan=\"2\" id=\"errorDisplay\" style=\"display:none;\">" . $errordisplay . "</td>
							</tr>
							<tr>
								<td colspan=\"2\">Use this screen to set the Single-Day Event Details for this Content Item.</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"start_date\">" . getPhrase('Event Date:') . "</label></td>
								<td >
									<input type=\"text\" id=\"start_date\" name=\"start_date\" value=\"" . stripslashes(htmlspecialchars($startDate)) . "\" readonly=\"readonly\" />
									<input type=\"hidden\" id=\"start_date_mysql\" name=\"start_date_mysql\" value=\"" . stripslashes(htmlspecialchars($mysqlStartDate)) . "\" />
								</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"start_time_hour\">" . getPhrase('Start Time:') . "</label></td>
								<td style=\"width:490px\">
									<span>" . getPhrase("Hours:") . "</span>
									<select name=\"start_time_hour\" id=\"start_time_hour\" onchange=\"setStartTime();\">\n";

		$arrStartTime = explode(":",$event['start_time']);

		for ($i=0;$i<24;$i++) {
			if (strlen($i)<2) {
				$j = "0" . $i;
			} else {
				$j = $i;
			}
			
			if ($j==$arrStartTime[0]) {
				$selected = " selected=\"selected\"";
			} else {
				$selected = "";
			}
			
			$formhtml .= "<option value=\"" . $j . "\"" . $selected . ">" . $j . "</option>\n";
		}
		
		$formhtml .= "				</select>
									<span>" . getPhrase("_MINUTES:") . "</span>
									<select name=\"start_time_minutes\" id=\"start_time_minutes\" onchange=\"setStartTime();\">\n";

		for ($i=0;$i<60;$i+=5) {
			if (strlen($i)<2) {
				$j = "0" . $i;
			} else {
				$j = $i;
			}
			
			if ($j==$arrStartTime[1]) {
				$selected = " selected=\"selected\"";
			} else {
				$selected = "";
			}
			
			$formhtml .= "<option value=\"" . $j . "\"" . $selected . ">" . $j . "</option>\n";
		}
												
		$formhtml .= "<option value=\"59\"" . $selected . ">59</option>\n";
												
		$formhtml .= "				</select>
								</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"end_time_hour\">" . getPhrase('End Time:') . "</label></td>
								<td style=\"width:490px\">
									<span>" . getPhrase("_HOURS:") . "</span>
									<select name=\"end_time_hour\" id=\"end_time_hour\" onchange=\"setEndTime();\">\n";

		$arrEndTime = explode(":",$event['end_time']);

		for ($i=0;$i<24;$i++) {
			if (strlen($i)<2) {
				$j = "0" . $i;
			} else {
				$j = $i;
			}
			
			if ($j==$arrEndTime[0]) {
				$selected = " selected=\"selected\"";
			} else {
				$selected = "";
			}
			
			$formhtml .= "<option value=\"" . $j . "\"" . $selected . ">" . $j . "</option>\n";
		}
												
												
		$formhtml .= "				</select>
									<span>" . getPhrase("_MINUTES:") . "</span>
									<select name=\"end_time_minutes\" id=\"end_time_minutes\" onchange=\"setEndTime();\">\n";

		for ($i=0;$i<60;$i+=5) {
			if (strlen($i)<2) {
				$j = "0" . $i;
			} else {
				$j = $i;
			}
			
			if ($j==$arrEndTime[1]) {
				$selected = " selected=\"selected\"";
			} else {
				$selected = "";
			}
			
			$formhtml .= "<option value=\"" . $j . "\"" . $selected . ">" . $j . "</option>\n";
		}
												
		$formhtml .= "<option value=\"59\"" . $selected . ">59</option>\n";
												
		$formhtml .= "				</select>
								</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"specify_time\">" . getPhrase('Specify Time:') . "</label></td>
								<td style=\"width:490px\"><input type=\"checkbox\" name=\"specify_time\" id=\"specify_time\"" . $specify_time_checked . " /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"location_name\">" . getPhrase('Location:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"location_name\" id=\"location_name\" value=\"" . stripslashes(htmlspecialchars($event['location_name'])) . "\" /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"location_address1\">" . getPhrase('Address 1:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"location_address1\" id=\"location_address1\" value=\"" . stripslashes(htmlspecialchars($event['location_address1'])) . "\" /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"location_address2\">" . getPhrase('Address 2:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"location_address2\" id=\"location_address2\" value=\"" . stripslashes(htmlspecialchars($event['location_address2'])) . "\" /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"location_city\">" . getPhrase('City:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"location_city\" id=\"location_city\" value=\"" . stripslashes(htmlspecialchars($event['location_city'])) . "\" /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"location_state\">" . getPhrase('State/County:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"location_state\" id=\"location_state\" value=\"" . stripslashes(htmlspecialchars($event['location_state'])) . "\" /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"location_postcode\">" . getPhrase('Post/ZIP Code:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"location_postcode\" id=\"location_postcode\" value=\"" . stripslashes(htmlspecialchars($event['location_postcode'])) . "\" /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"location_postcode\">" . getPhrase('Country:') . "</label></td>
								<td style=\"width:490px\">
									<select class=\"form_field\" name=\"location_country_id\" id=\"location_country_id\">
										<option value=\"\">" . getPhrase(" -- Select a Country -- ") . "</option>\n";
		
		if (inc('tribiq_country_manager')){
			$countries = tribiq_country_manager::getCountryAdminNamesIndexedByISOCode();

			foreach ($countries as $K=>$country) {
				if ($event['location_country_id']==$K) {
					$selected_country = " selected=\"selected\"";
				} else {
					$selected_country = "";
				}
				
				$formhtml .= "<option value=\"" . $K . "\"" . $selected_country . ">" . $country . "</option>\n";
			}

		}

		
		$formhtml .= "				</select>
								</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"phone\">" . getPhrase('Phone:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"phone\" id=\"phone\" value=\"" . stripslashes(htmlspecialchars($event['phone'])) . "\" /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"email\">" . getPhrase('Email:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"email\" id=\"email\" value=\"" . stripslashes(htmlspecialchars($event['email'])) . "\" /></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\"><label for=\"website\">" . getPhrase('Website:') . "</label></td>
								<td style=\"width:490px\"><input type=\"text\" class=\"form_field\" name=\"website\" id=\"website\" value=\"" . stripslashes(htmlspecialchars($event['website'])) . "\" /></td>
							</tr>
							<tr>
								<td>&nbsp;</td>
								<td class=\"left\">
									<input type=\"submit\" id=\"submit\" class=\"submit\" value=\"" . getPhrase("_CANCEL") . "\" onclick=\"cancelEdit();\" />
								</td>
							</tr>
							<tr>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>
						</table>
					</form>";
				
	} else {

		$formhtml = "<form name=\"setsettings\" action=\"?width=". $formInputs['width'] . "&height=" . $formInputs['height'] . "&KeepThis=true&TB_iframe=true&modal=true\" id=\"setsettings\" method=\"post\" class=\"thickbox\" onsubmit=\"formHandler(this);return false;\">
						<input type=\"hidden\" id=\"formMode\" name=\"formMode\" value=\"view\" />
						<table id=\"content_form\" border=\"0\">";
					
		$formhtml .= "				
							<tr>
								<td colspan=\"2\">Use this screen to set the Single-Day Event Details for this Content Item.</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Event Date:') . "</td>
								<td style=\"width:490px\">" . stripslashes($startDate) . "</td>
							</tr>\n";
							
		if ($event['specify_time']) {					
			$formhtml .= "		<tr>
									<td class=\"title\" style=\"width:110px\">" . getPhrase('Start Time:') . "</td>
									<td style=\"width:490px\">" . stripslashes($event['start_time']) . "</td>
								</tr>
								<tr>
									<td class=\"title\" style=\"width:110px\">" . getPhrase('End Time:') . "</td>
									<td style=\"width:490px\">" . stripslashes($event['end_time']) . "</td>
								</tr>\n";
		}
		
		$formhtml .= "		<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Location:') . "</td>
								<td style=\"width:490px\">" . stripslashes($event['location_name']) . "</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Address 1:') . "</td>
								<td style=\"width:490px\">" . stripslashes($event['location_address1']) . "</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Address 2:') . "</td>
								<td style=\"width:490px\">" . stripslashes($event['location_address2']) . "</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('City:') . "</td>
								<td style=\"width:490px\">" . stripslashes($event['location_city']) . "</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('State/County:') . "</td>
								<td style=\"width:490px\">" . stripslashes($event['location_state']) . "</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Post/ZIP Code:') . "</td>
								<td style=\"width:490px\">" . stripslashes($event['location_postcode']) . "</td>
							</tr>\n";
		
		if (inc('tribiq_country_manager')){
			$countries = tribiq_country_manager::getCountryAdminNamesIndexedByISOCode();
		}
		$formhtml .= "		<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Country:') . "</td>
								<td style=\"width:490px\">" . stripslashes($countries[$event['location_country_id']]) . "</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Phone:') . "</td>
								<td style=\"width:490px\">" . stripslashes($event['phone']) . "</td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Email:') . "</td>
								<td style=\"width:490px\"><a href=\"mailto:" . stripslashes($event['email']) . "\">" . stripslashes($event['email']) . "</a></td>
							</tr>
							<tr>
								<td class=\"title\" style=\"width:110px\">" . getPhrase('Website:') . "</td>
								<td style=\"width:490px\"><a href\"" . stripslashes($event['website']) . "\">" . stripslashes($event['website']) . "</a></td>
							</tr>";
		
		if ($showEditButton) {
			$formhtml .= "
							<tr>
								<td>&nbsp;</td>
								<td class=\"left\">
									<input type=\"submit\" id=\"submit\" name=\"submit\" class=\"submit\" value=\"" . getPhrase("_EDIT") . "\" />
								</td>
							</tr>";
		}
		
		$formhtml .= "
							<tr>
								<td>&nbsp;</td>
								<td>&nbsp;</td>
							</tr>
						</table>
					</form>";
	}
	
	return array($formhtml,$msg,$type_msg);
}

function validateSettings ($data) {
	if ($data['specify_time']) {
		if (!$data['start_time']) {
			$error[] = getPhrase("_ERR_NO_START_TIME");
		}
		
		if (strtotime($data['end_time'])<strtotime($data['start_time'])) {
			$error[] = getPhrase("_ERR_ENDTIME_LESS_THAN_STARTTIME");
		}
	}
	
	if ($error) {
		return Array("valid" => false,"errArray" => $error);
	} else {
		return Array("valid" => true,"errArray" => "");
	}
}

function saveSettings ($formInputs) {
	$sql = "
		UPDATE " . DB_NAME_PREFIX . "content_event SET
			start_date = ". ($formInputs['start_date_mysql']? "'". mysql_real_escape_string($formInputs['start_date_mysql']). "'" : "NULL"). ",
			end_date = ". ($formInputs['start_date_mysql']? "'". mysql_real_escape_string($formInputs['start_date_mysql']). "'" : "NULL"). ",
			start_time = ". ($formInputs['start_time']? "'". mysql_real_escape_string($formInputs['start_time']). "'" : "NULL"). ",
			end_time = ". ($formInputs['end_time']? "'". mysql_real_escape_string($formInputs['end_time']). "'" : "NULL"). ",
			publication_date = ". ($formInputs['start_date_mysql']? "'". mysql_real_escape_string($formInputs['start_date_mysql'] . ($formInputs['start_time'] ? (" " . $formInputs['start_time']) : "")). "'" : "NULL"). ",";
	
	if ($formInputs['specify_time']) {
		$sql .= "
			specify_time = 1,";
	}
	
	$sql .= "
			location_name = '" . mysql_real_escape_string($formInputs['location_name']) . "',
			location_address1 = '" . mysql_real_escape_string($formInputs['location_address1']) . "',
			location_address2 = '" . mysql_real_escape_string($formInputs['location_address2']) . "',
			location_city = '" . mysql_real_escape_string($formInputs['location_city']) . "',
			location_state = '" . mysql_real_escape_string($formInputs['location_state']) . "',
			location_postcode = '" . mysql_real_escape_string($formInputs['location_postcode']) . "',
			location_country_id = '" . mysql_real_escape_string($formInputs['location_country_id']) . "',
			phone = '" . mysql_real_escape_string($formInputs['phone']) . "',
			email = '" . mysql_real_escape_string($formInputs['email']) . "',
			website = '" . mysql_real_escape_string($formInputs['website']) . "'
		WHERE id = " . $formInputs['cID'] . "
		  AND version = " . $formInputs['cVersion'];
			
	$result = my_mysql_query($sql);
}


function deleteRawVersion($cID, $cVersion, $deleteDirectories=false) {
	
}

?>