<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

/* Define the content type variable for this include */

global $cType;
$cType = "picture";





function getItemMeta ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	
	if (($cID > 0) && ($cVersion > 0)) {
		$sql = "SELECT title,
					language_id,
					".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".status,
					description,
					keywords,
					family_name,
					".DB_NAME_PREFIX."templates.filename,
					".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".template_id
				FROM ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . "
				LEFT JOIN " . DB_NAME_PREFIX . "templates
					ON ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".template_id = " . DB_NAME_PREFIX . "templates.template_id
				WHERE id = '" . mysql_real_escape_string($cID) . "'
					AND version = " . $cVersion;
		$result = my_mysql_query ($sql);
		if ($row = mysql_fetch_array ($result)) {
			return $row;
		} else {
			return false;
		}
	} else {
		return false;
	}
}

function getPicture ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	$sql = "
		SELECT *
		FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
		WHERE id = " . $cID . "
		AND version = " . $cVersion;
	$result = my_mysql_query($sql);
	if ($row = mysql_fetch_array($result)) {
		return $row;
	} else {
		return false;
	}
}

function getItemFilename ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	
	$sql = "SELECT filename
			FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
			WHERE id = " . $cID . "
			AND version = " . $cVersion;
	$result = my_mysql_query($sql);
	
	if ($row = mysql_fetch_array($result)) {
		return $row[0];
	} else {
		return false;
	}
}	

function getDateCreated($cID) {
	$cID = (int) $cID;
	$sql = "
		SELECT created_datetime
		FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
		WHERE id = " . $cID . "
		AND version = '1'";
	$result = my_mysql_query($sql);
	if ($row = mysql_fetch_array($result)) {
		return $row[0];
	} else {
		return false;
	}
}



function createNewContent($menuid,$page_title, $template_id,$language_id,$sampletext=false,$private=false,$userfile,$caller="") {
	$siteConfig = loadSiteConfig();
	$contentTypeSettings = loadContentTypeSettings($GLOBALS['cType']);
	
	$menuid = (int) $menuid;
	$template_id = (int) $template_id;
	
	if (!$page_title||$page_title=="") {
		$error['page_title'] = getPhrase("_MSG_NO_TITLE_OR_FILENAME");
	}

	/*
	
	if (!$template_id||$template_id=="") {
		$error['template_id'] = getPhrase("_MSG_NO_TEMPLATE_SELECTED");
	}

	*/

	if (!$userfile||$userfile=="") {
		$error['userfile'] = getPhrase("_MSG_NO_FILE_PATH_SPECIFIED");
	}
	
	if (!$filename = $userfile['tmp_name']) {
		$filename = $userfile['fullpath'];
	}
	
	if (is_uploaded_file($filename) || file_exists($filename)) {
		if ($userfile['size']>$contentTypeSettings['max_filesize']) {
			$error['userfile'] = "Your file must be less than " . $contentTypeSettings['max_filesize'] . " bytes";
		}
		
		if (!in_array($userfile['type'],array("image/jpeg","image/gif","image/png","image/jpg","image/pjpeg"))) {
			$error['userfile'] = "You must select a valid file format";
		}
		
		if (!getimagesize($filename)) {
			$error['userfile'] = "You must select a valid image file";
		}
	} else {
		switch ($userfile['error']) {
			case 1:
				$error['userfile'] = "Your file must be less than " . $contentTypeSettings['max_filesize'] . " bytes";
				break;
			case 2:
				$error['userfile'] = "Your file must be less than " . $contentTypeSettings['max_filesize'] . " bytes";
				break;
			case 3:
				$error['userfile'] = "Your file was only partially uploaded.  Please try again.";
				break;
			default:
				$error['userfile'] = "You must select an image to upload";
		}
	}
	
	if (!$error) {
	
		if ($sampletext) {
			$content_bodymain = "<h1>Sample Text</h1>\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Curabitur eros augue, suscipit et, tempus nec, consequat sed, erat. Proin est. Proin dapibus. In facilisis sagittis libero. Vivamus nec enim. Cras magna. Donec eu eros. Vestibulum purus dui, viverra nec, sagittis at, laoreet at, augue. Integer mi ante, dictum id, posuere ac, malesuada non, nisi. Sed pulvinar elementum nisi. Nullam lacus erat, cursus sed, rutrum sit amet, interdum vel, quam.</p>";
		}
		
		if ($private) {
			$private = 1;
		} else {
			$private = 0;
		}
		
		if ($caller=="" && $parent_mID = getMenuParent($menuid)) {
			$content_array = getContentFromMenu($parent_mID);
			
			$cID = $content_array['content_id'];
			
			$sql = "SELECT template_id 
					FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . " 
					WHERE id = '" . mysql_real_escape_string($cID) . "'";
			$result = my_mysql_query($sql);
			
			if (mysql_num_rows($result)>0) {			
				$row = mysql_fetch_array($result);
				
				if (!$template_id) {
					$template_id = $row['template_id'];
				}
			} else {
				$sql = "SELECT default_template_id
						FROM " . DB_NAME_PREFIX . "contenttypes
						WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
				
				$result = my_mysql_query($sql);
				
				$row = mysql_fetch_array($result);
				
				if (!$template_id) {
					$template_id = $row['default_template_id'];
				}
			}
		} else {
			$sql = "SELECT default_template_id
					FROM " . DB_NAME_PREFIX . "contenttypes
					WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
			
			$result = my_mysql_query($sql);
			
			$row = mysql_fetch_array($result);
			
			if (!$template_id) {
				$template_id = $row['default_template_id'];
			}
		}
		
		$sql = "SELECT MAX(id)+1 AS NewID 
				FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'];
		
		$result = my_mysql_query($sql);
		

		$row = mysql_fetch_array($result);
		
		if ($row[0]!="") {
			$newid = $row[0];
		} else {
			$newid = 1;			
		}
		
		$img_size_result = getimagesize($filename);
		
		if (is_array($img_size_result)) {
			$img_width = $img_size_result[0]; 
			$img_height = $img_size_result[1];
			$img_mime_type = $img_size_result['mime'];
		} else {
			echo getPhrase("_TMP_FILENAME") . $filename;
			echo getPhrase("_GETIMAGESIZE_FAILED");
			exit;
		}

		$sql = "INSERT INTO " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . " 
					SET id = " . $newid . ",
					title = '" . mysql_real_escape_string($page_title) . "',
					owner_id = " . $_SESSION["admin_userid"] . ",
					owner_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					creating_author_id = " . $_SESSION["admin_userid"] . ",
					creating_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					created_datetime = NOW(),
					last_author_id = " . $_SESSION["admin_userid"] . ",
					last_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					content_head = '" . mysql_real_escape_string($content_head) . "',
					content_bodytop = '" . mysql_real_escape_string($content_bodytop) . "',
					content_bodymain = '" . mysql_real_escape_string($content_bodymain) . "',
					content_bodyfoot = '" . mysql_real_escape_string($content_bodyfoot) . "',
					language_id = '" . mysql_real_escape_string($language_id) . "',
					private = " . $private . ",
					template_id = " . $template_id . ",
					filename = '" . mysql_real_escape_string(str_replace(" ","_",$userfile['name'])) . "',
					mime_type = '" . mysql_real_escape_string($img_mime_type) . "',
					width = " . $img_width . ",
					height = " . $img_height . ",
					size = " . filesize($filename);
		
		$result = my_mysql_query($sql);
		
		$img_data_raw = file_get_contents($filename);

		$image = imagecreatefromstring($img_data_raw);
		
		if (function_exists(saveRawImage)) {
			saveRawImage($newid,1,$img_data_raw);
		}

		if ($contentTypeSettings['standard_width'] && $contentTypeSettings['standard_height']) {
			list($standard_width,$standard_height) = resizeImage($img_width,$img_height,$contentTypeSettings['standard_width'],$contentTypeSettings['standard_height']);
			
			$standard_width = (int) $standard_width;
			$standard_height = (int) $standard_height;

			// Manipulate Image
			$resized_image = imagecreatetruecolor($standard_width, $standard_height);
									
			imagecopyresampled($resized_image, $image, 0, 0, 0, 0, $standard_width, $standard_height, $img_width, $img_height);
			
			ob_start();
			
			//header('Content-type: '.$img_mime_type);	

			if ($img_mime_type == "image/gif") imagegif($resized_image);
			if ($img_mime_type == "image/png") imagepng($resized_image);
			if ($img_mime_type == "image/jpeg" || $img_mime_type == "image/pjpeg") imagejpeg($resized_image);
				
			$resized_image_bin = ob_get_contents();
			ob_end_clean();
			$img_data = $resized_image_bin;
		
		} else {
			$img_data = $img_data_raw;
            $standard_width = $img_width;
            $standard_width = $img_height;
		}

		$filename = $userfile['name'];
		
		if ((!$contentTypeSettings['thumbnail_width']) || (!$contentTypeSettings['thumbnail_height'])) {
			$thumb_width = 50;
			$thumb_height = 50;
		} else {
			$thumb_width = $contentTypeSettings['thumbnail_width'];
			$thumb_height = $contentTypeSettings['thumbnail_height'];
			
		}

		if (($img_width > $thumb_width) || ($img_height > $thumb_height)) {
			// Resize image
			list($thumb_width,$thumb_height) = resizeImage($img_width,$img_height,$thumb_width,$thumb_height);
				
			// Round it
			$thumb_width = (int)$thumb_width;
			$thumb_height = (int)$thumb_height;
		} else {
			// If image width is less than constraint then round the image instead.
			$thumb_width = (int)$img_width;
			$thumb_height = (int)$img_height;
		}						
		
		// Manipulate Image
		$resized_image = imagecreatetruecolor($thumb_width, $thumb_height);
								
		imagecopyresampled($resized_image, $image, 0, 0, 0, 0, $thumb_width, $thumb_height, $img_width, $img_height);
		
		ob_start();
		
		//header('Content-type: '.$img_mime_type);	
		
		if ($img_mime_type == "image/gif") imagegif($resized_image);
		if ($img_mime_type == "image/png") imagepng($resized_image);
		if ($img_mime_type == "image/jpeg" || $img_mime_type == "image/pjpeg") imagejpeg($resized_image);
			
		$resized_image_bin = ob_get_contents();
		ob_end_clean();
		$img_data_thumb = $resized_image_bin;

		$sql = "INSERT INTO " . DB_NAME_PREFIX . "images 
				SET content_item_id = " . $newid . ",
					content_item_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "', 
					content_item_version = 1,
					created_datetime = NOW(), 
					filename = '" . mysql_real_escape_string($filename = str_replace(" ","_",$filename)) . "', 
					mime_type = '" . mysql_real_escape_string($img_mime_type) . "',
					width = " . (int) $standard_width . ", 
					height = " . (int) $standard_height . ", 
					data = '" . mysql_real_escape_string($img_data) . "', 
					checksum = '" . mysql_real_escape_string($checksum = md5($img_data)) . "',
					checksum_inc_name = '" . mysql_real_escape_string(md5($filename. $checksum)) . "',
					thumbnail_data = '".mysql_real_escape_string($img_data_thumb)."',
					thumbnail_width = ". (int) $thumb_width.",
					thumbnail_height = ". (int) $thumb_height;
					
		$result = my_mysql_query($sql);

		$sql = "SELECT length(data), 
					length(thumbnail_data)
				FROM " . DB_NAME_PREFIX . "images
				WHERE content_item_id = " . $newid . "	
					AND content_item_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "'
					AND content_item_version = 1";
		
		$result = my_mysql_query($sql);
		
		$row = mysql_fetch_array($result);
		
		$sql = "UPDATE " . DB_NAME_PREFIX . "images
				SET size = " . $row[0] . ",
					thumbnail_size = " . $row[1] . "
				WHERE content_item_id = " . $newid . "	
					AND content_item_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "'
					AND content_item_version = 1";

		$result = my_mysql_query($sql);
		
		if ($caller=="") {
			$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems 
						SET content_id = " . $newid . ", 
						content_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "' , 
						language_id = '" . mysql_real_escape_string($language_id) . "'
						WHERE id = " . $menuid;
			
			$result = my_mysql_query($sql);
		}
		
		return true;
	
	} else {
		return $error;
	}
}









function createCTypeFile ($cID, $cVersion, $randomDir, $dimensions, &$newDimensions, $upscaleImagesIfNeeded = false) {
	$sql = "SELECT filename, 
				width, 
				height,
				mime_type
			FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;
	
	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		
		$path = CMS_ROOT . "tmp_downloads/" . $randomDir . "/" . $row['filename'];
		
		if (touch($path)) {			
			if ($picture_data = loadRawImage($cID, $cVersion)) {
				if ($dimensions) {
					
					//If $upscaleImagesIfNeeded is set, bloat the image size passed to the resizeImage algorithm
					//to make sure that it does fit the space
					$bloatToEnsureImageFitsTheSpace = $upscaleImagesIfNeeded? 10000 : 1;
					
					$newDimensions = resizeImage(
										$bloatToEnsureImageFitsTheSpace * $row['width'],
										$bloatToEnsureImageFitsTheSpace * $row['height'],
										$dimensions['width'],
										$dimensions['height']);
					
					$image = imagecreatefromstring($picture_data);
					// Manipulate Image
					$resized_image = imagecreatetruecolor($newDimensions[0], $newDimensions[1]);
											
					imagecopyresampled($resized_image, $image, 0, 0, 0, 0, $newDimensions[0], $newDimensions[1], $row['width'], $row['height']);
					
					ob_start();
					
					if ($row['mime_type'] == "image/gif") imagegif($resized_image);
					if ($row['mime_type'] == "image/png") imagepng($resized_image);
					if ($row['mime_type'] == "image/jpeg" || $row['mime_type'] == "image/pjpeg") imagejpeg($resized_image);
					$picture_data = ob_get_contents();
					ob_end_clean();					

					$newDimensions['width'] = (int) $newDimensions[0];
					$newDimensions['height'] = (int) $newDimensions[1];
				} else {
					$newDimensions = $row;
				}
				
				if (!$f = fopen($path,"w")) {
					return false;
				}
				
				if (!fwrite($f,$picture_data)) {
					return false;
				}
				
				if (!fclose($f)) {
					return false;
				}
				
				return $row[0];
			} else {
				return false;
			}
		} else {
			return false;
		}
	} else {
		return false;
	}

}

function importContent ($formInputs) {
	$siteConfig = loadSiteConfig();
	$contentTypeSettings = loadContentTypeSettings($GLOBALS['cType']);
	
	$fullpath = CMS_DROPBOX_DIR . "/" . SITENAME . "/" . $formInputs['current_file'];
	
	$formInputs['current_file'] = str_replace(" ","_",$formInputs['current_file']);
	
	$img_size_result = getimagesize($fullpath);

	if (is_array($img_size_result)) {
		$img_width = $img_size_result[0]; 
		$img_height = $img_size_result[1];
		$img_mime_type = $img_size_result['mime'];
	}

	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . " 
			SET filename = '" . mysql_real_escape_string($formInputs['current_file']) . "',
				mime_type = '" . mysql_real_escape_string($img_mime_type) . "',
				width = " . $img_width . ",
				height = " . $img_height . ",
				size = " . filesize($fullpath) . "
			WHERE id = " . $formInputs['cID'] . "
				AND version = " . $formInputs['cVersion'];

	$result = my_mysql_query($sql);

	$img_data_raw = file_get_contents($fullpath);

	$image = imagecreatefromstring($img_data_raw);
	
	if (function_exists(saveRawImage)) {
		saveRawImage($formInputs['cID'],$formInputs['cVersion'],$img_data_raw);
	}

	if ($contentTypeSettings['standard_width'] && $contentTypeSettings['standard_height']) {
		list($standard_width,$standard_height) = resizeImage($img_width,$img_height,$contentTypeSettings['standard_width'],$contentTypeSettings['standard_height']);
		
		$standard_width = (int) $standard_width;
		$standard_height = (int) $standard_height;

		// Manipulate Image
		$resized_image = imagecreatetruecolor($standard_width, $standard_height);
								
		imagecopyresampled($resized_image, $image, 0, 0, 0, 0, $standard_width, $standard_height, $img_width, $img_height);
		
		ob_start();
		
		//header('Content-type: '.$img_mime_type);	

		if ($img_mime_type == "image/gif") imagegif($resized_image);
		if ($img_mime_type == "image/png") imagepng($resized_image);
		if ($img_mime_type == "image/jpeg" || $img_mime_type == "image/pjpeg") imagejpeg($resized_image);
			
		$resized_image_bin = ob_get_contents();
		ob_end_clean();
		$img_data = $resized_image_bin;
	
	} else {
		$img_data = $img_data_raw;
		$standard_width = $img_width;
		$standard_height = $img_height;
	}

	if ((!$contentTypeSettings['thumbnail_width']) || (!$contentTypeSettings['thumbnail_height'])) {
		$thumb_width = 50;
		$thumb_height = 50;
	} else {
		$thumb_width = $contentTypeSettings['thumbnail_width'];
		$thumb_height = $contentTypeSettings['thumbnail_height'];
		
	}

	if (($img_width > $thumb_width) || ($img_height > $thumb_height)) {
		// Resize image
		list($thumb_width,$thumb_height) = resizeImage($img_width,$img_height,$thumb_width,$thumb_height);
			
		// Round it
		$thumb_width = (int)$thumb_width;
		$thumb_height = (int)$thumb_height;
	} else {
		// If image width is less than constraint then round the image instead.
		$thumb_width = (int)$img_width;
		$thumb_height = (int)$img_height;
	}						
	
	// Manipulate Image
	$resized_image = imagecreatetruecolor($thumb_width, $thumb_height);
							
	imagecopyresampled($resized_image, $image, 0, 0, 0, 0, $thumb_width, $thumb_height, $img_width, $img_height);
	
	ob_start();
	
	//header('Content-type: '.$img_mime_type);	
	
	if ($img_mime_type == "image/gif") imagegif($resized_image);
	if ($img_mime_type == "image/png") imagepng($resized_image);
	if ($img_mime_type == "image/jpeg" || $img_mime_type == "image/pjpeg") imagejpeg($resized_image);
		
	$resized_image_bin = ob_get_contents();
	ob_end_clean();
	$img_data_thumb = $resized_image_bin;

	$sql = "UPDATE " . DB_NAME_PREFIX . "images
			SET sticky_flag = 0
			WHERE content_item_id = " . $formInputs['cID'] . "	
				AND content_item_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "'
				AND content_item_version = " . $formInputs['cVersion'];
				
	$result = my_mysql_query($sql);

	$sql = "REPLACE INTO " . DB_NAME_PREFIX . "images 
			SET content_item_id = " . $formInputs['cID'] . ",
				content_item_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "', 
				content_item_version = " . $formInputs['cVersion'] . ",
				created_datetime = NOW(), 
				filename = '" . mysql_real_escape_string($filename = $formInputs['current_file']) . "', 
				mime_type = '" . mysql_real_escape_string($img_mime_type) . "',
				width = " . (int) $standard_width . ", 
				height = " . (int) $standard_height . ", 
				data = '" . mysql_real_escape_string($img_data) . "', 
				checksum = '" . mysql_real_escape_string($checksum = md5($img_data)) . "',
				checksum_inc_name = '" . mysql_real_escape_string(md5($filename. $checksum)) . "',
				thumbnail_data = '" . mysql_real_escape_string($img_data_thumb) . "',
				thumbnail_width = ". (int) $thumb_width.",
				thumbnail_height = ". (int) $thumb_height . ",
				sticky_flag = 1";

$storekeeper_width_constraint = 70;
$storekeeper_height_constraint = 70;


if (($img_width  > $storekeeper_width_constraint) || ($img_height  > $storekeeper_height_constraint)) {
	// Resize image
	list($storekeeper_width,$storekeeper_height) = resizeImage($img_width ,$img_height,$storekeeper_width_constraint,$storekeeper_height_constraint);
		
	// Round it
	$storekeeper_width = (int)$storekeeper_width;
	$storekeeper_height = (int)$storekeeper_height;
} else {
	// If image width is less than constraint then round the image instead.
	$storekeeper_width = (int)$img_width ;
	$storekeeper_height = (int)$img_height;
}


// Manipulate Image
$imageResource = imagecreatefromstring($img_data_raw);
$resized_image = imagecreatetruecolor($storekeeper_width, $storekeeper_height);
imagecopyresampled($resized_image, $imageResource, 0, 0, 0, 0, $storekeeper_width, $storekeeper_height, $img_width, $img_height);
						

ob_start();
	if ($img_mime_type == "image/gif") imagegif($resized_image);
	if ($img_mime_type == "image/png") imagepng($resized_image);
	if ($img_mime_type == "image/jpeg" || $img_mime_type == "image/pjpeg") imagejpeg($resized_image);
	$img_data_thumb = ob_get_contents();
ob_end_clean();


			$sql .= ",
				storekeeper_width = " . $storekeeper_width . ",
				storekeeper_height = " . $storekeeper_height . ",
				storekeeper_data = '" . mysql_real_escape_string($img_data_thumb) . "'";

				
	$result = my_mysql_query($sql);

	$sql = "SELECT length(data), 
				length(thumbnail_data)
			FROM " . DB_NAME_PREFIX . "images
			WHERE content_item_id = " . $formInputs['cID'] . "	
				AND content_item_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "'
				AND content_item_version = " . $formInputs['cVersion'];
	
	$result = my_mysql_query($sql);
	
	$row = mysql_fetch_array($result);
	
	$sql = "UPDATE " . DB_NAME_PREFIX . "images
			SET size = " . $row[0] . ",
				thumbnail_size = " . $row[1] . "
			WHERE content_item_id = " . $formInputs['cID'] . "	
				AND content_item_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "'
				AND content_item_version = " . $formInputs['cVersion'];

	$result = my_mysql_query($sql);
	
	unlink($fullpath);
}

function validateDropbox($data) {
	$error = array();
	
	if (!$data['selected_file']) {
		$error[] = getPhrase("Please select an image.");
	} else {
		if (!$img_size_result = getimagesize(CMS_DROPBOX_DIR . "/" . SITENAME . "/" . $data['selected_file'])) {
			$error[] = getPhrase("Please select a valid image.");
		} elseif ($img_size_result['mime'] != 'image/gif' && $img_size_result['mime'] != 'image/png'
			   && $img_size_result['mime'] != 'image/jpeg' && $img_size_result['mime'] != 'image/pjpeg') {
			$error[] = getPhrase("Please select a GIF, JPEG or PNG image.");
		}
	}
	
	return Array('valid' => empty($error), 'errArray' => $error);
}

/* Raw Store */

function saveRawImage ($cID, $cVersion, $data) {
	$sql = "REPLACE INTO " . DB_NAME_PREFIX . "raw_picture_store
			SELECT " . (int) $cID . " AS content_id,
				" . (int) $cVersion . " AS content_version,
				'" . mysql_real_escape_string($data) . "' AS data";
	
	$result = my_mysql_query($sql);
}

function loadRawImage ($cID, $cVersion) {
	$sql = "SELECT data
			FROM " . DB_NAME_PREFIX . "raw_picture_store
			WHERE content_id = " . (int) $cID . "
				AND content_version = " . (int) $cVersion;
			
	$result = my_mysql_query($sql);	
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		
		return $row[0];
	} else {
		return false;
	}
}

function createNewVersion ($cID,$oldVersion,$newVersion, $newCID = false) {
	
	if ($newCID === false) {
		$newCID = $cID;
	}
	
	$sql = "
			INSERT INTO " . DB_NAME_PREFIX . "raw_picture_store(
				content_id,
				content_version,
				data
			)
			SELECT
				" . (int) $newCID . ",
				" . (int) $newVersion . ",
				data
			FROM " . DB_NAME_PREFIX . "raw_picture_store
			WHERE content_id = " . (int) $cID . "
				AND content_version = " . (int) $oldVersion;
				
	$result = my_mysql_query($sql);
				
}

function deleteRawVersion($cID, $cVersion, $deleteDirectories=false) {
	$sql = "DELETE
			FROM " . DB_NAME_PREFIX . "raw_picture_store
			WHERE content_id = " . (int) $cID . "
				AND content_version = " . (int) $cVersion;

	$result = my_mysql_query($sql);	
}

?>