<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


class tribiq_cms_core extends plugin_base_class {
	
	
	public static $signalsCurrentlyTriggered = array();
	public static $importantGetRequests = array();
	public static $pageTitle = false;
	public static $menuTitle = false;
	public static $pluginJS = '';
	public static $pluginPossibleThemes = '';
	
	public function includeContentType($cType) {
		if ($cType == 'document') {
			$this->cTypeDocument();
		} elseif ($cType == 'html') {
			$this->cTypeHTML();
		} elseif ($cType == 'news') {
			$this->cTypeNews();
		} elseif ($cType == 'picture') {
			$this->cTypePicture();
		} elseif ($cType == 'video') {
			$this->cTypeVideo();
		} elseif ($cType == 'blog') {
			$this->cTypeBlog();
		} elseif ($cType == 'event') {
			$this->cTypeEvent();
		} else {
			return false;
		}
		return true;
	}
	
	private function cTypeHTML() {
		require_once $this->absPluginDir(). 'ctypes/html.inc.php';
	}
	
	private function cTypeDocument() {
		require_once $this->absPluginDir(). 'ctypes/document.inc.php';
		
	}
	
	private function cTypeNews() {
		require_once $this->absPluginDir(). 'ctypes/news.inc.php';
		
	}
	
	private function cTypePicture() {
		require_once $this->absPluginDir(). 'ctypes/picture.inc.php';
		
	}

	private function cTypeBlog() {
		require_once $this->absPluginDir(). 'ctypes/blog.inc.php';
		
	}	

	private function cTypeEvent() {
		require_once $this->absPluginDir(). 'ctypes/event.inc.php';
		
	}		
	
	//Direct the user to the homepage, when they've not specified what page they want
	public static function directUserToHomepage(&$siteConfig) {
		if ($siteConfig['default_homepage_id']) {
			return $siteConfig['default_homepage_id'];
		} else {
			return 1;
		}
	}
	
	
	//Get a sticky image, if it has been set for a content item
	public function getContentStickyImage($cID, $cType, $cVersion = false) {
		
		if (!$cVersion) {
			$cVersion = getShowableVersion($cID, $cType);
		}
		
		$sql = "SELECT filename
				FROM " . DB_NAME_PREFIX . "images
				WHERE content_item_id = " . (int) $cID . "
					AND content_item_version = " . (int) $cVersion . "
					AND content_item_type = '" . mysql_real_escape_string($cType) . "'
					AND sticky_flag = 1";
					
		$result = my_mysql_query($sql);
		
		if (mysql_num_rows($result)>0) {
			$row = mysql_fetch_array($result);
			
			$imgURL = "cmsincludes/image.php?cID=" . $cID . "&cType=" . $cType . "&cVersion=" . $cVersion . "&filename=" . rawurlencode($row['0']);
			
			return $imgURL;
		} else {
			return false;
		}
	}

	/*
	Menu Structure
	
	The following function is used to generate all cms based list style menus on the site.  The following parameters
	should be documented for the user/designer:
	
	$parent_id:		This is the point on the menu tree that the function will start generating the list from
					The default is 0 or false and will display the entire tree
	$num_levels:	The number of levels the function will display beneath the starting point.
					The default is 0 or false and will display all levels of menu tree
	$cLanguage:		Used to specify which language menu should be returned
					Default is to use the default specified by the database
	
	*/
	
	public static function getMenuStructure(
		$sectionId = "Main",
		$currentMenuId = false,
		$parentMenuId = 0,
		$numLevels = 0,
		$maxLevel1MenuItems = 100,
		$language = false,
		$onlyFollowOnLinks = false,
		$onlyIncludeOnLinks = false,
		$showAdminAddMenuItem = true,
		$showInvisibleMenuItems = false,
		$recurseCount = 0,
		$siteConfig = false
	) {
		
		if ($language === false) {
			$language = $_SESSION['user_lang']? $_SESSION['user_lang'] : DEFAULT_LANGUAGE;
		}
		$menus = false;
		
		if (++$recurseCount == 1) {
			$level1counter = 0;
		}
		
		if (!$siteConfig) {
			$siteConfig = array();
			$siteConfig['mod_rewrite_enabled'] = getSiteConfig('mod_rewrite_enabled');
			$siteConfig['mod_rewrite_suffix'] = getSiteConfig('mod_rewrite_suffix');
		}
	
		if (checkPriv()) {
			if (!checkLanguageExists($language)) {
				return false;
			}
		}
		
		$result = cms_core::lookForMenuItems($parentMenuId, $language, $sectionId, $currentMenuId, $recurseCount, $showInvisibleMenuItems);
		while ($row = mysql_fetch_assoc($result)) {
	
			if ($recurseCount==1) {
				$level1counter++;
			}
	
			if (checkPriv()) {
				$showMenuItem = true;
			} elseif ($row['target_loc'] == 'int' && $row['hide_private_item'] == 3) {
				$showMenuItem = issetArrayKey($_SESSION, 'extranetUserID');
			} elseif ($row['target_loc'] == 'int' && $row['hide_private_item'] == 2) {
				$showMenuItem = !issetArrayKey($_SESSION, 'extranetUserID');
			} elseif ($row['target_loc'] == 'int' && $row['hide_private_item']) {
				$showMenuItem = (bool) getShowableVersion($row['content_id'], $row['content_type'], false, false, arrayKey($_SESSION, 'extranetUserID'));
			} else {
				$showMenuItem = true;
			}
	
			if ($showMenuItem) {
				
				cms_core::getMenuItemURL($row, $hideFromVisitors, $gateway, $siteConfig);
	
				if ($row['accesskey'] != "") {
					$row['title'] = getPhrase('_ACCESS_KEY_EQUALS', array('key' => $row['accesskey']));
				}
	
				if ($row['open_in_new_window']) {
					$row['target'] = '_blank';
				}
				
				if (!$hideFromVisitors || checkPriv()) {
					$row['on'] = $currentMenuId == $row['id'] || isMenuItemAncestor($currentMenuId, $row['id']);
		
					if ((!$numLevels || $recurseCount < $numLevels) && !$gateway && (!$onlyFollowOnLinks || $row['on'])) {
						$row['children'] = cms_core::getMenuStructure(
												$sectionId, $currentMenuId, $row['id'],
												$numLevels, $maxLevel1MenuItems, $language,
												$onlyFollowOnLinks, $onlyIncludeOnLinks,
												$showAdminAddMenuItem, $showInvisibleMenuItems, 
												$recurseCount, $siteConfig);
						
					} else {
						$row['children'] = hasChild($row['id'], $sectionId, (bool) checkPriv());
					}
					
					if (!$onlyIncludeOnLinks || $row['on']) {
						$menus[] = $row;
					}
				}
				
				if ($recurseCount==1) {
					if ($level1counter >= $maxLevel1MenuItems) {
						break;
					}
				}
			}
		}
		
		if (
			checkPriv("_PRIV_ADD_MENU_ITEM") && $showAdminAddMenuItem
			&& ($parentMenuId || $level1counter < $maxLevel1MenuItems)
		) {
			$tooltip =
				$parentMenuId?
					getPhrase("_LOWER_LEVEL_MENU_TOOLTIP", array('section' => htmlspecialchars($sectionId), 'menuitem' => htmlspecialchars(getMenuName($parentMenuId))))
				:
					getPhrase("_TOP_LEVEL_MENU_TOOLTIP", array('section' => htmlspecialchars($sectionId)));
				
			$menus[] = array(
				'url' => '#',
				'is_admin_add_menu_item' => true,
				'onclick' => "tribiqAFB.open('', 'tb/". (checkPriv('_PRIV_CREATE_FIRST_DRAFT')? 'quick_menu' : 'menu'). ".php?content_type=html&parent_id=". $parentMenuId. "&section_id=". $sectionId. "&language_id=". $language. "');",
				'img' => '<img src="admin/images/slots/add_menu_icon.gif" class="pluginAdminButton" alt="'. getPhrase('_ADD'). '" border="0" 
							title="'. $tooltip. '" />'
				);
		}
	
		if ($recurseCount>1000) {
			echo "Aborting; Menu Generation seems to be in an infinite recursion loop!";
			exit;
		}
	
		return $menus;
	}
	
	protected static function getMenuItemURL(&$row, &$hideFromVisitors, &$gateway, &$siteConfig) {
		
		$editMenuItem = false;
		if ($row['target_loc'] == 'ext' && $row['ext_url']) {
			$row['url'] = $row['ext_url'];
				
		} else if ($row['target_loc'] == 'int' && $row['content_id']) {
			//Check if this is the primary menu item
			if (checkPriv()) {
				$thisContentItemsPrimaryMenu = getMenuItemFromContent($row['content_id'], $row['content_type']);
			}
			
			global $cID, $cType;
			
			$overwriteMenuTitle = $cID == $row['content_id'] && $cType == $row['content_type'] && cms_core::$menuTitle !== false;
			
			//For secondary menu items, link to the menu item and not the content item in admin mode
			if (checkPriv() && $row['id'] != $thisContentItemsPrimaryMenu['id']) {
				$row['url'] = SUBDIRECTORY . indexDotPHP(). "?mID=" . $row['id'];
				$editMenuItem = true;
				
			} else {
				if ($row['html_content_alias'] && !checkPriv()) {
					$cIDorAlias = $row['html_content_alias'];
				} else {
					$cIDorAlias = $row['content_id'];
				}
				
				$row['url'] = htmlspecialchars(linkToItem($cIDorAlias, $row['content_type'], $siteConfig, '', '', false));
			}
			
			if ($overwriteMenuTitle) {
				$row['name'] = htmlspecialchars(cms_core::$menuTitle);
			}

		} else {
			if (checkPriv()) {
				$row['url'] = '#';
				$editMenuItem = true;
			}
		}
		
		if ($editMenuItem) {
			$row['onclick'] = "if (tribiqA.pageMode == 'preview') return true; tribiqAFB.open('core', 'menu', {mID: ". (int)  $row['id']. "}); return false;";
		}
		
		$hideFromVisitors = false;
		$gateway = false;
	}
	
	protected static function lookForMenuItems(&$parentMenuId, &$language, &$sectionId, &$currentMenuId, &$recurseCount, $showInvisibleMenuItems) {
	
		$sql = "SELECT id,
					name,
					target_loc,
					open_in_new_window,
					content_id,
					html_content_alias,
					content_type,
					hide_private_item,
					ext_url,
					active,
					invisible,
					mode,
					accesskey,
					ordinal,
					rel_tag
				FROM " .DB_NAME_PREFIX . "menuitems AS i
				LEFT JOIN ".DB_NAME_PREFIX."menu_sections AS s
				   ON s.section_name = i.section_id
				LEFT JOIN ".DB_NAME_PREFIX."contenttypes AS t
				   ON i.content_type = t.content_type_id
				WHERE i.parent_id = ". (int) $parentMenuId. "
				  AND i.language_id = '". mysql_real_escape_string($language). "'
				  AND s.section_name = '". mysql_real_escape_string($sectionId). "'";
	
		if (!checkPriv()) {
			$sql .= " AND active>0";
		}
	
		$sql .= " ORDER BY ordinal";
		
		return my_mysql_query($sql);
	}

	



	
	static function createContentItem ($cType,$data) {
		if (!checkAdminPriv($data['adminId'],$data['adminAuthType'],"_PRIV_CREATE_FIRST_DRAFT")) {
			$errors[] = "_ERR_CONTRIBUTION_ADMIN_INSUFFICIENT_RIGHTS";
		}	

		if (!$data['title']) {
			$errors[] = "_ERR_YOU_MUST_ENTER_A_TITLE";
		}
		
		if ($errors) {
			return array("newId" => false, "sql" => false, "errors" => $errors);
		}
		
		$newId = (getLatestContentID($cType) + 1);
		
		if (!$data['template_id']) {
			$contentTypes = getContentTypes($cType);
			
			$data['template_id'] = $contentTypes[0]['default_template_id'];
		}
		
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($cType) . "
				SET id = " . (int) $newId . ",
					version = 1,
					title = '" . mysql_real_escape_string($data['title']) . "',
					language_id = '" . mysql_real_escape_string($data['languageId']) . "',
					status = 'private_draft',
					owner_id = " . (int) $data['adminId'] . ",
					owner_authtype = '" . mysql_real_escape_string($data['adminAuthType']) . "',
					creating_author_id = " . (int) $data['adminId'] . ",
					creating_author_authtype = '" . mysql_real_escape_string($data['adminAuthType']) . "',
					created_datetime = NOW(),
					last_author_id = " . (int) $data['adminId'] . ",
					last_author_authtype = '" . mysql_real_escape_string($data['adminAuthType']) . "',
					template_id = " . (int) $data['template_id'];
					
		
		return array("newId" => $newId, "sql" => $sql, "errors" => false);
	}
	
	
	static function createEvent ($data) {
		$creationResult = self::createContentItem("event",$data);
	
		if ($creationResult['errors']) {
			return $creationResult['errors'];
		}

		if ($data['specifyTime']) {
			if (!$data['startTime']) {
				$errors[] = "_ERR_NO_START_TIME";
			}
			
			if (strtotime($data['endTime'])<strtotime($data['startTime'])) {
				$errors[] = "_ERR_ENDTIME_LESS_THAN_STARTTIME";
			}
		}
		
		if ($errors) {
			return $errors;
		}
		
		$sql .= $creationResult['sql'] . ",
					content_bodytop = '" . mysql_real_escape_string($data['summary']) . "',";
					
		if ($data['startDate']) {
			$sql .= "start_date = '" . mysql_real_escape_string($data['startDate']) . "',";
		}					
		if ($data['endDate']) {
			$sql .= "end_date = '" . mysql_real_escape_string($data['endDate']) . "',";
		}
		
		if ($data['startTime']) {
			$sql .= "start_time = '" . mysql_real_escape_string($data['startTime']) . "',";
		}
		
		if ($data['endTime']) {
			$sql .= "end_time = '" . mysql_real_escape_string($data['endTime']) . "',";
		}
		
		$sql .= "location_name = '" . mysql_real_escape_string($data['locationName']) . "',
					location_address1 = '" . mysql_real_escape_string($data['locationAddress1']) . "',
					location_address2 = '" . mysql_real_escape_string($data['locationAddress2']) . "',
					location_city = '" . mysql_real_escape_string($data['locationCity']) . "',
					location_state = '" . mysql_real_escape_string($data['locationState']) . "',
					location_postcode = '" . mysql_real_escape_string($data['locationPostcode']) . "',
					location_country_id = '" . mysql_real_escape_string($data['locationCountryId']) . "',
					specify_time = " . (int) $data['specifyTime'];
					
		$result = my_mysql_query($sql);
		
		return $creationResult['newId'];
	}
	
	static function createHTML ($data) {
		$creationResult = self::createContentItem("html",$data);
	
		if ($creationResult['errors']) {
			return $creationResult['errors'];
		}
		
		$sql .= $creationResult['sql'];
		if ($data['alias']){
			$sql .= ",alias='" . mysql_real_escape_string($data['alias']) ."'";
		}
		
		if ($data['content_bodytop']){
			$sql .= ",content_bodytop='" . mysql_real_escape_string($data['content_bodytop']) ."'";
		}

		if ($data['content_bodymain']){
			$sql .= ",content_bodymain='" . mysql_real_escape_string($data['content_bodymain']) ."'";
		}
		
		$result = my_mysql_query($sql);
		return $creationResult['newId'];
	}
	
	
	/*	Pagination  */
	
	public function pagSelectList($currentPage, &$pages, &$html) {
		
		$html = '
			<select onChange="eval(this.value);" class="pagination">';
			
		foreach($pages as $page => &$params) {
			$html .= '
				<option '. ($currentPage == $page? 'selected="selected"' : ''). '" value="'.
					$this->refreshPluginSlotJS($params).
				'">'.
					htmlspecialchars($page).
				'</options>';
		}
			
		$html .= '
			</select>';
	}
	
	
	
	public function pagCurrentWithNP($currentPage, &$pages, &$html) {
		$this->pageNumbers($currentPage, $pages, $html, 'Current', $showNextPrev = true, $showFirstLast = false, $alwaysShowNextPrev = true);
	}
	
	public function pagCurrentWithFNPL($currentPage, &$pages, &$html) {
		$this->pageNumbers($currentPage, $pages, $html, 'Current', $showNextPrev = true, $showFirstLast = true, $alwaysShowNextPrev = true);
	}
	
	public function pagAll($currentPage, &$pages, &$html) {
		$this->pageNumbers($currentPage, $pages, $html, 'All', $showNextPrev = false, $showFirstLast = false, $alwaysShowNextPrev = false);
	}
	
	public function pagAllWithNPIfNeeded($currentPage, &$pages, &$html) {
		$this->pageNumbers($currentPage, $pages, $html, 'All', $showNextPrev = true, $showFirstLast = false, $alwaysShowNextPrev = false);
	}
	
	public function pagCloseWithNPIfNeeded($currentPage, &$pages, &$html) {
		$this->pageNumbers($currentPage, $pages, $html, 'Close', $showNextPrev = true, $showFirstLast = false, $alwaysShowNextPrev = false);
	}
	
	public function pagCloseWithNP($currentPage, &$pages, &$html) {
		$this->pageNumbers($currentPage, $pages, $html, 'Close', $showNextPrev = true, $showFirstLast = false, $alwaysShowNextPrev = true);
	}
	
	public function pagCloseWithFNPLIfNeeded($currentPage, &$pages, &$html) {
		$this->pageNumbers($currentPage, $pages, $html, 'Close', $showNextPrev = true, $showFirstLast = true, $alwaysShowNextPrev = false);
	}
	
	public function pagCloseWithFNPL($currentPage, &$pages, &$html) {
		$this->pageNumbers($currentPage, $pages, $html, 'Close', $showNextPrev = true, $showFirstLast = true, $alwaysShowNextPrev = true);
	}
	
	
	
	protected function drawPageLink($floatingBoxNo, $page, $params, $current = false, $css = 'pag_page') {
		return '
			<span class="'. $css. ($current? '_on' : ''). '"><span>
				<a '. ($params? $this->refreshPluginSlotAnchor($params) : ''). '>'.
					$page.
				'</a>
			</span></span>';
	
	}
		
	protected function pageNumbers($currentPage, &$pages, &$html, $pageNumbers = 'Close', $showNextPrev = true, $showFirstLast = true, $alwaysShowNextPrev = false) {
		
		$html = '
			<div class="pag_pagination">';
		
		//Find the total number of pages
		$count = count($pages);
		
		//Don't output anything if there is only one page!
		if ($count > 1) {
			//Pages might not be numberic, so get something that is to work with
			$pagesPos = array_keys($pages);
			$currentPos = (int) array_search($currentPage, $pagesPos);
			
			
			if ($showFirstLast && $currentPos > ($showNextPrev? 1 : 0)) {
				$html .= $this->drawPageLink($floatingBoxNo, $this->phrase('_FIRST'), $pages[$pagesPos[0]], false, 'pag_first');
			}
			
			if ($showNextPrev && $currentPos > 0) {
				$html .= $this->drawPageLink($floatingBoxNo, $this->phrase('_PREV'), $pages[$pagesPos[$currentPos-1]], false, 'pag_prev');
			} elseif ($showNextPrev && $alwaysShowNextPrev) {
				$html .= $this->drawPageLink($floatingBoxNo, $this->phrase('_PREV'), '', true, 'pag_prev');
			}
			
			
			if ($pageNumbers == 'Current') {
				$html .= $this->drawPageLink($floatingBoxNo, $page = $pagesPos[$currentPos], $pages[$page], true);
				
			} elseif ($pageNumbers == 'All') {
				foreach($pages as $page => &$params) {
					$html .= $this->drawPageLink($floatingBoxNo, $page, $params, $currentPage == $page);
				}
				
			} elseif ($pageNumbers == 'Close') {
				//Check if each is there, and include it if so
				for ($pos = $currentPos - 4; $pos <= $currentPos + 4; ++$pos) {
					if (isset($pagesPos[$pos])) {
						$html .= $this->drawPageLink($floatingBoxNo, $page = $pagesPos[$pos], $pages[$page], $currentPos == $pos);
					}
				}
				
			} elseif ($pageNumbers == 'Smart') {
				$this->smartPageNumbers($floatingBoxNo, $currentPos, $count, $showFirstLast, $pagesPos, $pages, $html);
			}
			
			
			if ($showNextPrev && $currentPos < $count - 1) {
				$html .= $this->drawPageLink($floatingBoxNo, $this->phrase('_NEXT'), $pages[$pagesPos[$currentPos+1]], false, 'pag_next');
			} elseif ($showNextPrev && $alwaysShowNextPrev) {
				$html .= $this->drawPageLink($floatingBoxNo, $this->phrase('_NEXT'), '', true, 'pag_next');
			}
			
			if ($showFirstLast && $currentPos < $count - ($showNextPrev? 2 : 1)) {
				$html .= $this->drawPageLink($floatingBoxNo, $this->phrase('_LAST'), $pages[$pagesPos[$count-1]], false, 'pag_last');
			}
		}
		
		
		$html .= '
			</div>';
	}
	
	
	static function poweredBy() {
		echo '<a href="http://tribiq.com">Powered by Tribiq CMS</a>';
	}

	public function getCategories ($id = false) {
		$sql = "SELECT id,
					parent_id,
					name,
					public,
					landing_page_content_id,
					landing_page_content_type
				FROM " . DB_NAME_PREFIX . "categories";
		
		if ($id) {
			$sql .= " WHERE id = ". (int) $id;
		} else {
			$sql .= " ORDER BY name";
		}
	
		$result = my_mysql_query($sql);
		
		if (mysql_num_rows($result)>0) {
			while ($row = mysql_fetch_array($result)) {
				$categories[] = $row;			
			}

			return $categories;
		} else {
			return false;
		}	
	}
	
	public function getCategoryNames ($id = false, $parentId = false) {
		$sql = "SELECT id,
					name
				FROM " . DB_NAME_PREFIX . "categories";
		
		if ($id) {
			$sql .= " WHERE id = ". (int) $id;
		} elseif (isset($parentId)) {
			$sql .= " WHERE parent_id = ". (int) $parentId;
		}
		
		$sql .= " ORDER BY name";
	
		$result = my_mysql_query($sql);
		
		if (mysql_num_rows($result)>0) {
			while ($row = mysql_fetch_array($result)) {
				$categories[$row['id']] = $row['name'];			
			}

			return $categories;
		} else {
			return false;
		}	
	}
	
	public static function getEditionName() {
		return 'Community';
	}
	public static function getLicenseName() {
		return 'GPL';
	}
	public static function getSKBannerPath() {
		return 'plugins/tribiq_cms_core_v1/storekeeper/banner.gif';
	}
	
	
	
	
	//
	//	Admin functions
	//
	
	
	public static function duplicateContentLoadDetails($cID, $cType, $cVersion, &$currentTitle, &$currentLang, &$currentAlias, &$currentMenu, &$languages) {
		return require 'plugins/tribiq_cms_core_v1/admin/duplicateContentLoadDetails.fun.php';
	}
	
	public static function setContentItemCategories($cID,$cType,$cVersion,$categories) {
		
		$sql = "DELETE
				FROM " . DB_NAME_PREFIX . "category_item_link
				WHERE item_id = " . (int) $cID . "
					AND content_type = '" . mysql_real_escape_string($cType) . "'
					AND version = " . (int) $cVersion;
		
		$result = my_mysql_query($sql);
		
		if (is_array($categories)) {
			foreach ($categories as $category) {
				$category = (int) $category;
				
				$sql = "INSERT INTO " . DB_NAME_PREFIX . "category_item_link
						SET category_id = " . $category . ",
							item_id = " . (int) $cID . ",
							content_type = '" . mysql_real_escape_string($cType) . "',
							version = " . (int) $cVersion;
				
				$result = my_mysql_query($sql);
			}
		}
	}
	
	
	public function publishContent($cID, $cType, $cVersion, $prev_version, $adminId = false, $adminType = false) {
		deleteArchive($cID, $cType, $prev_version);
	}


	public function handleAJAX() {
		return require 'plugins/tribiq_cms_core_v1/admin/handleAJAX.fun.php';
	}



	public function setAdminFloatingBoxPrimaryKey($floatingBoxName, &$primaryKey) {
		return require 'plugins/tribiq_cms_core_v1/admin/setAdminFloatingBoxPrimaryKey.fun.php';
	}
	
	public function setAdminFloatingBoxTitleAndValidatePrimaryKey($floatingBoxName, &$primaryKey, &$title) {
		return require 'plugins/tribiq_cms_core_v1/admin/setAdminFloatingBoxTitleAndValidatePrimaryKey.fun.php';
	}

	public function showAdminFloatingBoxTab($targetClassName, $floatingBoxName, $tabLabel, $primaryKey, $editMode, &$showEditButton) {
		if ($floatingBoxName=="Categories" && $tabLabel=="Settings") {
			require 'plugins/tribiq_cms_core_v1/admin/showCategorySettingsFB.fun.php';
		
		} elseif ($floatingBoxName=="Content" && $tabLabel=="Categories") {
			require 'plugins/tribiq_cms_core_v1/admin/showCategoriesFB.fun.php';
		
		} elseif ($floatingBoxName=="Administrator" && $tabLabel=="Permissions") {
			require 'plugins/tribiq_cms_core_v1/admin/showAdminPermsFB.fun.php';
		
		} elseif ($floatingBoxName=='Duplicate Content' && $tabLabel=='Duplicate Content') {
			require 'plugins/tribiq_cms_core_v1/admin/showDuplicateContentFB.fun.php';
		
		} elseif ($floatingBoxName=='Spare Domain Name' && $tabLabel=='Spare Domain Name') {
			require 'plugins/tribiq_cms_core_v1/admin/showSpareURLFB.fun.php';
		
		} elseif ($floatingBoxName=='Create Language Pack' && $tabLabel=='Details') {
			require 'plugins/tribiq_cms_core_v1/admin/showCreateVLPFB.fun.php';
		}
	}
	
	public function validateAdminFloatingBoxTab($targetClassName, $floatingBoxName, $tabLabel, $primaryKey) {
		if ($floatingBoxName=="Categories" && $tabLabel=="Settings") {
			require 'plugins/tribiq_cms_core_v1/admin/validateCategory.fun.php';
		
		} elseif ($floatingBoxName=='Duplicate Content' && $tabLabel=='Duplicate Content') {
			require 'plugins/tribiq_cms_core_v1/admin/validateDuplicateContentFB.fun.php';
		
		} elseif ($floatingBoxName=='Spare Domain Name' && $tabLabel=='Spare Domain Name') {
			require 'plugins/tribiq_cms_core_v1/admin/validateSpareURLFB.fun.php';
		
		} elseif ($floatingBoxName=='Create Language Pack' && $tabLabel=='Details') {
			require 'plugins/tribiq_cms_core_v1/admin/validateCreateVLPFB.fun.php';
		
		} else {
			echo json_encode(array('valid' => true, 'errArray' => array()));
		}
	}
	
	public function fillAdminBox($path, &$box) {
		require 'plugins/tribiq_cms_core_v1/admin/fillAdminBox.fun.php';
	}
	
	public function formatAdminBox($path, &$box, $definition, $values) {
		require 'plugins/tribiq_cms_core_v1/admin/formatAdminBox.fun.php';
	}
	
	public function validateAdminBox($path, &$box, $definition, $values) {
		require 'plugins/tribiq_cms_core_v1/admin/validateAdminBox.fun.php';
	}
	
	public function quickValidateAdminBox($path, $tab, $values, &$rowClasses, &$snippets) {
		require 'plugins/tribiq_cms_core_v1/admin/quickValidateAdminBox.fun.php';
	}
	
	public function saveAdminBox($path, &$box, $definition, $values) {
		require 'plugins/tribiq_cms_core_v1/admin/saveAdminBox.fun.php';
	}

	
	public function saveAdminFloatingBoxTab($targetClassName, $floatingBoxName, $tabLabel, $primaryKey) {
		if ($floatingBoxName=="Categories" && $tabLabel=="Settings") {
			require 'plugins/tribiq_cms_core_v1/admin/saveCategorySettingsFB.fun.php';
		
		} elseif ($floatingBoxName=="Content" && $tabLabel=="Categories" && checkPriv('_PRIV_EDIT_ITEM_CATEGORIES')) {
			cms_core::setContentItemCategories($this->postVariables['cID'], $this->postVariables['cType'], $this->postVariables['cVersion'],explode(",",$this->postVariables['selected_items']));
			json_encode(array());
		
		} elseif ($floatingBoxName=="Administrator" && $tabLabel=="Permissions") {
			if (!checkPriv('_PRIV_EDIT_ADMIN') || !($primaryKey['adminType'] == 'local' || $_SESSION["admin_authtype"] == 'super')) {
				exit;
			}
			saveAdmin($_POST, $primaryKey['adminId'], $primaryKey['adminType']);
			echo json_encode(array());
		
		} elseif ($floatingBoxName=='Duplicate Content' && $tabLabel=='Duplicate Content') {
			require 'plugins/tribiq_cms_core_v1/admin/saveDuplicateContentFB.fun.php';
		
		} elseif ($floatingBoxName=='Spare Domain Name' && $tabLabel=='Spare Domain Name') {
			require 'plugins/tribiq_cms_core_v1/admin/saveSpareURLFB.fun.php';
		
		} elseif ($floatingBoxName=='Create Language Pack' && $tabLabel=='Details') {
			require 'plugins/tribiq_cms_core_v1/admin/saveCreateVLPFB.fun.php';
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	//
	//	Storekeeper functions
	//
	
	public function lineStorekeeper($path, &$panel, $refinerName, $refinerId, $selectMode, $isXML) {
		return require 'plugins/tribiq_cms_core_v1/admin/lineStorekeeper.fun.php';
	}
	
	public function fillStorekeeper($path, &$panel, $refinerName, $refinerId, $selectMode, $isXML) {
		return require 'plugins/tribiq_cms_core_v1/admin/fillStorekeeper.fun.php';
	}
	
	public function storekeeperAJAX($path, $ids, $ids2, $refinerName, $refinerId) {
		return require 'plugins/tribiq_cms_core_v1/admin/storekeeperAJAX.fun.php';
	}
	
	public function storekeeperDownload($path, $ids, $refinerName, $refinerId) {
		return require 'plugins/tribiq_cms_core_v1/admin/storekeeperDownload.fun.php';
	}
	
	public static $configSettings;
	public static function configSetting($configSetting, $value) {
		cms_core::$configSettings[$configSetting] = $value;
	}
	
	//Function to fetch feeds from a store
	protected function CURLNewsFetch(&$panel, $phase, $refinerId = false) {
		return require 'plugins/tribiq_cms_core_v1/admin/CURLNewsFetch.fun.php';
	}
	
	//Function to fetch languages from a store
	protected function CURLLanguageFetch(&$panel, $phase, $refinerId = false, $id = false) {
		return require 'plugins/tribiq_cms_core_v1/admin/CURLLanguageFetch.fun.php';
	}
	
	protected function languageImportResults($numberOf, $error = false, $changeButtonHTML = false) {
		return require 'plugins/tribiq_cms_core_v1/admin/languageImportResults.fun.php';
	}

	protected function deleteCategory($id, $recurseCount = 0) {
		return require 'plugins/tribiq_cms_core_v1/admin/deleteCategory.fun.php';
	}
}
?>