tribiq_comments.loadWithDelay = function(containerId, enableColours, enableImages, enableEmoticons, enableLinks, empty) {
	if (tribiq.browserIsiPad() || tribiq.browserIsiPhone()) {
		return;
	}
	
	if (get('editor__' + containerId)) {
		get('editor__' + containerId).style.visibility = 'hidden';
	}
	
	setTimeout('tribiq_comments.load("' + containerId + '", ' + enableColours + ', ' + enableImages + ', ' + enableLinks + ', ' + empty + ')', 350);
}

tribiq_comments.load = function(containerId, enableColours, enableImages, enableEmoticons, enableLinks, empty, selfCalling) {
	if (tribiq.browserIsiPad() || tribiq.browserIsiPhone()) {
		return;
	}
	
	if (get('editor__' + containerId)) {
		get('editor__' + containerId).style.visibility = 'hidden';
	}

	if (typeof punymce != 'object') {
		if (!selfCalling) {
			jQuery.getScript(
				URLBasePath + 'cmsjs/inc-punymce.js.php?v=' + window.tribiqCSSJSVersionNumber + '&gz=' + tribiq.useGZ,
				function() {
					punymce.Event._pageInit();
					tribiq_comments.load(containerId, enableColours, enableImages, enableEmoticons, enableLinks, empty, true)
				}
			);
		}
		return;
	}
	
	if (!tribiq_comments.editorPhrases) {
		tribiq_comments.editorPhrases = tribiq_comments.phrase([
			'_EDITOR_BOLD',
			'_EDITOR_ITALIC',
			'_EDITOR_UNDERLINE',
			'_EDITOR_STRIKE',
			'_EDITOR_UNORDERED_LIST',
			'_EDITOR_ORDERED_LIST',
			'_EDITOR_STYLE',
			'_EDITOR_CODE',
			'_EDITOR_QUOTE',
			'_EDITOR_REMOVE_FORMAT',
			'_EDITOR_EDIT_SOURCE',
			'_EDITOR_EMOTICONS',
			'_EDITOR_INSERT_IMAGE',
			'_EDITOR_IMAGE_SRC',
			'_EDITOR_LINK',
			'_EDITOR_UNLINK',
			'_EDITOR_LINK_HREF',
			'_EDITOR_TEXT_COLOR'
		]);
		
		punymce.extend(punymce.I18n, {
			// Core
			bold: tribiq_comments.editorPhrases._EDITOR_BOLD,
			italic: tribiq_comments.editorPhrases._EDITOR_ITALIC,
			underline: tribiq_comments.editorPhrases._EDITOR_UNDERLINE,
			strike: tribiq_comments.editorPhrases._EDITOR_STRIKE,
			ul: tribiq_comments.editorPhrases._EDITOR_UNORDERED_LIST,
			ol: tribiq_comments.editorPhrases._EDITOR_ORDERED_LIST,
			style: tribiq_comments.editorPhrases._EDITOR_STYLE,
			removeformat: tribiq_comments.editorPhrases._EDITOR_REMOVE_FORMAT,

			//Plugins
			editsource: tribiq_comments.editorPhrases._EDITOR_EDIT_SOURCE,
			emoticons: tribiq_comments.editorPhrases._EDITOR_EMOTICONS,
		
			// Image plugin
			insertimage: tribiq_comments.editorPhrases._EDITOR_INSERT_IMAGE,
			entersrc: tribiq_comments.editorPhrases._EDITOR_IMAGE_SRC,
		
			// Link plugin
			link: tribiq_comments.editorPhrases._EDITOR_LINK,
			unlink: tribiq_comments.editorPhrases._EDITOR_UNLINK,
			enterhref: tribiq_comments.editorPhrases._EDITOR_LINK_HREF,
		
			// Textcolor plugin
			textcolor: tribiq_comments.editorPhrases._EDITOR_TEXT_COLOR
		});
	}
	
	//Attempt to fix a bug with escaping in punymce
	get('editor__' + containerId).value = htmlspecialchars(get('editor__' + containerId).value);
	
	tribiq_comments['editor__' + containerId] = new punymce.Editor({
		id: 'editor__' + containerId,
		toolbar:
			'bold,italic,underline,strike,' +
			(enableColours? 'textcolor,' : '') +
			'removeformat,style,ul,ol,' +
			(enableLinks? 'link,unlink,' : '') +
			(enableImages? 'image,' : '') +
			(enableEmoticons? 'emoticons,' : '') +
			'editsource',
		plugins:
			(enableColours? 'TextColor,' : '') +
			(enableLinks? 'Link,' : '') +
			(enableImages? 'Image,' : '') +
			(enableEmoticons? 'Emoticons,' : '') +
			'BBCode,Paste,EditSource',
		min_height : 200,
		min_width : 400,
		styles : [
			{ title : tribiq_comments.editorPhrases._EDITOR_CODE, cls : 'pre', cmd : 'FormatBlock', val : '<pre>' },
			{ title : tribiq_comments.editorPhrases._EDITOR_QUOTE, cls : 'blockquote', cmd : 'FormatBlock', val : '<blockquote>' }
		],
		emoticons : {
			auto_convert : 1,
			emoticons : {
				happy : [':)', '=)'],
				unhappy : [':|', '=|'],
				sad : [':(','=('],
				grin : [':D', '=D'],
				surprised : [':o',':O','=o', '=O'],
				wink : [';)'],
				halfhappy : [':/', '=/'],
				tounge : [':P', ':p', '=P', '=p'],
				lol : [':lol:'],
				mad : [':x', ':X', ':@'],
				rolleyes : [':roll:'],
				cool : ['8)', '8-)']
			}
		},
		content_css: 'cmsstyles/skin.css.php?v=' + encodeURIComponent(window.tribiqCSSJSVersionNumber) + '&id=' + tribiq.skinId + '&editor=1' + (tribiq.useGZ? '' : '&gz=1')
	});
	
	if (get('editor__' + containerId + '_f')) {
		get('editor__' + containerId + '_f').style.width = '100%';
	}
	
	if (empty) {
		tribiq_comments.latestEditor = 'editor__' + containerId;
		
		if (tribiq.browserIsWebKit()) {
			tribiq.setTimeout("$(get('editor__" + containerId + "_f').contentWindow.document.body).click(tribiq_comments.punymceCheckFocus);", 500);
		} else {
			punymce.Event.add(get('editor__' + containerId + '_f').contentWindow.document, 'click', tribiq_comments.punymceCheckFocus);
		}
	}
	
	
	//Set the value of the text field when saving
	$('#' + containerId + ' :submit').click(function() {
		var containerId = tribiq.getContainerIdFromEl(this);
		var message = {format: 'bbcode', content: tribiq_comments['editor__' + containerId].getContent()};
		
		tribiq_comments.toBBCode(undefined, message);
		
		get('editor__' + containerId).value = message.content;
	});
}

tribiq_comments.punymceCheckFocus = function(e) {
	if (tribiq_comments.latestEditor && tribiq_comments[tribiq_comments.latestEditor]) {
		tribiq_comments[tribiq_comments.latestEditor].setContent('');
		tribiq_comments.latestEditor = false;
	}
}

tribiq_comments.checkFocus = function (el, ed) {
	
	if (el.className == 'no_focus') {
		el.className = '';
		el.value = '';
	}
}