<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */





class tribiq_country_manager extends plugin_base_class {
	
	var $mergeFields = array();

	function init(){
		return true;
	}

	//refiner - 'all', 'active', 'inactive'
	private static function getWhereCondForActiveField($refiner){
		switch (strtolower(trim($refiner))){
			case 'active':
				$sql =' AND active=1 ';
				break;
			case 'inactive':
				$sql =' AND active=0 ';
				break;
			case 'all':
			case 'default':
				break;
		}
	return $sql;
	}
	
	private static function getOrderByClause(){
		return " ORDER BY english_name";
	}


	private static function updateRegionCheck($regionId,$regionCode,$countryCode,$regionName){
		if (!checkPriv('_PRIV_PUBLISH_ITEM')){
			return "You are not allowed to change the Regions list.";
		}
		if (trim($countryCode)==''){
			return 'You must enter a Country code';
		}
		if (trim($regionCode)==''){
			return 'You must enter a Region code';
		}
		if (preg_match('/[^A-Za-z0-9]+/',$countryCode)!==0){
			return 'Country code incorrect.';
		}
		if (preg_match('/[^A-Za-z0-9]+/',$regionId)!==0){
			return 'The Region code can contain only alphanumeric characters';
		}
		if ((self::getEnglishCountryName($countryCode))==''){
			return 'Country code incorrect.';
		}
		if (strlen($regionCode)>5){
			return 'The Region code is too long.';
		}
		if (trim($regionName)==''){
			return 'You must enter a Region name.';
		}


			$sql = "SELECT id FROM " . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_regions  WHERE id=" .  (int) $regionId ;
			$res=my_mysql_query($sql);
			if (mysql_num_rows($res)===0){
				return 'Region with id ' . $regionId . ' does not exists.';
			}

			$sql = "SELECT id FROM " . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_regions  WHERE country_id='" .  strtoupper(trim(mysql_real_escape_string($countryCode))) . "'";
			$sql .= " AND code='" .  strtoupper(trim(mysql_real_escape_string($regionCode))) . "'";
			$sql .= " AND  id<>" .  (int) $regionId ;
			$res=my_mysql_query($sql);
			if (mysql_num_rows($res)!==0){
				return 'Region with code "' . $regionCode . '" in country "' . ifNull(self::getEnglishCountryName($countryCode),$countryCode) . '" already exists.';
			}
	}


	private static function updateRegion($regionId,$regionCode,$countryCode,$regionName){
		if (self::updateRegionCheck($regionId,$regionCode,$countryCode,$regionName)==''){
			$sql = 'UPDATE '  . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_regions ' ;
			$sql .=" SET name='" . mysql_real_escape_string($regionName) . "',";
			$sql .=" code='" . trim(strtoupper(mysql_real_escape_string($regionCode))) . "'";
			$sql .=" WHERE id=" . (int)$regionId;
			
			my_mysql_query($sql);
			if (mysql_affected_rows!=1)
				return 'The query updating the Region failed.';
		}
	}
	

	private static function addNewRegionCheck($regionCode,$countryCode,$regionName){
		if (!checkPriv('_PRIV_PUBLISH_ITEM')){
			return "You are not allowed to change the Regions list.";
		}
		if (trim($countryCode)==''){
			return 'You must enter a Country code';
		}
		if (trim($regionCode)==''){
			return 'You must enter a Region code';
		}
		if (preg_match('/[^A-Za-z0-9]+/',$countryCode)!==0){
			return 'Country code incorrect.';
		}
		if (preg_match('/[^A-Za-z0-9]+/',$regionCode)!==0){
			return 'The Region code can contain only alphanumeric characters';
		}
		if ((self::getEnglishCountryName($countryCode))==''){
			return 'Country code incorrect.';
		}
		if (strlen($regionCode)>5){
			return 'The Region code is too long.';
		}
		if (trim($regionName)==''){
			return 'You must enter a Region name.';
		}

			$sql = "SELECT id FROM " . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_regions  WHERE country_id='" .  strtoupper(trim(mysql_real_escape_string($countryCode))) . "'";
			$sql .= " AND code='" .  strtoupper(trim(mysql_real_escape_string($regionCode))) . "'";
			$res=my_mysql_query($sql);
			if (mysql_num_rows($res)!==0){
				return 'Region with code "' . $regionCode . '"  in country "' . ifNull(self::getEnglishCountryName($countryCode),$countryCode) . '" already exists.';
			}			

	}

	private static function addNewRegion($regionCode,$countryCode,$regionName){
		if (self::addNewRegionCheck($regionCode,$countryCode,$regionName)==''){
			$sql = 'INSERT INTO ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_regions';
			$sql .= ' (`code`,`country_id`,`name`,`active`) ';
			$sql .= "VALUES ('" .strtoupper(trim(mysql_real_escape_string($regionCode))) . "','" .   mysql_real_escape_string($countryCode) . "','" .   mysql_real_escape_string($regionName) . "',1) ";
			my_mysql_query($sql);
			if (mysql_affected_rows!=1)
				return 'The query adding new Region failed.';
		}
	}


	private static function addNewCountryCheck($countryCode,$countryName,$state){
		if (!checkPriv('_PRIV_PUBLISH_ITEM')){
			return "You are not allowed to change the Countries list.";
		}
		if (!$countryCode){
			return 'You must enter a Country code.';
		}
		if (preg_match('/[^A-Za-z0-9]+/',$countryCode)!==0){
			return 'The Country code can contain only alphanumeric characters';
		}
		if (strlen($countryCode)>5){
			return 'The Country code is too long.';
		}

			$sql = "SELECT id FROM " . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_countries  WHERE id='" .  strtoupper(trim(mysql_real_escape_string($countryCode))) . "'";
			$res=my_mysql_query($sql);
			if (mysql_num_rows($res)!==0){
				return 'Country code "' . $countryCode . '" is already used as code of country "' . ifNull(self::getEnglishCountryName($countryCode),$countryCode) . '".';
			}

		if (!$countryName){
			return 'Please specify the name to be used in Storekeeper for the new Country.';
		}
		if (strlen($countryName)>255){
			return 'The Country name is too long.';
		}
		if (($state!=0) && ($state!=1)){
			return 'Wrong country state.';
		}
	}

	private static function addNewCountry($countryCode,$countryName,$state){
		if (($rv=self::addNewCountryCheck($countryCode,$countryName,$state))==''){
			$sql = 'INSERT INTO ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries (`id`,`english_name`,`active`) ';
			$sql .= " VALUES ( '" .  mysql_real_escape_string(strtoupper($countryCode)) . "','" . mysql_real_escape_string($countryName) . "'," . (int)$state . ")";
			my_mysql_query($sql);
			if (mysql_affected_rows()!=1){
				return 'The query adding new Country failed.';
			}
		} else {
			return $rv;
		}
	}

	private static function updateCountryCheck($countryCode,$countryName){
		if (!checkPriv('_PRIV_PUBLISH_ITEM')){
			return "You are not allowed to change the Countries list.";
		}
		if (!$countryCode){
			return 'You must enter a Country code.';
		}
		if (preg_match('/[^A-Za-z0-9]+/',$countryCode)!==0){
			return 'The Country code can contain only alphanumeric characters';
		}
		if (strlen($countryCode)>5){
			return 'The Country code is too long.';
		}

			$sql = "SELECT id FROM " . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_countries  WHERE id='" .  strtoupper(trim(mysql_real_escape_string($countryCode))) . "'";
			$res=my_mysql_query($sql);
			if (mysql_num_rows($res)===0){
				return 'The Country with code "' . $countryCode . '" is not present in the database and therefore could not be updated.';
			}

		if (!$countryName){
			return 'Please specify the name to be used in Storekeeper for the new Country.';
		}
		if (strlen($countryName)>255){
			return 'The Country name is too long.';
		}
	}

	private static function updateCountry($countryCode,$countryName){
		if (($rv=self::updateCountryCheck($countryCode,$countryName))==''){
			$sql = 'UPDATE ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries ';
			$sql .= " SET `english_name`='" . mysql_real_escape_string($countryName) . "'";
			$sql .= " WHERE `id`='" . mysql_real_escape_string(strtoupper($countryCode)) . "'";
			my_mysql_query($sql);
			if (mysql_affected_rows()!=1)
				return 'The query updating the Country failed.';
		} else {
			return $rv;
		}
	}

	public static function getCountryAdminNamesIndexedByISOCode($countryActivityFilter='active',$countryId=''){
		$tbl= self::getCountryFullInfo($countryActivityFilter,$countryId) ;
		$rv = array();
		foreach($tbl as $K=>$V)
			$rv[$K]=$V['english_name'];
		sqlArraySort($rv);
 		return $rv;
	}

	public static function getCountryAdminNames($countryActivityFilter='active',$countryId=''){
		$tbl= self::getCountryFullInfo($countryActivityFilter,$countryId) ;
		$rv = array();
		foreach($tbl as $K=>$V)
			$rv['COUNTRY_' . strtoupper($K)]=$V['english_name'];
		sqlArraySort($rv);
 		return $rv;
	}
	

	public static function getCountryNamesInCurrentVisitorLanguageIndexedByISOCode($countryActivityFilter='active',$countryId=''){
		$tbl= tribiq_country_manager::getVisitorCountriesIndexedByISOCode($_SESSION['user_lang'],$countryActivityFilter,$countryId) ;
		$rv = array();
		foreach($tbl as $K=>$V)
			$rv[$K]=$V['phrase'];
		sqlArraySort($rv);
 		return $rv;
	}
	
	public static function getVisitorCountriesIndexedByISOCode($langId,$countryActivityFilter='active',$countryId=''){
		$rv = array();
		$values = self::getCountryFullInfo($countryActivityFilter,$countryId);
		foreach($values as $K=>$V)
			$rv[strtoupper($K)]=array('phrase'=>self::getPhrase($langId,'_COUNTRY_NAME_' . strtoupper($K)),'country_id'=>strtoupper($K));
		return $rv;
	}

	public static function getCountryNamesInCurrentVisitorLanguage($countryActivityFilter='active',$countryId=''){
		$tbl= tribiq_country_manager::getVisitorCountries($_SESSION['user_lang'],$countryActivityFilter,$countryId) ;
		$rv = array();
		foreach($tbl as $K=>$V)
			$rv[$K]=$V['phrase'];
		sqlArraySort($rv);
 		return $rv;
	}
	
	public static function getVisitorCountries($langId,$countryActivityFilter='active',$countryId=''){
		$rv = array();
		$values = self::getCountryFullInfo($countryActivityFilter,$countryId);
		foreach($values as $K=>$V)
			$rv['COUNTRY_' . strtoupper($K)]=array('phrase'=>self::getPhrase($langId,'_COUNTRY_NAME_' . strtoupper($K)),'country_id'=>strtoupper($K));
		return $rv;
	}

	public static function getRegionNamesInCurrentVisitorLanguage($countryActivityFilter='active',$countryId='',$regionId=''){
		$tbl= tribiq_country_manager::getVisitorRegions($_SESSION['user_lang'],$countryActivityFilter,$countryId,$regionId) ;
		$rv = array();
		foreach($tbl as $K=>$V)
			$rv[$K]=$V['phrase'];
		sqlArraySort($rv);
 		return $rv;
	}

	
	public static function getVisitorRegions($langId,$countryActivityFilter='active',$countryId='',$regionId=''){
		$rv = array();
		$values = self::getRegions($countryActivityFilter,$countryId,$regionId);
		foreach($values as $K=>$V)
			$rv["REGION_" .strtoupper($V['country_id'] . '_' .  $V['code'])]= array('phrase'=> self::getPhrase($langId,"_REGION_NAME_" .strtoupper($V['country_id'] . '_' .  $V['code'])),'id'=>$V['id'],'code'=>$V['code'],'country_id'=>$V['country_id']) ;
		return $rv;
	}
	
	public static function getPhrase($langId,$phraseCode){
		return getVLPPhrase($phraseCode,array(),$langId,false,'tribiq_country_manager');
	}
	
	
	public static function getRegions($countryActivityFilter='all',$countryCodeFilter='',$regionCodeFilter='',$regionIdFilter=false){
		
		$rv = array();
		$sql = 'SELECT
					R.id, 
					R.code ,
					R.country_id,
					R.name,
					R.active,
					C.english_name as country_english_name,
					C.active AS country_active 
				FROM
					' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_regions R 
				INNER JOIN  
					'  . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries C 
				ON 
					C.id = R.country_id 
				WHERE 1 ';
				
		if ($regionIdFilter) {
			$sql .= " AND R.id = '" . mysql_real_escape_string($regionIdFilter)  . "' ";
		} else {
			if ($countryCodeFilter) {
				$sql .= " AND R.country_id = '" . mysql_real_escape_string($countryCodeFilter)  . "' ";
			} elseif ($regionCodeFilter) {
				$sql .= " AND R.code = '" . mysql_real_escape_string($regionCodeFilter)  . "' ";
			}
		}
		
		$sql .= " ORDER BY R.name";
				
		$res=my_mysql_query($sql);
		while($row= mysql_fetch_assoc($res))
			$rv[$row['id']]=$row;
		
		return $rv;
	}

	//refiner - 'all', 'active', 'inactive'
	public static function getCountryCodesList($activityFiler='all'){
		$rv=array();
		$sql = 'SELECT id FROM ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries WHERE 1 ' .self::getWhereCondForActiveField($activityFiler);
		$sql .= self::getOrderByClause();
		$res = my_mysql_query($sql);
		while($row = mysql_fetch_assoc($res))
			$rv[strtoupper($row['id'])]=strtoupper($row['id']);

		return $rv;
	}

	//code refiner - if set returns one dimensional country that code mathces $codeFilter, or zero if no  matching country code found
	public static function getCountryFullInfo($activityFilter='all',$codeFilter=''){
		$rv=array();
		$sql = 'SELECT id,english_name,active FROM ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries WHERE 1 ' . self::getWhereCondForActiveField($activityFilter);
		if (mysql_real_escape_string(trim(strtoupper($codeFilter)))!='')
			$sql .= " AND id='" . mysql_real_escape_string(trim(strtoupper($codeFilter))) . "'";
		$sql .= self::getOrderByClause();

		$res = my_mysql_query($sql);
		while ($row = mysql_fetch_assoc($res))
			$rv[strtoupper($row['id'])]=array('english_name'=>$row['english_name'],'vlp_phrase'=>'_COUNTRY_NAME' . strtoupper($row['id']),  'status'=> $row['active']);
		return $rv;
	}

	public static function getEnglishCountryName($code){
		if (count($rv = self::getCountryFullInfo('all',$code)))
			return  $rv[strtoupper($code)]['english_name'];
		else
			return '';
	}

	

	function showAdminFloatingBoxTab($targetClassName, $floatingBoxName, &$tabLabel, $primaryKey, $editMode, &$showEditButton){


		//$showEditButton=false;
		switch ($floatingBoxName)
		{
			case 'Edit Country':
				
				$showEditButton=false;
				$requiredFields=array();
				$currentValues=array('id'=>htmlspecialchars($primaryKey['id']),'country_name'=>htmlspecialchars(self::getEnglishCountryName($primaryKey['id'])));
				$editFields= array('id' =>	array(		'Read Only'=>true,
															'Label' => 'Country code:',
															'Field' => 'id',
															'Type' => 'varchar(5)',
															'Null' => 'NO',
															'Table' =>  TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries',
															'Numeric' => false
															),
										'country_name' => array(
															'Read Only'=>false,
															'Label' => 'Country name:',
															'Field' => 'english_name',
															'Type' => 'varchar(255)',
															'Null' => 'NO',
															'Table' =>  TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries',
															'Numeric' => false,
															'Note Below' => 'for use only in admin mode'
															)
															
									);
				echo dynamicThickboxFormInner(true,$editFields,
												   $requiredFields,
												   $this->postVariables,
												   $currentValues,
												   array(),
												   array());
				break;
			case 'Add New Country':
				$currentValues=array();
				$requiredFields=array();
				$editFields= array('id' =>	array(
															'Label' => 'Country code:',
															'Field' => 'id',
															'Type' => 'varchar(5)',
															'Null' => 'NO',
															'Table' =>  TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries',
															'Numeric' => false
															),
										'country_name' => array(
															'Label' => 'Country name:',
															'Field' => 'english_name',
															'Type' => 'varchar(255)',
															'Null' => 'NO',
															'Table' =>  TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries',
															'Numeric' => false,
															'Note Below' => 'for use only in admin mode'
															)
															
									);
				echo dynamicThickboxFormInner(true,$editFields,
								   $requiredFields,
								   $this->postVariables,
								   $currentValues,
								   array(),
								   array());
				break;
			case 'Edit Region':
				$currentValues = self::getRegions('all',$primaryKey['refinerId']);
				$currentValues = array('name'=>$currentValues[$primaryKey['id']]['name'],'code'=>$currentValues[$primaryKey['id']]['code'] );
				$editFields = array(
								'code' => array('Label' => 'Region code:',
											   'Field' => 'code',
											   'Type'=> 'varchar(5)',
											   'Table' => TRIBIQ_COUNTRY_MANAGER_PREFIX .  'country_manager_regions',
											   'Numeric'=>false
											   ),
								'name'=> array('Label' => 'Region name:',
											   'Field' => 'name',
											   'Type'=> 'varchar(255)',
											   'Table' => TRIBIQ_COUNTRY_MANAGER_PREFIX .  'country_manager_regions',
											   'Numeric'=>false
											   )
										);
				echo dynamicThickboxFormInner(true,$editFields,array(),$this->postVariables,$currentValues,array(),array());
				break;
			case 'Add New Region':
				$editFields = array(
								'code' => array('Label' => 'Region code:',
											   'Field' => 'code',
											   'Type'=> 'varchar(5)',
											   'Table' => TRIBIQ_COUNTRY_MANAGER_PREFIX .  'country_manager_regions',
											   'Numeric'=>false,
											   ),
								'name'=> array('Label' => 'Region name:',
											   'Field' => 'Name',
											   'Type'=> 'varchar(255)',
											   'Table' => TRIBIQ_COUNTRY_MANAGER_PREFIX .  'country_manager_regions',
											   'Numeric'=>false
											   )
										);
				echo dynamicThickboxFormInner(true,$editFields,array(),$this->postVariables,array(),array(),array());
				break;
		}	
	}

    function setAdminFloatingBoxTitleAndValidatePrimaryKey($floatingBoxName, &$primaryKey, &$title) {
                switch($floatingBoxName){
                        case 'Add New Country':
                                $title="Creating a Country";
                                break;
                        case 'Edit Country':
                        		if ($this->inc('tribiq_geo_landing_pages')){
                        				$title = 'Viewing/Editing Country "' . htmlspecialchars(self::getEnglishCountryName($this->getVariables['id'])) . ' (' . htmlspecialchars($this->getVariables['id']) . ')"' ;
                        		} else {
                        				$title = 'Renaming Country "' . htmlspecialchars(self::getEnglishCountryName($this->getVariables['id'])) . ' (' . htmlspecialchars($this->getVariables['id']) . ')"' ;
                        		}
                            break;
                        case 'Add New Region':
                                $title='Creating a Region in the Country "'. htmlspecialchars(self::getEnglishCountryName($this->getVariables['refinerId'])) . '"'; 
                                break;
                        case 'Edit Region':
                        		$details = self::getRegions('all',$this->getVariables['refinerId']);
                                $title = 'Renaming Region "' . htmlspecialchars($details[$this->getVariables['id']]['name']) . '" in Country "' . htmlspecialchars(self::getEnglishCountryName($details[$this->getVariables['id']]['country_id'])) . '"' ;
                                break;
                }
        }


	public function validateAdminFloatingBoxTab($targetClassName, $floatingBoxName, $tabLabel, $primaryKey) {

		
		$errArray = array();
		switch ($floatingBoxName)
		{
			case 'Add New Country':
				if(($rv=self::addNewCountryCheck($this->request('id'),$this->request('country_name'),1))!='')
					$errArray[]=htmlspecialchars($rv);
				break;		
			case 'Edit Country':
				if(($rv=self::updateCountryCheck($this->request('id'),$this->request('country_name')))!='')
					$errArray[]=htmlspecialchars($rv);
				break;		
			case 'Add New Region':
				if(($rv=self::addNewRegionCheck($this->request('code'),$this->request('refinerId'),$this->request('name')))!='')
					$errArray[]=htmlspecialchars($rv);
				break;		
			case 'Edit Region':
				if(($rv=self::updateRegionCheck($primaryKey['id'],$this->request('code'), $this->request('refinerId'),$this->request('name')))!='')
					$errArray[]=htmlspecialchars($rv);
				break;		

		}
		echo json_encode(array('valid' => !count($errArray), 'errArray' => $errArray));
	}

	public function saveAdminFloatingBoxTab($targetClassName, $floatingBoxName, $tabLabel, $primaryKey) {
		switch ($floatingBoxName)
		{
			case 'Add New Country':
				if (self::addNewCountry($this->request('id'),$this->request('country_name'),1)==''){
					echo json_encode(array('id' => strtoupper($this->request('id'))));
				}
				break;
			case 'Edit Country':
				self::updateCountry($this->request('id'),$this->request('country_name'));
				json_encode(array());
				break;
			case 'Add New Region':
				self::addNewRegion($this->request('code'),$this->request('refinerId'),$this->request('name'));
				echo json_encode(array('id'=>mysql_insert_id ( )));
				break;
			case 'Edit Region':
				self::updateRegion($primaryKey['id'],$this->request('code'), $this->request('refinerId'),$this->request('name'));
				json_encode(array());
				break;

		}		
	}

	function setAdminFloatingBoxPrimaryKey($floatingBoxName, &$primaryKey) {
		$primaryKey = array("id","refinerId","country_id","region_id");
	}

	
	public function fillStorekeeper($path, &$panel, $refinerName, $refinerId) {
		switch ($path) {
			case 'tribiq__countries':
				foreach ($panel['items'] as &$item) {
					if ($item['country_status']=='active') {
						$item['traits'] = array('active' => true);
					} else {
						$item['traits'] = array('suspended' => true);
					}
				}
				break;
			case 'tribiq__countries/regions':
				if ($country=$this->getEnglishCountryName($refinerId))
					$panel['title'] = 'Regions in Country "'. $country . '"';
				break;
		}
	}


	public function storekeeperAJAX($path, $ids, $ids2, $refinerName, $refinerId) {
		if (checkPriv("_PRIV_PUBLISH_ITEM")){
			foreach (explode(',',$ids) as $id) {
				if($this->post('action') == 'activate_country'){
					$sql = 'UPDATE ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_countries SET active=1 where id='" . mysql_real_escape_string($id) . "'";
				}
				if($this->post('action') == 'suspend_country'){
					$sql = 'UPDATE ' .DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_countries SET active=0 where id='" . mysql_real_escape_string($id) . "'";
				}
				if($this->post('action') == 'delete_country'){
					$sql = 'DELETE FROM ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_countries  where id='" . mysql_real_escape_string($id) . "'";
					my_mysql_query($sql);
					$sql = 'DELETE FROM ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_regions  where country_id='" . mysql_real_escape_string($id) . "'";

					sendSignal('eventCountryDeleted', array("countryId" => $id));
				}
				if($this->post('action') == 'activate_all'){
					$sql = 'UPDATE ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries SET active=1';
				}
				if($this->post('action') == 'suspend_all'){
					$sql = 'UPDATE ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . 'country_manager_countries SET active=0';
				}
				if($this->post('action') == 'delete_region'){
					$sql = 'DELETE FROM ' . DB_NAME_PREFIX . TRIBIQ_COUNTRY_MANAGER_PREFIX . "country_manager_regions  where id=" . (int)($id);
				}
				if ($sql) {
					my_mysql_query($sql);
				}
			}
		} else {
			echo "You have no permission to manipulate Countries or Regions.";
		}
 	}
}

?>
