<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


class tribiq_extranet_password_reminder extends tribiq_extranet {
	
	public function init() {
		
		$this->mode = 'modeForgotPassword';
		
		$this->lang = getLanguage();
		$this->manageCookies();
		
		if ($this->post('extranet_forgot_password')) {
			if ($this->forgotPassword()) {
				$this->message = $this->phrase('_EMAIL_SENT');
				$this->mode = 'modeLogin';
			}
		}
		
		return true;
	}
	
	protected function addLoginLinks() {
		
		if ($this->lang['extranet_login_page_id'] && $this->checkFrameworkSectionExists('Login_Link_Section') && (!issetArrayKey($_SESSION,'extranetUserID'))) {
			$this->subSections['Login_Link_Section'] = true;
			$this->objects['Login_Link'] = $this->linkToItemAnchor($this->lang['extranet_login_page_id']);
		}
		if ($this->lang['extranet_password_reminder_page_id'] && $this->checkFrameworkSectionExists('Forget_Password_Link_Section')) {
			$this->subSections['Forget_Password_Link_Section'] = true;
			$this->objects['Forget_Password_Link'] = $this->linkToItemAnchor($this->lang['extranet_password_reminder_page_id']);
		}
		if ($this->lang['extranet_registration_page_id'] && $this->checkFrameworkSectionExists('Registration_Link_Section')) {
			$this->subSections['Registration_Link_Section'] = true;
			$this->objects['Registration_Link'] = $this->linkToItemAnchor($this->lang['extranet_registration_page_id']);
		}
		if ($this->lang['extranet_registration_page_id'] && $this->checkFrameworkSectionExists('Resend_Link_Section')) {
			$this->subSections['Resend_Link_Section'] = true;
			$this->objects['Resend_Link'] = $this->linkToItemAnchor($this->lang['extranet_registration_page_id'], 'html', false, '&extranet_resend=1');
		}
	}

	
	//Display a form that lets the user enter the email address that they used to register,
	//and then have their password emailed to them
	public function modeForgotPassword() {
		$this->addLoginLinks();
		
		$this->frameworkHead('Outer', 'Forget_Password_Form', $this->objects, $this->subSections);
			echo $this->openForm();
					$this->framework('Forget_Password_Form', $this->objects, $this->subSections);
			echo $this->closeForm();
		$this->frameworkFoot('Outer', 'Forget_Password_Form', $this->objects, $this->subSections);

	}


	function forgotPassword() {
		if (!$this->validateFormFields('Forget_Password_Form')) {
		
		} elseif (!$userDetails = $this->getDetailsFromEmail($this->post('extranet_email'))) {
			$this->errors[] = array('Error' => $this->phrase('_ERROR_EMAIL_UNASSOCIATED'));
			
		} else {
			if (!getRow('users', 'email_verified', array('email' => $this->post('extranet_email')))) {
				$this->errors[] = array('Error' => $this->phrase('_ERROR_EMAIL_NOT_VERIFIED'));
			
			} else {
				$userDetails['IP_Address'] = $_SERVER['REMOTE_ADDR'];
				$userDetails['CMS_URL'] = $this->absCMSDirURL();
				
				if ($this->inc('tribiq_email_template_manager')){
						if (tribiq_email_template_manager::sendEmailsUsingTemplate($userDetails['Email'],$this->setting('password_reminder_email_template'),$userDetails,array())){
							return true;
						} else {
							$this->errors[] = array('Error' => $this->phrase('_COULD_NOT_SEND_RECOVER_PASSWORD_EMAIL'));
						}
				} else {
					$this->errors[] = array('Error' => $this->phrase('_COULD_NOT_SEND_RECOVER_PASSWORD_EMAIL'));
				}
			}
		}
		
		return false;
	}
	
	
	//If a page is created with this Plugin as the Featured Plugin,
	//on a Language without a Password Reminder Page set, set this as the Password Reminder Page.
	public static function eventQuickAddContentItem($cID, $instance) {
		if ($instance['class_name'] == 'tribiq_extranet_password_reminder') {
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "languages SET
					extranet_password_reminder_page_id = ". (int) $cID. "
				WHERE id = '". mysql_real_escape_string(getContentLang($cID, 'html')). "'
				  AND extranet_password_reminder_page_id = 0";
			my_mysql_query($sql);
		}
	}
	

}
?>