<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */




class tribiq_footer extends tribiq_menu {
	
	var $copyrightNotice;
	
	function allowPluginToBeShownOnErrorPage() {
		return true;
	}
	
	function init() {
		$this->sectionId				= 'Footer';
		$this->startFrom				= '_MENU_LEVEL_1';
		$this->numLevels				= 1;
		$this->maxLevel1MenuItems		= 40;
		$this->language					= false;
		$this->showAdminAddMenuItem		= true;
		$this->onlyFollowOnLinks		= true;
		$this->onlyIncludeOnLinks		= false;
		$this->showInvisibleMenuItems	= false;
		
		$this->markSlotAsBeingEdited(false);
		
		//Get the menu item for this content item
		$this->currentMenuId = getSectionMenuItemFromContent($this->cID, $this->cType, $this->sectionId);
		
		return true;
	}
	
	//Recursive function to draw menu items from the database
	function drawMenu(&$menuArray, $recurseCount = 0, $headerObjects = array(), $subSections = array()) {
		
		if ($recurseCount != 0) {
			return;
		}
		
		//Add a "print this page" option if requested
		if ($this->setting('show_print_page')) {
			$menuArray[] = array(
				'url' => '#',
				'active' => true,
				'name' => $this->phrase('_PRINT_PAGE'),
				'onclick' => "window.print(); return false;"
			);
		}
		
		//Add the login link for admins if this looks like a logged out admin
		if (isset($_COOKIE['COOKIE_LAST_ADMIN_USER']) && !checkPriv()) { 
			$menuArray[] = array(
				'url' => 'admin/welcome.php?cID='. ifNull($this->cID, $_REQUEST['cID']). '&amp;cType='. ifNull($this->cType, $_REQUEST['cType'], 'html'),
				'active' => true,
				'name' => $this->phrase('_ADMIN')
			);
		}
		
		tribiq_menu::drawMenu($menuArray, $recurseCount, array('Copyright_Notice' => $this->setting('copyright_notice')));
	}
}


?>
