<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

class tribiq_picture_gallery extends plugin_base_class {
	
	function init()	{
		$this->rows = $this->setting('number_of_rows');
		$this->cols = $this->setting('number_of_columns');
		$this->per_page = $this->rows * $this->cols;
		
		$this->registerGetRequest('page', 1);
		$this->page = ifNull((int) $this->getVariables['page'], 1);
		if ($this->page < 1) {
			$this->page = 1;
		}
		
		if ($this->page == 1) {
			$this->first = '0';
		} else {
			$this->last = $this->per_page * $this->page;
			$this->first = $this->last - $this->per_page;
		}
		
		$this->windowWidth = $this->setting('w_width')? $this->setting('w_width') : 400;
		$this->windowHeight = $this->setting('w_height')? $this->setting('w_height') : 400;
		
		return true;
	}
	
	
	function showSlot() {	
				
		$this->frameworkHead();
		$this->galleryDisplay = $this->getGalleryContent();
		
		//No Pictures found
		if (($this->message) || (count($this->galleryDisplay['pictures'])<1)){
			$this->framework('Message_Display', array('Message' => $this->message));
		} else {
		
			$this->frameworkHead('Gallery_Thumbnails', 'Picture');
				$this->framework('Picture', $this->galleryDisplay['pictures']);
			$this->frameworkFoot('Gallery_Thumbnails', 'Picture');
			
			$this->framework('Gallery_Footer_Results', array('Gallery_Results' => $this->galleryDisplay['matches'], 'Pages' => $this->galleryDisplay['pagination']));
		
		}
		
		$this->frameworkFoot();
		
	}
	
	
	function getSQLBaseQuery(){
		$sql = "SELECT p.id,
					p.version,
					title,
					description,
					i.filename,
					p.mime_type as type,
					p.size,
					p.created_datetime as created,
					p.width,
					p.height
				FROM " . DB_NAME_PREFIX . "content_picture AS p
				INNER JOIN " . DB_NAME_PREFIX . "images AS i
					ON p.id = i.content_item_id
					AND p.version = i.content_item_version ";
		if ($this->setting('category') ) 
			$sql .= "INNER JOIN " . DB_NAME_PREFIX . "category_item_link as lpc on lpc.item_id=p.id and content_type='picture' and p.version = lpc.version and lpc.category_id='" . (int)$this->setting('category') ."' ";  
		return $sql;
	}

	function getSQLWhereCondition(){
		$sql =" WHERE 1 ";
		$sql .= "AND i.content_item_type = 'picture' AND i.sticky_flag=1 and status<>'hidden'  " ;
		if (checkPriv()) 
			$sql .= " AND ((draft_exists = 0 AND status = 'published') OR status = 'private_draft')";
		else 
			$sql .= " AND status = 'published'";
		return $sql;
	}
	
	function getSQLWhereConditionImageById($imageId){
		$sql .= "WHERE p.id = ". (int) $imageId;
		return $sql;
	}
	
	function getDownloadLink($imageID){
		return '<a class="picture_downlaod_link" href="' .  $this->linkToItem($imageID,'picture') . '" > ' . $this->phrase('_DOWNLOAD_ORIGINAL')  . '</a>';
	}
	
	function getGalleryContent()
	{
					
		$sql = $this->getSQLBaseQuery() . $this->getSQLWhereCondition();
		$result = my_mysql_query($sql);
		
		$this->total_records = mysql_num_rows($result);		
		
		if ( 0 == $this->total_records ) {

			$this->message = $this->phrase("_NO_PICTURES");

		} else {
			
			$sql .= " ORDER BY id LIMIT " . (int)$this->first . "," . (int)$this->per_page;			
			$result = my_mysql_query($sql);
			$this->total_this_page = mysql_num_rows($result);			

			$j = '1';			
			while ($row = mysql_fetch_array($result)) {
					$imageID = $row['id'];
					$imageVersion = $row['version'];
					$imageDescription =  $row['description'] ;
					$imageFilename = $row['filename'];
					$imageTitle =  $row['title'] ;
					$imageSize = $row['size'];
					$imageType = $row['type'];
					$downloadLink = $this->getDownloadLink($imageID);
			
					if(($j % $this->cols) == '0') { $p_break = "_on"; } else { $p_break = ""; }				
					
				    if ($row['width'] && $row['height']){
				    		list($width,$height) = $this->getThumbnailDimesios();
							list($width,$height) = resizeImage($row['width'],$row['height'],$width,$height);
					} else {
							$width = '';
							$height = '';
					}
					
					$pictures[] = array(
									"Pic_Link" => $downloadLink,
									"Pic_Id" => "image_" . $row['id'],
									"Pic_Path_AdditionalRequests" => "?cID=" . $imageID . "&cType=picture&cVersion=" . $imageVersion . "&filename=" . $imageFilename . "&mode=thumb",
									"Pic_Title" => htmlspecialchars($imageTitle),
									"Pic_Description" => htmlspecialchars($imageDescription),
									"Pic_Break" => $p_break,
									"Pic_Path_Subdirectory" => SUBDIRECTORY,
									"Thumbnail_width"=>(int) $width,
									"Thumbnail_height"=>(int) $height,
									'image_filename' => htmlspecialchars($imageFilename),
									'image_id' => htmlspecialchars($imageID),
									'image_version' => htmlspecialchars($imageVersion),
									'image_base_path' => $this->absCMSDirURL(),
									'Container_Id' => $this->containerId
									);
					
					$j++;
				}
		}	
		
		// Pagination
		
		$this->start_this_page = $this->first + 1;
		$this->last_record_on_page = ($this->start_this_page + $this->total_this_page) -1;
			
		$matches_result = $this->phrase( '_DISPLAYING_MATCHES', array( 'first_record' => $this->start_this_page, 'last_record' => $this->last_record_on_page, 'total_records' => $this->total_records ) );
			
		$this->numberofpages = ceil($this->total_records/$this->per_page);
		
		$pages = array();
		for ($i=1;$i<=$this->numberofpages;$i++) {
			$pages[$i] = 'page='. $i;
		}
		
		$output = array(
			"pictures" => $pictures,
			"matches" => $matches_result);
		
		$this->pagination('pagination_style', $this->page, $pages, $output['pagination']);
		
		return $output;
	}
	


	
	function getThumbnailDimesios(){
		if ($this->setting('use_custom_thumbnail_constraint')==1){
			return array ($this->setting('max_thumb_width'),$this->setting('max_thumb_height'));
		} else {
			getContentTypeSettings('picture',$fields,$values);
			return array((int) $values['thumbnail_height'],(int) $values['thumbnail_width']);
		}
	}
}

?>
