<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

class tribiq_search_entry_box extends tribiq_search_results {
	
	public function allowPluginToBeShownOnErrorPage() {
		return true;
	}
	
	function showSlot() {
		$this->sections = array();
		$this->mergeFields = array();
		
		$cID = $cType = false;
		if ($this->setting('use_specific_search_results_page') && $this->getCIDAndCTypeFromSetting($cID, $cType, 'specific_search_results_page')) {
			if ($cID == $this->cID && $cType == $this->cType) {
				$cID = $cType = false;
			}
		
		} elseif (($searchPage = getLanguageDefaultSearchPage()) && ($this->cID != $searchPage)) {
			$cID = $searchPage;
			$cType = 'html';
		}
		
		$this->drawSearchBox($cID, $cType);
		
		$this->framework('Search_Box', $this->mergeFields, $this->sections);

	}
	
	function launchAJAXSearch() {
		$this->mergeFields['Search_Submit'] =
			"if (tribiq.searchPlugin = ifNull(window.tribiq_search_results_pro, window.tribiq_search_results)) {".
				"tribiq.refreshPluginSlot(".
					"tribiq.searchPlugin.slotName(),".
					"'lookup',".
					"'&searchString=' + encodeURIComponent(get('". $this->mergeFields['Search_Field_ID']. "').value));".
				"return false;".
			"}";
	}
}
?>
