<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */





//This Plugin is used to create a Sitemap

//Rather than start from the ground up, the Sitemap Plugin uses code from an existing Plugin called tribiq_menu: Note that the
//showSlot method is not included at all, as the version in the Menu Plugin already does everything the Sitemap Plugin needs.

//However the Sitemap Plugin does have its own version of the init method, which it uses to set up sitemap-specific settings
//to change the way that the showSlot method will behave
class tribiq_sitemap extends tribiq_menu {
	
	//The init method is called by the CMS lets Plugin Developers run code before the Plugin and the page it is on are displayed.
	//In visitor mode, the Plugin is only displayed if this method returns true.
	function init() {
		//The only setting used is which Menu Section to display
		//(This will usually be set to "main")
		$this->sectionId				= $this->setting('menu_section');
		
		//Start from the top of the menu tree, and have no real limits on the depth or the number of menu items
		$this->startFrom				= '_MENU_LEVEL_1';
		$this->numLevels				= 999;
		$this->maxLevel1MenuItems		= 999;
		
		//Auto-detect the visitors current language
		$this->language					= false;
		
		//Don't allow Admins to build menus using the map
		$this->showAdminAddMenuItem		= false;
		
		//Show every branch of the menu tree
		$this->onlyFollowOnLinks		= false;
		$this->onlyIncludeOnLinks		= false;
		$this->showInvisibleMenuItems	= $this->setting('show_invisible_menu_items');
		
		//Get the menu item for this content item
		$this->currentMenuId = getSectionMenuItemFromContent($this->cID, $this->cType, $this->sectionId);
		
		//Always display this Plugin
		return true;
	}
}


?>
