<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */



//This Plugin displays the current weather in one location, using an XML feed from the BBC
class tribiq_social_bookmarking extends plugin_base_class {
	var $mergeFields = array();
	var $sections = array();

	//The showSlot method is called by the CMS, and displays the Plugin on the page
	function showSlot() {
		
		$pageUrl = htmlspecialchars(urlencode($this->linkToItem($this->cID, $this->cType, $fullPath = true)));
		$pageTitle = htmlspecialchars(urlencode(getItemTitle($this->cID,$this->cType,$this->cVersion)));
		
		$iconPath = $this->absCMSDirURL() . $this->frameworkDir(). 'icons/';
		
		if ($this->setting('delicious')) {
			$this->sections['delicious'] = true;
			$this->mergeFields['delicious_link'] = 'http://delicious.com/post?url='. $pageUrl. '&amp;title='. $pageTitle;
		}
		
		if ($this->setting('digg')) {
			$this->sections['digg'] = true;
			$this->mergeFields['digg_link'] = 'http://digg.com/submit?url='. $pageUrl. '&amp;title='. $pageTitle;
		}
		
		if ($this->setting('reddit')) {
			$this->sections['reddit'] = true;
			$this->mergeFields['reddit_link'] = 'http://reddit.com/submit?url='. $pageUrl. '&amp;title='. $pageTitle;
		}
		
		if ($this->setting('facebook')) {
			$this->sections['facebook'] = true;
			$this->mergeFields['facebook_link'] = 'http://www.facebook.com/sharer.php?u='. $pageUrl;
		}
		
		if ($this->setting('stumbleupon')) {
			$this->sections['stumbleupon'] = true;
			$this->mergeFields['stumbleupon_link'] = 'http://www.stumbleupon.com/submit?url='. $pageUrl. '&amp;title='. $pageTitle;
		}

		if ($this->setting('tweetmeme')) {
			$sql =" SELECT 
						id
					FROM 
						" . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($this->cType) . "
					WHERE 
							id = " . (int) $this->cID . " 
						AND version = ". (int) $this->cVersion . "
						AND status='published'
						AND private=0
						LIMIT 1";
			if (mysql_num_rows(my_mysql_query($sql))==1){
				$this->sections['tweetmeme'] = true;
			}
		}
		
		$this->framework('Outer', $this->mergeFields, $this->sections);
	}
}
?>
