<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

$title = getPhrase(
			'Adding the Language &quot;[[language]]&quot; to the Site',
			array('language' => htmlspecialchars(getLanguageName(ifNull($_GET['lang'], $_GET['id'])))));


$tab_programs = array();
if (checkPriv('_PRIV_ENABLE_VLP')) {
	$tab_programs['add_language'] = getPhrase('Create details for essential pages');
	$tab_programs['add_language_2'] = getPhrase('Create details for Extranet pages');
	$tab_programs['language_phrases'] = array('tab_label' => getPhrase('Import Phrases for Plugins'), 'loaded_by_default' => true);
}

//Hack to initialise hp_alias and sp_alias
$_REQUEST['hp_alias'] = getVLPPhrase('__DEFAULT_HOME_PAGE_ALIAS__', '', $_GET['id'], true);
$_REQUEST['sp_alias'] = getVLPPhrase('__DEFAULT_SEARCH_PAGE_ALIAS__', '', $_GET['id'], true);

thickboxHeader($title, $tab_programs, 'Add Language', array('lang', 'hp_alias', 'sp_alias'));
thickboxFooter();
?>