<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_ENABLE_VLP');
$hasEditPermission = checkPriv('_PRIV_ENABLE_VLP');

$noSaving = false;
$noValidation = false;
$showEditButton = false;
$editMode = true;
require 'includes/common_head.inc.php';


//Exit if the user tries to call a language that does not exist
if (!checkRowExists('visitor_phrases', array('language_id' => $_POST['lang']))) {
	exit;
}

//Saving data
if ($_POST['save']=="true") {
	saveAddLanguage($_POST, 1);
	
	//Overwrite the menuId in the primary key if needed
	echo json_encode(array());
	

//Check if a form is valid
} elseif ($_POST['validate']) {
	
	echo json_encode(validateAddLanguage($_POST, 1));
	

//Call the display form function.
} else {
	
	$valuesInCache = $_POST;
	
	//Create a search page by default
	if (!isset($valuesInCache['create_search_page'])) {
		$valuesInCache['create_search_page'] = true;
	}
	
	
	$dbDetails = array();
	$dbDetails['home_page_alias'] = getVLPPhrase('__DEFAULT_HOME_PAGE_ALIAS__', '', $_POST['lang'], true);
	$dbDetails['search_page_alias'] = getVLPPhrase('__DEFAULT_SEARCH_PAGE_ALIAS__', '', $_POST['lang'], true);
	
	
	$requiredFields = array('home_page_alias', 'search_page_alias');
	$aboveTableHTML = '';
	
	$fields = array();
	
	$fields['home_page_alias'] = 
		array(
			'Field' => 'home_page_alias',
			'Type' => 'varchar(50)',
			'onkeyup' => "tribiqA.manField = this; tribiqAFB.pk.hp_alias = this.value;"
		);
	
	$fields['create_search_page'] = 
		array(
			'Field' => 'create_search_page',
			'Type' => 'tinyint(1)',
			'onclick' => "tribiqAFB.checkboxChange(this); tribiqAFB.pk.sp_alias = '';"
		);
	
	$fields['search_page_alias'] = 
		array(
			'Field' => 'search_page_alias',
			'Type' => 'varchar(50)',
			'Requires' => 'create_search_page',
			'onkeyup' => "tribiqA.manField = this; tribiqAFB.pk.sp_alias = this.value;"
		);
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $valuesInCache, $dbDetails);
}
?>