<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_ENABLE_VLP');
$hasEditPermission = checkPriv('_PRIV_ENABLE_VLP');

$noSaving = false;
$noValidation = false;
$showEditButton = false;
$editMode = true;
require 'includes/common_head.inc.php';


//Exit if the user tries to call a language that does not exist
if (!checkRowExists('visitor_phrases', array('language_id' => $_POST['lang']))) {
	exit;
}

//Saving data
if ($_POST['save']=="true") {
	saveAddLanguage($_POST, 2);
	
	//Overwrite the menuId in the primary key if needed
	echo json_encode(array());
	

//Check if a form is valid
} elseif ($_POST['validate']) {
	
	echo json_encode(validateAddLanguage($_POST, 2));
	

//Call the display form function.
} else {
	
	$valuesInCache = $_POST;
	
	$dbDetails = array();
	$dbDetails['extranet_login_page_alias'] = getVLPPhrase('__DEFAULT_EXTRANET_LOGIN_PAGE_ALIAS__', '', $_POST['lang'], true);
	$dbDetails['extranet_registration_page_alias'] = getVLPPhrase('__DEFAULT_EXTRANET_REGISTRATION_PAGE_ALIAS__', '', $_POST['lang'], true);
	$dbDetails['extranet_password_reminder_page_alias'] = getVLPPhrase('__DEFAULT_EXTRANET_PASSWORD_REMINDER_ALIAS__', '', $_POST['lang'], true);
	$dbDetails['extranet_change_password_page_alias'] = getVLPPhrase('__DEFAULT_EXTRANET_CHANGE_PASSWORD_ALIAS__', '', $_POST['lang'], true);
	$dbDetails['extranet_logout_page_alias'] = getVLPPhrase('__DEFAULT_EXTRANET_LOGOUT_PAGE_PAGE_ALIAS__', '', $_POST['lang'], true);
	
	
	$fields = array();
	$aboveTableHTML = '';
	
	$requiredFields = array(
		'extranet_login_page_alias',
		'extranet_registration_page_alias',
		'extranet_password_reminder_page_alias',
		'extranet_change_password_page_alias',
		'extranet_logout_page_alias');
	
	$fields['create_extranet_login_page'] = 
		array(
			'Label' => getPhrase("Create an Extranet Login page:"),
			'Type' => 'tinyint(1)'
		);
	
	$fields['extranet_login_page_alias'] = 
		array(
			'Label' => getPhrase("Extranet Login page Alias:"),
			'Type' => 'varchar(50)',
			'Requires' => 'create_extranet_login_page'
		);
	
	$fields['create_extranet_registration_page'] = 
		array(
			'Label' => getPhrase("Create an Extranet Registration page:"),
			'Type' => 'tinyint(1)'
		);
	
	$fields['extranet_registration_page_alias'] = 
		array(
			'Label' => getPhrase("Extranet Registration page Alias:"),
			'Type' => 'varchar(50)',
			'Requires' => 'create_extranet_registration_page'
		);
	
	$fields['create_extranet_password_reminder_page'] = 
		array(
			'Label' => getPhrase("Create an Extranet Password Reminder page:"),
			'Type' => 'tinyint(1)'
		);
	
	$fields['extranet_password_reminder_page_alias'] = 
		array(
			'Label' => getPhrase("Extranet Password Reminder page Alias:"),
			'Type' => 'varchar(50)',
			'Requires' => 'create_extranet_password_reminder_page'
		);
	
	$fields['create_extranet_change_password_page'] = 
		array(
			'Label' => getPhrase("Create an Extranet Change Password page:"),
			'Type' => 'tinyint(1)'
		);
	
	$fields['extranet_change_password_page_alias'] = 
		array(
			'Label' => getPhrase("Extranet Change Password page Alias:"),
			'Type' => 'varchar(50)',
			'Requires' => 'create_extranet_change_password_page'
		);
	
	$fields['create_extranet_logout_page'] = 
		array(
			'Label' => getPhrase("Create an Extranet Logout page:"),
			'Type' => 'tinyint(1)'
		);
	
	$fields['extranet_logout_page_alias'] = 
		array(
			'Label' => getPhrase("Extranet Logout page Alias:"),
			'Type' => 'varchar(50)',
			'Requires' => 'create_extranet_logout_page'
		);
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $valuesInCache, $dbDetails);
}
?>