<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if (!includeContentType($_POST['cType'])) {
	exit;
}

if ($_POST['create_draft']) {
	if ($_POST['cID']) {
		$hasEditPermission = checkPriv('_PRIV_CREATE_REVISION_DRAFT');
	} else {
		$hasEditPermission = checkPriv('_PRIV_CREATE_FIRST_DRAFT');
	}
} elseif ($_POST['publish']) {
	$hasEditPermission = checkPriv('_PRIV_PUBLISH_ITEM');
} else {
	exit;
}

$noSaving = false;
$noValidation = false;
$editMode = true;
require 'includes/common_head.inc.php';

//Create a new private draft if making changes from a published utem
if ($_POST['create_draft']) {
	
	if (!$_POST['cID']) {
		echo json_encode(array());
		exit;
	}
	
	if (!$lastest_version = getLatestVersion($_POST['cID'], $_POST['cType'])) {
		echo json_encode(array('error' => true));
		exit;
	}
	
	$newVersion = createPrivateDraft($_POST['cID'], $_POST['cVersion'], $lastest_version, $_POST['cType'], true);
	
	if ($newVersion !== false ) {
		echo json_encode(array('cVersion' => $newVersion));
		exit;
	} elseif ($lastest_version != $_POST['cVersion']) {
		echo json_encode(array('error' => true, 'message' => getPhrase('You cannot create a draft using this historic version as a draft already exists.')));
		exit;
	} else {
		echo json_encode(array());
		exit;
	}
	
} elseif ($_POST['publish']) {
	publishContent($_POST['cID'], $_POST['cType'], $_POST['cVersion']);
}