<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_POST['cID']) {
	$hasEditPermission = checkPriv('_PRIV_CREATE_REVISION_DRAFT');
} else {
	$hasEditPermission = exitIfNotCheckPriv('_PRIV_CREATE_FIRST_DRAFT');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['cID'];
$editMode = $_POST['formMode']=="edit" || !$_POST['cID'];
require 'includes/common_head.inc.php';


if ($_POST['save']=="true") {

	if (includeContentType($_POST['cType'])) { {
			$_POST['current_file'] = $_POST['selected_file'] = decodeItemIdForStorekeeper($_POST['selected_file']);
			importContent($_POST);
			
			//Update the Content Item with the document's title, if it is blank
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($_POST['cType']). " SET
					title = '". mysql_real_escape_string($_POST['selected_file']). "'
				WHERE title = ''
				  AND id = ". (int) $_POST['cID']. "
				  AND version = ". (int) $_POST['cVersion'];
			my_mysql_query($sql);
		}
	}
} else {
	if (includeContentType($_POST['cType'])) { {
			
			if ($_POST['validate']) {
				$_POST['current_file'] = $_POST['selected_file'] = decodeItemIdForStorekeeper($_POST['selected_file']);
				$validationResult = validateDropbox($_POST);
				echo json_encode($validationResult);
			
			} else {
				$fields = array();
				$details = array();
				$requiredFields = array();
				
				$fields['description'] = array(
					'Type' => 'description',
					'Label' => getPhrase('Use this screen to Upload a file.')
				);
				
				if ($editMode) {
					$fields['selected_file'] = array(
						'Type' => 'sk',
						'Nothing Selected Phrase' => getPhrase('No File Selected'),
						'Select Phrase' => getPhrase('Select a File'),
						'Path' => 'tribiq__content/dropbox',
						'Target Path' => 'tribiq__content/dropbox',
						'Min Path' => 'tribiq__content/dropbox',
						'Max Path' => 'tribiq__content/dropbox',
						'Disallow Identical Min Path' => true,
						'Label' => getPhrase('File:'));
				} else {
					$fields['selected_file'] = array(
						'Label' => getPhrase('Current File:')
					);
					$details['selected_file'] = getItemFilename($_POST['cID'], $_POST['cVersion']);
				}
				
				echo dynamicThickboxForm('', 
						$editMode, $showEditButton, $fields, $requiredFields, $_POST, $details);
				
			}
		}
	}
}
