<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_POST['groupId']) {
	exitIfNotCheckPriv('_PRIV_VIEW_GROUP');
	$hasEditPermission = checkPriv('_PRIV_EDIT_GROUP');
} else {
	exitIfNotCheckPriv('_PRIV_CREATE_GROUP');
	$hasEditPermission = checkPriv('_PRIV_CREATE_GROUP');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['groupId'];
$editMode = $_POST['formMode']=="edit" || !$_POST['groupId'];
require 'includes/common_head.inc.php';


//Saving data
if ($_POST['save']=="true") {
	
	$groupId = post('groupId');
	saveGroup($_POST, $groupId);
	
	//Overwrite the groupId in the primary key if needed
	echo json_encode(array('groupId' => $groupId));
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	echo json_encode(validateGroup($_POST));
	

//Call the display form function.
} else {
	
	$requiredFields = array('name');
	
	
	$fields = array();
	$fields['name'] = array(
		'Label' => getPhrase('Internal Name:'),
		'Type' => 'varchar(100)');
	$fields['public'] = array(
		'Label' => getPhrase('Group is Public:'),
		'Type' => 'tinyint(1)',
		'Note Below' => getPhrase('A Public Group will automatically be given a name in all Enabled Languages. You can manage its Public Name(s) via the Phrases system.'));
	$fields['allow_opt_in_opt_out'] = array(
		'Label' => getPhrase('Allow Opt Ins and Opt Outs:'),
		'Type' => 'tinyint(1)',
		'Requires' => 'public');
	$fields['members_are_employees'] = array(
		'Type' => 'tinyint(1)',
		'Table' => 'groups');
	
	$userDBDetails = array();
	if ($_POST['groupId']) {
		//Load user details fro database if an id has been given
		$userDBDetails = getGroupDBDetails($_POST['groupId']);
	} else {
		//No need to show the show the "Edit"/"Cancel" button for new groups
		$hasEditPermission = false;
	}
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $_POST, $userDBDetails);
}
?>