<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if (!$_POST['pluginId']) {
	exit;
}
exitIfNotCheckPriv('_PRIV_VIEW_PLUGIN_INSTANCE');
$hasEditPermission = checkPriv('_PRIV_MANAGE_PLUGIN_INSTANCE');

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && post('instanceId');
$editMode = $_POST['formMode']=="edit" || !post('instanceId');
require 'includes/common_head.inc.php';


$nest = 0;
$errors = array();


//Saving data
if ($_POST['save']=="true") {
	
	if (post('duplicate')) {
		$instanceId = post('duplicate');
		renameInstance($instanceId, $nest, $_POST['name'], $errors, $createNewInstance = true);
	
	} else {
		$instanceId = post('instanceId');
		renameInstance($instanceId, $nest, $_POST['name'], $errors, $createNewInstance = false);
	}
	
	echo json_encode(array('instanceId' => $instanceId));	

//Check if a form is valid
} elseif ($_POST['validate']) {
	
	if (post('duplicate')) {
		$instanceId = post('duplicate');
		$valid = renameInstance($instanceId, $nest, $_POST['name'], $errors, $createNewInstance = true, $onlyValidate = true);

	} else {
		$instanceId = post('instanceId');
		$valid = renameInstance($instanceId, $nest, $_POST['name'], $errors, $createNewInstance = false, $onlyValidate = true);
	}
	
	if ($valid) {
		echo json_encode(array('valid' => true, 'errArray' => array()));
	} else {
		if (!is_array($errors)) {
			$errors = array($errors);
		}
		echo json_encode(array('valid' => false, 'errArray' => $errors));
	}

//Call the display form function.
} else {
	
	//Load user details from database if an id has been given
	$details = array();
	if (post('duplicate')) {
		$details['name'] = getInstanceName(post('duplicate'));
	} elseif (post('instanceId')) {
		$details['name'] = getInstanceName(post('instanceId'));
	}
	
	$fields = array(
		'name' => array(
            'Type' => 'varchar(250)',
            'Null' => 'NO',
            'Label' => getPhrase('Instance Name:'),
            'Table' => 'plugin_instances'
        ));
	
	$requiredFields = array('name');
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $_POST, $details);
}

exit;
?>