<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_LANGUAGE_CONFIG');
$hasEditPermission = checkPriv('_PRIV_EDIT_LANGUAGE_CONFIG');

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['lang'];
$editMode = $_POST['formMode']=="edit" || !$_POST['lang'];
require 'includes/common_head.inc.php';



//Check the language exists and get its details
if (!$dBDetails = getLanguage($_POST['lang'])) {
	exit;
}


//Saving data
if ($_POST['save']=="true") {
	
	$lang = $_POST['lang'];
	saveLanguage($_POST, $lang);
	
	//Overwrite the lang in the primary key if needed
	echo json_encode(array());
	

//Check if a form is valid
} elseif ($_POST['validate']) {
	
	echo json_encode(validateLanguage($_POST));
	

//Call the display form function.
} else {
	
	$dBDetails = array();
	$requiredFields = array();
	$valuesInCache = $_POST;
	//Load user details from the database
	$dBDetails = getLanguage($_POST['lang']);
	
	$aboveTableHTML = '';
	
	$fields = array();
	$fields['language_local_name'] = array(
		'Type' => 'varchar(100)',
		'Label' => 'Language Local Name:');

	$fields['homepage_id'] = array(
		'Type' => 'content',
		'HTML_Id_Only' => true,
		'Force_cType' => true,
		'Target_cType' => 'html',
		'Force_LanguageId' => true,
		'Target_LanguageId' => $_POST['lang'],
		'Label' => 'Homepage:');

	$fields['search_page_id'] = array(
		'Type' => 'content',
		'HTML_Id_Only' => true,
		'Force_cType' => true,
		'Target_cType' => 'html',
		'Force_LanguageId' => true,
		'Target_LanguageId' => $_POST['lang'],
		'Label' => 'Search page:');

	$fields['extranet_login_page_id'] = array(
		'Type' => 'content',
		'HTML_Id_Only' => true,
		'Force_cType' => true,
		'Target_cType' => 'html',
		'Force_LanguageId' => true,
		'Target_LanguageId' => $_POST['lang'],
		'Label' => 'Extranet Login page:');

	$fields['extranet_registration_page_id'] = array(
		'Type' => 'content',
		'HTML_Id_Only' => true,
		'Force_cType' => true,
		'Target_cType' => 'html',
		'Force_LanguageId' => true,
		'Target_LanguageId' => $_POST['lang'],
		'Label' => 'Extranet Registration page:');

	$fields['extranet_password_reminder_page_id'] = array(
		'Type' => 'content',
		'HTML_Id_Only' => true,
		'Force_cType' => true,
		'Target_cType' => 'html',
		'Force_LanguageId' => true,
		'Target_LanguageId' => $_POST['lang'],
		'Label' => 'Extranet Password Reminder page:');

	$fields['extranet_change_password_page_id'] = array(
		'Type' => 'content',
		'HTML_Id_Only' => true,
		'Force_cType' => true,
		'Target_cType' => 'html',
		'Force_LanguageId' => true,
		'Target_LanguageId' => $_POST['lang'],
		'Label' => 'Extranet Change Password page:');

	$fields['extranet_logout_page_id'] = array(
		'Type' => 'content',
		'HTML_Id_Only' => true,
		'Force_cType' => true,
		'Target_cType' => 'html',
		'Force_LanguageId' => true,
		'Target_LanguageId' => $_POST['lang'],
		'Label' => 'Extranet Logout page:');
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $hasEditPermission, $fields, $requiredFields, $valuesInCache, $dBDetails);
}
?>