<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_MENU_ITEM');
if ($_POST['mID']) {
	$hasEditPermission = $_POST['parentMenuID']? checkPriv('_PRIV_EDIT_MENU_ITEM') : checkPriv('_PRIV_EDIT_TOP_LEVEL_MENU_ITEM');
} else {
	$hasEditPermission = $_POST['parentMenuID']? checkPriv('_PRIV_ADD_MENU_ITEM') : checkPriv('_PRIV_ADD_TOP_LEVEL_MENU_ITEM');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['mID'];
$editMode = $_POST['formMode']=="edit" || !$_POST['mID'];
require 'includes/common_head.inc.php';


//Saving data
if ($_POST['save']=="true") {
	
	$menuId = $_POST['mID'];
	
	saveMenuDetails($_POST, $menuId);
	
	//Overwrite the menuId in the primary key if needed
	echo json_encode(array('mID' => $menuId));
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	echo json_encode(validateMenuDetails($_POST, $_POST['mID']));
	

//Call the display form function.
} else {
	
	$dbDetails = array();
	$valuesInCache = $_POST;
	if ($_POST['mID']) {
		//Load user details from the database if an id has been given
		$dbDetails = getMenuItemFromMenuID($_POST['mID']);
	}
	
	$requiredFields = array();
	$aboveTableHTML = '';
	
	$fields = array();
	
	$fields['accesskey'] = 
		array(
			'Label' => '_ACCESS_KEY:',
			'Type' => 'varchar(1)',
			'Table' => 'menuitems'
		);
	
	$fields['rel_tag'] = 
		array(
            'Type' => 'varchar(100)',
            'Table' => 'menuitems'
        );
	
	$fields['open_in_new_window'] = 
		array(
            'Type' => 'tinyint(1)',
            'Table' => 'menuitems',
            'Label' => getPhrase('Open in a new window:')
        );
	
	$fields['hide_private_item'] = 
		array(
            'Type' => 'select',
            'Null Phrase' => getPhrase('Always show, even if the target Item is Private'),
            'Options' => array(
            	0 => getPhrase('Always show, even if the target Item is Private'),
            	1 => getPhrase('Only show to visitors who can see the target Item'),
            	2 => getPhrase('Only show to visitors who are logged out'),
            	3 => getPhrase('Always show to visitors who are logged in')),
            'Table' => 'menuitems',
            'Label' => getPhrase('Privacy:')
        );
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $valuesInCache, $dbDetails);
}
?>