<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if (!$_POST['language_id']) {
	exit;
}
exitIfNotCheckPriv('_PRIV_VIEW_VLP');
$hasEditPermission = checkPriv('_PRIV_EDIT_VLP');

if (post('pluginClass') == 'Core' || post('pluginClass') == 'Core Features') {
	$_POST['pluginClass'] = '';
}

$phraseExists = $_POST['code'] && checkIfPhraseIsProtected($_POST['language_id'], $_POST['pluginClass'], $_POST['code'], true);

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $phraseExists;
$editMode = $_POST['formMode']=="edit" || !$phraseExists;
require 'includes/common_head.inc.php';



	
if ($phraseExists) {
	$pluginClass = $_POST['pluginClass'];
	$code = $_POST['code'];
} else {
	$pluginClass = ifNull($_POST['vlp_class'], $_POST['pluginClass']);
	$code = $_POST['code_name'];
}

//Saving data
if ($_POST['save']=="true") {
	
	$sql = 
		DB_NAME_PREFIX . "visitor_phrases SET
			language_id = '". mysql_real_escape_string($_POST['language_id']). "',
			plugin_class = '". mysql_real_escape_string($pluginClass). "',
			code = '". mysql_real_escape_string($code). "',
			local_text = '". mysql_real_escape_string($_POST['local_text']). "',
			protect_flag = ". (int) $_POST['protect_flag'];
	
	if ($id = arrayKey($_POST, 'id')) {
		$sql = "UPDATE ". $sql. " WHERE id = ". (int) $_POST['id'];
	} else {
		$sql = "REPLACE INTO ". $sql;
	}
	
	my_mysql_query($sql);
	
	if (!$id) {
		$id = mysql_insert_id();
	}
	
	echo json_encode(array('id' => $id, 'code' => ifNull($_POST['code'], $_POST['code_name'])));	

//Check if a form is valid
} elseif ($_POST['validate']) {
	
	$errors = array();
	
	if (!$phraseExists) {
		if (!$code) {
			$errors[] = getPhrase('Please enter a code name.');
		
		} elseif (substr($code, 0, 1) != '_') {
			$errors[] = getPhrase('The code name must begin with an underscore.');
		
		} elseif (preg_replace('/[a-zA-Z0-9\:_]/', '', $code) != '') {
			$errors[] = getPhrase('The code name may only contain the letters A-Z, digits, underscores or colons.');
		
		} elseif (checkIfPhraseIsProtected($_POST['language_id'], $pluginClass, $code, true)) {
			if ($pluginClass) {
				$errors[] = getPhrase('This Phrase code already exists for this Plugin in this Language.');
			} else {
				$errors[] = getPhrase('This Phrase code already exists in this Language.');
			}
		}
	}
	
	if ($_POST['local_text'] == '') {
		$errors[] = getPhrase('Please enter a translation.');
	}
	
	echo json_encode(array('valid' => !count($errors), 'errArray' => $errors));

//Call the display form function.
} else {
	
	$fields = array();
	$details = array();
	$requiredFields = array();
	
	$details['language'] = getLanguageName($_POST['language_id']);
	$fields['language'] = array(
		'Label' => getPhrase('Language:'),
		'Read Only' => true);
	
	if ($_POST['pluginClass']) {
		$details['vlp_class'] = $_POST['pluginClass'];
		$fields['vlp_class'] = array(
			'Label' => getPhrase('Plugin:'),
			'Read Only' => true);
	} else {
		$fields['vlp_class'] = array(
			'Label' => getPhrase('Plugin:'),
			'Type' => 'vlp_class');
	}
	
	if ($_POST['code']) {
		$details['code_name'] = $_POST['code'];
		$fields['code_name'] = array(
			'Label' => getPhrase('Phrase Code:'),
			'Read Only' => true);
	} else {
		$requiredFields[] = 'code_name';
		$fields['code_name'] = array(
			'Label' => getPhrase('Phrase Code:'),
			'Type' => 'varchar(100)',
			'Null' => 'NO');
	}
	
	if ($phraseExists) {
		$details['local_text'] = getVLPPhrase($_POST['code'], $replace = array(), $_POST['language_id'], $returnFalseOnFailure = true, $_POST['pluginClass']);
	}
	$requiredFields[] = 'local_text';
	$fields['local_text'] = array(
		'Label' => getPhrase('Local Text:'),
		'Type' => 'text',
		'Null' => 'NO');
	
	if ($editMode) {
		$details['protect_flag'] = 1;
	} else {
		$details['protect_flag'] = (int) checkRowExists('visitor_phrases',
			array(
				'code' => $code,
				'language_id' => $_POST['language_id'],
				'plugin_class' => $pluginClass,
				'protect_flag' => 1));
	}
	
	$fields['protect_flag'] = array(
		'Label' => getPhrase('Protected:'),
		'Type' => 'tinyint(1)',
		'Note Below' => getPhrase('Protected Phrases will never be overwritten when importing Phrases from a CSV file.'));
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $_POST, $details);
}

exit;
?>