<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_TEMPLATE');
$hasEditPermission = checkPriv('_PRIV_EDIT_TEMPLATE');

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['templateId'] && (!$_POST['sourceId']);
$editMode = $_POST['formMode']=="edit" || !$_POST['templateId'] || $_POST['sourceId'];
require 'includes/common_head.inc.php';


//Saving data
if ($_POST['save']=="true") {
	$templateId = $_POST['templateId'];
	$sourceId = $_POST['sourceId'];
	saveTemplate($_POST, $templateId,$sourceId,'Details');
	
	//Overwrite the templateId in the primary key if needed
	echo json_encode(array('templateId' => $templateId));
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	$templateId = $_POST['templateId'];
	echo json_encode(validateTemplate($_POST, $templateId,'Details'));
	

//Call the display form function.
} else {
	$valuesInCache = $_POST;
	
	$aboveTableHTML = '';
	
	$requiredFields = array();
	
	$fields = getFields(DB_NAME_PREFIX, 'templates');

	$fields['name']['Note Below']='<i>' . getPhrase('Please choose a unique name for your Template (for internal use only)') . '</i>';
	$fields['name']['Label']=getPhrase('_TEMPLATE_NAME:');
	
	if (($_POST['templateId']) && ($_POST['sourceId'])) {
		$DBDetails = getTemplateDetails($_POST['templateId']);
		$DBDetails['name'] .= ' (copy)'; 
		unset($fields['status']);
		$fields['content_type']['Type'] = "contenttype";
	} elseif ($_POST['templateId']) {
		$DBDetails = getTemplateDetails($_POST['templateId']);
		$fields['status']['Read Only'] = true;
		$fields['content_type']['Read Only'] = true;
	} else {
		$DBDetails = array();
		$DBDetails['family_name'] = $_POST['templateFamily'];
		$DBDetails['filename'] = $_POST['fileName'];
		unset($fields['status']);
		$fields['content_type']['Type'] = "contenttype";
	}
	
	$fields['family_name']['Read Only'] = true;
	$fields['filename']['Read Only'] = true;
	
	if (!$_POST['templateId']) {
		$templateFamilyDetails = getTemplateFamilyDetails($_POST['templateFamily']);
		$defaultSkinName = getSkinName($templateFamilyDetails['skin_id']);
		$defaultSkinMessage = getPhrase("_DEFAULT_SKIN:",array("skinName" => $defaultSkinName . " (" . getPhrase("_SKIN_SET_AT_TEMPLATE_FAMILY_LEVEL") . ")"));		
	} elseif ($_POST['templateId'] && ($defaultSkinName = checkForActiveTemplateFamilySkin($_POST['templateId']))) {
		$defaultSkinMessage = getPhrase("_DEFAULT_SKIN:",array("skinName" => $defaultSkinName . " (" . getPhrase("_SKIN_SET_AT_TEMPLATE_FAMILY_LEVEL") . ")"));
	} else {
		$defaultSkinMessage = getPhrase("_DEFAULT_SKIN:",array("skinName" => getPhrase("_NOT_SET")));
	}
	
	$fields['skin_id']['Post Field HTML'] = '<br /><i>'. $defaultSkinMessage. '</i>';
	
	$columnsNotToShow = array();
	$columnsNotToShow[] = 'template_id';
	$columnsNotToShow[] = 'usage_flag';
	$columnsNotToShow[] = 'editor_width_bodymain';
	$columnsNotToShow[] = 'custom_bodytag';
	$columnsNotToShow[] = 'enable_content_head';
	$columnsNotToShow[] = 'enable_content_bodytop';
	$columnsNotToShow[] = 'enable_content_bodymain';
	$columnsNotToShow[] = 'enable_content_bodyfoot';
	$columnsNotToShow[] = 'allow_rss';
	$columnsNotToShow[] = 'image_filename';
	$columnsNotToShow[] = 'mime_type';
	$columnsNotToShow[] = 'width';
	$columnsNotToShow[] = 'height';
	$columnsNotToShow[] = 'size';
	$columnsNotToShow[] = 'data';
	$columnsNotToShow[] = 'checksum';
	$columnsNotToShow[] = 'checksum_inc_name';
	$columnsNotToShow[] = 'storekeeper_width';
	$columnsNotToShow[] = 'storekeeper_height';
	$columnsNotToShow[] = 'storekeeper_data';
	$columnsNotToShow[] = 'storekeeper_size';
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $valuesInCache, $DBDetails, $columnsNotToShow);

}
?>