<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_TEMPLATE');
$hasEditPermission = checkPriv('_PRIV_EDIT_TEMPLATE');

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['templateId'] && (!$_POST['sourceId']);
$editMode = $_POST['formMode']=="edit" || !$_POST['templateId'] || $_POST['sourceId'];
require 'includes/common_head.inc.php';


//Saving data
if ($_POST['save']=="true") {
	
	$templateId = $_POST['templateId'];
	$sourceId = $_POST['sourceId'];
	saveTemplate($_POST, $templateId,$sourceId,'Image');
	
	//Overwrite the templateId in the primary key if needed
	echo json_encode(array('templateId' => $templateId));
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	$templateId = $_POST['templateId'];
	echo json_encode(validateTemplate($_POST, $templateId,'Image'));
	

//Call the display form function.
} else {
	if ($editMode){
		$fields['image']['Type'] = 'sk';
		$fields['image']['Select Phrase'] = getPhrase('Select Image...');
		$fields['image']['Nothing Selected Phrase'] = getPhrase('No Image Selected');
		$fields['image']['Path'] = 'tribiq__content/dropbox';
		$fields['image']['Target Path'] = 'tribiq__content/dropbox';
		$fields['image']['Min Path'] = 'tribiq__content/dropbox';
		$fields['image']['Max Path'] = 'tribiq__content/dropbox';
		$fields['image']['Disallow Identical Min Path'] = true;

		$currentValues = array();
		if (issetArrayKey($_POST,'templateId') && ($template = getTemplateDetails(arrayKey($_POST,'templateId')))){
			if ($template['image_filename']){
				$currentValues['image'] = encodeItemIdForStorekeeper($template['image_filename']);
			}
		} 
	} else {
		$fields['image']['Type'] = 'varchar(255)';
		$fields['image']['Label'] = 'Image:';

		$currentValues = array();
		if (issetArrayKey($_POST,'templateId') && ($template = getTemplateDetails(arrayKey($_POST,'templateId')))){
			if ($template['image_filename']){
				$currentValues['image'] = $template['image_filename'];
			}
		} 
	}

	$valuesInCache = $_POST;

	echo "Select an image to represent the Template." . dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, array(), $valuesInCache, $currentValues, array());

}
?>