<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_USER');
$hasEditPermission = checkPriv('_PRIV_MANAGE_GROUP_MEMBERSHIP');

$noSaving = false;
$noValidation = true;
$showEditButton = $hasEditPermission && $_POST['userId'];
$editMode = $_POST['formMode']=="edit" || !$_POST['userId'];
require 'includes/common_head.inc.php';



//Saving data
if ($_POST['save']=="true") {
	
	$userId = $_POST['userId'];
	$selectedGroupsInGet = explode(',', $_POST['selected_groups']);
	$unselectedGroupsInGet = $_POST['unselected_groups'];
	
	if ($unselectedGroupsInGet != '') {
		$sql = "
			DELETE FROM ". DB_NAME_PREFIX. "group_user_link
			WHERE user_id = ". (int) $userId. "
			  AND group_id IN (". mysql_real_escape_string($unselectedGroupsInGet). ")";
		my_mysql_query($sql);
	}
	
	foreach ($selectedGroupsInGet as $groupId) {
		if ($groupId) {
			$sql = "
				REPLACE INTO ". DB_NAME_PREFIX. "group_user_link SET
					user_id = ". (int) $userId. ",
					group_id = ". (int) $groupId;
			my_mysql_query($sql);
		}
	}
	
	echo json_encode(array());

//Call the display form function.
} else {
	
	$groups = getAllGroupsAndCheckWhichAUserIsIn($_POST['userId']);

	$selectedGroups = array();
	$unselectedGroups = array();
	$temporaryGroups = array();
	$selectedGroupsInGet = array_flip(explode(',', $_POST['selected_groups']));
	$unselectedGroupsInGet = array_flip(explode(',', $_POST['unselected_groups']));
	
	foreach($groups as $group) {
		if ($group['temporary']) {
			$temporaryGroups[] = $group;
		} else {
			if ($editMode && $_POST['submit']) {
				if (isset($selectedGroupsInGet[$group['id']])) {
					$selectedGroups[] = $group;
				} else {
					$unselectedGroups[] = $group;
				}
			} else {
				if ($group['in_group']) {
					$selectedGroups[] = $group;
				} else {
					$unselectedGroups[] = $group;
				}
			}
		}
	}
	
	echo '
		<form name="tab_form" id="tab_form" class="thickbox" onsubmit="formHandler(); return false;">
			<input type="hidden" id="formMode" name="formMode" value="'. ($editMode? 'edit' : 'view'). '" />
			<input type="hidden" id="userId" name="userId" value="' . $_POST['userId'] . '" />

			<table id="content_form" border="0">';
	
	if ($editMode) {

		echo '
			  <tr>
				<td class="title" style="width:110px">
					' . getPhrase('_MEMBER_OF:') . '
				</td><td>
					<div>'. getPhrase('_ALL_GROUPS') .'</div>
					<select name="unselected_groups" id="unselected_groups" multiple="multiple" size="10" style="width: 330px;">';
		
		foreach($unselectedGroups as $group) {
			echo '
						<option value="'. $group['id']. '">'. htmlspecialchars($group['name']). '</option>';
		}

		echo '							
					</select>
				</td><td>
					<input type="button" name="right" value="&gt;&gt;" onClick="tribiqAFB.moveOptions(\'unselected_groups\', \'selected_groups\');" />
					<br />
					<input type="button" name="left" value="&lt;&lt;" onClick="tribiqAFB.moveOptions(\'selected_groups\', \'unselected_groups\');" />
				</td><td>
					<div>' . getPhrase('_SELECTED_GROUPS') . '</div>
					<select name="selected_groups" id="selected_groups" multiple="multiple" size="10" style="width: 330px;">';
		
		foreach($selectedGroups as $group) {
			echo '
						<option value="'. $group['id']. '">'. htmlspecialchars($group['name']). '</option>';
		}

		echo '
					</select>';
		
		echo '
				</td>
			  </tr>';
	
	} else {
		
		echo '
			  <tr>
				<td class="title" style="width:110px">' . getPhrase('_MEMBER_OF:') . '</td>
				<td style="width:490px" colspan="3">';

		foreach($selectedGroups as $i => $group) {
			if ($i) {
				echo '<br />';
			}
			
			echo htmlspecialchars($group['name']);
		}
		
		echo '
				</td>
			  </tr>';
	}

	if (count($temporaryGroups)) {
		echo '
			  <tr>
				<td class="title" style="width:110px">
					' . getPhrase('_SUBSCRIPTIONS:') . '
				</td>
				<td style="width:490px" colspan="3">';
		
		foreach($temporaryGroups as $i => $group) {
			if ($i) {
				echo '<br />';
			}
			
			echo htmlspecialchars($group['name']);
		}
	
		echo '
				</td>
			  </tr>';
	}
		
	echo '
			  <tr>
				<td></td>
				<td>';

	if ($editMode && $_POST['userId']) {
		echo '
					<input type="submit" id="submit" name="submit" class="submit" value="Cancel" onclick="cancelEdit();" />';
	} elseif($showEditButton) {
		echo '
					<input type="submit" id="submit" name="submit" class="submit" value="Edit" />';
	} else {
		echo '
					<input type="hidden" id="submit" name="submit" value="Edit" />';
	}
	
	echo '
				</td>
			  </tr>
			</table>
		</form>';
}
?>