<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_CHANGE_USER_PASSWORD');
$hasEditPermission = checkPriv('_PRIV_CHANGE_USER_PASSWORD');

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['userId'];
$editMode = $_POST['formMode']=="edit" || !$_POST['userId'];
require 'includes/common_head.inc.php';





//Saving data
if ($_POST['save']=="true") {
	
	$userId = $_POST['userId'];
	saveUser($_POST, $userId);
	
	echo json_encode(array());	

//Check if a form is valid
} elseif ($_POST['validate']) {

	echo json_encode(validateUser($_POST));

//Call the display form function.
} else {
	
	//Load user details from database if an id has been given
	$userDBDetails = array();
	
	$aboveTableHTML = getPhrase('_CHANGE_PASSWORD_FOR', array('name' => getUsername($_POST['userId'])));
	
	$fields = array(
		'password' => array(
			'Field' => 'password',
            'Type' => 'password',
            'Null' => 'NO',
            'Key' => '',
            'Default' => '',
            'Extra' => '',
            'Table' => 'users',
            'Numeric' => false
        ),
		'password_reconfirm' => array(
			'Field' => 'password_reconfirm',
            'Type' => 'password_reconfirm',
            'Null' => 'NO',
            'Key' => '',
            'Default' => '',
            'Extra' => '',
            'Table' => 'users',
            'Numeric' => false
        ));
	
	$requiredFields = array('password', 'password_reconfirm');
	
	$columnsNotToShow = array();
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $_POST, $userDBDetails, $columnsNotToShow);
}

exit;
?>