<?php 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_SLOT');


if ($_POST['familyLevelChanges']) {
	$html = getPhrase(
		'<p>This change will affect <span class="tribiq_x_published_items">[[published]] Published Content Item(s)</span> <span class="tribiq_y_items">([[pages]] Content Item(s) in total).</span></p><p>Are you sure you wish to continue?</p>',
		array('pages' => checkTemplateUsage($_POST['templateId'], $_POST['templateFamily'], false),
				'published' => checkTemplateUsage($_POST['templateId'], $_POST['templateFamily'], true)));
} elseif ($_POST['templateLevelChanges']) {
	$html = getPhrase(
		'<p>This change will affect <span class="tribiq_x_published_items">[[published]] Published Content Item(s)</span> <span class="tribiq_y_items">([[pages]] Content Item(s) in total).</span></p><p>Are you sure you wish to continue?</p>',
		array('pages' => checkTemplateUsage($_POST['templateId'], false, false),
				'published' => checkTemplateUsage($_POST['templateId'], false, true)));
} else {
	echo json_encode(array('action' => 'continue'));
	exit;
}

$buttons = '<input type="button" class="submit_selected" value="'. getPhrase('_SAVE'). '" onClick="tribiqAFB.saveTabsSkippingConfirm();"/>'.
					'<input type="button" class="submit" value="'. getPhrase('_CANCEL'). '" onClick="tribiqA.closeFloatingBox();"/>';


echo json_encode(array('action' => 'confirm', 'html' => $html, 'buttons' => $buttons, 'warning' => 1));


?>