<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';


if ($_REQUEST['id'] && !isset($_REQUEST['cID'])) {
	$_REQUEST['cID'] = $_REQUEST['id'];
}
if ($_REQUEST['refiner__content_type']) {
	$_REQUEST['cType'] = $_REQUEST['refiner__content_type'];
}
if ($_REQUEST['refiner__language']) {
	$_REQUEST['language_id'] = $_REQUEST['refiner__language'];
}
if ($_REQUEST['language_id']) {
	$_REQUEST['suggestedLanguageId'] = $_REQUEST['language_id'];
}
if (!$_REQUEST['cVersion']) {
	$_REQUEST['cVersion'] = getLatestVersion($_REQUEST['cID'], $_REQUEST['cType']);
}



$tab_programs = array();
$showSettings =
	$_REQUEST['cType'] == 'event'
 || $_REQUEST['cType'] == 'recurringevent'
 || $_REQUEST['cType'] == 'html';
$showDropbox =
	$_REQUEST['cType'] == 'document'
 || $_REQUEST['cType'] == 'picture'
 || $_REQUEST['cType'] == 'video'
 || $_REQUEST['cType'] == 'audio';
$showCreateOptions =
	$_REQUEST['cType'] == 'html';

if ($_REQUEST['cType']=='event' || $_REQUEST['cType']=='recurringevent') {
	$settingsTabText = getPhrase('When & Where');
} elseif ($_REQUEST['cType']=='html') {
	$settingsTabText = getPhrase('Alias');
} else {
	$settingsTabText = getPhrase('Settings');
}

if ($_REQUEST['cID']) {
	if (checkPriv('_PRIV_VIEW_ITEM_META_DATA')) {
		$tab_programs["set_meta_data"] = array('tab_label' => getPhrase("_SET_META_DATA"), 'max_height' => 500);
		$tab_programs['set_summary'] = getPhrase('Summary');
	}
	if (checkPriv('_PRIV_VIEW_ITEM_SETTINGS') && $showSettings) {
		$tab_programs["set_settings"] = $settingsTabText;
	}
	if ($showDropbox) {
		$tab_programs["dropbox"] = getPhrase("_FILE");
	}
	if (checkPriv('_PRIV_VIEW_ITEM_TEMPLATE')) {
		$tab_programs["set_template"] = getPhrase("_SET_TEMPLATE");
	}
	if (checkPriv('_PRIV_VIEW_ITEM_PERMISSIONS')) {
		$tab_programs["set_permissions"] = getPhrase("_SET_PERMISSIONS");
	}

} elseif (checkPriv('_PRIV_CREATE_FIRST_DRAFT')) {
	$tab_programs["set_meta_data"] = getPhrase("_SET_META_DATA");
	if (checkPriv('_PRIV_VIEW_ITEM_META_DATA')) {
		$tab_programs['set_summary'] = getPhrase('Summary');
	}
	if ($showCreateOptions) {
		$tab_programs["set_create_options"] = getPhrase("_SET_CREATE_OPTIONS");
	}
	if ($showSettings) {
		$tab_programs["set_settings"] = $settingsTabText;
	}
	if ($showDropbox) {
		$tab_programs["dropbox"] = getPhrase("_FILE");
	}
	if (checkPriv('_PRIV_EDIT_ITEM_TEMPLATE')) {
		$tab_programs["set_template"] = getPhrase("_SET_TEMPLATE");
	}
	if (checkPriv('_PRIV_EDIT_ITEM_PERMISSIONS')) {
		$tab_programs["set_permissions"] = getPhrase("_SET_PERMISSIONS");
	}
}



if ($_REQUEST['cID']) {
	$title = getPhrase("Viewing/Editing settings for Content Item &quot;[[tag]]&quot;",
				array("tag" => htmlspecialchars(getTag($_REQUEST['cID'],$_REQUEST['cType'],$_REQUEST['cVersion']))));
} else {
	$title = getPhrase('Creating a Content Item of type &quot;[[cType]]&quot;', array('cType' => getContentTypeName($_REQUEST['cType'])));
}

thickboxHeader($title, $tab_programs, 'Content', array('cID', 'cType', 'cVersion', 'suggestedLanguageId', 'current_file'), 'create_content', $useJSONForDisplay = true, $_REQUEST['tab']);
?>