<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if (request('id')) {
	$instance = getPluginInstanceDetails(request('id'));
	$_REQUEST['pluginId'] = $instance['plugin_id'];
} elseif (!request('pluginId') && request('refiner__plugin')) {
	$_REQUEST['pluginId'] = request('refiner__plugin');
}

$tab_programs = array();
if (request('pluginId')) {
	if (checkPriv('_PRIV_MANAGE_PLUGIN_INSTANCE')) {
		$tab_programs['instance'] = array('text' => getPhrase('Instance Name'), 'max_height' => 150);
	}
}

if (request('duplicate')) {
	$_REQUEST['duplicate'] = request('id');
	$_REQUEST['instanceId'] = false;
	$title = getPhrase('Duplicating the Instance &quot;[[instance_name]]&quot;.', array('instance_name' => htmlspecialchars($instance['instance_name'])));

} else {
	$title = getPhrase('Renaming the Instance &quot;[[instance_name]]&quot;.', array('instance_name' => htmlspecialchars($instance['instance_name'])));
}

thickboxHeader($title, $tab_programs, 'Instance', array('instanceId', 'pluginId', 'duplicate'),"instance");
thickboxFooter();

?>