
//Cancel the warning message and go back to the form
tribiqTab.cancelSettingsConfirmForm = function() {
	//Remove the warning form
	tribiqA.closeFloatingBox();
}

//Confirm the warning message, with one of two options checked
tribiqTab.submitSettingsConfirmForm = function() {
	//Check which option is checked
	if (!get('create_new_instance') || get('change_instance').checked) {
		//Handle the case where the existing instance will be overwritten
		//Null out the new instance name field
		tribiqAFB.pk.save_action = '';
		//Remove the warning pop-up
		tribiqA.closeFloatingBox();
		//Submit the form
		tribiqAFB.saveTabsSkippingConfirm();
		
	} else if (get('create_new_instance').checked) {
		//Set the new instance name field
		tribiqAFB.pk.save_action = 'create_new_instance';
		//Remove the warning pop-up
		tribiqA.closeFloatingBox();
		//Submit the form
		tribiqAFB.saveTabsSkippingConfirm();
	} else {
		//Otherwise stop the box from closing
		tribiqA.currentlyClosingFloatingBox = true;
	}
}


tribiqTab.setCheckboxArrayField = function(el, field) {
	
	var val = get(field).value;
	
	if (val == '') {
		val = ',';
	} else {
		val = (',' + val + ',').replace(',' + el.value + ',', ',');
	}
	
	if (el.checked) {
		val += el.value + ',';
	}
	
	get(field).value = val.substr(1, val.length-2);
}


tribiqTab.viewFrameworkSource = function() {
	var url = URLBasePath + 'cmsincludes/framework.php?';
	
	if (tribiqAFB.pk.instanceId) {
		url += 'instanceId=' + tribiqAFB.pk.instanceId;
	} else {
		url += 'pluginId=' + tribiqAFB.pk.pluginId;
	}
	
	if (get('framework')) {
		url += '&framework=' + get('framework').value;
	}
	
	window.open(url);
}


tribiqTab.fetchFrameworkSource = function() {
	var url = URLBasePath + 'cmsincludes/framework.php?fetch=true&';
	
	if (tribiqAFB.pk.instanceId) {
		url += 'instanceId=' + tribiqAFB.pk.instanceId;
	} else {
		url += 'pluginId=' + tribiqAFB.pk.pluginId;
	}
	
	if (get('framework')) {
		url += '&framework=' + get('framework').value;
	}
	
	return tribiq.nonAsyncAJAX(url);
}

tribiqTab.customiseFrameworkOnclick = function(el, warningPhrase, okayPhrase, cancelPhrase) {
	if (el.checked) {
		get('custom_framework').value = tribiqTab.fetchFrameworkSource();
		tribiqAFB.checkboxChange(el);
	} else {
		el.checked = true;
		tribiqA.floatingBox(
			warningPhrase,
			'<input type="button" class="submit_selected" value="' + okayPhrase + '" onclick="' +
				"get('custom_framework').value = ''; " +
				"var cb = get('use_custom_framework'); " +
				"cb.checked = false; " +
				"tribiqAFB.checkboxChange(cb);" +
			'"/> <input type="button" class="submit" value="' + cancelPhrase + '"/>',
			true);
	}
}