<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if (request('id') && !request('mID')) {
	$_REQUEST['mID'] = request('id');
}

if (request('mID')) {
	$menuDetails = getMenuItemFromMenuID(request('mID'));
	$_REQUEST['currentName'] = $menuDetails['name'];
	$_REQUEST['sectionId'] = $menuDetails['section_id'];
	$_REQUEST['languageId'] = $menuDetails['language_id'];
	$_REQUEST['parentMenuID'] = $menuDetails['parent_id'];
} elseif (request('refiner__section')) {
	$menuDetails = $_REQUEST;
	$_REQUEST['languageId'] = request('refiner__language');
	$_REQUEST['sectionId'] = request('refiner__section');
	$_REQUEST['parentMenuID'] = request('refiner__children');
} else {
	$menuDetails = $_REQUEST;
	$_REQUEST['languageId'] = request('language_id');
	$_REQUEST['sectionId'] = request('section_id');
	$_REQUEST['parentMenuID'] = request('parent_id');
}

$tab_programs = array();
if (request('mID')) {
	$title = getPhrase('Viewing/Editing the Menu Item &quot;[[menuitem]]&quot;', array('menuitem' => htmlspecialchars($menuDetails['name'])));
	if (checkPriv('_PRIV_VIEW_MENU_ITEM')) {
		$tab_programs['menu_text'] = array('text' => getPhrase('_TEXT'), 'max_height' => 450);
		$tab_programs['menu_destination'] = getPhrase('_DESTINATION');
		$tab_programs['menu_advanced'] = getPhrase('_ADVANCED');
	}
} else {
	$title = getPhrase('Adding a Menu Item');
	if (request('refiner__children')? checkPriv('_PRIV_ADD_MENU_ITEM') : checkPriv('_PRIV_ADD_TOP_LEVEL_MENU_ITEM')) {
		$tab_programs['menu_text'] = array('text' => getPhrase('_TEXT'), 'max_height' => 450);
		$tab_programs['menu_destination'] = getPhrase('_DESTINATION');
		$tab_programs['menu_advanced'] = getPhrase('_ADVANCED');
	}
}


thickboxHeader($title, $tab_programs, 'Menu Item', array('mID', 'sectionId', 'languageId', 'parentMenuID', 'currentName'), 'menu_item');

//The "destination" tab needs to be able to see the name entered into the "text" tab, so we need globalDisplayMode turned on for that tab
echo '
<script type="text/javascript">
	useGlobalDisplayMode.menu_destination = true;
	var storeKeeperParams = "";
';

if ($_REQUEST['mID']) {
	echo '
		storeKeeperParams += "&current_menu_id='. (int) $_REQUEST['mID']. ';"';
}

echo '
primaryKey.sectionId = "'. addslashes($menuDetails['section_id']). '";
primaryKey.languageId = "'. addslashes($menuDetails['language_id']). '";
primaryKey.parentMenuID = '. (int) $menuDetails['parent_id']. ';
storeKeeperParams += "&section_id='. addslashes($menuDetails['section_id']). '";
storeKeeperParams += "&overrideShowBackButton=1";

</script>';

thickboxFooter();


?>