<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';


$tab_programs = array();


//Attempt to load all the information we can from the request
if (!issetArrayKey($_REQUEST, 'instanceId') && issetArrayKey($_REQUEST, 'id')) {
	$_REQUEST['instanceId'] = arrayKey($_REQUEST, 'id');
}

$pk = array();
if (issetArrayKey($_REQUEST, 'refiner__nest')) {
	$pk['instanceId'] = arrayKey($_REQUEST, 'refiner__nest');
	$pk['nest'] = (int) arrayKey($_REQUEST, 'id');
	
	$nestedItem = getNestDetails($pk['nest'], $pk['instanceId']);
	$pk['pluginId'] = $pluginId = $nestedItem['plugin_id'];
	
	$pk['doNotOfferTryout'] = true;
	$pk['storekeeperIdColumn'] = 'nest';
	$pk['cID'] = false;
	$pk['cType'] = false;
	$pk['slotName'] = false;

} elseif (!issetArrayKey($_REQUEST, 'instanceId') && issetArrayKey($_REQUEST, 'refiner__plugin')) {
	$pk['instanceId'] = false;
	$pk['cID'] = false;
	$pk['cType'] = false;
	$pk['slotName'] = false;
	$pk['nest'] = 0;
	$pk['pluginId'] = $pluginId = arrayKey($_REQUEST, 'refiner__plugin');

} else {
	$pk['instanceId'] = arrayKey($_REQUEST, 'instanceId');
	$pk['cID'] = (int) arrayKey($_REQUEST, 'cID');
	$pk['cType'] = arrayKey($_REQUEST, 'cType');
	$pk['slotName'] = arrayKey($_REQUEST, 'slotName');
	$pk['nest'] = (int) arrayKey($_REQUEST, 'nest');
	$pk['pluginId'] = $pluginId = arrayKey($_REQUEST, 'pluginId');
}

if ($pk['nest']) {
	exitIfNotCheckPriv('_PRIV_VIEW_NESTED_PLUGIN');
} elseif ($pk['instanceId']) {
	exitIfNotCheckPriv('_PRIV_VIEW_PLUGIN_INSTANCE');
} else {
	exitIfNotCheckPriv('_PRIV_MANAGE_PLUGIN_INSTANCE');
}

$pluginName = $instanceName = '';
getPluginSettingDesc($pk['instanceId'], $instanceName, $pluginName, $pluginId, $themes, $tab_programs, $sections, $valuesInDB, $pk['nest']);
$pk['instanceName'] = $instanceName;
$pk['save_action'] = '';
$pk['instance_new_name'] = '';
$pk['parent_id'] = '';
if ($parent = getInstanceParent($pk['instanceId'])) {
	$pk['parent_id'] = $parent['instance_id'];
}

if ($pk['nest']) {
	$title = 
		getPhrase('Viewing/Editing the &quot;[[plugin]]&quot; Plugin in the Nest &quot;[[nest]]&quot;',
			array('plugin' => htmlspecialchars(getPluginDisplayName($pluginId)), 'nest' => htmlspecialchars($instanceName)));
} elseif ($pk['instanceId']) {
	$title = 
		getPhrase('&quot;[[plugin]]&quot; Plugin: Viewing/Editing Settings for selected Instance',
			array('plugin' => htmlspecialchars(getPluginDisplayName($pluginId))));
} else {
	$title = 
		getPhrase('&quot;[[plugin]]&quot; Plugin: creating a new Instance',
			array('plugin' => htmlspecialchars(getPluginDisplayName($pluginId))));
}

thickboxHeader($title, $tab_programs, 'Instance Settings', array_keys($pk), 'plugin_settings', false, false, false, false, 'core', $pk, 'plugin_settings');
?>