<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';
$tab_programs = array();
if (checkPriv('_PRIV_VIEW_USER') && $_GET['id']) {
	$userDetails = getUserDetails($_GET['id']);

	$title = getPhrase("Viewing/Editing the User &quot;" . htmlspecialchars($userDetails['username']) . "&quot;");

	$tab_programs['user_details'] = getPhrase('_DETAILS');
	$tab_programs['user_additional_details'] = getPhrase('Details+');
	
	if (checkPriv('_PRIV_CHANGE_USER_PASSWORD')) {
		$tab_programs['user_password'] = getPhrase('_PASSWORD');
	}
	
	$tab_programs['user_status'] = getPhrase('_STATUS');
	$tab_programs['user_groups'] = getPhrase('_GROUPS');
	
} elseif (checkPriv('_PRIV_CREATE_USER') && !$_GET['id']) {
	$tab_programs['user_details'] = getPhrase('_DETAILS');
	$tab_programs['user_additional_details'] = getPhrase('Details+');
	
	if (checkPriv('_PRIV_MANAGE_GROUP_MEMBERSHIP')) {
		$tab_programs['user_groups'] = getPhrase('_GROUPS');
	}
	
	$title = getPhrase("Creating a new User");
}


thickboxHeader($title, $tab_programs, 'User', 'userId');
thickboxFooter();


?>