<?php 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

header("Content-Type: text/html; charset=UTF-8");


$lang = getLanguage();
$canonicalURL = linkToItem($cID, $cType, $siteConfig, true);

if (cms_core::$pageTitle !== false) {
	$pageTitle = cms_core::$pageTitle;
} elseif (checkPriv()) {
	$pageTitle = ($item_meta['status'] <> 'published'? "[".$item_meta['status']."] " : '').
					getTag($cID, $cType, $cVersion, $siteConfig['content_tag_zerofill'], 500);
} else { 
	$pageTitle = $item_meta['title'];
}

if ($cType != 'html' || (
	$cID != $lang['homepage_id'] &&
	$cID != $lang['extranet_login_page_id'] &&
	$cID != $lang['extranet_registration_page_id'] &&
	$cID != $lang['extranet_password_reminder_page_id'] &&
	$cID != $lang['extranet_change_password_page_id'] &&
	$cID != $lang['extranet_logout_page_id'])
) {
	$_SESSION['destCID'] = $cID;
	$_SESSION['destCType'] = $cType;
	$_SESSION['destURL'] = $canonicalURL;
	$_SESSION['destTitle'] = $pageTitle;
}
				
				
// Get meta data for the page; some things not really needed if not in admin mode
echo '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="', $_SESSION["user_lang"], '" lang="', $_SESSION["user_lang"], '">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>', htmlspecialchars($pageTitle), '</title>
<link rel="canonical" href="', htmlspecialchars($canonicalURL), '"/>
<meta name="description" content="', htmlspecialchars($item_meta['description']), '" />
<meta name="language" content="', htmlspecialchars($_SESSION["user_lang"]), '" />
<meta name="keywords" content="', htmlspecialchars($item_meta['keywords']), '" />
<meta name="generator" content="Tribiq CMS ', getTribiqCmsVersionNumber(), '" />';


CMSWritePageHead('', $slotContents, $siteConfig, $skin['id']);

?>
</head>