<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


if (!defined('NOT_ACCESSED_DIRECTLY')) {
	//Define a constant to mark than any further include files have been legitamately included
	define('NOT_ACCESSED_DIRECTLY', true);
	define('THIS_FILE_IS_BEING_DIRECTLY_ACCESSED', false);
}

require_once 'siteconfigs/global.php';

//Include the CMS' library of functions
require_once 'cmsincludes/stripslashes.inc.php';
require_once 'cmsincludes/cms.inc.php';


//Check for any form submissions
if (count($_POST)) {
	//Attempt to stop some XSS attacks by checking that the referer matches
	if (substr($_SERVER['HTTP_REFERER'], 0, strlen(httpOrhttps(). $_SERVER['HTTP_HOST'])) !== httpOrhttps(). $_SERVER['HTTP_HOST']) {
		//Allow an execption if someone is using a session_key
		if (!issetArrayKey($_REQUEST, 'session_key') || arrayKey($_SESSION, 'session_key') !== $_REQUEST['session_key']) {
			echo 'Sorry, but the referer for the form you just submitted does not seem to match this site';
			exit;
		}
	}
}


//Set up the database connection
connectGlobalDB();
doUrlRedirect();
connectLocalDB();
$siteConfig = loadSiteConfig();
	

//Check whether we should show error messages or not
if (checkPriv() || $siteConfig['show_sql_errors_to_visitors']) {
	define('SHOW_SQL_ERRORS_TO_VISITORS', true);
} else {
	define('SHOW_SQL_ERRORS_TO_VISITORS', false);
}


//Include any module actions in Plugins
foreach (scandir('plugins/') as $pluginDir) {
	if (substr($pluginDir, 0, 1) != '.'
	 && is_dir($pluginDir = 'plugins/'. $pluginDir. '/modules/actions/')) {
		foreach (scandir($pluginDir) as $pluginModule) {
			if (substr($pluginModule, 0, 1) != '.' && substr($pluginModule, -8) == '.inc.php'
			 && is_file($pluginDir. $pluginModule)) {
				require_once $pluginDir. $pluginModule;
			}
		}
	}
}
unset($pluginDir);
unset($pluginModule);


//Display the content-type header
header('Content-Type: text/html; charset=UTF-8');


//Include the Plugin Base Class
require CMS_ROOT. 'cmsincludes/plugin_base_class/plugin_code.php';

//Include the currently running version of the Core CMS Plugin
	 if (inc('tribiq_cms_core_enterprise', $missingPlugin))		{ class cms_core extends tribiq_cms_core_enterprise {}	}
else if (inc('tribiq_cms_core_probusiness', $missingPlugin))	{ class cms_core extends tribiq_cms_core_probusiness {}	}
else if (inc('tribiq_cms_core_pro', $missingPlugin))			{ class cms_core extends tribiq_cms_core_pro {}			}
else if (inc('tribiq_cms_core', $missingPlugin))				{ class cms_core extends tribiq_cms_core {}				}


//Attempt to automatically log a User in if the cookie is set on the User's Machine
if (!issetArrayKey($_SESSION, 'extranetUserID')
 && issetArrayKey($_COOKIE, 'LOG_ME_IN_COOKIE')
 && ($idAndMD5 = explode('_', $_COOKIE['LOG_ME_IN_COOKIE'], 2))
 && (count($idAndMD5) == 2)
 && ($user = getUserDetails($idAndMD5[0]))
 && ($idAndMD5[1] === md5(SITENAME. $user['id']. $user['username']. $user['email']. $user['password']))) {
	logUserIn($user['id'], $user);
}


//Set the user's language, if it is not set already
if (!issetArrayKey($_SESSION, 'user_lang')) {
	if (issetArrayKey($_REQUEST, 'cID')) {
		$_SESSION['user_lang'] = getContentLang($_REQUEST['cID'], ifNull(arrayKey($_REQUEST, 'cType'), 'html'));
	} else {
		$_SESSION['user_lang'] = DEFAULT_LANGUAGE;
	}
}

?>